/* Bezier.c generated by valac 0.42.7, the Vala compiler
 * generated from Bezier.vala, do not modify */

/*
* Copyright (c) 2018 (https://github.com/phase1geo/Minder)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Trevor Williams <phase1geo@gmail.com>
*/


#include <glib.h>
#include <glib-object.h>
#include <float.h>
#include <math.h>
#include <string.h>
#include <gobject/gvaluecollector.h>


#define TYPE_BEZIER (bezier_get_type ())
#define BEZIER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BEZIER, Bezier))
#define BEZIER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BEZIER, BezierClass))
#define IS_BEZIER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BEZIER))
#define IS_BEZIER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BEZIER))
#define BEZIER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BEZIER, BezierClass))

typedef struct _Bezier Bezier;
typedef struct _BezierClass BezierClass;
typedef struct _BezierPrivate BezierPrivate;

#define BEZIER_TYPE_POINT (bezier_point_get_type ())
#define BEZIER_POINT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), BEZIER_TYPE_POINT, BezierPoint))
#define BEZIER_POINT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), BEZIER_TYPE_POINT, BezierPointClass))
#define BEZIER_IS_POINT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), BEZIER_TYPE_POINT))
#define BEZIER_IS_POINT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), BEZIER_TYPE_POINT))
#define BEZIER_POINT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), BEZIER_TYPE_POINT, BezierPointClass))

typedef struct _BezierPoint BezierPoint;
typedef struct _BezierPointClass BezierPointClass;
#define _g_array_unref0(var) ((var == NULL) ? NULL : (var = (g_array_unref (var), NULL)))
#define _bezier_point_unref0(var) ((var == NULL) ? NULL : (var = (bezier_point_unref (var), NULL)))
#define _g_free0(var) ((var == NULL) ? NULL : (var = (g_free (var), NULL)))
typedef struct _BezierPointPrivate BezierPointPrivate;
typedef struct _BezierParamSpecPoint BezierParamSpecPoint;
typedef struct _ParamSpecBezier ParamSpecBezier;
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _Bezier {
	GTypeInstance parent_instance;
	volatile int ref_count;
	BezierPrivate * priv;
};

struct _BezierClass {
	GTypeClass parent_class;
	void (*finalize) (Bezier *self);
};

struct _BezierPrivate {
	GArray* _points;
	GArray* _apoints;
	BezierPoint* _from;
	BezierPoint* _to;
};

struct _BezierPoint {
	GTypeInstance parent_instance;
	volatile int ref_count;
	BezierPointPrivate * priv;
};

struct _BezierPointClass {
	GTypeClass parent_class;
	void (*finalize) (BezierPoint *self);
};

struct _BezierPointPrivate {
	gdouble _x;
	gdouble _y;
};

struct _BezierParamSpecPoint {
	GParamSpec parent_instance;
};

struct _ParamSpecBezier {
	GParamSpec parent_instance;
};


static gint Bezier_private_offset;
static gpointer bezier_parent_class = NULL;
static gint BezierPoint_private_offset;
static gpointer bezier_point_parent_class = NULL;

gpointer bezier_ref (gpointer instance);
void bezier_unref (gpointer instance);
GParamSpec* param_spec_bezier (const gchar* name,
                               const gchar* nick,
                               const gchar* blurb,
                               GType object_type,
                               GParamFlags flags);
void value_set_bezier (GValue* value,
                       gpointer v_object);
void value_take_bezier (GValue* value,
                        gpointer v_object);
gpointer value_get_bezier (const GValue* value);
GType bezier_get_type (void) G_GNUC_CONST;
static gpointer bezier_point_ref (gpointer instance);
static void bezier_point_unref (gpointer instance);
static GParamSpec* bezier_param_spec_point (const gchar* name,
                                     const gchar* nick,
                                     const gchar* blurb,
                                     GType object_type,
                                     GParamFlags flags) G_GNUC_UNUSED;
static void bezier_value_set_point (GValue* value,
                             gpointer v_object) G_GNUC_UNUSED;
static void bezier_value_take_point (GValue* value,
                              gpointer v_object) G_GNUC_UNUSED;
static gpointer bezier_value_get_point (const GValue* value) G_GNUC_UNUSED;
static GType bezier_point_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
static void _bezier_point_unref0_ (gpointer var);
static void _vala_BezierPoint_free_function_content_of (gpointer data);
static BezierPoint* bezier_point_new (void);
static BezierPoint* bezier_point_construct (GType object_type);
Bezier* bezier_new (void);
Bezier* bezier_construct (GType object_type);
Bezier* bezier_new_with_endpoints (gdouble x0,
                                   gdouble y0,
                                   gdouble x1,
                                   gdouble y1);
Bezier* bezier_construct_with_endpoints (GType object_type,
                                         gdouble x0,
                                         gdouble y0,
                                         gdouble x1,
                                         gdouble y1);
static void bezier_point_set_coordinate (BezierPoint* self,
                                  gdouble a,
                                  gdouble b);
void bezier_copy (Bezier* self,
                  Bezier* b);
static gdouble bezier_point_get_x (BezierPoint* self);
static gdouble bezier_point_get_y (BezierPoint* self);
void bezier_get_point (Bezier* self,
                       gint pindex,
                       gdouble* x,
                       gdouble* y);
void bezier_get_from_point (Bezier* self,
                            gdouble* x,
                            gdouble* y);
void bezier_get_to_point (Bezier* self,
                          gdouble* x,
                          gdouble* y);
void bezier_set_point (Bezier* self,
                       gint pindex,
                       gdouble x,
                       gdouble y);
void bezier_update_control_from_drag_handle (Bezier* self,
                                             gdouble x,
                                             gdouble y);
static gboolean bezier_is_t_within_range (Bezier* self,
                                   gdouble t);
static void bezier_align_point (Bezier* self,
                         gint pindex,
                         gdouble a,
                         gdouble tx,
                         gdouble ty);
static void bezier_align (Bezier* self,
                   gdouble lx0,
                   gdouble ly0,
                   gdouble lx1,
                   gdouble ly1);
static void bezier_get_roots (Bezier* self,
                       gdouble axis,
                       gboolean axis_is_x,
                       GArray* * roots);
static gdouble* _double_dup (gdouble* self);
static gdouble bezier_get_axis (Bezier* self,
                         gdouble t,
                         gboolean axis_is_x);
gboolean bezier_within_range (Bezier* self,
                              gdouble x,
                              gdouble y);
static void _g_free0_ (gpointer var);
static void _vala_gdouble_free_function_content_of (gpointer data);
gdouble* bezier_get_intersecting_point (Bezier* self,
                                        gdouble axis,
                                        gboolean axis_is_x,
                                        gboolean from);
void bezier_set_connect_point (Bezier* self,
                               gboolean from,
                               gdouble top,
                               gdouble bottom,
                               gdouble left,
                               gdouble right);
static BezierPoint* bezier_point_new_with_coordinate (gdouble a,
                                               gdouble b);
static BezierPoint* bezier_point_construct_with_coordinate (GType object_type,
                                                     gdouble a,
                                                     gdouble b);
static void bezier_point_set_x (BezierPoint* self,
                         gdouble value);
static void bezier_point_set_y (BezierPoint* self,
                         gdouble value);
static void bezier_point_finalize (BezierPoint * obj);
static void bezier_finalize (Bezier * obj);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);


static inline gpointer
bezier_get_instance_private (Bezier* self)
{
	return G_STRUCT_MEMBER_P (self, Bezier_private_offset);
}


static void
_bezier_point_unref0_ (gpointer var)
{
#line 40 "../src/Bezier.vala"
	(var == NULL) ? NULL : (var = (bezier_point_unref (var), NULL));
#line 245 "Bezier.c"
}


static void
_vala_BezierPoint_free_function_content_of (gpointer data)
{
	BezierPoint* self;
#line 40 "../src/Bezier.vala"
	self = *((BezierPoint**) data);
#line 40 "../src/Bezier.vala"
	_bezier_point_unref0_ (self);
#line 257 "Bezier.c"
}


Bezier*
bezier_construct (GType object_type)
{
	Bezier* self = NULL;
#line 46 "../src/Bezier.vala"
	self = (Bezier*) g_type_create_instance (object_type);
#line 267 "Bezier.c"
	{
		gint i = 0;
#line 47 "../src/Bezier.vala"
		i = 0;
#line 272 "Bezier.c"
		{
			gboolean _tmp0_ = FALSE;
#line 47 "../src/Bezier.vala"
			_tmp0_ = TRUE;
#line 47 "../src/Bezier.vala"
			while (TRUE) {
#line 279 "Bezier.c"
				gint _tmp2_;
				GArray* _tmp3_;
				BezierPoint* _tmp4_;
				GArray* _tmp5_;
				BezierPoint* _tmp6_;
#line 47 "../src/Bezier.vala"
				if (!_tmp0_) {
#line 287 "Bezier.c"
					gint _tmp1_;
#line 47 "../src/Bezier.vala"
					_tmp1_ = i;
#line 47 "../src/Bezier.vala"
					i = _tmp1_ + 1;
#line 293 "Bezier.c"
				}
#line 47 "../src/Bezier.vala"
				_tmp0_ = FALSE;
#line 47 "../src/Bezier.vala"
				_tmp2_ = i;
#line 47 "../src/Bezier.vala"
				if (!(_tmp2_ < 3)) {
#line 47 "../src/Bezier.vala"
					break;
#line 303 "Bezier.c"
				}
#line 48 "../src/Bezier.vala"
				_tmp3_ = self->priv->_points;
#line 48 "../src/Bezier.vala"
				_tmp4_ = bezier_point_new ();
#line 48 "../src/Bezier.vala"
				g_array_append_val (_tmp3_, _tmp4_);
#line 49 "../src/Bezier.vala"
				_tmp5_ = self->priv->_apoints;
#line 49 "../src/Bezier.vala"
				_tmp6_ = bezier_point_new ();
#line 49 "../src/Bezier.vala"
				g_array_append_val (_tmp5_, _tmp6_);
#line 317 "Bezier.c"
			}
		}
	}
#line 46 "../src/Bezier.vala"
	return self;
#line 323 "Bezier.c"
}


Bezier*
bezier_new (void)
{
#line 46 "../src/Bezier.vala"
	return bezier_construct (TYPE_BEZIER);
#line 332 "Bezier.c"
}


Bezier*
bezier_construct_with_endpoints (GType object_type,
                                 gdouble x0,
                                 gdouble y0,
                                 gdouble x1,
                                 gdouble y1)
{
	Bezier* self = NULL;
	GArray* _tmp7_;
	BezierPoint* _tmp8_;
	GArray* _tmp9_;
	BezierPoint* _tmp10_;
	GArray* _tmp11_;
	BezierPoint* _tmp12_;
#line 54 "../src/Bezier.vala"
	self = (Bezier*) g_type_create_instance (object_type);
#line 352 "Bezier.c"
	{
		gint i = 0;
#line 55 "../src/Bezier.vala"
		i = 0;
#line 357 "Bezier.c"
		{
			gboolean _tmp0_ = FALSE;
#line 55 "../src/Bezier.vala"
			_tmp0_ = TRUE;
#line 55 "../src/Bezier.vala"
			while (TRUE) {
#line 364 "Bezier.c"
				gint _tmp2_;
				GArray* _tmp3_;
				BezierPoint* _tmp4_;
				GArray* _tmp5_;
				BezierPoint* _tmp6_;
#line 55 "../src/Bezier.vala"
				if (!_tmp0_) {
#line 372 "Bezier.c"
					gint _tmp1_;
#line 55 "../src/Bezier.vala"
					_tmp1_ = i;
#line 55 "../src/Bezier.vala"
					i = _tmp1_ + 1;
#line 378 "Bezier.c"
				}
#line 55 "../src/Bezier.vala"
				_tmp0_ = FALSE;
#line 55 "../src/Bezier.vala"
				_tmp2_ = i;
#line 55 "../src/Bezier.vala"
				if (!(_tmp2_ < 3)) {
#line 55 "../src/Bezier.vala"
					break;
#line 388 "Bezier.c"
				}
#line 56 "../src/Bezier.vala"
				_tmp3_ = self->priv->_points;
#line 56 "../src/Bezier.vala"
				_tmp4_ = bezier_point_new ();
#line 56 "../src/Bezier.vala"
				g_array_append_val (_tmp3_, _tmp4_);
#line 57 "../src/Bezier.vala"
				_tmp5_ = self->priv->_apoints;
#line 57 "../src/Bezier.vala"
				_tmp6_ = bezier_point_new ();
#line 57 "../src/Bezier.vala"
				g_array_append_val (_tmp5_, _tmp6_);
#line 402 "Bezier.c"
			}
		}
	}
#line 59 "../src/Bezier.vala"
	_tmp7_ = self->priv->_points;
#line 59 "../src/Bezier.vala"
	_tmp8_ = g_array_index (_tmp7_, BezierPoint*, (guint) 0);
#line 59 "../src/Bezier.vala"
	bezier_point_set_coordinate (_tmp8_, x0, y0);
#line 60 "../src/Bezier.vala"
	_tmp9_ = self->priv->_points;
#line 60 "../src/Bezier.vala"
	_tmp10_ = g_array_index (_tmp9_, BezierPoint*, (guint) 1);
#line 60 "../src/Bezier.vala"
	bezier_point_set_coordinate (_tmp10_, (x0 + x1) * 0.5, (y0 + y1) * 0.5);
#line 61 "../src/Bezier.vala"
	_tmp11_ = self->priv->_points;
#line 61 "../src/Bezier.vala"
	_tmp12_ = g_array_index (_tmp11_, BezierPoint*, (guint) 2);
#line 61 "../src/Bezier.vala"
	bezier_point_set_coordinate (_tmp12_, x1, y1);
#line 54 "../src/Bezier.vala"
	return self;
#line 426 "Bezier.c"
}


Bezier*
bezier_new_with_endpoints (gdouble x0,
                           gdouble y0,
                           gdouble x1,
                           gdouble y1)
{
#line 54 "../src/Bezier.vala"
	return bezier_construct_with_endpoints (TYPE_BEZIER, x0, y0, x1, y1);
#line 438 "Bezier.c"
}


void
bezier_copy (Bezier* self,
             Bezier* b)
{
	BezierPoint* _tmp29_;
	BezierPoint* _tmp30_;
	gdouble _tmp31_;
	gdouble _tmp32_;
	BezierPoint* _tmp33_;
	gdouble _tmp34_;
	gdouble _tmp35_;
	BezierPoint* _tmp36_;
	BezierPoint* _tmp37_;
	gdouble _tmp38_;
	gdouble _tmp39_;
	BezierPoint* _tmp40_;
	gdouble _tmp41_;
	gdouble _tmp42_;
#line 65 "../src/Bezier.vala"
	g_return_if_fail (self != NULL);
#line 65 "../src/Bezier.vala"
	g_return_if_fail (b != NULL);
#line 464 "Bezier.c"
	{
		gint i = 0;
#line 66 "../src/Bezier.vala"
		i = 0;
#line 469 "Bezier.c"
		{
			gboolean _tmp0_ = FALSE;
#line 66 "../src/Bezier.vala"
			_tmp0_ = TRUE;
#line 66 "../src/Bezier.vala"
			while (TRUE) {
#line 476 "Bezier.c"
				gint _tmp2_;
				GArray* _tmp3_;
				gint _tmp4_;
				BezierPoint* _tmp5_;
				GArray* _tmp6_;
				gint _tmp7_;
				BezierPoint* _tmp8_;
				gdouble _tmp9_;
				gdouble _tmp10_;
				GArray* _tmp11_;
				gint _tmp12_;
				BezierPoint* _tmp13_;
				gdouble _tmp14_;
				gdouble _tmp15_;
				GArray* _tmp16_;
				gint _tmp17_;
				BezierPoint* _tmp18_;
				GArray* _tmp19_;
				gint _tmp20_;
				BezierPoint* _tmp21_;
				gdouble _tmp22_;
				gdouble _tmp23_;
				GArray* _tmp24_;
				gint _tmp25_;
				BezierPoint* _tmp26_;
				gdouble _tmp27_;
				gdouble _tmp28_;
#line 66 "../src/Bezier.vala"
				if (!_tmp0_) {
#line 506 "Bezier.c"
					gint _tmp1_;
#line 66 "../src/Bezier.vala"
					_tmp1_ = i;
#line 66 "../src/Bezier.vala"
					i = _tmp1_ + 1;
#line 512 "Bezier.c"
				}
#line 66 "../src/Bezier.vala"
				_tmp0_ = FALSE;
#line 66 "../src/Bezier.vala"
				_tmp2_ = i;
#line 66 "../src/Bezier.vala"
				if (!(_tmp2_ < 3)) {
#line 66 "../src/Bezier.vala"
					break;
#line 522 "Bezier.c"
				}
#line 67 "../src/Bezier.vala"
				_tmp3_ = self->priv->_points;
#line 67 "../src/Bezier.vala"
				_tmp4_ = i;
#line 67 "../src/Bezier.vala"
				_tmp5_ = g_array_index (_tmp3_, BezierPoint*, (guint) _tmp4_);
#line 67 "../src/Bezier.vala"
				_tmp6_ = b->priv->_points;
#line 67 "../src/Bezier.vala"
				_tmp7_ = i;
#line 67 "../src/Bezier.vala"
				_tmp8_ = g_array_index (_tmp6_, BezierPoint*, (guint) _tmp7_);
#line 67 "../src/Bezier.vala"
				_tmp9_ = bezier_point_get_x (_tmp8_);
#line 67 "../src/Bezier.vala"
				_tmp10_ = _tmp9_;
#line 67 "../src/Bezier.vala"
				_tmp11_ = b->priv->_points;
#line 67 "../src/Bezier.vala"
				_tmp12_ = i;
#line 67 "../src/Bezier.vala"
				_tmp13_ = g_array_index (_tmp11_, BezierPoint*, (guint) _tmp12_);
#line 67 "../src/Bezier.vala"
				_tmp14_ = bezier_point_get_y (_tmp13_);
#line 67 "../src/Bezier.vala"
				_tmp15_ = _tmp14_;
#line 67 "../src/Bezier.vala"
				bezier_point_set_coordinate (_tmp5_, _tmp10_, _tmp15_);
#line 68 "../src/Bezier.vala"
				_tmp16_ = self->priv->_apoints;
#line 68 "../src/Bezier.vala"
				_tmp17_ = i;
#line 68 "../src/Bezier.vala"
				_tmp18_ = g_array_index (_tmp16_, BezierPoint*, (guint) _tmp17_);
#line 68 "../src/Bezier.vala"
				_tmp19_ = b->priv->_apoints;
#line 68 "../src/Bezier.vala"
				_tmp20_ = i;
#line 68 "../src/Bezier.vala"
				_tmp21_ = g_array_index (_tmp19_, BezierPoint*, (guint) _tmp20_);
#line 68 "../src/Bezier.vala"
				_tmp22_ = bezier_point_get_x (_tmp21_);
#line 68 "../src/Bezier.vala"
				_tmp23_ = _tmp22_;
#line 68 "../src/Bezier.vala"
				_tmp24_ = b->priv->_apoints;
#line 68 "../src/Bezier.vala"
				_tmp25_ = i;
#line 68 "../src/Bezier.vala"
				_tmp26_ = g_array_index (_tmp24_, BezierPoint*, (guint) _tmp25_);
#line 68 "../src/Bezier.vala"
				_tmp27_ = bezier_point_get_y (_tmp26_);
#line 68 "../src/Bezier.vala"
				_tmp28_ = _tmp27_;
#line 68 "../src/Bezier.vala"
				bezier_point_set_coordinate (_tmp18_, _tmp23_, _tmp28_);
#line 580 "Bezier.c"
			}
		}
	}
#line 70 "../src/Bezier.vala"
	_tmp29_ = self->priv->_from;
#line 70 "../src/Bezier.vala"
	_tmp30_ = b->priv->_from;
#line 70 "../src/Bezier.vala"
	_tmp31_ = bezier_point_get_x (_tmp30_);
#line 70 "../src/Bezier.vala"
	_tmp32_ = _tmp31_;
#line 70 "../src/Bezier.vala"
	_tmp33_ = b->priv->_from;
#line 70 "../src/Bezier.vala"
	_tmp34_ = bezier_point_get_y (_tmp33_);
#line 70 "../src/Bezier.vala"
	_tmp35_ = _tmp34_;
#line 70 "../src/Bezier.vala"
	bezier_point_set_coordinate (_tmp29_, _tmp32_, _tmp35_);
#line 71 "../src/Bezier.vala"
	_tmp36_ = self->priv->_to;
#line 71 "../src/Bezier.vala"
	_tmp37_ = b->priv->_to;
#line 71 "../src/Bezier.vala"
	_tmp38_ = bezier_point_get_x (_tmp37_);
#line 71 "../src/Bezier.vala"
	_tmp39_ = _tmp38_;
#line 71 "../src/Bezier.vala"
	_tmp40_ = b->priv->_to;
#line 71 "../src/Bezier.vala"
	_tmp41_ = bezier_point_get_y (_tmp40_);
#line 71 "../src/Bezier.vala"
	_tmp42_ = _tmp41_;
#line 71 "../src/Bezier.vala"
	bezier_point_set_coordinate (_tmp36_, _tmp39_, _tmp42_);
#line 616 "Bezier.c"
}


void
bezier_get_point (Bezier* self,
                  gint pindex,
                  gdouble* x,
                  gdouble* y)
{
	gdouble _vala_x = 0.0;
	gdouble _vala_y = 0.0;
	GArray* _tmp0_;
	BezierPoint* _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
	GArray* _tmp4_;
	BezierPoint* _tmp5_;
	gdouble _tmp6_;
	gdouble _tmp7_;
#line 75 "../src/Bezier.vala"
	g_return_if_fail (self != NULL);
#line 76 "../src/Bezier.vala"
	_tmp0_ = self->priv->_points;
#line 76 "../src/Bezier.vala"
	_tmp1_ = g_array_index (_tmp0_, BezierPoint*, (guint) pindex);
#line 76 "../src/Bezier.vala"
	_tmp2_ = bezier_point_get_x (_tmp1_);
#line 76 "../src/Bezier.vala"
	_tmp3_ = _tmp2_;
#line 76 "../src/Bezier.vala"
	_vala_x = _tmp3_;
#line 77 "../src/Bezier.vala"
	_tmp4_ = self->priv->_points;
#line 77 "../src/Bezier.vala"
	_tmp5_ = g_array_index (_tmp4_, BezierPoint*, (guint) pindex);
#line 77 "../src/Bezier.vala"
	_tmp6_ = bezier_point_get_y (_tmp5_);
#line 77 "../src/Bezier.vala"
	_tmp7_ = _tmp6_;
#line 77 "../src/Bezier.vala"
	_vala_y = _tmp7_;
#line 75 "../src/Bezier.vala"
	if (x) {
#line 75 "../src/Bezier.vala"
		*x = _vala_x;
#line 662 "Bezier.c"
	}
#line 75 "../src/Bezier.vala"
	if (y) {
#line 75 "../src/Bezier.vala"
		*y = _vala_y;
#line 668 "Bezier.c"
	}
}


void
bezier_get_from_point (Bezier* self,
                       gdouble* x,
                       gdouble* y)
{
	gdouble _vala_x = 0.0;
	gdouble _vala_y = 0.0;
	BezierPoint* _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	BezierPoint* _tmp3_;
	gdouble _tmp4_;
	gdouble _tmp5_;
#line 80 "../src/Bezier.vala"
	g_return_if_fail (self != NULL);
#line 81 "../src/Bezier.vala"
	_tmp0_ = self->priv->_from;
#line 81 "../src/Bezier.vala"
	_tmp1_ = bezier_point_get_x (_tmp0_);
#line 81 "../src/Bezier.vala"
	_tmp2_ = _tmp1_;
#line 81 "../src/Bezier.vala"
	_vala_x = _tmp2_;
#line 82 "../src/Bezier.vala"
	_tmp3_ = self->priv->_from;
#line 82 "../src/Bezier.vala"
	_tmp4_ = bezier_point_get_y (_tmp3_);
#line 82 "../src/Bezier.vala"
	_tmp5_ = _tmp4_;
#line 82 "../src/Bezier.vala"
	_vala_y = _tmp5_;
#line 80 "../src/Bezier.vala"
	if (x) {
#line 80 "../src/Bezier.vala"
		*x = _vala_x;
#line 708 "Bezier.c"
	}
#line 80 "../src/Bezier.vala"
	if (y) {
#line 80 "../src/Bezier.vala"
		*y = _vala_y;
#line 714 "Bezier.c"
	}
}


void
bezier_get_to_point (Bezier* self,
                     gdouble* x,
                     gdouble* y)
{
	gdouble _vala_x = 0.0;
	gdouble _vala_y = 0.0;
	BezierPoint* _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	BezierPoint* _tmp3_;
	gdouble _tmp4_;
	gdouble _tmp5_;
#line 85 "../src/Bezier.vala"
	g_return_if_fail (self != NULL);
#line 86 "../src/Bezier.vala"
	_tmp0_ = self->priv->_to;
#line 86 "../src/Bezier.vala"
	_tmp1_ = bezier_point_get_x (_tmp0_);
#line 86 "../src/Bezier.vala"
	_tmp2_ = _tmp1_;
#line 86 "../src/Bezier.vala"
	_vala_x = _tmp2_;
#line 87 "../src/Bezier.vala"
	_tmp3_ = self->priv->_to;
#line 87 "../src/Bezier.vala"
	_tmp4_ = bezier_point_get_y (_tmp3_);
#line 87 "../src/Bezier.vala"
	_tmp5_ = _tmp4_;
#line 87 "../src/Bezier.vala"
	_vala_y = _tmp5_;
#line 85 "../src/Bezier.vala"
	if (x) {
#line 85 "../src/Bezier.vala"
		*x = _vala_x;
#line 754 "Bezier.c"
	}
#line 85 "../src/Bezier.vala"
	if (y) {
#line 85 "../src/Bezier.vala"
		*y = _vala_y;
#line 760 "Bezier.c"
	}
}


void
bezier_set_point (Bezier* self,
                  gint pindex,
                  gdouble x,
                  gdouble y)
{
	GArray* _tmp0_;
	BezierPoint* _tmp1_;
#line 91 "../src/Bezier.vala"
	g_return_if_fail (self != NULL);
#line 92 "../src/Bezier.vala"
	_tmp0_ = self->priv->_points;
#line 92 "../src/Bezier.vala"
	_tmp1_ = g_array_index (_tmp0_, BezierPoint*, (guint) pindex);
#line 92 "../src/Bezier.vala"
	bezier_point_set_coordinate (_tmp1_, x, y);
#line 781 "Bezier.c"
}


void
bezier_update_control_from_drag_handle (Bezier* self,
                                        gdouble x,
                                        gdouble y)
{
	gdouble cx = 0.0;
	GArray* _tmp0_;
	BezierPoint* _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
	GArray* _tmp4_;
	BezierPoint* _tmp5_;
	gdouble _tmp6_;
	gdouble _tmp7_;
	gdouble cy = 0.0;
	GArray* _tmp8_;
	BezierPoint* _tmp9_;
	gdouble _tmp10_;
	gdouble _tmp11_;
	GArray* _tmp12_;
	BezierPoint* _tmp13_;
	gdouble _tmp14_;
	gdouble _tmp15_;
#line 95 "../src/Bezier.vala"
	g_return_if_fail (self != NULL);
#line 96 "../src/Bezier.vala"
	_tmp0_ = self->priv->_points;
#line 96 "../src/Bezier.vala"
	_tmp1_ = g_array_index (_tmp0_, BezierPoint*, (guint) 0);
#line 96 "../src/Bezier.vala"
	_tmp2_ = bezier_point_get_x (_tmp1_);
#line 96 "../src/Bezier.vala"
	_tmp3_ = _tmp2_;
#line 96 "../src/Bezier.vala"
	_tmp4_ = self->priv->_points;
#line 96 "../src/Bezier.vala"
	_tmp5_ = g_array_index (_tmp4_, BezierPoint*, (guint) 2);
#line 96 "../src/Bezier.vala"
	_tmp6_ = bezier_point_get_x (_tmp5_);
#line 96 "../src/Bezier.vala"
	_tmp7_ = _tmp6_;
#line 96 "../src/Bezier.vala"
	cx = x - (((_tmp3_ + _tmp7_) * 0.5) - x);
#line 97 "../src/Bezier.vala"
	_tmp8_ = self->priv->_points;
#line 97 "../src/Bezier.vala"
	_tmp9_ = g_array_index (_tmp8_, BezierPoint*, (guint) 0);
#line 97 "../src/Bezier.vala"
	_tmp10_ = bezier_point_get_y (_tmp9_);
#line 97 "../src/Bezier.vala"
	_tmp11_ = _tmp10_;
#line 97 "../src/Bezier.vala"
	_tmp12_ = self->priv->_points;
#line 97 "../src/Bezier.vala"
	_tmp13_ = g_array_index (_tmp12_, BezierPoint*, (guint) 2);
#line 97 "../src/Bezier.vala"
	_tmp14_ = bezier_point_get_y (_tmp13_);
#line 97 "../src/Bezier.vala"
	_tmp15_ = _tmp14_;
#line 97 "../src/Bezier.vala"
	cy = y - (((_tmp11_ + _tmp15_) * 0.5) - y);
#line 98 "../src/Bezier.vala"
	bezier_set_point (self, 1, cx, cy);
#line 848 "Bezier.c"
}


static gboolean
bezier_is_t_within_range (Bezier* self,
                          gdouble t)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 102 "../src/Bezier.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 103 "../src/Bezier.vala"
	if (((gdouble) 0) <= t) {
#line 103 "../src/Bezier.vala"
		_tmp0_ = t <= ((gdouble) 1);
#line 864 "Bezier.c"
	} else {
#line 103 "../src/Bezier.vala"
		_tmp0_ = FALSE;
#line 868 "Bezier.c"
	}
#line 103 "../src/Bezier.vala"
	result = _tmp0_;
#line 103 "../src/Bezier.vala"
	return result;
#line 874 "Bezier.c"
}


static void
bezier_align_point (Bezier* self,
                    gint pindex,
                    gdouble a,
                    gdouble tx,
                    gdouble ty)
{
	gdouble x = 0.0;
	GArray* _tmp0_;
	BezierPoint* _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
	GArray* _tmp4_;
	BezierPoint* _tmp5_;
	gdouble _tmp6_;
	gdouble _tmp7_;
	gdouble y = 0.0;
	GArray* _tmp8_;
	BezierPoint* _tmp9_;
	gdouble _tmp10_;
	gdouble _tmp11_;
	GArray* _tmp12_;
	BezierPoint* _tmp13_;
	gdouble _tmp14_;
	gdouble _tmp15_;
	GArray* _tmp16_;
	BezierPoint* _tmp17_;
#line 107 "../src/Bezier.vala"
	g_return_if_fail (self != NULL);
#line 108 "../src/Bezier.vala"
	_tmp0_ = self->priv->_points;
#line 108 "../src/Bezier.vala"
	_tmp1_ = g_array_index (_tmp0_, BezierPoint*, (guint) pindex);
#line 108 "../src/Bezier.vala"
	_tmp2_ = bezier_point_get_x (_tmp1_);
#line 108 "../src/Bezier.vala"
	_tmp3_ = _tmp2_;
#line 108 "../src/Bezier.vala"
	_tmp4_ = self->priv->_points;
#line 108 "../src/Bezier.vala"
	_tmp5_ = g_array_index (_tmp4_, BezierPoint*, (guint) pindex);
#line 108 "../src/Bezier.vala"
	_tmp6_ = bezier_point_get_y (_tmp5_);
#line 108 "../src/Bezier.vala"
	_tmp7_ = _tmp6_;
#line 108 "../src/Bezier.vala"
	x = ((_tmp3_ - tx) * cos (a)) - ((_tmp7_ - ty) * sin (a));
#line 109 "../src/Bezier.vala"
	_tmp8_ = self->priv->_points;
#line 109 "../src/Bezier.vala"
	_tmp9_ = g_array_index (_tmp8_, BezierPoint*, (guint) pindex);
#line 109 "../src/Bezier.vala"
	_tmp10_ = bezier_point_get_x (_tmp9_);
#line 109 "../src/Bezier.vala"
	_tmp11_ = _tmp10_;
#line 109 "../src/Bezier.vala"
	_tmp12_ = self->priv->_points;
#line 109 "../src/Bezier.vala"
	_tmp13_ = g_array_index (_tmp12_, BezierPoint*, (guint) pindex);
#line 109 "../src/Bezier.vala"
	_tmp14_ = bezier_point_get_y (_tmp13_);
#line 109 "../src/Bezier.vala"
	_tmp15_ = _tmp14_;
#line 109 "../src/Bezier.vala"
	y = ((_tmp11_ - tx) * sin (a)) + ((_tmp15_ - ty) * cos (a));
#line 110 "../src/Bezier.vala"
	_tmp16_ = self->priv->_apoints;
#line 110 "../src/Bezier.vala"
	_tmp17_ = g_array_index (_tmp16_, BezierPoint*, (guint) pindex);
#line 110 "../src/Bezier.vala"
	bezier_point_set_coordinate (_tmp17_, x, y);
#line 949 "Bezier.c"
}


static void
bezier_align (Bezier* self,
              gdouble lx0,
              gdouble ly0,
              gdouble lx1,
              gdouble ly1)
{
	gdouble tx = 0.0;
	gdouble ty = 0.0;
	gdouble a = 0.0;
	gdouble _tmp0_;
	gdouble _tmp1_;
#line 114 "../src/Bezier.vala"
	g_return_if_fail (self != NULL);
#line 116 "../src/Bezier.vala"
	tx = lx0;
#line 117 "../src/Bezier.vala"
	ty = ly0;
#line 118 "../src/Bezier.vala"
	_tmp0_ = ty;
#line 118 "../src/Bezier.vala"
	_tmp1_ = tx;
#line 118 "../src/Bezier.vala"
	a = -atan2 (ly1 - _tmp0_, lx1 - _tmp1_);
#line 977 "Bezier.c"
	{
		gint i = 0;
#line 120 "../src/Bezier.vala"
		i = 0;
#line 982 "Bezier.c"
		{
			gboolean _tmp2_ = FALSE;
#line 120 "../src/Bezier.vala"
			_tmp2_ = TRUE;
#line 120 "../src/Bezier.vala"
			while (TRUE) {
#line 989 "Bezier.c"
				gint _tmp4_;
				gint _tmp5_;
				gdouble _tmp6_;
				gdouble _tmp7_;
				gdouble _tmp8_;
#line 120 "../src/Bezier.vala"
				if (!_tmp2_) {
#line 997 "Bezier.c"
					gint _tmp3_;
#line 120 "../src/Bezier.vala"
					_tmp3_ = i;
#line 120 "../src/Bezier.vala"
					i = _tmp3_ + 1;
#line 1003 "Bezier.c"
				}
#line 120 "../src/Bezier.vala"
				_tmp2_ = FALSE;
#line 120 "../src/Bezier.vala"
				_tmp4_ = i;
#line 120 "../src/Bezier.vala"
				if (!(_tmp4_ < 3)) {
#line 120 "../src/Bezier.vala"
					break;
#line 1013 "Bezier.c"
				}
#line 121 "../src/Bezier.vala"
				_tmp5_ = i;
#line 121 "../src/Bezier.vala"
				_tmp6_ = a;
#line 121 "../src/Bezier.vala"
				_tmp7_ = tx;
#line 121 "../src/Bezier.vala"
				_tmp8_ = ty;
#line 121 "../src/Bezier.vala"
				bezier_align_point (self, _tmp5_, _tmp6_, _tmp7_, _tmp8_);
#line 1025 "Bezier.c"
			}
		}
	}
}


static gdouble*
_double_dup (gdouble* self)
{
	gdouble* dup;
#line 145 "../src/Bezier.vala"
	dup = g_new0 (gdouble, 1);
#line 145 "../src/Bezier.vala"
	memcpy (dup, self, sizeof (gdouble));
#line 145 "../src/Bezier.vala"
	return dup;
#line 1042 "Bezier.c"
}


static gpointer
__double_dup0 (gpointer self)
{
#line 145 "../src/Bezier.vala"
	return self ? _double_dup (self) : NULL;
#line 1051 "Bezier.c"
}


static void
bezier_get_roots (Bezier* self,
                  gdouble axis,
                  gboolean axis_is_x,
                  GArray* * roots)
{
	gdouble _tmp0_ = 0.0;
	gdouble lx0 = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble ly0 = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble lx1 = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble ly1 = 0.0;
	gdouble _tmp4_;
	gdouble _tmp5_;
	gdouble _tmp6_;
	gdouble _tmp7_;
	gdouble a = 0.0;
	GArray* _tmp8_;
	BezierPoint* _tmp9_;
	gdouble _tmp10_;
	gdouble _tmp11_;
	gdouble b = 0.0;
	GArray* _tmp12_;
	BezierPoint* _tmp13_;
	gdouble _tmp14_;
	gdouble _tmp15_;
	gdouble c = 0.0;
	GArray* _tmp16_;
	BezierPoint* _tmp17_;
	gdouble _tmp18_;
	gdouble _tmp19_;
	gdouble d = 0.0;
	gdouble _tmp20_;
	gdouble _tmp21_;
	gdouble _tmp22_;
	gdouble _tmp23_;
#line 127 "../src/Bezier.vala"
	g_return_if_fail (self != NULL);
#line 127 "../src/Bezier.vala"
	g_return_if_fail (*roots != NULL);
#line 129 "../src/Bezier.vala"
	if (axis_is_x) {
#line 129 "../src/Bezier.vala"
		_tmp0_ = axis;
#line 1101 "Bezier.c"
	} else {
#line 129 "../src/Bezier.vala"
		_tmp0_ = (gdouble) 0;
#line 1105 "Bezier.c"
	}
#line 129 "../src/Bezier.vala"
	lx0 = _tmp0_;
#line 130 "../src/Bezier.vala"
	if (axis_is_x) {
#line 130 "../src/Bezier.vala"
		_tmp1_ = (gdouble) 0;
#line 1113 "Bezier.c"
	} else {
#line 130 "../src/Bezier.vala"
		_tmp1_ = axis;
#line 1117 "Bezier.c"
	}
#line 130 "../src/Bezier.vala"
	ly0 = _tmp1_;
#line 131 "../src/Bezier.vala"
	if (axis_is_x) {
#line 131 "../src/Bezier.vala"
		_tmp2_ = axis;
#line 1125 "Bezier.c"
	} else {
#line 131 "../src/Bezier.vala"
		_tmp2_ = (gdouble) 1000000;
#line 1129 "Bezier.c"
	}
#line 131 "../src/Bezier.vala"
	lx1 = _tmp2_;
#line 132 "../src/Bezier.vala"
	if (axis_is_x) {
#line 132 "../src/Bezier.vala"
		_tmp3_ = (gdouble) 1000000;
#line 1137 "Bezier.c"
	} else {
#line 132 "../src/Bezier.vala"
		_tmp3_ = axis;
#line 1141 "Bezier.c"
	}
#line 132 "../src/Bezier.vala"
	ly1 = _tmp3_;
#line 133 "../src/Bezier.vala"
	_tmp4_ = lx0;
#line 133 "../src/Bezier.vala"
	_tmp5_ = ly0;
#line 133 "../src/Bezier.vala"
	_tmp6_ = lx1;
#line 133 "../src/Bezier.vala"
	_tmp7_ = ly1;
#line 133 "../src/Bezier.vala"
	bezier_align (self, _tmp4_, _tmp5_, _tmp6_, _tmp7_);
#line 135 "../src/Bezier.vala"
	_tmp8_ = self->priv->_apoints;
#line 135 "../src/Bezier.vala"
	_tmp9_ = g_array_index (_tmp8_, BezierPoint*, (guint) 0);
#line 135 "../src/Bezier.vala"
	_tmp10_ = bezier_point_get_y (_tmp9_);
#line 135 "../src/Bezier.vala"
	_tmp11_ = _tmp10_;
#line 135 "../src/Bezier.vala"
	a = _tmp11_;
#line 136 "../src/Bezier.vala"
	_tmp12_ = self->priv->_apoints;
#line 136 "../src/Bezier.vala"
	_tmp13_ = g_array_index (_tmp12_, BezierPoint*, (guint) 1);
#line 136 "../src/Bezier.vala"
	_tmp14_ = bezier_point_get_y (_tmp13_);
#line 136 "../src/Bezier.vala"
	_tmp15_ = _tmp14_;
#line 136 "../src/Bezier.vala"
	b = _tmp15_;
#line 137 "../src/Bezier.vala"
	_tmp16_ = self->priv->_apoints;
#line 137 "../src/Bezier.vala"
	_tmp17_ = g_array_index (_tmp16_, BezierPoint*, (guint) 2);
#line 137 "../src/Bezier.vala"
	_tmp18_ = bezier_point_get_y (_tmp17_);
#line 137 "../src/Bezier.vala"
	_tmp19_ = _tmp18_;
#line 137 "../src/Bezier.vala"
	c = _tmp19_;
#line 138 "../src/Bezier.vala"
	_tmp20_ = a;
#line 138 "../src/Bezier.vala"
	_tmp21_ = b;
#line 138 "../src/Bezier.vala"
	_tmp22_ = c;
#line 138 "../src/Bezier.vala"
	d = (_tmp20_ - (2 * _tmp21_)) + _tmp22_;
#line 140 "../src/Bezier.vala"
	_tmp23_ = d;
#line 140 "../src/Bezier.vala"
	if (_tmp23_ != ((gdouble) 0)) {
#line 1197 "Bezier.c"
		gdouble m1 = 0.0;
		gdouble _tmp24_;
		gdouble _tmp25_;
		gdouble _tmp26_;
		gdouble _tmp27_;
		gdouble m2 = 0.0;
		gdouble _tmp28_;
		gdouble _tmp29_;
		gdouble v1 = 0.0;
		gdouble _tmp30_;
		gdouble _tmp31_;
		gdouble _tmp32_;
		gdouble v2 = 0.0;
		gdouble _tmp33_;
		gdouble _tmp34_;
		gdouble _tmp35_;
		gdouble _tmp36_;
		gdouble _tmp39_;
#line 141 "../src/Bezier.vala"
		_tmp24_ = b;
#line 141 "../src/Bezier.vala"
		_tmp25_ = b;
#line 141 "../src/Bezier.vala"
		_tmp26_ = a;
#line 141 "../src/Bezier.vala"
		_tmp27_ = c;
#line 141 "../src/Bezier.vala"
		m1 = -sqrt ((_tmp24_ * _tmp25_) - (_tmp26_ * _tmp27_));
#line 142 "../src/Bezier.vala"
		_tmp28_ = a;
#line 142 "../src/Bezier.vala"
		_tmp29_ = b;
#line 142 "../src/Bezier.vala"
		m2 = (-_tmp28_) + _tmp29_;
#line 143 "../src/Bezier.vala"
		_tmp30_ = m1;
#line 143 "../src/Bezier.vala"
		_tmp31_ = m2;
#line 143 "../src/Bezier.vala"
		_tmp32_ = d;
#line 143 "../src/Bezier.vala"
		v1 = (-(_tmp30_ + _tmp31_)) / _tmp32_;
#line 144 "../src/Bezier.vala"
		_tmp33_ = m1;
#line 144 "../src/Bezier.vala"
		_tmp34_ = m2;
#line 144 "../src/Bezier.vala"
		_tmp35_ = d;
#line 144 "../src/Bezier.vala"
		v2 = (-((-_tmp33_) + _tmp34_)) / _tmp35_;
#line 145 "../src/Bezier.vala"
		_tmp36_ = v1;
#line 145 "../src/Bezier.vala"
		if (bezier_is_t_within_range (self, _tmp36_)) {
#line 1252 "Bezier.c"
			gdouble _tmp37_;
			gdouble* _tmp38_;
#line 145 "../src/Bezier.vala"
			_tmp37_ = v1;
#line 145 "../src/Bezier.vala"
			_tmp38_ = __double_dup0 (&_tmp37_);
#line 145 "../src/Bezier.vala"
			g_array_append_val (*roots, _tmp38_);
#line 1261 "Bezier.c"
		}
#line 146 "../src/Bezier.vala"
		_tmp39_ = v2;
#line 146 "../src/Bezier.vala"
		if (bezier_is_t_within_range (self, _tmp39_)) {
#line 1267 "Bezier.c"
			gdouble _tmp40_;
			gdouble* _tmp41_;
#line 146 "../src/Bezier.vala"
			_tmp40_ = v2;
#line 146 "../src/Bezier.vala"
			_tmp41_ = __double_dup0 (&_tmp40_);
#line 146 "../src/Bezier.vala"
			g_array_append_val (*roots, _tmp41_);
#line 1276 "Bezier.c"
		}
	} else {
		gdouble _tmp42_;
		gdouble _tmp43_;
#line 147 "../src/Bezier.vala"
		_tmp42_ = b;
#line 147 "../src/Bezier.vala"
		_tmp43_ = c;
#line 147 "../src/Bezier.vala"
		if (_tmp42_ != _tmp43_) {
#line 1287 "Bezier.c"
			gdouble v = 0.0;
			gdouble _tmp44_;
			gdouble _tmp45_;
			gdouble _tmp46_;
			gdouble _tmp47_;
			gdouble _tmp48_;
#line 148 "../src/Bezier.vala"
			_tmp44_ = b;
#line 148 "../src/Bezier.vala"
			_tmp45_ = c;
#line 148 "../src/Bezier.vala"
			_tmp46_ = b;
#line 148 "../src/Bezier.vala"
			_tmp47_ = c;
#line 148 "../src/Bezier.vala"
			v = ((2 * _tmp44_) - _tmp45_) / (2 * (_tmp46_ - _tmp47_));
#line 149 "../src/Bezier.vala"
			_tmp48_ = v;
#line 149 "../src/Bezier.vala"
			if (bezier_is_t_within_range (self, _tmp48_)) {
#line 1308 "Bezier.c"
				gdouble _tmp49_;
				gdouble* _tmp50_;
#line 149 "../src/Bezier.vala"
				_tmp49_ = v;
#line 149 "../src/Bezier.vala"
				_tmp50_ = __double_dup0 (&_tmp49_);
#line 149 "../src/Bezier.vala"
				g_array_append_val (*roots, _tmp50_);
#line 1317 "Bezier.c"
			}
		}
	}
}


static gdouble
bezier_get_axis (Bezier* self,
                 gdouble t,
                 gboolean axis_is_x)
{
	gdouble result = 0.0;
	gdouble mt = 0.0;
	gdouble mt2 = 0.0;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble t2 = 0.0;
	gdouble a = 0.0;
	gdouble _tmp2_;
	gdouble b = 0.0;
	gdouble _tmp3_;
	gdouble c = 0.0;
	gdouble _tmp4_;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp14_ = 0.0;
	gdouble _tmp23_ = 0.0;
	gdouble axis = 0.0;
	gdouble _tmp32_;
	gdouble _tmp33_;
	gdouble _tmp34_;
#line 154 "../src/Bezier.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 156 "../src/Bezier.vala"
	mt = 1 - t;
#line 157 "../src/Bezier.vala"
	_tmp0_ = mt;
#line 157 "../src/Bezier.vala"
	_tmp1_ = mt;
#line 157 "../src/Bezier.vala"
	mt2 = _tmp0_ * _tmp1_;
#line 158 "../src/Bezier.vala"
	t2 = t * t;
#line 159 "../src/Bezier.vala"
	_tmp2_ = mt2;
#line 159 "../src/Bezier.vala"
	a = _tmp2_;
#line 160 "../src/Bezier.vala"
	_tmp3_ = mt;
#line 160 "../src/Bezier.vala"
	b = (_tmp3_ * t) * 2;
#line 161 "../src/Bezier.vala"
	_tmp4_ = t2;
#line 161 "../src/Bezier.vala"
	c = _tmp4_;
#line 162 "../src/Bezier.vala"
	if (axis_is_x) {
#line 1374 "Bezier.c"
		GArray* _tmp6_;
		BezierPoint* _tmp7_;
		gdouble _tmp8_;
		gdouble _tmp9_;
#line 162 "../src/Bezier.vala"
		_tmp6_ = self->priv->_points;
#line 162 "../src/Bezier.vala"
		_tmp7_ = g_array_index (_tmp6_, BezierPoint*, (guint) 0);
#line 162 "../src/Bezier.vala"
		_tmp8_ = bezier_point_get_y (_tmp7_);
#line 162 "../src/Bezier.vala"
		_tmp9_ = _tmp8_;
#line 162 "../src/Bezier.vala"
		_tmp5_ = _tmp9_;
#line 1389 "Bezier.c"
	} else {
		GArray* _tmp10_;
		BezierPoint* _tmp11_;
		gdouble _tmp12_;
		gdouble _tmp13_;
#line 162 "../src/Bezier.vala"
		_tmp10_ = self->priv->_points;
#line 162 "../src/Bezier.vala"
		_tmp11_ = g_array_index (_tmp10_, BezierPoint*, (guint) 0);
#line 162 "../src/Bezier.vala"
		_tmp12_ = bezier_point_get_x (_tmp11_);
#line 162 "../src/Bezier.vala"
		_tmp13_ = _tmp12_;
#line 162 "../src/Bezier.vala"
		_tmp5_ = _tmp13_;
#line 1405 "Bezier.c"
	}
#line 163 "../src/Bezier.vala"
	if (axis_is_x) {
#line 1409 "Bezier.c"
		GArray* _tmp15_;
		BezierPoint* _tmp16_;
		gdouble _tmp17_;
		gdouble _tmp18_;
#line 163 "../src/Bezier.vala"
		_tmp15_ = self->priv->_points;
#line 163 "../src/Bezier.vala"
		_tmp16_ = g_array_index (_tmp15_, BezierPoint*, (guint) 1);
#line 163 "../src/Bezier.vala"
		_tmp17_ = bezier_point_get_y (_tmp16_);
#line 163 "../src/Bezier.vala"
		_tmp18_ = _tmp17_;
#line 163 "../src/Bezier.vala"
		_tmp14_ = _tmp18_;
#line 1424 "Bezier.c"
	} else {
		GArray* _tmp19_;
		BezierPoint* _tmp20_;
		gdouble _tmp21_;
		gdouble _tmp22_;
#line 163 "../src/Bezier.vala"
		_tmp19_ = self->priv->_points;
#line 163 "../src/Bezier.vala"
		_tmp20_ = g_array_index (_tmp19_, BezierPoint*, (guint) 1);
#line 163 "../src/Bezier.vala"
		_tmp21_ = bezier_point_get_x (_tmp20_);
#line 163 "../src/Bezier.vala"
		_tmp22_ = _tmp21_;
#line 163 "../src/Bezier.vala"
		_tmp14_ = _tmp22_;
#line 1440 "Bezier.c"
	}
#line 164 "../src/Bezier.vala"
	if (axis_is_x) {
#line 1444 "Bezier.c"
		GArray* _tmp24_;
		BezierPoint* _tmp25_;
		gdouble _tmp26_;
		gdouble _tmp27_;
#line 164 "../src/Bezier.vala"
		_tmp24_ = self->priv->_points;
#line 164 "../src/Bezier.vala"
		_tmp25_ = g_array_index (_tmp24_, BezierPoint*, (guint) 2);
#line 164 "../src/Bezier.vala"
		_tmp26_ = bezier_point_get_y (_tmp25_);
#line 164 "../src/Bezier.vala"
		_tmp27_ = _tmp26_;
#line 164 "../src/Bezier.vala"
		_tmp23_ = _tmp27_;
#line 1459 "Bezier.c"
	} else {
		GArray* _tmp28_;
		BezierPoint* _tmp29_;
		gdouble _tmp30_;
		gdouble _tmp31_;
#line 164 "../src/Bezier.vala"
		_tmp28_ = self->priv->_points;
#line 164 "../src/Bezier.vala"
		_tmp29_ = g_array_index (_tmp28_, BezierPoint*, (guint) 2);
#line 164 "../src/Bezier.vala"
		_tmp30_ = bezier_point_get_x (_tmp29_);
#line 164 "../src/Bezier.vala"
		_tmp31_ = _tmp30_;
#line 164 "../src/Bezier.vala"
		_tmp23_ = _tmp31_;
#line 1475 "Bezier.c"
	}
#line 162 "../src/Bezier.vala"
	_tmp32_ = a;
#line 162 "../src/Bezier.vala"
	_tmp33_ = b;
#line 162 "../src/Bezier.vala"
	_tmp34_ = c;
#line 162 "../src/Bezier.vala"
	axis = ((_tmp32_ * _tmp5_) + (_tmp33_ * _tmp14_)) + (_tmp34_ * _tmp23_);
#line 166 "../src/Bezier.vala"
	result = axis;
#line 166 "../src/Bezier.vala"
	return result;
#line 1489 "Bezier.c"
}


static void
_g_free0_ (gpointer var)
{
#line 173 "../src/Bezier.vala"
	(var == NULL) ? NULL : (var = (g_free (var), NULL));
#line 1498 "Bezier.c"
}


static void
_vala_gdouble_free_function_content_of (gpointer data)
{
	gdouble* self;
#line 173 "../src/Bezier.vala"
	self = *((gdouble**) data);
#line 173 "../src/Bezier.vala"
	_g_free0_ (self);
#line 1510 "Bezier.c"
}


static gpointer*
vala_g_array_remove_range (GArray* self,
                           guint index,
                           guint length,
                           int* result_length1)
{
	gpointer* result = NULL;
	guint _tmp0_;
	gpointer* ga = NULL;
	gpointer* _tmp1_;
	gint ga_length1;
	gint _ga_size_;
	gpointer* _tmp10_;
	gint _tmp10__length1;
#line 5314 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 5315 "glib-2.0.vapi"
	_tmp0_ = self->len;
#line 5315 "glib-2.0.vapi"
	_vala_assert (_tmp0_ >= (index + length), "this.length >= index + length");
#line 5316 "glib-2.0.vapi"
	_tmp1_ = g_new0 (gpointer, length);
#line 5316 "glib-2.0.vapi"
	ga = _tmp1_;
#line 5316 "glib-2.0.vapi"
	ga_length1 = length;
#line 5316 "glib-2.0.vapi"
	_ga_size_ = ga_length1;
#line 1542 "Bezier.c"
	{
		guint i = 0U;
#line 5317 "glib-2.0.vapi"
		i = (guint) 0;
#line 1547 "Bezier.c"
		{
			gboolean _tmp2_ = FALSE;
#line 5317 "glib-2.0.vapi"
			_tmp2_ = TRUE;
#line 5317 "glib-2.0.vapi"
			while (TRUE) {
#line 1554 "Bezier.c"
				guint _tmp4_;
				gpointer* _tmp5_;
				gint _tmp5__length1;
				guint _tmp6_;
				gpointer* _tmp7_;
				gint _tmp7__length1;
				guint _tmp8_;
				gpointer _tmp9_;
#line 5317 "glib-2.0.vapi"
				if (!_tmp2_) {
#line 1565 "Bezier.c"
					guint _tmp3_;
#line 5317 "glib-2.0.vapi"
					_tmp3_ = i;
#line 5317 "glib-2.0.vapi"
					i = _tmp3_ + 1;
#line 1571 "Bezier.c"
				}
#line 5317 "glib-2.0.vapi"
				_tmp2_ = FALSE;
#line 5317 "glib-2.0.vapi"
				_tmp4_ = i;
#line 5317 "glib-2.0.vapi"
				if (!(_tmp4_ < length)) {
#line 5317 "glib-2.0.vapi"
					break;
#line 1581 "Bezier.c"
				}
#line 5318 "glib-2.0.vapi"
				_tmp5_ = ga;
#line 5318 "glib-2.0.vapi"
				_tmp5__length1 = ga_length1;
#line 5318 "glib-2.0.vapi"
				_tmp6_ = i;
#line 5318 "glib-2.0.vapi"
				_tmp7_ = self->data;
#line 5318 "glib-2.0.vapi"
				_tmp7__length1 = (gint) self->len;
#line 5318 "glib-2.0.vapi"
				_tmp8_ = i;
#line 5318 "glib-2.0.vapi"
				_tmp9_ = _tmp7_[_tmp8_ + index];
#line 5318 "glib-2.0.vapi"
				_tmp7_[_tmp8_ + index] = NULL;
#line 5318 "glib-2.0.vapi"
				_tmp5_[_tmp6_] = _tmp9_;
#line 1601 "Bezier.c"
			}
		}
	}
#line 5320 "glib-2.0.vapi"
	g_array_remove_range (self, index, length);
#line 5321 "glib-2.0.vapi"
	_tmp10_ = ga;
#line 5321 "glib-2.0.vapi"
	_tmp10__length1 = ga_length1;
#line 5321 "glib-2.0.vapi"
	if (result_length1) {
#line 5321 "glib-2.0.vapi"
		*result_length1 = _tmp10__length1;
#line 1615 "Bezier.c"
	}
#line 5321 "glib-2.0.vapi"
	result = _tmp10_;
#line 5321 "glib-2.0.vapi"
	return result;
#line 1621 "Bezier.c"
}


gboolean
bezier_within_range (Bezier* self,
                     gdouble x,
                     gdouble y)
{
	gboolean result = FALSE;
	GArray* roots = NULL;
	GArray* _tmp0_;
	gdouble tolerance = 0.0;
	GArray* _tmp1_;
	guint _tmp2_;
	GArray* _tmp15_;
	GArray* _tmp16_;
	guint _tmp17_;
	gint _tmp18_ = 0;
	gpointer* _tmp19_;
	gdouble** _tmp20_;
	gint _tmp20__length1;
#line 171 "../src/Bezier.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 173 "../src/Bezier.vala"
	_tmp0_ = g_array_new (TRUE, TRUE, sizeof (gdouble*));
#line 173 "../src/Bezier.vala"
	g_array_set_clear_func (_tmp0_, _vala_gdouble_free_function_content_of);
#line 173 "../src/Bezier.vala"
	roots = _tmp0_;
#line 174 "../src/Bezier.vala"
	tolerance = (gdouble) 10;
#line 177 "../src/Bezier.vala"
	bezier_get_roots (self, x, TRUE, &roots);
#line 179 "../src/Bezier.vala"
	_tmp1_ = roots;
#line 179 "../src/Bezier.vala"
	_tmp2_ = _tmp1_->len;
#line 179 "../src/Bezier.vala"
	if (_tmp2_ > ((guint) 0)) {
#line 1661 "Bezier.c"
		{
			gint i = 0;
#line 180 "../src/Bezier.vala"
			i = 0;
#line 1666 "Bezier.c"
			{
				gboolean _tmp3_ = FALSE;
#line 180 "../src/Bezier.vala"
				_tmp3_ = TRUE;
#line 180 "../src/Bezier.vala"
				while (TRUE) {
#line 1673 "Bezier.c"
					gint _tmp5_;
					GArray* _tmp6_;
					guint _tmp7_;
					gdouble curve_y = 0.0;
					GArray* _tmp8_;
					gint _tmp9_;
					gboolean _tmp10_ = FALSE;
					gdouble _tmp11_;
					gdouble _tmp12_;
#line 180 "../src/Bezier.vala"
					if (!_tmp3_) {
#line 1685 "Bezier.c"
						gint _tmp4_;
#line 180 "../src/Bezier.vala"
						_tmp4_ = i;
#line 180 "../src/Bezier.vala"
						i = _tmp4_ + 1;
#line 1691 "Bezier.c"
					}
#line 180 "../src/Bezier.vala"
					_tmp3_ = FALSE;
#line 180 "../src/Bezier.vala"
					_tmp5_ = i;
#line 180 "../src/Bezier.vala"
					_tmp6_ = roots;
#line 180 "../src/Bezier.vala"
					_tmp7_ = _tmp6_->len;
#line 180 "../src/Bezier.vala"
					if (!(((guint) _tmp5_) < _tmp7_)) {
#line 180 "../src/Bezier.vala"
						break;
#line 1705 "Bezier.c"
					}
#line 181 "../src/Bezier.vala"
					_tmp8_ = roots;
#line 181 "../src/Bezier.vala"
					_tmp9_ = i;
#line 181 "../src/Bezier.vala"
					curve_y = bezier_get_axis (self, *g_array_index (_tmp8_, gdouble*, (guint) _tmp9_), TRUE);
#line 182 "../src/Bezier.vala"
					_tmp11_ = curve_y;
#line 182 "../src/Bezier.vala"
					_tmp12_ = tolerance;
#line 182 "../src/Bezier.vala"
					if ((_tmp11_ - _tmp12_) <= y) {
#line 1719 "Bezier.c"
						gdouble _tmp13_;
						gdouble _tmp14_;
#line 182 "../src/Bezier.vala"
						_tmp13_ = curve_y;
#line 182 "../src/Bezier.vala"
						_tmp14_ = tolerance;
#line 182 "../src/Bezier.vala"
						_tmp10_ = y <= (_tmp13_ + _tmp14_);
#line 1728 "Bezier.c"
					} else {
#line 182 "../src/Bezier.vala"
						_tmp10_ = FALSE;
#line 1732 "Bezier.c"
					}
#line 182 "../src/Bezier.vala"
					if (_tmp10_) {
#line 183 "../src/Bezier.vala"
						result = TRUE;
#line 183 "../src/Bezier.vala"
						_g_array_unref0 (roots);
#line 183 "../src/Bezier.vala"
						return result;
#line 1742 "Bezier.c"
					}
				}
			}
		}
	}
#line 189 "../src/Bezier.vala"
	_tmp15_ = roots;
#line 189 "../src/Bezier.vala"
	_tmp16_ = roots;
#line 189 "../src/Bezier.vala"
	_tmp17_ = _tmp16_->len;
#line 189 "../src/Bezier.vala"
	_tmp19_ = vala_g_array_remove_range (_tmp15_, (guint) 0, _tmp17_, &_tmp18_);
#line 189 "../src/Bezier.vala"
	_tmp20_ = _tmp19_;
#line 189 "../src/Bezier.vala"
	_tmp20__length1 = _tmp18_;
#line 189 "../src/Bezier.vala"
	_tmp20_ = (_vala_array_free (_tmp20_, _tmp20__length1, (GDestroyNotify) g_free), NULL);
#line 190 "../src/Bezier.vala"
	bezier_get_roots (self, y, FALSE, &roots);
#line 1764 "Bezier.c"
	{
		gint i = 0;
#line 192 "../src/Bezier.vala"
		i = 0;
#line 1769 "Bezier.c"
		{
			gboolean _tmp21_ = FALSE;
#line 192 "../src/Bezier.vala"
			_tmp21_ = TRUE;
#line 192 "../src/Bezier.vala"
			while (TRUE) {
#line 1776 "Bezier.c"
				gint _tmp23_;
				GArray* _tmp24_;
				guint _tmp25_;
				gdouble curve_x = 0.0;
				GArray* _tmp26_;
				gint _tmp27_;
				gboolean _tmp28_ = FALSE;
				gdouble _tmp29_;
				gdouble _tmp30_;
#line 192 "../src/Bezier.vala"
				if (!_tmp21_) {
#line 1788 "Bezier.c"
					gint _tmp22_;
#line 192 "../src/Bezier.vala"
					_tmp22_ = i;
#line 192 "../src/Bezier.vala"
					i = _tmp22_ + 1;
#line 1794 "Bezier.c"
				}
#line 192 "../src/Bezier.vala"
				_tmp21_ = FALSE;
#line 192 "../src/Bezier.vala"
				_tmp23_ = i;
#line 192 "../src/Bezier.vala"
				_tmp24_ = roots;
#line 192 "../src/Bezier.vala"
				_tmp25_ = _tmp24_->len;
#line 192 "../src/Bezier.vala"
				if (!(((guint) _tmp23_) < _tmp25_)) {
#line 192 "../src/Bezier.vala"
					break;
#line 1808 "Bezier.c"
				}
#line 193 "../src/Bezier.vala"
				_tmp26_ = roots;
#line 193 "../src/Bezier.vala"
				_tmp27_ = i;
#line 193 "../src/Bezier.vala"
				curve_x = bezier_get_axis (self, *g_array_index (_tmp26_, gdouble*, (guint) _tmp27_), FALSE);
#line 194 "../src/Bezier.vala"
				_tmp29_ = curve_x;
#line 194 "../src/Bezier.vala"
				_tmp30_ = tolerance;
#line 194 "../src/Bezier.vala"
				if ((_tmp29_ - _tmp30_) <= x) {
#line 1822 "Bezier.c"
					gdouble _tmp31_;
					gdouble _tmp32_;
#line 194 "../src/Bezier.vala"
					_tmp31_ = curve_x;
#line 194 "../src/Bezier.vala"
					_tmp32_ = tolerance;
#line 194 "../src/Bezier.vala"
					_tmp28_ = x <= (_tmp31_ + _tmp32_);
#line 1831 "Bezier.c"
				} else {
#line 194 "../src/Bezier.vala"
					_tmp28_ = FALSE;
#line 1835 "Bezier.c"
				}
#line 194 "../src/Bezier.vala"
				if (_tmp28_) {
#line 195 "../src/Bezier.vala"
					result = TRUE;
#line 195 "../src/Bezier.vala"
					_g_array_unref0 (roots);
#line 195 "../src/Bezier.vala"
					return result;
#line 1845 "Bezier.c"
				}
			}
		}
	}
#line 199 "../src/Bezier.vala"
	result = FALSE;
#line 199 "../src/Bezier.vala"
	_g_array_unref0 (roots);
#line 199 "../src/Bezier.vala"
	return result;
#line 1856 "Bezier.c"
}


gdouble*
bezier_get_intersecting_point (Bezier* self,
                               gdouble axis,
                               gboolean axis_is_x,
                               gboolean from)
{
	gdouble* result = NULL;
	GArray* roots = NULL;
	GArray* _tmp0_;
	GArray* _tmp1_;
	guint _tmp2_;
#line 204 "../src/Bezier.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 206 "../src/Bezier.vala"
	_tmp0_ = g_array_new (TRUE, TRUE, sizeof (gdouble*));
#line 206 "../src/Bezier.vala"
	g_array_set_clear_func (_tmp0_, _vala_gdouble_free_function_content_of);
#line 206 "../src/Bezier.vala"
	roots = _tmp0_;
#line 208 "../src/Bezier.vala"
	bezier_get_roots (self, axis, axis_is_x, &roots);
#line 210 "../src/Bezier.vala"
	_tmp1_ = roots;
#line 210 "../src/Bezier.vala"
	_tmp2_ = _tmp1_->len;
#line 210 "../src/Bezier.vala"
	switch (_tmp2_) {
#line 210 "../src/Bezier.vala"
		case 0:
#line 1889 "Bezier.c"
		{
#line 211 "../src/Bezier.vala"
			result = NULL;
#line 211 "../src/Bezier.vala"
			_g_array_unref0 (roots);
#line 211 "../src/Bezier.vala"
			return result;
#line 1897 "Bezier.c"
		}
#line 210 "../src/Bezier.vala"
		case 1:
#line 1901 "Bezier.c"
		{
			GArray* _tmp3_;
			gdouble _tmp4_;
			gdouble* _tmp5_;
#line 213 "../src/Bezier.vala"
			_tmp3_ = roots;
#line 213 "../src/Bezier.vala"
			_tmp4_ = bezier_get_axis (self, *g_array_index (_tmp3_, gdouble*, (guint) 0), axis_is_x);
#line 213 "../src/Bezier.vala"
			_tmp5_ = __double_dup0 (&_tmp4_);
#line 213 "../src/Bezier.vala"
			result = _tmp5_;
#line 213 "../src/Bezier.vala"
			_g_array_unref0 (roots);
#line 213 "../src/Bezier.vala"
			return result;
#line 1918 "Bezier.c"
		}
		default:
		{
#line 215 "../src/Bezier.vala"
			if (from) {
#line 1924 "Bezier.c"
				gdouble max = 0.0;
				gdouble _tmp16_;
				gdouble _tmp17_;
				gdouble* _tmp18_;
#line 216 "../src/Bezier.vala"
				max = (gdouble) 1000000;
#line 1931 "Bezier.c"
				{
					gint i = 0;
#line 217 "../src/Bezier.vala"
					i = 0;
#line 1936 "Bezier.c"
					{
						gboolean _tmp6_ = FALSE;
#line 217 "../src/Bezier.vala"
						_tmp6_ = TRUE;
#line 217 "../src/Bezier.vala"
						while (TRUE) {
#line 1943 "Bezier.c"
							gint _tmp8_;
							GArray* _tmp9_;
							guint _tmp10_;
							GArray* _tmp11_;
							gint _tmp12_;
							gdouble _tmp13_;
#line 217 "../src/Bezier.vala"
							if (!_tmp6_) {
#line 1952 "Bezier.c"
								gint _tmp7_;
#line 217 "../src/Bezier.vala"
								_tmp7_ = i;
#line 217 "../src/Bezier.vala"
								i = _tmp7_ + 1;
#line 1958 "Bezier.c"
							}
#line 217 "../src/Bezier.vala"
							_tmp6_ = FALSE;
#line 217 "../src/Bezier.vala"
							_tmp8_ = i;
#line 217 "../src/Bezier.vala"
							_tmp9_ = roots;
#line 217 "../src/Bezier.vala"
							_tmp10_ = _tmp9_->len;
#line 217 "../src/Bezier.vala"
							if (!(((guint) _tmp8_) < _tmp10_)) {
#line 217 "../src/Bezier.vala"
								break;
#line 1972 "Bezier.c"
							}
#line 218 "../src/Bezier.vala"
							_tmp11_ = roots;
#line 218 "../src/Bezier.vala"
							_tmp12_ = i;
#line 218 "../src/Bezier.vala"
							_tmp13_ = max;
#line 218 "../src/Bezier.vala"
							if ((*g_array_index (_tmp11_, gdouble*, (guint) _tmp12_)) < _tmp13_) {
#line 1982 "Bezier.c"
								GArray* _tmp14_;
								gint _tmp15_;
#line 219 "../src/Bezier.vala"
								_tmp14_ = roots;
#line 219 "../src/Bezier.vala"
								_tmp15_ = i;
#line 219 "../src/Bezier.vala"
								max = *g_array_index (_tmp14_, gdouble*, (guint) _tmp15_);
#line 1991 "Bezier.c"
							}
						}
					}
				}
#line 222 "../src/Bezier.vala"
				_tmp16_ = max;
#line 222 "../src/Bezier.vala"
				_tmp17_ = bezier_get_axis (self, _tmp16_, axis_is_x);
#line 222 "../src/Bezier.vala"
				_tmp18_ = __double_dup0 (&_tmp17_);
#line 222 "../src/Bezier.vala"
				result = _tmp18_;
#line 222 "../src/Bezier.vala"
				_g_array_unref0 (roots);
#line 222 "../src/Bezier.vala"
				return result;
#line 2008 "Bezier.c"
			} else {
				gdouble min = 0.0;
				gdouble _tmp29_;
				gdouble _tmp30_;
				gdouble* _tmp31_;
#line 224 "../src/Bezier.vala"
				min = (gdouble) 0;
#line 2016 "Bezier.c"
				{
					gint i = 0;
#line 225 "../src/Bezier.vala"
					i = 0;
#line 2021 "Bezier.c"
					{
						gboolean _tmp19_ = FALSE;
#line 225 "../src/Bezier.vala"
						_tmp19_ = TRUE;
#line 225 "../src/Bezier.vala"
						while (TRUE) {
#line 2028 "Bezier.c"
							gint _tmp21_;
							GArray* _tmp22_;
							guint _tmp23_;
							GArray* _tmp24_;
							gint _tmp25_;
							gdouble _tmp26_;
#line 225 "../src/Bezier.vala"
							if (!_tmp19_) {
#line 2037 "Bezier.c"
								gint _tmp20_;
#line 225 "../src/Bezier.vala"
								_tmp20_ = i;
#line 225 "../src/Bezier.vala"
								i = _tmp20_ + 1;
#line 2043 "Bezier.c"
							}
#line 225 "../src/Bezier.vala"
							_tmp19_ = FALSE;
#line 225 "../src/Bezier.vala"
							_tmp21_ = i;
#line 225 "../src/Bezier.vala"
							_tmp22_ = roots;
#line 225 "../src/Bezier.vala"
							_tmp23_ = _tmp22_->len;
#line 225 "../src/Bezier.vala"
							if (!(((guint) _tmp21_) < _tmp23_)) {
#line 225 "../src/Bezier.vala"
								break;
#line 2057 "Bezier.c"
							}
#line 226 "../src/Bezier.vala"
							_tmp24_ = roots;
#line 226 "../src/Bezier.vala"
							_tmp25_ = i;
#line 226 "../src/Bezier.vala"
							_tmp26_ = min;
#line 226 "../src/Bezier.vala"
							if ((*g_array_index (_tmp24_, gdouble*, (guint) _tmp25_)) > _tmp26_) {
#line 2067 "Bezier.c"
								GArray* _tmp27_;
								gint _tmp28_;
#line 227 "../src/Bezier.vala"
								_tmp27_ = roots;
#line 227 "../src/Bezier.vala"
								_tmp28_ = i;
#line 227 "../src/Bezier.vala"
								min = *g_array_index (_tmp27_, gdouble*, (guint) _tmp28_);
#line 2076 "Bezier.c"
							}
						}
					}
				}
#line 230 "../src/Bezier.vala"
				_tmp29_ = min;
#line 230 "../src/Bezier.vala"
				_tmp30_ = bezier_get_axis (self, _tmp29_, axis_is_x);
#line 230 "../src/Bezier.vala"
				_tmp31_ = __double_dup0 (&_tmp30_);
#line 230 "../src/Bezier.vala"
				result = _tmp31_;
#line 230 "../src/Bezier.vala"
				_g_array_unref0 (roots);
#line 230 "../src/Bezier.vala"
				return result;
#line 2093 "Bezier.c"
			}
		}
	}
#line 204 "../src/Bezier.vala"
	_g_array_unref0 (roots);
#line 2099 "Bezier.c"
}


void
bezier_set_connect_point (Bezier* self,
                          gboolean from,
                          gdouble top,
                          gdouble bottom,
                          gdouble left,
                          gdouble right)
{
	gdouble* isect = NULL;
	gdouble* _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gdouble* _tmp3_;
	gdouble* _tmp10_;
	gboolean _tmp11_ = FALSE;
	gboolean _tmp12_ = FALSE;
	gdouble* _tmp13_;
	gdouble* _tmp20_;
	gboolean _tmp21_ = FALSE;
	gboolean _tmp22_ = FALSE;
	gdouble* _tmp23_;
	gdouble* _tmp30_;
	gboolean _tmp31_ = FALSE;
	gboolean _tmp32_ = FALSE;
	gdouble* _tmp33_;
#line 237 "../src/Bezier.vala"
	g_return_if_fail (self != NULL);
#line 242 "../src/Bezier.vala"
	_tmp0_ = bezier_get_intersecting_point (self, top, FALSE, from);
#line 242 "../src/Bezier.vala"
	_g_free0 (isect);
#line 242 "../src/Bezier.vala"
	isect = _tmp0_;
#line 243 "../src/Bezier.vala"
	_tmp3_ = isect;
#line 243 "../src/Bezier.vala"
	if (_tmp3_ != NULL) {
#line 2140 "Bezier.c"
		gdouble* _tmp4_;
#line 243 "../src/Bezier.vala"
		_tmp4_ = isect;
#line 243 "../src/Bezier.vala"
		_tmp2_ = left <= (*_tmp4_);
#line 2146 "Bezier.c"
	} else {
#line 243 "../src/Bezier.vala"
		_tmp2_ = FALSE;
#line 2150 "Bezier.c"
	}
#line 243 "../src/Bezier.vala"
	if (_tmp2_) {
#line 2154 "Bezier.c"
		gdouble* _tmp5_;
#line 243 "../src/Bezier.vala"
		_tmp5_ = isect;
#line 243 "../src/Bezier.vala"
		_tmp1_ = (*_tmp5_) <= right;
#line 2160 "Bezier.c"
	} else {
#line 243 "../src/Bezier.vala"
		_tmp1_ = FALSE;
#line 2164 "Bezier.c"
	}
#line 243 "../src/Bezier.vala"
	if (_tmp1_) {
#line 244 "../src/Bezier.vala"
		if (from) {
#line 2170 "Bezier.c"
			BezierPoint* _tmp6_;
			gdouble* _tmp7_;
#line 244 "../src/Bezier.vala"
			_tmp6_ = self->priv->_from;
#line 244 "../src/Bezier.vala"
			_tmp7_ = isect;
#line 244 "../src/Bezier.vala"
			bezier_point_set_coordinate (_tmp6_, *_tmp7_, top);
#line 2179 "Bezier.c"
		} else {
			BezierPoint* _tmp8_;
			gdouble* _tmp9_;
#line 244 "../src/Bezier.vala"
			_tmp8_ = self->priv->_to;
#line 244 "../src/Bezier.vala"
			_tmp9_ = isect;
#line 244 "../src/Bezier.vala"
			bezier_point_set_coordinate (_tmp8_, *_tmp9_, top);
#line 2189 "Bezier.c"
		}
#line 245 "../src/Bezier.vala"
		_g_free0 (isect);
#line 245 "../src/Bezier.vala"
		return;
#line 2195 "Bezier.c"
	}
#line 249 "../src/Bezier.vala"
	_tmp10_ = bezier_get_intersecting_point (self, bottom, FALSE, from);
#line 249 "../src/Bezier.vala"
	_g_free0 (isect);
#line 249 "../src/Bezier.vala"
	isect = _tmp10_;
#line 250 "../src/Bezier.vala"
	_tmp13_ = isect;
#line 250 "../src/Bezier.vala"
	if (_tmp13_ != NULL) {
#line 2207 "Bezier.c"
		gdouble* _tmp14_;
#line 250 "../src/Bezier.vala"
		_tmp14_ = isect;
#line 250 "../src/Bezier.vala"
		_tmp12_ = left <= (*_tmp14_);
#line 2213 "Bezier.c"
	} else {
#line 250 "../src/Bezier.vala"
		_tmp12_ = FALSE;
#line 2217 "Bezier.c"
	}
#line 250 "../src/Bezier.vala"
	if (_tmp12_) {
#line 2221 "Bezier.c"
		gdouble* _tmp15_;
#line 250 "../src/Bezier.vala"
		_tmp15_ = isect;
#line 250 "../src/Bezier.vala"
		_tmp11_ = (*_tmp15_) <= right;
#line 2227 "Bezier.c"
	} else {
#line 250 "../src/Bezier.vala"
		_tmp11_ = FALSE;
#line 2231 "Bezier.c"
	}
#line 250 "../src/Bezier.vala"
	if (_tmp11_) {
#line 251 "../src/Bezier.vala"
		if (from) {
#line 2237 "Bezier.c"
			BezierPoint* _tmp16_;
			gdouble* _tmp17_;
#line 251 "../src/Bezier.vala"
			_tmp16_ = self->priv->_from;
#line 251 "../src/Bezier.vala"
			_tmp17_ = isect;
#line 251 "../src/Bezier.vala"
			bezier_point_set_coordinate (_tmp16_, *_tmp17_, bottom);
#line 2246 "Bezier.c"
		} else {
			BezierPoint* _tmp18_;
			gdouble* _tmp19_;
#line 251 "../src/Bezier.vala"
			_tmp18_ = self->priv->_to;
#line 251 "../src/Bezier.vala"
			_tmp19_ = isect;
#line 251 "../src/Bezier.vala"
			bezier_point_set_coordinate (_tmp18_, *_tmp19_, bottom);
#line 2256 "Bezier.c"
		}
#line 252 "../src/Bezier.vala"
		_g_free0 (isect);
#line 252 "../src/Bezier.vala"
		return;
#line 2262 "Bezier.c"
	}
#line 256 "../src/Bezier.vala"
	_tmp20_ = bezier_get_intersecting_point (self, left, TRUE, from);
#line 256 "../src/Bezier.vala"
	_g_free0 (isect);
#line 256 "../src/Bezier.vala"
	isect = _tmp20_;
#line 257 "../src/Bezier.vala"
	_tmp23_ = isect;
#line 257 "../src/Bezier.vala"
	if (_tmp23_ != NULL) {
#line 2274 "Bezier.c"
		gdouble* _tmp24_;
#line 257 "../src/Bezier.vala"
		_tmp24_ = isect;
#line 257 "../src/Bezier.vala"
		_tmp22_ = top <= (*_tmp24_);
#line 2280 "Bezier.c"
	} else {
#line 257 "../src/Bezier.vala"
		_tmp22_ = FALSE;
#line 2284 "Bezier.c"
	}
#line 257 "../src/Bezier.vala"
	if (_tmp22_) {
#line 2288 "Bezier.c"
		gdouble* _tmp25_;
#line 257 "../src/Bezier.vala"
		_tmp25_ = isect;
#line 257 "../src/Bezier.vala"
		_tmp21_ = (*_tmp25_) <= bottom;
#line 2294 "Bezier.c"
	} else {
#line 257 "../src/Bezier.vala"
		_tmp21_ = FALSE;
#line 2298 "Bezier.c"
	}
#line 257 "../src/Bezier.vala"
	if (_tmp21_) {
#line 258 "../src/Bezier.vala"
		if (from) {
#line 2304 "Bezier.c"
			BezierPoint* _tmp26_;
			gdouble* _tmp27_;
#line 258 "../src/Bezier.vala"
			_tmp26_ = self->priv->_from;
#line 258 "../src/Bezier.vala"
			_tmp27_ = isect;
#line 258 "../src/Bezier.vala"
			bezier_point_set_coordinate (_tmp26_, left, *_tmp27_);
#line 2313 "Bezier.c"
		} else {
			BezierPoint* _tmp28_;
			gdouble* _tmp29_;
#line 258 "../src/Bezier.vala"
			_tmp28_ = self->priv->_to;
#line 258 "../src/Bezier.vala"
			_tmp29_ = isect;
#line 258 "../src/Bezier.vala"
			bezier_point_set_coordinate (_tmp28_, left, *_tmp29_);
#line 2323 "Bezier.c"
		}
#line 259 "../src/Bezier.vala"
		_g_free0 (isect);
#line 259 "../src/Bezier.vala"
		return;
#line 2329 "Bezier.c"
	}
#line 263 "../src/Bezier.vala"
	_tmp30_ = bezier_get_intersecting_point (self, right, TRUE, from);
#line 263 "../src/Bezier.vala"
	_g_free0 (isect);
#line 263 "../src/Bezier.vala"
	isect = _tmp30_;
#line 264 "../src/Bezier.vala"
	_tmp33_ = isect;
#line 264 "../src/Bezier.vala"
	if (_tmp33_ != NULL) {
#line 2341 "Bezier.c"
		gdouble* _tmp34_;
#line 264 "../src/Bezier.vala"
		_tmp34_ = isect;
#line 264 "../src/Bezier.vala"
		_tmp32_ = top <= (*_tmp34_);
#line 2347 "Bezier.c"
	} else {
#line 264 "../src/Bezier.vala"
		_tmp32_ = FALSE;
#line 2351 "Bezier.c"
	}
#line 264 "../src/Bezier.vala"
	if (_tmp32_) {
#line 2355 "Bezier.c"
		gdouble* _tmp35_;
#line 264 "../src/Bezier.vala"
		_tmp35_ = isect;
#line 264 "../src/Bezier.vala"
		_tmp31_ = (*_tmp35_) <= bottom;
#line 2361 "Bezier.c"
	} else {
#line 264 "../src/Bezier.vala"
		_tmp31_ = FALSE;
#line 2365 "Bezier.c"
	}
#line 264 "../src/Bezier.vala"
	if (_tmp31_) {
#line 265 "../src/Bezier.vala"
		if (from) {
#line 2371 "Bezier.c"
			BezierPoint* _tmp36_;
			gdouble* _tmp37_;
#line 265 "../src/Bezier.vala"
			_tmp36_ = self->priv->_from;
#line 265 "../src/Bezier.vala"
			_tmp37_ = isect;
#line 265 "../src/Bezier.vala"
			bezier_point_set_coordinate (_tmp36_, right, *_tmp37_);
#line 2380 "Bezier.c"
		} else {
			BezierPoint* _tmp38_;
			gdouble* _tmp39_;
#line 265 "../src/Bezier.vala"
			_tmp38_ = self->priv->_to;
#line 265 "../src/Bezier.vala"
			_tmp39_ = isect;
#line 265 "../src/Bezier.vala"
			bezier_point_set_coordinate (_tmp38_, right, *_tmp39_);
#line 2390 "Bezier.c"
		}
#line 266 "../src/Bezier.vala"
		_g_free0 (isect);
#line 266 "../src/Bezier.vala"
		return;
#line 2396 "Bezier.c"
	}
#line 269 "../src/Bezier.vala"
	if (from) {
#line 2400 "Bezier.c"
		BezierPoint* _tmp40_;
		GArray* _tmp41_;
		BezierPoint* _tmp42_;
		gdouble _tmp43_;
		gdouble _tmp44_;
		GArray* _tmp45_;
		BezierPoint* _tmp46_;
		gdouble _tmp47_;
		gdouble _tmp48_;
#line 270 "../src/Bezier.vala"
		_tmp40_ = self->priv->_from;
#line 270 "../src/Bezier.vala"
		_tmp41_ = self->priv->_points;
#line 270 "../src/Bezier.vala"
		_tmp42_ = g_array_index (_tmp41_, BezierPoint*, (guint) 0);
#line 270 "../src/Bezier.vala"
		_tmp43_ = bezier_point_get_x (_tmp42_);
#line 270 "../src/Bezier.vala"
		_tmp44_ = _tmp43_;
#line 270 "../src/Bezier.vala"
		_tmp45_ = self->priv->_points;
#line 270 "../src/Bezier.vala"
		_tmp46_ = g_array_index (_tmp45_, BezierPoint*, (guint) 0);
#line 270 "../src/Bezier.vala"
		_tmp47_ = bezier_point_get_y (_tmp46_);
#line 270 "../src/Bezier.vala"
		_tmp48_ = _tmp47_;
#line 270 "../src/Bezier.vala"
		bezier_point_set_coordinate (_tmp40_, _tmp44_, _tmp48_);
#line 2430 "Bezier.c"
	} else {
		BezierPoint* _tmp49_;
		GArray* _tmp50_;
		BezierPoint* _tmp51_;
		gdouble _tmp52_;
		gdouble _tmp53_;
		GArray* _tmp54_;
		BezierPoint* _tmp55_;
		gdouble _tmp56_;
		gdouble _tmp57_;
#line 272 "../src/Bezier.vala"
		_tmp49_ = self->priv->_to;
#line 272 "../src/Bezier.vala"
		_tmp50_ = self->priv->_points;
#line 272 "../src/Bezier.vala"
		_tmp51_ = g_array_index (_tmp50_, BezierPoint*, (guint) 2);
#line 272 "../src/Bezier.vala"
		_tmp52_ = bezier_point_get_x (_tmp51_);
#line 272 "../src/Bezier.vala"
		_tmp53_ = _tmp52_;
#line 272 "../src/Bezier.vala"
		_tmp54_ = self->priv->_points;
#line 272 "../src/Bezier.vala"
		_tmp55_ = g_array_index (_tmp54_, BezierPoint*, (guint) 2);
#line 272 "../src/Bezier.vala"
		_tmp56_ = bezier_point_get_y (_tmp55_);
#line 272 "../src/Bezier.vala"
		_tmp57_ = _tmp56_;
#line 272 "../src/Bezier.vala"
		bezier_point_set_coordinate (_tmp49_, _tmp53_, _tmp57_);
#line 2461 "Bezier.c"
	}
#line 237 "../src/Bezier.vala"
	_g_free0 (isect);
#line 2465 "Bezier.c"
}


static inline gpointer
bezier_point_get_instance_private (BezierPoint* self)
{
	return G_STRUCT_MEMBER_P (self, BezierPoint_private_offset);
}


static BezierPoint*
bezier_point_construct (GType object_type)
{
	BezierPoint* self = NULL;
#line 29 "../src/Bezier.vala"
	self = (BezierPoint*) g_type_create_instance (object_type);
#line 29 "../src/Bezier.vala"
	return self;
#line 2484 "Bezier.c"
}


static BezierPoint*
bezier_point_new (void)
{
#line 29 "../src/Bezier.vala"
	return bezier_point_construct (BEZIER_TYPE_POINT);
#line 2493 "Bezier.c"
}


static BezierPoint*
bezier_point_construct_with_coordinate (GType object_type,
                                        gdouble a,
                                        gdouble b)
{
	BezierPoint* self = NULL;
#line 30 "../src/Bezier.vala"
	self = (BezierPoint*) g_type_create_instance (object_type);
#line 31 "../src/Bezier.vala"
	bezier_point_set_x (self, a);
#line 32 "../src/Bezier.vala"
	bezier_point_set_y (self, b);
#line 30 "../src/Bezier.vala"
	return self;
#line 2511 "Bezier.c"
}


static BezierPoint*
bezier_point_new_with_coordinate (gdouble a,
                                  gdouble b)
{
#line 30 "../src/Bezier.vala"
	return bezier_point_construct_with_coordinate (BEZIER_TYPE_POINT, a, b);
#line 2521 "Bezier.c"
}


static void
bezier_point_set_coordinate (BezierPoint* self,
                             gdouble a,
                             gdouble b)
{
#line 34 "../src/Bezier.vala"
	g_return_if_fail (self != NULL);
#line 35 "../src/Bezier.vala"
	bezier_point_set_x (self, a);
#line 36 "../src/Bezier.vala"
	bezier_point_set_y (self, b);
#line 2536 "Bezier.c"
}


static gdouble
bezier_point_get_x (BezierPoint* self)
{
	gdouble result;
	gdouble _tmp0_;
#line 27 "../src/Bezier.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 27 "../src/Bezier.vala"
	_tmp0_ = self->priv->_x;
#line 27 "../src/Bezier.vala"
	result = _tmp0_;
#line 27 "../src/Bezier.vala"
	return result;
#line 2553 "Bezier.c"
}


static void
bezier_point_set_x (BezierPoint* self,
                    gdouble value)
{
#line 27 "../src/Bezier.vala"
	g_return_if_fail (self != NULL);
#line 27 "../src/Bezier.vala"
	self->priv->_x = value;
#line 2565 "Bezier.c"
}


static gdouble
bezier_point_get_y (BezierPoint* self)
{
	gdouble result;
	gdouble _tmp0_;
#line 28 "../src/Bezier.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 28 "../src/Bezier.vala"
	_tmp0_ = self->priv->_y;
#line 28 "../src/Bezier.vala"
	result = _tmp0_;
#line 28 "../src/Bezier.vala"
	return result;
#line 2582 "Bezier.c"
}


static void
bezier_point_set_y (BezierPoint* self,
                    gdouble value)
{
#line 28 "../src/Bezier.vala"
	g_return_if_fail (self != NULL);
#line 28 "../src/Bezier.vala"
	self->priv->_y = value;
#line 2594 "Bezier.c"
}


static void
bezier_value_point_init (GValue* value)
{
#line 26 "../src/Bezier.vala"
	value->data[0].v_pointer = NULL;
#line 2603 "Bezier.c"
}


static void
bezier_value_point_free_value (GValue* value)
{
#line 26 "../src/Bezier.vala"
	if (value->data[0].v_pointer) {
#line 26 "../src/Bezier.vala"
		bezier_point_unref (value->data[0].v_pointer);
#line 2614 "Bezier.c"
	}
}


static void
bezier_value_point_copy_value (const GValue* src_value,
                               GValue* dest_value)
{
#line 26 "../src/Bezier.vala"
	if (src_value->data[0].v_pointer) {
#line 26 "../src/Bezier.vala"
		dest_value->data[0].v_pointer = bezier_point_ref (src_value->data[0].v_pointer);
#line 2627 "Bezier.c"
	} else {
#line 26 "../src/Bezier.vala"
		dest_value->data[0].v_pointer = NULL;
#line 2631 "Bezier.c"
	}
}


static gpointer
bezier_value_point_peek_pointer (const GValue* value)
{
#line 26 "../src/Bezier.vala"
	return value->data[0].v_pointer;
#line 2641 "Bezier.c"
}


static gchar*
bezier_value_point_collect_value (GValue* value,
                                  guint n_collect_values,
                                  GTypeCValue* collect_values,
                                  guint collect_flags)
{
#line 26 "../src/Bezier.vala"
	if (collect_values[0].v_pointer) {
#line 2653 "Bezier.c"
		BezierPoint * object;
		object = collect_values[0].v_pointer;
#line 26 "../src/Bezier.vala"
		if (object->parent_instance.g_class == NULL) {
#line 26 "../src/Bezier.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 2660 "Bezier.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 26 "../src/Bezier.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 2664 "Bezier.c"
		}
#line 26 "../src/Bezier.vala"
		value->data[0].v_pointer = bezier_point_ref (object);
#line 2668 "Bezier.c"
	} else {
#line 26 "../src/Bezier.vala"
		value->data[0].v_pointer = NULL;
#line 2672 "Bezier.c"
	}
#line 26 "../src/Bezier.vala"
	return NULL;
#line 2676 "Bezier.c"
}


static gchar*
bezier_value_point_lcopy_value (const GValue* value,
                                guint n_collect_values,
                                GTypeCValue* collect_values,
                                guint collect_flags)
{
	BezierPoint ** object_p;
	object_p = collect_values[0].v_pointer;
#line 26 "../src/Bezier.vala"
	if (!object_p) {
#line 26 "../src/Bezier.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 2692 "Bezier.c"
	}
#line 26 "../src/Bezier.vala"
	if (!value->data[0].v_pointer) {
#line 26 "../src/Bezier.vala"
		*object_p = NULL;
#line 2698 "Bezier.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 26 "../src/Bezier.vala"
		*object_p = value->data[0].v_pointer;
#line 2702 "Bezier.c"
	} else {
#line 26 "../src/Bezier.vala"
		*object_p = bezier_point_ref (value->data[0].v_pointer);
#line 2706 "Bezier.c"
	}
#line 26 "../src/Bezier.vala"
	return NULL;
#line 2710 "Bezier.c"
}


static GParamSpec*
bezier_param_spec_point (const gchar* name,
                         const gchar* nick,
                         const gchar* blurb,
                         GType object_type,
                         GParamFlags flags)
{
	BezierParamSpecPoint* spec;
#line 26 "../src/Bezier.vala"
	g_return_val_if_fail (g_type_is_a (object_type, BEZIER_TYPE_POINT), NULL);
#line 26 "../src/Bezier.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 26 "../src/Bezier.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 26 "../src/Bezier.vala"
	return G_PARAM_SPEC (spec);
#line 2730 "Bezier.c"
}


static gpointer
bezier_value_get_point (const GValue* value)
{
#line 26 "../src/Bezier.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, BEZIER_TYPE_POINT), NULL);
#line 26 "../src/Bezier.vala"
	return value->data[0].v_pointer;
#line 2741 "Bezier.c"
}


static void
bezier_value_set_point (GValue* value,
                        gpointer v_object)
{
	BezierPoint * old;
#line 26 "../src/Bezier.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, BEZIER_TYPE_POINT));
#line 26 "../src/Bezier.vala"
	old = value->data[0].v_pointer;
#line 26 "../src/Bezier.vala"
	if (v_object) {
#line 26 "../src/Bezier.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, BEZIER_TYPE_POINT));
#line 26 "../src/Bezier.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 26 "../src/Bezier.vala"
		value->data[0].v_pointer = v_object;
#line 26 "../src/Bezier.vala"
		bezier_point_ref (value->data[0].v_pointer);
#line 2764 "Bezier.c"
	} else {
#line 26 "../src/Bezier.vala"
		value->data[0].v_pointer = NULL;
#line 2768 "Bezier.c"
	}
#line 26 "../src/Bezier.vala"
	if (old) {
#line 26 "../src/Bezier.vala"
		bezier_point_unref (old);
#line 2774 "Bezier.c"
	}
}


static void
bezier_value_take_point (GValue* value,
                         gpointer v_object)
{
	BezierPoint * old;
#line 26 "../src/Bezier.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, BEZIER_TYPE_POINT));
#line 26 "../src/Bezier.vala"
	old = value->data[0].v_pointer;
#line 26 "../src/Bezier.vala"
	if (v_object) {
#line 26 "../src/Bezier.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, BEZIER_TYPE_POINT));
#line 26 "../src/Bezier.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 26 "../src/Bezier.vala"
		value->data[0].v_pointer = v_object;
#line 2796 "Bezier.c"
	} else {
#line 26 "../src/Bezier.vala"
		value->data[0].v_pointer = NULL;
#line 2800 "Bezier.c"
	}
#line 26 "../src/Bezier.vala"
	if (old) {
#line 26 "../src/Bezier.vala"
		bezier_point_unref (old);
#line 2806 "Bezier.c"
	}
}


static void
bezier_point_class_init (BezierPointClass * klass)
{
#line 26 "../src/Bezier.vala"
	bezier_point_parent_class = g_type_class_peek_parent (klass);
#line 26 "../src/Bezier.vala"
	((BezierPointClass *) klass)->finalize = bezier_point_finalize;
#line 26 "../src/Bezier.vala"
	g_type_class_adjust_private_offset (klass, &BezierPoint_private_offset);
#line 2820 "Bezier.c"
}


static void
bezier_point_instance_init (BezierPoint * self)
{
#line 26 "../src/Bezier.vala"
	self->priv = bezier_point_get_instance_private (self);
#line 27 "../src/Bezier.vala"
	self->priv->_x = (gdouble) 0;
#line 28 "../src/Bezier.vala"
	self->priv->_y = (gdouble) 0;
#line 26 "../src/Bezier.vala"
	self->ref_count = 1;
#line 2835 "Bezier.c"
}


static void
bezier_point_finalize (BezierPoint * obj)
{
	BezierPoint * self;
#line 26 "../src/Bezier.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, BEZIER_TYPE_POINT, BezierPoint);
#line 26 "../src/Bezier.vala"
	g_signal_handlers_destroy (self);
#line 2847 "Bezier.c"
}


static GType
bezier_point_get_type (void)
{
	static volatile gsize bezier_point_type_id__volatile = 0;
	if (g_once_init_enter (&bezier_point_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { bezier_value_point_init, bezier_value_point_free_value, bezier_value_point_copy_value, bezier_value_point_peek_pointer, "p", bezier_value_point_collect_value, "p", bezier_value_point_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (BezierPointClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) bezier_point_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (BezierPoint), 0, (GInstanceInitFunc) bezier_point_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType bezier_point_type_id;
		bezier_point_type_id = g_type_register_fundamental (g_type_fundamental_next (), "BezierPoint", &g_define_type_info, &g_define_type_fundamental_info, 0);
		BezierPoint_private_offset = g_type_add_instance_private (bezier_point_type_id, sizeof (BezierPointPrivate));
		g_once_init_leave (&bezier_point_type_id__volatile, bezier_point_type_id);
	}
	return bezier_point_type_id__volatile;
}


static gpointer
bezier_point_ref (gpointer instance)
{
	BezierPoint * self;
	self = instance;
#line 26 "../src/Bezier.vala"
	g_atomic_int_inc (&self->ref_count);
#line 26 "../src/Bezier.vala"
	return instance;
#line 2877 "Bezier.c"
}


static void
bezier_point_unref (gpointer instance)
{
	BezierPoint * self;
	self = instance;
#line 26 "../src/Bezier.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 26 "../src/Bezier.vala"
		BEZIER_POINT_GET_CLASS (self)->finalize (self);
#line 26 "../src/Bezier.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 2892 "Bezier.c"
	}
}


static void
value_bezier_init (GValue* value)
{
#line 24 "../src/Bezier.vala"
	value->data[0].v_pointer = NULL;
#line 2902 "Bezier.c"
}


static void
value_bezier_free_value (GValue* value)
{
#line 24 "../src/Bezier.vala"
	if (value->data[0].v_pointer) {
#line 24 "../src/Bezier.vala"
		bezier_unref (value->data[0].v_pointer);
#line 2913 "Bezier.c"
	}
}


static void
value_bezier_copy_value (const GValue* src_value,
                         GValue* dest_value)
{
#line 24 "../src/Bezier.vala"
	if (src_value->data[0].v_pointer) {
#line 24 "../src/Bezier.vala"
		dest_value->data[0].v_pointer = bezier_ref (src_value->data[0].v_pointer);
#line 2926 "Bezier.c"
	} else {
#line 24 "../src/Bezier.vala"
		dest_value->data[0].v_pointer = NULL;
#line 2930 "Bezier.c"
	}
}


static gpointer
value_bezier_peek_pointer (const GValue* value)
{
#line 24 "../src/Bezier.vala"
	return value->data[0].v_pointer;
#line 2940 "Bezier.c"
}


static gchar*
value_bezier_collect_value (GValue* value,
                            guint n_collect_values,
                            GTypeCValue* collect_values,
                            guint collect_flags)
{
#line 24 "../src/Bezier.vala"
	if (collect_values[0].v_pointer) {
#line 2952 "Bezier.c"
		Bezier * object;
		object = collect_values[0].v_pointer;
#line 24 "../src/Bezier.vala"
		if (object->parent_instance.g_class == NULL) {
#line 24 "../src/Bezier.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 2959 "Bezier.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 24 "../src/Bezier.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 2963 "Bezier.c"
		}
#line 24 "../src/Bezier.vala"
		value->data[0].v_pointer = bezier_ref (object);
#line 2967 "Bezier.c"
	} else {
#line 24 "../src/Bezier.vala"
		value->data[0].v_pointer = NULL;
#line 2971 "Bezier.c"
	}
#line 24 "../src/Bezier.vala"
	return NULL;
#line 2975 "Bezier.c"
}


static gchar*
value_bezier_lcopy_value (const GValue* value,
                          guint n_collect_values,
                          GTypeCValue* collect_values,
                          guint collect_flags)
{
	Bezier ** object_p;
	object_p = collect_values[0].v_pointer;
#line 24 "../src/Bezier.vala"
	if (!object_p) {
#line 24 "../src/Bezier.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 2991 "Bezier.c"
	}
#line 24 "../src/Bezier.vala"
	if (!value->data[0].v_pointer) {
#line 24 "../src/Bezier.vala"
		*object_p = NULL;
#line 2997 "Bezier.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 24 "../src/Bezier.vala"
		*object_p = value->data[0].v_pointer;
#line 3001 "Bezier.c"
	} else {
#line 24 "../src/Bezier.vala"
		*object_p = bezier_ref (value->data[0].v_pointer);
#line 3005 "Bezier.c"
	}
#line 24 "../src/Bezier.vala"
	return NULL;
#line 3009 "Bezier.c"
}


GParamSpec*
param_spec_bezier (const gchar* name,
                   const gchar* nick,
                   const gchar* blurb,
                   GType object_type,
                   GParamFlags flags)
{
	ParamSpecBezier* spec;
#line 24 "../src/Bezier.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_BEZIER), NULL);
#line 24 "../src/Bezier.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 24 "../src/Bezier.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 24 "../src/Bezier.vala"
	return G_PARAM_SPEC (spec);
#line 3029 "Bezier.c"
}


gpointer
value_get_bezier (const GValue* value)
{
#line 24 "../src/Bezier.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_BEZIER), NULL);
#line 24 "../src/Bezier.vala"
	return value->data[0].v_pointer;
#line 3040 "Bezier.c"
}


void
value_set_bezier (GValue* value,
                  gpointer v_object)
{
	Bezier * old;
#line 24 "../src/Bezier.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_BEZIER));
#line 24 "../src/Bezier.vala"
	old = value->data[0].v_pointer;
#line 24 "../src/Bezier.vala"
	if (v_object) {
#line 24 "../src/Bezier.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_BEZIER));
#line 24 "../src/Bezier.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 24 "../src/Bezier.vala"
		value->data[0].v_pointer = v_object;
#line 24 "../src/Bezier.vala"
		bezier_ref (value->data[0].v_pointer);
#line 3063 "Bezier.c"
	} else {
#line 24 "../src/Bezier.vala"
		value->data[0].v_pointer = NULL;
#line 3067 "Bezier.c"
	}
#line 24 "../src/Bezier.vala"
	if (old) {
#line 24 "../src/Bezier.vala"
		bezier_unref (old);
#line 3073 "Bezier.c"
	}
}


void
value_take_bezier (GValue* value,
                   gpointer v_object)
{
	Bezier * old;
#line 24 "../src/Bezier.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_BEZIER));
#line 24 "../src/Bezier.vala"
	old = value->data[0].v_pointer;
#line 24 "../src/Bezier.vala"
	if (v_object) {
#line 24 "../src/Bezier.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_BEZIER));
#line 24 "../src/Bezier.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 24 "../src/Bezier.vala"
		value->data[0].v_pointer = v_object;
#line 3095 "Bezier.c"
	} else {
#line 24 "../src/Bezier.vala"
		value->data[0].v_pointer = NULL;
#line 3099 "Bezier.c"
	}
#line 24 "../src/Bezier.vala"
	if (old) {
#line 24 "../src/Bezier.vala"
		bezier_unref (old);
#line 3105 "Bezier.c"
	}
}


static void
bezier_class_init (BezierClass * klass)
{
#line 24 "../src/Bezier.vala"
	bezier_parent_class = g_type_class_peek_parent (klass);
#line 24 "../src/Bezier.vala"
	((BezierClass *) klass)->finalize = bezier_finalize;
#line 24 "../src/Bezier.vala"
	g_type_class_adjust_private_offset (klass, &Bezier_private_offset);
#line 3119 "Bezier.c"
}


static void
bezier_instance_init (Bezier * self)
{
	GArray* _tmp0_;
	GArray* _tmp1_;
	BezierPoint* _tmp2_;
	BezierPoint* _tmp3_;
#line 24 "../src/Bezier.vala"
	self->priv = bezier_get_instance_private (self);
#line 40 "../src/Bezier.vala"
	_tmp0_ = g_array_new (TRUE, TRUE, sizeof (BezierPoint*));
#line 40 "../src/Bezier.vala"
	g_array_set_clear_func (_tmp0_, _vala_BezierPoint_free_function_content_of);
#line 40 "../src/Bezier.vala"
	self->priv->_points = _tmp0_;
#line 41 "../src/Bezier.vala"
	_tmp1_ = g_array_new (TRUE, TRUE, sizeof (BezierPoint*));
#line 41 "../src/Bezier.vala"
	g_array_set_clear_func (_tmp1_, _vala_BezierPoint_free_function_content_of);
#line 41 "../src/Bezier.vala"
	self->priv->_apoints = _tmp1_;
#line 42 "../src/Bezier.vala"
	_tmp2_ = bezier_point_new ();
#line 42 "../src/Bezier.vala"
	self->priv->_from = _tmp2_;
#line 43 "../src/Bezier.vala"
	_tmp3_ = bezier_point_new ();
#line 43 "../src/Bezier.vala"
	self->priv->_to = _tmp3_;
#line 24 "../src/Bezier.vala"
	self->ref_count = 1;
#line 3154 "Bezier.c"
}


static void
bezier_finalize (Bezier * obj)
{
	Bezier * self;
#line 24 "../src/Bezier.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_BEZIER, Bezier);
#line 24 "../src/Bezier.vala"
	g_signal_handlers_destroy (self);
#line 40 "../src/Bezier.vala"
	_g_array_unref0 (self->priv->_points);
#line 41 "../src/Bezier.vala"
	_g_array_unref0 (self->priv->_apoints);
#line 42 "../src/Bezier.vala"
	_bezier_point_unref0 (self->priv->_from);
#line 43 "../src/Bezier.vala"
	_bezier_point_unref0 (self->priv->_to);
#line 3174 "Bezier.c"
}


GType
bezier_get_type (void)
{
	static volatile gsize bezier_type_id__volatile = 0;
	if (g_once_init_enter (&bezier_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_bezier_init, value_bezier_free_value, value_bezier_copy_value, value_bezier_peek_pointer, "p", value_bezier_collect_value, "p", value_bezier_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (BezierClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) bezier_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Bezier), 0, (GInstanceInitFunc) bezier_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType bezier_type_id;
		bezier_type_id = g_type_register_fundamental (g_type_fundamental_next (), "Bezier", &g_define_type_info, &g_define_type_fundamental_info, 0);
		Bezier_private_offset = g_type_add_instance_private (bezier_type_id, sizeof (BezierPrivate));
		g_once_init_leave (&bezier_type_id__volatile, bezier_type_id);
	}
	return bezier_type_id__volatile;
}


gpointer
bezier_ref (gpointer instance)
{
	Bezier * self;
	self = instance;
#line 24 "../src/Bezier.vala"
	g_atomic_int_inc (&self->ref_count);
#line 24 "../src/Bezier.vala"
	return instance;
#line 3204 "Bezier.c"
}


void
bezier_unref (gpointer instance)
{
	Bezier * self;
	self = instance;
#line 24 "../src/Bezier.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 24 "../src/Bezier.vala"
		BEZIER_GET_CLASS (self)->finalize (self);
#line 24 "../src/Bezier.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 3219 "Bezier.c"
	}
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



