/* CanvasText.c generated by valac 0.42.7, the Vala compiler
 * generated from CanvasText.vala, do not modify */

/*
* Copyright (c) 2018 (https://github.com/phase1geo/Minder)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Trevor Williams <phase1geo@gmail.com>
*/


#include <glib.h>
#include <glib-object.h>
#include <libxml/tree.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <pango/pango.h>
#include <gtk/gtk.h>
#include <gdk/gdk.h>
#include <cairo.h>
#include <pango/pangocairo.h>


#define TYPE_CANVAS_TEXT (canvas_text_get_type ())
#define CANVAS_TEXT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CANVAS_TEXT, CanvasText))
#define CANVAS_TEXT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CANVAS_TEXT, CanvasTextClass))
#define IS_CANVAS_TEXT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CANVAS_TEXT))
#define IS_CANVAS_TEXT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CANVAS_TEXT))
#define CANVAS_TEXT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CANVAS_TEXT, CanvasTextClass))

typedef struct _CanvasText CanvasText;
typedef struct _CanvasTextClass CanvasTextClass;
typedef struct _CanvasTextPrivate CanvasTextPrivate;
enum  {
	CANVAS_TEXT_0_PROPERTY,
	CANVAS_TEXT_TEXT_PROPERTY,
	CANVAS_TEXT_POSX_PROPERTY,
	CANVAS_TEXT_POSY_PROPERTY,
	CANVAS_TEXT_WIDTH_PROPERTY,
	CANVAS_TEXT_HEIGHT_PROPERTY,
	CANVAS_TEXT_MARKUP_PROPERTY,
	CANVAS_TEXT_EDIT_PROPERTY,
	CANVAS_TEXT_NUM_PROPERTIES
};
static GParamSpec* canvas_text_properties[CANVAS_TEXT_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_DRAW_AREA (draw_area_get_type ())
#define DRAW_AREA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DRAW_AREA, DrawArea))
#define DRAW_AREA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DRAW_AREA, DrawAreaClass))
#define IS_DRAW_AREA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DRAW_AREA))
#define IS_DRAW_AREA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DRAW_AREA))
#define DRAW_AREA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DRAW_AREA, DrawAreaClass))

typedef struct _DrawArea DrawArea;
typedef struct _DrawAreaClass DrawAreaClass;
typedef struct _Block3Data Block3Data;
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))

#define TYPE_THEME (theme_get_type ())
#define THEME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THEME, Theme))
#define THEME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THEME, ThemeClass))
#define IS_THEME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THEME))
#define IS_THEME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THEME))
#define THEME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THEME, ThemeClass))

typedef struct _Theme Theme;
typedef struct _ThemeClass ThemeClass;
#define _pango_layout_line_unref0(var) ((var == NULL) ? NULL : (var = (pango_layout_line_unref (var), NULL)))
enum  {
	CANVAS_TEXT_RESIZED_SIGNAL,
	CANVAS_TEXT_NUM_SIGNALS
};
static guint canvas_text_signals[CANVAS_TEXT_NUM_SIGNALS] = {0};

struct _CanvasText {
	GObject parent_instance;
	CanvasTextPrivate * priv;
};

struct _CanvasTextClass {
	GObjectClass parent_class;
	void (*load) (CanvasText* self, xmlNode* n);
	void (*resize) (CanvasText* self, gdouble diff);
};

struct _CanvasTextPrivate {
	gchar* _text;
	gboolean _markup;
	gboolean _edit;
	gint _cursor;
	gint _column;
	PangoLayout* _pango_layout;
	gint _selstart;
	gint _selend;
	gint _selanchor;
	gdouble _max_width;
	gdouble _width;
	gdouble _height;
	gdouble _posx;
	gdouble _posy;
};

struct _Block3Data {
	int _ref_count_;
	CanvasText* self;
	gchar* str;
};


static gint CanvasText_private_offset;
static gpointer canvas_text_parent_class = NULL;

GType canvas_text_get_type (void) G_GNUC_CONST;
GType draw_area_get_type (void) G_GNUC_CONST;
CanvasText* canvas_text_new (DrawArea* da,
                             gdouble max_width);
CanvasText* canvas_text_construct (GType object_type,
                                   DrawArea* da,
                                   gdouble max_width);
void canvas_text_update_size (CanvasText* self,
                              gboolean call_resized);
CanvasText* canvas_text_new_with_text (DrawArea* da,
                                       gdouble max_width,
                                       const gchar* txt);
CanvasText* canvas_text_construct_with_text (GType object_type,
                                             DrawArea* da,
                                             gdouble max_width,
                                             const gchar* txt);
void canvas_text_copy (CanvasText* self,
                       CanvasText* ct);
gdouble canvas_text_get_posx (CanvasText* self);
void canvas_text_set_posx (CanvasText* self,
                           gdouble value);
gdouble canvas_text_get_posy (CanvasText* self);
void canvas_text_set_posy (CanvasText* self,
                           gdouble value);
const gchar* canvas_text_get_text (CanvasText* self);
gint canvas_text_max_width (CanvasText* self);
void canvas_text_set_font (CanvasText* self,
                           PangoFontDescription* font);
gboolean canvas_text_is_wrapped (CanvasText* self);
gchar* canvas_text_get_wrapped_text (CanvasText* self);
static Block3Data* block3_data_ref (Block3Data* _data3_);
static void block3_data_unref (void * _userdata_);
static void __lambda34_ (Block3Data* _data3_,
                  PangoLayoutLine* item);
static void ___lambda34__gfunc (gconstpointer data,
                         gpointer self);
gboolean canvas_text_is_within (CanvasText* self,
                                gdouble x,
                                gdouble y);
gboolean utils_is_within_bounds (gdouble x,
                                 gdouble y,
                                 gdouble bx,
                                 gdouble by,
                                 gdouble bw,
                                 gdouble bh);
void canvas_text_load (CanvasText* self,
                       xmlNode* n);
static void canvas_text_real_load (CanvasText* self,
                            xmlNode* n);
void canvas_text_set_text (CanvasText* self,
                           const gchar* value);
static gchar* canvas_text_unmarkup (CanvasText* self,
                             const gchar* markup);
GType theme_get_type (void) G_GNUC_CONST;
static gchar* canvas_text_name_markup (CanvasText* self,
                                Theme* theme);
gchar* utils_color_from_rgba (GdkRGBA* rgba);
GdkRGBA* theme_get_color (Theme* self,
                          const gchar* name);
gboolean canvas_text_get_markup (CanvasText* self);
gboolean canvas_text_get_edit (CanvasText* self);
void canvas_text_resize (CanvasText* self,
                         gdouble diff);
static void canvas_text_real_resize (CanvasText* self,
                              gdouble diff);
static void canvas_text_update_column (CanvasText* self);
void canvas_text_set_cursor_at_char (CanvasText* self,
                                     gdouble x,
                                     gdouble y,
                                     gboolean motion);
void canvas_text_set_cursor_at_word (CanvasText* self,
                                     gdouble x,
                                     gdouble y,
                                     gboolean motion);
void canvas_text_clear_selection (CanvasText* self);
static void canvas_text_adjust_selection (CanvasText* self,
                                   gint last_cursor);
void canvas_text_set_cursor_none (CanvasText* self);
void canvas_text_set_cursor_all (CanvasText* self,
                                 gboolean motion);
static void canvas_text_cursor_by_char (CanvasText* self,
                                 gint dir);
void canvas_text_move_cursor (CanvasText* self,
                              gint dir);
void canvas_text_selection_by_char (CanvasText* self,
                                    gint dir);
static void canvas_text_cursor_by_line (CanvasText* self,
                                 gint dir);
void canvas_text_move_cursor_vertically (CanvasText* self,
                                         gint dir);
void canvas_text_selection_vertically (CanvasText* self,
                                       gint dir);
void canvas_text_move_cursor_to_start (CanvasText* self);
void canvas_text_move_cursor_to_end (CanvasText* self);
void canvas_text_selection_to_start (CanvasText* self);
void canvas_text_selection_to_end (CanvasText* self);
static gint canvas_text_find_word (CanvasText* self,
                            gint start,
                            gint dir);
void canvas_text_move_cursor_by_word (CanvasText* self,
                                      gint dir);
void canvas_text_selection_by_word (CanvasText* self,
                                    gint dir);
void canvas_text_backspace (CanvasText* self);
void canvas_text_delete (CanvasText* self);
void canvas_text_insert (CanvasText* self,
                         const gchar* s);
gchar* canvas_text_get_selected_text (CanvasText* self);
void canvas_text_get_cursor_pos (CanvasText* self,
                                 gint* x,
                                 gint* ytop,
                                 gint* ybot);
void canvas_text_draw (CanvasText* self,
                       cairo_t* ctx,
                       Theme* theme,
                       GdkRGBA* fg,
                       gdouble alpha);
void utils_set_context_color_with_alpha (cairo_t* ctx,
                                         GdkRGBA* color,
                                         gdouble alpha);
gdouble canvas_text_get_width (CanvasText* self);
gdouble canvas_text_get_height (CanvasText* self);
void canvas_text_set_markup (CanvasText* self,
                             gboolean value);
void canvas_text_set_edit (CanvasText* self,
                           gboolean value);
static void canvas_text_finalize (GObject * obj);
static void _vala_canvas_text_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_canvas_text_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec);


static inline gpointer
canvas_text_get_instance_private (CanvasText* self)
{
	return G_STRUCT_MEMBER_P (self, CanvasText_private_offset);
}


CanvasText*
canvas_text_construct (GType object_type,
                       DrawArea* da,
                       gdouble max_width)
{
	CanvasText * self = NULL;
	PangoLayout* _tmp0_;
	PangoLayout* _tmp1_;
	PangoLayout* _tmp2_;
	gdouble _tmp3_;
#line 95 "../src/CanvasText.vala"
	g_return_val_if_fail (da != NULL, NULL);
#line 95 "../src/CanvasText.vala"
	self = (CanvasText*) g_object_new (object_type, NULL);
#line 96 "../src/CanvasText.vala"
	self->priv->_max_width = max_width;
#line 97 "../src/CanvasText.vala"
	_tmp0_ = gtk_widget_create_pango_layout ((GtkWidget*) da, NULL);
#line 97 "../src/CanvasText.vala"
	_g_object_unref0 (self->priv->_pango_layout);
#line 97 "../src/CanvasText.vala"
	self->priv->_pango_layout = _tmp0_;
#line 98 "../src/CanvasText.vala"
	_tmp1_ = self->priv->_pango_layout;
#line 98 "../src/CanvasText.vala"
	pango_layout_set_wrap (_tmp1_, PANGO_WRAP_WORD_CHAR);
#line 99 "../src/CanvasText.vala"
	_tmp2_ = self->priv->_pango_layout;
#line 99 "../src/CanvasText.vala"
	_tmp3_ = self->priv->_max_width;
#line 99 "../src/CanvasText.vala"
	pango_layout_set_width (_tmp2_, ((gint) _tmp3_) * PANGO_SCALE);
#line 100 "../src/CanvasText.vala"
	canvas_text_update_size (self, FALSE);
#line 95 "../src/CanvasText.vala"
	return self;
#line 313 "CanvasText.c"
}


CanvasText*
canvas_text_new (DrawArea* da,
                 gdouble max_width)
{
#line 95 "../src/CanvasText.vala"
	return canvas_text_construct (TYPE_CANVAS_TEXT, da, max_width);
#line 323 "CanvasText.c"
}


CanvasText*
canvas_text_construct_with_text (GType object_type,
                                 DrawArea* da,
                                 gdouble max_width,
                                 const gchar* txt)
{
	CanvasText * self = NULL;
	PangoLayout* _tmp0_;
	PangoLayout* _tmp1_;
	PangoLayout* _tmp2_;
	gdouble _tmp3_;
	gchar* _tmp4_;
#line 104 "../src/CanvasText.vala"
	g_return_val_if_fail (da != NULL, NULL);
#line 104 "../src/CanvasText.vala"
	g_return_val_if_fail (txt != NULL, NULL);
#line 104 "../src/CanvasText.vala"
	self = (CanvasText*) g_object_new (object_type, NULL);
#line 105 "../src/CanvasText.vala"
	self->priv->_max_width = max_width;
#line 106 "../src/CanvasText.vala"
	_tmp0_ = gtk_widget_create_pango_layout ((GtkWidget*) da, txt);
#line 106 "../src/CanvasText.vala"
	_g_object_unref0 (self->priv->_pango_layout);
#line 106 "../src/CanvasText.vala"
	self->priv->_pango_layout = _tmp0_;
#line 107 "../src/CanvasText.vala"
	_tmp1_ = self->priv->_pango_layout;
#line 107 "../src/CanvasText.vala"
	pango_layout_set_wrap (_tmp1_, PANGO_WRAP_WORD_CHAR);
#line 108 "../src/CanvasText.vala"
	_tmp2_ = self->priv->_pango_layout;
#line 108 "../src/CanvasText.vala"
	_tmp3_ = self->priv->_max_width;
#line 108 "../src/CanvasText.vala"
	pango_layout_set_width (_tmp2_, ((gint) _tmp3_) * PANGO_SCALE);
#line 109 "../src/CanvasText.vala"
	_tmp4_ = g_strdup (txt);
#line 109 "../src/CanvasText.vala"
	_g_free0 (self->priv->_text);
#line 109 "../src/CanvasText.vala"
	self->priv->_text = _tmp4_;
#line 110 "../src/CanvasText.vala"
	canvas_text_update_size (self, FALSE);
#line 104 "../src/CanvasText.vala"
	return self;
#line 373 "CanvasText.c"
}


CanvasText*
canvas_text_new_with_text (DrawArea* da,
                           gdouble max_width,
                           const gchar* txt)
{
#line 104 "../src/CanvasText.vala"
	return canvas_text_construct_with_text (TYPE_CANVAS_TEXT, da, max_width, txt);
#line 384 "CanvasText.c"
}


void
canvas_text_copy (CanvasText* self,
                  CanvasText* ct)
{
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	PangoLayout* _tmp6_;
	PangoLayout* _tmp7_;
	PangoFontDescription* _tmp8_;
	PangoLayout* _tmp9_;
	gdouble _tmp10_;
#line 114 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 114 "../src/CanvasText.vala"
	g_return_if_fail (ct != NULL);
#line 115 "../src/CanvasText.vala"
	_tmp0_ = ct->priv->_posx;
#line 115 "../src/CanvasText.vala"
	canvas_text_set_posx (self, _tmp0_);
#line 116 "../src/CanvasText.vala"
	_tmp1_ = ct->priv->_posy;
#line 116 "../src/CanvasText.vala"
	canvas_text_set_posy (self, _tmp1_);
#line 117 "../src/CanvasText.vala"
	_tmp2_ = ct->priv->_max_width;
#line 117 "../src/CanvasText.vala"
	self->priv->_max_width = _tmp2_;
#line 118 "../src/CanvasText.vala"
	_tmp3_ = canvas_text_get_text (ct);
#line 118 "../src/CanvasText.vala"
	_tmp4_ = _tmp3_;
#line 118 "../src/CanvasText.vala"
	_tmp5_ = g_strdup (_tmp4_);
#line 118 "../src/CanvasText.vala"
	_g_free0 (self->priv->_text);
#line 118 "../src/CanvasText.vala"
	self->priv->_text = _tmp5_;
#line 119 "../src/CanvasText.vala"
	_tmp6_ = self->priv->_pango_layout;
#line 119 "../src/CanvasText.vala"
	_tmp7_ = ct->priv->_pango_layout;
#line 119 "../src/CanvasText.vala"
	_tmp8_ = pango_layout_get_font_description (_tmp7_);
#line 119 "../src/CanvasText.vala"
	pango_layout_set_font_description (_tmp6_, _tmp8_);
#line 120 "../src/CanvasText.vala"
	_tmp9_ = self->priv->_pango_layout;
#line 120 "../src/CanvasText.vala"
	_tmp10_ = self->priv->_max_width;
#line 120 "../src/CanvasText.vala"
	pango_layout_set_width (_tmp9_, ((gint) _tmp10_) * PANGO_SCALE);
#line 121 "../src/CanvasText.vala"
	canvas_text_update_size (self, TRUE);
#line 445 "CanvasText.c"
}


gint
canvas_text_max_width (CanvasText* self)
{
	gint result = 0;
	gdouble _tmp0_;
#line 125 "../src/CanvasText.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 126 "../src/CanvasText.vala"
	_tmp0_ = self->priv->_max_width;
#line 126 "../src/CanvasText.vala"
	result = (gint) _tmp0_;
#line 126 "../src/CanvasText.vala"
	return result;
#line 462 "CanvasText.c"
}


void
canvas_text_set_font (CanvasText* self,
                      PangoFontDescription* font)
{
	PangoLayout* _tmp0_;
#line 130 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 130 "../src/CanvasText.vala"
	g_return_if_fail (font != NULL);
#line 131 "../src/CanvasText.vala"
	_tmp0_ = self->priv->_pango_layout;
#line 131 "../src/CanvasText.vala"
	pango_layout_set_font_description (_tmp0_, font);
#line 132 "../src/CanvasText.vala"
	canvas_text_update_size (self, TRUE);
#line 481 "CanvasText.c"
}


gboolean
canvas_text_is_wrapped (CanvasText* self)
{
	gboolean result = FALSE;
	PangoLayout* _tmp0_;
#line 136 "../src/CanvasText.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 137 "../src/CanvasText.vala"
	_tmp0_ = self->priv->_pango_layout;
#line 137 "../src/CanvasText.vala"
	result = pango_layout_is_wrapped (_tmp0_);
#line 137 "../src/CanvasText.vala"
	return result;
#line 498 "CanvasText.c"
}


static Block3Data*
block3_data_ref (Block3Data* _data3_)
{
#line 141 "../src/CanvasText.vala"
	g_atomic_int_inc (&_data3_->_ref_count_);
#line 141 "../src/CanvasText.vala"
	return _data3_;
#line 509 "CanvasText.c"
}


static void
block3_data_unref (void * _userdata_)
{
	Block3Data* _data3_;
	_data3_ = (Block3Data*) _userdata_;
#line 141 "../src/CanvasText.vala"
	if (g_atomic_int_dec_and_test (&_data3_->_ref_count_)) {
#line 520 "CanvasText.c"
		CanvasText* self;
#line 141 "../src/CanvasText.vala"
		self = _data3_->self;
#line 141 "../src/CanvasText.vala"
		_g_free0 (_data3_->str);
#line 141 "../src/CanvasText.vala"
		_g_object_unref0 (self);
#line 141 "../src/CanvasText.vala"
		g_slice_free (Block3Data, _data3_);
#line 530 "CanvasText.c"
	}
}


static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	glong result = 0L;
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 1392 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1392 "glib-2.0.vapi"
	end = _tmp0_;
#line 1393 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1393 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1394 "glib-2.0.vapi"
		result = maxlen;
#line 1394 "glib-2.0.vapi"
		return result;
#line 555 "CanvasText.c"
	} else {
		gchar* _tmp2_;
#line 1396 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1396 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1396 "glib-2.0.vapi"
		return result;
#line 564 "CanvasText.c"
	}
}


static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	gchar* result = NULL;
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	glong _tmp6_;
	gchar* _tmp7_;
#line 1403 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1405 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1405 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 585 "CanvasText.c"
	} else {
#line 1405 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 589 "CanvasText.c"
	}
#line 1405 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1407 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 595 "CanvasText.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1409 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1409 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1409 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 605 "CanvasText.c"
	}
#line 1412 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 609 "CanvasText.c"
		glong _tmp3_;
#line 1413 "glib-2.0.vapi"
		_tmp3_ = string_length;
#line 1413 "glib-2.0.vapi"
		offset = _tmp3_ + offset;
#line 1414 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 617 "CanvasText.c"
	} else {
		glong _tmp4_;
#line 1416 "glib-2.0.vapi"
		_tmp4_ = string_length;
#line 1416 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= _tmp4_, NULL);
#line 624 "CanvasText.c"
	}
#line 1418 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 628 "CanvasText.c"
		glong _tmp5_;
#line 1419 "glib-2.0.vapi"
		_tmp5_ = string_length;
#line 1419 "glib-2.0.vapi"
		len = _tmp5_ - offset;
#line 634 "CanvasText.c"
	}
#line 1421 "glib-2.0.vapi"
	_tmp6_ = string_length;
#line 1421 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= _tmp6_, NULL);
#line 1422 "glib-2.0.vapi"
	_tmp7_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1422 "glib-2.0.vapi"
	result = _tmp7_;
#line 1422 "glib-2.0.vapi"
	return result;
#line 646 "CanvasText.c"
}


static void
__lambda34_ (Block3Data* _data3_,
             PangoLayoutLine* item)
{
	CanvasText* self;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
#line 144 "../src/CanvasText.vala"
	self = _data3_->self;
#line 144 "../src/CanvasText.vala"
	g_return_if_fail (item != NULL);
#line 145 "../src/CanvasText.vala"
	_tmp0_ = canvas_text_get_text (self);
#line 145 "../src/CanvasText.vala"
	_tmp1_ = _tmp0_;
#line 145 "../src/CanvasText.vala"
	_tmp2_ = item->start_index;
#line 145 "../src/CanvasText.vala"
	_tmp3_ = item->length;
#line 145 "../src/CanvasText.vala"
	_tmp4_ = string_substring (_tmp1_, (glong) _tmp2_, (glong) _tmp3_);
#line 145 "../src/CanvasText.vala"
	_tmp5_ = _tmp4_;
#line 145 "../src/CanvasText.vala"
	_tmp6_ = g_strconcat (_tmp5_, "\n", NULL);
#line 145 "../src/CanvasText.vala"
	_tmp7_ = _tmp6_;
#line 145 "../src/CanvasText.vala"
	_tmp8_ = g_strconcat (_data3_->str, _tmp7_, NULL);
#line 145 "../src/CanvasText.vala"
	_g_free0 (_data3_->str);
#line 145 "../src/CanvasText.vala"
	_data3_->str = _tmp8_;
#line 145 "../src/CanvasText.vala"
	_g_free0 (_tmp7_);
#line 145 "../src/CanvasText.vala"
	_g_free0 (_tmp5_);
#line 694 "CanvasText.c"
}


static void
___lambda34__gfunc (gconstpointer data,
                    gpointer self)
{
#line 144 "../src/CanvasText.vala"
	__lambda34_ (self, (PangoLayoutLine*) data);
#line 704 "CanvasText.c"
}


gchar*
canvas_text_get_wrapped_text (CanvasText* self)
{
	gchar* result = NULL;
	Block3Data* _data3_;
	GSList* lines = NULL;
	PangoLayout* _tmp0_;
	GSList* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
#line 141 "../src/CanvasText.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 141 "../src/CanvasText.vala"
	_data3_ = g_slice_new0 (Block3Data);
#line 141 "../src/CanvasText.vala"
	_data3_->_ref_count_ = 1;
#line 141 "../src/CanvasText.vala"
	_data3_->self = g_object_ref (self);
#line 142 "../src/CanvasText.vala"
	_tmp0_ = self->priv->_pango_layout;
#line 142 "../src/CanvasText.vala"
	_tmp1_ = pango_layout_get_lines_readonly (_tmp0_);
#line 142 "../src/CanvasText.vala"
	lines = _tmp1_;
#line 143 "../src/CanvasText.vala"
	_tmp2_ = g_strdup ("");
#line 143 "../src/CanvasText.vala"
	_data3_->str = _tmp2_;
#line 144 "../src/CanvasText.vala"
	g_slist_foreach (lines, ___lambda34__gfunc, _data3_);
#line 147 "../src/CanvasText.vala"
	_tmp3_ = g_strdup (_data3_->str);
#line 147 "../src/CanvasText.vala"
	result = _tmp3_;
#line 147 "../src/CanvasText.vala"
	block3_data_unref (_data3_);
#line 147 "../src/CanvasText.vala"
	_data3_ = NULL;
#line 147 "../src/CanvasText.vala"
	return result;
#line 748 "CanvasText.c"
}


gboolean
canvas_text_is_within (CanvasText* self,
                       gdouble x,
                       gdouble y)
{
	gboolean result = FALSE;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
#line 151 "../src/CanvasText.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 152 "../src/CanvasText.vala"
	_tmp0_ = self->priv->_posx;
#line 152 "../src/CanvasText.vala"
	_tmp1_ = self->priv->_posy;
#line 152 "../src/CanvasText.vala"
	_tmp2_ = self->priv->_width;
#line 152 "../src/CanvasText.vala"
	_tmp3_ = self->priv->_height;
#line 152 "../src/CanvasText.vala"
	result = utils_is_within_bounds (x, y, _tmp0_, _tmp1_, _tmp2_, _tmp3_);
#line 152 "../src/CanvasText.vala"
	return result;
#line 776 "CanvasText.c"
}


static gdouble
double_parse (const gchar* str)
{
	gdouble result = 0.0;
#line 944 "glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, 0.0);
#line 945 "glib-2.0.vapi"
	result = g_ascii_strtod (str, NULL);
#line 945 "glib-2.0.vapi"
	return result;
#line 790 "CanvasText.c"
}


static void
canvas_text_real_load (CanvasText* self,
                       xmlNode* n)
{
	gchar* x = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* y = NULL;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* mw = NULL;
	gchar* _tmp6_;
	const gchar* _tmp7_;
	gboolean _tmp11_ = FALSE;
	xmlNode* _tmp12_;
#line 158 "../src/CanvasText.vala"
	_tmp0_ = (gchar*) xmlGetProp (n, (xmlChar*) "posx");
#line 158 "../src/CanvasText.vala"
	x = _tmp0_;
#line 159 "../src/CanvasText.vala"
	_tmp1_ = x;
#line 159 "../src/CanvasText.vala"
	if (_tmp1_ != NULL) {
#line 817 "CanvasText.c"
		const gchar* _tmp2_;
#line 160 "../src/CanvasText.vala"
		_tmp2_ = x;
#line 160 "../src/CanvasText.vala"
		canvas_text_set_posx (self, double_parse (_tmp2_));
#line 823 "CanvasText.c"
	}
#line 163 "../src/CanvasText.vala"
	_tmp3_ = (gchar*) xmlGetProp (n, (xmlChar*) "posy");
#line 163 "../src/CanvasText.vala"
	y = _tmp3_;
#line 164 "../src/CanvasText.vala"
	_tmp4_ = y;
#line 164 "../src/CanvasText.vala"
	if (_tmp4_ != NULL) {
#line 833 "CanvasText.c"
		const gchar* _tmp5_;
#line 165 "../src/CanvasText.vala"
		_tmp5_ = y;
#line 165 "../src/CanvasText.vala"
		canvas_text_set_posy (self, double_parse (_tmp5_));
#line 839 "CanvasText.c"
	}
#line 168 "../src/CanvasText.vala"
	_tmp6_ = (gchar*) xmlGetProp (n, (xmlChar*) "maxwidth");
#line 168 "../src/CanvasText.vala"
	mw = _tmp6_;
#line 169 "../src/CanvasText.vala"
	_tmp7_ = mw;
#line 169 "../src/CanvasText.vala"
	if (_tmp7_ != NULL) {
#line 849 "CanvasText.c"
		const gchar* _tmp8_;
		PangoLayout* _tmp9_;
		gdouble _tmp10_;
#line 170 "../src/CanvasText.vala"
		_tmp8_ = mw;
#line 170 "../src/CanvasText.vala"
		self->priv->_max_width = double_parse (_tmp8_);
#line 171 "../src/CanvasText.vala"
		_tmp9_ = self->priv->_pango_layout;
#line 171 "../src/CanvasText.vala"
		_tmp10_ = self->priv->_max_width;
#line 171 "../src/CanvasText.vala"
		pango_layout_set_width (_tmp9_, ((gint) _tmp10_) * PANGO_SCALE);
#line 863 "CanvasText.c"
	}
#line 174 "../src/CanvasText.vala"
	_tmp12_ = n->children;
#line 174 "../src/CanvasText.vala"
	if (_tmp12_ != NULL) {
#line 869 "CanvasText.c"
		xmlNode* _tmp13_;
		xmlElementType _tmp14_;
#line 174 "../src/CanvasText.vala"
		_tmp13_ = n->children;
#line 174 "../src/CanvasText.vala"
		_tmp14_ = _tmp13_->type;
#line 174 "../src/CanvasText.vala"
		_tmp11_ = _tmp14_ == XML_TEXT_NODE;
#line 878 "CanvasText.c"
	} else {
#line 174 "../src/CanvasText.vala"
		_tmp11_ = FALSE;
#line 882 "CanvasText.c"
	}
#line 174 "../src/CanvasText.vala"
	if (_tmp11_) {
#line 886 "CanvasText.c"
		xmlNode* _tmp15_;
		gchar* _tmp16_;
		gchar* _tmp17_;
#line 175 "../src/CanvasText.vala"
		_tmp15_ = n->children;
#line 175 "../src/CanvasText.vala"
		_tmp16_ = (gchar*) xmlNodeGetContent (_tmp15_);
#line 175 "../src/CanvasText.vala"
		_tmp17_ = _tmp16_;
#line 175 "../src/CanvasText.vala"
		canvas_text_set_text (self, _tmp17_);
#line 175 "../src/CanvasText.vala"
		_g_free0 (_tmp17_);
#line 900 "CanvasText.c"
	}
#line 156 "../src/CanvasText.vala"
	_g_free0 (mw);
#line 156 "../src/CanvasText.vala"
	_g_free0 (y);
#line 156 "../src/CanvasText.vala"
	_g_free0 (x);
#line 908 "CanvasText.c"
}


void
canvas_text_load (CanvasText* self,
                  xmlNode* n)
{
#line 156 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 156 "../src/CanvasText.vala"
	CANVAS_TEXT_GET_CLASS (self)->load (self, n);
#line 920 "CanvasText.c"
}


static gchar*
string_replace (const gchar* self,
                const gchar* old,
                const gchar* replacement)
{
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	GError* _inner_error0_ = NULL;
#line 1477 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1477 "glib-2.0.vapi"
	g_return_val_if_fail (old != NULL, NULL);
#line 1477 "glib-2.0.vapi"
	g_return_val_if_fail (replacement != NULL, NULL);
#line 1478 "glib-2.0.vapi"
	if ((*((gchar*) self)) == '\0') {
#line 1478 "glib-2.0.vapi"
		_tmp1_ = TRUE;
#line 943 "CanvasText.c"
	} else {
#line 1478 "glib-2.0.vapi"
		_tmp1_ = (*((gchar*) old)) == '\0';
#line 947 "CanvasText.c"
	}
#line 1478 "glib-2.0.vapi"
	if (_tmp1_) {
#line 1478 "glib-2.0.vapi"
		_tmp0_ = TRUE;
#line 953 "CanvasText.c"
	} else {
#line 1478 "glib-2.0.vapi"
		_tmp0_ = g_strcmp0 (old, replacement) == 0;
#line 957 "CanvasText.c"
	}
#line 1478 "glib-2.0.vapi"
	if (_tmp0_) {
#line 961 "CanvasText.c"
		gchar* _tmp2_;
#line 1479 "glib-2.0.vapi"
		_tmp2_ = g_strdup (self);
#line 1479 "glib-2.0.vapi"
		result = _tmp2_;
#line 1479 "glib-2.0.vapi"
		return result;
#line 969 "CanvasText.c"
	}
	{
		GRegex* regex = NULL;
		gchar* _tmp3_;
		gchar* _tmp4_;
		GRegex* _tmp5_;
		GRegex* _tmp6_;
		gchar* _tmp7_ = NULL;
		GRegex* _tmp8_;
		gchar* _tmp9_;
		gchar* _tmp10_;
#line 1482 "glib-2.0.vapi"
		_tmp3_ = g_regex_escape_string (old, -1);
#line 1482 "glib-2.0.vapi"
		_tmp4_ = _tmp3_;
#line 1482 "glib-2.0.vapi"
		_tmp5_ = g_regex_new (_tmp4_, 0, 0, &_inner_error0_);
#line 1482 "glib-2.0.vapi"
		_tmp6_ = _tmp5_;
#line 1482 "glib-2.0.vapi"
		_g_free0 (_tmp4_);
#line 1482 "glib-2.0.vapi"
		regex = _tmp6_;
#line 1482 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1482 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 997 "CanvasText.c"
				goto __catch21_g_regex_error;
			}
#line 1482 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1482 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1482 "glib-2.0.vapi"
			return NULL;
#line 1006 "CanvasText.c"
		}
#line 1483 "glib-2.0.vapi"
		_tmp8_ = regex;
#line 1483 "glib-2.0.vapi"
		_tmp9_ = g_regex_replace_literal (_tmp8_, self, (gssize) -1, 0, replacement, 0, &_inner_error0_);
#line 1483 "glib-2.0.vapi"
		_tmp7_ = _tmp9_;
#line 1483 "glib-2.0.vapi"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1483 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1483 "glib-2.0.vapi"
			if (_inner_error0_->domain == G_REGEX_ERROR) {
#line 1020 "CanvasText.c"
				goto __catch21_g_regex_error;
			}
#line 1483 "glib-2.0.vapi"
			_g_regex_unref0 (regex);
#line 1483 "glib-2.0.vapi"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1483 "glib-2.0.vapi"
			g_clear_error (&_inner_error0_);
#line 1483 "glib-2.0.vapi"
			return NULL;
#line 1031 "CanvasText.c"
		}
#line 1483 "glib-2.0.vapi"
		_tmp10_ = _tmp7_;
#line 1483 "glib-2.0.vapi"
		_tmp7_ = NULL;
#line 1483 "glib-2.0.vapi"
		result = _tmp10_;
#line 1483 "glib-2.0.vapi"
		_g_free0 (_tmp7_);
#line 1483 "glib-2.0.vapi"
		_g_regex_unref0 (regex);
#line 1483 "glib-2.0.vapi"
		return result;
#line 1045 "CanvasText.c"
	}
	goto __finally21;
	__catch21_g_regex_error:
	{
		GError* e = NULL;
#line 1481 "glib-2.0.vapi"
		e = _inner_error0_;
#line 1481 "glib-2.0.vapi"
		_inner_error0_ = NULL;
#line 1485 "glib-2.0.vapi"
		g_assert_not_reached ();
#line 1481 "glib-2.0.vapi"
		_g_error_free0 (e);
#line 1059 "CanvasText.c"
	}
	__finally21:
#line 1481 "glib-2.0.vapi"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1481 "glib-2.0.vapi"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 1481 "glib-2.0.vapi"
		g_clear_error (&_inner_error0_);
#line 1481 "glib-2.0.vapi"
		return NULL;
#line 1070 "CanvasText.c"
	}
}


static gchar*
canvas_text_unmarkup (CanvasText* self,
                      const gchar* markup)
{
	gchar* result = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
#line 181 "../src/CanvasText.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 181 "../src/CanvasText.vala"
	g_return_val_if_fail (markup != NULL, NULL);
#line 182 "../src/CanvasText.vala"
	_tmp0_ = string_replace (markup, "&", "&amp;");
#line 182 "../src/CanvasText.vala"
	_tmp1_ = _tmp0_;
#line 182 "../src/CanvasText.vala"
	_tmp2_ = string_replace (_tmp1_, "<", "&lt;");
#line 182 "../src/CanvasText.vala"
	_tmp3_ = _tmp2_;
#line 182 "../src/CanvasText.vala"
	_tmp4_ = string_replace (_tmp3_, ">", "&gt;");
#line 182 "../src/CanvasText.vala"
	_tmp5_ = _tmp4_;
#line 182 "../src/CanvasText.vala"
	_g_free0 (_tmp3_);
#line 182 "../src/CanvasText.vala"
	_g_free0 (_tmp1_);
#line 182 "../src/CanvasText.vala"
	result = _tmp5_;
#line 182 "../src/CanvasText.vala"
	return result;
#line 1110 "CanvasText.c"
}


static gint
string_index_of_nth_char (const gchar* self,
                          glong c)
{
	gint result = 0;
	gchar* _tmp0_;
#line 1230 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1231 "glib-2.0.vapi"
	_tmp0_ = g_utf8_offset_to_pointer (self, c);
#line 1231 "glib-2.0.vapi"
	result = (gint) (_tmp0_ - ((gchar*) self));
#line 1231 "glib-2.0.vapi"
	return result;
#line 1128 "CanvasText.c"
}


static gchar*
string_slice (const gchar* self,
              glong start,
              glong end)
{
	gchar* result = NULL;
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp6_ = FALSE;
	gchar* _tmp8_;
#line 1425 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1426 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1426 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1426 "glib-2.0.vapi"
	string_length = (glong) _tmp1_;
#line 1427 "glib-2.0.vapi"
	if (start < ((glong) 0)) {
#line 1154 "CanvasText.c"
		glong _tmp2_;
#line 1428 "glib-2.0.vapi"
		_tmp2_ = string_length;
#line 1428 "glib-2.0.vapi"
		start = _tmp2_ + start;
#line 1160 "CanvasText.c"
	}
#line 1430 "glib-2.0.vapi"
	if (end < ((glong) 0)) {
#line 1164 "CanvasText.c"
		glong _tmp3_;
#line 1431 "glib-2.0.vapi"
		_tmp3_ = string_length;
#line 1431 "glib-2.0.vapi"
		end = _tmp3_ + end;
#line 1170 "CanvasText.c"
	}
#line 1433 "glib-2.0.vapi"
	if (start >= ((glong) 0)) {
#line 1174 "CanvasText.c"
		glong _tmp5_;
#line 1433 "glib-2.0.vapi"
		_tmp5_ = string_length;
#line 1433 "glib-2.0.vapi"
		_tmp4_ = start <= _tmp5_;
#line 1180 "CanvasText.c"
	} else {
#line 1433 "glib-2.0.vapi"
		_tmp4_ = FALSE;
#line 1184 "CanvasText.c"
	}
#line 1433 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp4_, NULL);
#line 1434 "glib-2.0.vapi"
	if (end >= ((glong) 0)) {
#line 1190 "CanvasText.c"
		glong _tmp7_;
#line 1434 "glib-2.0.vapi"
		_tmp7_ = string_length;
#line 1434 "glib-2.0.vapi"
		_tmp6_ = end <= _tmp7_;
#line 1196 "CanvasText.c"
	} else {
#line 1434 "glib-2.0.vapi"
		_tmp6_ = FALSE;
#line 1200 "CanvasText.c"
	}
#line 1434 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp6_, NULL);
#line 1435 "glib-2.0.vapi"
	g_return_val_if_fail (start <= end, NULL);
#line 1436 "glib-2.0.vapi"
	_tmp8_ = g_strndup (((gchar*) self) + start, (gsize) (end - start));
#line 1436 "glib-2.0.vapi"
	result = _tmp8_;
#line 1436 "glib-2.0.vapi"
	return result;
#line 1212 "CanvasText.c"
}


static gchar*
canvas_text_name_markup (CanvasText* self,
                         Theme* theme)
{
	gchar* result = NULL;
	gboolean _tmp0_ = FALSE;
	gint _tmp1_;
	gint _tmp2_;
	gchar* _tmp64_ = NULL;
	gboolean _tmp65_ = FALSE;
	gboolean _tmp66_;
	gboolean _tmp67_;
#line 186 "../src/CanvasText.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 187 "../src/CanvasText.vala"
	_tmp1_ = self->priv->_selstart;
#line 187 "../src/CanvasText.vala"
	_tmp2_ = self->priv->_selend;
#line 187 "../src/CanvasText.vala"
	if (_tmp1_ != _tmp2_) {
#line 187 "../src/CanvasText.vala"
		_tmp0_ = theme != NULL;
#line 1238 "CanvasText.c"
	} else {
#line 187 "../src/CanvasText.vala"
		_tmp0_ = FALSE;
#line 1242 "CanvasText.c"
	}
#line 187 "../src/CanvasText.vala"
	if (_tmp0_) {
#line 1246 "CanvasText.c"
		gchar* fg = NULL;
		GdkRGBA* _tmp3_;
		GdkRGBA* _tmp4_;
		GdkRGBA _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* bg = NULL;
		GdkRGBA* _tmp8_;
		GdkRGBA* _tmp9_;
		GdkRGBA _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
		gint spos = 0;
		const gchar* _tmp13_;
		const gchar* _tmp14_;
		gint _tmp15_;
		gint epos = 0;
		const gchar* _tmp16_;
		const gchar* _tmp17_;
		gint _tmp18_;
		gchar* begtext = NULL;
		const gchar* _tmp19_;
		const gchar* _tmp20_;
		gint _tmp21_;
		gchar* _tmp22_;
		gchar* _tmp23_;
		gchar* _tmp24_;
		gchar* _tmp25_;
		gchar* endtext = NULL;
		const gchar* _tmp26_;
		const gchar* _tmp27_;
		gint _tmp28_;
		const gchar* _tmp29_;
		const gchar* _tmp30_;
		gchar* _tmp31_;
		gchar* _tmp32_;
		gchar* _tmp33_;
		gchar* _tmp34_;
		gchar* seltext = NULL;
		const gchar* _tmp35_;
		gchar* _tmp36_;
		gchar* _tmp37_;
		gchar* _tmp38_;
		gchar* _tmp39_;
		const gchar* _tmp40_;
		gchar* _tmp41_;
		gchar* _tmp42_;
		gchar* _tmp43_;
		gchar* _tmp44_;
		const gchar* _tmp45_;
		const gchar* _tmp46_;
		gint _tmp47_;
		gint _tmp48_;
		gchar* _tmp49_;
		gchar* _tmp50_;
		gchar* _tmp51_;
		gchar* _tmp52_;
		gchar* _tmp53_;
		gchar* _tmp54_;
		gchar* _tmp55_;
		gchar* _tmp56_;
		const gchar* _tmp57_;
		const gchar* _tmp58_;
		gchar* _tmp59_;
		gchar* _tmp60_;
		const gchar* _tmp61_;
		gchar* _tmp62_;
		gchar* _tmp63_;
#line 188 "../src/CanvasText.vala"
		_tmp3_ = theme_get_color (theme, "textsel_foreground");
#line 188 "../src/CanvasText.vala"
		_tmp4_ = _tmp3_;
#line 188 "../src/CanvasText.vala"
		_tmp5_ = *_tmp4_;
#line 188 "../src/CanvasText.vala"
		_tmp6_ = utils_color_from_rgba (&_tmp5_);
#line 188 "../src/CanvasText.vala"
		_tmp7_ = _tmp6_;
#line 188 "../src/CanvasText.vala"
		_g_free0 (_tmp4_);
#line 188 "../src/CanvasText.vala"
		fg = _tmp7_;
#line 189 "../src/CanvasText.vala"
		_tmp8_ = theme_get_color (theme, "textsel_background");
#line 189 "../src/CanvasText.vala"
		_tmp9_ = _tmp8_;
#line 189 "../src/CanvasText.vala"
		_tmp10_ = *_tmp9_;
#line 189 "../src/CanvasText.vala"
		_tmp11_ = utils_color_from_rgba (&_tmp10_);
#line 189 "../src/CanvasText.vala"
		_tmp12_ = _tmp11_;
#line 189 "../src/CanvasText.vala"
		_g_free0 (_tmp9_);
#line 189 "../src/CanvasText.vala"
		bg = _tmp12_;
#line 190 "../src/CanvasText.vala"
		_tmp13_ = canvas_text_get_text (self);
#line 190 "../src/CanvasText.vala"
		_tmp14_ = _tmp13_;
#line 190 "../src/CanvasText.vala"
		_tmp15_ = self->priv->_selstart;
#line 190 "../src/CanvasText.vala"
		spos = string_index_of_nth_char (_tmp14_, (glong) _tmp15_);
#line 191 "../src/CanvasText.vala"
		_tmp16_ = canvas_text_get_text (self);
#line 191 "../src/CanvasText.vala"
		_tmp17_ = _tmp16_;
#line 191 "../src/CanvasText.vala"
		_tmp18_ = self->priv->_selend;
#line 191 "../src/CanvasText.vala"
		epos = string_index_of_nth_char (_tmp17_, (glong) _tmp18_);
#line 192 "../src/CanvasText.vala"
		_tmp19_ = canvas_text_get_text (self);
#line 192 "../src/CanvasText.vala"
		_tmp20_ = _tmp19_;
#line 192 "../src/CanvasText.vala"
		_tmp21_ = spos;
#line 192 "../src/CanvasText.vala"
		_tmp22_ = string_slice (_tmp20_, (glong) 0, (glong) _tmp21_);
#line 192 "../src/CanvasText.vala"
		_tmp23_ = _tmp22_;
#line 192 "../src/CanvasText.vala"
		_tmp24_ = canvas_text_unmarkup (self, _tmp23_);
#line 192 "../src/CanvasText.vala"
		_tmp25_ = _tmp24_;
#line 192 "../src/CanvasText.vala"
		_g_free0 (_tmp23_);
#line 192 "../src/CanvasText.vala"
		begtext = _tmp25_;
#line 193 "../src/CanvasText.vala"
		_tmp26_ = canvas_text_get_text (self);
#line 193 "../src/CanvasText.vala"
		_tmp27_ = _tmp26_;
#line 193 "../src/CanvasText.vala"
		_tmp28_ = epos;
#line 193 "../src/CanvasText.vala"
		_tmp29_ = canvas_text_get_text (self);
#line 193 "../src/CanvasText.vala"
		_tmp30_ = _tmp29_;
#line 193 "../src/CanvasText.vala"
		_tmp31_ = string_slice (_tmp27_, (glong) _tmp28_, (glong) g_utf8_strlen (_tmp30_, (gssize) -1));
#line 193 "../src/CanvasText.vala"
		_tmp32_ = _tmp31_;
#line 193 "../src/CanvasText.vala"
		_tmp33_ = canvas_text_unmarkup (self, _tmp32_);
#line 193 "../src/CanvasText.vala"
		_tmp34_ = _tmp33_;
#line 193 "../src/CanvasText.vala"
		_g_free0 (_tmp32_);
#line 193 "../src/CanvasText.vala"
		endtext = _tmp34_;
#line 194 "../src/CanvasText.vala"
		_tmp35_ = fg;
#line 194 "../src/CanvasText.vala"
		_tmp36_ = g_strconcat ("<span foreground=\"", _tmp35_, NULL);
#line 194 "../src/CanvasText.vala"
		_tmp37_ = _tmp36_;
#line 194 "../src/CanvasText.vala"
		_tmp38_ = g_strconcat (_tmp37_, "\" background=\"", NULL);
#line 194 "../src/CanvasText.vala"
		_tmp39_ = _tmp38_;
#line 194 "../src/CanvasText.vala"
		_tmp40_ = bg;
#line 194 "../src/CanvasText.vala"
		_tmp41_ = g_strconcat (_tmp39_, _tmp40_, NULL);
#line 194 "../src/CanvasText.vala"
		_tmp42_ = _tmp41_;
#line 194 "../src/CanvasText.vala"
		_tmp43_ = g_strconcat (_tmp42_, "\">", NULL);
#line 194 "../src/CanvasText.vala"
		_tmp44_ = _tmp43_;
#line 194 "../src/CanvasText.vala"
		_tmp45_ = canvas_text_get_text (self);
#line 194 "../src/CanvasText.vala"
		_tmp46_ = _tmp45_;
#line 194 "../src/CanvasText.vala"
		_tmp47_ = spos;
#line 194 "../src/CanvasText.vala"
		_tmp48_ = epos;
#line 194 "../src/CanvasText.vala"
		_tmp49_ = string_slice (_tmp46_, (glong) _tmp47_, (glong) _tmp48_);
#line 194 "../src/CanvasText.vala"
		_tmp50_ = _tmp49_;
#line 194 "../src/CanvasText.vala"
		_tmp51_ = canvas_text_unmarkup (self, _tmp50_);
#line 194 "../src/CanvasText.vala"
		_tmp52_ = _tmp51_;
#line 194 "../src/CanvasText.vala"
		_tmp53_ = g_strconcat (_tmp44_, _tmp52_, NULL);
#line 194 "../src/CanvasText.vala"
		_tmp54_ = _tmp53_;
#line 194 "../src/CanvasText.vala"
		_tmp55_ = g_strconcat (_tmp54_, "</span>", NULL);
#line 194 "../src/CanvasText.vala"
		_tmp56_ = _tmp55_;
#line 194 "../src/CanvasText.vala"
		_g_free0 (_tmp54_);
#line 194 "../src/CanvasText.vala"
		_g_free0 (_tmp52_);
#line 194 "../src/CanvasText.vala"
		_g_free0 (_tmp50_);
#line 194 "../src/CanvasText.vala"
		_g_free0 (_tmp44_);
#line 194 "../src/CanvasText.vala"
		_g_free0 (_tmp42_);
#line 194 "../src/CanvasText.vala"
		_g_free0 (_tmp39_);
#line 194 "../src/CanvasText.vala"
		_g_free0 (_tmp37_);
#line 194 "../src/CanvasText.vala"
		seltext = _tmp56_;
#line 195 "../src/CanvasText.vala"
		_tmp57_ = begtext;
#line 195 "../src/CanvasText.vala"
		_tmp58_ = seltext;
#line 195 "../src/CanvasText.vala"
		_tmp59_ = g_strconcat (_tmp57_, _tmp58_, NULL);
#line 195 "../src/CanvasText.vala"
		_tmp60_ = _tmp59_;
#line 195 "../src/CanvasText.vala"
		_tmp61_ = endtext;
#line 195 "../src/CanvasText.vala"
		_tmp62_ = g_strconcat (_tmp60_, _tmp61_, NULL);
#line 195 "../src/CanvasText.vala"
		_tmp63_ = _tmp62_;
#line 195 "../src/CanvasText.vala"
		_g_free0 (_tmp60_);
#line 195 "../src/CanvasText.vala"
		result = _tmp63_;
#line 195 "../src/CanvasText.vala"
		_g_free0 (seltext);
#line 195 "../src/CanvasText.vala"
		_g_free0 (endtext);
#line 195 "../src/CanvasText.vala"
		_g_free0 (begtext);
#line 195 "../src/CanvasText.vala"
		_g_free0 (bg);
#line 195 "../src/CanvasText.vala"
		_g_free0 (fg);
#line 195 "../src/CanvasText.vala"
		return result;
#line 1489 "CanvasText.c"
	}
#line 197 "../src/CanvasText.vala"
	_tmp66_ = canvas_text_get_markup (self);
#line 197 "../src/CanvasText.vala"
	_tmp67_ = _tmp66_;
#line 197 "../src/CanvasText.vala"
	if (_tmp67_) {
#line 197 "../src/CanvasText.vala"
		_tmp65_ = TRUE;
#line 1499 "CanvasText.c"
	} else {
		gboolean _tmp68_;
		gboolean _tmp69_;
#line 197 "../src/CanvasText.vala"
		_tmp68_ = canvas_text_get_edit (self);
#line 197 "../src/CanvasText.vala"
		_tmp69_ = _tmp68_;
#line 197 "../src/CanvasText.vala"
		_tmp65_ = _tmp69_;
#line 1509 "CanvasText.c"
	}
#line 197 "../src/CanvasText.vala"
	if (_tmp65_) {
#line 1513 "CanvasText.c"
		const gchar* _tmp70_;
		const gchar* _tmp71_;
		gchar* _tmp72_;
#line 197 "../src/CanvasText.vala"
		_tmp70_ = canvas_text_get_text (self);
#line 197 "../src/CanvasText.vala"
		_tmp71_ = _tmp70_;
#line 197 "../src/CanvasText.vala"
		_tmp72_ = g_strdup (_tmp71_);
#line 197 "../src/CanvasText.vala"
		_g_free0 (_tmp64_);
#line 197 "../src/CanvasText.vala"
		_tmp64_ = _tmp72_;
#line 1527 "CanvasText.c"
	} else {
		const gchar* _tmp73_;
		const gchar* _tmp74_;
		gchar* _tmp75_;
#line 197 "../src/CanvasText.vala"
		_tmp73_ = canvas_text_get_text (self);
#line 197 "../src/CanvasText.vala"
		_tmp74_ = _tmp73_;
#line 197 "../src/CanvasText.vala"
		_tmp75_ = canvas_text_unmarkup (self, _tmp74_);
#line 197 "../src/CanvasText.vala"
		_g_free0 (_tmp64_);
#line 197 "../src/CanvasText.vala"
		_tmp64_ = _tmp75_;
#line 1542 "CanvasText.c"
	}
#line 197 "../src/CanvasText.vala"
	result = _tmp64_;
#line 197 "../src/CanvasText.vala"
	return result;
#line 1548 "CanvasText.c"
}


void
canvas_text_update_size (CanvasText* self,
                         gboolean call_resized)
{
	PangoLayout* _tmp0_;
#line 203 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 204 "../src/CanvasText.vala"
	_tmp0_ = self->priv->_pango_layout;
#line 204 "../src/CanvasText.vala"
	if (_tmp0_ != NULL) {
#line 1563 "CanvasText.c"
		gint text_width = 0;
		gint text_height = 0;
		PangoLayout* _tmp1_;
		gchar* _tmp2_;
		gchar* _tmp3_;
		PangoLayout* _tmp4_;
		gint _tmp5_ = 0;
		gint _tmp6_ = 0;
		gint _tmp7_;
		gint _tmp8_;
#line 206 "../src/CanvasText.vala"
		_tmp1_ = self->priv->_pango_layout;
#line 206 "../src/CanvasText.vala"
		_tmp2_ = canvas_text_name_markup (self, NULL);
#line 206 "../src/CanvasText.vala"
		_tmp3_ = _tmp2_;
#line 206 "../src/CanvasText.vala"
		pango_layout_set_markup (_tmp1_, _tmp3_, -1);
#line 206 "../src/CanvasText.vala"
		_g_free0 (_tmp3_);
#line 207 "../src/CanvasText.vala"
		_tmp4_ = self->priv->_pango_layout;
#line 207 "../src/CanvasText.vala"
		pango_layout_get_size (_tmp4_, &_tmp5_, &_tmp6_);
#line 207 "../src/CanvasText.vala"
		text_width = _tmp5_;
#line 207 "../src/CanvasText.vala"
		text_height = _tmp6_;
#line 208 "../src/CanvasText.vala"
		_tmp7_ = text_width;
#line 208 "../src/CanvasText.vala"
		self->priv->_width = (gdouble) (_tmp7_ / PANGO_SCALE);
#line 209 "../src/CanvasText.vala"
		_tmp8_ = text_height;
#line 209 "../src/CanvasText.vala"
		self->priv->_height = (gdouble) (_tmp8_ / PANGO_SCALE);
#line 210 "../src/CanvasText.vala"
		if (call_resized) {
#line 211 "../src/CanvasText.vala"
			g_signal_emit (self, canvas_text_signals[CANVAS_TEXT_RESIZED_SIGNAL], 0);
#line 1604 "CanvasText.c"
		}
	}
}


static void
canvas_text_real_resize (CanvasText* self,
                         gdouble diff)
{
	gdouble _tmp0_;
	PangoLayout* _tmp1_;
	gdouble _tmp2_;
#line 218 "../src/CanvasText.vala"
	_tmp0_ = self->priv->_max_width;
#line 218 "../src/CanvasText.vala"
	self->priv->_max_width = _tmp0_ + diff;
#line 219 "../src/CanvasText.vala"
	_tmp1_ = self->priv->_pango_layout;
#line 219 "../src/CanvasText.vala"
	_tmp2_ = self->priv->_max_width;
#line 219 "../src/CanvasText.vala"
	pango_layout_set_width (_tmp1_, ((gint) _tmp2_) * PANGO_SCALE);
#line 220 "../src/CanvasText.vala"
	canvas_text_update_size (self, TRUE);
#line 1629 "CanvasText.c"
}


void
canvas_text_resize (CanvasText* self,
                    gdouble diff)
{
#line 217 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 217 "../src/CanvasText.vala"
	CANVAS_TEXT_GET_CLASS (self)->resize (self, diff);
#line 1641 "CanvasText.c"
}


static void
canvas_text_update_column (CanvasText* self)
{
	gint line = 0;
	gint cpos = 0;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gint _tmp2_;
	PangoLayout* _tmp3_;
	gint _tmp4_ = 0;
	gint _tmp5_ = 0;
#line 224 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 226 "../src/CanvasText.vala"
	_tmp0_ = canvas_text_get_text (self);
#line 226 "../src/CanvasText.vala"
	_tmp1_ = _tmp0_;
#line 226 "../src/CanvasText.vala"
	_tmp2_ = self->priv->_cursor;
#line 226 "../src/CanvasText.vala"
	cpos = string_index_of_nth_char (_tmp1_, (glong) _tmp2_);
#line 227 "../src/CanvasText.vala"
	_tmp3_ = self->priv->_pango_layout;
#line 227 "../src/CanvasText.vala"
	pango_layout_index_to_line_x (_tmp3_, cpos, FALSE, &_tmp4_, &_tmp5_);
#line 227 "../src/CanvasText.vala"
	line = _tmp4_;
#line 227 "../src/CanvasText.vala"
	self->priv->_column = _tmp5_;
#line 1674 "CanvasText.c"
}


void
canvas_text_set_cursor_at_char (CanvasText* self,
                                gdouble x,
                                gdouble y,
                                gboolean motion)
{
	gint cursor = 0;
	gint trailing = 0;
	gint adjusted_x = 0;
	gdouble _tmp0_;
	gint adjusted_y = 0;
	gdouble _tmp1_;
	PangoLayout* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gint _tmp5_ = 0;
	gint _tmp6_ = 0;
	gboolean _tmp7_;
#line 231 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 233 "../src/CanvasText.vala"
	_tmp0_ = self->priv->_posx;
#line 233 "../src/CanvasText.vala"
	adjusted_x = ((gint) (x - _tmp0_)) * PANGO_SCALE;
#line 234 "../src/CanvasText.vala"
	_tmp1_ = self->priv->_posy;
#line 234 "../src/CanvasText.vala"
	adjusted_y = ((gint) (y - _tmp1_)) * PANGO_SCALE;
#line 235 "../src/CanvasText.vala"
	_tmp2_ = self->priv->_pango_layout;
#line 235 "../src/CanvasText.vala"
	_tmp3_ = adjusted_x;
#line 235 "../src/CanvasText.vala"
	_tmp4_ = adjusted_y;
#line 235 "../src/CanvasText.vala"
	_tmp7_ = pango_layout_xy_to_index (_tmp2_, _tmp3_, _tmp4_, &_tmp5_, &_tmp6_);
#line 235 "../src/CanvasText.vala"
	cursor = _tmp5_;
#line 235 "../src/CanvasText.vala"
	trailing = _tmp6_;
#line 235 "../src/CanvasText.vala"
	if (_tmp7_) {
#line 1720 "CanvasText.c"
		gint cindex = 0;
		const gchar* _tmp8_;
		const gchar* _tmp9_;
		gint _tmp10_;
		gint _tmp11_;
		gint _tmp23_;
#line 236 "../src/CanvasText.vala"
		_tmp8_ = canvas_text_get_text (self);
#line 236 "../src/CanvasText.vala"
		_tmp9_ = _tmp8_;
#line 236 "../src/CanvasText.vala"
		_tmp10_ = cursor;
#line 236 "../src/CanvasText.vala"
		_tmp11_ = trailing;
#line 236 "../src/CanvasText.vala"
		cindex = g_utf8_strlen (_tmp9_, (gssize) (_tmp10_ + _tmp11_));
#line 237 "../src/CanvasText.vala"
		if (motion) {
#line 1739 "CanvasText.c"
			gint _tmp12_;
			gint _tmp13_;
#line 238 "../src/CanvasText.vala"
			_tmp12_ = cindex;
#line 238 "../src/CanvasText.vala"
			_tmp13_ = self->priv->_selanchor;
#line 238 "../src/CanvasText.vala"
			if (_tmp12_ > _tmp13_) {
#line 1748 "CanvasText.c"
				gint _tmp14_;
#line 239 "../src/CanvasText.vala"
				_tmp14_ = cindex;
#line 239 "../src/CanvasText.vala"
				self->priv->_selend = _tmp14_;
#line 1754 "CanvasText.c"
			} else {
				gint _tmp15_;
				gint _tmp16_;
#line 240 "../src/CanvasText.vala"
				_tmp15_ = cindex;
#line 240 "../src/CanvasText.vala"
				_tmp16_ = self->priv->_selanchor;
#line 240 "../src/CanvasText.vala"
				if (_tmp15_ < _tmp16_) {
#line 1764 "CanvasText.c"
					gint _tmp17_;
#line 241 "../src/CanvasText.vala"
					_tmp17_ = cindex;
#line 241 "../src/CanvasText.vala"
					self->priv->_selstart = _tmp17_;
#line 1770 "CanvasText.c"
				} else {
					gint _tmp18_;
					gint _tmp19_;
#line 243 "../src/CanvasText.vala"
					_tmp18_ = cindex;
#line 243 "../src/CanvasText.vala"
					self->priv->_selstart = _tmp18_;
#line 244 "../src/CanvasText.vala"
					_tmp19_ = cindex;
#line 244 "../src/CanvasText.vala"
					self->priv->_selend = _tmp19_;
#line 1782 "CanvasText.c"
				}
			}
		} else {
			gint _tmp20_;
			gint _tmp21_;
			gint _tmp22_;
#line 247 "../src/CanvasText.vala"
			_tmp20_ = cindex;
#line 247 "../src/CanvasText.vala"
			self->priv->_selstart = _tmp20_;
#line 248 "../src/CanvasText.vala"
			_tmp21_ = cindex;
#line 248 "../src/CanvasText.vala"
			self->priv->_selend = _tmp21_;
#line 249 "../src/CanvasText.vala"
			_tmp22_ = cindex;
#line 249 "../src/CanvasText.vala"
			self->priv->_selanchor = _tmp22_;
#line 1801 "CanvasText.c"
		}
#line 251 "../src/CanvasText.vala"
		_tmp23_ = self->priv->_selend;
#line 251 "../src/CanvasText.vala"
		self->priv->_cursor = _tmp23_;
#line 252 "../src/CanvasText.vala"
		canvas_text_update_column (self);
#line 1809 "CanvasText.c"
	}
}


static gint
string_last_index_of (const gchar* self,
                      const gchar* needle,
                      gint start_index)
{
	gint result = 0;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 1091 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1091 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, 0);
#line 1092 "glib-2.0.vapi"
	_tmp0_ = g_strrstr (((gchar*) self) + start_index, (gchar*) needle);
#line 1092 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1094 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1094 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 1835 "CanvasText.c"
		gchar* _tmp2_;
#line 1095 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1095 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1095 "glib-2.0.vapi"
		return result;
#line 1843 "CanvasText.c"
	} else {
#line 1097 "glib-2.0.vapi"
		result = -1;
#line 1097 "glib-2.0.vapi"
		return result;
#line 1849 "CanvasText.c"
	}
}


static gint
string_index_of (const gchar* self,
                 const gchar* needle,
                 gint start_index)
{
	gint result = 0;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 1081 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1081 "glib-2.0.vapi"
	g_return_val_if_fail (needle != NULL, 0);
#line 1082 "glib-2.0.vapi"
	_tmp0_ = strstr (((gchar*) self) + start_index, (gchar*) needle);
#line 1082 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1084 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1084 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 1875 "CanvasText.c"
		gchar* _tmp2_;
#line 1085 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1085 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1085 "glib-2.0.vapi"
		return result;
#line 1883 "CanvasText.c"
	} else {
#line 1087 "glib-2.0.vapi"
		result = -1;
#line 1087 "glib-2.0.vapi"
		return result;
#line 1889 "CanvasText.c"
	}
}


void
canvas_text_set_cursor_at_word (CanvasText* self,
                                gdouble x,
                                gdouble y,
                                gboolean motion)
{
	gint cursor = 0;
	gint trailing = 0;
	gint adjusted_x = 0;
	gdouble _tmp0_;
	gint adjusted_y = 0;
	gdouble _tmp1_;
	PangoLayout* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gint _tmp5_ = 0;
	gint _tmp6_ = 0;
	gboolean _tmp7_;
#line 257 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 259 "../src/CanvasText.vala"
	_tmp0_ = self->priv->_posx;
#line 259 "../src/CanvasText.vala"
	adjusted_x = ((gint) (x - _tmp0_)) * PANGO_SCALE;
#line 260 "../src/CanvasText.vala"
	_tmp1_ = self->priv->_posy;
#line 260 "../src/CanvasText.vala"
	adjusted_y = ((gint) (y - _tmp1_)) * PANGO_SCALE;
#line 261 "../src/CanvasText.vala"
	_tmp2_ = self->priv->_pango_layout;
#line 261 "../src/CanvasText.vala"
	_tmp3_ = adjusted_x;
#line 261 "../src/CanvasText.vala"
	_tmp4_ = adjusted_y;
#line 261 "../src/CanvasText.vala"
	_tmp7_ = pango_layout_xy_to_index (_tmp2_, _tmp3_, _tmp4_, &_tmp5_, &_tmp6_);
#line 261 "../src/CanvasText.vala"
	cursor = _tmp5_;
#line 261 "../src/CanvasText.vala"
	trailing = _tmp6_;
#line 261 "../src/CanvasText.vala"
	if (_tmp7_) {
#line 1936 "CanvasText.c"
		gint _tmp8_;
		gint _tmp9_;
		gint word_start = 0;
		const gchar* _tmp10_;
		const gchar* _tmp11_;
		gint _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		gint _tmp15_;
		gint word_end = 0;
		const gchar* _tmp16_;
		const gchar* _tmp17_;
		gint _tmp18_;
		gint _tmp19_;
		gint _tmp27_;
		gint _tmp37_;
#line 262 "../src/CanvasText.vala"
		_tmp8_ = cursor;
#line 262 "../src/CanvasText.vala"
		_tmp9_ = trailing;
#line 262 "../src/CanvasText.vala"
		cursor = _tmp8_ + _tmp9_;
#line 263 "../src/CanvasText.vala"
		_tmp10_ = canvas_text_get_text (self);
#line 263 "../src/CanvasText.vala"
		_tmp11_ = _tmp10_;
#line 263 "../src/CanvasText.vala"
		_tmp12_ = cursor;
#line 263 "../src/CanvasText.vala"
		_tmp13_ = string_substring (_tmp11_, (glong) 0, (glong) _tmp12_);
#line 263 "../src/CanvasText.vala"
		_tmp14_ = _tmp13_;
#line 263 "../src/CanvasText.vala"
		_tmp15_ = string_last_index_of (_tmp14_, " ", 0);
#line 263 "../src/CanvasText.vala"
		_g_free0 (_tmp14_);
#line 263 "../src/CanvasText.vala"
		word_start = _tmp15_;
#line 264 "../src/CanvasText.vala"
		_tmp16_ = canvas_text_get_text (self);
#line 264 "../src/CanvasText.vala"
		_tmp17_ = _tmp16_;
#line 264 "../src/CanvasText.vala"
		_tmp18_ = cursor;
#line 264 "../src/CanvasText.vala"
		word_end = string_index_of (_tmp17_, " ", _tmp18_);
#line 265 "../src/CanvasText.vala"
		_tmp19_ = word_start;
#line 265 "../src/CanvasText.vala"
		if (_tmp19_ == -1) {
#line 265 "../src/CanvasText.vala"
			self->priv->_selstart = 0;
#line 1989 "CanvasText.c"
		} else {
			gint windex = 0;
			const gchar* _tmp20_;
			const gchar* _tmp21_;
			gint _tmp22_;
			gboolean _tmp23_ = FALSE;
#line 265 "../src/CanvasText.vala"
			_tmp20_ = canvas_text_get_text (self);
#line 265 "../src/CanvasText.vala"
			_tmp21_ = _tmp20_;
#line 265 "../src/CanvasText.vala"
			_tmp22_ = word_start;
#line 265 "../src/CanvasText.vala"
			windex = g_utf8_strlen (_tmp21_, (gssize) _tmp22_);
#line 265 "../src/CanvasText.vala"
			if (!motion) {
#line 265 "../src/CanvasText.vala"
				_tmp23_ = TRUE;
#line 2008 "CanvasText.c"
			} else {
				gint _tmp24_;
				gint _tmp25_;
#line 265 "../src/CanvasText.vala"
				_tmp24_ = windex;
#line 265 "../src/CanvasText.vala"
				_tmp25_ = self->priv->_selanchor;
#line 265 "../src/CanvasText.vala"
				_tmp23_ = _tmp24_ < _tmp25_;
#line 2018 "CanvasText.c"
			}
#line 265 "../src/CanvasText.vala"
			if (_tmp23_) {
#line 2022 "CanvasText.c"
				gint _tmp26_;
#line 265 "../src/CanvasText.vala"
				_tmp26_ = windex;
#line 265 "../src/CanvasText.vala"
				self->priv->_selstart = _tmp26_ + 1;
#line 2028 "CanvasText.c"
			}
		}
#line 266 "../src/CanvasText.vala"
		_tmp27_ = word_end;
#line 266 "../src/CanvasText.vala"
		if (_tmp27_ == -1) {
#line 2035 "CanvasText.c"
			const gchar* _tmp28_;
			const gchar* _tmp29_;
#line 267 "../src/CanvasText.vala"
			_tmp28_ = canvas_text_get_text (self);
#line 267 "../src/CanvasText.vala"
			_tmp29_ = _tmp28_;
#line 267 "../src/CanvasText.vala"
			self->priv->_selend = g_utf8_strlen (_tmp29_, (gssize) -1);
#line 2044 "CanvasText.c"
		} else {
			gint windex = 0;
			const gchar* _tmp30_;
			const gchar* _tmp31_;
			gint _tmp32_;
			gboolean _tmp33_ = FALSE;
#line 269 "../src/CanvasText.vala"
			_tmp30_ = canvas_text_get_text (self);
#line 269 "../src/CanvasText.vala"
			_tmp31_ = _tmp30_;
#line 269 "../src/CanvasText.vala"
			_tmp32_ = word_end;
#line 269 "../src/CanvasText.vala"
			windex = g_utf8_strlen (_tmp31_, (gssize) _tmp32_);
#line 270 "../src/CanvasText.vala"
			if (!motion) {
#line 270 "../src/CanvasText.vala"
				_tmp33_ = TRUE;
#line 2063 "CanvasText.c"
			} else {
				gint _tmp34_;
				gint _tmp35_;
#line 270 "../src/CanvasText.vala"
				_tmp34_ = windex;
#line 270 "../src/CanvasText.vala"
				_tmp35_ = self->priv->_selanchor;
#line 270 "../src/CanvasText.vala"
				_tmp33_ = _tmp34_ > _tmp35_;
#line 2073 "CanvasText.c"
			}
#line 270 "../src/CanvasText.vala"
			if (_tmp33_) {
#line 2077 "CanvasText.c"
				gint _tmp36_;
#line 271 "../src/CanvasText.vala"
				_tmp36_ = windex;
#line 271 "../src/CanvasText.vala"
				self->priv->_selend = _tmp36_;
#line 2083 "CanvasText.c"
			}
		}
#line 274 "../src/CanvasText.vala"
		_tmp37_ = self->priv->_selend;
#line 274 "../src/CanvasText.vala"
		self->priv->_cursor = _tmp37_;
#line 275 "../src/CanvasText.vala"
		canvas_text_update_column (self);
#line 2092 "CanvasText.c"
	}
}


void
canvas_text_clear_selection (CanvasText* self)
{
	gint _tmp0_;
	gint _tmp1_;
#line 280 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 281 "../src/CanvasText.vala"
	_tmp0_ = self->priv->_cursor;
#line 281 "../src/CanvasText.vala"
	self->priv->_selend = _tmp0_;
#line 281 "../src/CanvasText.vala"
	_tmp1_ = self->priv->_selend;
#line 281 "../src/CanvasText.vala"
	self->priv->_selstart = _tmp1_;
#line 2112 "CanvasText.c"
}


static void
canvas_text_adjust_selection (CanvasText* self,
                              gint last_cursor)
{
	gint _tmp0_;
#line 288 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 289 "../src/CanvasText.vala"
	_tmp0_ = self->priv->_selstart;
#line 289 "../src/CanvasText.vala"
	if (last_cursor == _tmp0_) {
#line 2127 "CanvasText.c"
		gint _tmp1_;
		gint _tmp2_;
#line 290 "../src/CanvasText.vala"
		_tmp1_ = self->priv->_cursor;
#line 290 "../src/CanvasText.vala"
		_tmp2_ = self->priv->_selend;
#line 290 "../src/CanvasText.vala"
		if (_tmp1_ <= _tmp2_) {
#line 2136 "CanvasText.c"
			gint _tmp3_;
#line 291 "../src/CanvasText.vala"
			_tmp3_ = self->priv->_cursor;
#line 291 "../src/CanvasText.vala"
			self->priv->_selstart = _tmp3_;
#line 2142 "CanvasText.c"
		} else {
			gint _tmp4_;
#line 293 "../src/CanvasText.vala"
			_tmp4_ = self->priv->_cursor;
#line 293 "../src/CanvasText.vala"
			self->priv->_selend = _tmp4_;
#line 2149 "CanvasText.c"
		}
	} else {
		gint _tmp5_;
		gint _tmp6_;
#line 296 "../src/CanvasText.vala"
		_tmp5_ = self->priv->_cursor;
#line 296 "../src/CanvasText.vala"
		_tmp6_ = self->priv->_selstart;
#line 296 "../src/CanvasText.vala"
		if (_tmp5_ >= _tmp6_) {
#line 2160 "CanvasText.c"
			gint _tmp7_;
#line 297 "../src/CanvasText.vala"
			_tmp7_ = self->priv->_cursor;
#line 297 "../src/CanvasText.vala"
			self->priv->_selend = _tmp7_;
#line 2166 "CanvasText.c"
		} else {
			gint _tmp8_;
#line 299 "../src/CanvasText.vala"
			_tmp8_ = self->priv->_cursor;
#line 299 "../src/CanvasText.vala"
			self->priv->_selstart = _tmp8_;
#line 2173 "CanvasText.c"
		}
	}
}


void
canvas_text_set_cursor_none (CanvasText* self)
{
#line 305 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 306 "../src/CanvasText.vala"
	canvas_text_clear_selection (self);
#line 2186 "CanvasText.c"
}


void
canvas_text_set_cursor_all (CanvasText* self,
                            gboolean motion)
{
#line 310 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 311 "../src/CanvasText.vala"
	if (!motion) {
#line 2198 "CanvasText.c"
		const gchar* _tmp0_;
		const gchar* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
#line 312 "../src/CanvasText.vala"
		self->priv->_selstart = 0;
#line 313 "../src/CanvasText.vala"
		_tmp0_ = canvas_text_get_text (self);
#line 313 "../src/CanvasText.vala"
		_tmp1_ = _tmp0_;
#line 313 "../src/CanvasText.vala"
		self->priv->_selend = g_utf8_strlen (_tmp1_, (gssize) -1);
#line 314 "../src/CanvasText.vala"
		_tmp2_ = self->priv->_selend;
#line 314 "../src/CanvasText.vala"
		self->priv->_selanchor = _tmp2_;
#line 315 "../src/CanvasText.vala"
		_tmp3_ = self->priv->_selend;
#line 315 "../src/CanvasText.vala"
		self->priv->_cursor = _tmp3_;
#line 2219 "CanvasText.c"
	}
}


static void
canvas_text_cursor_by_char (CanvasText* self,
                            gint dir)
{
	gint last = 0;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
#line 320 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 321 "../src/CanvasText.vala"
	_tmp0_ = canvas_text_get_text (self);
#line 321 "../src/CanvasText.vala"
	_tmp1_ = _tmp0_;
#line 321 "../src/CanvasText.vala"
	last = g_utf8_strlen (_tmp1_, (gssize) -1);
#line 322 "../src/CanvasText.vala"
	_tmp2_ = self->priv->_cursor;
#line 322 "../src/CanvasText.vala"
	self->priv->_cursor = _tmp2_ + dir;
#line 323 "../src/CanvasText.vala"
	_tmp3_ = self->priv->_cursor;
#line 323 "../src/CanvasText.vala"
	if (_tmp3_ < 0) {
#line 324 "../src/CanvasText.vala"
		self->priv->_cursor = 0;
#line 2251 "CanvasText.c"
	} else {
		gint _tmp4_;
		gint _tmp5_;
#line 325 "../src/CanvasText.vala"
		_tmp4_ = self->priv->_cursor;
#line 325 "../src/CanvasText.vala"
		_tmp5_ = last;
#line 325 "../src/CanvasText.vala"
		if (_tmp4_ > _tmp5_) {
#line 2261 "CanvasText.c"
			gint _tmp6_;
#line 326 "../src/CanvasText.vala"
			_tmp6_ = last;
#line 326 "../src/CanvasText.vala"
			self->priv->_cursor = _tmp6_;
#line 2267 "CanvasText.c"
		}
	}
#line 328 "../src/CanvasText.vala"
	canvas_text_update_column (self);
#line 2272 "CanvasText.c"
}


void
canvas_text_move_cursor (CanvasText* self,
                         gint dir)
{
#line 332 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 333 "../src/CanvasText.vala"
	canvas_text_cursor_by_char (self, dir);
#line 334 "../src/CanvasText.vala"
	canvas_text_clear_selection (self);
#line 2286 "CanvasText.c"
}


void
canvas_text_selection_by_char (CanvasText* self,
                               gint dir)
{
	gint last_cursor = 0;
	gint _tmp0_;
#line 338 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 339 "../src/CanvasText.vala"
	_tmp0_ = self->priv->_cursor;
#line 339 "../src/CanvasText.vala"
	last_cursor = _tmp0_;
#line 340 "../src/CanvasText.vala"
	canvas_text_cursor_by_char (self, dir);
#line 341 "../src/CanvasText.vala"
	canvas_text_adjust_selection (self, last_cursor);
#line 2306 "CanvasText.c"
}


static gpointer
_pango_layout_line_ref0 (gpointer self)
{
#line 356 "../src/CanvasText.vala"
	return self ? pango_layout_line_ref (self) : NULL;
#line 2315 "CanvasText.c"
}


static void
canvas_text_cursor_by_line (CanvasText* self,
                            gint dir)
{
	gint line = 0;
	gint x = 0;
	gint cpos = 0;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gint _tmp2_;
	PangoLayout* _tmp3_;
	gint _tmp4_;
	gint _tmp5_ = 0;
	gint _tmp6_ = 0;
	gint _tmp7_;
	gint _tmp8_;
#line 345 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 347 "../src/CanvasText.vala"
	_tmp0_ = canvas_text_get_text (self);
#line 347 "../src/CanvasText.vala"
	_tmp1_ = _tmp0_;
#line 347 "../src/CanvasText.vala"
	_tmp2_ = self->priv->_cursor;
#line 347 "../src/CanvasText.vala"
	cpos = string_index_of_nth_char (_tmp1_, (glong) _tmp2_);
#line 348 "../src/CanvasText.vala"
	_tmp3_ = self->priv->_pango_layout;
#line 348 "../src/CanvasText.vala"
	_tmp4_ = cpos;
#line 348 "../src/CanvasText.vala"
	pango_layout_index_to_line_x (_tmp3_, _tmp4_, FALSE, &_tmp5_, &_tmp6_);
#line 348 "../src/CanvasText.vala"
	line = _tmp5_;
#line 348 "../src/CanvasText.vala"
	x = _tmp6_;
#line 349 "../src/CanvasText.vala"
	_tmp7_ = line;
#line 349 "../src/CanvasText.vala"
	line = _tmp7_ + dir;
#line 350 "../src/CanvasText.vala"
	_tmp8_ = line;
#line 350 "../src/CanvasText.vala"
	if (_tmp8_ < 0) {
#line 351 "../src/CanvasText.vala"
		self->priv->_cursor = 0;
#line 2365 "CanvasText.c"
	} else {
		gint _tmp9_;
		PangoLayout* _tmp10_;
#line 352 "../src/CanvasText.vala"
		_tmp9_ = line;
#line 352 "../src/CanvasText.vala"
		_tmp10_ = self->priv->_pango_layout;
#line 352 "../src/CanvasText.vala"
		if (_tmp9_ >= pango_layout_get_line_count (_tmp10_)) {
#line 2375 "CanvasText.c"
			const gchar* _tmp11_;
			const gchar* _tmp12_;
#line 353 "../src/CanvasText.vala"
			_tmp11_ = canvas_text_get_text (self);
#line 353 "../src/CanvasText.vala"
			_tmp12_ = _tmp11_;
#line 353 "../src/CanvasText.vala"
			self->priv->_cursor = g_utf8_strlen (_tmp12_, (gssize) -1);
#line 2384 "CanvasText.c"
		} else {
			gint index = 0;
			gint trailing = 0;
			PangoLayoutLine* line_layout = NULL;
			PangoLayout* _tmp13_;
			gint _tmp14_;
			PangoLayoutLine* _tmp15_;
			PangoLayoutLine* _tmp16_;
			PangoLayoutLine* _tmp17_;
			gint _tmp18_;
			gint _tmp19_ = 0;
			gint _tmp20_ = 0;
			const gchar* _tmp21_;
			const gchar* _tmp22_;
			gint _tmp23_;
			gint _tmp24_;
#line 356 "../src/CanvasText.vala"
			_tmp13_ = self->priv->_pango_layout;
#line 356 "../src/CanvasText.vala"
			_tmp14_ = line;
#line 356 "../src/CanvasText.vala"
			_tmp15_ = pango_layout_get_line (_tmp13_, _tmp14_);
#line 356 "../src/CanvasText.vala"
			_tmp16_ = _pango_layout_line_ref0 (_tmp15_);
#line 356 "../src/CanvasText.vala"
			line_layout = _tmp16_;
#line 357 "../src/CanvasText.vala"
			_tmp17_ = line_layout;
#line 357 "../src/CanvasText.vala"
			_tmp18_ = self->priv->_column;
#line 357 "../src/CanvasText.vala"
			pango_layout_line_x_to_index (_tmp17_, _tmp18_, &_tmp19_, &_tmp20_);
#line 357 "../src/CanvasText.vala"
			index = _tmp19_;
#line 357 "../src/CanvasText.vala"
			trailing = _tmp20_;
#line 358 "../src/CanvasText.vala"
			_tmp21_ = canvas_text_get_text (self);
#line 358 "../src/CanvasText.vala"
			_tmp22_ = _tmp21_;
#line 358 "../src/CanvasText.vala"
			_tmp23_ = index;
#line 358 "../src/CanvasText.vala"
			_tmp24_ = trailing;
#line 358 "../src/CanvasText.vala"
			self->priv->_cursor = g_utf8_strlen (_tmp22_, (gssize) (_tmp23_ + _tmp24_));
#line 352 "../src/CanvasText.vala"
			_pango_layout_line_unref0 (line_layout);
#line 2433 "CanvasText.c"
		}
	}
}


void
canvas_text_move_cursor_vertically (CanvasText* self,
                                    gint dir)
{
#line 366 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 367 "../src/CanvasText.vala"
	canvas_text_cursor_by_line (self, dir);
#line 368 "../src/CanvasText.vala"
	canvas_text_clear_selection (self);
#line 2449 "CanvasText.c"
}


void
canvas_text_selection_vertically (CanvasText* self,
                                  gint dir)
{
	gint last_cursor = 0;
	gint _tmp0_;
#line 372 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 373 "../src/CanvasText.vala"
	_tmp0_ = self->priv->_cursor;
#line 373 "../src/CanvasText.vala"
	last_cursor = _tmp0_;
#line 374 "../src/CanvasText.vala"
	canvas_text_cursor_by_line (self, dir);
#line 375 "../src/CanvasText.vala"
	canvas_text_adjust_selection (self, last_cursor);
#line 2469 "CanvasText.c"
}


void
canvas_text_move_cursor_to_start (CanvasText* self)
{
#line 379 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 380 "../src/CanvasText.vala"
	self->priv->_cursor = 0;
#line 381 "../src/CanvasText.vala"
	canvas_text_clear_selection (self);
#line 2482 "CanvasText.c"
}


void
canvas_text_move_cursor_to_end (CanvasText* self)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
#line 385 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 386 "../src/CanvasText.vala"
	_tmp0_ = canvas_text_get_text (self);
#line 386 "../src/CanvasText.vala"
	_tmp1_ = _tmp0_;
#line 386 "../src/CanvasText.vala"
	self->priv->_cursor = g_utf8_strlen (_tmp1_, (gssize) -1);
#line 387 "../src/CanvasText.vala"
	canvas_text_clear_selection (self);
#line 2501 "CanvasText.c"
}


void
canvas_text_selection_to_start (CanvasText* self)
{
	gint _tmp0_;
	gint _tmp1_;
#line 391 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 392 "../src/CanvasText.vala"
	_tmp0_ = self->priv->_selstart;
#line 392 "../src/CanvasText.vala"
	_tmp1_ = self->priv->_selend;
#line 392 "../src/CanvasText.vala"
	if (_tmp0_ == _tmp1_) {
#line 2518 "CanvasText.c"
		gint _tmp2_;
#line 393 "../src/CanvasText.vala"
		self->priv->_selstart = 0;
#line 394 "../src/CanvasText.vala"
		_tmp2_ = self->priv->_cursor;
#line 394 "../src/CanvasText.vala"
		self->priv->_selend = _tmp2_;
#line 395 "../src/CanvasText.vala"
		self->priv->_cursor = 0;
#line 2528 "CanvasText.c"
	} else {
#line 397 "../src/CanvasText.vala"
		self->priv->_selstart = 0;
#line 398 "../src/CanvasText.vala"
		self->priv->_cursor = 0;
#line 2534 "CanvasText.c"
	}
}


void
canvas_text_selection_to_end (CanvasText* self)
{
	gint _tmp0_;
	gint _tmp1_;
#line 403 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 404 "../src/CanvasText.vala"
	_tmp0_ = self->priv->_selstart;
#line 404 "../src/CanvasText.vala"
	_tmp1_ = self->priv->_selend;
#line 404 "../src/CanvasText.vala"
	if (_tmp0_ == _tmp1_) {
#line 2552 "CanvasText.c"
		gint _tmp2_;
		const gchar* _tmp3_;
		const gchar* _tmp4_;
		const gchar* _tmp5_;
		const gchar* _tmp6_;
#line 405 "../src/CanvasText.vala"
		_tmp2_ = self->priv->_cursor;
#line 405 "../src/CanvasText.vala"
		self->priv->_selstart = _tmp2_;
#line 406 "../src/CanvasText.vala"
		_tmp3_ = canvas_text_get_text (self);
#line 406 "../src/CanvasText.vala"
		_tmp4_ = _tmp3_;
#line 406 "../src/CanvasText.vala"
		self->priv->_selend = g_utf8_strlen (_tmp4_, (gssize) -1);
#line 407 "../src/CanvasText.vala"
		_tmp5_ = canvas_text_get_text (self);
#line 407 "../src/CanvasText.vala"
		_tmp6_ = _tmp5_;
#line 407 "../src/CanvasText.vala"
		self->priv->_cursor = g_utf8_strlen (_tmp6_, (gssize) -1);
#line 2574 "CanvasText.c"
	} else {
		const gchar* _tmp7_;
		const gchar* _tmp8_;
		const gchar* _tmp9_;
		const gchar* _tmp10_;
#line 409 "../src/CanvasText.vala"
		_tmp7_ = canvas_text_get_text (self);
#line 409 "../src/CanvasText.vala"
		_tmp8_ = _tmp7_;
#line 409 "../src/CanvasText.vala"
		self->priv->_selend = g_utf8_strlen (_tmp8_, (gssize) -1);
#line 410 "../src/CanvasText.vala"
		_tmp9_ = canvas_text_get_text (self);
#line 410 "../src/CanvasText.vala"
		_tmp10_ = _tmp9_;
#line 410 "../src/CanvasText.vala"
		self->priv->_cursor = g_utf8_strlen (_tmp10_, (gssize) -1);
#line 2592 "CanvasText.c"
	}
}


static gunichar
string_get_char (const gchar* self,
                 glong index)
{
	gunichar result = 0U;
#line 1210 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0U);
#line 1211 "glib-2.0.vapi"
	result = g_utf8_get_char (((gchar*) self) + index);
#line 1211 "glib-2.0.vapi"
	return result;
#line 2608 "CanvasText.c"
}


static gint
canvas_text_find_word (CanvasText* self,
                       gint start,
                       gint dir)
{
	gint result = 0;
	gboolean alnum_found = FALSE;
#line 415 "../src/CanvasText.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 416 "../src/CanvasText.vala"
	alnum_found = FALSE;
#line 417 "../src/CanvasText.vala"
	if (dir == 1) {
#line 2625 "CanvasText.c"
		const gchar* _tmp12_;
		const gchar* _tmp13_;
		{
			gint i = 0;
#line 418 "../src/CanvasText.vala"
			i = start;
#line 2632 "CanvasText.c"
			{
				gboolean _tmp0_ = FALSE;
#line 418 "../src/CanvasText.vala"
				_tmp0_ = TRUE;
#line 418 "../src/CanvasText.vala"
				while (TRUE) {
#line 2639 "CanvasText.c"
					gint _tmp2_;
					const gchar* _tmp3_;
					const gchar* _tmp4_;
					gint index = 0;
					const gchar* _tmp5_;
					const gchar* _tmp6_;
					gint _tmp7_;
					const gchar* _tmp8_;
					const gchar* _tmp9_;
					gint _tmp10_;
#line 418 "../src/CanvasText.vala"
					if (!_tmp0_) {
#line 2652 "CanvasText.c"
						gint _tmp1_;
#line 418 "../src/CanvasText.vala"
						_tmp1_ = i;
#line 418 "../src/CanvasText.vala"
						i = _tmp1_ + 1;
#line 2658 "CanvasText.c"
					}
#line 418 "../src/CanvasText.vala"
					_tmp0_ = FALSE;
#line 418 "../src/CanvasText.vala"
					_tmp2_ = i;
#line 418 "../src/CanvasText.vala"
					_tmp3_ = canvas_text_get_text (self);
#line 418 "../src/CanvasText.vala"
					_tmp4_ = _tmp3_;
#line 418 "../src/CanvasText.vala"
					if (!(_tmp2_ < g_utf8_strlen (_tmp4_, (gssize) -1))) {
#line 418 "../src/CanvasText.vala"
						break;
#line 2672 "CanvasText.c"
					}
#line 419 "../src/CanvasText.vala"
					_tmp5_ = canvas_text_get_text (self);
#line 419 "../src/CanvasText.vala"
					_tmp6_ = _tmp5_;
#line 419 "../src/CanvasText.vala"
					_tmp7_ = i;
#line 419 "../src/CanvasText.vala"
					index = string_index_of_nth_char (_tmp6_, (glong) _tmp7_);
#line 420 "../src/CanvasText.vala"
					_tmp8_ = canvas_text_get_text (self);
#line 420 "../src/CanvasText.vala"
					_tmp9_ = _tmp8_;
#line 420 "../src/CanvasText.vala"
					_tmp10_ = index;
#line 420 "../src/CanvasText.vala"
					if (g_unichar_isalnum (string_get_char (_tmp9_, (glong) _tmp10_))) {
#line 421 "../src/CanvasText.vala"
						alnum_found = TRUE;
#line 2692 "CanvasText.c"
					} else {
						gboolean _tmp11_;
#line 422 "../src/CanvasText.vala"
						_tmp11_ = alnum_found;
#line 422 "../src/CanvasText.vala"
						if (_tmp11_) {
#line 423 "../src/CanvasText.vala"
							result = i;
#line 423 "../src/CanvasText.vala"
							return result;
#line 2703 "CanvasText.c"
						}
					}
				}
			}
		}
#line 426 "../src/CanvasText.vala"
		_tmp12_ = canvas_text_get_text (self);
#line 426 "../src/CanvasText.vala"
		_tmp13_ = _tmp12_;
#line 426 "../src/CanvasText.vala"
		result = g_utf8_strlen (_tmp13_, (gssize) -1);
#line 426 "../src/CanvasText.vala"
		return result;
#line 2717 "CanvasText.c"
	} else {
		{
			gint i = 0;
#line 428 "../src/CanvasText.vala"
			i = start - 1;
#line 2723 "CanvasText.c"
			{
				gboolean _tmp14_ = FALSE;
#line 428 "../src/CanvasText.vala"
				_tmp14_ = TRUE;
#line 428 "../src/CanvasText.vala"
				while (TRUE) {
#line 2730 "CanvasText.c"
					gint _tmp16_;
					gint index = 0;
					const gchar* _tmp17_;
					const gchar* _tmp18_;
					gint _tmp19_;
					const gchar* _tmp20_;
					const gchar* _tmp21_;
					gint _tmp22_;
#line 428 "../src/CanvasText.vala"
					if (!_tmp14_) {
#line 2741 "CanvasText.c"
						gint _tmp15_;
#line 428 "../src/CanvasText.vala"
						_tmp15_ = i;
#line 428 "../src/CanvasText.vala"
						i = _tmp15_ - 1;
#line 2747 "CanvasText.c"
					}
#line 428 "../src/CanvasText.vala"
					_tmp14_ = FALSE;
#line 428 "../src/CanvasText.vala"
					_tmp16_ = i;
#line 428 "../src/CanvasText.vala"
					if (!(_tmp16_ >= 0)) {
#line 428 "../src/CanvasText.vala"
						break;
#line 2757 "CanvasText.c"
					}
#line 429 "../src/CanvasText.vala"
					_tmp17_ = canvas_text_get_text (self);
#line 429 "../src/CanvasText.vala"
					_tmp18_ = _tmp17_;
#line 429 "../src/CanvasText.vala"
					_tmp19_ = i;
#line 429 "../src/CanvasText.vala"
					index = string_index_of_nth_char (_tmp18_, (glong) _tmp19_);
#line 430 "../src/CanvasText.vala"
					_tmp20_ = canvas_text_get_text (self);
#line 430 "../src/CanvasText.vala"
					_tmp21_ = _tmp20_;
#line 430 "../src/CanvasText.vala"
					_tmp22_ = index;
#line 430 "../src/CanvasText.vala"
					if (g_unichar_isalnum (string_get_char (_tmp21_, (glong) _tmp22_))) {
#line 431 "../src/CanvasText.vala"
						alnum_found = TRUE;
#line 2777 "CanvasText.c"
					} else {
						gboolean _tmp23_;
#line 432 "../src/CanvasText.vala"
						_tmp23_ = alnum_found;
#line 432 "../src/CanvasText.vala"
						if (_tmp23_) {
#line 2784 "CanvasText.c"
							gint _tmp24_;
#line 433 "../src/CanvasText.vala"
							_tmp24_ = i;
#line 433 "../src/CanvasText.vala"
							result = _tmp24_ + 1;
#line 433 "../src/CanvasText.vala"
							return result;
#line 2792 "CanvasText.c"
						}
					}
				}
			}
		}
#line 436 "../src/CanvasText.vala"
		result = 0;
#line 436 "../src/CanvasText.vala"
		return result;
#line 2802 "CanvasText.c"
	}
}


void
canvas_text_move_cursor_by_word (CanvasText* self,
                                 gint dir)
{
	gint _tmp0_;
	gint _tmp1_;
#line 441 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 442 "../src/CanvasText.vala"
	_tmp0_ = self->priv->_cursor;
#line 442 "../src/CanvasText.vala"
	self->priv->_cursor = canvas_text_find_word (self, _tmp0_, dir);
#line 443 "../src/CanvasText.vala"
	_tmp1_ = self->priv->_selstart;
#line 443 "../src/CanvasText.vala"
	self->priv->_selend = _tmp1_;
#line 2823 "CanvasText.c"
}


void
canvas_text_selection_by_word (CanvasText* self,
                               gint dir)
{
	gint _tmp0_;
	gint _tmp1_;
#line 447 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 448 "../src/CanvasText.vala"
	_tmp0_ = self->priv->_cursor;
#line 448 "../src/CanvasText.vala"
	_tmp1_ = self->priv->_selstart;
#line 448 "../src/CanvasText.vala"
	if (_tmp0_ == _tmp1_) {
#line 2841 "CanvasText.c"
		gint _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
#line 449 "../src/CanvasText.vala"
		_tmp2_ = self->priv->_cursor;
#line 449 "../src/CanvasText.vala"
		self->priv->_cursor = canvas_text_find_word (self, _tmp2_, dir);
#line 450 "../src/CanvasText.vala"
		_tmp3_ = self->priv->_cursor;
#line 450 "../src/CanvasText.vala"
		_tmp4_ = self->priv->_selend;
#line 450 "../src/CanvasText.vala"
		if (_tmp3_ <= _tmp4_) {
#line 2855 "CanvasText.c"
			gint _tmp5_;
#line 451 "../src/CanvasText.vala"
			_tmp5_ = self->priv->_cursor;
#line 451 "../src/CanvasText.vala"
			self->priv->_selstart = _tmp5_;
#line 2861 "CanvasText.c"
		} else {
			gint _tmp6_;
			gint _tmp7_;
#line 453 "../src/CanvasText.vala"
			_tmp6_ = self->priv->_selend;
#line 453 "../src/CanvasText.vala"
			self->priv->_selstart = _tmp6_;
#line 454 "../src/CanvasText.vala"
			_tmp7_ = self->priv->_cursor;
#line 454 "../src/CanvasText.vala"
			self->priv->_selend = _tmp7_;
#line 2873 "CanvasText.c"
		}
	} else {
		gint _tmp8_;
		gint _tmp9_;
		gint _tmp10_;
#line 457 "../src/CanvasText.vala"
		_tmp8_ = self->priv->_cursor;
#line 457 "../src/CanvasText.vala"
		self->priv->_cursor = canvas_text_find_word (self, _tmp8_, dir);
#line 458 "../src/CanvasText.vala"
		_tmp9_ = self->priv->_cursor;
#line 458 "../src/CanvasText.vala"
		_tmp10_ = self->priv->_selstart;
#line 458 "../src/CanvasText.vala"
		if (_tmp9_ >= _tmp10_) {
#line 2889 "CanvasText.c"
			gint _tmp11_;
#line 459 "../src/CanvasText.vala"
			_tmp11_ = self->priv->_cursor;
#line 459 "../src/CanvasText.vala"
			self->priv->_selend = _tmp11_;
#line 2895 "CanvasText.c"
		} else {
			gint _tmp12_;
			gint _tmp13_;
#line 461 "../src/CanvasText.vala"
			_tmp12_ = self->priv->_selstart;
#line 461 "../src/CanvasText.vala"
			self->priv->_selend = _tmp12_;
#line 462 "../src/CanvasText.vala"
			_tmp13_ = self->priv->_cursor;
#line 462 "../src/CanvasText.vala"
			self->priv->_selstart = _tmp13_;
#line 2907 "CanvasText.c"
		}
	}
}


static gchar*
string_splice (const gchar* self,
               glong start,
               glong end,
               const gchar* str)
{
	gchar* result = NULL;
	glong string_length = 0L;
	gint _tmp0_;
	gint _tmp1_;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp6_ = FALSE;
	gsize str_size = 0UL;
	const gchar* _result_ = NULL;
	glong _tmp10_;
	gsize _tmp11_;
	void* _tmp12_;
	gchar* dest = NULL;
	const gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	gsize _tmp17_;
	gchar* _tmp18_;
	gsize _tmp19_;
	gchar* _tmp20_;
	glong _tmp21_;
	const gchar* _tmp22_;
#line 1439 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1440 "glib-2.0.vapi"
	_tmp0_ = strlen (self);
#line 1440 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 1440 "glib-2.0.vapi"
	string_length = (glong) _tmp1_;
#line 1441 "glib-2.0.vapi"
	if (start < ((glong) 0)) {
#line 2951 "CanvasText.c"
		glong _tmp2_;
#line 1442 "glib-2.0.vapi"
		_tmp2_ = string_length;
#line 1442 "glib-2.0.vapi"
		start = _tmp2_ + start;
#line 2957 "CanvasText.c"
	}
#line 1444 "glib-2.0.vapi"
	if (end < ((glong) 0)) {
#line 2961 "CanvasText.c"
		glong _tmp3_;
#line 1445 "glib-2.0.vapi"
		_tmp3_ = string_length;
#line 1445 "glib-2.0.vapi"
		end = _tmp3_ + end;
#line 2967 "CanvasText.c"
	}
#line 1447 "glib-2.0.vapi"
	if (start >= ((glong) 0)) {
#line 2971 "CanvasText.c"
		glong _tmp5_;
#line 1447 "glib-2.0.vapi"
		_tmp5_ = string_length;
#line 1447 "glib-2.0.vapi"
		_tmp4_ = start <= _tmp5_;
#line 2977 "CanvasText.c"
	} else {
#line 1447 "glib-2.0.vapi"
		_tmp4_ = FALSE;
#line 2981 "CanvasText.c"
	}
#line 1447 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp4_, NULL);
#line 1448 "glib-2.0.vapi"
	if (end >= ((glong) 0)) {
#line 2987 "CanvasText.c"
		glong _tmp7_;
#line 1448 "glib-2.0.vapi"
		_tmp7_ = string_length;
#line 1448 "glib-2.0.vapi"
		_tmp6_ = end <= _tmp7_;
#line 2993 "CanvasText.c"
	} else {
#line 1448 "glib-2.0.vapi"
		_tmp6_ = FALSE;
#line 2997 "CanvasText.c"
	}
#line 1448 "glib-2.0.vapi"
	g_return_val_if_fail (_tmp6_, NULL);
#line 1449 "glib-2.0.vapi"
	g_return_val_if_fail (start <= end, NULL);
#line 1452 "glib-2.0.vapi"
	if (str == NULL) {
#line 1453 "glib-2.0.vapi"
		str_size = (gsize) 0;
#line 3007 "CanvasText.c"
	} else {
		gint _tmp8_;
		gint _tmp9_;
#line 1455 "glib-2.0.vapi"
		_tmp8_ = strlen ((const gchar*) str);
#line 1455 "glib-2.0.vapi"
		_tmp9_ = _tmp8_;
#line 1455 "glib-2.0.vapi"
		str_size = (gsize) _tmp9_;
#line 3017 "CanvasText.c"
	}
#line 1458 "glib-2.0.vapi"
	_tmp10_ = string_length;
#line 1458 "glib-2.0.vapi"
	_tmp11_ = str_size;
#line 1458 "glib-2.0.vapi"
	_tmp12_ = g_malloc0 (((_tmp10_ - (end - start)) + _tmp11_) + 1);
#line 1458 "glib-2.0.vapi"
	_result_ = _tmp12_;
#line 1460 "glib-2.0.vapi"
	_tmp13_ = _result_;
#line 1460 "glib-2.0.vapi"
	dest = (gchar*) _tmp13_;
#line 1462 "glib-2.0.vapi"
	_tmp14_ = dest;
#line 1462 "glib-2.0.vapi"
	memcpy (_tmp14_, self, (gsize) start);
#line 1463 "glib-2.0.vapi"
	_tmp15_ = dest;
#line 1463 "glib-2.0.vapi"
	dest = _tmp15_ + start;
#line 1465 "glib-2.0.vapi"
	_tmp16_ = dest;
#line 1465 "glib-2.0.vapi"
	_tmp17_ = str_size;
#line 1465 "glib-2.0.vapi"
	memcpy (_tmp16_, str, _tmp17_);
#line 1466 "glib-2.0.vapi"
	_tmp18_ = dest;
#line 1466 "glib-2.0.vapi"
	_tmp19_ = str_size;
#line 1466 "glib-2.0.vapi"
	dest = _tmp18_ + _tmp19_;
#line 1468 "glib-2.0.vapi"
	_tmp20_ = dest;
#line 1468 "glib-2.0.vapi"
	_tmp21_ = string_length;
#line 1468 "glib-2.0.vapi"
	memcpy (_tmp20_, ((gchar*) self) + end, (gsize) (_tmp21_ - end));
#line 1470 "glib-2.0.vapi"
	_tmp22_ = _result_;
#line 1470 "glib-2.0.vapi"
	_result_ = NULL;
#line 1470 "glib-2.0.vapi"
	result = (gchar*) _tmp22_;
#line 1470 "glib-2.0.vapi"
	return result;
#line 3065 "CanvasText.c"
}


void
canvas_text_backspace (CanvasText* self)
{
	gint _tmp0_;
#line 468 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 469 "../src/CanvasText.vala"
	_tmp0_ = self->priv->_cursor;
#line 469 "../src/CanvasText.vala"
	if (_tmp0_ > 0) {
#line 3079 "CanvasText.c"
		gint _tmp1_;
		gint _tmp2_;
#line 470 "../src/CanvasText.vala"
		_tmp1_ = self->priv->_selstart;
#line 470 "../src/CanvasText.vala"
		_tmp2_ = self->priv->_selend;
#line 470 "../src/CanvasText.vala"
		if (_tmp1_ != _tmp2_) {
#line 3088 "CanvasText.c"
			gint spos = 0;
			const gchar* _tmp3_;
			const gchar* _tmp4_;
			gint _tmp5_;
			gint epos = 0;
			const gchar* _tmp6_;
			const gchar* _tmp7_;
			gint _tmp8_;
			const gchar* _tmp9_;
			const gchar* _tmp10_;
			gint _tmp11_;
			gint _tmp12_;
			gchar* _tmp13_;
			gchar* _tmp14_;
			gint _tmp15_;
			gint _tmp16_;
#line 471 "../src/CanvasText.vala"
			_tmp3_ = canvas_text_get_text (self);
#line 471 "../src/CanvasText.vala"
			_tmp4_ = _tmp3_;
#line 471 "../src/CanvasText.vala"
			_tmp5_ = self->priv->_selstart;
#line 471 "../src/CanvasText.vala"
			spos = string_index_of_nth_char (_tmp4_, (glong) _tmp5_);
#line 472 "../src/CanvasText.vala"
			_tmp6_ = canvas_text_get_text (self);
#line 472 "../src/CanvasText.vala"
			_tmp7_ = _tmp6_;
#line 472 "../src/CanvasText.vala"
			_tmp8_ = self->priv->_selend;
#line 472 "../src/CanvasText.vala"
			epos = string_index_of_nth_char (_tmp7_, (glong) _tmp8_);
#line 473 "../src/CanvasText.vala"
			_tmp9_ = canvas_text_get_text (self);
#line 473 "../src/CanvasText.vala"
			_tmp10_ = _tmp9_;
#line 473 "../src/CanvasText.vala"
			_tmp11_ = spos;
#line 473 "../src/CanvasText.vala"
			_tmp12_ = epos;
#line 473 "../src/CanvasText.vala"
			_tmp13_ = string_splice (_tmp10_, (glong) _tmp11_, (glong) _tmp12_, NULL);
#line 473 "../src/CanvasText.vala"
			_tmp14_ = _tmp13_;
#line 473 "../src/CanvasText.vala"
			canvas_text_set_text (self, _tmp14_);
#line 473 "../src/CanvasText.vala"
			_g_free0 (_tmp14_);
#line 474 "../src/CanvasText.vala"
			_tmp15_ = self->priv->_selstart;
#line 474 "../src/CanvasText.vala"
			self->priv->_cursor = _tmp15_;
#line 475 "../src/CanvasText.vala"
			_tmp16_ = self->priv->_selstart;
#line 475 "../src/CanvasText.vala"
			self->priv->_selend = _tmp16_;
#line 3145 "CanvasText.c"
		} else {
			gint spos = 0;
			const gchar* _tmp17_;
			const gchar* _tmp18_;
			gint _tmp19_;
			gint epos = 0;
			const gchar* _tmp20_;
			const gchar* _tmp21_;
			gint _tmp22_;
			const gchar* _tmp23_;
			const gchar* _tmp24_;
			gint _tmp25_;
			gint _tmp26_;
			gchar* _tmp27_;
			gchar* _tmp28_;
			gint _tmp29_;
#line 477 "../src/CanvasText.vala"
			_tmp17_ = canvas_text_get_text (self);
#line 477 "../src/CanvasText.vala"
			_tmp18_ = _tmp17_;
#line 477 "../src/CanvasText.vala"
			_tmp19_ = self->priv->_cursor;
#line 477 "../src/CanvasText.vala"
			spos = string_index_of_nth_char (_tmp18_, (glong) (_tmp19_ - 1));
#line 478 "../src/CanvasText.vala"
			_tmp20_ = canvas_text_get_text (self);
#line 478 "../src/CanvasText.vala"
			_tmp21_ = _tmp20_;
#line 478 "../src/CanvasText.vala"
			_tmp22_ = self->priv->_cursor;
#line 478 "../src/CanvasText.vala"
			epos = string_index_of_nth_char (_tmp21_, (glong) _tmp22_);
#line 479 "../src/CanvasText.vala"
			_tmp23_ = canvas_text_get_text (self);
#line 479 "../src/CanvasText.vala"
			_tmp24_ = _tmp23_;
#line 479 "../src/CanvasText.vala"
			_tmp25_ = spos;
#line 479 "../src/CanvasText.vala"
			_tmp26_ = epos;
#line 479 "../src/CanvasText.vala"
			_tmp27_ = string_splice (_tmp24_, (glong) _tmp25_, (glong) _tmp26_, NULL);
#line 479 "../src/CanvasText.vala"
			_tmp28_ = _tmp27_;
#line 479 "../src/CanvasText.vala"
			canvas_text_set_text (self, _tmp28_);
#line 479 "../src/CanvasText.vala"
			_g_free0 (_tmp28_);
#line 480 "../src/CanvasText.vala"
			_tmp29_ = self->priv->_cursor;
#line 480 "../src/CanvasText.vala"
			self->priv->_cursor = _tmp29_ - 1;
#line 3198 "CanvasText.c"
		}
	}
}


void
canvas_text_delete (CanvasText* self)
{
	gint _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
#line 486 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 487 "../src/CanvasText.vala"
	_tmp0_ = self->priv->_cursor;
#line 487 "../src/CanvasText.vala"
	_tmp1_ = canvas_text_get_text (self);
#line 487 "../src/CanvasText.vala"
	_tmp2_ = _tmp1_;
#line 487 "../src/CanvasText.vala"
	_tmp3_ = strlen (_tmp2_);
#line 487 "../src/CanvasText.vala"
	_tmp4_ = _tmp3_;
#line 487 "../src/CanvasText.vala"
	if (_tmp0_ < _tmp4_) {
#line 3226 "CanvasText.c"
		gint _tmp5_;
		gint _tmp6_;
#line 488 "../src/CanvasText.vala"
		_tmp5_ = self->priv->_selstart;
#line 488 "../src/CanvasText.vala"
		_tmp6_ = self->priv->_selend;
#line 488 "../src/CanvasText.vala"
		if (_tmp5_ != _tmp6_) {
#line 3235 "CanvasText.c"
			gint spos = 0;
			const gchar* _tmp7_;
			const gchar* _tmp8_;
			gint _tmp9_;
			gint epos = 0;
			const gchar* _tmp10_;
			const gchar* _tmp11_;
			gint _tmp12_;
			const gchar* _tmp13_;
			const gchar* _tmp14_;
			gint _tmp15_;
			gint _tmp16_;
			gchar* _tmp17_;
			gchar* _tmp18_;
			gint _tmp19_;
			gint _tmp20_;
#line 489 "../src/CanvasText.vala"
			_tmp7_ = canvas_text_get_text (self);
#line 489 "../src/CanvasText.vala"
			_tmp8_ = _tmp7_;
#line 489 "../src/CanvasText.vala"
			_tmp9_ = self->priv->_selstart;
#line 489 "../src/CanvasText.vala"
			spos = string_index_of_nth_char (_tmp8_, (glong) _tmp9_);
#line 490 "../src/CanvasText.vala"
			_tmp10_ = canvas_text_get_text (self);
#line 490 "../src/CanvasText.vala"
			_tmp11_ = _tmp10_;
#line 490 "../src/CanvasText.vala"
			_tmp12_ = self->priv->_selend;
#line 490 "../src/CanvasText.vala"
			epos = string_index_of_nth_char (_tmp11_, (glong) _tmp12_);
#line 491 "../src/CanvasText.vala"
			_tmp13_ = canvas_text_get_text (self);
#line 491 "../src/CanvasText.vala"
			_tmp14_ = _tmp13_;
#line 491 "../src/CanvasText.vala"
			_tmp15_ = spos;
#line 491 "../src/CanvasText.vala"
			_tmp16_ = epos;
#line 491 "../src/CanvasText.vala"
			_tmp17_ = string_splice (_tmp14_, (glong) _tmp15_, (glong) _tmp16_, NULL);
#line 491 "../src/CanvasText.vala"
			_tmp18_ = _tmp17_;
#line 491 "../src/CanvasText.vala"
			canvas_text_set_text (self, _tmp18_);
#line 491 "../src/CanvasText.vala"
			_g_free0 (_tmp18_);
#line 492 "../src/CanvasText.vala"
			_tmp19_ = self->priv->_selstart;
#line 492 "../src/CanvasText.vala"
			self->priv->_cursor = _tmp19_;
#line 493 "../src/CanvasText.vala"
			_tmp20_ = self->priv->_selstart;
#line 493 "../src/CanvasText.vala"
			self->priv->_selend = _tmp20_;
#line 3292 "CanvasText.c"
		} else {
			gint spos = 0;
			const gchar* _tmp21_;
			const gchar* _tmp22_;
			gint _tmp23_;
			gint epos = 0;
			const gchar* _tmp24_;
			const gchar* _tmp25_;
			gint _tmp26_;
			const gchar* _tmp27_;
			const gchar* _tmp28_;
			gint _tmp29_;
			gint _tmp30_;
			gchar* _tmp31_;
			gchar* _tmp32_;
#line 495 "../src/CanvasText.vala"
			_tmp21_ = canvas_text_get_text (self);
#line 495 "../src/CanvasText.vala"
			_tmp22_ = _tmp21_;
#line 495 "../src/CanvasText.vala"
			_tmp23_ = self->priv->_cursor;
#line 495 "../src/CanvasText.vala"
			spos = string_index_of_nth_char (_tmp22_, (glong) _tmp23_);
#line 496 "../src/CanvasText.vala"
			_tmp24_ = canvas_text_get_text (self);
#line 496 "../src/CanvasText.vala"
			_tmp25_ = _tmp24_;
#line 496 "../src/CanvasText.vala"
			_tmp26_ = self->priv->_cursor;
#line 496 "../src/CanvasText.vala"
			epos = string_index_of_nth_char (_tmp25_, (glong) (_tmp26_ + 1));
#line 497 "../src/CanvasText.vala"
			_tmp27_ = canvas_text_get_text (self);
#line 497 "../src/CanvasText.vala"
			_tmp28_ = _tmp27_;
#line 497 "../src/CanvasText.vala"
			_tmp29_ = spos;
#line 497 "../src/CanvasText.vala"
			_tmp30_ = epos;
#line 497 "../src/CanvasText.vala"
			_tmp31_ = string_splice (_tmp28_, (glong) _tmp29_, (glong) _tmp30_, NULL);
#line 497 "../src/CanvasText.vala"
			_tmp32_ = _tmp31_;
#line 497 "../src/CanvasText.vala"
			canvas_text_set_text (self, _tmp32_);
#line 497 "../src/CanvasText.vala"
			_g_free0 (_tmp32_);
#line 3340 "CanvasText.c"
		}
	}
}


void
canvas_text_insert (CanvasText* self,
                    const gchar* s)
{
	gint slen = 0;
	gint _tmp0_;
	gint _tmp1_;
#line 503 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 503 "../src/CanvasText.vala"
	g_return_if_fail (s != NULL);
#line 504 "../src/CanvasText.vala"
	slen = g_utf8_strlen (s, (gssize) -1);
#line 505 "../src/CanvasText.vala"
	_tmp0_ = self->priv->_selstart;
#line 505 "../src/CanvasText.vala"
	_tmp1_ = self->priv->_selend;
#line 505 "../src/CanvasText.vala"
	if (_tmp0_ != _tmp1_) {
#line 3365 "CanvasText.c"
		gint spos = 0;
		const gchar* _tmp2_;
		const gchar* _tmp3_;
		gint _tmp4_;
		gint epos = 0;
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		gint _tmp7_;
		const gchar* _tmp8_;
		const gchar* _tmp9_;
		gint _tmp10_;
		gint _tmp11_;
		gchar* _tmp12_;
		gchar* _tmp13_;
		gint _tmp14_;
		gint _tmp15_;
		gint _tmp16_;
#line 506 "../src/CanvasText.vala"
		_tmp2_ = canvas_text_get_text (self);
#line 506 "../src/CanvasText.vala"
		_tmp3_ = _tmp2_;
#line 506 "../src/CanvasText.vala"
		_tmp4_ = self->priv->_selstart;
#line 506 "../src/CanvasText.vala"
		spos = string_index_of_nth_char (_tmp3_, (glong) _tmp4_);
#line 507 "../src/CanvasText.vala"
		_tmp5_ = canvas_text_get_text (self);
#line 507 "../src/CanvasText.vala"
		_tmp6_ = _tmp5_;
#line 507 "../src/CanvasText.vala"
		_tmp7_ = self->priv->_selend;
#line 507 "../src/CanvasText.vala"
		epos = string_index_of_nth_char (_tmp6_, (glong) _tmp7_);
#line 508 "../src/CanvasText.vala"
		_tmp8_ = canvas_text_get_text (self);
#line 508 "../src/CanvasText.vala"
		_tmp9_ = _tmp8_;
#line 508 "../src/CanvasText.vala"
		_tmp10_ = spos;
#line 508 "../src/CanvasText.vala"
		_tmp11_ = epos;
#line 508 "../src/CanvasText.vala"
		_tmp12_ = string_splice (_tmp9_, (glong) _tmp10_, (glong) _tmp11_, s);
#line 508 "../src/CanvasText.vala"
		_tmp13_ = _tmp12_;
#line 508 "../src/CanvasText.vala"
		canvas_text_set_text (self, _tmp13_);
#line 508 "../src/CanvasText.vala"
		_g_free0 (_tmp13_);
#line 509 "../src/CanvasText.vala"
		_tmp14_ = self->priv->_selstart;
#line 509 "../src/CanvasText.vala"
		_tmp15_ = slen;
#line 509 "../src/CanvasText.vala"
		self->priv->_cursor = _tmp14_ + _tmp15_;
#line 510 "../src/CanvasText.vala"
		_tmp16_ = self->priv->_selstart;
#line 510 "../src/CanvasText.vala"
		self->priv->_selend = _tmp16_;
#line 3425 "CanvasText.c"
	} else {
		gint cpos = 0;
		const gchar* _tmp17_;
		const gchar* _tmp18_;
		gint _tmp19_;
		const gchar* _tmp20_;
		const gchar* _tmp21_;
		gint _tmp22_;
		gint _tmp23_;
		gchar* _tmp24_;
		gchar* _tmp25_;
		gint _tmp26_;
		gint _tmp27_;
#line 512 "../src/CanvasText.vala"
		_tmp17_ = canvas_text_get_text (self);
#line 512 "../src/CanvasText.vala"
		_tmp18_ = _tmp17_;
#line 512 "../src/CanvasText.vala"
		_tmp19_ = self->priv->_cursor;
#line 512 "../src/CanvasText.vala"
		cpos = string_index_of_nth_char (_tmp18_, (glong) _tmp19_);
#line 513 "../src/CanvasText.vala"
		_tmp20_ = canvas_text_get_text (self);
#line 513 "../src/CanvasText.vala"
		_tmp21_ = _tmp20_;
#line 513 "../src/CanvasText.vala"
		_tmp22_ = cpos;
#line 513 "../src/CanvasText.vala"
		_tmp23_ = cpos;
#line 513 "../src/CanvasText.vala"
		_tmp24_ = string_splice (_tmp21_, (glong) _tmp22_, (glong) _tmp23_, s);
#line 513 "../src/CanvasText.vala"
		_tmp25_ = _tmp24_;
#line 513 "../src/CanvasText.vala"
		canvas_text_set_text (self, _tmp25_);
#line 513 "../src/CanvasText.vala"
		_g_free0 (_tmp25_);
#line 514 "../src/CanvasText.vala"
		_tmp26_ = self->priv->_cursor;
#line 514 "../src/CanvasText.vala"
		_tmp27_ = slen;
#line 514 "../src/CanvasText.vala"
		self->priv->_cursor = _tmp26_ + _tmp27_;
#line 3469 "CanvasText.c"
	}
}


gchar*
canvas_text_get_selected_text (CanvasText* self)
{
	gchar* result = NULL;
	gint _tmp0_;
	gint _tmp1_;
#line 522 "../src/CanvasText.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 523 "../src/CanvasText.vala"
	_tmp0_ = self->priv->_selstart;
#line 523 "../src/CanvasText.vala"
	_tmp1_ = self->priv->_selend;
#line 523 "../src/CanvasText.vala"
	if (_tmp0_ != _tmp1_) {
#line 3488 "CanvasText.c"
		gint spos = 0;
		const gchar* _tmp2_;
		const gchar* _tmp3_;
		gint _tmp4_;
		gint epos = 0;
		const gchar* _tmp5_;
		const gchar* _tmp6_;
		gint _tmp7_;
		const gchar* _tmp8_;
		const gchar* _tmp9_;
		gint _tmp10_;
		gint _tmp11_;
		gchar* _tmp12_;
#line 524 "../src/CanvasText.vala"
		_tmp2_ = canvas_text_get_text (self);
#line 524 "../src/CanvasText.vala"
		_tmp3_ = _tmp2_;
#line 524 "../src/CanvasText.vala"
		_tmp4_ = self->priv->_selstart;
#line 524 "../src/CanvasText.vala"
		spos = string_index_of_nth_char (_tmp3_, (glong) _tmp4_);
#line 525 "../src/CanvasText.vala"
		_tmp5_ = canvas_text_get_text (self);
#line 525 "../src/CanvasText.vala"
		_tmp6_ = _tmp5_;
#line 525 "../src/CanvasText.vala"
		_tmp7_ = self->priv->_selend;
#line 525 "../src/CanvasText.vala"
		epos = string_index_of_nth_char (_tmp6_, (glong) _tmp7_);
#line 526 "../src/CanvasText.vala"
		_tmp8_ = canvas_text_get_text (self);
#line 526 "../src/CanvasText.vala"
		_tmp9_ = _tmp8_;
#line 526 "../src/CanvasText.vala"
		_tmp10_ = spos;
#line 526 "../src/CanvasText.vala"
		_tmp11_ = epos;
#line 526 "../src/CanvasText.vala"
		_tmp12_ = string_slice (_tmp9_, (glong) _tmp10_, (glong) _tmp11_);
#line 526 "../src/CanvasText.vala"
		result = _tmp12_;
#line 526 "../src/CanvasText.vala"
		return result;
#line 3532 "CanvasText.c"
	}
#line 528 "../src/CanvasText.vala"
	result = NULL;
#line 528 "../src/CanvasText.vala"
	return result;
#line 3538 "CanvasText.c"
}


void
canvas_text_get_cursor_pos (CanvasText* self,
                            gint* x,
                            gint* ytop,
                            gint* ybot)
{
	gint _vala_x = 0;
	gint _vala_ytop = 0;
	gint _vala_ybot = 0;
	gint index = 0;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gint _tmp2_;
	PangoRectangle rect = {0};
	PangoLayout* _tmp3_;
	PangoRectangle _tmp4_ = {0};
	gdouble _tmp5_;
	PangoRectangle _tmp6_;
	gint _tmp7_;
	gdouble _tmp8_;
	PangoRectangle _tmp9_;
	gint _tmp10_;
	PangoRectangle _tmp11_;
	gint _tmp12_;
#line 532 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 533 "../src/CanvasText.vala"
	_tmp0_ = canvas_text_get_text (self);
#line 533 "../src/CanvasText.vala"
	_tmp1_ = _tmp0_;
#line 533 "../src/CanvasText.vala"
	_tmp2_ = self->priv->_cursor;
#line 533 "../src/CanvasText.vala"
	index = string_index_of_nth_char (_tmp1_, (glong) _tmp2_);
#line 534 "../src/CanvasText.vala"
	_tmp3_ = self->priv->_pango_layout;
#line 534 "../src/CanvasText.vala"
	pango_layout_index_to_pos (_tmp3_, index, &_tmp4_);
#line 534 "../src/CanvasText.vala"
	rect = _tmp4_;
#line 535 "../src/CanvasText.vala"
	_tmp5_ = self->priv->_posx;
#line 535 "../src/CanvasText.vala"
	_tmp6_ = rect;
#line 535 "../src/CanvasText.vala"
	_tmp7_ = _tmp6_.x;
#line 535 "../src/CanvasText.vala"
	_vala_x = (gint) (_tmp5_ + (_tmp7_ / PANGO_SCALE));
#line 536 "../src/CanvasText.vala"
	_tmp8_ = self->priv->_posy;
#line 536 "../src/CanvasText.vala"
	_tmp9_ = rect;
#line 536 "../src/CanvasText.vala"
	_tmp10_ = _tmp9_.y;
#line 536 "../src/CanvasText.vala"
	_vala_ytop = (gint) (_tmp8_ + (_tmp10_ / PANGO_SCALE));
#line 537 "../src/CanvasText.vala"
	_tmp11_ = rect;
#line 537 "../src/CanvasText.vala"
	_tmp12_ = _tmp11_.height;
#line 537 "../src/CanvasText.vala"
	_vala_ybot = _vala_ytop + ((gint) (_tmp12_ / PANGO_SCALE));
#line 532 "../src/CanvasText.vala"
	if (x) {
#line 532 "../src/CanvasText.vala"
		*x = _vala_x;
#line 3608 "CanvasText.c"
	}
#line 532 "../src/CanvasText.vala"
	if (ytop) {
#line 532 "../src/CanvasText.vala"
		*ytop = _vala_ytop;
#line 3614 "CanvasText.c"
	}
#line 532 "../src/CanvasText.vala"
	if (ybot) {
#line 532 "../src/CanvasText.vala"
		*ybot = _vala_ybot;
#line 3620 "CanvasText.c"
	}
}


void
canvas_text_draw (CanvasText* self,
                  cairo_t* ctx,
                  Theme* theme,
                  GdkRGBA* fg,
                  gdouble alpha)
{
	PangoLayout* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gdouble _tmp3_;
	gdouble _tmp4_;
	GdkRGBA _tmp5_;
	PangoLayout* _tmp6_;
	gboolean _tmp7_;
	gboolean _tmp8_;
#line 541 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 541 "../src/CanvasText.vala"
	g_return_if_fail (ctx != NULL);
#line 541 "../src/CanvasText.vala"
	g_return_if_fail (theme != NULL);
#line 541 "../src/CanvasText.vala"
	g_return_if_fail (fg != NULL);
#line 544 "../src/CanvasText.vala"
	_tmp0_ = self->priv->_pango_layout;
#line 544 "../src/CanvasText.vala"
	_tmp1_ = canvas_text_name_markup (self, theme);
#line 544 "../src/CanvasText.vala"
	_tmp2_ = _tmp1_;
#line 544 "../src/CanvasText.vala"
	pango_layout_set_markup (_tmp0_, _tmp2_, -1);
#line 544 "../src/CanvasText.vala"
	_g_free0 (_tmp2_);
#line 547 "../src/CanvasText.vala"
	_tmp3_ = self->priv->_posx;
#line 547 "../src/CanvasText.vala"
	_tmp4_ = self->priv->_posy;
#line 547 "../src/CanvasText.vala"
	cairo_move_to (ctx, _tmp3_, _tmp4_);
#line 548 "../src/CanvasText.vala"
	_tmp5_ = *fg;
#line 548 "../src/CanvasText.vala"
	utils_set_context_color_with_alpha (ctx, &_tmp5_, alpha);
#line 549 "../src/CanvasText.vala"
	_tmp6_ = self->priv->_pango_layout;
#line 549 "../src/CanvasText.vala"
	pango_cairo_show_layout (ctx, _tmp6_);
#line 550 "../src/CanvasText.vala"
	cairo_new_path (ctx);
#line 553 "../src/CanvasText.vala"
	_tmp7_ = canvas_text_get_edit (self);
#line 553 "../src/CanvasText.vala"
	_tmp8_ = _tmp7_;
#line 553 "../src/CanvasText.vala"
	if (_tmp8_) {
#line 3681 "CanvasText.c"
		gint cpos = 0;
		const gchar* _tmp9_;
		const gchar* _tmp10_;
		gint _tmp11_;
		PangoRectangle rect = {0};
		PangoLayout* _tmp12_;
		gint _tmp13_;
		PangoRectangle _tmp14_ = {0};
		GdkRGBA* _tmp15_;
		GdkRGBA* _tmp16_;
		GdkRGBA _tmp17_;
		gdouble ix = 0.0;
		gdouble iy = 0.0;
		gdouble _tmp18_;
		PangoRectangle _tmp19_;
		gint _tmp20_;
		gdouble _tmp21_;
		PangoRectangle _tmp22_;
		gint _tmp23_;
		gdouble _tmp24_;
		gdouble _tmp25_;
		PangoRectangle _tmp26_;
		gint _tmp27_;
#line 554 "../src/CanvasText.vala"
		_tmp9_ = canvas_text_get_text (self);
#line 554 "../src/CanvasText.vala"
		_tmp10_ = _tmp9_;
#line 554 "../src/CanvasText.vala"
		_tmp11_ = self->priv->_cursor;
#line 554 "../src/CanvasText.vala"
		cpos = string_index_of_nth_char (_tmp10_, (glong) _tmp11_);
#line 555 "../src/CanvasText.vala"
		_tmp12_ = self->priv->_pango_layout;
#line 555 "../src/CanvasText.vala"
		_tmp13_ = cpos;
#line 555 "../src/CanvasText.vala"
		pango_layout_index_to_pos (_tmp12_, _tmp13_, &_tmp14_);
#line 555 "../src/CanvasText.vala"
		rect = _tmp14_;
#line 556 "../src/CanvasText.vala"
		_tmp15_ = theme_get_color (theme, "text_cursor");
#line 556 "../src/CanvasText.vala"
		_tmp16_ = _tmp15_;
#line 556 "../src/CanvasText.vala"
		_tmp17_ = *_tmp16_;
#line 556 "../src/CanvasText.vala"
		utils_set_context_color_with_alpha (ctx, &_tmp17_, alpha);
#line 556 "../src/CanvasText.vala"
		_g_free0 (_tmp16_);
#line 558 "../src/CanvasText.vala"
		_tmp18_ = self->priv->_posx;
#line 558 "../src/CanvasText.vala"
		_tmp19_ = rect;
#line 558 "../src/CanvasText.vala"
		_tmp20_ = _tmp19_.x;
#line 558 "../src/CanvasText.vala"
		ix = (_tmp18_ + (_tmp20_ / PANGO_SCALE)) - 1;
#line 559 "../src/CanvasText.vala"
		_tmp21_ = self->priv->_posy;
#line 559 "../src/CanvasText.vala"
		_tmp22_ = rect;
#line 559 "../src/CanvasText.vala"
		_tmp23_ = _tmp22_.y;
#line 559 "../src/CanvasText.vala"
		iy = _tmp21_ + (_tmp23_ / PANGO_SCALE);
#line 560 "../src/CanvasText.vala"
		_tmp24_ = ix;
#line 560 "../src/CanvasText.vala"
		_tmp25_ = iy;
#line 560 "../src/CanvasText.vala"
		_tmp26_ = rect;
#line 560 "../src/CanvasText.vala"
		_tmp27_ = _tmp26_.height;
#line 560 "../src/CanvasText.vala"
		cairo_rectangle (ctx, _tmp24_, _tmp25_, (gdouble) 1, (gdouble) (_tmp27_ / PANGO_SCALE));
#line 561 "../src/CanvasText.vala"
		cairo_fill (ctx);
#line 3759 "CanvasText.c"
	}
}


const gchar*
canvas_text_get_text (CanvasText* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 49 "../src/CanvasText.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 50 "../src/CanvasText.vala"
	_tmp0_ = self->priv->_text;
#line 50 "../src/CanvasText.vala"
	result = _tmp0_;
#line 50 "../src/CanvasText.vala"
	return result;
#line 3777 "CanvasText.c"
}


void
canvas_text_set_text (CanvasText* self,
                      const gchar* value)
{
	const gchar* _tmp0_;
#line 52 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 53 "../src/CanvasText.vala"
	_tmp0_ = self->priv->_text;
#line 53 "../src/CanvasText.vala"
	if (g_strcmp0 (_tmp0_, value) != 0) {
#line 3792 "CanvasText.c"
		gchar* _tmp1_;
#line 54 "../src/CanvasText.vala"
		_tmp1_ = g_strdup (value);
#line 54 "../src/CanvasText.vala"
		_g_free0 (self->priv->_text);
#line 54 "../src/CanvasText.vala"
		self->priv->_text = _tmp1_;
#line 55 "../src/CanvasText.vala"
		canvas_text_update_size (self, TRUE);
#line 3802 "CanvasText.c"
	}
#line 52 "../src/CanvasText.vala"
	g_object_notify_by_pspec ((GObject *) self, canvas_text_properties[CANVAS_TEXT_TEXT_PROPERTY]);
#line 3806 "CanvasText.c"
}


gdouble
canvas_text_get_posx (CanvasText* self)
{
	gdouble result;
	gdouble _tmp0_;
#line 59 "../src/CanvasText.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 59 "../src/CanvasText.vala"
	_tmp0_ = self->priv->_posx;
#line 59 "../src/CanvasText.vala"
	result = _tmp0_;
#line 59 "../src/CanvasText.vala"
	return result;
#line 3823 "CanvasText.c"
}


void
canvas_text_set_posx (CanvasText* self,
                      gdouble value)
{
#line 59 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 59 "../src/CanvasText.vala"
	if (canvas_text_get_posx (self) != value) {
#line 59 "../src/CanvasText.vala"
		self->priv->_posx = value;
#line 59 "../src/CanvasText.vala"
		g_object_notify_by_pspec ((GObject *) self, canvas_text_properties[CANVAS_TEXT_POSX_PROPERTY]);
#line 3839 "CanvasText.c"
	}
}


gdouble
canvas_text_get_posy (CanvasText* self)
{
	gdouble result;
	gdouble _tmp0_;
#line 60 "../src/CanvasText.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 60 "../src/CanvasText.vala"
	_tmp0_ = self->priv->_posy;
#line 60 "../src/CanvasText.vala"
	result = _tmp0_;
#line 60 "../src/CanvasText.vala"
	return result;
#line 3857 "CanvasText.c"
}


void
canvas_text_set_posy (CanvasText* self,
                      gdouble value)
{
#line 60 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 60 "../src/CanvasText.vala"
	if (canvas_text_get_posy (self) != value) {
#line 60 "../src/CanvasText.vala"
		self->priv->_posy = value;
#line 60 "../src/CanvasText.vala"
		g_object_notify_by_pspec ((GObject *) self, canvas_text_properties[CANVAS_TEXT_POSY_PROPERTY]);
#line 3873 "CanvasText.c"
	}
}


gdouble
canvas_text_get_width (CanvasText* self)
{
	gdouble result;
	gdouble _tmp0_;
#line 62 "../src/CanvasText.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 63 "../src/CanvasText.vala"
	_tmp0_ = self->priv->_width;
#line 63 "../src/CanvasText.vala"
	result = _tmp0_;
#line 63 "../src/CanvasText.vala"
	return result;
#line 3891 "CanvasText.c"
}


gdouble
canvas_text_get_height (CanvasText* self)
{
	gdouble result;
	gdouble _tmp0_;
#line 67 "../src/CanvasText.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 68 "../src/CanvasText.vala"
	_tmp0_ = self->priv->_height;
#line 68 "../src/CanvasText.vala"
	result = _tmp0_;
#line 68 "../src/CanvasText.vala"
	return result;
#line 3908 "CanvasText.c"
}


gboolean
canvas_text_get_markup (CanvasText* self)
{
	gboolean result;
	gboolean _tmp0_;
#line 72 "../src/CanvasText.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 73 "../src/CanvasText.vala"
	_tmp0_ = self->priv->_markup;
#line 73 "../src/CanvasText.vala"
	result = _tmp0_;
#line 73 "../src/CanvasText.vala"
	return result;
#line 3925 "CanvasText.c"
}


void
canvas_text_set_markup (CanvasText* self,
                        gboolean value)
{
	gboolean _tmp0_;
#line 75 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 76 "../src/CanvasText.vala"
	_tmp0_ = self->priv->_markup;
#line 76 "../src/CanvasText.vala"
	if (_tmp0_ != value) {
#line 77 "../src/CanvasText.vala"
		self->priv->_markup = value;
#line 78 "../src/CanvasText.vala"
		canvas_text_update_size (self, TRUE);
#line 3944 "CanvasText.c"
	}
#line 75 "../src/CanvasText.vala"
	g_object_notify_by_pspec ((GObject *) self, canvas_text_properties[CANVAS_TEXT_MARKUP_PROPERTY]);
#line 3948 "CanvasText.c"
}


gboolean
canvas_text_get_edit (CanvasText* self)
{
	gboolean result;
	gboolean _tmp0_;
#line 83 "../src/CanvasText.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 84 "../src/CanvasText.vala"
	_tmp0_ = self->priv->_edit;
#line 84 "../src/CanvasText.vala"
	result = _tmp0_;
#line 84 "../src/CanvasText.vala"
	return result;
#line 3965 "CanvasText.c"
}


void
canvas_text_set_edit (CanvasText* self,
                      gboolean value)
{
	gboolean _tmp0_;
#line 86 "../src/CanvasText.vala"
	g_return_if_fail (self != NULL);
#line 87 "../src/CanvasText.vala"
	_tmp0_ = self->priv->_edit;
#line 87 "../src/CanvasText.vala"
	if (_tmp0_ != value) {
#line 88 "../src/CanvasText.vala"
		self->priv->_edit = value;
#line 89 "../src/CanvasText.vala"
		canvas_text_update_size (self, TRUE);
#line 3984 "CanvasText.c"
	}
#line 86 "../src/CanvasText.vala"
	g_object_notify_by_pspec ((GObject *) self, canvas_text_properties[CANVAS_TEXT_EDIT_PROPERTY]);
#line 3988 "CanvasText.c"
}


static void
canvas_text_class_init (CanvasTextClass * klass)
{
#line 28 "../src/CanvasText.vala"
	canvas_text_parent_class = g_type_class_peek_parent (klass);
#line 28 "../src/CanvasText.vala"
	g_type_class_adjust_private_offset (klass, &CanvasText_private_offset);
#line 28 "../src/CanvasText.vala"
	((CanvasTextClass *) klass)->load = (void (*) (CanvasText*, xmlNode*)) canvas_text_real_load;
#line 28 "../src/CanvasText.vala"
	((CanvasTextClass *) klass)->resize = (void (*) (CanvasText*, gdouble)) canvas_text_real_resize;
#line 28 "../src/CanvasText.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_canvas_text_get_property;
#line 28 "../src/CanvasText.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_canvas_text_set_property;
#line 28 "../src/CanvasText.vala"
	G_OBJECT_CLASS (klass)->finalize = canvas_text_finalize;
#line 28 "../src/CanvasText.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CANVAS_TEXT_TEXT_PROPERTY, canvas_text_properties[CANVAS_TEXT_TEXT_PROPERTY] = g_param_spec_string ("text", "text", "text", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 28 "../src/CanvasText.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CANVAS_TEXT_POSX_PROPERTY, canvas_text_properties[CANVAS_TEXT_POSX_PROPERTY] = g_param_spec_double ("posx", "posx", "posx", -G_MAXDOUBLE, G_MAXDOUBLE, (gdouble) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 28 "../src/CanvasText.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CANVAS_TEXT_POSY_PROPERTY, canvas_text_properties[CANVAS_TEXT_POSY_PROPERTY] = g_param_spec_double ("posy", "posy", "posy", -G_MAXDOUBLE, G_MAXDOUBLE, (gdouble) 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 28 "../src/CanvasText.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CANVAS_TEXT_WIDTH_PROPERTY, canvas_text_properties[CANVAS_TEXT_WIDTH_PROPERTY] = g_param_spec_double ("width", "width", "width", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 28 "../src/CanvasText.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CANVAS_TEXT_HEIGHT_PROPERTY, canvas_text_properties[CANVAS_TEXT_HEIGHT_PROPERTY] = g_param_spec_double ("height", "height", "height", -G_MAXDOUBLE, G_MAXDOUBLE, 0.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 28 "../src/CanvasText.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CANVAS_TEXT_MARKUP_PROPERTY, canvas_text_properties[CANVAS_TEXT_MARKUP_PROPERTY] = g_param_spec_boolean ("markup", "markup", "markup", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 28 "../src/CanvasText.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CANVAS_TEXT_EDIT_PROPERTY, canvas_text_properties[CANVAS_TEXT_EDIT_PROPERTY] = g_param_spec_boolean ("edit", "edit", "edit", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 28 "../src/CanvasText.vala"
	canvas_text_signals[CANVAS_TEXT_RESIZED_SIGNAL] = g_signal_new ("resized", TYPE_CANVAS_TEXT, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 4025 "CanvasText.c"
}


static void
canvas_text_instance_init (CanvasText * self)
{
	gchar* _tmp0_;
#line 28 "../src/CanvasText.vala"
	self->priv = canvas_text_get_instance_private (self);
#line 31 "../src/CanvasText.vala"
	_tmp0_ = g_strdup ("");
#line 31 "../src/CanvasText.vala"
	self->priv->_text = _tmp0_;
#line 32 "../src/CanvasText.vala"
	self->priv->_markup = TRUE;
#line 33 "../src/CanvasText.vala"
	self->priv->_edit = FALSE;
#line 34 "../src/CanvasText.vala"
	self->priv->_cursor = 0;
#line 35 "../src/CanvasText.vala"
	self->priv->_column = 0;
#line 36 "../src/CanvasText.vala"
	self->priv->_pango_layout = NULL;
#line 37 "../src/CanvasText.vala"
	self->priv->_selstart = 0;
#line 38 "../src/CanvasText.vala"
	self->priv->_selend = 0;
#line 39 "../src/CanvasText.vala"
	self->priv->_selanchor = 0;
#line 40 "../src/CanvasText.vala"
	self->priv->_max_width = (gdouble) 200;
#line 41 "../src/CanvasText.vala"
	self->priv->_width = (gdouble) 0;
#line 42 "../src/CanvasText.vala"
	self->priv->_height = (gdouble) 0;
#line 59 "../src/CanvasText.vala"
	self->priv->_posx = (gdouble) 0;
#line 60 "../src/CanvasText.vala"
	self->priv->_posy = (gdouble) 0;
#line 4065 "CanvasText.c"
}


static void
canvas_text_finalize (GObject * obj)
{
	CanvasText * self;
#line 28 "../src/CanvasText.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CANVAS_TEXT, CanvasText);
#line 31 "../src/CanvasText.vala"
	_g_free0 (self->priv->_text);
#line 36 "../src/CanvasText.vala"
	_g_object_unref0 (self->priv->_pango_layout);
#line 28 "../src/CanvasText.vala"
	G_OBJECT_CLASS (canvas_text_parent_class)->finalize (obj);
#line 4081 "CanvasText.c"
}


GType
canvas_text_get_type (void)
{
	static volatile gsize canvas_text_type_id__volatile = 0;
	if (g_once_init_enter (&canvas_text_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (CanvasTextClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) canvas_text_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (CanvasText), 0, (GInstanceInitFunc) canvas_text_instance_init, NULL };
		GType canvas_text_type_id;
		canvas_text_type_id = g_type_register_static (G_TYPE_OBJECT, "CanvasText", &g_define_type_info, 0);
		CanvasText_private_offset = g_type_add_instance_private (canvas_text_type_id, sizeof (CanvasTextPrivate));
		g_once_init_leave (&canvas_text_type_id__volatile, canvas_text_type_id);
	}
	return canvas_text_type_id__volatile;
}


static void
_vala_canvas_text_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	CanvasText * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CANVAS_TEXT, CanvasText);
#line 28 "../src/CanvasText.vala"
	switch (property_id) {
#line 28 "../src/CanvasText.vala"
		case CANVAS_TEXT_TEXT_PROPERTY:
#line 28 "../src/CanvasText.vala"
		g_value_set_string (value, canvas_text_get_text (self));
#line 28 "../src/CanvasText.vala"
		break;
#line 28 "../src/CanvasText.vala"
		case CANVAS_TEXT_POSX_PROPERTY:
#line 28 "../src/CanvasText.vala"
		g_value_set_double (value, canvas_text_get_posx (self));
#line 28 "../src/CanvasText.vala"
		break;
#line 28 "../src/CanvasText.vala"
		case CANVAS_TEXT_POSY_PROPERTY:
#line 28 "../src/CanvasText.vala"
		g_value_set_double (value, canvas_text_get_posy (self));
#line 28 "../src/CanvasText.vala"
		break;
#line 28 "../src/CanvasText.vala"
		case CANVAS_TEXT_WIDTH_PROPERTY:
#line 28 "../src/CanvasText.vala"
		g_value_set_double (value, canvas_text_get_width (self));
#line 28 "../src/CanvasText.vala"
		break;
#line 28 "../src/CanvasText.vala"
		case CANVAS_TEXT_HEIGHT_PROPERTY:
#line 28 "../src/CanvasText.vala"
		g_value_set_double (value, canvas_text_get_height (self));
#line 28 "../src/CanvasText.vala"
		break;
#line 28 "../src/CanvasText.vala"
		case CANVAS_TEXT_MARKUP_PROPERTY:
#line 28 "../src/CanvasText.vala"
		g_value_set_boolean (value, canvas_text_get_markup (self));
#line 28 "../src/CanvasText.vala"
		break;
#line 28 "../src/CanvasText.vala"
		case CANVAS_TEXT_EDIT_PROPERTY:
#line 28 "../src/CanvasText.vala"
		g_value_set_boolean (value, canvas_text_get_edit (self));
#line 28 "../src/CanvasText.vala"
		break;
#line 4152 "CanvasText.c"
		default:
#line 28 "../src/CanvasText.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 28 "../src/CanvasText.vala"
		break;
#line 4158 "CanvasText.c"
	}
}


static void
_vala_canvas_text_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec)
{
	CanvasText * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CANVAS_TEXT, CanvasText);
#line 28 "../src/CanvasText.vala"
	switch (property_id) {
#line 28 "../src/CanvasText.vala"
		case CANVAS_TEXT_TEXT_PROPERTY:
#line 28 "../src/CanvasText.vala"
		canvas_text_set_text (self, g_value_get_string (value));
#line 28 "../src/CanvasText.vala"
		break;
#line 28 "../src/CanvasText.vala"
		case CANVAS_TEXT_POSX_PROPERTY:
#line 28 "../src/CanvasText.vala"
		canvas_text_set_posx (self, g_value_get_double (value));
#line 28 "../src/CanvasText.vala"
		break;
#line 28 "../src/CanvasText.vala"
		case CANVAS_TEXT_POSY_PROPERTY:
#line 28 "../src/CanvasText.vala"
		canvas_text_set_posy (self, g_value_get_double (value));
#line 28 "../src/CanvasText.vala"
		break;
#line 28 "../src/CanvasText.vala"
		case CANVAS_TEXT_MARKUP_PROPERTY:
#line 28 "../src/CanvasText.vala"
		canvas_text_set_markup (self, g_value_get_boolean (value));
#line 28 "../src/CanvasText.vala"
		break;
#line 28 "../src/CanvasText.vala"
		case CANVAS_TEXT_EDIT_PROPERTY:
#line 28 "../src/CanvasText.vala"
		canvas_text_set_edit (self, g_value_get_boolean (value));
#line 28 "../src/CanvasText.vala"
		break;
#line 4203 "CanvasText.c"
		default:
#line 28 "../src/CanvasText.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 28 "../src/CanvasText.vala"
		break;
#line 4209 "CanvasText.c"
	}
}



