/* ConnectionMenu.c generated by valac 0.42.7, the Vala compiler
 * generated from ConnectionMenu.vala, do not modify */

/*
* Copyright (c) 2018 (https://github.com/phase1geo/Minder)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Trevor Williams <phase1geo@gmail.com>
*/


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <glib/gi18n-lib.h>
#include <gdk/gdk.h>
#include <stdlib.h>
#include <string.h>


#define TYPE_CONNECTION_MENU (connection_menu_get_type ())
#define CONNECTION_MENU(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CONNECTION_MENU, ConnectionMenu))
#define CONNECTION_MENU_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CONNECTION_MENU, ConnectionMenuClass))
#define IS_CONNECTION_MENU(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CONNECTION_MENU))
#define IS_CONNECTION_MENU_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CONNECTION_MENU))
#define CONNECTION_MENU_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CONNECTION_MENU, ConnectionMenuClass))

typedef struct _ConnectionMenu ConnectionMenu;
typedef struct _ConnectionMenuClass ConnectionMenuClass;
typedef struct _ConnectionMenuPrivate ConnectionMenuPrivate;

#define TYPE_DRAW_AREA (draw_area_get_type ())
#define DRAW_AREA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DRAW_AREA, DrawArea))
#define DRAW_AREA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DRAW_AREA, DrawAreaClass))
#define IS_DRAW_AREA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DRAW_AREA))
#define IS_DRAW_AREA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DRAW_AREA))
#define DRAW_AREA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DRAW_AREA, DrawAreaClass))

typedef struct _DrawArea DrawArea;
typedef struct _DrawAreaClass DrawAreaClass;
enum  {
	CONNECTION_MENU_0_PROPERTY,
	CONNECTION_MENU_NUM_PROPERTIES
};
static GParamSpec* connection_menu_properties[CONNECTION_MENU_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_CONNECTION (connection_get_type ())
#define CONNECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CONNECTION, Connection))
#define CONNECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CONNECTION, ConnectionClass))
#define IS_CONNECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CONNECTION))
#define IS_CONNECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CONNECTION))
#define CONNECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CONNECTION, ConnectionClass))

typedef struct _Connection Connection;
typedef struct _ConnectionClass ConnectionClass;

#define TYPE_CANVAS_TEXT (canvas_text_get_type ())
#define CANVAS_TEXT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CANVAS_TEXT, CanvasText))
#define CANVAS_TEXT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CANVAS_TEXT, CanvasTextClass))
#define IS_CANVAS_TEXT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CANVAS_TEXT))
#define IS_CANVAS_TEXT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CANVAS_TEXT))
#define CANVAS_TEXT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CANVAS_TEXT, CanvasTextClass))

typedef struct _CanvasText CanvasText;
typedef struct _CanvasTextClass CanvasTextClass;
typedef enum  {
	CONN_MODE_NONE = 0,
	CONN_MODE_LINKING,
	CONN_MODE_CONNECTING,
	CONN_MODE_SELECTED,
	CONN_MODE_ADJUSTING,
	CONN_MODE_EDITABLE
} ConnMode;


#define TYPE_CONN_MODE (conn_mode_get_type ())

struct _ConnectionMenu {
	GtkMenu parent_instance;
	ConnectionMenuPrivate * priv;
};

struct _ConnectionMenuClass {
	GtkMenuClass parent_class;
};

struct _ConnectionMenuPrivate {
	DrawArea* _da;
	GtkMenuItem* _delete;
	GtkMenuItem* _edit;
	GtkMenuItem* _note;
	GtkMenuItem* _selstart;
	GtkMenuItem* _selend;
	GtkMenuItem* _selnext;
	GtkMenuItem* _selprev;
};


static gint ConnectionMenu_private_offset;
static gpointer connection_menu_parent_class = NULL;

GType connection_menu_get_type (void) G_GNUC_CONST;
GType draw_area_get_type (void) G_GNUC_CONST;
ConnectionMenu* connection_menu_new (DrawArea* da,
                                     GtkAccelGroup* accel_group);
ConnectionMenu* connection_menu_construct (GType object_type,
                                           DrawArea* da,
                                           GtkAccelGroup* accel_group);
static void connection_menu_delete_connection (ConnectionMenu* self);
static void _connection_menu_delete_connection_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                gpointer self);
void utils_add_accel_label (GtkMenuItem* item,
                            guint key,
                            GdkModifierType mods);
static void connection_menu_edit_title (ConnectionMenu* self);
static void _connection_menu_edit_title_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                         gpointer self);
static void connection_menu_change_note (ConnectionMenu* self);
static void _connection_menu_change_note_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                          gpointer self);
static void connection_menu_select_start_node (ConnectionMenu* self);
static void _connection_menu_select_start_node_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                gpointer self);
static void connection_menu_select_end_node (ConnectionMenu* self);
static void _connection_menu_select_end_node_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                              gpointer self);
static void connection_menu_select_next_connection (ConnectionMenu* self);
static void _connection_menu_select_next_connection_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                     gpointer self);
static void connection_menu_select_prev_connection (ConnectionMenu* self);
static void _connection_menu_select_prev_connection_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                     gpointer self);
static void connection_menu_on_popup (ConnectionMenu* self);
static void _connection_menu_on_popup_gtk_widget_show (GtkWidget* _sender,
                                                gpointer self);
static gboolean connection_menu_connection_has_note (ConnectionMenu* self);
GType connection_get_type (void) G_GNUC_CONST;
Connection* draw_area_get_current_connection (DrawArea* self);
const gchar* connection_get_note (Connection* self);
void draw_area_delete_connection (DrawArea* self);
GType canvas_text_get_type (void) G_GNUC_CONST;
CanvasText* connection_get_title (Connection* self);
void connection_change_title (Connection* self,
                              DrawArea* da,
                              const gchar* title,
                              gboolean allow_empty);
GType conn_mode_get_type (void) G_GNUC_CONST;
void connection_set_mode (Connection* self,
                          ConnMode value);
void draw_area_change_current_connection_note (DrawArea* self,
                                               const gchar* note);
void draw_area_select_connection_node (DrawArea* self,
                                       gboolean start);
void draw_area_select_connection (DrawArea* self,
                                  gint dir);
static void connection_menu_finalize (GObject * obj);


static inline gpointer
connection_menu_get_instance_private (ConnectionMenu* self)
{
	return G_STRUCT_MEMBER_P (self, ConnectionMenu_private_offset);
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 38 "../src/ConnectionMenu.vala"
	return self ? g_object_ref (self) : NULL;
#line 187 "ConnectionMenu.c"
}


static void
_connection_menu_delete_connection_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                           gpointer self)
{
#line 41 "../src/ConnectionMenu.vala"
	connection_menu_delete_connection ((ConnectionMenu*) self);
#line 197 "ConnectionMenu.c"
}


static void
_connection_menu_edit_title_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                    gpointer self)
{
#line 45 "../src/ConnectionMenu.vala"
	connection_menu_edit_title ((ConnectionMenu*) self);
#line 207 "ConnectionMenu.c"
}


static void
_connection_menu_change_note_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                     gpointer self)
{
#line 49 "../src/ConnectionMenu.vala"
	connection_menu_change_note ((ConnectionMenu*) self);
#line 217 "ConnectionMenu.c"
}


static void
_connection_menu_select_start_node_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                           gpointer self)
{
#line 56 "../src/ConnectionMenu.vala"
	connection_menu_select_start_node ((ConnectionMenu*) self);
#line 227 "ConnectionMenu.c"
}


static void
_connection_menu_select_end_node_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                         gpointer self)
{
#line 60 "../src/ConnectionMenu.vala"
	connection_menu_select_end_node ((ConnectionMenu*) self);
#line 237 "ConnectionMenu.c"
}


static void
_connection_menu_select_next_connection_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                gpointer self)
{
#line 64 "../src/ConnectionMenu.vala"
	connection_menu_select_next_connection ((ConnectionMenu*) self);
#line 247 "ConnectionMenu.c"
}


static void
_connection_menu_select_prev_connection_gtk_menu_item_activate (GtkMenuItem* _sender,
                                                                gpointer self)
{
#line 68 "../src/ConnectionMenu.vala"
	connection_menu_select_prev_connection ((ConnectionMenu*) self);
#line 257 "ConnectionMenu.c"
}


static void
_connection_menu_on_popup_gtk_widget_show (GtkWidget* _sender,
                                           gpointer self)
{
#line 90 "../src/ConnectionMenu.vala"
	connection_menu_on_popup ((ConnectionMenu*) self);
#line 267 "ConnectionMenu.c"
}


ConnectionMenu*
connection_menu_construct (GType object_type,
                           DrawArea* da,
                           GtkAccelGroup* accel_group)
{
	ConnectionMenu * self = NULL;
	DrawArea* _tmp0_;
	GtkMenuItem* _tmp1_;
	GtkMenuItem* _tmp2_;
	GtkMenuItem* _tmp3_;
	GtkMenuItem* _tmp4_;
	GtkMenuItem* _tmp5_;
	GtkMenuItem* _tmp6_;
	GtkMenuItem* _tmp7_;
	GtkMenuItem* _tmp8_;
	GtkMenuItem* selnode = NULL;
	GtkMenuItem* _tmp9_;
	GtkMenu* selmenu = NULL;
	GtkMenu* _tmp10_;
	GtkMenuItem* _tmp11_;
	GtkMenuItem* _tmp12_;
	GtkMenuItem* _tmp13_;
	GtkMenuItem* _tmp14_;
	GtkMenuItem* _tmp15_;
	GtkMenuItem* _tmp16_;
	GtkMenuItem* _tmp17_;
	GtkMenuItem* _tmp18_;
	GtkMenuItem* _tmp19_;
	GtkMenuItem* _tmp20_;
	GtkMenuItem* _tmp21_;
	GtkMenuItem* _tmp22_;
	GtkMenuItem* _tmp23_;
	GtkSeparatorMenuItem* _tmp24_;
	GtkSeparatorMenuItem* _tmp25_;
	GtkMenuItem* _tmp26_;
	GtkMenuItem* _tmp27_;
	GtkSeparatorMenuItem* _tmp28_;
	GtkSeparatorMenuItem* _tmp29_;
	GtkMenuItem* _tmp30_;
	GtkMenuItem* _tmp31_;
	GtkSeparatorMenuItem* _tmp32_;
	GtkSeparatorMenuItem* _tmp33_;
	GtkMenuItem* _tmp34_;
	GtkMenuItem* _tmp35_;
#line 36 "../src/ConnectionMenu.vala"
	g_return_val_if_fail (da != NULL, NULL);
#line 36 "../src/ConnectionMenu.vala"
	g_return_val_if_fail (accel_group != NULL, NULL);
#line 36 "../src/ConnectionMenu.vala"
	self = (ConnectionMenu*) g_object_new (object_type, NULL);
#line 38 "../src/ConnectionMenu.vala"
	_tmp0_ = _g_object_ref0 (da);
#line 38 "../src/ConnectionMenu.vala"
	_g_object_unref0 (self->priv->_da);
#line 38 "../src/ConnectionMenu.vala"
	self->priv->_da = _tmp0_;
#line 40 "../src/ConnectionMenu.vala"
	_tmp1_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Delete"));
#line 40 "../src/ConnectionMenu.vala"
	g_object_ref_sink (_tmp1_);
#line 40 "../src/ConnectionMenu.vala"
	_g_object_unref0 (self->priv->_delete);
#line 40 "../src/ConnectionMenu.vala"
	self->priv->_delete = _tmp1_;
#line 41 "../src/ConnectionMenu.vala"
	_tmp2_ = self->priv->_delete;
#line 41 "../src/ConnectionMenu.vala"
	g_signal_connect_object (_tmp2_, "activate", (GCallback) _connection_menu_delete_connection_gtk_menu_item_activate, self, 0);
#line 42 "../src/ConnectionMenu.vala"
	_tmp3_ = self->priv->_delete;
#line 42 "../src/ConnectionMenu.vala"
	utils_add_accel_label (_tmp3_, (guint) 65535, 0);
#line 44 "../src/ConnectionMenu.vala"
	_tmp4_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Edit…"));
#line 44 "../src/ConnectionMenu.vala"
	g_object_ref_sink (_tmp4_);
#line 44 "../src/ConnectionMenu.vala"
	_g_object_unref0 (self->priv->_edit);
#line 44 "../src/ConnectionMenu.vala"
	self->priv->_edit = _tmp4_;
#line 45 "../src/ConnectionMenu.vala"
	_tmp5_ = self->priv->_edit;
#line 45 "../src/ConnectionMenu.vala"
	g_signal_connect_object (_tmp5_, "activate", (GCallback) _connection_menu_edit_title_gtk_menu_item_activate, self, 0);
#line 46 "../src/ConnectionMenu.vala"
	_tmp6_ = self->priv->_edit;
#line 46 "../src/ConnectionMenu.vala"
	utils_add_accel_label (_tmp6_, (guint) 'e', 0);
#line 48 "../src/ConnectionMenu.vala"
	_tmp7_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Add Note"));
#line 48 "../src/ConnectionMenu.vala"
	g_object_ref_sink (_tmp7_);
#line 48 "../src/ConnectionMenu.vala"
	_g_object_unref0 (self->priv->_note);
#line 48 "../src/ConnectionMenu.vala"
	self->priv->_note = _tmp7_;
#line 49 "../src/ConnectionMenu.vala"
	_tmp8_ = self->priv->_note;
#line 49 "../src/ConnectionMenu.vala"
	g_signal_connect_object (_tmp8_, "activate", (GCallback) _connection_menu_change_note_gtk_menu_item_activate, self, 0);
#line 51 "../src/ConnectionMenu.vala"
	_tmp9_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Select"));
#line 51 "../src/ConnectionMenu.vala"
	g_object_ref_sink (_tmp9_);
#line 51 "../src/ConnectionMenu.vala"
	selnode = _tmp9_;
#line 52 "../src/ConnectionMenu.vala"
	_tmp10_ = (GtkMenu*) gtk_menu_new ();
#line 52 "../src/ConnectionMenu.vala"
	g_object_ref_sink (_tmp10_);
#line 52 "../src/ConnectionMenu.vala"
	selmenu = _tmp10_;
#line 53 "../src/ConnectionMenu.vala"
	gtk_menu_item_set_submenu (selnode, selmenu);
#line 55 "../src/ConnectionMenu.vala"
	_tmp11_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Start Node"));
#line 55 "../src/ConnectionMenu.vala"
	g_object_ref_sink (_tmp11_);
#line 55 "../src/ConnectionMenu.vala"
	_g_object_unref0 (self->priv->_selstart);
#line 55 "../src/ConnectionMenu.vala"
	self->priv->_selstart = _tmp11_;
#line 56 "../src/ConnectionMenu.vala"
	_tmp12_ = self->priv->_selstart;
#line 56 "../src/ConnectionMenu.vala"
	g_signal_connect_object (_tmp12_, "activate", (GCallback) _connection_menu_select_start_node_gtk_menu_item_activate, self, 0);
#line 57 "../src/ConnectionMenu.vala"
	_tmp13_ = self->priv->_selstart;
#line 57 "../src/ConnectionMenu.vala"
	utils_add_accel_label (_tmp13_, (guint) 'f', 0);
#line 59 "../src/ConnectionMenu.vala"
	_tmp14_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("End Node"));
#line 59 "../src/ConnectionMenu.vala"
	g_object_ref_sink (_tmp14_);
#line 59 "../src/ConnectionMenu.vala"
	_g_object_unref0 (self->priv->_selend);
#line 59 "../src/ConnectionMenu.vala"
	self->priv->_selend = _tmp14_;
#line 60 "../src/ConnectionMenu.vala"
	_tmp15_ = self->priv->_selend;
#line 60 "../src/ConnectionMenu.vala"
	g_signal_connect_object (_tmp15_, "activate", (GCallback) _connection_menu_select_end_node_gtk_menu_item_activate, self, 0);
#line 61 "../src/ConnectionMenu.vala"
	_tmp16_ = self->priv->_selend;
#line 61 "../src/ConnectionMenu.vala"
	utils_add_accel_label (_tmp16_, (guint) 't', 0);
#line 63 "../src/ConnectionMenu.vala"
	_tmp17_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Next Connection"));
#line 63 "../src/ConnectionMenu.vala"
	g_object_ref_sink (_tmp17_);
#line 63 "../src/ConnectionMenu.vala"
	_g_object_unref0 (self->priv->_selnext);
#line 63 "../src/ConnectionMenu.vala"
	self->priv->_selnext = _tmp17_;
#line 64 "../src/ConnectionMenu.vala"
	_tmp18_ = self->priv->_selnext;
#line 64 "../src/ConnectionMenu.vala"
	g_signal_connect_object (_tmp18_, "activate", (GCallback) _connection_menu_select_next_connection_gtk_menu_item_activate, self, 0);
#line 65 "../src/ConnectionMenu.vala"
	_tmp19_ = self->priv->_selnext;
#line 65 "../src/ConnectionMenu.vala"
	utils_add_accel_label (_tmp19_, (guint) 65363, 0);
#line 67 "../src/ConnectionMenu.vala"
	_tmp20_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Previous Connection"));
#line 67 "../src/ConnectionMenu.vala"
	g_object_ref_sink (_tmp20_);
#line 67 "../src/ConnectionMenu.vala"
	_g_object_unref0 (self->priv->_selprev);
#line 67 "../src/ConnectionMenu.vala"
	self->priv->_selprev = _tmp20_;
#line 68 "../src/ConnectionMenu.vala"
	_tmp21_ = self->priv->_selprev;
#line 68 "../src/ConnectionMenu.vala"
	g_signal_connect_object (_tmp21_, "activate", (GCallback) _connection_menu_select_prev_connection_gtk_menu_item_activate, self, 0);
#line 69 "../src/ConnectionMenu.vala"
	_tmp22_ = self->priv->_selprev;
#line 69 "../src/ConnectionMenu.vala"
	utils_add_accel_label (_tmp22_, (guint) 65361, 0);
#line 72 "../src/ConnectionMenu.vala"
	_tmp23_ = self->priv->_delete;
#line 72 "../src/ConnectionMenu.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp23_);
#line 73 "../src/ConnectionMenu.vala"
	_tmp24_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 73 "../src/ConnectionMenu.vala"
	g_object_ref_sink (_tmp24_);
#line 73 "../src/ConnectionMenu.vala"
	_tmp25_ = _tmp24_;
#line 73 "../src/ConnectionMenu.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp25_);
#line 73 "../src/ConnectionMenu.vala"
	_g_object_unref0 (_tmp25_);
#line 74 "../src/ConnectionMenu.vala"
	_tmp26_ = self->priv->_edit;
#line 74 "../src/ConnectionMenu.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp26_);
#line 75 "../src/ConnectionMenu.vala"
	_tmp27_ = self->priv->_note;
#line 75 "../src/ConnectionMenu.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp27_);
#line 76 "../src/ConnectionMenu.vala"
	_tmp28_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 76 "../src/ConnectionMenu.vala"
	g_object_ref_sink (_tmp28_);
#line 76 "../src/ConnectionMenu.vala"
	_tmp29_ = _tmp28_;
#line 76 "../src/ConnectionMenu.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp29_);
#line 76 "../src/ConnectionMenu.vala"
	_g_object_unref0 (_tmp29_);
#line 77 "../src/ConnectionMenu.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) selnode);
#line 80 "../src/ConnectionMenu.vala"
	_tmp30_ = self->priv->_selstart;
#line 80 "../src/ConnectionMenu.vala"
	gtk_container_add ((GtkContainer*) selmenu, (GtkWidget*) _tmp30_);
#line 81 "../src/ConnectionMenu.vala"
	_tmp31_ = self->priv->_selend;
#line 81 "../src/ConnectionMenu.vala"
	gtk_container_add ((GtkContainer*) selmenu, (GtkWidget*) _tmp31_);
#line 82 "../src/ConnectionMenu.vala"
	_tmp32_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 82 "../src/ConnectionMenu.vala"
	g_object_ref_sink (_tmp32_);
#line 82 "../src/ConnectionMenu.vala"
	_tmp33_ = _tmp32_;
#line 82 "../src/ConnectionMenu.vala"
	gtk_container_add ((GtkContainer*) selmenu, (GtkWidget*) _tmp33_);
#line 82 "../src/ConnectionMenu.vala"
	_g_object_unref0 (_tmp33_);
#line 83 "../src/ConnectionMenu.vala"
	_tmp34_ = self->priv->_selnext;
#line 83 "../src/ConnectionMenu.vala"
	gtk_container_add ((GtkContainer*) selmenu, (GtkWidget*) _tmp34_);
#line 84 "../src/ConnectionMenu.vala"
	_tmp35_ = self->priv->_selprev;
#line 84 "../src/ConnectionMenu.vala"
	gtk_container_add ((GtkContainer*) selmenu, (GtkWidget*) _tmp35_);
#line 87 "../src/ConnectionMenu.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 90 "../src/ConnectionMenu.vala"
	g_signal_connect_object ((GtkWidget*) self, "show", (GCallback) _connection_menu_on_popup_gtk_widget_show, self, 0);
#line 36 "../src/ConnectionMenu.vala"
	_g_object_unref0 (selmenu);
#line 36 "../src/ConnectionMenu.vala"
	_g_object_unref0 (selnode);
#line 36 "../src/ConnectionMenu.vala"
	return self;
#line 519 "ConnectionMenu.c"
}


ConnectionMenu*
connection_menu_new (DrawArea* da,
                     GtkAccelGroup* accel_group)
{
#line 36 "../src/ConnectionMenu.vala"
	return connection_menu_construct (TYPE_CONNECTION_MENU, da, accel_group);
#line 529 "ConnectionMenu.c"
}


static gboolean
connection_menu_connection_has_note (ConnectionMenu* self)
{
	gboolean result = FALSE;
	Connection* current = NULL;
	DrawArea* _tmp0_;
	Connection* _tmp1_;
	gboolean _tmp2_ = FALSE;
	Connection* _tmp3_;
#line 95 "../src/ConnectionMenu.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 96 "../src/ConnectionMenu.vala"
	_tmp0_ = self->priv->_da;
#line 96 "../src/ConnectionMenu.vala"
	_tmp1_ = draw_area_get_current_connection (_tmp0_);
#line 96 "../src/ConnectionMenu.vala"
	current = _tmp1_;
#line 97 "../src/ConnectionMenu.vala"
	_tmp3_ = current;
#line 97 "../src/ConnectionMenu.vala"
	if (_tmp3_ != NULL) {
#line 554 "ConnectionMenu.c"
		Connection* _tmp4_;
		const gchar* _tmp5_;
		const gchar* _tmp6_;
#line 97 "../src/ConnectionMenu.vala"
		_tmp4_ = current;
#line 97 "../src/ConnectionMenu.vala"
		_tmp5_ = connection_get_note (_tmp4_);
#line 97 "../src/ConnectionMenu.vala"
		_tmp6_ = _tmp5_;
#line 97 "../src/ConnectionMenu.vala"
		_tmp2_ = g_strcmp0 (_tmp6_, "") != 0;
#line 566 "ConnectionMenu.c"
	} else {
#line 97 "../src/ConnectionMenu.vala"
		_tmp2_ = FALSE;
#line 570 "ConnectionMenu.c"
	}
#line 97 "../src/ConnectionMenu.vala"
	result = _tmp2_;
#line 97 "../src/ConnectionMenu.vala"
	_g_object_unref0 (current);
#line 97 "../src/ConnectionMenu.vala"
	return result;
#line 578 "ConnectionMenu.c"
}


static void
connection_menu_on_popup (ConnectionMenu* self)
{
	const gchar* _tmp0_ = NULL;
	GtkMenuItem* _tmp1_;
#line 101 "../src/ConnectionMenu.vala"
	g_return_if_fail (self != NULL);
#line 104 "../src/ConnectionMenu.vala"
	if (connection_menu_connection_has_note (self)) {
#line 104 "../src/ConnectionMenu.vala"
		_tmp0_ = _ ("Remove Note");
#line 593 "ConnectionMenu.c"
	} else {
#line 104 "../src/ConnectionMenu.vala"
		_tmp0_ = _ ("Add Note");
#line 597 "ConnectionMenu.c"
	}
#line 104 "../src/ConnectionMenu.vala"
	_tmp1_ = self->priv->_note;
#line 104 "../src/ConnectionMenu.vala"
	gtk_menu_item_set_label (_tmp1_, _tmp0_);
#line 603 "ConnectionMenu.c"
}


static void
connection_menu_delete_connection (ConnectionMenu* self)
{
	DrawArea* _tmp0_;
#line 109 "../src/ConnectionMenu.vala"
	g_return_if_fail (self != NULL);
#line 110 "../src/ConnectionMenu.vala"
	_tmp0_ = self->priv->_da;
#line 110 "../src/ConnectionMenu.vala"
	draw_area_delete_connection (_tmp0_);
#line 617 "ConnectionMenu.c"
}


static void
connection_menu_edit_title (ConnectionMenu* self)
{
	Connection* conn = NULL;
	DrawArea* _tmp0_;
	Connection* _tmp1_;
	Connection* _tmp2_;
	CanvasText* _tmp3_;
	CanvasText* _tmp4_;
	Connection* _tmp7_;
#line 114 "../src/ConnectionMenu.vala"
	g_return_if_fail (self != NULL);
#line 115 "../src/ConnectionMenu.vala"
	_tmp0_ = self->priv->_da;
#line 115 "../src/ConnectionMenu.vala"
	_tmp1_ = draw_area_get_current_connection (_tmp0_);
#line 115 "../src/ConnectionMenu.vala"
	conn = _tmp1_;
#line 116 "../src/ConnectionMenu.vala"
	_tmp2_ = conn;
#line 116 "../src/ConnectionMenu.vala"
	_tmp3_ = connection_get_title (_tmp2_);
#line 116 "../src/ConnectionMenu.vala"
	_tmp4_ = _tmp3_;
#line 116 "../src/ConnectionMenu.vala"
	if (_tmp4_ == NULL) {
#line 647 "ConnectionMenu.c"
		Connection* _tmp5_;
		DrawArea* _tmp6_;
#line 117 "../src/ConnectionMenu.vala"
		_tmp5_ = conn;
#line 117 "../src/ConnectionMenu.vala"
		_tmp6_ = self->priv->_da;
#line 117 "../src/ConnectionMenu.vala"
		connection_change_title (_tmp5_, _tmp6_, "", TRUE);
#line 656 "ConnectionMenu.c"
	}
#line 119 "../src/ConnectionMenu.vala"
	_tmp7_ = conn;
#line 119 "../src/ConnectionMenu.vala"
	connection_set_mode (_tmp7_, CONN_MODE_EDITABLE);
#line 114 "../src/ConnectionMenu.vala"
	_g_object_unref0 (conn);
#line 664 "ConnectionMenu.c"
}


static void
connection_menu_change_note (ConnectionMenu* self)
{
	DrawArea* _tmp2_;
	DrawArea* _tmp3_;
#line 123 "../src/ConnectionMenu.vala"
	g_return_if_fail (self != NULL);
#line 124 "../src/ConnectionMenu.vala"
	if (connection_menu_connection_has_note (self)) {
#line 677 "ConnectionMenu.c"
		DrawArea* _tmp0_;
#line 125 "../src/ConnectionMenu.vala"
		_tmp0_ = self->priv->_da;
#line 125 "../src/ConnectionMenu.vala"
		draw_area_change_current_connection_note (_tmp0_, "");
#line 683 "ConnectionMenu.c"
	} else {
		DrawArea* _tmp1_;
#line 127 "../src/ConnectionMenu.vala"
		_tmp1_ = self->priv->_da;
#line 127 "../src/ConnectionMenu.vala"
		g_signal_emit_by_name (_tmp1_, "show-properties", "current", TRUE);
#line 690 "ConnectionMenu.c"
	}
#line 129 "../src/ConnectionMenu.vala"
	_tmp2_ = self->priv->_da;
#line 129 "../src/ConnectionMenu.vala"
	_tmp3_ = self->priv->_da;
#line 129 "../src/ConnectionMenu.vala"
	g_signal_emit_by_name (_tmp2_, "current-changed", _tmp3_);
#line 698 "ConnectionMenu.c"
}


static void
connection_menu_select_start_node (ConnectionMenu* self)
{
	DrawArea* _tmp0_;
#line 133 "../src/ConnectionMenu.vala"
	g_return_if_fail (self != NULL);
#line 134 "../src/ConnectionMenu.vala"
	_tmp0_ = self->priv->_da;
#line 134 "../src/ConnectionMenu.vala"
	draw_area_select_connection_node (_tmp0_, TRUE);
#line 712 "ConnectionMenu.c"
}


static void
connection_menu_select_end_node (ConnectionMenu* self)
{
	DrawArea* _tmp0_;
#line 138 "../src/ConnectionMenu.vala"
	g_return_if_fail (self != NULL);
#line 139 "../src/ConnectionMenu.vala"
	_tmp0_ = self->priv->_da;
#line 139 "../src/ConnectionMenu.vala"
	draw_area_select_connection_node (_tmp0_, FALSE);
#line 726 "ConnectionMenu.c"
}


static void
connection_menu_select_next_connection (ConnectionMenu* self)
{
	DrawArea* _tmp0_;
#line 143 "../src/ConnectionMenu.vala"
	g_return_if_fail (self != NULL);
#line 144 "../src/ConnectionMenu.vala"
	_tmp0_ = self->priv->_da;
#line 144 "../src/ConnectionMenu.vala"
	draw_area_select_connection (_tmp0_, 1);
#line 740 "ConnectionMenu.c"
}


static void
connection_menu_select_prev_connection (ConnectionMenu* self)
{
	DrawArea* _tmp0_;
#line 148 "../src/ConnectionMenu.vala"
	g_return_if_fail (self != NULL);
#line 149 "../src/ConnectionMenu.vala"
	_tmp0_ = self->priv->_da;
#line 149 "../src/ConnectionMenu.vala"
	draw_area_select_connection (_tmp0_, -1);
#line 754 "ConnectionMenu.c"
}


static void
connection_menu_class_init (ConnectionMenuClass * klass)
{
#line 24 "../src/ConnectionMenu.vala"
	connection_menu_parent_class = g_type_class_peek_parent (klass);
#line 24 "../src/ConnectionMenu.vala"
	g_type_class_adjust_private_offset (klass, &ConnectionMenu_private_offset);
#line 24 "../src/ConnectionMenu.vala"
	G_OBJECT_CLASS (klass)->finalize = connection_menu_finalize;
#line 767 "ConnectionMenu.c"
}


static void
connection_menu_instance_init (ConnectionMenu * self)
{
#line 24 "../src/ConnectionMenu.vala"
	self->priv = connection_menu_get_instance_private (self);
#line 776 "ConnectionMenu.c"
}


static void
connection_menu_finalize (GObject * obj)
{
	ConnectionMenu * self;
#line 24 "../src/ConnectionMenu.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CONNECTION_MENU, ConnectionMenu);
#line 26 "../src/ConnectionMenu.vala"
	_g_object_unref0 (self->priv->_da);
#line 27 "../src/ConnectionMenu.vala"
	_g_object_unref0 (self->priv->_delete);
#line 28 "../src/ConnectionMenu.vala"
	_g_object_unref0 (self->priv->_edit);
#line 29 "../src/ConnectionMenu.vala"
	_g_object_unref0 (self->priv->_note);
#line 30 "../src/ConnectionMenu.vala"
	_g_object_unref0 (self->priv->_selstart);
#line 31 "../src/ConnectionMenu.vala"
	_g_object_unref0 (self->priv->_selend);
#line 32 "../src/ConnectionMenu.vala"
	_g_object_unref0 (self->priv->_selnext);
#line 33 "../src/ConnectionMenu.vala"
	_g_object_unref0 (self->priv->_selprev);
#line 24 "../src/ConnectionMenu.vala"
	G_OBJECT_CLASS (connection_menu_parent_class)->finalize (obj);
#line 804 "ConnectionMenu.c"
}


GType
connection_menu_get_type (void)
{
	static volatile gsize connection_menu_type_id__volatile = 0;
	if (g_once_init_enter (&connection_menu_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ConnectionMenuClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) connection_menu_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ConnectionMenu), 0, (GInstanceInitFunc) connection_menu_instance_init, NULL };
		GType connection_menu_type_id;
		connection_menu_type_id = g_type_register_static (gtk_menu_get_type (), "ConnectionMenu", &g_define_type_info, 0);
		ConnectionMenu_private_offset = g_type_add_instance_private (connection_menu_type_id, sizeof (ConnectionMenuPrivate));
		g_once_init_leave (&connection_menu_type_id__volatile, connection_menu_type_id);
	}
	return connection_menu_type_id__volatile;
}



