/* ImageEditor.c generated by valac 0.42.7, the Vala compiler
 * generated from ImageEditor.vala, do not modify */

/*
* Copyright (c) 2018 (https://github.com/phase1geo/Minder)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Trevor Williams <phase1geo@gmail.com>
*/


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <float.h>
#include <math.h>
#include <gdk/gdk.h>
#include <cairo.h>
#include <glib/gi18n-lib.h>
#include <stdlib.h>
#include <string.h>
#include <gobject/gvaluecollector.h>


#define TYPE_IMAGE_EDITOR (image_editor_get_type ())
#define IMAGE_EDITOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_IMAGE_EDITOR, ImageEditor))
#define IMAGE_EDITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_IMAGE_EDITOR, ImageEditorClass))
#define IS_IMAGE_EDITOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_IMAGE_EDITOR))
#define IS_IMAGE_EDITOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_IMAGE_EDITOR))
#define IMAGE_EDITOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_IMAGE_EDITOR, ImageEditorClass))

typedef struct _ImageEditor ImageEditor;
typedef struct _ImageEditorClass ImageEditorClass;
typedef struct _ImageEditorPrivate ImageEditorPrivate;

#define TYPE_NODE (node_get_type ())
#define NODE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NODE, Node))
#define NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NODE, NodeClass))
#define IS_NODE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NODE))
#define IS_NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NODE))
#define NODE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NODE, NodeClass))

typedef struct _Node Node;
typedef struct _NodeClass NodeClass;

#define TYPE_NODE_IMAGE (node_image_get_type ())
#define NODE_IMAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NODE_IMAGE, NodeImage))
#define NODE_IMAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NODE_IMAGE, NodeImageClass))
#define IS_NODE_IMAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NODE_IMAGE))
#define IS_NODE_IMAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NODE_IMAGE))
#define NODE_IMAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NODE_IMAGE, NodeImageClass))

typedef struct _NodeImage NodeImage;
typedef struct _NodeImageClass NodeImageClass;
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _node_image_unref0(var) ((var == NULL) ? NULL : (var = (node_image_unref (var), NULL)))

#define TYPE_DRAW_AREA (draw_area_get_type ())
#define DRAW_AREA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DRAW_AREA, DrawArea))
#define DRAW_AREA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DRAW_AREA, DrawAreaClass))
#define IS_DRAW_AREA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DRAW_AREA))
#define IS_DRAW_AREA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DRAW_AREA))
#define DRAW_AREA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DRAW_AREA, DrawAreaClass))

typedef struct _DrawArea DrawArea;
typedef struct _DrawAreaClass DrawAreaClass;

#define TYPE_IMAGE_MANAGER (image_manager_get_type ())
#define IMAGE_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_IMAGE_MANAGER, ImageManager))
#define IMAGE_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_IMAGE_MANAGER, ImageManagerClass))
#define IS_IMAGE_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_IMAGE_MANAGER))
#define IS_IMAGE_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_IMAGE_MANAGER))
#define IMAGE_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_IMAGE_MANAGER, ImageManagerClass))

typedef struct _ImageManager ImageManager;
typedef struct _ImageManagerClass ImageManagerClass;
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _image_manager_unref0(var) ((var == NULL) ? NULL : (var = (image_manager_unref (var), NULL)))
typedef struct _Block12Data Block12Data;
#define _image_editor_unref0(var) ((var == NULL) ? NULL : (var = (image_editor_unref (var), NULL)))
typedef struct _Block13Data Block13Data;
typedef struct _ParamSpecImageEditor ParamSpecImageEditor;
enum  {
	IMAGE_EDITOR_CHANGED_SIGNAL,
	IMAGE_EDITOR_NUM_SIGNALS
};
static guint image_editor_signals[IMAGE_EDITOR_NUM_SIGNALS] = {0};

struct _ImageEditor {
	GTypeInstance parent_instance;
	volatile int ref_count;
	ImageEditorPrivate * priv;
};

struct _ImageEditorClass {
	GTypeClass parent_class;
	void (*finalize) (ImageEditor *self);
};

struct _ImageEditorPrivate {
	GtkPopover* _popover;
	GtkDrawingArea* _da;
	Node* _node;
	NodeImage* _image;
	gint _crop_target;
	gdouble _last_x;
	gdouble _last_y;
	GdkRectangle* _crop_points;
	gint _crop_points_length1;
	gint __crop_points_size_;
	GdkCursorType* _crop_cursors;
	gint _crop_cursors_length1;
	gint __crop_cursors_size_;
	GtkLabel* _status_cursor;
	GtkLabel* _status_crop;
};

struct _Block12Data {
	int _ref_count_;
	ImageEditor* self;
	GtkDrawingArea* da;
	ImageManager* im;
};

struct _Block13Data {
	int _ref_count_;
	ImageEditor* self;
	GtkWindow* parent;
	ImageManager* im;
};

struct _ParamSpecImageEditor {
	GParamSpec parent_instance;
};


static gint ImageEditor_private_offset;
static gpointer image_editor_parent_class = NULL;

gpointer image_editor_ref (gpointer instance);
void image_editor_unref (gpointer instance);
GParamSpec* param_spec_image_editor (const gchar* name,
                                     const gchar* nick,
                                     const gchar* blurb,
                                     GType object_type,
                                     GParamFlags flags);
void value_set_image_editor (GValue* value,
                             gpointer v_object);
void value_take_image_editor (GValue* value,
                              gpointer v_object);
gpointer value_get_image_editor (const GValue* value);
GType image_editor_get_type (void) G_GNUC_CONST;
GType node_get_type (void) G_GNUC_CONST;
gpointer node_image_ref (gpointer instance);
void node_image_unref (gpointer instance);
GParamSpec* param_spec_node_image (const gchar* name,
                                   const gchar* nick,
                                   const gchar* blurb,
                                   GType object_type,
                                   GParamFlags flags);
void value_set_node_image (GValue* value,
                           gpointer v_object);
void value_take_node_image (GValue* value,
                            gpointer v_object);
gpointer value_get_node_image (const GValue* value);
GType node_image_get_type (void) G_GNUC_CONST;
#define IMAGE_EDITOR_MIN_WIDTH ((gdouble) 50)
#define IMAGE_EDITOR_CROP_WIDTH 8
GType draw_area_get_type (void) G_GNUC_CONST;
ImageEditor* image_editor_new (DrawArea* da);
ImageEditor* image_editor_construct (GType object_type,
                                     DrawArea* da);
gpointer image_manager_ref (gpointer instance);
void image_manager_unref (gpointer instance);
GParamSpec* param_spec_image_manager (const gchar* name,
                                      const gchar* nick,
                                      const gchar* blurb,
                                      GType object_type,
                                      GParamFlags flags);
void value_set_image_manager (GValue* value,
                              gpointer v_object);
void value_take_image_manager (GValue* value,
                               gpointer v_object);
gpointer value_get_image_manager (const GValue* value);
GType image_manager_get_type (void) G_GNUC_CONST;
void image_editor_create_ui (ImageEditor* self,
                             GtkWindow* parent,
                             ImageManager* im);
ImageManager* draw_area_get_image_manager (DrawArea* self);
static void image_editor_show_popover (ImageEditor* self,
                                gboolean show);
void image_editor_edit_image (ImageEditor* self,
                              ImageManager* im,
                              Node* node,
                              gdouble x,
                              gdouble y);
NodeImage* node_get_image (Node* self);
gint node_image_get_id (NodeImage* self);
gint node_max_width (Node* self);
NodeImage* node_image_new (ImageManager* im,
                           gint id,
                           gint width);
NodeImage* node_image_construct (GType object_type,
                                 ImageManager* im,
                                 gint id,
                                 gint width);
gboolean node_image_get_valid (NodeImage* self);
gint node_image_get_crop_x (NodeImage* self);
void node_image_set_crop_x (NodeImage* self,
                            gint value);
gint node_image_get_crop_y (NodeImage* self);
void node_image_set_crop_y (NodeImage* self,
                            gint value);
gint node_image_get_crop_w (NodeImage* self);
void node_image_set_crop_w (NodeImage* self,
                            gint value);
gint node_image_get_crop_h (NodeImage* self);
void node_image_set_crop_h (NodeImage* self,
                            gint value);
cairo_surface_t* node_image_get_surface (NodeImage* self);
static void image_editor_set_crop_points (ImageEditor* self);
static gboolean image_editor_initialize (ImageEditor* self,
                                  NodeImage* ni);
static void image_editor_set_cursor_location (ImageEditor* self,
                                       gint x,
                                       gint y);
static void image_editor_set_crop_target (ImageEditor* self,
                                   gdouble x,
                                   gdouble y);
static void image_editor_adjust_crop_points (ImageEditor* self,
                                      gint diffx,
                                      gint diffy);
GtkDrawingArea* image_editor_create_drawing_area (ImageEditor* self,
                                                  ImageManager* im);
static GtkBox* image_editor_create_status_area (ImageEditor* self);
static GtkBox* image_editor_create_buttons (ImageEditor* self,
                                     GtkWindow* parent,
                                     ImageManager* im);
static Block12Data* block12_data_ref (Block12Data* _data12_);
static void block12_data_unref (void * _userdata_);
#define NODE_IMAGE_EDIT_WIDTH 600
#define NODE_IMAGE_EDIT_HEIGHT 600
static gboolean __lambda57_ (ImageEditor* self,
                      cairo_t* ctx);
static void image_editor_draw_image (ImageEditor* self,
                              cairo_t* ctx);
static gboolean ___lambda57__gtk_widget_draw (GtkWidget* _sender,
                                       cairo_t* cr,
                                       gpointer self);
static gboolean __lambda58_ (ImageEditor* self,
                      GdkEventButton* e);
static gboolean ___lambda58__gtk_widget_button_press_event (GtkWidget* _sender,
                                                     GdkEventButton* event,
                                                     gpointer self);
static gboolean __lambda59_ (Block12Data* _data12_,
                      GdkEventMotion* e);
static void image_editor_set_cursor (ImageEditor* self,
                              GdkCursorType* type);
static gboolean ___lambda59__gtk_widget_motion_notify_event (GtkWidget* _sender,
                                                      GdkEventMotion* event,
                                                      gpointer self);
static gboolean __lambda60_ (ImageEditor* self,
                      GdkEventButton* e);
static gboolean ___lambda60__gtk_widget_button_release_event (GtkWidget* _sender,
                                                       GdkEventButton* event,
                                                       gpointer self);
static void __lambda61_ (Block12Data* _data12_,
                  GdkDragContext* ctx,
                  gint x,
                  gint y,
                  GtkSelectionData* data,
                  guint info,
                  guint t);
NodeImage* node_image_new_from_uri (ImageManager* im,
                                    const gchar* uri,
                                    gint width);
NodeImage* node_image_construct_from_uri (GType object_type,
                                          ImageManager* im,
                                          const gchar* uri,
                                          gint width);
static void ___lambda61__gtk_widget_drag_data_received (GtkWidget* _sender,
                                                 GdkDragContext* context,
                                                 gint x,
                                                 gint y,
                                                 GtkSelectionData* selection_data,
                                                 guint info,
                                                 guint time_,
                                                 gpointer self);
static Block13Data* block13_data_ref (Block13Data* _data13_);
static void block13_data_unref (void * _userdata_);
static void __lambda62_ (ImageEditor* self);
static void ___lambda62__gtk_button_clicked (GtkButton* _sender,
                                      gpointer self);
static void __lambda63_ (Block13Data* _data13_);
static void image_editor_set_image (ImageEditor* self,
                             ImageManager* im);
static void ___lambda63__gtk_button_clicked (GtkButton* _sender,
                                      gpointer self);
static void __lambda64_ (Block13Data* _data13_);
gint image_manager_choose_image (ImageManager* self,
                                 GtkWindow* parent);
static void ___lambda64__gtk_button_clicked (GtkButton* _sender,
                                      gpointer self);
static void __lambda65_ (Block13Data* _data13_);
static void image_editor_remove_image (ImageEditor* self,
                                ImageManager* im);
static void ___lambda65__gtk_button_clicked (GtkButton* _sender,
                                      gpointer self);
static gboolean _gdk_cursor_type_equal (const GdkCursorType * s1,
                                 const GdkCursorType * s2);
static void image_editor_draw_crop_point (ImageEditor* self,
                                   cairo_t* ctx,
                                   GdkRectangle* crop);
void node_set_image (Node* self,
                     ImageManager* im,
                     NodeImage* ni);
void node_image_set_width (NodeImage* self,
                           gint width);
static void g_cclosure_user_marshal_VOID__NODE_IMAGE (GClosure * closure,
                                               GValue * return_value,
                                               guint n_param_values,
                                               const GValue * param_values,
                                               gpointer invocation_hint,
                                               gpointer marshal_data);
static void image_editor_finalize (ImageEditor * obj);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);

static const GtkTargetEntry IMAGE_EDITOR_DRAG_TARGETS[1] = {{"text/uri-list", (guint) 0, (guint) 0}};

static inline gpointer
image_editor_get_instance_private (ImageEditor* self)
{
	return G_STRUCT_MEMBER_P (self, ImageEditor_private_offset);
}


ImageEditor*
image_editor_construct (GType object_type,
                        DrawArea* da)
{
	ImageEditor* self = NULL;
	GdkRectangle* _tmp0_;
	GdkCursorType* _tmp1_;
	GdkCursorType* _tmp9_;
	gint _tmp9__length1;
	GdkCursorType* _tmp10_;
	gint _tmp10__length1;
	GdkCursorType* _tmp11_;
	gint _tmp11__length1;
	GdkCursorType* _tmp12_;
	gint _tmp12__length1;
	GdkCursorType* _tmp13_;
	gint _tmp13__length1;
	GdkCursorType* _tmp14_;
	gint _tmp14__length1;
	GdkCursorType* _tmp15_;
	gint _tmp15__length1;
	GdkCursorType* _tmp16_;
	gint _tmp16__length1;
	GtkWidget* _tmp17_;
	ImageManager* _tmp18_;
	ImageManager* _tmp19_;
#line 49 "../src/ImageEditor.vala"
	g_return_val_if_fail (da != NULL, NULL);
#line 49 "../src/ImageEditor.vala"
	self = (ImageEditor*) g_type_create_instance (object_type);
#line 52 "../src/ImageEditor.vala"
	_tmp0_ = g_new0 (GdkRectangle, 9);
#line 52 "../src/ImageEditor.vala"
	self->priv->_crop_points = (g_free (self->priv->_crop_points), NULL);
#line 52 "../src/ImageEditor.vala"
	self->priv->_crop_points = _tmp0_;
#line 52 "../src/ImageEditor.vala"
	self->priv->_crop_points_length1 = 9;
#line 52 "../src/ImageEditor.vala"
	self->priv->__crop_points_size_ = self->priv->_crop_points_length1;
#line 53 "../src/ImageEditor.vala"
	_tmp1_ = g_new0 (GdkCursorType, 8);
#line 53 "../src/ImageEditor.vala"
	self->priv->_crop_cursors = (g_free (self->priv->_crop_cursors), NULL);
#line 53 "../src/ImageEditor.vala"
	self->priv->_crop_cursors = _tmp1_;
#line 53 "../src/ImageEditor.vala"
	self->priv->_crop_cursors_length1 = 8;
#line 53 "../src/ImageEditor.vala"
	self->priv->__crop_cursors_size_ = self->priv->_crop_cursors_length1;
#line 409 "ImageEditor.c"
	{
		gint i = 0;
#line 56 "../src/ImageEditor.vala"
		i = 0;
#line 414 "ImageEditor.c"
		{
			gboolean _tmp2_ = FALSE;
#line 56 "../src/ImageEditor.vala"
			_tmp2_ = TRUE;
#line 56 "../src/ImageEditor.vala"
			while (TRUE) {
#line 421 "ImageEditor.c"
				gint _tmp4_;
				GdkRectangle* _tmp5_;
				gint _tmp5__length1;
				GdkRectangle* _tmp6_;
				gint _tmp6__length1;
				gint _tmp7_;
				GdkRectangle _tmp8_ = {0};
#line 56 "../src/ImageEditor.vala"
				if (!_tmp2_) {
#line 431 "ImageEditor.c"
					gint _tmp3_;
#line 56 "../src/ImageEditor.vala"
					_tmp3_ = i;
#line 56 "../src/ImageEditor.vala"
					i = _tmp3_ + 1;
#line 437 "ImageEditor.c"
				}
#line 56 "../src/ImageEditor.vala"
				_tmp2_ = FALSE;
#line 56 "../src/ImageEditor.vala"
				_tmp4_ = i;
#line 56 "../src/ImageEditor.vala"
				_tmp5_ = self->priv->_crop_points;
#line 56 "../src/ImageEditor.vala"
				_tmp5__length1 = self->priv->_crop_points_length1;
#line 56 "../src/ImageEditor.vala"
				if (!(_tmp4_ < _tmp5__length1)) {
#line 56 "../src/ImageEditor.vala"
					break;
#line 451 "ImageEditor.c"
				}
#line 57 "../src/ImageEditor.vala"
				_tmp6_ = self->priv->_crop_points;
#line 57 "../src/ImageEditor.vala"
				_tmp6__length1 = self->priv->_crop_points_length1;
#line 57 "../src/ImageEditor.vala"
				_tmp7_ = i;
#line 57 "../src/ImageEditor.vala"
				_tmp8_.x = 0;
#line 57 "../src/ImageEditor.vala"
				_tmp8_.y = 0;
#line 57 "../src/ImageEditor.vala"
				_tmp8_.width = IMAGE_EDITOR_CROP_WIDTH;
#line 57 "../src/ImageEditor.vala"
				_tmp8_.height = IMAGE_EDITOR_CROP_WIDTH;
#line 57 "../src/ImageEditor.vala"
				_tmp6_[_tmp7_] = _tmp8_;
#line 469 "ImageEditor.c"
			}
		}
	}
#line 61 "../src/ImageEditor.vala"
	_tmp9_ = self->priv->_crop_cursors;
#line 61 "../src/ImageEditor.vala"
	_tmp9__length1 = self->priv->_crop_cursors_length1;
#line 61 "../src/ImageEditor.vala"
	_tmp9_[0] = GDK_TOP_LEFT_CORNER;
#line 62 "../src/ImageEditor.vala"
	_tmp10_ = self->priv->_crop_cursors;
#line 62 "../src/ImageEditor.vala"
	_tmp10__length1 = self->priv->_crop_cursors_length1;
#line 62 "../src/ImageEditor.vala"
	_tmp10_[1] = GDK_SB_V_DOUBLE_ARROW;
#line 63 "../src/ImageEditor.vala"
	_tmp11_ = self->priv->_crop_cursors;
#line 63 "../src/ImageEditor.vala"
	_tmp11__length1 = self->priv->_crop_cursors_length1;
#line 63 "../src/ImageEditor.vala"
	_tmp11_[2] = GDK_TOP_RIGHT_CORNER;
#line 64 "../src/ImageEditor.vala"
	_tmp12_ = self->priv->_crop_cursors;
#line 64 "../src/ImageEditor.vala"
	_tmp12__length1 = self->priv->_crop_cursors_length1;
#line 64 "../src/ImageEditor.vala"
	_tmp12_[3] = GDK_SB_H_DOUBLE_ARROW;
#line 65 "../src/ImageEditor.vala"
	_tmp13_ = self->priv->_crop_cursors;
#line 65 "../src/ImageEditor.vala"
	_tmp13__length1 = self->priv->_crop_cursors_length1;
#line 65 "../src/ImageEditor.vala"
	_tmp13_[4] = GDK_SB_H_DOUBLE_ARROW;
#line 66 "../src/ImageEditor.vala"
	_tmp14_ = self->priv->_crop_cursors;
#line 66 "../src/ImageEditor.vala"
	_tmp14__length1 = self->priv->_crop_cursors_length1;
#line 66 "../src/ImageEditor.vala"
	_tmp14_[5] = GDK_TOP_RIGHT_CORNER;
#line 67 "../src/ImageEditor.vala"
	_tmp15_ = self->priv->_crop_cursors;
#line 67 "../src/ImageEditor.vala"
	_tmp15__length1 = self->priv->_crop_cursors_length1;
#line 67 "../src/ImageEditor.vala"
	_tmp15_[6] = GDK_SB_V_DOUBLE_ARROW;
#line 68 "../src/ImageEditor.vala"
	_tmp16_ = self->priv->_crop_cursors;
#line 68 "../src/ImageEditor.vala"
	_tmp16__length1 = self->priv->_crop_cursors_length1;
#line 68 "../src/ImageEditor.vala"
	_tmp16_[7] = GDK_TOP_LEFT_CORNER;
#line 71 "../src/ImageEditor.vala"
	_tmp17_ = gtk_widget_get_toplevel ((GtkWidget*) da);
#line 71 "../src/ImageEditor.vala"
	_tmp18_ = draw_area_get_image_manager (da);
#line 71 "../src/ImageEditor.vala"
	_tmp19_ = _tmp18_;
#line 71 "../src/ImageEditor.vala"
	image_editor_create_ui (self, G_TYPE_CHECK_INSTANCE_CAST (_tmp17_, gtk_window_get_type (), GtkWindow), _tmp19_);
#line 49 "../src/ImageEditor.vala"
	return self;
#line 531 "ImageEditor.c"
}


ImageEditor*
image_editor_new (DrawArea* da)
{
#line 49 "../src/ImageEditor.vala"
	return image_editor_construct (TYPE_IMAGE_EDITOR, da);
#line 540 "ImageEditor.c"
}


static void
image_editor_show_popover (ImageEditor* self,
                           gboolean show)
{
#line 76 "../src/ImageEditor.vala"
	g_return_if_fail (self != NULL);
#line 79 "../src/ImageEditor.vala"
	if (show) {
#line 552 "ImageEditor.c"
		GtkPopover* _tmp0_;
#line 80 "../src/ImageEditor.vala"
		_tmp0_ = self->priv->_popover;
#line 80 "../src/ImageEditor.vala"
		gtk_popover_popup (_tmp0_);
#line 558 "ImageEditor.c"
	} else {
		GtkPopover* _tmp1_;
#line 82 "../src/ImageEditor.vala"
		_tmp1_ = self->priv->_popover;
#line 82 "../src/ImageEditor.vala"
		gtk_popover_popdown (_tmp1_);
#line 565 "ImageEditor.c"
	}
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 101 "../src/ImageEditor.vala"
	return self ? g_object_ref (self) : NULL;
#line 575 "ImageEditor.c"
}


void
image_editor_edit_image (ImageEditor* self,
                         ImageManager* im,
                         Node* node,
                         gdouble x,
                         gdouble y)
{
	GdkRectangle rect = {0};
	GdkRectangle _tmp0_ = {0};
	GtkPopover* _tmp1_;
	GdkRectangle _tmp2_;
	Node* _tmp3_;
	NodeImage* _tmp4_;
	NodeImage* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
	Node* _tmp8_;
	NodeImage* _tmp9_;
	NodeImage* _tmp10_;
	gboolean _tmp11_;
	gboolean _tmp12_;
#line 95 "../src/ImageEditor.vala"
	g_return_if_fail (self != NULL);
#line 95 "../src/ImageEditor.vala"
	g_return_if_fail (im != NULL);
#line 95 "../src/ImageEditor.vala"
	g_return_if_fail (node != NULL);
#line 97 "../src/ImageEditor.vala"
	_tmp0_.x = (gint) x;
#line 97 "../src/ImageEditor.vala"
	_tmp0_.y = (gint) y;
#line 97 "../src/ImageEditor.vala"
	_tmp0_.width = 1;
#line 97 "../src/ImageEditor.vala"
	_tmp0_.height = 1;
#line 97 "../src/ImageEditor.vala"
	rect = _tmp0_;
#line 98 "../src/ImageEditor.vala"
	_tmp1_ = self->priv->_popover;
#line 98 "../src/ImageEditor.vala"
	_tmp2_ = rect;
#line 98 "../src/ImageEditor.vala"
	g_object_set (_tmp1_, "pointing-to", &_tmp2_, NULL);
#line 101 "../src/ImageEditor.vala"
	_tmp3_ = _g_object_ref0 (node);
#line 101 "../src/ImageEditor.vala"
	_g_object_unref0 (self->priv->_node);
#line 101 "../src/ImageEditor.vala"
	self->priv->_node = _tmp3_;
#line 102 "../src/ImageEditor.vala"
	_tmp4_ = node_get_image (node);
#line 102 "../src/ImageEditor.vala"
	_tmp5_ = _tmp4_;
#line 102 "../src/ImageEditor.vala"
	_tmp6_ = node_image_get_id (_tmp5_);
#line 102 "../src/ImageEditor.vala"
	_tmp7_ = _tmp6_;
#line 102 "../src/ImageEditor.vala"
	_tmp8_ = self->priv->_node;
#line 102 "../src/ImageEditor.vala"
	_tmp9_ = node_image_new (im, _tmp7_, node_max_width (_tmp8_));
#line 102 "../src/ImageEditor.vala"
	_node_image_unref0 (self->priv->_image);
#line 102 "../src/ImageEditor.vala"
	self->priv->_image = _tmp9_;
#line 104 "../src/ImageEditor.vala"
	_tmp10_ = self->priv->_image;
#line 104 "../src/ImageEditor.vala"
	_tmp11_ = node_image_get_valid (_tmp10_);
#line 104 "../src/ImageEditor.vala"
	_tmp12_ = _tmp11_;
#line 104 "../src/ImageEditor.vala"
	if (_tmp12_) {
#line 652 "ImageEditor.c"
		NodeImage* _tmp13_;
		NodeImage* _tmp14_;
		NodeImage* _tmp15_;
		gint _tmp16_;
		gint _tmp17_;
		NodeImage* _tmp18_;
		NodeImage* _tmp19_;
		NodeImage* _tmp20_;
		gint _tmp21_;
		gint _tmp22_;
		NodeImage* _tmp23_;
		NodeImage* _tmp24_;
		NodeImage* _tmp25_;
		gint _tmp26_;
		gint _tmp27_;
		NodeImage* _tmp28_;
		NodeImage* _tmp29_;
		NodeImage* _tmp30_;
		gint _tmp31_;
		gint _tmp32_;
		GtkDrawingArea* _tmp33_;
		NodeImage* _tmp34_;
		NodeImage* _tmp35_;
		cairo_surface_t* _tmp36_;
		cairo_surface_t* _tmp37_;
		GtkDrawingArea* _tmp38_;
		NodeImage* _tmp39_;
		NodeImage* _tmp40_;
		cairo_surface_t* _tmp41_;
		cairo_surface_t* _tmp42_;
		GdkRectangle* _tmp43_;
		gint _tmp43__length1;
		NodeImage* _tmp44_;
		gint _tmp45_;
		gint _tmp46_;
		GdkRectangle* _tmp47_;
		gint _tmp47__length1;
		NodeImage* _tmp48_;
		gint _tmp49_;
		gint _tmp50_;
		GtkDrawingArea* _tmp51_;
#line 106 "../src/ImageEditor.vala"
		_tmp13_ = self->priv->_image;
#line 106 "../src/ImageEditor.vala"
		_tmp14_ = node_get_image (node);
#line 106 "../src/ImageEditor.vala"
		_tmp15_ = _tmp14_;
#line 106 "../src/ImageEditor.vala"
		_tmp16_ = node_image_get_crop_x (_tmp15_);
#line 106 "../src/ImageEditor.vala"
		_tmp17_ = _tmp16_;
#line 106 "../src/ImageEditor.vala"
		node_image_set_crop_x (_tmp13_, _tmp17_);
#line 107 "../src/ImageEditor.vala"
		_tmp18_ = self->priv->_image;
#line 107 "../src/ImageEditor.vala"
		_tmp19_ = node_get_image (node);
#line 107 "../src/ImageEditor.vala"
		_tmp20_ = _tmp19_;
#line 107 "../src/ImageEditor.vala"
		_tmp21_ = node_image_get_crop_y (_tmp20_);
#line 107 "../src/ImageEditor.vala"
		_tmp22_ = _tmp21_;
#line 107 "../src/ImageEditor.vala"
		node_image_set_crop_y (_tmp18_, _tmp22_);
#line 108 "../src/ImageEditor.vala"
		_tmp23_ = self->priv->_image;
#line 108 "../src/ImageEditor.vala"
		_tmp24_ = node_get_image (node);
#line 108 "../src/ImageEditor.vala"
		_tmp25_ = _tmp24_;
#line 108 "../src/ImageEditor.vala"
		_tmp26_ = node_image_get_crop_w (_tmp25_);
#line 108 "../src/ImageEditor.vala"
		_tmp27_ = _tmp26_;
#line 108 "../src/ImageEditor.vala"
		node_image_set_crop_w (_tmp23_, _tmp27_);
#line 109 "../src/ImageEditor.vala"
		_tmp28_ = self->priv->_image;
#line 109 "../src/ImageEditor.vala"
		_tmp29_ = node_get_image (node);
#line 109 "../src/ImageEditor.vala"
		_tmp30_ = _tmp29_;
#line 109 "../src/ImageEditor.vala"
		_tmp31_ = node_image_get_crop_h (_tmp30_);
#line 109 "../src/ImageEditor.vala"
		_tmp32_ = _tmp31_;
#line 109 "../src/ImageEditor.vala"
		node_image_set_crop_h (_tmp28_, _tmp32_);
#line 112 "../src/ImageEditor.vala"
		_tmp33_ = self->priv->_da;
#line 112 "../src/ImageEditor.vala"
		_tmp34_ = node_get_image (node);
#line 112 "../src/ImageEditor.vala"
		_tmp35_ = _tmp34_;
#line 112 "../src/ImageEditor.vala"
		_tmp36_ = node_image_get_surface (_tmp35_);
#line 112 "../src/ImageEditor.vala"
		_tmp37_ = _tmp36_;
#line 112 "../src/ImageEditor.vala"
		g_object_set ((GtkWidget*) _tmp33_, "width-request", cairo_image_surface_get_width (_tmp37_), NULL);
#line 112 "../src/ImageEditor.vala"
		_cairo_surface_destroy0 (_tmp37_);
#line 113 "../src/ImageEditor.vala"
		_tmp38_ = self->priv->_da;
#line 113 "../src/ImageEditor.vala"
		_tmp39_ = node_get_image (node);
#line 113 "../src/ImageEditor.vala"
		_tmp40_ = _tmp39_;
#line 113 "../src/ImageEditor.vala"
		_tmp41_ = node_image_get_surface (_tmp40_);
#line 113 "../src/ImageEditor.vala"
		_tmp42_ = _tmp41_;
#line 113 "../src/ImageEditor.vala"
		g_object_set ((GtkWidget*) _tmp38_, "height-request", cairo_image_surface_get_height (_tmp42_), NULL);
#line 113 "../src/ImageEditor.vala"
		_cairo_surface_destroy0 (_tmp42_);
#line 114 "../src/ImageEditor.vala"
		_tmp43_ = self->priv->_crop_points;
#line 114 "../src/ImageEditor.vala"
		_tmp43__length1 = self->priv->_crop_points_length1;
#line 114 "../src/ImageEditor.vala"
		_tmp44_ = self->priv->_image;
#line 114 "../src/ImageEditor.vala"
		_tmp45_ = node_image_get_crop_w (_tmp44_);
#line 114 "../src/ImageEditor.vala"
		_tmp46_ = _tmp45_;
#line 114 "../src/ImageEditor.vala"
		_tmp43_[8].width = _tmp46_;
#line 115 "../src/ImageEditor.vala"
		_tmp47_ = self->priv->_crop_points;
#line 115 "../src/ImageEditor.vala"
		_tmp47__length1 = self->priv->_crop_points_length1;
#line 115 "../src/ImageEditor.vala"
		_tmp48_ = self->priv->_image;
#line 115 "../src/ImageEditor.vala"
		_tmp49_ = node_image_get_crop_h (_tmp48_);
#line 115 "../src/ImageEditor.vala"
		_tmp50_ = _tmp49_;
#line 115 "../src/ImageEditor.vala"
		_tmp47_[8].height = _tmp50_;
#line 116 "../src/ImageEditor.vala"
		image_editor_set_crop_points (self);
#line 117 "../src/ImageEditor.vala"
		_tmp51_ = self->priv->_da;
#line 117 "../src/ImageEditor.vala"
		gtk_widget_queue_draw ((GtkWidget*) _tmp51_);
#line 120 "../src/ImageEditor.vala"
		image_editor_show_popover (self, TRUE);
#line 802 "ImageEditor.c"
	}
}


static gpointer
_node_image_ref0 (gpointer self)
{
#line 130 "../src/ImageEditor.vala"
	return self ? node_image_ref (self) : NULL;
#line 812 "ImageEditor.c"
}


static gboolean
image_editor_initialize (ImageEditor* self,
                         NodeImage* ni)
{
	gboolean result = FALSE;
	NodeImage* _tmp0_;
	NodeImage* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	NodeImage* _tmp21_;
	gboolean _tmp22_;
	gboolean _tmp23_;
#line 127 "../src/ImageEditor.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 127 "../src/ImageEditor.vala"
	g_return_val_if_fail (ni != NULL, FALSE);
#line 130 "../src/ImageEditor.vala"
	_tmp0_ = _node_image_ref0 (ni);
#line 130 "../src/ImageEditor.vala"
	_node_image_unref0 (self->priv->_image);
#line 130 "../src/ImageEditor.vala"
	self->priv->_image = _tmp0_;
#line 133 "../src/ImageEditor.vala"
	_tmp1_ = self->priv->_image;
#line 133 "../src/ImageEditor.vala"
	_tmp2_ = node_image_get_valid (_tmp1_);
#line 133 "../src/ImageEditor.vala"
	_tmp3_ = _tmp2_;
#line 133 "../src/ImageEditor.vala"
	if (_tmp3_) {
#line 846 "ImageEditor.c"
		GtkDrawingArea* _tmp4_;
		NodeImage* _tmp5_;
		cairo_surface_t* _tmp6_;
		cairo_surface_t* _tmp7_;
		GtkDrawingArea* _tmp8_;
		NodeImage* _tmp9_;
		cairo_surface_t* _tmp10_;
		cairo_surface_t* _tmp11_;
		GdkRectangle* _tmp12_;
		gint _tmp12__length1;
		NodeImage* _tmp13_;
		gint _tmp14_;
		gint _tmp15_;
		GdkRectangle* _tmp16_;
		gint _tmp16__length1;
		NodeImage* _tmp17_;
		gint _tmp18_;
		gint _tmp19_;
		GtkDrawingArea* _tmp20_;
#line 134 "../src/ImageEditor.vala"
		_tmp4_ = self->priv->_da;
#line 134 "../src/ImageEditor.vala"
		_tmp5_ = self->priv->_image;
#line 134 "../src/ImageEditor.vala"
		_tmp6_ = node_image_get_surface (_tmp5_);
#line 134 "../src/ImageEditor.vala"
		_tmp7_ = _tmp6_;
#line 134 "../src/ImageEditor.vala"
		g_object_set ((GtkWidget*) _tmp4_, "width-request", cairo_image_surface_get_width (_tmp7_), NULL);
#line 134 "../src/ImageEditor.vala"
		_cairo_surface_destroy0 (_tmp7_);
#line 135 "../src/ImageEditor.vala"
		_tmp8_ = self->priv->_da;
#line 135 "../src/ImageEditor.vala"
		_tmp9_ = self->priv->_image;
#line 135 "../src/ImageEditor.vala"
		_tmp10_ = node_image_get_surface (_tmp9_);
#line 135 "../src/ImageEditor.vala"
		_tmp11_ = _tmp10_;
#line 135 "../src/ImageEditor.vala"
		g_object_set ((GtkWidget*) _tmp8_, "height-request", cairo_image_surface_get_height (_tmp11_), NULL);
#line 135 "../src/ImageEditor.vala"
		_cairo_surface_destroy0 (_tmp11_);
#line 136 "../src/ImageEditor.vala"
		_tmp12_ = self->priv->_crop_points;
#line 136 "../src/ImageEditor.vala"
		_tmp12__length1 = self->priv->_crop_points_length1;
#line 136 "../src/ImageEditor.vala"
		_tmp13_ = self->priv->_image;
#line 136 "../src/ImageEditor.vala"
		_tmp14_ = node_image_get_crop_w (_tmp13_);
#line 136 "../src/ImageEditor.vala"
		_tmp15_ = _tmp14_;
#line 136 "../src/ImageEditor.vala"
		_tmp12_[8].width = _tmp15_;
#line 137 "../src/ImageEditor.vala"
		_tmp16_ = self->priv->_crop_points;
#line 137 "../src/ImageEditor.vala"
		_tmp16__length1 = self->priv->_crop_points_length1;
#line 137 "../src/ImageEditor.vala"
		_tmp17_ = self->priv->_image;
#line 137 "../src/ImageEditor.vala"
		_tmp18_ = node_image_get_crop_h (_tmp17_);
#line 137 "../src/ImageEditor.vala"
		_tmp19_ = _tmp18_;
#line 137 "../src/ImageEditor.vala"
		_tmp16_[8].height = _tmp19_;
#line 138 "../src/ImageEditor.vala"
		image_editor_set_crop_points (self);
#line 139 "../src/ImageEditor.vala"
		image_editor_set_cursor_location (self, 0, 0);
#line 140 "../src/ImageEditor.vala"
		_tmp20_ = self->priv->_da;
#line 140 "../src/ImageEditor.vala"
		gtk_widget_queue_draw ((GtkWidget*) _tmp20_);
#line 922 "ImageEditor.c"
	}
#line 143 "../src/ImageEditor.vala"
	_tmp21_ = self->priv->_image;
#line 143 "../src/ImageEditor.vala"
	_tmp22_ = node_image_get_valid (_tmp21_);
#line 143 "../src/ImageEditor.vala"
	_tmp23_ = _tmp22_;
#line 143 "../src/ImageEditor.vala"
	result = _tmp23_;
#line 143 "../src/ImageEditor.vala"
	return result;
#line 934 "ImageEditor.c"
}


static void
image_editor_set_crop_points (ImageEditor* self)
{
	gint x0 = 0;
	NodeImage* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gint x1 = 0;
	NodeImage* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	NodeImage* _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	gint x2 = 0;
	NodeImage* _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	NodeImage* _tmp12_;
	gint _tmp13_;
	gint _tmp14_;
	gint y0 = 0;
	NodeImage* _tmp15_;
	gint _tmp16_;
	gint _tmp17_;
	gint y1 = 0;
	NodeImage* _tmp18_;
	gint _tmp19_;
	gint _tmp20_;
	NodeImage* _tmp21_;
	gint _tmp22_;
	gint _tmp23_;
	gint y2 = 0;
	NodeImage* _tmp24_;
	gint _tmp25_;
	gint _tmp26_;
	NodeImage* _tmp27_;
	gint _tmp28_;
	gint _tmp29_;
	GdkRectangle* _tmp30_;
	gint _tmp30__length1;
	GdkRectangle* _tmp31_;
	gint _tmp31__length1;
	GdkRectangle* _tmp32_;
	gint _tmp32__length1;
	GdkRectangle* _tmp33_;
	gint _tmp33__length1;
	GdkRectangle* _tmp34_;
	gint _tmp34__length1;
	GdkRectangle* _tmp35_;
	gint _tmp35__length1;
	GdkRectangle* _tmp36_;
	gint _tmp36__length1;
	GdkRectangle* _tmp37_;
	gint _tmp37__length1;
	GdkRectangle* _tmp38_;
	gint _tmp38__length1;
	GdkRectangle* _tmp39_;
	gint _tmp39__length1;
	GdkRectangle* _tmp40_;
	gint _tmp40__length1;
	GdkRectangle* _tmp41_;
	gint _tmp41__length1;
	GdkRectangle* _tmp42_;
	gint _tmp42__length1;
	GdkRectangle* _tmp43_;
	gint _tmp43__length1;
	GdkRectangle* _tmp44_;
	gint _tmp44__length1;
	GdkRectangle* _tmp45_;
	gint _tmp45__length1;
	GdkRectangle* _tmp46_;
	gint _tmp46__length1;
	GdkRectangle* _tmp47_;
	gint _tmp47__length1;
	GdkRectangle* _tmp48_;
	gint _tmp48__length1;
	NodeImage* _tmp49_;
	gint _tmp50_;
	gint _tmp51_;
	GdkRectangle* _tmp52_;
	gint _tmp52__length1;
	NodeImage* _tmp53_;
	gint _tmp54_;
	gint _tmp55_;
	GtkLabel* _tmp56_;
	GdkRectangle* _tmp57_;
	gint _tmp57__length1;
	GdkRectangle _tmp58_;
	gint _tmp59_;
	GdkRectangle* _tmp60_;
	gint _tmp60__length1;
	GdkRectangle _tmp61_;
	gint _tmp62_;
	GdkRectangle* _tmp63_;
	gint _tmp63__length1;
	GdkRectangle _tmp64_;
	gint _tmp65_;
	GdkRectangle* _tmp66_;
	gint _tmp66__length1;
	GdkRectangle _tmp67_;
	gint _tmp68_;
	gchar* _tmp69_;
	gchar* _tmp70_;
#line 148 "../src/ImageEditor.vala"
	g_return_if_fail (self != NULL);
#line 150 "../src/ImageEditor.vala"
	_tmp0_ = self->priv->_image;
#line 150 "../src/ImageEditor.vala"
	_tmp1_ = node_image_get_crop_x (_tmp0_);
#line 150 "../src/ImageEditor.vala"
	_tmp2_ = _tmp1_;
#line 150 "../src/ImageEditor.vala"
	x0 = _tmp2_;
#line 151 "../src/ImageEditor.vala"
	_tmp3_ = self->priv->_image;
#line 151 "../src/ImageEditor.vala"
	_tmp4_ = node_image_get_crop_x (_tmp3_);
#line 151 "../src/ImageEditor.vala"
	_tmp5_ = _tmp4_;
#line 151 "../src/ImageEditor.vala"
	_tmp6_ = self->priv->_image;
#line 151 "../src/ImageEditor.vala"
	_tmp7_ = node_image_get_crop_w (_tmp6_);
#line 151 "../src/ImageEditor.vala"
	_tmp8_ = _tmp7_;
#line 151 "../src/ImageEditor.vala"
	x1 = (_tmp5_ + (_tmp8_ / 2)) - (IMAGE_EDITOR_CROP_WIDTH / 2);
#line 152 "../src/ImageEditor.vala"
	_tmp9_ = self->priv->_image;
#line 152 "../src/ImageEditor.vala"
	_tmp10_ = node_image_get_crop_x (_tmp9_);
#line 152 "../src/ImageEditor.vala"
	_tmp11_ = _tmp10_;
#line 152 "../src/ImageEditor.vala"
	_tmp12_ = self->priv->_image;
#line 152 "../src/ImageEditor.vala"
	_tmp13_ = node_image_get_crop_w (_tmp12_);
#line 152 "../src/ImageEditor.vala"
	_tmp14_ = _tmp13_;
#line 152 "../src/ImageEditor.vala"
	x2 = (_tmp11_ + _tmp14_) - IMAGE_EDITOR_CROP_WIDTH;
#line 153 "../src/ImageEditor.vala"
	_tmp15_ = self->priv->_image;
#line 153 "../src/ImageEditor.vala"
	_tmp16_ = node_image_get_crop_y (_tmp15_);
#line 153 "../src/ImageEditor.vala"
	_tmp17_ = _tmp16_;
#line 153 "../src/ImageEditor.vala"
	y0 = _tmp17_;
#line 154 "../src/ImageEditor.vala"
	_tmp18_ = self->priv->_image;
#line 154 "../src/ImageEditor.vala"
	_tmp19_ = node_image_get_crop_y (_tmp18_);
#line 154 "../src/ImageEditor.vala"
	_tmp20_ = _tmp19_;
#line 154 "../src/ImageEditor.vala"
	_tmp21_ = self->priv->_image;
#line 154 "../src/ImageEditor.vala"
	_tmp22_ = node_image_get_crop_h (_tmp21_);
#line 154 "../src/ImageEditor.vala"
	_tmp23_ = _tmp22_;
#line 154 "../src/ImageEditor.vala"
	y1 = (_tmp20_ + (_tmp23_ / 2)) - (IMAGE_EDITOR_CROP_WIDTH / 2);
#line 155 "../src/ImageEditor.vala"
	_tmp24_ = self->priv->_image;
#line 155 "../src/ImageEditor.vala"
	_tmp25_ = node_image_get_crop_y (_tmp24_);
#line 155 "../src/ImageEditor.vala"
	_tmp26_ = _tmp25_;
#line 155 "../src/ImageEditor.vala"
	_tmp27_ = self->priv->_image;
#line 155 "../src/ImageEditor.vala"
	_tmp28_ = node_image_get_crop_h (_tmp27_);
#line 155 "../src/ImageEditor.vala"
	_tmp29_ = _tmp28_;
#line 155 "../src/ImageEditor.vala"
	y2 = (_tmp26_ + _tmp29_) - IMAGE_EDITOR_CROP_WIDTH;
#line 157 "../src/ImageEditor.vala"
	_tmp30_ = self->priv->_crop_points;
#line 157 "../src/ImageEditor.vala"
	_tmp30__length1 = self->priv->_crop_points_length1;
#line 157 "../src/ImageEditor.vala"
	_tmp30_[0].x = x0;
#line 158 "../src/ImageEditor.vala"
	_tmp31_ = self->priv->_crop_points;
#line 158 "../src/ImageEditor.vala"
	_tmp31__length1 = self->priv->_crop_points_length1;
#line 158 "../src/ImageEditor.vala"
	_tmp31_[0].y = y0;
#line 159 "../src/ImageEditor.vala"
	_tmp32_ = self->priv->_crop_points;
#line 159 "../src/ImageEditor.vala"
	_tmp32__length1 = self->priv->_crop_points_length1;
#line 159 "../src/ImageEditor.vala"
	_tmp32_[1].x = x1;
#line 160 "../src/ImageEditor.vala"
	_tmp33_ = self->priv->_crop_points;
#line 160 "../src/ImageEditor.vala"
	_tmp33__length1 = self->priv->_crop_points_length1;
#line 160 "../src/ImageEditor.vala"
	_tmp33_[1].y = y0;
#line 161 "../src/ImageEditor.vala"
	_tmp34_ = self->priv->_crop_points;
#line 161 "../src/ImageEditor.vala"
	_tmp34__length1 = self->priv->_crop_points_length1;
#line 161 "../src/ImageEditor.vala"
	_tmp34_[2].x = x2;
#line 162 "../src/ImageEditor.vala"
	_tmp35_ = self->priv->_crop_points;
#line 162 "../src/ImageEditor.vala"
	_tmp35__length1 = self->priv->_crop_points_length1;
#line 162 "../src/ImageEditor.vala"
	_tmp35_[2].y = y0;
#line 163 "../src/ImageEditor.vala"
	_tmp36_ = self->priv->_crop_points;
#line 163 "../src/ImageEditor.vala"
	_tmp36__length1 = self->priv->_crop_points_length1;
#line 163 "../src/ImageEditor.vala"
	_tmp36_[3].x = x0;
#line 164 "../src/ImageEditor.vala"
	_tmp37_ = self->priv->_crop_points;
#line 164 "../src/ImageEditor.vala"
	_tmp37__length1 = self->priv->_crop_points_length1;
#line 164 "../src/ImageEditor.vala"
	_tmp37_[3].y = y1;
#line 165 "../src/ImageEditor.vala"
	_tmp38_ = self->priv->_crop_points;
#line 165 "../src/ImageEditor.vala"
	_tmp38__length1 = self->priv->_crop_points_length1;
#line 165 "../src/ImageEditor.vala"
	_tmp38_[4].x = x2;
#line 166 "../src/ImageEditor.vala"
	_tmp39_ = self->priv->_crop_points;
#line 166 "../src/ImageEditor.vala"
	_tmp39__length1 = self->priv->_crop_points_length1;
#line 166 "../src/ImageEditor.vala"
	_tmp39_[4].y = y1;
#line 167 "../src/ImageEditor.vala"
	_tmp40_ = self->priv->_crop_points;
#line 167 "../src/ImageEditor.vala"
	_tmp40__length1 = self->priv->_crop_points_length1;
#line 167 "../src/ImageEditor.vala"
	_tmp40_[5].x = x0;
#line 168 "../src/ImageEditor.vala"
	_tmp41_ = self->priv->_crop_points;
#line 168 "../src/ImageEditor.vala"
	_tmp41__length1 = self->priv->_crop_points_length1;
#line 168 "../src/ImageEditor.vala"
	_tmp41_[5].y = y2;
#line 169 "../src/ImageEditor.vala"
	_tmp42_ = self->priv->_crop_points;
#line 169 "../src/ImageEditor.vala"
	_tmp42__length1 = self->priv->_crop_points_length1;
#line 169 "../src/ImageEditor.vala"
	_tmp42_[6].x = x1;
#line 170 "../src/ImageEditor.vala"
	_tmp43_ = self->priv->_crop_points;
#line 170 "../src/ImageEditor.vala"
	_tmp43__length1 = self->priv->_crop_points_length1;
#line 170 "../src/ImageEditor.vala"
	_tmp43_[6].y = y2;
#line 171 "../src/ImageEditor.vala"
	_tmp44_ = self->priv->_crop_points;
#line 171 "../src/ImageEditor.vala"
	_tmp44__length1 = self->priv->_crop_points_length1;
#line 171 "../src/ImageEditor.vala"
	_tmp44_[7].x = x2;
#line 172 "../src/ImageEditor.vala"
	_tmp45_ = self->priv->_crop_points;
#line 172 "../src/ImageEditor.vala"
	_tmp45__length1 = self->priv->_crop_points_length1;
#line 172 "../src/ImageEditor.vala"
	_tmp45_[7].y = y2;
#line 174 "../src/ImageEditor.vala"
	_tmp46_ = self->priv->_crop_points;
#line 174 "../src/ImageEditor.vala"
	_tmp46__length1 = self->priv->_crop_points_length1;
#line 174 "../src/ImageEditor.vala"
	_tmp46_[8].x = x0;
#line 175 "../src/ImageEditor.vala"
	_tmp47_ = self->priv->_crop_points;
#line 175 "../src/ImageEditor.vala"
	_tmp47__length1 = self->priv->_crop_points_length1;
#line 175 "../src/ImageEditor.vala"
	_tmp47_[8].y = y0;
#line 176 "../src/ImageEditor.vala"
	_tmp48_ = self->priv->_crop_points;
#line 176 "../src/ImageEditor.vala"
	_tmp48__length1 = self->priv->_crop_points_length1;
#line 176 "../src/ImageEditor.vala"
	_tmp49_ = self->priv->_image;
#line 176 "../src/ImageEditor.vala"
	_tmp50_ = node_image_get_crop_w (_tmp49_);
#line 176 "../src/ImageEditor.vala"
	_tmp51_ = _tmp50_;
#line 176 "../src/ImageEditor.vala"
	_tmp48_[8].width = _tmp51_;
#line 177 "../src/ImageEditor.vala"
	_tmp52_ = self->priv->_crop_points;
#line 177 "../src/ImageEditor.vala"
	_tmp52__length1 = self->priv->_crop_points_length1;
#line 177 "../src/ImageEditor.vala"
	_tmp53_ = self->priv->_image;
#line 177 "../src/ImageEditor.vala"
	_tmp54_ = node_image_get_crop_h (_tmp53_);
#line 177 "../src/ImageEditor.vala"
	_tmp55_ = _tmp54_;
#line 177 "../src/ImageEditor.vala"
	_tmp52_[8].height = _tmp55_;
#line 179 "../src/ImageEditor.vala"
	_tmp56_ = self->priv->_status_crop;
#line 179 "../src/ImageEditor.vala"
	_tmp57_ = self->priv->_crop_points;
#line 179 "../src/ImageEditor.vala"
	_tmp57__length1 = self->priv->_crop_points_length1;
#line 179 "../src/ImageEditor.vala"
	_tmp58_ = _tmp57_[8];
#line 179 "../src/ImageEditor.vala"
	_tmp59_ = _tmp58_.x;
#line 179 "../src/ImageEditor.vala"
	_tmp60_ = self->priv->_crop_points;
#line 179 "../src/ImageEditor.vala"
	_tmp60__length1 = self->priv->_crop_points_length1;
#line 179 "../src/ImageEditor.vala"
	_tmp61_ = _tmp60_[8];
#line 179 "../src/ImageEditor.vala"
	_tmp62_ = _tmp61_.y;
#line 179 "../src/ImageEditor.vala"
	_tmp63_ = self->priv->_crop_points;
#line 179 "../src/ImageEditor.vala"
	_tmp63__length1 = self->priv->_crop_points_length1;
#line 179 "../src/ImageEditor.vala"
	_tmp64_ = _tmp63_[8];
#line 179 "../src/ImageEditor.vala"
	_tmp65_ = _tmp64_.width;
#line 179 "../src/ImageEditor.vala"
	_tmp66_ = self->priv->_crop_points;
#line 179 "../src/ImageEditor.vala"
	_tmp66__length1 = self->priv->_crop_points_length1;
#line 179 "../src/ImageEditor.vala"
	_tmp67_ = _tmp66_[8];
#line 179 "../src/ImageEditor.vala"
	_tmp68_ = _tmp67_.height;
#line 179 "../src/ImageEditor.vala"
	_tmp69_ = g_strdup_printf (_ ("Crop Area: %d,%d %3dx%3d"), _tmp59_, _tmp62_, _tmp65_, _tmp68_);
#line 179 "../src/ImageEditor.vala"
	_tmp70_ = _tmp69_;
#line 179 "../src/ImageEditor.vala"
	gtk_label_set_label (_tmp56_, _tmp70_);
#line 179 "../src/ImageEditor.vala"
	_g_free0 (_tmp70_);
#line 1290 "ImageEditor.c"
}


static void
image_editor_set_crop_target (ImageEditor* self,
                              gdouble x,
                              gdouble y)
{
	GdkRectangle cursor = {0};
	GdkRectangle _tmp0_ = {0};
	GdkRectangle tmp = {0};
	gint i = 0;
	GdkRectangle* _tmp1_;
	gint _tmp1__length1;
#line 184 "../src/ImageEditor.vala"
	g_return_if_fail (self != NULL);
#line 185 "../src/ImageEditor.vala"
	_tmp0_.x = (gint) x;
#line 185 "../src/ImageEditor.vala"
	_tmp0_.y = (gint) y;
#line 185 "../src/ImageEditor.vala"
	_tmp0_.width = 1;
#line 185 "../src/ImageEditor.vala"
	_tmp0_.height = 1;
#line 185 "../src/ImageEditor.vala"
	cursor = _tmp0_;
#line 187 "../src/ImageEditor.vala"
	i = 0;
#line 188 "../src/ImageEditor.vala"
	_tmp1_ = self->priv->_crop_points;
#line 188 "../src/ImageEditor.vala"
	_tmp1__length1 = self->priv->_crop_points_length1;
#line 1323 "ImageEditor.c"
	{
		GdkRectangle* crop_point_collection = NULL;
		gint crop_point_collection_length1 = 0;
		gint _crop_point_collection_size_ = 0;
		gint crop_point_it = 0;
#line 188 "../src/ImageEditor.vala"
		crop_point_collection = _tmp1_;
#line 188 "../src/ImageEditor.vala"
		crop_point_collection_length1 = _tmp1__length1;
#line 188 "../src/ImageEditor.vala"
		for (crop_point_it = 0; crop_point_it < _tmp1__length1; crop_point_it = crop_point_it + 1) {
#line 1335 "ImageEditor.c"
			GdkRectangle crop_point = {0};
#line 188 "../src/ImageEditor.vala"
			crop_point = crop_point_collection[crop_point_it];
#line 1339 "ImageEditor.c"
			{
				GdkRectangle _tmp2_;
				GdkRectangle _tmp3_ = {0};
				gboolean _tmp4_;
				gint _tmp6_;
#line 189 "../src/ImageEditor.vala"
				_tmp2_ = cursor;
#line 189 "../src/ImageEditor.vala"
				_tmp4_ = gdk_rectangle_intersect (&crop_point, &_tmp2_, &_tmp3_);
#line 189 "../src/ImageEditor.vala"
				tmp = _tmp3_;
#line 189 "../src/ImageEditor.vala"
				if (_tmp4_) {
#line 1353 "ImageEditor.c"
					gint _tmp5_;
#line 190 "../src/ImageEditor.vala"
					_tmp5_ = i;
#line 190 "../src/ImageEditor.vala"
					self->priv->_crop_target = _tmp5_;
#line 191 "../src/ImageEditor.vala"
					return;
#line 1361 "ImageEditor.c"
				}
#line 193 "../src/ImageEditor.vala"
				_tmp6_ = i;
#line 193 "../src/ImageEditor.vala"
				i = _tmp6_ + 1;
#line 1367 "ImageEditor.c"
			}
		}
	}
#line 195 "../src/ImageEditor.vala"
	self->priv->_crop_target = -1;
#line 1373 "ImageEditor.c"
}


static void
image_editor_adjust_crop_points (ImageEditor* self,
                                 gint diffx,
                                 gint diffy)
{
	gint _tmp0_;
#line 199 "../src/ImageEditor.vala"
	g_return_if_fail (self != NULL);
#line 200 "../src/ImageEditor.vala"
	_tmp0_ = self->priv->_crop_target;
#line 200 "../src/ImageEditor.vala"
	if (_tmp0_ != -1) {
#line 1389 "ImageEditor.c"
		gint x = 0;
		NodeImage* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
		gint y = 0;
		NodeImage* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
		gint w = 0;
		NodeImage* _tmp7_;
		gint _tmp8_;
		gint _tmp9_;
		gint h = 0;
		NodeImage* _tmp10_;
		gint _tmp11_;
		gint _tmp12_;
		gint _tmp13_;
		gboolean _tmp34_ = FALSE;
		gboolean _tmp35_ = FALSE;
		gint _tmp36_;
		gboolean _tmp47_ = FALSE;
		gboolean _tmp48_ = FALSE;
		gint _tmp49_;
#line 201 "../src/ImageEditor.vala"
		_tmp1_ = self->priv->_image;
#line 201 "../src/ImageEditor.vala"
		_tmp2_ = node_image_get_crop_x (_tmp1_);
#line 201 "../src/ImageEditor.vala"
		_tmp3_ = _tmp2_;
#line 201 "../src/ImageEditor.vala"
		x = _tmp3_;
#line 202 "../src/ImageEditor.vala"
		_tmp4_ = self->priv->_image;
#line 202 "../src/ImageEditor.vala"
		_tmp5_ = node_image_get_crop_y (_tmp4_);
#line 202 "../src/ImageEditor.vala"
		_tmp6_ = _tmp5_;
#line 202 "../src/ImageEditor.vala"
		y = _tmp6_;
#line 203 "../src/ImageEditor.vala"
		_tmp7_ = self->priv->_image;
#line 203 "../src/ImageEditor.vala"
		_tmp8_ = node_image_get_crop_w (_tmp7_);
#line 203 "../src/ImageEditor.vala"
		_tmp9_ = _tmp8_;
#line 203 "../src/ImageEditor.vala"
		w = _tmp9_;
#line 204 "../src/ImageEditor.vala"
		_tmp10_ = self->priv->_image;
#line 204 "../src/ImageEditor.vala"
		_tmp11_ = node_image_get_crop_h (_tmp10_);
#line 204 "../src/ImageEditor.vala"
		_tmp12_ = _tmp11_;
#line 204 "../src/ImageEditor.vala"
		h = _tmp12_;
#line 205 "../src/ImageEditor.vala"
		_tmp13_ = self->priv->_crop_target;
#line 205 "../src/ImageEditor.vala"
		switch (_tmp13_) {
#line 205 "../src/ImageEditor.vala"
			case 0:
#line 1451 "ImageEditor.c"
			{
				gint _tmp14_;
				gint _tmp15_;
				gint _tmp16_;
				gint _tmp17_;
#line 206 "../src/ImageEditor.vala"
				_tmp14_ = x;
#line 206 "../src/ImageEditor.vala"
				x = _tmp14_ + diffx;
#line 206 "../src/ImageEditor.vala"
				_tmp15_ = y;
#line 206 "../src/ImageEditor.vala"
				y = _tmp15_ + diffy;
#line 206 "../src/ImageEditor.vala"
				_tmp16_ = w;
#line 206 "../src/ImageEditor.vala"
				w = _tmp16_ - diffx;
#line 206 "../src/ImageEditor.vala"
				_tmp17_ = h;
#line 206 "../src/ImageEditor.vala"
				h = _tmp17_ - diffy;
#line 206 "../src/ImageEditor.vala"
				break;
#line 1475 "ImageEditor.c"
			}
#line 205 "../src/ImageEditor.vala"
			case 1:
#line 1479 "ImageEditor.c"
			{
				gint _tmp18_;
				gint _tmp19_;
#line 207 "../src/ImageEditor.vala"
				_tmp18_ = y;
#line 207 "../src/ImageEditor.vala"
				y = _tmp18_ + diffy;
#line 207 "../src/ImageEditor.vala"
				_tmp19_ = h;
#line 207 "../src/ImageEditor.vala"
				h = _tmp19_ - diffy;
#line 207 "../src/ImageEditor.vala"
				break;
#line 1493 "ImageEditor.c"
			}
#line 205 "../src/ImageEditor.vala"
			case 2:
#line 1497 "ImageEditor.c"
			{
				gint _tmp20_;
				gint _tmp21_;
				gint _tmp22_;
#line 208 "../src/ImageEditor.vala"
				_tmp20_ = y;
#line 208 "../src/ImageEditor.vala"
				y = _tmp20_ + diffy;
#line 208 "../src/ImageEditor.vala"
				_tmp21_ = w;
#line 208 "../src/ImageEditor.vala"
				w = _tmp21_ + diffx;
#line 208 "../src/ImageEditor.vala"
				_tmp22_ = h;
#line 208 "../src/ImageEditor.vala"
				h = _tmp22_ - diffy;
#line 208 "../src/ImageEditor.vala"
				break;
#line 1516 "ImageEditor.c"
			}
#line 205 "../src/ImageEditor.vala"
			case 3:
#line 1520 "ImageEditor.c"
			{
				gint _tmp23_;
				gint _tmp24_;
#line 209 "../src/ImageEditor.vala"
				_tmp23_ = x;
#line 209 "../src/ImageEditor.vala"
				x = _tmp23_ + diffx;
#line 209 "../src/ImageEditor.vala"
				_tmp24_ = w;
#line 209 "../src/ImageEditor.vala"
				w = _tmp24_ - diffx;
#line 209 "../src/ImageEditor.vala"
				break;
#line 1534 "ImageEditor.c"
			}
#line 205 "../src/ImageEditor.vala"
			case 4:
#line 1538 "ImageEditor.c"
			{
				gint _tmp25_;
#line 210 "../src/ImageEditor.vala"
				_tmp25_ = w;
#line 210 "../src/ImageEditor.vala"
				w = _tmp25_ + diffx;
#line 210 "../src/ImageEditor.vala"
				break;
#line 1547 "ImageEditor.c"
			}
#line 205 "../src/ImageEditor.vala"
			case 5:
#line 1551 "ImageEditor.c"
			{
				gint _tmp26_;
				gint _tmp27_;
				gint _tmp28_;
#line 211 "../src/ImageEditor.vala"
				_tmp26_ = x;
#line 211 "../src/ImageEditor.vala"
				x = _tmp26_ + diffx;
#line 211 "../src/ImageEditor.vala"
				_tmp27_ = w;
#line 211 "../src/ImageEditor.vala"
				w = _tmp27_ - diffx;
#line 211 "../src/ImageEditor.vala"
				_tmp28_ = h;
#line 211 "../src/ImageEditor.vala"
				h = _tmp28_ + diffy;
#line 211 "../src/ImageEditor.vala"
				break;
#line 1570 "ImageEditor.c"
			}
#line 205 "../src/ImageEditor.vala"
			case 6:
#line 1574 "ImageEditor.c"
			{
				gint _tmp29_;
#line 212 "../src/ImageEditor.vala"
				_tmp29_ = h;
#line 212 "../src/ImageEditor.vala"
				h = _tmp29_ + diffy;
#line 212 "../src/ImageEditor.vala"
				break;
#line 1583 "ImageEditor.c"
			}
#line 205 "../src/ImageEditor.vala"
			case 7:
#line 1587 "ImageEditor.c"
			{
				gint _tmp30_;
				gint _tmp31_;
#line 213 "../src/ImageEditor.vala"
				_tmp30_ = w;
#line 213 "../src/ImageEditor.vala"
				w = _tmp30_ + diffx;
#line 213 "../src/ImageEditor.vala"
				_tmp31_ = h;
#line 213 "../src/ImageEditor.vala"
				h = _tmp31_ + diffy;
#line 213 "../src/ImageEditor.vala"
				break;
#line 1601 "ImageEditor.c"
			}
#line 205 "../src/ImageEditor.vala"
			case 8:
#line 1605 "ImageEditor.c"
			{
				gint _tmp32_;
				gint _tmp33_;
#line 214 "../src/ImageEditor.vala"
				_tmp32_ = x;
#line 214 "../src/ImageEditor.vala"
				x = _tmp32_ + diffx;
#line 214 "../src/ImageEditor.vala"
				_tmp33_ = y;
#line 214 "../src/ImageEditor.vala"
				y = _tmp33_ + diffy;
#line 214 "../src/ImageEditor.vala"
				break;
#line 1619 "ImageEditor.c"
			}
			default:
#line 205 "../src/ImageEditor.vala"
			break;
#line 1624 "ImageEditor.c"
		}
#line 216 "../src/ImageEditor.vala"
		_tmp36_ = x;
#line 216 "../src/ImageEditor.vala"
		if (_tmp36_ >= 0) {
#line 1630 "ImageEditor.c"
			gint _tmp37_;
			gint _tmp38_;
			GtkDrawingArea* _tmp39_;
			gint _tmp40_;
			gint _tmp41_;
#line 216 "../src/ImageEditor.vala"
			_tmp37_ = x;
#line 216 "../src/ImageEditor.vala"
			_tmp38_ = w;
#line 216 "../src/ImageEditor.vala"
			_tmp39_ = self->priv->_da;
#line 216 "../src/ImageEditor.vala"
			g_object_get ((GtkWidget*) _tmp39_, "width-request", &_tmp40_, NULL);
#line 216 "../src/ImageEditor.vala"
			_tmp41_ = _tmp40_;
#line 216 "../src/ImageEditor.vala"
			_tmp35_ = (_tmp37_ + _tmp38_) <= _tmp41_;
#line 1648 "ImageEditor.c"
		} else {
#line 216 "../src/ImageEditor.vala"
			_tmp35_ = FALSE;
#line 1652 "ImageEditor.c"
		}
#line 216 "../src/ImageEditor.vala"
		if (_tmp35_) {
#line 1656 "ImageEditor.c"
			gint _tmp42_;
#line 216 "../src/ImageEditor.vala"
			_tmp42_ = w;
#line 216 "../src/ImageEditor.vala"
			_tmp34_ = ((gdouble) _tmp42_) >= IMAGE_EDITOR_MIN_WIDTH;
#line 1662 "ImageEditor.c"
		} else {
#line 216 "../src/ImageEditor.vala"
			_tmp34_ = FALSE;
#line 1666 "ImageEditor.c"
		}
#line 216 "../src/ImageEditor.vala"
		if (_tmp34_) {
#line 1670 "ImageEditor.c"
			NodeImage* _tmp43_;
			gint _tmp44_;
			NodeImage* _tmp45_;
			gint _tmp46_;
#line 217 "../src/ImageEditor.vala"
			_tmp43_ = self->priv->_image;
#line 217 "../src/ImageEditor.vala"
			_tmp44_ = x;
#line 217 "../src/ImageEditor.vala"
			node_image_set_crop_x (_tmp43_, _tmp44_);
#line 218 "../src/ImageEditor.vala"
			_tmp45_ = self->priv->_image;
#line 218 "../src/ImageEditor.vala"
			_tmp46_ = w;
#line 218 "../src/ImageEditor.vala"
			node_image_set_crop_w (_tmp45_, _tmp46_);
#line 1687 "ImageEditor.c"
		}
#line 220 "../src/ImageEditor.vala"
		_tmp49_ = y;
#line 220 "../src/ImageEditor.vala"
		if (_tmp49_ >= 0) {
#line 1693 "ImageEditor.c"
			gint _tmp50_;
			gint _tmp51_;
			GtkDrawingArea* _tmp52_;
			gint _tmp53_;
			gint _tmp54_;
#line 220 "../src/ImageEditor.vala"
			_tmp50_ = y;
#line 220 "../src/ImageEditor.vala"
			_tmp51_ = h;
#line 220 "../src/ImageEditor.vala"
			_tmp52_ = self->priv->_da;
#line 220 "../src/ImageEditor.vala"
			g_object_get ((GtkWidget*) _tmp52_, "height-request", &_tmp53_, NULL);
#line 220 "../src/ImageEditor.vala"
			_tmp54_ = _tmp53_;
#line 220 "../src/ImageEditor.vala"
			_tmp48_ = (_tmp50_ + _tmp51_) <= _tmp54_;
#line 1711 "ImageEditor.c"
		} else {
#line 220 "../src/ImageEditor.vala"
			_tmp48_ = FALSE;
#line 1715 "ImageEditor.c"
		}
#line 220 "../src/ImageEditor.vala"
		if (_tmp48_) {
#line 1719 "ImageEditor.c"
			gint _tmp55_;
#line 220 "../src/ImageEditor.vala"
			_tmp55_ = h;
#line 220 "../src/ImageEditor.vala"
			_tmp47_ = ((gdouble) _tmp55_) >= IMAGE_EDITOR_MIN_WIDTH;
#line 1725 "ImageEditor.c"
		} else {
#line 220 "../src/ImageEditor.vala"
			_tmp47_ = FALSE;
#line 1729 "ImageEditor.c"
		}
#line 220 "../src/ImageEditor.vala"
		if (_tmp47_) {
#line 1733 "ImageEditor.c"
			NodeImage* _tmp56_;
			gint _tmp57_;
			NodeImage* _tmp58_;
			gint _tmp59_;
#line 221 "../src/ImageEditor.vala"
			_tmp56_ = self->priv->_image;
#line 221 "../src/ImageEditor.vala"
			_tmp57_ = y;
#line 221 "../src/ImageEditor.vala"
			node_image_set_crop_y (_tmp56_, _tmp57_);
#line 222 "../src/ImageEditor.vala"
			_tmp58_ = self->priv->_image;
#line 222 "../src/ImageEditor.vala"
			_tmp59_ = h;
#line 222 "../src/ImageEditor.vala"
			node_image_set_crop_h (_tmp58_, _tmp59_);
#line 1750 "ImageEditor.c"
		}
#line 224 "../src/ImageEditor.vala"
		image_editor_set_crop_points (self);
#line 1754 "ImageEditor.c"
	}
}


void
image_editor_create_ui (ImageEditor* self,
                        GtkWindow* parent,
                        ImageManager* im)
{
	GtkPopover* _tmp0_;
	GtkPopover* _tmp1_;
	GtkBox* box = NULL;
	GtkBox* _tmp2_;
	GtkDrawingArea* _tmp3_;
	GtkBox* status = NULL;
	GtkBox* _tmp4_;
	GtkBox* buttons = NULL;
	GtkBox* _tmp5_;
	GtkDrawingArea* _tmp6_;
	GtkPopover* _tmp7_;
#line 229 "../src/ImageEditor.vala"
	g_return_if_fail (self != NULL);
#line 229 "../src/ImageEditor.vala"
	g_return_if_fail (parent != NULL);
#line 229 "../src/ImageEditor.vala"
	g_return_if_fail (im != NULL);
#line 231 "../src/ImageEditor.vala"
	_tmp0_ = (GtkPopover*) gtk_popover_new ((GtkWidget*) parent);
#line 231 "../src/ImageEditor.vala"
	g_object_ref_sink (_tmp0_);
#line 231 "../src/ImageEditor.vala"
	_g_object_unref0 (self->priv->_popover);
#line 231 "../src/ImageEditor.vala"
	self->priv->_popover = _tmp0_;
#line 232 "../src/ImageEditor.vala"
	_tmp1_ = self->priv->_popover;
#line 232 "../src/ImageEditor.vala"
	gtk_popover_set_modal (_tmp1_, TRUE);
#line 234 "../src/ImageEditor.vala"
	_tmp2_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 5);
#line 234 "../src/ImageEditor.vala"
	g_object_ref_sink (_tmp2_);
#line 234 "../src/ImageEditor.vala"
	box = _tmp2_;
#line 236 "../src/ImageEditor.vala"
	gtk_container_set_border_width ((GtkContainer*) box, (guint) 5);
#line 238 "../src/ImageEditor.vala"
	_tmp3_ = image_editor_create_drawing_area (self, im);
#line 238 "../src/ImageEditor.vala"
	_g_object_unref0 (self->priv->_da);
#line 238 "../src/ImageEditor.vala"
	self->priv->_da = _tmp3_;
#line 239 "../src/ImageEditor.vala"
	_tmp4_ = image_editor_create_status_area (self);
#line 239 "../src/ImageEditor.vala"
	status = _tmp4_;
#line 240 "../src/ImageEditor.vala"
	_tmp5_ = image_editor_create_buttons (self, parent, im);
#line 240 "../src/ImageEditor.vala"
	buttons = _tmp5_;
#line 243 "../src/ImageEditor.vala"
	_tmp6_ = self->priv->_da;
#line 243 "../src/ImageEditor.vala"
	gtk_box_pack_start (box, (GtkWidget*) _tmp6_, TRUE, TRUE, (guint) 0);
#line 244 "../src/ImageEditor.vala"
	gtk_box_pack_start (box, (GtkWidget*) status, FALSE, FALSE, (guint) 0);
#line 245 "../src/ImageEditor.vala"
	gtk_box_pack_start (box, (GtkWidget*) buttons, FALSE, TRUE, (guint) 0);
#line 247 "../src/ImageEditor.vala"
	gtk_widget_show_all ((GtkWidget*) box);
#line 250 "../src/ImageEditor.vala"
	_tmp7_ = self->priv->_popover;
#line 250 "../src/ImageEditor.vala"
	gtk_container_add ((GtkContainer*) _tmp7_, (GtkWidget*) box);
#line 229 "../src/ImageEditor.vala"
	_g_object_unref0 (buttons);
#line 229 "../src/ImageEditor.vala"
	_g_object_unref0 (status);
#line 229 "../src/ImageEditor.vala"
	_g_object_unref0 (box);
#line 1835 "ImageEditor.c"
}


static gpointer
_image_manager_ref0 (gpointer self)
{
#line 255 "../src/ImageEditor.vala"
	return self ? image_manager_ref (self) : NULL;
#line 1844 "ImageEditor.c"
}


static Block12Data*
block12_data_ref (Block12Data* _data12_)
{
#line 255 "../src/ImageEditor.vala"
	g_atomic_int_inc (&_data12_->_ref_count_);
#line 255 "../src/ImageEditor.vala"
	return _data12_;
#line 1855 "ImageEditor.c"
}


static void
block12_data_unref (void * _userdata_)
{
	Block12Data* _data12_;
	_data12_ = (Block12Data*) _userdata_;
#line 255 "../src/ImageEditor.vala"
	if (g_atomic_int_dec_and_test (&_data12_->_ref_count_)) {
#line 1866 "ImageEditor.c"
		ImageEditor* self;
#line 255 "../src/ImageEditor.vala"
		self = _data12_->self;
#line 255 "../src/ImageEditor.vala"
		_g_object_unref0 (_data12_->da);
#line 255 "../src/ImageEditor.vala"
		_image_manager_unref0 (_data12_->im);
#line 255 "../src/ImageEditor.vala"
		_image_editor_unref0 (self);
#line 255 "../src/ImageEditor.vala"
		g_slice_free (Block12Data, _data12_);
#line 1878 "ImageEditor.c"
	}
}


static gboolean
__lambda57_ (ImageEditor* self,
             cairo_t* ctx)
{
	gboolean result = FALSE;
#line 277 "../src/ImageEditor.vala"
	g_return_val_if_fail (ctx != NULL, FALSE);
#line 278 "../src/ImageEditor.vala"
	image_editor_draw_image (self, ctx);
#line 279 "../src/ImageEditor.vala"
	result = FALSE;
#line 279 "../src/ImageEditor.vala"
	return result;
#line 1896 "ImageEditor.c"
}


static gboolean
___lambda57__gtk_widget_draw (GtkWidget* _sender,
                              cairo_t* cr,
                              gpointer self)
{
	gboolean result;
	result = __lambda57_ ((ImageEditor*) self, cr);
#line 277 "../src/ImageEditor.vala"
	return result;
#line 1909 "ImageEditor.c"
}


static gboolean
__lambda58_ (ImageEditor* self,
             GdkEventButton* e)
{
	gboolean result = FALSE;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gint _tmp2_;
	gdouble _tmp11_;
	gdouble _tmp12_;
#line 282 "../src/ImageEditor.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 283 "../src/ImageEditor.vala"
	_tmp0_ = e->x;
#line 283 "../src/ImageEditor.vala"
	_tmp1_ = e->y;
#line 283 "../src/ImageEditor.vala"
	image_editor_set_crop_target (self, _tmp0_, _tmp1_);
#line 284 "../src/ImageEditor.vala"
	_tmp2_ = self->priv->_crop_target;
#line 284 "../src/ImageEditor.vala"
	if (_tmp2_ == 8) {
#line 1935 "ImageEditor.c"
		GdkWindow* win = NULL;
		GtkDrawingArea* _tmp3_;
		GdkWindow* _tmp4_;
		GdkWindow* _tmp5_;
		GdkWindow* _tmp6_;
		GtkPopover* _tmp7_;
		GdkDisplay* _tmp8_;
		GdkCursor* _tmp9_;
		GdkCursor* _tmp10_;
#line 285 "../src/ImageEditor.vala"
		_tmp3_ = self->priv->_da;
#line 285 "../src/ImageEditor.vala"
		_tmp4_ = gtk_widget_get_window ((GtkWidget*) _tmp3_);
#line 285 "../src/ImageEditor.vala"
		_tmp5_ = _g_object_ref0 (_tmp4_);
#line 285 "../src/ImageEditor.vala"
		win = _tmp5_;
#line 286 "../src/ImageEditor.vala"
		_tmp6_ = win;
#line 286 "../src/ImageEditor.vala"
		_tmp7_ = self->priv->_popover;
#line 286 "../src/ImageEditor.vala"
		_tmp8_ = gtk_widget_get_display ((GtkWidget*) _tmp7_);
#line 286 "../src/ImageEditor.vala"
		_tmp9_ = gdk_cursor_new_from_name (_tmp8_, "grabbing");
#line 286 "../src/ImageEditor.vala"
		_tmp10_ = _tmp9_;
#line 286 "../src/ImageEditor.vala"
		gdk_window_set_cursor (_tmp6_, _tmp10_);
#line 286 "../src/ImageEditor.vala"
		_g_object_unref0 (_tmp10_);
#line 284 "../src/ImageEditor.vala"
		_g_object_unref0 (win);
#line 1969 "ImageEditor.c"
	}
#line 288 "../src/ImageEditor.vala"
	_tmp11_ = e->x;
#line 288 "../src/ImageEditor.vala"
	self->priv->_last_x = _tmp11_;
#line 289 "../src/ImageEditor.vala"
	_tmp12_ = e->y;
#line 289 "../src/ImageEditor.vala"
	self->priv->_last_y = _tmp12_;
#line 290 "../src/ImageEditor.vala"
	result = FALSE;
#line 290 "../src/ImageEditor.vala"
	return result;
#line 1983 "ImageEditor.c"
}


static gboolean
___lambda58__gtk_widget_button_press_event (GtkWidget* _sender,
                                            GdkEventButton* event,
                                            gpointer self)
{
	gboolean result;
	result = __lambda58_ ((ImageEditor*) self, event);
#line 282 "../src/ImageEditor.vala"
	return result;
#line 1996 "ImageEditor.c"
}


static gboolean
__lambda59_ (Block12Data* _data12_,
             GdkEventMotion* e)
{
	ImageEditor* self;
	gboolean result = FALSE;
	gint _tmp0_;
	gdouble _tmp13_;
	gdouble _tmp14_;
	gdouble _tmp15_;
	gdouble _tmp16_;
#line 293 "../src/ImageEditor.vala"
	self = _data12_->self;
#line 293 "../src/ImageEditor.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 294 "../src/ImageEditor.vala"
	_tmp0_ = self->priv->_crop_target;
#line 294 "../src/ImageEditor.vala"
	if (_tmp0_ == -1) {
#line 2019 "ImageEditor.c"
		gdouble _tmp1_;
		gdouble _tmp2_;
		gboolean _tmp3_ = FALSE;
		gint _tmp4_;
#line 295 "../src/ImageEditor.vala"
		_tmp1_ = e->x;
#line 295 "../src/ImageEditor.vala"
		_tmp2_ = e->y;
#line 295 "../src/ImageEditor.vala"
		image_editor_set_crop_target (self, _tmp1_, _tmp2_);
#line 296 "../src/ImageEditor.vala"
		_tmp4_ = self->priv->_crop_target;
#line 296 "../src/ImageEditor.vala"
		if (_tmp4_ >= 0) {
#line 2034 "ImageEditor.c"
			gint _tmp5_;
#line 296 "../src/ImageEditor.vala"
			_tmp5_ = self->priv->_crop_target;
#line 296 "../src/ImageEditor.vala"
			_tmp3_ = _tmp5_ < 8;
#line 2040 "ImageEditor.c"
		} else {
#line 296 "../src/ImageEditor.vala"
			_tmp3_ = FALSE;
#line 2044 "ImageEditor.c"
		}
#line 296 "../src/ImageEditor.vala"
		if (_tmp3_) {
#line 2048 "ImageEditor.c"
			GdkCursorType* _tmp6_;
			gint _tmp6__length1;
			gint _tmp7_;
			GdkCursorType _tmp8_;
#line 297 "../src/ImageEditor.vala"
			_tmp6_ = self->priv->_crop_cursors;
#line 297 "../src/ImageEditor.vala"
			_tmp6__length1 = self->priv->_crop_cursors_length1;
#line 297 "../src/ImageEditor.vala"
			_tmp7_ = self->priv->_crop_target;
#line 297 "../src/ImageEditor.vala"
			_tmp8_ = _tmp6_[_tmp7_];
#line 297 "../src/ImageEditor.vala"
			image_editor_set_cursor (self, &_tmp8_);
#line 2063 "ImageEditor.c"
		} else {
#line 299 "../src/ImageEditor.vala"
			image_editor_set_cursor (self, NULL);
#line 2067 "ImageEditor.c"
		}
#line 301 "../src/ImageEditor.vala"
		self->priv->_crop_target = -1;
#line 2071 "ImageEditor.c"
	} else {
		gdouble _tmp9_;
		gdouble _tmp10_;
		gdouble _tmp11_;
		gdouble _tmp12_;
#line 303 "../src/ImageEditor.vala"
		_tmp9_ = e->x;
#line 303 "../src/ImageEditor.vala"
		_tmp10_ = self->priv->_last_x;
#line 303 "../src/ImageEditor.vala"
		_tmp11_ = e->y;
#line 303 "../src/ImageEditor.vala"
		_tmp12_ = self->priv->_last_y;
#line 303 "../src/ImageEditor.vala"
		image_editor_adjust_crop_points (self, (gint) (_tmp9_ - _tmp10_), (gint) (_tmp11_ - _tmp12_));
#line 304 "../src/ImageEditor.vala"
		gtk_widget_queue_draw ((GtkWidget*) _data12_->da);
#line 2089 "ImageEditor.c"
	}
#line 306 "../src/ImageEditor.vala"
	_tmp13_ = e->x;
#line 306 "../src/ImageEditor.vala"
	self->priv->_last_x = _tmp13_;
#line 307 "../src/ImageEditor.vala"
	_tmp14_ = e->y;
#line 307 "../src/ImageEditor.vala"
	self->priv->_last_y = _tmp14_;
#line 308 "../src/ImageEditor.vala"
	_tmp15_ = e->x;
#line 308 "../src/ImageEditor.vala"
	_tmp16_ = e->y;
#line 308 "../src/ImageEditor.vala"
	image_editor_set_cursor_location (self, (gint) _tmp15_, (gint) _tmp16_);
#line 309 "../src/ImageEditor.vala"
	result = FALSE;
#line 309 "../src/ImageEditor.vala"
	return result;
#line 2109 "ImageEditor.c"
}


static gboolean
___lambda59__gtk_widget_motion_notify_event (GtkWidget* _sender,
                                             GdkEventMotion* event,
                                             gpointer self)
{
	gboolean result;
	result = __lambda59_ (self, event);
#line 293 "../src/ImageEditor.vala"
	return result;
#line 2122 "ImageEditor.c"
}


static gboolean
__lambda60_ (ImageEditor* self,
             GdkEventButton* e)
{
	gboolean result = FALSE;
#line 312 "../src/ImageEditor.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 313 "../src/ImageEditor.vala"
	self->priv->_crop_target = -1;
#line 314 "../src/ImageEditor.vala"
	image_editor_set_cursor (self, NULL);
#line 315 "../src/ImageEditor.vala"
	result = FALSE;
#line 315 "../src/ImageEditor.vala"
	return result;
#line 2141 "ImageEditor.c"
}


static gboolean
___lambda60__gtk_widget_button_release_event (GtkWidget* _sender,
                                              GdkEventButton* event,
                                              gpointer self)
{
	gboolean result;
	result = __lambda60_ ((ImageEditor*) self, event);
#line 312 "../src/ImageEditor.vala"
	return result;
#line 2154 "ImageEditor.c"
}


static void
__lambda61_ (Block12Data* _data12_,
             GdkDragContext* ctx,
             gint x,
             gint y,
             GtkSelectionData* data,
             guint info,
             guint t)
{
	ImageEditor* self;
	gchar** _tmp0_;
	gchar** _tmp1_;
	gchar** _tmp2_;
	gint _tmp2__length1;
	gboolean _tmp3_;
#line 321 "../src/ImageEditor.vala"
	self = _data12_->self;
#line 321 "../src/ImageEditor.vala"
	g_return_if_fail (ctx != NULL);
#line 321 "../src/ImageEditor.vala"
	g_return_if_fail (data != NULL);
#line 322 "../src/ImageEditor.vala"
	_tmp1_ = _tmp0_ = gtk_selection_data_get_uris (data);
#line 322 "../src/ImageEditor.vala"
	_tmp2_ = _tmp1_;
#line 322 "../src/ImageEditor.vala"
	_tmp2__length1 = _vala_array_length (_tmp0_);
#line 322 "../src/ImageEditor.vala"
	_tmp3_ = _vala_array_length (_tmp0_) == 1;
#line 322 "../src/ImageEditor.vala"
	_tmp2_ = (_vala_array_free (_tmp2_, _tmp2__length1, (GDestroyNotify) g_free), NULL);
#line 322 "../src/ImageEditor.vala"
	if (_tmp3_) {
#line 2191 "ImageEditor.c"
		NodeImage* ni = NULL;
		gchar** _tmp4_;
		gchar** _tmp5_;
		gchar** _tmp6_;
		gint _tmp6__length1;
		const gchar* _tmp7_;
		Node* _tmp8_;
		NodeImage* _tmp9_;
		NodeImage* _tmp10_;
		gboolean _tmp11_ = FALSE;
		NodeImage* _tmp12_;
#line 323 "../src/ImageEditor.vala"
		_tmp5_ = _tmp4_ = gtk_selection_data_get_uris (data);
#line 323 "../src/ImageEditor.vala"
		_tmp6_ = _tmp5_;
#line 323 "../src/ImageEditor.vala"
		_tmp6__length1 = _vala_array_length (_tmp4_);
#line 323 "../src/ImageEditor.vala"
		_tmp7_ = _tmp6_[0];
#line 323 "../src/ImageEditor.vala"
		_tmp8_ = self->priv->_node;
#line 323 "../src/ImageEditor.vala"
		_tmp9_ = node_image_new_from_uri (_data12_->im, _tmp7_, node_max_width (_tmp8_));
#line 323 "../src/ImageEditor.vala"
		_tmp10_ = _tmp9_;
#line 323 "../src/ImageEditor.vala"
		_tmp6_ = (_vala_array_free (_tmp6_, _tmp6__length1, (GDestroyNotify) g_free), NULL);
#line 323 "../src/ImageEditor.vala"
		ni = _tmp10_;
#line 324 "../src/ImageEditor.vala"
		_tmp12_ = ni;
#line 324 "../src/ImageEditor.vala"
		if (_tmp12_ != NULL) {
#line 2225 "ImageEditor.c"
			NodeImage* _tmp13_;
#line 324 "../src/ImageEditor.vala"
			_tmp13_ = ni;
#line 324 "../src/ImageEditor.vala"
			_tmp11_ = image_editor_initialize (self, _tmp13_);
#line 2231 "ImageEditor.c"
		} else {
#line 324 "../src/ImageEditor.vala"
			_tmp11_ = FALSE;
#line 2235 "ImageEditor.c"
		}
#line 324 "../src/ImageEditor.vala"
		if (_tmp11_) {
#line 325 "../src/ImageEditor.vala"
			gtk_drag_finish (ctx, TRUE, FALSE, (guint32) t);
#line 2241 "ImageEditor.c"
		}
#line 322 "../src/ImageEditor.vala"
		_node_image_unref0 (ni);
#line 2245 "ImageEditor.c"
	}
}


static void
___lambda61__gtk_widget_drag_data_received (GtkWidget* _sender,
                                            GdkDragContext* context,
                                            gint x,
                                            gint y,
                                            GtkSelectionData* selection_data,
                                            guint info,
                                            guint time_,
                                            gpointer self)
{
#line 321 "../src/ImageEditor.vala"
	__lambda61_ (self, context, x, y, selection_data, info, time_);
#line 2262 "ImageEditor.c"
}


GtkDrawingArea*
image_editor_create_drawing_area (ImageEditor* self,
                                  ImageManager* im)
{
	GtkDrawingArea* result = NULL;
	Block12Data* _data12_;
	ImageManager* _tmp0_;
	GtkDrawingArea* _tmp1_;
	GtkStyleContext* _tmp2_;
	GtkDrawingArea* _tmp3_;
#line 255 "../src/ImageEditor.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 255 "../src/ImageEditor.vala"
	g_return_val_if_fail (im != NULL, NULL);
#line 255 "../src/ImageEditor.vala"
	_data12_ = g_slice_new0 (Block12Data);
#line 255 "../src/ImageEditor.vala"
	_data12_->_ref_count_ = 1;
#line 255 "../src/ImageEditor.vala"
	_data12_->self = image_editor_ref (self);
#line 255 "../src/ImageEditor.vala"
	_tmp0_ = _image_manager_ref0 (im);
#line 255 "../src/ImageEditor.vala"
	_image_manager_unref0 (_data12_->im);
#line 255 "../src/ImageEditor.vala"
	_data12_->im = _tmp0_;
#line 257 "../src/ImageEditor.vala"
	_tmp1_ = (GtkDrawingArea*) gtk_drawing_area_new ();
#line 257 "../src/ImageEditor.vala"
	g_object_ref_sink (_tmp1_);
#line 257 "../src/ImageEditor.vala"
	_data12_->da = _tmp1_;
#line 259 "../src/ImageEditor.vala"
	g_object_set ((GtkWidget*) _data12_->da, "width-request", NODE_IMAGE_EDIT_WIDTH, NULL);
#line 260 "../src/ImageEditor.vala"
	g_object_set ((GtkWidget*) _data12_->da, "height-request", NODE_IMAGE_EDIT_HEIGHT, NULL);
#line 263 "../src/ImageEditor.vala"
	gtk_widget_add_events ((GtkWidget*) _data12_->da, (gint) (((GDK_BUTTON_PRESS_MASK | GDK_BUTTON_RELEASE_MASK) | GDK_BUTTON1_MOTION_MASK) | GDK_POINTER_MOTION_MASK));
#line 274 "../src/ImageEditor.vala"
	_tmp2_ = gtk_widget_get_style_context ((GtkWidget*) _data12_->da);
#line 274 "../src/ImageEditor.vala"
	gtk_style_context_add_class (_tmp2_, "canvas");
#line 277 "../src/ImageEditor.vala"
	g_signal_connect ((GtkWidget*) _data12_->da, "draw", (GCallback) ___lambda57__gtk_widget_draw, self);
#line 282 "../src/ImageEditor.vala"
	g_signal_connect ((GtkWidget*) _data12_->da, "button-press-event", (GCallback) ___lambda58__gtk_widget_button_press_event, self);
#line 293 "../src/ImageEditor.vala"
	g_signal_connect_data ((GtkWidget*) _data12_->da, "motion-notify-event", (GCallback) ___lambda59__gtk_widget_motion_notify_event, block12_data_ref (_data12_), (GClosureNotify) block12_data_unref, 0);
#line 312 "../src/ImageEditor.vala"
	g_signal_connect ((GtkWidget*) _data12_->da, "button-release-event", (GCallback) ___lambda60__gtk_widget_button_release_event, self);
#line 319 "../src/ImageEditor.vala"
	gtk_drag_dest_set ((GtkWidget*) _data12_->da, GTK_DEST_DEFAULT_MOTION | GTK_DEST_DEFAULT_DROP, IMAGE_EDITOR_DRAG_TARGETS, G_N_ELEMENTS (IMAGE_EDITOR_DRAG_TARGETS), GDK_ACTION_COPY);
#line 321 "../src/ImageEditor.vala"
	g_signal_connect_data ((GtkWidget*) _data12_->da, "drag-data-received", (GCallback) ___lambda61__gtk_widget_drag_data_received, block12_data_ref (_data12_), (GClosureNotify) block12_data_unref, 0);
#line 330 "../src/ImageEditor.vala"
	_tmp3_ = _g_object_ref0 (_data12_->da);
#line 330 "../src/ImageEditor.vala"
	result = _tmp3_;
#line 330 "../src/ImageEditor.vala"
	block12_data_unref (_data12_);
#line 330 "../src/ImageEditor.vala"
	_data12_ = NULL;
#line 330 "../src/ImageEditor.vala"
	return result;
#line 2330 "ImageEditor.c"
}


static GtkBox*
image_editor_create_status_area (ImageEditor* self)
{
	GtkBox* result = NULL;
	GtkBox* box = NULL;
	GtkBox* _tmp0_;
	GtkLabel* _tmp1_;
	GtkLabel* _tmp2_;
	GtkLabel* _tmp3_;
	GtkLabel* _tmp4_;
#line 335 "../src/ImageEditor.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 337 "../src/ImageEditor.vala"
	_tmp0_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 10);
#line 337 "../src/ImageEditor.vala"
	g_object_ref_sink (_tmp0_);
#line 337 "../src/ImageEditor.vala"
	box = _tmp0_;
#line 339 "../src/ImageEditor.vala"
	gtk_box_set_homogeneous (box, TRUE);
#line 341 "../src/ImageEditor.vala"
	_tmp1_ = (GtkLabel*) gtk_label_new (NULL);
#line 341 "../src/ImageEditor.vala"
	g_object_ref_sink (_tmp1_);
#line 341 "../src/ImageEditor.vala"
	_g_object_unref0 (self->priv->_status_cursor);
#line 341 "../src/ImageEditor.vala"
	self->priv->_status_cursor = _tmp1_;
#line 342 "../src/ImageEditor.vala"
	_tmp2_ = (GtkLabel*) gtk_label_new (NULL);
#line 342 "../src/ImageEditor.vala"
	g_object_ref_sink (_tmp2_);
#line 342 "../src/ImageEditor.vala"
	_g_object_unref0 (self->priv->_status_crop);
#line 342 "../src/ImageEditor.vala"
	self->priv->_status_crop = _tmp2_;
#line 344 "../src/ImageEditor.vala"
	_tmp3_ = self->priv->_status_cursor;
#line 344 "../src/ImageEditor.vala"
	gtk_box_pack_start (box, (GtkWidget*) _tmp3_, FALSE, FALSE, (guint) 0);
#line 345 "../src/ImageEditor.vala"
	_tmp4_ = self->priv->_status_crop;
#line 345 "../src/ImageEditor.vala"
	gtk_box_pack_start (box, (GtkWidget*) _tmp4_, FALSE, FALSE, (guint) 0);
#line 347 "../src/ImageEditor.vala"
	result = box;
#line 347 "../src/ImageEditor.vala"
	return result;
#line 2382 "ImageEditor.c"
}


static void
image_editor_set_cursor_location (ImageEditor* self,
                                  gint x,
                                  gint y)
{
	GtkLabel* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
#line 352 "../src/ImageEditor.vala"
	g_return_if_fail (self != NULL);
#line 353 "../src/ImageEditor.vala"
	_tmp0_ = self->priv->_status_cursor;
#line 353 "../src/ImageEditor.vala"
	_tmp1_ = g_strdup_printf (_ ("Cursor: %3d,%3d"), x, y);
#line 353 "../src/ImageEditor.vala"
	_tmp2_ = _tmp1_;
#line 353 "../src/ImageEditor.vala"
	gtk_label_set_label (_tmp0_, _tmp2_);
#line 353 "../src/ImageEditor.vala"
	_g_free0 (_tmp2_);
#line 2406 "ImageEditor.c"
}


static Block13Data*
block13_data_ref (Block13Data* _data13_)
{
#line 357 "../src/ImageEditor.vala"
	g_atomic_int_inc (&_data13_->_ref_count_);
#line 357 "../src/ImageEditor.vala"
	return _data13_;
#line 2417 "ImageEditor.c"
}


static void
block13_data_unref (void * _userdata_)
{
	Block13Data* _data13_;
	_data13_ = (Block13Data*) _userdata_;
#line 357 "../src/ImageEditor.vala"
	if (g_atomic_int_dec_and_test (&_data13_->_ref_count_)) {
#line 2428 "ImageEditor.c"
		ImageEditor* self;
#line 357 "../src/ImageEditor.vala"
		self = _data13_->self;
#line 357 "../src/ImageEditor.vala"
		_g_object_unref0 (_data13_->parent);
#line 357 "../src/ImageEditor.vala"
		_image_manager_unref0 (_data13_->im);
#line 357 "../src/ImageEditor.vala"
		_image_editor_unref0 (self);
#line 357 "../src/ImageEditor.vala"
		g_slice_free (Block13Data, _data13_);
#line 2440 "ImageEditor.c"
	}
}


static void
__lambda62_ (ImageEditor* self)
{
#line 366 "../src/ImageEditor.vala"
	image_editor_show_popover (self, FALSE);
#line 2450 "ImageEditor.c"
}


static void
___lambda62__gtk_button_clicked (GtkButton* _sender,
                                 gpointer self)
{
#line 365 "../src/ImageEditor.vala"
	__lambda62_ ((ImageEditor*) self);
#line 2460 "ImageEditor.c"
}


static void
__lambda63_ (Block13Data* _data13_)
{
	ImageEditor* self;
#line 369 "../src/ImageEditor.vala"
	self = _data13_->self;
#line 370 "../src/ImageEditor.vala"
	image_editor_set_image (self, _data13_->im);
#line 2472 "ImageEditor.c"
}


static void
___lambda63__gtk_button_clicked (GtkButton* _sender,
                                 gpointer self)
{
#line 369 "../src/ImageEditor.vala"
	__lambda63_ (self);
#line 2482 "ImageEditor.c"
}


static void
__lambda64_ (Block13Data* _data13_)
{
	ImageEditor* self;
	gint id = 0;
	gint _tmp0_;
#line 373 "../src/ImageEditor.vala"
	self = _data13_->self;
#line 374 "../src/ImageEditor.vala"
	id = image_manager_choose_image (_data13_->im, _data13_->parent);
#line 375 "../src/ImageEditor.vala"
	_tmp0_ = id;
#line 375 "../src/ImageEditor.vala"
	if (_tmp0_ != -1) {
#line 2500 "ImageEditor.c"
		NodeImage* ni = NULL;
		gint _tmp1_;
		Node* _tmp2_;
		NodeImage* _tmp3_;
		NodeImage* _tmp4_;
#line 376 "../src/ImageEditor.vala"
		_tmp1_ = id;
#line 376 "../src/ImageEditor.vala"
		_tmp2_ = self->priv->_node;
#line 376 "../src/ImageEditor.vala"
		_tmp3_ = node_image_new (_data13_->im, _tmp1_, node_max_width (_tmp2_));
#line 376 "../src/ImageEditor.vala"
		ni = _tmp3_;
#line 377 "../src/ImageEditor.vala"
		_tmp4_ = ni;
#line 377 "../src/ImageEditor.vala"
		if (_tmp4_ != NULL) {
#line 2518 "ImageEditor.c"
			NodeImage* _tmp5_;
#line 378 "../src/ImageEditor.vala"
			_tmp5_ = ni;
#line 378 "../src/ImageEditor.vala"
			image_editor_initialize (self, _tmp5_);
#line 2524 "ImageEditor.c"
		}
#line 375 "../src/ImageEditor.vala"
		_node_image_unref0 (ni);
#line 2528 "ImageEditor.c"
	}
}


static void
___lambda64__gtk_button_clicked (GtkButton* _sender,
                                 gpointer self)
{
#line 373 "../src/ImageEditor.vala"
	__lambda64_ (self);
#line 2539 "ImageEditor.c"
}


static void
__lambda65_ (Block13Data* _data13_)
{
	ImageEditor* self;
#line 383 "../src/ImageEditor.vala"
	self = _data13_->self;
#line 384 "../src/ImageEditor.vala"
	image_editor_remove_image (self, _data13_->im);
#line 2551 "ImageEditor.c"
}


static void
___lambda65__gtk_button_clicked (GtkButton* _sender,
                                 gpointer self)
{
#line 383 "../src/ImageEditor.vala"
	__lambda65_ (self);
#line 2561 "ImageEditor.c"
}


static GtkBox*
image_editor_create_buttons (ImageEditor* self,
                             GtkWindow* parent,
                             ImageManager* im)
{
	GtkBox* result = NULL;
	Block13Data* _data13_;
	GtkWindow* _tmp0_;
	ImageManager* _tmp1_;
	GtkBox* box = NULL;
	GtkBox* _tmp2_;
	GtkButton* cancel = NULL;
	GtkButton* _tmp3_;
	GtkButton* apply = NULL;
	GtkButton* _tmp4_;
	GtkButton* change = NULL;
	GtkButton* _tmp5_;
	GtkButton* remove = NULL;
	GtkButton* _tmp6_;
#line 357 "../src/ImageEditor.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 357 "../src/ImageEditor.vala"
	g_return_val_if_fail (parent != NULL, NULL);
#line 357 "../src/ImageEditor.vala"
	g_return_val_if_fail (im != NULL, NULL);
#line 357 "../src/ImageEditor.vala"
	_data13_ = g_slice_new0 (Block13Data);
#line 357 "../src/ImageEditor.vala"
	_data13_->_ref_count_ = 1;
#line 357 "../src/ImageEditor.vala"
	_data13_->self = image_editor_ref (self);
#line 357 "../src/ImageEditor.vala"
	_tmp0_ = _g_object_ref0 (parent);
#line 357 "../src/ImageEditor.vala"
	_g_object_unref0 (_data13_->parent);
#line 357 "../src/ImageEditor.vala"
	_data13_->parent = _tmp0_;
#line 357 "../src/ImageEditor.vala"
	_tmp1_ = _image_manager_ref0 (im);
#line 357 "../src/ImageEditor.vala"
	_image_manager_unref0 (_data13_->im);
#line 357 "../src/ImageEditor.vala"
	_data13_->im = _tmp1_;
#line 359 "../src/ImageEditor.vala"
	_tmp2_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 5);
#line 359 "../src/ImageEditor.vala"
	g_object_ref_sink (_tmp2_);
#line 359 "../src/ImageEditor.vala"
	box = _tmp2_;
#line 360 "../src/ImageEditor.vala"
	_tmp3_ = (GtkButton*) gtk_button_new_with_label (_ ("Cancel"));
#line 360 "../src/ImageEditor.vala"
	g_object_ref_sink (_tmp3_);
#line 360 "../src/ImageEditor.vala"
	cancel = _tmp3_;
#line 361 "../src/ImageEditor.vala"
	_tmp4_ = (GtkButton*) gtk_button_new_with_label (_ ("Apply"));
#line 361 "../src/ImageEditor.vala"
	g_object_ref_sink (_tmp4_);
#line 361 "../src/ImageEditor.vala"
	apply = _tmp4_;
#line 362 "../src/ImageEditor.vala"
	_tmp5_ = (GtkButton*) gtk_button_new_with_label (_ ("Change Image"));
#line 362 "../src/ImageEditor.vala"
	g_object_ref_sink (_tmp5_);
#line 362 "../src/ImageEditor.vala"
	change = _tmp5_;
#line 363 "../src/ImageEditor.vala"
	_tmp6_ = (GtkButton*) gtk_button_new_with_label (_ ("Remove Image"));
#line 363 "../src/ImageEditor.vala"
	g_object_ref_sink (_tmp6_);
#line 363 "../src/ImageEditor.vala"
	remove = _tmp6_;
#line 365 "../src/ImageEditor.vala"
	g_signal_connect (cancel, "clicked", (GCallback) ___lambda62__gtk_button_clicked, self);
#line 369 "../src/ImageEditor.vala"
	g_signal_connect_data (apply, "clicked", (GCallback) ___lambda63__gtk_button_clicked, block13_data_ref (_data13_), (GClosureNotify) block13_data_unref, 0);
#line 373 "../src/ImageEditor.vala"
	g_signal_connect_data (change, "clicked", (GCallback) ___lambda64__gtk_button_clicked, block13_data_ref (_data13_), (GClosureNotify) block13_data_unref, 0);
#line 383 "../src/ImageEditor.vala"
	g_signal_connect_data (remove, "clicked", (GCallback) ___lambda65__gtk_button_clicked, block13_data_ref (_data13_), (GClosureNotify) block13_data_unref, 0);
#line 387 "../src/ImageEditor.vala"
	gtk_box_pack_start (box, (GtkWidget*) change, FALSE, FALSE, (guint) 0);
#line 388 "../src/ImageEditor.vala"
	gtk_box_pack_start (box, (GtkWidget*) remove, FALSE, FALSE, (guint) 0);
#line 389 "../src/ImageEditor.vala"
	gtk_box_pack_end (box, (GtkWidget*) apply, FALSE, FALSE, (guint) 0);
#line 390 "../src/ImageEditor.vala"
	gtk_box_pack_end (box, (GtkWidget*) cancel, FALSE, FALSE, (guint) 0);
#line 392 "../src/ImageEditor.vala"
	result = box;
#line 392 "../src/ImageEditor.vala"
	_g_object_unref0 (remove);
#line 392 "../src/ImageEditor.vala"
	_g_object_unref0 (change);
#line 392 "../src/ImageEditor.vala"
	_g_object_unref0 (apply);
#line 392 "../src/ImageEditor.vala"
	_g_object_unref0 (cancel);
#line 392 "../src/ImageEditor.vala"
	block13_data_unref (_data13_);
#line 392 "../src/ImageEditor.vala"
	_data13_ = NULL;
#line 392 "../src/ImageEditor.vala"
	return result;
#line 2670 "ImageEditor.c"
}


static gboolean
_gdk_cursor_type_equal (const GdkCursorType * s1,
                        const GdkCursorType * s2)
{
#line 404 "../src/ImageEditor.vala"
	if (s1 == s2) {
#line 404 "../src/ImageEditor.vala"
		return TRUE;
#line 2682 "ImageEditor.c"
	}
#line 404 "../src/ImageEditor.vala"
	if (s1 == NULL) {
#line 404 "../src/ImageEditor.vala"
		return FALSE;
#line 2688 "ImageEditor.c"
	}
#line 404 "../src/ImageEditor.vala"
	if (s2 == NULL) {
#line 404 "../src/ImageEditor.vala"
		return FALSE;
#line 2694 "ImageEditor.c"
	}
#line 404 "../src/ImageEditor.vala"
	return (*s1) == (*s2);
#line 2698 "ImageEditor.c"
}


static void
image_editor_set_cursor (ImageEditor* self,
                         GdkCursorType* type)
{
	GdkWindow* win = NULL;
	GtkDrawingArea* _tmp0_;
	GdkWindow* _tmp1_;
	GdkWindow* _tmp2_;
	GdkCursor* cursor = NULL;
	GdkWindow* _tmp3_;
	GdkCursor* _tmp4_;
	GdkCursor* _tmp5_;
#line 397 "../src/ImageEditor.vala"
	g_return_if_fail (self != NULL);
#line 399 "../src/ImageEditor.vala"
	_tmp0_ = self->priv->_da;
#line 399 "../src/ImageEditor.vala"
	_tmp1_ = gtk_widget_get_window ((GtkWidget*) _tmp0_);
#line 399 "../src/ImageEditor.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 399 "../src/ImageEditor.vala"
	win = _tmp2_;
#line 400 "../src/ImageEditor.vala"
	_tmp3_ = win;
#line 400 "../src/ImageEditor.vala"
	_tmp4_ = gdk_window_get_cursor (_tmp3_);
#line 400 "../src/ImageEditor.vala"
	_tmp5_ = _g_object_ref0 (_tmp4_);
#line 400 "../src/ImageEditor.vala"
	cursor = _tmp5_;
#line 402 "../src/ImageEditor.vala"
	if (type == NULL) {
#line 2734 "ImageEditor.c"
		GdkWindow* _tmp6_;
#line 403 "../src/ImageEditor.vala"
		_tmp6_ = win;
#line 403 "../src/ImageEditor.vala"
		gdk_window_set_cursor (_tmp6_, NULL);
#line 2740 "ImageEditor.c"
	} else {
		gboolean _tmp7_ = FALSE;
		GdkCursor* _tmp8_;
#line 404 "../src/ImageEditor.vala"
		_tmp8_ = cursor;
#line 404 "../src/ImageEditor.vala"
		if (_tmp8_ == NULL) {
#line 404 "../src/ImageEditor.vala"
			_tmp7_ = TRUE;
#line 2750 "ImageEditor.c"
		} else {
			GdkCursor* _tmp9_;
			GdkCursorType _tmp10_;
			GdkCursorType _tmp11_;
#line 404 "../src/ImageEditor.vala"
			_tmp9_ = cursor;
#line 404 "../src/ImageEditor.vala"
			_tmp10_ = gdk_cursor_get_cursor_type (_tmp9_);
#line 404 "../src/ImageEditor.vala"
			_tmp11_ = _tmp10_;
#line 404 "../src/ImageEditor.vala"
			_tmp7_ = _gdk_cursor_type_equal (&_tmp11_, type) != TRUE;
#line 2763 "ImageEditor.c"
		}
#line 404 "../src/ImageEditor.vala"
		if (_tmp7_) {
#line 2767 "ImageEditor.c"
			GdkWindow* _tmp12_;
			GtkPopover* _tmp13_;
			GdkDisplay* _tmp14_;
			GdkCursor* _tmp15_;
			GdkCursor* _tmp16_;
#line 405 "../src/ImageEditor.vala"
			_tmp12_ = win;
#line 405 "../src/ImageEditor.vala"
			_tmp13_ = self->priv->_popover;
#line 405 "../src/ImageEditor.vala"
			_tmp14_ = gtk_widget_get_display ((GtkWidget*) _tmp13_);
#line 405 "../src/ImageEditor.vala"
			_tmp15_ = gdk_cursor_new_for_display (_tmp14_, *type);
#line 405 "../src/ImageEditor.vala"
			_tmp16_ = _tmp15_;
#line 405 "../src/ImageEditor.vala"
			gdk_window_set_cursor (_tmp12_, _tmp16_);
#line 405 "../src/ImageEditor.vala"
			_g_object_unref0 (_tmp16_);
#line 2787 "ImageEditor.c"
		}
	}
#line 397 "../src/ImageEditor.vala"
	_g_object_unref0 (cursor);
#line 397 "../src/ImageEditor.vala"
	_g_object_unref0 (win);
#line 2794 "ImageEditor.c"
}


static void
image_editor_draw_image (ImageEditor* self,
                         cairo_t* ctx)
{
	NodeImage* _tmp0_;
	cairo_surface_t* _tmp1_;
	cairo_surface_t* _tmp2_;
	GtkDrawingArea* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	GtkDrawingArea* _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	NodeImage* _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
	NodeImage* _tmp12_;
	gint _tmp13_;
	gint _tmp14_;
	NodeImage* _tmp15_;
	gint _tmp16_;
	gint _tmp17_;
	NodeImage* _tmp18_;
	gint _tmp19_;
	gint _tmp20_;
	NodeImage* _tmp21_;
	cairo_surface_t* _tmp22_;
	cairo_surface_t* _tmp23_;
	NodeImage* _tmp24_;
	gint _tmp25_;
	gint _tmp26_;
	NodeImage* _tmp27_;
	gint _tmp28_;
	gint _tmp29_;
	NodeImage* _tmp30_;
	gint _tmp31_;
	gint _tmp32_;
	NodeImage* _tmp33_;
	gint _tmp34_;
	gint _tmp35_;
#line 411 "../src/ImageEditor.vala"
	g_return_if_fail (self != NULL);
#line 411 "../src/ImageEditor.vala"
	g_return_if_fail (ctx != NULL);
#line 414 "../src/ImageEditor.vala"
	_tmp0_ = self->priv->_image;
#line 414 "../src/ImageEditor.vala"
	_tmp1_ = node_image_get_surface (_tmp0_);
#line 414 "../src/ImageEditor.vala"
	_tmp2_ = _tmp1_;
#line 414 "../src/ImageEditor.vala"
	cairo_set_source_surface (ctx, _tmp2_, (gdouble) 0, (gdouble) 0);
#line 414 "../src/ImageEditor.vala"
	_cairo_surface_destroy0 (_tmp2_);
#line 415 "../src/ImageEditor.vala"
	cairo_paint (ctx);
#line 418 "../src/ImageEditor.vala"
	cairo_set_source_rgba (ctx, (gdouble) 0, (gdouble) 0, (gdouble) 0, 0.8);
#line 419 "../src/ImageEditor.vala"
	_tmp3_ = self->priv->_da;
#line 419 "../src/ImageEditor.vala"
	g_object_get ((GtkWidget*) _tmp3_, "width-request", &_tmp4_, NULL);
#line 419 "../src/ImageEditor.vala"
	_tmp5_ = _tmp4_;
#line 419 "../src/ImageEditor.vala"
	_tmp6_ = self->priv->_da;
#line 419 "../src/ImageEditor.vala"
	g_object_get ((GtkWidget*) _tmp6_, "height-request", &_tmp7_, NULL);
#line 419 "../src/ImageEditor.vala"
	_tmp8_ = _tmp7_;
#line 419 "../src/ImageEditor.vala"
	cairo_rectangle (ctx, (gdouble) 0, (gdouble) 0, (gdouble) _tmp5_, (gdouble) _tmp8_);
#line 420 "../src/ImageEditor.vala"
	cairo_fill (ctx);
#line 423 "../src/ImageEditor.vala"
	cairo_set_operator (ctx, CAIRO_OPERATOR_CLEAR);
#line 424 "../src/ImageEditor.vala"
	_tmp9_ = self->priv->_image;
#line 424 "../src/ImageEditor.vala"
	_tmp10_ = node_image_get_crop_x (_tmp9_);
#line 424 "../src/ImageEditor.vala"
	_tmp11_ = _tmp10_;
#line 424 "../src/ImageEditor.vala"
	_tmp12_ = self->priv->_image;
#line 424 "../src/ImageEditor.vala"
	_tmp13_ = node_image_get_crop_y (_tmp12_);
#line 424 "../src/ImageEditor.vala"
	_tmp14_ = _tmp13_;
#line 424 "../src/ImageEditor.vala"
	_tmp15_ = self->priv->_image;
#line 424 "../src/ImageEditor.vala"
	_tmp16_ = node_image_get_crop_w (_tmp15_);
#line 424 "../src/ImageEditor.vala"
	_tmp17_ = _tmp16_;
#line 424 "../src/ImageEditor.vala"
	_tmp18_ = self->priv->_image;
#line 424 "../src/ImageEditor.vala"
	_tmp19_ = node_image_get_crop_h (_tmp18_);
#line 424 "../src/ImageEditor.vala"
	_tmp20_ = _tmp19_;
#line 424 "../src/ImageEditor.vala"
	cairo_rectangle (ctx, (gdouble) _tmp11_, (gdouble) _tmp14_, (gdouble) _tmp17_, (gdouble) _tmp20_);
#line 425 "../src/ImageEditor.vala"
	cairo_fill (ctx);
#line 428 "../src/ImageEditor.vala"
	cairo_set_operator (ctx, CAIRO_OPERATOR_OVER);
#line 429 "../src/ImageEditor.vala"
	_tmp21_ = self->priv->_image;
#line 429 "../src/ImageEditor.vala"
	_tmp22_ = node_image_get_surface (_tmp21_);
#line 429 "../src/ImageEditor.vala"
	_tmp23_ = _tmp22_;
#line 429 "../src/ImageEditor.vala"
	cairo_set_source_surface (ctx, _tmp23_, (gdouble) 0, (gdouble) 0);
#line 429 "../src/ImageEditor.vala"
	_cairo_surface_destroy0 (_tmp23_);
#line 430 "../src/ImageEditor.vala"
	_tmp24_ = self->priv->_image;
#line 430 "../src/ImageEditor.vala"
	_tmp25_ = node_image_get_crop_x (_tmp24_);
#line 430 "../src/ImageEditor.vala"
	_tmp26_ = _tmp25_;
#line 430 "../src/ImageEditor.vala"
	_tmp27_ = self->priv->_image;
#line 430 "../src/ImageEditor.vala"
	_tmp28_ = node_image_get_crop_y (_tmp27_);
#line 430 "../src/ImageEditor.vala"
	_tmp29_ = _tmp28_;
#line 430 "../src/ImageEditor.vala"
	_tmp30_ = self->priv->_image;
#line 430 "../src/ImageEditor.vala"
	_tmp31_ = node_image_get_crop_w (_tmp30_);
#line 430 "../src/ImageEditor.vala"
	_tmp32_ = _tmp31_;
#line 430 "../src/ImageEditor.vala"
	_tmp33_ = self->priv->_image;
#line 430 "../src/ImageEditor.vala"
	_tmp34_ = node_image_get_crop_h (_tmp33_);
#line 430 "../src/ImageEditor.vala"
	_tmp35_ = _tmp34_;
#line 430 "../src/ImageEditor.vala"
	cairo_rectangle (ctx, (gdouble) _tmp26_, (gdouble) _tmp29_, (gdouble) _tmp32_, (gdouble) _tmp35_);
#line 431 "../src/ImageEditor.vala"
	cairo_fill (ctx);
#line 434 "../src/ImageEditor.vala"
	cairo_set_line_width (ctx, (gdouble) 1);
#line 2944 "ImageEditor.c"
	{
		gint i = 0;
#line 435 "../src/ImageEditor.vala"
		i = 0;
#line 2949 "ImageEditor.c"
		{
			gboolean _tmp36_ = FALSE;
#line 435 "../src/ImageEditor.vala"
			_tmp36_ = TRUE;
#line 435 "../src/ImageEditor.vala"
			while (TRUE) {
#line 2956 "ImageEditor.c"
				gint _tmp38_;
				GdkRectangle* _tmp39_;
				gint _tmp39__length1;
				gint _tmp40_;
				GdkRectangle _tmp41_;
#line 435 "../src/ImageEditor.vala"
				if (!_tmp36_) {
#line 2964 "ImageEditor.c"
					gint _tmp37_;
#line 435 "../src/ImageEditor.vala"
					_tmp37_ = i;
#line 435 "../src/ImageEditor.vala"
					i = _tmp37_ + 1;
#line 2970 "ImageEditor.c"
				}
#line 435 "../src/ImageEditor.vala"
				_tmp36_ = FALSE;
#line 435 "../src/ImageEditor.vala"
				_tmp38_ = i;
#line 435 "../src/ImageEditor.vala"
				if (!(_tmp38_ < 8)) {
#line 435 "../src/ImageEditor.vala"
					break;
#line 2980 "ImageEditor.c"
				}
#line 436 "../src/ImageEditor.vala"
				_tmp39_ = self->priv->_crop_points;
#line 436 "../src/ImageEditor.vala"
				_tmp39__length1 = self->priv->_crop_points_length1;
#line 436 "../src/ImageEditor.vala"
				_tmp40_ = i;
#line 436 "../src/ImageEditor.vala"
				_tmp41_ = _tmp39_[_tmp40_];
#line 436 "../src/ImageEditor.vala"
				image_editor_draw_crop_point (self, ctx, &_tmp41_);
#line 2992 "ImageEditor.c"
			}
		}
	}
}


static void
image_editor_draw_crop_point (ImageEditor* self,
                              cairo_t* ctx,
                              GdkRectangle* crop)
{
	GdkRectangle _tmp0_;
	gint _tmp1_;
	GdkRectangle _tmp2_;
	gint _tmp3_;
	GdkRectangle _tmp4_;
	gint _tmp5_;
	GdkRectangle _tmp6_;
	gint _tmp7_;
	GdkRectangle _tmp8_;
	gint _tmp9_;
	GdkRectangle _tmp10_;
	gint _tmp11_;
	GdkRectangle _tmp12_;
	gint _tmp13_;
	GdkRectangle _tmp14_;
	gint _tmp15_;
#line 442 "../src/ImageEditor.vala"
	g_return_if_fail (self != NULL);
#line 442 "../src/ImageEditor.vala"
	g_return_if_fail (ctx != NULL);
#line 442 "../src/ImageEditor.vala"
	g_return_if_fail (crop != NULL);
#line 444 "../src/ImageEditor.vala"
	cairo_set_source_rgb (ctx, (gdouble) 1, (gdouble) 1, (gdouble) 1);
#line 445 "../src/ImageEditor.vala"
	_tmp0_ = *crop;
#line 445 "../src/ImageEditor.vala"
	_tmp1_ = _tmp0_.x;
#line 445 "../src/ImageEditor.vala"
	_tmp2_ = *crop;
#line 445 "../src/ImageEditor.vala"
	_tmp3_ = _tmp2_.y;
#line 445 "../src/ImageEditor.vala"
	_tmp4_ = *crop;
#line 445 "../src/ImageEditor.vala"
	_tmp5_ = _tmp4_.width;
#line 445 "../src/ImageEditor.vala"
	_tmp6_ = *crop;
#line 445 "../src/ImageEditor.vala"
	_tmp7_ = _tmp6_.width;
#line 445 "../src/ImageEditor.vala"
	cairo_rectangle (ctx, (gdouble) _tmp1_, (gdouble) _tmp3_, (gdouble) _tmp5_, (gdouble) _tmp7_);
#line 446 "../src/ImageEditor.vala"
	cairo_fill (ctx);
#line 448 "../src/ImageEditor.vala"
	cairo_set_source_rgb (ctx, (gdouble) 0, (gdouble) 0, (gdouble) 0);
#line 449 "../src/ImageEditor.vala"
	_tmp8_ = *crop;
#line 449 "../src/ImageEditor.vala"
	_tmp9_ = _tmp8_.x;
#line 449 "../src/ImageEditor.vala"
	_tmp10_ = *crop;
#line 449 "../src/ImageEditor.vala"
	_tmp11_ = _tmp10_.y;
#line 449 "../src/ImageEditor.vala"
	_tmp12_ = *crop;
#line 449 "../src/ImageEditor.vala"
	_tmp13_ = _tmp12_.width;
#line 449 "../src/ImageEditor.vala"
	_tmp14_ = *crop;
#line 449 "../src/ImageEditor.vala"
	_tmp15_ = _tmp14_.width;
#line 449 "../src/ImageEditor.vala"
	cairo_rectangle (ctx, (gdouble) _tmp9_, (gdouble) _tmp11_, (gdouble) _tmp13_, (gdouble) _tmp15_);
#line 450 "../src/ImageEditor.vala"
	cairo_stroke (ctx);
#line 3070 "ImageEditor.c"
}


static void
image_editor_remove_image (ImageEditor* self,
                           ImageManager* im)
{
	NodeImage* orig_image = NULL;
	Node* _tmp0_;
	NodeImage* _tmp1_;
	NodeImage* _tmp2_;
	NodeImage* _tmp3_;
	Node* _tmp4_;
#line 455 "../src/ImageEditor.vala"
	g_return_if_fail (self != NULL);
#line 455 "../src/ImageEditor.vala"
	g_return_if_fail (im != NULL);
#line 458 "../src/ImageEditor.vala"
	_tmp0_ = self->priv->_node;
#line 458 "../src/ImageEditor.vala"
	_tmp1_ = node_get_image (_tmp0_);
#line 458 "../src/ImageEditor.vala"
	_tmp2_ = _tmp1_;
#line 458 "../src/ImageEditor.vala"
	_tmp3_ = _node_image_ref0 (_tmp2_);
#line 458 "../src/ImageEditor.vala"
	orig_image = _tmp3_;
#line 461 "../src/ImageEditor.vala"
	_tmp4_ = self->priv->_node;
#line 461 "../src/ImageEditor.vala"
	node_set_image (_tmp4_, im, NULL);
#line 464 "../src/ImageEditor.vala"
	g_signal_emit (self, image_editor_signals[IMAGE_EDITOR_CHANGED_SIGNAL], 0, orig_image);
#line 467 "../src/ImageEditor.vala"
	image_editor_show_popover (self, FALSE);
#line 455 "../src/ImageEditor.vala"
	_node_image_unref0 (orig_image);
#line 3108 "ImageEditor.c"
}


static void
image_editor_set_image (ImageEditor* self,
                        ImageManager* im)
{
	NodeImage* orig_image = NULL;
	Node* _tmp0_;
	NodeImage* _tmp1_;
	NodeImage* _tmp2_;
	NodeImage* _tmp3_;
	NodeImage* _tmp4_;
	Node* _tmp5_;
	Node* _tmp6_;
	NodeImage* _tmp7_;
#line 472 "../src/ImageEditor.vala"
	g_return_if_fail (self != NULL);
#line 472 "../src/ImageEditor.vala"
	g_return_if_fail (im != NULL);
#line 475 "../src/ImageEditor.vala"
	_tmp0_ = self->priv->_node;
#line 475 "../src/ImageEditor.vala"
	_tmp1_ = node_get_image (_tmp0_);
#line 475 "../src/ImageEditor.vala"
	_tmp2_ = _tmp1_;
#line 475 "../src/ImageEditor.vala"
	_tmp3_ = _node_image_ref0 (_tmp2_);
#line 475 "../src/ImageEditor.vala"
	orig_image = _tmp3_;
#line 478 "../src/ImageEditor.vala"
	_tmp4_ = self->priv->_image;
#line 478 "../src/ImageEditor.vala"
	_tmp5_ = self->priv->_node;
#line 478 "../src/ImageEditor.vala"
	node_image_set_width (_tmp4_, node_max_width (_tmp5_));
#line 481 "../src/ImageEditor.vala"
	_tmp6_ = self->priv->_node;
#line 481 "../src/ImageEditor.vala"
	_tmp7_ = self->priv->_image;
#line 481 "../src/ImageEditor.vala"
	node_set_image (_tmp6_, im, _tmp7_);
#line 484 "../src/ImageEditor.vala"
	g_signal_emit (self, image_editor_signals[IMAGE_EDITOR_CHANGED_SIGNAL], 0, orig_image);
#line 487 "../src/ImageEditor.vala"
	image_editor_show_popover (self, FALSE);
#line 472 "../src/ImageEditor.vala"
	_node_image_unref0 (orig_image);
#line 3157 "ImageEditor.c"
}


static void
g_cclosure_user_marshal_VOID__NODE_IMAGE (GClosure * closure,
                                          GValue * return_value,
                                          guint n_param_values,
                                          const GValue * param_values,
                                          gpointer invocation_hint,
                                          gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__NODE_IMAGE) (gpointer data1, gpointer arg_1, gpointer data2);
	register GMarshalFunc_VOID__NODE_IMAGE callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 26 "../src/ImageEditor.vala"
	g_return_if_fail (n_param_values == 2);
#line 26 "../src/ImageEditor.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 26 "../src/ImageEditor.vala"
		data1 = closure->data;
#line 26 "../src/ImageEditor.vala"
		data2 = param_values->data[0].v_pointer;
#line 3183 "ImageEditor.c"
	} else {
#line 26 "../src/ImageEditor.vala"
		data1 = param_values->data[0].v_pointer;
#line 26 "../src/ImageEditor.vala"
		data2 = closure->data;
#line 3189 "ImageEditor.c"
	}
#line 26 "../src/ImageEditor.vala"
	callback = (GMarshalFunc_VOID__NODE_IMAGE) (marshal_data ? marshal_data : cc->callback);
#line 26 "../src/ImageEditor.vala"
	callback (data1, value_get_node_image (param_values + 1), data2);
#line 3195 "ImageEditor.c"
}


static void
value_image_editor_init (GValue* value)
{
#line 26 "../src/ImageEditor.vala"
	value->data[0].v_pointer = NULL;
#line 3204 "ImageEditor.c"
}


static void
value_image_editor_free_value (GValue* value)
{
#line 26 "../src/ImageEditor.vala"
	if (value->data[0].v_pointer) {
#line 26 "../src/ImageEditor.vala"
		image_editor_unref (value->data[0].v_pointer);
#line 3215 "ImageEditor.c"
	}
}


static void
value_image_editor_copy_value (const GValue* src_value,
                               GValue* dest_value)
{
#line 26 "../src/ImageEditor.vala"
	if (src_value->data[0].v_pointer) {
#line 26 "../src/ImageEditor.vala"
		dest_value->data[0].v_pointer = image_editor_ref (src_value->data[0].v_pointer);
#line 3228 "ImageEditor.c"
	} else {
#line 26 "../src/ImageEditor.vala"
		dest_value->data[0].v_pointer = NULL;
#line 3232 "ImageEditor.c"
	}
}


static gpointer
value_image_editor_peek_pointer (const GValue* value)
{
#line 26 "../src/ImageEditor.vala"
	return value->data[0].v_pointer;
#line 3242 "ImageEditor.c"
}


static gchar*
value_image_editor_collect_value (GValue* value,
                                  guint n_collect_values,
                                  GTypeCValue* collect_values,
                                  guint collect_flags)
{
#line 26 "../src/ImageEditor.vala"
	if (collect_values[0].v_pointer) {
#line 3254 "ImageEditor.c"
		ImageEditor * object;
		object = collect_values[0].v_pointer;
#line 26 "../src/ImageEditor.vala"
		if (object->parent_instance.g_class == NULL) {
#line 26 "../src/ImageEditor.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 3261 "ImageEditor.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 26 "../src/ImageEditor.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 3265 "ImageEditor.c"
		}
#line 26 "../src/ImageEditor.vala"
		value->data[0].v_pointer = image_editor_ref (object);
#line 3269 "ImageEditor.c"
	} else {
#line 26 "../src/ImageEditor.vala"
		value->data[0].v_pointer = NULL;
#line 3273 "ImageEditor.c"
	}
#line 26 "../src/ImageEditor.vala"
	return NULL;
#line 3277 "ImageEditor.c"
}


static gchar*
value_image_editor_lcopy_value (const GValue* value,
                                guint n_collect_values,
                                GTypeCValue* collect_values,
                                guint collect_flags)
{
	ImageEditor ** object_p;
	object_p = collect_values[0].v_pointer;
#line 26 "../src/ImageEditor.vala"
	if (!object_p) {
#line 26 "../src/ImageEditor.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 3293 "ImageEditor.c"
	}
#line 26 "../src/ImageEditor.vala"
	if (!value->data[0].v_pointer) {
#line 26 "../src/ImageEditor.vala"
		*object_p = NULL;
#line 3299 "ImageEditor.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 26 "../src/ImageEditor.vala"
		*object_p = value->data[0].v_pointer;
#line 3303 "ImageEditor.c"
	} else {
#line 26 "../src/ImageEditor.vala"
		*object_p = image_editor_ref (value->data[0].v_pointer);
#line 3307 "ImageEditor.c"
	}
#line 26 "../src/ImageEditor.vala"
	return NULL;
#line 3311 "ImageEditor.c"
}


GParamSpec*
param_spec_image_editor (const gchar* name,
                         const gchar* nick,
                         const gchar* blurb,
                         GType object_type,
                         GParamFlags flags)
{
	ParamSpecImageEditor* spec;
#line 26 "../src/ImageEditor.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_IMAGE_EDITOR), NULL);
#line 26 "../src/ImageEditor.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 26 "../src/ImageEditor.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 26 "../src/ImageEditor.vala"
	return G_PARAM_SPEC (spec);
#line 3331 "ImageEditor.c"
}


gpointer
value_get_image_editor (const GValue* value)
{
#line 26 "../src/ImageEditor.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_IMAGE_EDITOR), NULL);
#line 26 "../src/ImageEditor.vala"
	return value->data[0].v_pointer;
#line 3342 "ImageEditor.c"
}


void
value_set_image_editor (GValue* value,
                        gpointer v_object)
{
	ImageEditor * old;
#line 26 "../src/ImageEditor.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_IMAGE_EDITOR));
#line 26 "../src/ImageEditor.vala"
	old = value->data[0].v_pointer;
#line 26 "../src/ImageEditor.vala"
	if (v_object) {
#line 26 "../src/ImageEditor.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_IMAGE_EDITOR));
#line 26 "../src/ImageEditor.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 26 "../src/ImageEditor.vala"
		value->data[0].v_pointer = v_object;
#line 26 "../src/ImageEditor.vala"
		image_editor_ref (value->data[0].v_pointer);
#line 3365 "ImageEditor.c"
	} else {
#line 26 "../src/ImageEditor.vala"
		value->data[0].v_pointer = NULL;
#line 3369 "ImageEditor.c"
	}
#line 26 "../src/ImageEditor.vala"
	if (old) {
#line 26 "../src/ImageEditor.vala"
		image_editor_unref (old);
#line 3375 "ImageEditor.c"
	}
}


void
value_take_image_editor (GValue* value,
                         gpointer v_object)
{
	ImageEditor * old;
#line 26 "../src/ImageEditor.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_IMAGE_EDITOR));
#line 26 "../src/ImageEditor.vala"
	old = value->data[0].v_pointer;
#line 26 "../src/ImageEditor.vala"
	if (v_object) {
#line 26 "../src/ImageEditor.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_IMAGE_EDITOR));
#line 26 "../src/ImageEditor.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 26 "../src/ImageEditor.vala"
		value->data[0].v_pointer = v_object;
#line 3397 "ImageEditor.c"
	} else {
#line 26 "../src/ImageEditor.vala"
		value->data[0].v_pointer = NULL;
#line 3401 "ImageEditor.c"
	}
#line 26 "../src/ImageEditor.vala"
	if (old) {
#line 26 "../src/ImageEditor.vala"
		image_editor_unref (old);
#line 3407 "ImageEditor.c"
	}
}


static void
image_editor_class_init (ImageEditorClass * klass)
{
#line 26 "../src/ImageEditor.vala"
	image_editor_parent_class = g_type_class_peek_parent (klass);
#line 26 "../src/ImageEditor.vala"
	((ImageEditorClass *) klass)->finalize = image_editor_finalize;
#line 26 "../src/ImageEditor.vala"
	g_type_class_adjust_private_offset (klass, &ImageEditor_private_offset);
#line 26 "../src/ImageEditor.vala"
	image_editor_signals[IMAGE_EDITOR_CHANGED_SIGNAL] = g_signal_new ("changed", TYPE_IMAGE_EDITOR, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__NODE_IMAGE, G_TYPE_NONE, 1, TYPE_NODE_IMAGE);
#line 3423 "ImageEditor.c"
}


static void
image_editor_instance_init (ImageEditor * self)
{
#line 26 "../src/ImageEditor.vala"
	self->priv = image_editor_get_instance_private (self);
#line 38 "../src/ImageEditor.vala"
	self->priv->_crop_target = -1;
#line 26 "../src/ImageEditor.vala"
	self->ref_count = 1;
#line 3436 "ImageEditor.c"
}


static void
image_editor_finalize (ImageEditor * obj)
{
	ImageEditor * self;
#line 26 "../src/ImageEditor.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_IMAGE_EDITOR, ImageEditor);
#line 26 "../src/ImageEditor.vala"
	g_signal_handlers_destroy (self);
#line 34 "../src/ImageEditor.vala"
	_g_object_unref0 (self->priv->_popover);
#line 35 "../src/ImageEditor.vala"
	_g_object_unref0 (self->priv->_da);
#line 36 "../src/ImageEditor.vala"
	_g_object_unref0 (self->priv->_node);
#line 37 "../src/ImageEditor.vala"
	_node_image_unref0 (self->priv->_image);
#line 41 "../src/ImageEditor.vala"
	self->priv->_crop_points = (g_free (self->priv->_crop_points), NULL);
#line 42 "../src/ImageEditor.vala"
	self->priv->_crop_cursors = (g_free (self->priv->_crop_cursors), NULL);
#line 43 "../src/ImageEditor.vala"
	_g_object_unref0 (self->priv->_status_cursor);
#line 44 "../src/ImageEditor.vala"
	_g_object_unref0 (self->priv->_status_crop);
#line 3464 "ImageEditor.c"
}


GType
image_editor_get_type (void)
{
	static volatile gsize image_editor_type_id__volatile = 0;
	if (g_once_init_enter (&image_editor_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_image_editor_init, value_image_editor_free_value, value_image_editor_copy_value, value_image_editor_peek_pointer, "p", value_image_editor_collect_value, "p", value_image_editor_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (ImageEditorClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) image_editor_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ImageEditor), 0, (GInstanceInitFunc) image_editor_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType image_editor_type_id;
		image_editor_type_id = g_type_register_fundamental (g_type_fundamental_next (), "ImageEditor", &g_define_type_info, &g_define_type_fundamental_info, 0);
		ImageEditor_private_offset = g_type_add_instance_private (image_editor_type_id, sizeof (ImageEditorPrivate));
		g_once_init_leave (&image_editor_type_id__volatile, image_editor_type_id);
	}
	return image_editor_type_id__volatile;
}


gpointer
image_editor_ref (gpointer instance)
{
	ImageEditor * self;
	self = instance;
#line 26 "../src/ImageEditor.vala"
	g_atomic_int_inc (&self->ref_count);
#line 26 "../src/ImageEditor.vala"
	return instance;
#line 3494 "ImageEditor.c"
}


void
image_editor_unref (gpointer instance)
{
	ImageEditor * self;
	self = instance;
#line 26 "../src/ImageEditor.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 26 "../src/ImageEditor.vala"
		IMAGE_EDITOR_GET_CLASS (self)->finalize (self);
#line 26 "../src/ImageEditor.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 3509 "ImageEditor.c"
	}
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



