/* ImageManager.c generated by valac 0.42.7, the Vala compiler
 * generated from ImageManager.vala, do not modify */

/*
* Copyright (c) 2018 (https://github.com/phase1geo/Minder)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Trevor Williams <phase1geo@gmail.com>
*/


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gstdio.h>
#include <libxml/tree.h>
#include <gtk/gtk.h>
#include <glib/gi18n-lib.h>
#include <gio/gio.h>
#include <gobject/gvaluecollector.h>


#define TYPE_IMAGE_MANAGER (image_manager_get_type ())
#define IMAGE_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_IMAGE_MANAGER, ImageManager))
#define IMAGE_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_IMAGE_MANAGER, ImageManagerClass))
#define IS_IMAGE_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_IMAGE_MANAGER))
#define IS_IMAGE_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_IMAGE_MANAGER))
#define IMAGE_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_IMAGE_MANAGER, ImageManagerClass))

typedef struct _ImageManager ImageManager;
typedef struct _ImageManagerClass ImageManagerClass;
typedef struct _ImageManagerPrivate ImageManagerPrivate;

#define IMAGE_MANAGER_TYPE_IMAGE_ITEM (image_manager_image_item_get_type ())
#define IMAGE_MANAGER_IMAGE_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), IMAGE_MANAGER_TYPE_IMAGE_ITEM, ImageManagerImageItem))
#define IMAGE_MANAGER_IMAGE_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), IMAGE_MANAGER_TYPE_IMAGE_ITEM, ImageManagerImageItemClass))
#define IMAGE_MANAGER_IS_IMAGE_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), IMAGE_MANAGER_TYPE_IMAGE_ITEM))
#define IMAGE_MANAGER_IS_IMAGE_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), IMAGE_MANAGER_TYPE_IMAGE_ITEM))
#define IMAGE_MANAGER_IMAGE_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), IMAGE_MANAGER_TYPE_IMAGE_ITEM, ImageManagerImageItemClass))

typedef struct _ImageManagerImageItem ImageManagerImageItem;
typedef struct _ImageManagerImageItemClass ImageManagerImageItemClass;
#define _g_array_unref0(var) ((var == NULL) ? NULL : (var = (g_array_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _image_manager_image_item_unref0(var) ((var == NULL) ? NULL : (var = (image_manager_image_item_unref (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _ImageManagerImageItemPrivate ImageManagerImageItemPrivate;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _ImageManagerParamSpecImageItem ImageManagerParamSpecImageItem;
typedef struct _ParamSpecImageManager ParamSpecImageManager;

struct _ImageManager {
	GTypeInstance parent_instance;
	volatile int ref_count;
	ImageManagerPrivate * priv;
};

struct _ImageManagerClass {
	GTypeClass parent_class;
	void (*finalize) (ImageManager *self);
};

struct _ImageManagerPrivate {
	GArray* _images;
	gboolean _available;
};

struct _ImageManagerImageItem {
	GTypeInstance parent_instance;
	volatile int ref_count;
	ImageManagerImageItemPrivate * priv;
};

struct _ImageManagerImageItemClass {
	GTypeClass parent_class;
	void (*finalize) (ImageManagerImageItem *self);
};

struct _ImageManagerImageItemPrivate {
	gint _id;
	gchar* _uri;
	gchar* _ext;
	gboolean _valid;
};

struct _ImageManagerParamSpecImageItem {
	GParamSpec parent_instance;
};

struct _ParamSpecImageManager {
	GParamSpec parent_instance;
};


static gint ImageManager_private_offset;
static gpointer image_manager_parent_class = NULL;
static gint ImageManagerImageItem_private_offset;
static gpointer image_manager_image_item_parent_class = NULL;
extern GSettings* minder_settings;

gpointer image_manager_ref (gpointer instance);
void image_manager_unref (gpointer instance);
GParamSpec* param_spec_image_manager (const gchar* name,
                                      const gchar* nick,
                                      const gchar* blurb,
                                      GType object_type,
                                      GParamFlags flags);
void value_set_image_manager (GValue* value,
                              gpointer v_object);
void value_take_image_manager (GValue* value,
                               gpointer v_object);
gpointer value_get_image_manager (const GValue* value);
GType image_manager_get_type (void) G_GNUC_CONST;
static gpointer image_manager_image_item_ref (gpointer instance);
static void image_manager_image_item_unref (gpointer instance);
static GParamSpec* image_manager_param_spec_image_item (const gchar* name,
                                                 const gchar* nick,
                                                 const gchar* blurb,
                                                 GType object_type,
                                                 GParamFlags flags) G_GNUC_UNUSED;
static void image_manager_value_set_image_item (GValue* value,
                                         gpointer v_object) G_GNUC_UNUSED;
static void image_manager_value_take_image_item (GValue* value,
                                          gpointer v_object) G_GNUC_UNUSED;
static gpointer image_manager_value_get_image_item (const GValue* value) G_GNUC_UNUSED;
static GType image_manager_image_item_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
static gchar* image_manager_get_storage_path (void);
ImageManager* image_manager_new (void);
ImageManager* image_manager_construct (GType object_type);
static void _image_manager_image_item_unref0_ (gpointer var);
static void _vala_ImageManagerImageItem_free_function_content_of (gpointer data);
void image_manager_load (ImageManager* self,
                         xmlNode* n);
static ImageManagerImageItem* image_manager_image_item_new_from_xml (xmlNode* n);
static ImageManagerImageItem* image_manager_image_item_construct_from_xml (GType object_type,
                                                                    xmlNode* n);
void image_manager_save (ImageManager* self,
                         xmlNode* n);
static gboolean image_manager_image_item_get_valid (ImageManagerImageItem* self);
static void image_manager_image_item_save (ImageManagerImageItem* self,
                                    xmlNode* parent);
static ImageManagerImageItem* image_manager_find_match (ImageManager* self,
                                                 gint id);
static gint image_manager_image_item_get_id (ImageManagerImageItem* self);
static ImageManagerImageItem* image_manager_find_uri_match (ImageManager* self,
                                                     const gchar* uri);
static const gchar* image_manager_image_item_get_uri (ImageManagerImageItem* self);
gint image_manager_add_image (ImageManager* self,
                              const gchar* uri);
static ImageManagerImageItem* image_manager_image_item_new (const gchar* uri);
static ImageManagerImageItem* image_manager_image_item_construct (GType object_type,
                                                           const gchar* uri);
static gboolean image_manager_image_item_copy_file (ImageManagerImageItem* self);
static gboolean image_manager_image_item_exists (ImageManagerImageItem* self);
gchar* image_manager_get_file (ImageManager* self,
                               gint id);
static gchar* image_manager_image_item_get_path (ImageManagerImageItem* self);
gchar* image_manager_get_uri (ImageManager* self,
                              gint id);
void image_manager_set_valid (ImageManager* self,
                              gint id,
                              gboolean value);
static void image_manager_image_item_set_valid (ImageManagerImageItem* self,
                                         gboolean value);
void image_manager_cleanup (ImageManager* self);
static void image_manager_image_item_cleanup (ImageManagerImageItem* self);
gint image_manager_choose_image (ImageManager* self,
                                 GtkWindow* parent);
static void image_manager_image_item_set_id (ImageManagerImageItem* self,
                                      gint value);
static void image_manager_image_item_set_uri (ImageManagerImageItem* self,
                                       const gchar* value);
static gchar* image_manager_image_item_get_extension (ImageManagerImageItem* self);
static void image_manager_image_item_set_ext (ImageManagerImageItem* self,
                                       const gchar* value);
static const gchar* image_manager_image_item_get_ext (ImageManagerImageItem* self);
static void image_manager_image_item_finalize (ImageManagerImageItem * obj);
static void image_manager_finalize (ImageManager * obj);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);
static gint _vala_array_length (gpointer array);


static inline gpointer
image_manager_get_instance_private (ImageManager* self)
{
	return G_STRUCT_MEMBER_P (self, ImageManager_private_offset);
}


static gchar*
image_manager_get_storage_path (void)
{
	gchar* result = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
#line 29 "../src/ImageManager.vala"
	_tmp0_ = g_get_user_data_dir ();
#line 29 "../src/ImageManager.vala"
	_tmp1_ = g_build_filename (_tmp0_, "minder", "images", NULL);
#line 29 "../src/ImageManager.vala"
	result = _tmp1_;
#line 29 "../src/ImageManager.vala"
	return result;
#line 225 "ImageManager.c"
}


static void
_image_manager_image_item_unref0_ (gpointer var)
{
#line 129 "../src/ImageManager.vala"
	(var == NULL) ? NULL : (var = (image_manager_image_item_unref (var), NULL));
#line 234 "ImageManager.c"
}


static void
_vala_ImageManagerImageItem_free_function_content_of (gpointer data)
{
	ImageManagerImageItem* self;
#line 129 "../src/ImageManager.vala"
	self = *((ImageManagerImageItem**) data);
#line 129 "../src/ImageManager.vala"
	_image_manager_image_item_unref0_ (self);
#line 246 "ImageManager.c"
}


ImageManager*
image_manager_construct (GType object_type)
{
	ImageManager* self = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gboolean _tmp2_;
	GArray* _tmp3_;
#line 121 "../src/ImageManager.vala"
	self = (ImageManager*) g_type_create_instance (object_type);
#line 124 "../src/ImageManager.vala"
	_tmp0_ = image_manager_get_storage_path ();
#line 124 "../src/ImageManager.vala"
	_tmp1_ = _tmp0_;
#line 124 "../src/ImageManager.vala"
	_tmp2_ = g_mkdir_with_parents (_tmp1_, 0775) == 0;
#line 124 "../src/ImageManager.vala"
	_g_free0 (_tmp1_);
#line 124 "../src/ImageManager.vala"
	if (_tmp2_) {
#line 125 "../src/ImageManager.vala"
		self->priv->_available = TRUE;
#line 272 "ImageManager.c"
	}
#line 129 "../src/ImageManager.vala"
	_tmp3_ = g_array_new (TRUE, TRUE, sizeof (ImageManagerImageItem*));
#line 129 "../src/ImageManager.vala"
	g_array_set_clear_func (_tmp3_, _vala_ImageManagerImageItem_free_function_content_of);
#line 129 "../src/ImageManager.vala"
	_g_array_unref0 (self->priv->_images);
#line 129 "../src/ImageManager.vala"
	self->priv->_images = _tmp3_;
#line 121 "../src/ImageManager.vala"
	return self;
#line 284 "ImageManager.c"
}


ImageManager*
image_manager_new (void)
{
#line 121 "../src/ImageManager.vala"
	return image_manager_construct (TYPE_IMAGE_MANAGER);
#line 293 "ImageManager.c"
}


void
image_manager_load (ImageManager* self,
                    xmlNode* n)
{
#line 134 "../src/ImageManager.vala"
	g_return_if_fail (self != NULL);
#line 303 "ImageManager.c"
	{
		xmlNode* it = NULL;
		xmlNode* _tmp0_;
#line 135 "../src/ImageManager.vala"
		_tmp0_ = n->children;
#line 135 "../src/ImageManager.vala"
		it = _tmp0_;
#line 311 "ImageManager.c"
		{
			gboolean _tmp1_ = FALSE;
#line 135 "../src/ImageManager.vala"
			_tmp1_ = TRUE;
#line 135 "../src/ImageManager.vala"
			while (TRUE) {
#line 318 "ImageManager.c"
				xmlNode* _tmp4_;
				xmlNode* _tmp5_;
				xmlElementType _tmp6_;
#line 135 "../src/ImageManager.vala"
				if (!_tmp1_) {
#line 324 "ImageManager.c"
					xmlNode* _tmp2_;
					xmlNode* _tmp3_;
#line 135 "../src/ImageManager.vala"
					_tmp2_ = it;
#line 135 "../src/ImageManager.vala"
					_tmp3_ = _tmp2_->next;
#line 135 "../src/ImageManager.vala"
					it = _tmp3_;
#line 333 "ImageManager.c"
				}
#line 135 "../src/ImageManager.vala"
				_tmp1_ = FALSE;
#line 135 "../src/ImageManager.vala"
				_tmp4_ = it;
#line 135 "../src/ImageManager.vala"
				if (!(_tmp4_ != NULL)) {
#line 135 "../src/ImageManager.vala"
					break;
#line 343 "ImageManager.c"
				}
#line 136 "../src/ImageManager.vala"
				_tmp5_ = it;
#line 136 "../src/ImageManager.vala"
				_tmp6_ = _tmp5_->type;
#line 136 "../src/ImageManager.vala"
				if (_tmp6_ == XML_ELEMENT_NODE) {
#line 351 "ImageManager.c"
					xmlNode* _tmp7_;
					const gchar* _tmp8_;
#line 137 "../src/ImageManager.vala"
					_tmp7_ = it;
#line 137 "../src/ImageManager.vala"
					_tmp8_ = _tmp7_->name;
#line 137 "../src/ImageManager.vala"
					if (g_strcmp0 (_tmp8_, "image") == 0) {
#line 360 "ImageManager.c"
						GArray* _tmp9_;
						xmlNode* _tmp10_;
						ImageManagerImageItem* _tmp11_;
#line 138 "../src/ImageManager.vala"
						_tmp9_ = self->priv->_images;
#line 138 "../src/ImageManager.vala"
						_tmp10_ = it;
#line 138 "../src/ImageManager.vala"
						_tmp11_ = image_manager_image_item_new_from_xml (_tmp10_);
#line 138 "../src/ImageManager.vala"
						g_array_append_val (_tmp9_, _tmp11_);
#line 372 "ImageManager.c"
					}
				}
			}
		}
	}
}


void
image_manager_save (ImageManager* self,
                    xmlNode* n)
{
#line 145 "../src/ImageManager.vala"
	g_return_if_fail (self != NULL);
#line 387 "ImageManager.c"
	{
		gint i = 0;
#line 146 "../src/ImageManager.vala"
		i = 0;
#line 392 "ImageManager.c"
		{
			gboolean _tmp0_ = FALSE;
#line 146 "../src/ImageManager.vala"
			_tmp0_ = TRUE;
#line 146 "../src/ImageManager.vala"
			while (TRUE) {
#line 399 "ImageManager.c"
				gint _tmp2_;
				GArray* _tmp3_;
				guint _tmp4_;
				GArray* _tmp5_;
				gint _tmp6_;
				ImageManagerImageItem* _tmp7_;
				gboolean _tmp8_;
				gboolean _tmp9_;
#line 146 "../src/ImageManager.vala"
				if (!_tmp0_) {
#line 410 "ImageManager.c"
					gint _tmp1_;
#line 146 "../src/ImageManager.vala"
					_tmp1_ = i;
#line 146 "../src/ImageManager.vala"
					i = _tmp1_ + 1;
#line 416 "ImageManager.c"
				}
#line 146 "../src/ImageManager.vala"
				_tmp0_ = FALSE;
#line 146 "../src/ImageManager.vala"
				_tmp2_ = i;
#line 146 "../src/ImageManager.vala"
				_tmp3_ = self->priv->_images;
#line 146 "../src/ImageManager.vala"
				_tmp4_ = _tmp3_->len;
#line 146 "../src/ImageManager.vala"
				if (!(((guint) _tmp2_) < _tmp4_)) {
#line 146 "../src/ImageManager.vala"
					break;
#line 430 "ImageManager.c"
				}
#line 147 "../src/ImageManager.vala"
				_tmp5_ = self->priv->_images;
#line 147 "../src/ImageManager.vala"
				_tmp6_ = i;
#line 147 "../src/ImageManager.vala"
				_tmp7_ = g_array_index (_tmp5_, ImageManagerImageItem*, (guint) _tmp6_);
#line 147 "../src/ImageManager.vala"
				_tmp8_ = image_manager_image_item_get_valid (_tmp7_);
#line 147 "../src/ImageManager.vala"
				_tmp9_ = _tmp8_;
#line 147 "../src/ImageManager.vala"
				if (_tmp9_) {
#line 444 "ImageManager.c"
					GArray* _tmp10_;
					gint _tmp11_;
					ImageManagerImageItem* _tmp12_;
#line 148 "../src/ImageManager.vala"
					_tmp10_ = self->priv->_images;
#line 148 "../src/ImageManager.vala"
					_tmp11_ = i;
#line 148 "../src/ImageManager.vala"
					_tmp12_ = g_array_index (_tmp10_, ImageManagerImageItem*, (guint) _tmp11_);
#line 148 "../src/ImageManager.vala"
					image_manager_image_item_save (_tmp12_, n);
#line 456 "ImageManager.c"
				}
			}
		}
	}
}


static gpointer
_image_manager_image_item_ref0 (gpointer self)
{
#line 161 "../src/ImageManager.vala"
	return self ? image_manager_image_item_ref (self) : NULL;
#line 469 "ImageManager.c"
}


static ImageManagerImageItem*
image_manager_find_match (ImageManager* self,
                          gint id)
{
	ImageManagerImageItem* result = NULL;
#line 158 "../src/ImageManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 480 "ImageManager.c"
	{
		gint i = 0;
#line 159 "../src/ImageManager.vala"
		i = 0;
#line 485 "ImageManager.c"
		{
			gboolean _tmp0_ = FALSE;
#line 159 "../src/ImageManager.vala"
			_tmp0_ = TRUE;
#line 159 "../src/ImageManager.vala"
			while (TRUE) {
#line 492 "ImageManager.c"
				gint _tmp2_;
				GArray* _tmp3_;
				guint _tmp4_;
				GArray* _tmp5_;
				gint _tmp6_;
				ImageManagerImageItem* _tmp7_;
				gint _tmp8_;
				gint _tmp9_;
#line 159 "../src/ImageManager.vala"
				if (!_tmp0_) {
#line 503 "ImageManager.c"
					gint _tmp1_;
#line 159 "../src/ImageManager.vala"
					_tmp1_ = i;
#line 159 "../src/ImageManager.vala"
					i = _tmp1_ + 1;
#line 509 "ImageManager.c"
				}
#line 159 "../src/ImageManager.vala"
				_tmp0_ = FALSE;
#line 159 "../src/ImageManager.vala"
				_tmp2_ = i;
#line 159 "../src/ImageManager.vala"
				_tmp3_ = self->priv->_images;
#line 159 "../src/ImageManager.vala"
				_tmp4_ = _tmp3_->len;
#line 159 "../src/ImageManager.vala"
				if (!(((guint) _tmp2_) < _tmp4_)) {
#line 159 "../src/ImageManager.vala"
					break;
#line 523 "ImageManager.c"
				}
#line 160 "../src/ImageManager.vala"
				_tmp5_ = self->priv->_images;
#line 160 "../src/ImageManager.vala"
				_tmp6_ = i;
#line 160 "../src/ImageManager.vala"
				_tmp7_ = g_array_index (_tmp5_, ImageManagerImageItem*, (guint) _tmp6_);
#line 160 "../src/ImageManager.vala"
				_tmp8_ = image_manager_image_item_get_id (_tmp7_);
#line 160 "../src/ImageManager.vala"
				_tmp9_ = _tmp8_;
#line 160 "../src/ImageManager.vala"
				if (_tmp9_ == id) {
#line 537 "ImageManager.c"
					GArray* _tmp10_;
					gint _tmp11_;
					ImageManagerImageItem* _tmp12_;
					ImageManagerImageItem* _tmp13_;
#line 161 "../src/ImageManager.vala"
					_tmp10_ = self->priv->_images;
#line 161 "../src/ImageManager.vala"
					_tmp11_ = i;
#line 161 "../src/ImageManager.vala"
					_tmp12_ = g_array_index (_tmp10_, ImageManagerImageItem*, (guint) _tmp11_);
#line 161 "../src/ImageManager.vala"
					_tmp13_ = _image_manager_image_item_ref0 (_tmp12_);
#line 161 "../src/ImageManager.vala"
					result = _tmp13_;
#line 161 "../src/ImageManager.vala"
					return result;
#line 554 "ImageManager.c"
				}
			}
		}
	}
#line 164 "../src/ImageManager.vala"
	result = NULL;
#line 164 "../src/ImageManager.vala"
	return result;
#line 563 "ImageManager.c"
}


static ImageManagerImageItem*
image_manager_find_uri_match (ImageManager* self,
                              const gchar* uri)
{
	ImageManagerImageItem* result = NULL;
#line 171 "../src/ImageManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 171 "../src/ImageManager.vala"
	g_return_val_if_fail (uri != NULL, NULL);
#line 576 "ImageManager.c"
	{
		gint i = 0;
#line 172 "../src/ImageManager.vala"
		i = 0;
#line 581 "ImageManager.c"
		{
			gboolean _tmp0_ = FALSE;
#line 172 "../src/ImageManager.vala"
			_tmp0_ = TRUE;
#line 172 "../src/ImageManager.vala"
			while (TRUE) {
#line 588 "ImageManager.c"
				gint _tmp2_;
				GArray* _tmp3_;
				guint _tmp4_;
				GArray* _tmp5_;
				gint _tmp6_;
				ImageManagerImageItem* _tmp7_;
				const gchar* _tmp8_;
				const gchar* _tmp9_;
#line 172 "../src/ImageManager.vala"
				if (!_tmp0_) {
#line 599 "ImageManager.c"
					gint _tmp1_;
#line 172 "../src/ImageManager.vala"
					_tmp1_ = i;
#line 172 "../src/ImageManager.vala"
					i = _tmp1_ + 1;
#line 605 "ImageManager.c"
				}
#line 172 "../src/ImageManager.vala"
				_tmp0_ = FALSE;
#line 172 "../src/ImageManager.vala"
				_tmp2_ = i;
#line 172 "../src/ImageManager.vala"
				_tmp3_ = self->priv->_images;
#line 172 "../src/ImageManager.vala"
				_tmp4_ = _tmp3_->len;
#line 172 "../src/ImageManager.vala"
				if (!(((guint) _tmp2_) < _tmp4_)) {
#line 172 "../src/ImageManager.vala"
					break;
#line 619 "ImageManager.c"
				}
#line 173 "../src/ImageManager.vala"
				_tmp5_ = self->priv->_images;
#line 173 "../src/ImageManager.vala"
				_tmp6_ = i;
#line 173 "../src/ImageManager.vala"
				_tmp7_ = g_array_index (_tmp5_, ImageManagerImageItem*, (guint) _tmp6_);
#line 173 "../src/ImageManager.vala"
				_tmp8_ = image_manager_image_item_get_uri (_tmp7_);
#line 173 "../src/ImageManager.vala"
				_tmp9_ = _tmp8_;
#line 173 "../src/ImageManager.vala"
				if (g_strcmp0 (_tmp9_, uri) == 0) {
#line 633 "ImageManager.c"
					GArray* _tmp10_;
					gint _tmp11_;
					ImageManagerImageItem* _tmp12_;
					ImageManagerImageItem* _tmp13_;
#line 174 "../src/ImageManager.vala"
					_tmp10_ = self->priv->_images;
#line 174 "../src/ImageManager.vala"
					_tmp11_ = i;
#line 174 "../src/ImageManager.vala"
					_tmp12_ = g_array_index (_tmp10_, ImageManagerImageItem*, (guint) _tmp11_);
#line 174 "../src/ImageManager.vala"
					_tmp13_ = _image_manager_image_item_ref0 (_tmp12_);
#line 174 "../src/ImageManager.vala"
					result = _tmp13_;
#line 174 "../src/ImageManager.vala"
					return result;
#line 650 "ImageManager.c"
				}
			}
		}
	}
#line 177 "../src/ImageManager.vala"
	result = NULL;
#line 177 "../src/ImageManager.vala"
	return result;
#line 659 "ImageManager.c"
}


gint
image_manager_add_image (ImageManager* self,
                         const gchar* uri)
{
	gint result = 0;
	ImageManagerImageItem* item = NULL;
	ImageManagerImageItem* _tmp0_;
	ImageManagerImageItem* _tmp1_;
	ImageManagerImageItem* _tmp9_;
	gint _tmp10_;
	gint _tmp11_;
#line 185 "../src/ImageManager.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 185 "../src/ImageManager.vala"
	g_return_val_if_fail (uri != NULL, 0);
#line 186 "../src/ImageManager.vala"
	_tmp0_ = image_manager_find_uri_match (self, uri);
#line 186 "../src/ImageManager.vala"
	item = _tmp0_;
#line 187 "../src/ImageManager.vala"
	_tmp1_ = item;
#line 187 "../src/ImageManager.vala"
	if (_tmp1_ == NULL) {
#line 686 "ImageManager.c"
		ImageManagerImageItem* _tmp2_;
		ImageManagerImageItem* _tmp3_;
		GArray* _tmp4_;
		ImageManagerImageItem* _tmp5_;
		ImageManagerImageItem* _tmp6_;
#line 188 "../src/ImageManager.vala"
		_tmp2_ = image_manager_image_item_new (uri);
#line 188 "../src/ImageManager.vala"
		_image_manager_image_item_unref0 (item);
#line 188 "../src/ImageManager.vala"
		item = _tmp2_;
#line 189 "../src/ImageManager.vala"
		_tmp3_ = item;
#line 189 "../src/ImageManager.vala"
		if (!image_manager_image_item_copy_file (_tmp3_)) {
#line 189 "../src/ImageManager.vala"
			result = -1;
#line 189 "../src/ImageManager.vala"
			_image_manager_image_item_unref0 (item);
#line 189 "../src/ImageManager.vala"
			return result;
#line 708 "ImageManager.c"
		}
#line 190 "../src/ImageManager.vala"
		_tmp4_ = self->priv->_images;
#line 190 "../src/ImageManager.vala"
		_tmp5_ = item;
#line 190 "../src/ImageManager.vala"
		_tmp6_ = _image_manager_image_item_ref0 (_tmp5_);
#line 190 "../src/ImageManager.vala"
		g_array_append_val (_tmp4_, _tmp6_);
#line 718 "ImageManager.c"
	} else {
		ImageManagerImageItem* _tmp7_;
#line 191 "../src/ImageManager.vala"
		_tmp7_ = item;
#line 191 "../src/ImageManager.vala"
		if (!image_manager_image_item_exists (_tmp7_)) {
#line 725 "ImageManager.c"
			ImageManagerImageItem* _tmp8_;
#line 192 "../src/ImageManager.vala"
			_tmp8_ = item;
#line 192 "../src/ImageManager.vala"
			if (!image_manager_image_item_copy_file (_tmp8_)) {
#line 192 "../src/ImageManager.vala"
				result = -1;
#line 192 "../src/ImageManager.vala"
				_image_manager_image_item_unref0 (item);
#line 192 "../src/ImageManager.vala"
				return result;
#line 737 "ImageManager.c"
			}
		}
	}
#line 194 "../src/ImageManager.vala"
	_tmp9_ = item;
#line 194 "../src/ImageManager.vala"
	_tmp10_ = image_manager_image_item_get_id (_tmp9_);
#line 194 "../src/ImageManager.vala"
	_tmp11_ = _tmp10_;
#line 194 "../src/ImageManager.vala"
	result = _tmp11_;
#line 194 "../src/ImageManager.vala"
	_image_manager_image_item_unref0 (item);
#line 194 "../src/ImageManager.vala"
	return result;
#line 753 "ImageManager.c"
}


gchar*
image_manager_get_file (ImageManager* self,
                        gint id)
{
	gchar* result = NULL;
	ImageManagerImageItem* item = NULL;
	ImageManagerImageItem* _tmp0_;
	ImageManagerImageItem* _tmp1_;
#line 198 "../src/ImageManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 199 "../src/ImageManager.vala"
	_tmp0_ = image_manager_find_match (self, id);
#line 199 "../src/ImageManager.vala"
	item = _tmp0_;
#line 200 "../src/ImageManager.vala"
	_tmp1_ = item;
#line 200 "../src/ImageManager.vala"
	if (_tmp1_ != NULL) {
#line 775 "ImageManager.c"
		ImageManagerImageItem* _tmp2_;
		gchar* _tmp3_;
#line 201 "../src/ImageManager.vala"
		_tmp2_ = item;
#line 201 "../src/ImageManager.vala"
		_tmp3_ = image_manager_image_item_get_path (_tmp2_);
#line 201 "../src/ImageManager.vala"
		result = _tmp3_;
#line 201 "../src/ImageManager.vala"
		_image_manager_image_item_unref0 (item);
#line 201 "../src/ImageManager.vala"
		return result;
#line 788 "ImageManager.c"
	}
#line 203 "../src/ImageManager.vala"
	result = NULL;
#line 203 "../src/ImageManager.vala"
	_image_manager_image_item_unref0 (item);
#line 203 "../src/ImageManager.vala"
	return result;
#line 796 "ImageManager.c"
}


gchar*
image_manager_get_uri (ImageManager* self,
                       gint id)
{
	gchar* result = NULL;
	ImageManagerImageItem* item = NULL;
	ImageManagerImageItem* _tmp0_;
	ImageManagerImageItem* _tmp1_;
	gchar* _tmp6_;
#line 207 "../src/ImageManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 208 "../src/ImageManager.vala"
	_tmp0_ = image_manager_find_match (self, id);
#line 208 "../src/ImageManager.vala"
	item = _tmp0_;
#line 209 "../src/ImageManager.vala"
	_tmp1_ = item;
#line 209 "../src/ImageManager.vala"
	if (_tmp1_ != NULL) {
#line 819 "ImageManager.c"
		ImageManagerImageItem* _tmp2_;
		const gchar* _tmp3_;
		const gchar* _tmp4_;
		gchar* _tmp5_;
#line 210 "../src/ImageManager.vala"
		_tmp2_ = item;
#line 210 "../src/ImageManager.vala"
		_tmp3_ = image_manager_image_item_get_uri (_tmp2_);
#line 210 "../src/ImageManager.vala"
		_tmp4_ = _tmp3_;
#line 210 "../src/ImageManager.vala"
		_tmp5_ = g_strdup (_tmp4_);
#line 210 "../src/ImageManager.vala"
		result = _tmp5_;
#line 210 "../src/ImageManager.vala"
		_image_manager_image_item_unref0 (item);
#line 210 "../src/ImageManager.vala"
		return result;
#line 838 "ImageManager.c"
	}
#line 212 "../src/ImageManager.vala"
	_tmp6_ = g_strdup ("");
#line 212 "../src/ImageManager.vala"
	result = _tmp6_;
#line 212 "../src/ImageManager.vala"
	_image_manager_image_item_unref0 (item);
#line 212 "../src/ImageManager.vala"
	return result;
#line 848 "ImageManager.c"
}


void
image_manager_set_valid (ImageManager* self,
                         gint id,
                         gboolean value)
{
	ImageManagerImageItem* item = NULL;
	ImageManagerImageItem* _tmp0_;
	ImageManagerImageItem* _tmp1_;
#line 220 "../src/ImageManager.vala"
	g_return_if_fail (self != NULL);
#line 221 "../src/ImageManager.vala"
	_tmp0_ = image_manager_find_match (self, id);
#line 221 "../src/ImageManager.vala"
	item = _tmp0_;
#line 222 "../src/ImageManager.vala"
	_tmp1_ = item;
#line 222 "../src/ImageManager.vala"
	if (_tmp1_ != NULL) {
#line 870 "ImageManager.c"
		ImageManagerImageItem* _tmp2_;
#line 223 "../src/ImageManager.vala"
		_tmp2_ = item;
#line 223 "../src/ImageManager.vala"
		image_manager_image_item_set_valid (_tmp2_, value);
#line 876 "ImageManager.c"
	}
#line 220 "../src/ImageManager.vala"
	_image_manager_image_item_unref0 (item);
#line 880 "ImageManager.c"
}


void
image_manager_cleanup (ImageManager* self)
{
#line 228 "../src/ImageManager.vala"
	g_return_if_fail (self != NULL);
#line 889 "ImageManager.c"
	{
		gint i = 0;
#line 229 "../src/ImageManager.vala"
		i = 0;
#line 894 "ImageManager.c"
		{
			gboolean _tmp0_ = FALSE;
#line 229 "../src/ImageManager.vala"
			_tmp0_ = TRUE;
#line 229 "../src/ImageManager.vala"
			while (TRUE) {
#line 901 "ImageManager.c"
				gint _tmp2_;
				GArray* _tmp3_;
				guint _tmp4_;
				GArray* _tmp5_;
				gint _tmp6_;
				ImageManagerImageItem* _tmp7_;
#line 229 "../src/ImageManager.vala"
				if (!_tmp0_) {
#line 910 "ImageManager.c"
					gint _tmp1_;
#line 229 "../src/ImageManager.vala"
					_tmp1_ = i;
#line 229 "../src/ImageManager.vala"
					i = _tmp1_ + 1;
#line 916 "ImageManager.c"
				}
#line 229 "../src/ImageManager.vala"
				_tmp0_ = FALSE;
#line 229 "../src/ImageManager.vala"
				_tmp2_ = i;
#line 229 "../src/ImageManager.vala"
				_tmp3_ = self->priv->_images;
#line 229 "../src/ImageManager.vala"
				_tmp4_ = _tmp3_->len;
#line 229 "../src/ImageManager.vala"
				if (!(((guint) _tmp2_) < _tmp4_)) {
#line 229 "../src/ImageManager.vala"
					break;
#line 930 "ImageManager.c"
				}
#line 230 "../src/ImageManager.vala"
				_tmp5_ = self->priv->_images;
#line 230 "../src/ImageManager.vala"
				_tmp6_ = i;
#line 230 "../src/ImageManager.vala"
				_tmp7_ = g_array_index (_tmp5_, ImageManagerImageItem*, (guint) _tmp6_);
#line 230 "../src/ImageManager.vala"
				image_manager_image_item_cleanup (_tmp7_);
#line 940 "ImageManager.c"
			}
		}
	}
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 253 "../src/ImageManager.vala"
	return self ? g_object_ref (self) : NULL;
#line 952 "ImageManager.c"
}


gint
image_manager_choose_image (ImageManager* self,
                            GtkWindow* parent)
{
	gint result = 0;
	gint id = 0;
	GtkFileChooserNative* dialog = NULL;
	GtkFileChooserNative* _tmp0_;
	GtkFileFilter* filter = NULL;
	GtkFileFilter* _tmp1_;
	GtkFileFilter* _tmp2_;
	GtkFileFilter* _tmp3_;
	GtkFileFilter* _tmp4_;
	GtkFileFilter* _tmp5_;
	GtkFileFilter* _tmp6_;
	GtkFileFilter* _tmp7_;
	GtkFileChooserNative* _tmp8_;
	GtkFileFilter* _tmp9_;
	GtkFileFilter* _tmp10_;
	GtkFileChooserNative* _tmp11_;
	GtkFileChooserNative* _tmp15_;
#line 239 "../src/ImageManager.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 239 "../src/ImageManager.vala"
	g_return_val_if_fail (parent != NULL, 0);
#line 241 "../src/ImageManager.vala"
	id = -1;
#line 243 "../src/ImageManager.vala"
	_tmp0_ = gtk_file_chooser_native_new (_ ("Select Image"), parent, GTK_FILE_CHOOSER_ACTION_OPEN, _ ("Select"), _ ("Cancel"));
#line 243 "../src/ImageManager.vala"
	dialog = _tmp0_;
#line 246 "../src/ImageManager.vala"
	_tmp1_ = gtk_file_filter_new ();
#line 246 "../src/ImageManager.vala"
	g_object_ref_sink (_tmp1_);
#line 246 "../src/ImageManager.vala"
	filter = _tmp1_;
#line 247 "../src/ImageManager.vala"
	_tmp2_ = filter;
#line 247 "../src/ImageManager.vala"
	gtk_file_filter_set_name (_tmp2_, _ ("Images"));
#line 248 "../src/ImageManager.vala"
	_tmp3_ = filter;
#line 248 "../src/ImageManager.vala"
	gtk_file_filter_add_pattern (_tmp3_, "*.bmp");
#line 249 "../src/ImageManager.vala"
	_tmp4_ = filter;
#line 249 "../src/ImageManager.vala"
	gtk_file_filter_add_pattern (_tmp4_, "*.png");
#line 250 "../src/ImageManager.vala"
	_tmp5_ = filter;
#line 250 "../src/ImageManager.vala"
	gtk_file_filter_add_pattern (_tmp5_, "*.jpg");
#line 251 "../src/ImageManager.vala"
	_tmp6_ = filter;
#line 251 "../src/ImageManager.vala"
	gtk_file_filter_add_pattern (_tmp6_, "*.jpeg");
#line 252 "../src/ImageManager.vala"
	_tmp7_ = filter;
#line 252 "../src/ImageManager.vala"
	gtk_file_filter_add_pattern (_tmp7_, "*.svg");
#line 253 "../src/ImageManager.vala"
	_tmp8_ = dialog;
#line 253 "../src/ImageManager.vala"
	_tmp9_ = filter;
#line 253 "../src/ImageManager.vala"
	_tmp10_ = _g_object_ref0 (_tmp9_);
#line 253 "../src/ImageManager.vala"
	gtk_file_chooser_add_filter ((GtkFileChooser*) _tmp8_, _tmp10_);
#line 255 "../src/ImageManager.vala"
	_tmp11_ = dialog;
#line 255 "../src/ImageManager.vala"
	if (gtk_native_dialog_run ((GtkNativeDialog*) _tmp11_) == ((gint) GTK_RESPONSE_ACCEPT)) {
#line 1029 "ImageManager.c"
		GtkFileChooserNative* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
#line 256 "../src/ImageManager.vala"
		_tmp12_ = dialog;
#line 256 "../src/ImageManager.vala"
		_tmp13_ = gtk_file_chooser_get_uri ((GtkFileChooser*) _tmp12_);
#line 256 "../src/ImageManager.vala"
		_tmp14_ = _tmp13_;
#line 256 "../src/ImageManager.vala"
		id = image_manager_add_image (self, _tmp14_);
#line 256 "../src/ImageManager.vala"
		_g_free0 (_tmp14_);
#line 1043 "ImageManager.c"
	}
#line 260 "../src/ImageManager.vala"
	_tmp15_ = dialog;
#line 260 "../src/ImageManager.vala"
	gtk_native_dialog_destroy ((GtkNativeDialog*) _tmp15_);
#line 262 "../src/ImageManager.vala"
	result = id;
#line 262 "../src/ImageManager.vala"
	_g_object_unref0 (filter);
#line 262 "../src/ImageManager.vala"
	_g_object_unref0 (dialog);
#line 262 "../src/ImageManager.vala"
	return result;
#line 1057 "ImageManager.c"
}


static inline gpointer
image_manager_image_item_get_instance_private (ImageManagerImageItem* self)
{
	return G_STRUCT_MEMBER_P (self, ImageManagerImageItem_private_offset);
}


static ImageManagerImageItem*
image_manager_image_item_construct (GType object_type,
                                    const gchar* uri)
{
	ImageManagerImageItem* self = NULL;
	GSettings* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	GSettings* _tmp3_;
	gint _tmp4_;
#line 41 "../src/ImageManager.vala"
	g_return_val_if_fail (uri != NULL, NULL);
#line 41 "../src/ImageManager.vala"
	self = (ImageManagerImageItem*) g_type_create_instance (object_type);
#line 42 "../src/ImageManager.vala"
	_tmp0_ = minder_settings;
#line 42 "../src/ImageManager.vala"
	image_manager_image_item_set_id (self, g_settings_get_int (_tmp0_, "image-id"));
#line 43 "../src/ImageManager.vala"
	image_manager_image_item_set_uri (self, uri);
#line 44 "../src/ImageManager.vala"
	_tmp1_ = image_manager_image_item_get_extension (self);
#line 44 "../src/ImageManager.vala"
	_tmp2_ = _tmp1_;
#line 44 "../src/ImageManager.vala"
	image_manager_image_item_set_ext (self, _tmp2_);
#line 44 "../src/ImageManager.vala"
	_g_free0 (_tmp2_);
#line 45 "../src/ImageManager.vala"
	image_manager_image_item_set_valid (self, TRUE);
#line 46 "../src/ImageManager.vala"
	_tmp3_ = minder_settings;
#line 46 "../src/ImageManager.vala"
	_tmp4_ = self->priv->_id;
#line 46 "../src/ImageManager.vala"
	g_settings_set_int (_tmp3_, "image-id", _tmp4_ + 1);
#line 41 "../src/ImageManager.vala"
	return self;
#line 1106 "ImageManager.c"
}


static ImageManagerImageItem*
image_manager_image_item_new (const gchar* uri)
{
#line 41 "../src/ImageManager.vala"
	return image_manager_image_item_construct (IMAGE_MANAGER_TYPE_IMAGE_ITEM, uri);
#line 1115 "ImageManager.c"
}


static ImageManagerImageItem*
image_manager_image_item_construct_from_xml (GType object_type,
                                             xmlNode* n)
{
	ImageManagerImageItem* self = NULL;
	gchar* i = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* u = NULL;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* e = NULL;
	gchar* _tmp6_;
	const gchar* _tmp7_;
#line 50 "../src/ImageManager.vala"
	self = (ImageManagerImageItem*) g_type_create_instance (object_type);
#line 51 "../src/ImageManager.vala"
	_tmp0_ = (gchar*) xmlGetProp (n, (xmlChar*) "id");
#line 51 "../src/ImageManager.vala"
	i = _tmp0_;
#line 52 "../src/ImageManager.vala"
	_tmp1_ = i;
#line 52 "../src/ImageManager.vala"
	if (_tmp1_ != NULL) {
#line 1143 "ImageManager.c"
		const gchar* _tmp2_;
#line 53 "../src/ImageManager.vala"
		_tmp2_ = i;
#line 53 "../src/ImageManager.vala"
		image_manager_image_item_set_id (self, atoi (_tmp2_));
#line 1149 "ImageManager.c"
	}
#line 55 "../src/ImageManager.vala"
	_tmp3_ = (gchar*) xmlGetProp (n, (xmlChar*) "uri");
#line 55 "../src/ImageManager.vala"
	u = _tmp3_;
#line 56 "../src/ImageManager.vala"
	_tmp4_ = u;
#line 56 "../src/ImageManager.vala"
	if (_tmp4_ != NULL) {
#line 1159 "ImageManager.c"
		const gchar* _tmp5_;
#line 57 "../src/ImageManager.vala"
		_tmp5_ = u;
#line 57 "../src/ImageManager.vala"
		image_manager_image_item_set_uri (self, _tmp5_);
#line 1165 "ImageManager.c"
	}
#line 59 "../src/ImageManager.vala"
	_tmp6_ = (gchar*) xmlGetProp (n, (xmlChar*) "ext");
#line 59 "../src/ImageManager.vala"
	e = _tmp6_;
#line 60 "../src/ImageManager.vala"
	_tmp7_ = e;
#line 60 "../src/ImageManager.vala"
	if (_tmp7_ != NULL) {
#line 1175 "ImageManager.c"
		const gchar* _tmp8_;
#line 61 "../src/ImageManager.vala"
		_tmp8_ = e;
#line 61 "../src/ImageManager.vala"
		image_manager_image_item_set_ext (self, _tmp8_);
#line 1181 "ImageManager.c"
	}
#line 63 "../src/ImageManager.vala"
	image_manager_image_item_set_valid (self, TRUE);
#line 50 "../src/ImageManager.vala"
	_g_free0 (e);
#line 50 "../src/ImageManager.vala"
	_g_free0 (u);
#line 50 "../src/ImageManager.vala"
	_g_free0 (i);
#line 50 "../src/ImageManager.vala"
	return self;
#line 1193 "ImageManager.c"
}


static ImageManagerImageItem*
image_manager_image_item_new_from_xml (xmlNode* n)
{
#line 50 "../src/ImageManager.vala"
	return image_manager_image_item_construct_from_xml (IMAGE_MANAGER_TYPE_IMAGE_ITEM, n);
#line 1202 "ImageManager.c"
}


static void
image_manager_image_item_save (ImageManagerImageItem* self,
                               xmlNode* parent)
{
	xmlNode* n = NULL;
	xmlNode* _tmp0_;
	gint _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	const gchar* _tmp5_;
#line 67 "../src/ImageManager.vala"
	g_return_if_fail (self != NULL);
#line 68 "../src/ImageManager.vala"
	_tmp0_ = xmlNewNode (NULL, (xmlChar*) "image");
#line 68 "../src/ImageManager.vala"
	n = _tmp0_;
#line 69 "../src/ImageManager.vala"
	_tmp1_ = self->priv->_id;
#line 69 "../src/ImageManager.vala"
	_tmp2_ = g_strdup_printf ("%i", _tmp1_);
#line 69 "../src/ImageManager.vala"
	_tmp3_ = _tmp2_;
#line 69 "../src/ImageManager.vala"
	xmlNewProp (n, (xmlChar*) "id", (xmlChar*) _tmp3_);
#line 69 "../src/ImageManager.vala"
	_g_free0 (_tmp3_);
#line 70 "../src/ImageManager.vala"
	_tmp4_ = self->priv->_uri;
#line 70 "../src/ImageManager.vala"
	xmlNewProp (n, (xmlChar*) "uri", (xmlChar*) _tmp4_);
#line 71 "../src/ImageManager.vala"
	_tmp5_ = self->priv->_ext;
#line 71 "../src/ImageManager.vala"
	xmlNewProp (n, (xmlChar*) "ext", (xmlChar*) _tmp5_);
#line 72 "../src/ImageManager.vala"
	xmlAddChild (parent, n);
#line 1243 "ImageManager.c"
}


static gboolean
image_manager_image_item_exists (ImageManagerImageItem* self)
{
	gboolean result = FALSE;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gboolean _tmp2_;
#line 76 "../src/ImageManager.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 77 "../src/ImageManager.vala"
	_tmp0_ = image_manager_image_item_get_path (self);
#line 77 "../src/ImageManager.vala"
	_tmp1_ = _tmp0_;
#line 77 "../src/ImageManager.vala"
	_tmp2_ = g_file_test (_tmp1_, G_FILE_TEST_EXISTS);
#line 77 "../src/ImageManager.vala"
	_g_free0 (_tmp1_);
#line 77 "../src/ImageManager.vala"
	result = _tmp2_;
#line 77 "../src/ImageManager.vala"
	return result;
#line 1268 "ImageManager.c"
}


static gchar*
image_manager_image_item_get_extension (ImageManagerImageItem* self)
{
	gchar* result = NULL;
	gchar** parts = NULL;
	const gchar* _tmp0_;
	gchar** _tmp1_;
	gchar** _tmp2_;
	gint parts_length1;
	gint _parts_size_;
	gchar* ext = NULL;
	gchar** _tmp3_;
	gint _tmp3__length1;
	gchar** _tmp4_;
	gint _tmp4__length1;
	const gchar* _tmp5_;
	gchar** _tmp6_;
	gchar** _tmp7_;
	gchar** _tmp8_;
	gint _tmp8__length1;
	const gchar* _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gboolean _tmp12_ = FALSE;
	gboolean _tmp13_ = FALSE;
	gboolean _tmp14_ = FALSE;
	gboolean _tmp15_ = FALSE;
	const gchar* _tmp16_;
	gchar* _tmp23_;
#line 81 "../src/ImageManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 82 "../src/ImageManager.vala"
	_tmp0_ = self->priv->_uri;
#line 82 "../src/ImageManager.vala"
	_tmp2_ = _tmp1_ = g_strsplit (_tmp0_, ".", 0);
#line 82 "../src/ImageManager.vala"
	parts = _tmp2_;
#line 82 "../src/ImageManager.vala"
	parts_length1 = _vala_array_length (_tmp1_);
#line 82 "../src/ImageManager.vala"
	_parts_size_ = parts_length1;
#line 83 "../src/ImageManager.vala"
	_tmp3_ = parts;
#line 83 "../src/ImageManager.vala"
	_tmp3__length1 = parts_length1;
#line 83 "../src/ImageManager.vala"
	_tmp4_ = parts;
#line 83 "../src/ImageManager.vala"
	_tmp4__length1 = parts_length1;
#line 83 "../src/ImageManager.vala"
	_tmp5_ = _tmp3_[_tmp4__length1 - 1];
#line 83 "../src/ImageManager.vala"
	_tmp7_ = _tmp6_ = g_strsplit (_tmp5_, "?", 0);
#line 83 "../src/ImageManager.vala"
	_tmp8_ = _tmp7_;
#line 83 "../src/ImageManager.vala"
	_tmp8__length1 = _vala_array_length (_tmp6_);
#line 83 "../src/ImageManager.vala"
	_tmp9_ = _tmp8_[0];
#line 83 "../src/ImageManager.vala"
	_tmp10_ = g_strdup (_tmp9_);
#line 83 "../src/ImageManager.vala"
	_tmp11_ = _tmp10_;
#line 83 "../src/ImageManager.vala"
	_tmp8_ = (_vala_array_free (_tmp8_, _tmp8__length1, (GDestroyNotify) g_free), NULL);
#line 83 "../src/ImageManager.vala"
	ext = _tmp11_;
#line 84 "../src/ImageManager.vala"
	_tmp16_ = ext;
#line 84 "../src/ImageManager.vala"
	if (g_strcmp0 (_tmp16_, "bmp") == 0) {
#line 84 "../src/ImageManager.vala"
		_tmp15_ = TRUE;
#line 1345 "ImageManager.c"
	} else {
		const gchar* _tmp17_;
#line 84 "../src/ImageManager.vala"
		_tmp17_ = ext;
#line 84 "../src/ImageManager.vala"
		_tmp15_ = g_strcmp0 (_tmp17_, "png") == 0;
#line 1352 "ImageManager.c"
	}
#line 84 "../src/ImageManager.vala"
	if (_tmp15_) {
#line 84 "../src/ImageManager.vala"
		_tmp14_ = TRUE;
#line 1358 "ImageManager.c"
	} else {
		const gchar* _tmp18_;
#line 84 "../src/ImageManager.vala"
		_tmp18_ = ext;
#line 84 "../src/ImageManager.vala"
		_tmp14_ = g_strcmp0 (_tmp18_, "jpg") == 0;
#line 1365 "ImageManager.c"
	}
#line 84 "../src/ImageManager.vala"
	if (_tmp14_) {
#line 84 "../src/ImageManager.vala"
		_tmp13_ = TRUE;
#line 1371 "ImageManager.c"
	} else {
		const gchar* _tmp19_;
#line 84 "../src/ImageManager.vala"
		_tmp19_ = ext;
#line 84 "../src/ImageManager.vala"
		_tmp13_ = g_strcmp0 (_tmp19_, "jpeg") == 0;
#line 1378 "ImageManager.c"
	}
#line 84 "../src/ImageManager.vala"
	if (_tmp13_) {
#line 84 "../src/ImageManager.vala"
		_tmp12_ = TRUE;
#line 1384 "ImageManager.c"
	} else {
		const gchar* _tmp20_;
#line 84 "../src/ImageManager.vala"
		_tmp20_ = ext;
#line 84 "../src/ImageManager.vala"
		_tmp12_ = g_strcmp0 (_tmp20_, "svg") == 0;
#line 1391 "ImageManager.c"
	}
#line 84 "../src/ImageManager.vala"
	if (_tmp12_) {
#line 1395 "ImageManager.c"
		const gchar* _tmp21_;
		gchar* _tmp22_;
#line 85 "../src/ImageManager.vala"
		_tmp21_ = ext;
#line 85 "../src/ImageManager.vala"
		_tmp22_ = g_strconcat (".", _tmp21_, NULL);
#line 85 "../src/ImageManager.vala"
		result = _tmp22_;
#line 85 "../src/ImageManager.vala"
		_g_free0 (ext);
#line 85 "../src/ImageManager.vala"
		parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 85 "../src/ImageManager.vala"
		return result;
#line 1410 "ImageManager.c"
	}
#line 87 "../src/ImageManager.vala"
	_tmp23_ = g_strdup ("");
#line 87 "../src/ImageManager.vala"
	result = _tmp23_;
#line 87 "../src/ImageManager.vala"
	_g_free0 (ext);
#line 87 "../src/ImageManager.vala"
	parts = (_vala_array_free (parts, parts_length1, (GDestroyNotify) g_free), NULL);
#line 87 "../src/ImageManager.vala"
	return result;
#line 1422 "ImageManager.c"
}


static gchar*
image_manager_image_item_get_path (ImageManagerImageItem* self)
{
	gchar* result = NULL;
	gchar* basename = NULL;
	gint _tmp0_;
	const gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
#line 91 "../src/ImageManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 92 "../src/ImageManager.vala"
	_tmp0_ = self->priv->_id;
#line 92 "../src/ImageManager.vala"
	_tmp1_ = self->priv->_ext;
#line 92 "../src/ImageManager.vala"
	_tmp2_ = g_strdup_printf ("img%06x%s", (guint) _tmp0_, _tmp1_);
#line 92 "../src/ImageManager.vala"
	basename = _tmp2_;
#line 93 "../src/ImageManager.vala"
	_tmp3_ = image_manager_get_storage_path ();
#line 93 "../src/ImageManager.vala"
	_tmp4_ = _tmp3_;
#line 93 "../src/ImageManager.vala"
	_tmp5_ = g_build_filename (_tmp4_, basename, NULL);
#line 93 "../src/ImageManager.vala"
	_tmp6_ = _tmp5_;
#line 93 "../src/ImageManager.vala"
	_g_free0 (_tmp4_);
#line 93 "../src/ImageManager.vala"
	result = _tmp6_;
#line 93 "../src/ImageManager.vala"
	_g_free0 (basename);
#line 93 "../src/ImageManager.vala"
	return result;
#line 1464 "ImageManager.c"
}


static gboolean
image_manager_image_item_copy_file (ImageManagerImageItem* self)
{
	gboolean result = FALSE;
	GFile* rfile = NULL;
	const gchar* _tmp0_;
	GFile* _tmp1_;
	GFile* lfile = NULL;
	gchar* _tmp2_;
	gchar* _tmp3_;
	GFile* _tmp4_;
	GFile* _tmp5_;
	GError* _inner_error0_ = NULL;
#line 97 "../src/ImageManager.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 98 "../src/ImageManager.vala"
	_tmp0_ = self->priv->_uri;
#line 98 "../src/ImageManager.vala"
	_tmp1_ = g_file_new_for_uri (_tmp0_);
#line 98 "../src/ImageManager.vala"
	rfile = _tmp1_;
#line 99 "../src/ImageManager.vala"
	_tmp2_ = image_manager_image_item_get_path (self);
#line 99 "../src/ImageManager.vala"
	_tmp3_ = _tmp2_;
#line 99 "../src/ImageManager.vala"
	_tmp4_ = g_file_new_for_path (_tmp3_);
#line 99 "../src/ImageManager.vala"
	_tmp5_ = _tmp4_;
#line 99 "../src/ImageManager.vala"
	_g_free0 (_tmp3_);
#line 99 "../src/ImageManager.vala"
	lfile = _tmp5_;
#line 1501 "ImageManager.c"
	{
		GFile* _tmp6_;
		GFile* _tmp7_;
#line 101 "../src/ImageManager.vala"
		_tmp6_ = rfile;
#line 101 "../src/ImageManager.vala"
		_tmp7_ = lfile;
#line 101 "../src/ImageManager.vala"
		g_file_copy (_tmp6_, _tmp7_, G_FILE_COPY_OVERWRITE, NULL, NULL, NULL, &_inner_error0_);
#line 101 "../src/ImageManager.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1513 "ImageManager.c"
			goto __catch22_g_error;
		}
	}
	goto __finally22;
	__catch22_g_error:
	{
		GError* e = NULL;
#line 100 "../src/ImageManager.vala"
		e = _inner_error0_;
#line 100 "../src/ImageManager.vala"
		_inner_error0_ = NULL;
#line 103 "../src/ImageManager.vala"
		result = FALSE;
#line 103 "../src/ImageManager.vala"
		_g_error_free0 (e);
#line 103 "../src/ImageManager.vala"
		_g_object_unref0 (lfile);
#line 103 "../src/ImageManager.vala"
		_g_object_unref0 (rfile);
#line 103 "../src/ImageManager.vala"
		return result;
#line 1535 "ImageManager.c"
	}
	__finally22:
#line 100 "../src/ImageManager.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 1540 "ImageManager.c"
		gboolean _tmp8_ = FALSE;
#line 100 "../src/ImageManager.vala"
		_g_object_unref0 (lfile);
#line 100 "../src/ImageManager.vala"
		_g_object_unref0 (rfile);
#line 100 "../src/ImageManager.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 100 "../src/ImageManager.vala"
		g_clear_error (&_inner_error0_);
#line 100 "../src/ImageManager.vala"
		return _tmp8_;
#line 1552 "ImageManager.c"
	}
#line 105 "../src/ImageManager.vala"
	result = TRUE;
#line 105 "../src/ImageManager.vala"
	_g_object_unref0 (lfile);
#line 105 "../src/ImageManager.vala"
	_g_object_unref0 (rfile);
#line 105 "../src/ImageManager.vala"
	return result;
#line 1562 "ImageManager.c"
}


static void
image_manager_image_item_cleanup (ImageManagerImageItem* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
#line 109 "../src/ImageManager.vala"
	g_return_if_fail (self != NULL);
#line 110 "../src/ImageManager.vala"
	_tmp1_ = self->priv->_valid;
#line 110 "../src/ImageManager.vala"
	if (!_tmp1_) {
#line 110 "../src/ImageManager.vala"
		_tmp0_ = image_manager_image_item_exists (self);
#line 1579 "ImageManager.c"
	} else {
#line 110 "../src/ImageManager.vala"
		_tmp0_ = FALSE;
#line 1583 "ImageManager.c"
	}
#line 110 "../src/ImageManager.vala"
	if (_tmp0_) {
#line 1587 "ImageManager.c"
		gchar* _tmp2_;
		gchar* _tmp3_;
#line 111 "../src/ImageManager.vala"
		_tmp2_ = image_manager_image_item_get_path (self);
#line 111 "../src/ImageManager.vala"
		_tmp3_ = _tmp2_;
#line 111 "../src/ImageManager.vala"
		g_unlink (_tmp3_);
#line 111 "../src/ImageManager.vala"
		_g_free0 (_tmp3_);
#line 1598 "ImageManager.c"
	}
}


static gint
image_manager_image_item_get_id (ImageManagerImageItem* self)
{
	gint result;
	gint _tmp0_;
#line 35 "../src/ImageManager.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 35 "../src/ImageManager.vala"
	_tmp0_ = self->priv->_id;
#line 35 "../src/ImageManager.vala"
	result = _tmp0_;
#line 35 "../src/ImageManager.vala"
	return result;
#line 1616 "ImageManager.c"
}


static void
image_manager_image_item_set_id (ImageManagerImageItem* self,
                                 gint value)
{
#line 35 "../src/ImageManager.vala"
	g_return_if_fail (self != NULL);
#line 35 "../src/ImageManager.vala"
	self->priv->_id = value;
#line 1628 "ImageManager.c"
}


static const gchar*
image_manager_image_item_get_uri (ImageManagerImageItem* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 36 "../src/ImageManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 36 "../src/ImageManager.vala"
	_tmp0_ = self->priv->_uri;
#line 36 "../src/ImageManager.vala"
	result = _tmp0_;
#line 36 "../src/ImageManager.vala"
	return result;
#line 1645 "ImageManager.c"
}


static void
image_manager_image_item_set_uri (ImageManagerImageItem* self,
                                  const gchar* value)
{
	gchar* _tmp0_;
#line 36 "../src/ImageManager.vala"
	g_return_if_fail (self != NULL);
#line 36 "../src/ImageManager.vala"
	_tmp0_ = g_strdup (value);
#line 36 "../src/ImageManager.vala"
	_g_free0 (self->priv->_uri);
#line 36 "../src/ImageManager.vala"
	self->priv->_uri = _tmp0_;
#line 1662 "ImageManager.c"
}


static const gchar*
image_manager_image_item_get_ext (ImageManagerImageItem* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 37 "../src/ImageManager.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 37 "../src/ImageManager.vala"
	_tmp0_ = self->priv->_ext;
#line 37 "../src/ImageManager.vala"
	result = _tmp0_;
#line 37 "../src/ImageManager.vala"
	return result;
#line 1679 "ImageManager.c"
}


static void
image_manager_image_item_set_ext (ImageManagerImageItem* self,
                                  const gchar* value)
{
	gchar* _tmp0_;
#line 37 "../src/ImageManager.vala"
	g_return_if_fail (self != NULL);
#line 37 "../src/ImageManager.vala"
	_tmp0_ = g_strdup (value);
#line 37 "../src/ImageManager.vala"
	_g_free0 (self->priv->_ext);
#line 37 "../src/ImageManager.vala"
	self->priv->_ext = _tmp0_;
#line 1696 "ImageManager.c"
}


static gboolean
image_manager_image_item_get_valid (ImageManagerImageItem* self)
{
	gboolean result;
	gboolean _tmp0_;
#line 38 "../src/ImageManager.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 38 "../src/ImageManager.vala"
	_tmp0_ = self->priv->_valid;
#line 38 "../src/ImageManager.vala"
	result = _tmp0_;
#line 38 "../src/ImageManager.vala"
	return result;
#line 1713 "ImageManager.c"
}


static void
image_manager_image_item_set_valid (ImageManagerImageItem* self,
                                    gboolean value)
{
#line 38 "../src/ImageManager.vala"
	g_return_if_fail (self != NULL);
#line 38 "../src/ImageManager.vala"
	self->priv->_valid = value;
#line 1725 "ImageManager.c"
}


static void
image_manager_value_image_item_init (GValue* value)
{
#line 33 "../src/ImageManager.vala"
	value->data[0].v_pointer = NULL;
#line 1734 "ImageManager.c"
}


static void
image_manager_value_image_item_free_value (GValue* value)
{
#line 33 "../src/ImageManager.vala"
	if (value->data[0].v_pointer) {
#line 33 "../src/ImageManager.vala"
		image_manager_image_item_unref (value->data[0].v_pointer);
#line 1745 "ImageManager.c"
	}
}


static void
image_manager_value_image_item_copy_value (const GValue* src_value,
                                           GValue* dest_value)
{
#line 33 "../src/ImageManager.vala"
	if (src_value->data[0].v_pointer) {
#line 33 "../src/ImageManager.vala"
		dest_value->data[0].v_pointer = image_manager_image_item_ref (src_value->data[0].v_pointer);
#line 1758 "ImageManager.c"
	} else {
#line 33 "../src/ImageManager.vala"
		dest_value->data[0].v_pointer = NULL;
#line 1762 "ImageManager.c"
	}
}


static gpointer
image_manager_value_image_item_peek_pointer (const GValue* value)
{
#line 33 "../src/ImageManager.vala"
	return value->data[0].v_pointer;
#line 1772 "ImageManager.c"
}


static gchar*
image_manager_value_image_item_collect_value (GValue* value,
                                              guint n_collect_values,
                                              GTypeCValue* collect_values,
                                              guint collect_flags)
{
#line 33 "../src/ImageManager.vala"
	if (collect_values[0].v_pointer) {
#line 1784 "ImageManager.c"
		ImageManagerImageItem * object;
		object = collect_values[0].v_pointer;
#line 33 "../src/ImageManager.vala"
		if (object->parent_instance.g_class == NULL) {
#line 33 "../src/ImageManager.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1791 "ImageManager.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 33 "../src/ImageManager.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1795 "ImageManager.c"
		}
#line 33 "../src/ImageManager.vala"
		value->data[0].v_pointer = image_manager_image_item_ref (object);
#line 1799 "ImageManager.c"
	} else {
#line 33 "../src/ImageManager.vala"
		value->data[0].v_pointer = NULL;
#line 1803 "ImageManager.c"
	}
#line 33 "../src/ImageManager.vala"
	return NULL;
#line 1807 "ImageManager.c"
}


static gchar*
image_manager_value_image_item_lcopy_value (const GValue* value,
                                            guint n_collect_values,
                                            GTypeCValue* collect_values,
                                            guint collect_flags)
{
	ImageManagerImageItem ** object_p;
	object_p = collect_values[0].v_pointer;
#line 33 "../src/ImageManager.vala"
	if (!object_p) {
#line 33 "../src/ImageManager.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1823 "ImageManager.c"
	}
#line 33 "../src/ImageManager.vala"
	if (!value->data[0].v_pointer) {
#line 33 "../src/ImageManager.vala"
		*object_p = NULL;
#line 1829 "ImageManager.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 33 "../src/ImageManager.vala"
		*object_p = value->data[0].v_pointer;
#line 1833 "ImageManager.c"
	} else {
#line 33 "../src/ImageManager.vala"
		*object_p = image_manager_image_item_ref (value->data[0].v_pointer);
#line 1837 "ImageManager.c"
	}
#line 33 "../src/ImageManager.vala"
	return NULL;
#line 1841 "ImageManager.c"
}


static GParamSpec*
image_manager_param_spec_image_item (const gchar* name,
                                     const gchar* nick,
                                     const gchar* blurb,
                                     GType object_type,
                                     GParamFlags flags)
{
	ImageManagerParamSpecImageItem* spec;
#line 33 "../src/ImageManager.vala"
	g_return_val_if_fail (g_type_is_a (object_type, IMAGE_MANAGER_TYPE_IMAGE_ITEM), NULL);
#line 33 "../src/ImageManager.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 33 "../src/ImageManager.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 33 "../src/ImageManager.vala"
	return G_PARAM_SPEC (spec);
#line 1861 "ImageManager.c"
}


static gpointer
image_manager_value_get_image_item (const GValue* value)
{
#line 33 "../src/ImageManager.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, IMAGE_MANAGER_TYPE_IMAGE_ITEM), NULL);
#line 33 "../src/ImageManager.vala"
	return value->data[0].v_pointer;
#line 1872 "ImageManager.c"
}


static void
image_manager_value_set_image_item (GValue* value,
                                    gpointer v_object)
{
	ImageManagerImageItem * old;
#line 33 "../src/ImageManager.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, IMAGE_MANAGER_TYPE_IMAGE_ITEM));
#line 33 "../src/ImageManager.vala"
	old = value->data[0].v_pointer;
#line 33 "../src/ImageManager.vala"
	if (v_object) {
#line 33 "../src/ImageManager.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, IMAGE_MANAGER_TYPE_IMAGE_ITEM));
#line 33 "../src/ImageManager.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 33 "../src/ImageManager.vala"
		value->data[0].v_pointer = v_object;
#line 33 "../src/ImageManager.vala"
		image_manager_image_item_ref (value->data[0].v_pointer);
#line 1895 "ImageManager.c"
	} else {
#line 33 "../src/ImageManager.vala"
		value->data[0].v_pointer = NULL;
#line 1899 "ImageManager.c"
	}
#line 33 "../src/ImageManager.vala"
	if (old) {
#line 33 "../src/ImageManager.vala"
		image_manager_image_item_unref (old);
#line 1905 "ImageManager.c"
	}
}


static void
image_manager_value_take_image_item (GValue* value,
                                     gpointer v_object)
{
	ImageManagerImageItem * old;
#line 33 "../src/ImageManager.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, IMAGE_MANAGER_TYPE_IMAGE_ITEM));
#line 33 "../src/ImageManager.vala"
	old = value->data[0].v_pointer;
#line 33 "../src/ImageManager.vala"
	if (v_object) {
#line 33 "../src/ImageManager.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, IMAGE_MANAGER_TYPE_IMAGE_ITEM));
#line 33 "../src/ImageManager.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 33 "../src/ImageManager.vala"
		value->data[0].v_pointer = v_object;
#line 1927 "ImageManager.c"
	} else {
#line 33 "../src/ImageManager.vala"
		value->data[0].v_pointer = NULL;
#line 1931 "ImageManager.c"
	}
#line 33 "../src/ImageManager.vala"
	if (old) {
#line 33 "../src/ImageManager.vala"
		image_manager_image_item_unref (old);
#line 1937 "ImageManager.c"
	}
}


static void
image_manager_image_item_class_init (ImageManagerImageItemClass * klass)
{
#line 33 "../src/ImageManager.vala"
	image_manager_image_item_parent_class = g_type_class_peek_parent (klass);
#line 33 "../src/ImageManager.vala"
	((ImageManagerImageItemClass *) klass)->finalize = image_manager_image_item_finalize;
#line 33 "../src/ImageManager.vala"
	g_type_class_adjust_private_offset (klass, &ImageManagerImageItem_private_offset);
#line 1951 "ImageManager.c"
}


static void
image_manager_image_item_instance_init (ImageManagerImageItem * self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 33 "../src/ImageManager.vala"
	self->priv = image_manager_image_item_get_instance_private (self);
#line 35 "../src/ImageManager.vala"
	self->priv->_id = -1;
#line 36 "../src/ImageManager.vala"
	_tmp0_ = g_strdup ("");
#line 36 "../src/ImageManager.vala"
	self->priv->_uri = _tmp0_;
#line 37 "../src/ImageManager.vala"
	_tmp1_ = g_strdup ("");
#line 37 "../src/ImageManager.vala"
	self->priv->_ext = _tmp1_;
#line 38 "../src/ImageManager.vala"
	self->priv->_valid = FALSE;
#line 33 "../src/ImageManager.vala"
	self->ref_count = 1;
#line 1976 "ImageManager.c"
}


static void
image_manager_image_item_finalize (ImageManagerImageItem * obj)
{
	ImageManagerImageItem * self;
#line 33 "../src/ImageManager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, IMAGE_MANAGER_TYPE_IMAGE_ITEM, ImageManagerImageItem);
#line 33 "../src/ImageManager.vala"
	g_signal_handlers_destroy (self);
#line 36 "../src/ImageManager.vala"
	_g_free0 (self->priv->_uri);
#line 37 "../src/ImageManager.vala"
	_g_free0 (self->priv->_ext);
#line 1992 "ImageManager.c"
}


static GType
image_manager_image_item_get_type (void)
{
	static volatile gsize image_manager_image_item_type_id__volatile = 0;
	if (g_once_init_enter (&image_manager_image_item_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { image_manager_value_image_item_init, image_manager_value_image_item_free_value, image_manager_value_image_item_copy_value, image_manager_value_image_item_peek_pointer, "p", image_manager_value_image_item_collect_value, "p", image_manager_value_image_item_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (ImageManagerImageItemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) image_manager_image_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ImageManagerImageItem), 0, (GInstanceInitFunc) image_manager_image_item_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType image_manager_image_item_type_id;
		image_manager_image_item_type_id = g_type_register_fundamental (g_type_fundamental_next (), "ImageManagerImageItem", &g_define_type_info, &g_define_type_fundamental_info, 0);
		ImageManagerImageItem_private_offset = g_type_add_instance_private (image_manager_image_item_type_id, sizeof (ImageManagerImageItemPrivate));
		g_once_init_leave (&image_manager_image_item_type_id__volatile, image_manager_image_item_type_id);
	}
	return image_manager_image_item_type_id__volatile;
}


static gpointer
image_manager_image_item_ref (gpointer instance)
{
	ImageManagerImageItem * self;
	self = instance;
#line 33 "../src/ImageManager.vala"
	g_atomic_int_inc (&self->ref_count);
#line 33 "../src/ImageManager.vala"
	return instance;
#line 2022 "ImageManager.c"
}


static void
image_manager_image_item_unref (gpointer instance)
{
	ImageManagerImageItem * self;
	self = instance;
#line 33 "../src/ImageManager.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 33 "../src/ImageManager.vala"
		IMAGE_MANAGER_IMAGE_ITEM_GET_CLASS (self)->finalize (self);
#line 33 "../src/ImageManager.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 2037 "ImageManager.c"
	}
}


static void
value_image_manager_init (GValue* value)
{
#line 25 "../src/ImageManager.vala"
	value->data[0].v_pointer = NULL;
#line 2047 "ImageManager.c"
}


static void
value_image_manager_free_value (GValue* value)
{
#line 25 "../src/ImageManager.vala"
	if (value->data[0].v_pointer) {
#line 25 "../src/ImageManager.vala"
		image_manager_unref (value->data[0].v_pointer);
#line 2058 "ImageManager.c"
	}
}


static void
value_image_manager_copy_value (const GValue* src_value,
                                GValue* dest_value)
{
#line 25 "../src/ImageManager.vala"
	if (src_value->data[0].v_pointer) {
#line 25 "../src/ImageManager.vala"
		dest_value->data[0].v_pointer = image_manager_ref (src_value->data[0].v_pointer);
#line 2071 "ImageManager.c"
	} else {
#line 25 "../src/ImageManager.vala"
		dest_value->data[0].v_pointer = NULL;
#line 2075 "ImageManager.c"
	}
}


static gpointer
value_image_manager_peek_pointer (const GValue* value)
{
#line 25 "../src/ImageManager.vala"
	return value->data[0].v_pointer;
#line 2085 "ImageManager.c"
}


static gchar*
value_image_manager_collect_value (GValue* value,
                                   guint n_collect_values,
                                   GTypeCValue* collect_values,
                                   guint collect_flags)
{
#line 25 "../src/ImageManager.vala"
	if (collect_values[0].v_pointer) {
#line 2097 "ImageManager.c"
		ImageManager * object;
		object = collect_values[0].v_pointer;
#line 25 "../src/ImageManager.vala"
		if (object->parent_instance.g_class == NULL) {
#line 25 "../src/ImageManager.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 2104 "ImageManager.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 25 "../src/ImageManager.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 2108 "ImageManager.c"
		}
#line 25 "../src/ImageManager.vala"
		value->data[0].v_pointer = image_manager_ref (object);
#line 2112 "ImageManager.c"
	} else {
#line 25 "../src/ImageManager.vala"
		value->data[0].v_pointer = NULL;
#line 2116 "ImageManager.c"
	}
#line 25 "../src/ImageManager.vala"
	return NULL;
#line 2120 "ImageManager.c"
}


static gchar*
value_image_manager_lcopy_value (const GValue* value,
                                 guint n_collect_values,
                                 GTypeCValue* collect_values,
                                 guint collect_flags)
{
	ImageManager ** object_p;
	object_p = collect_values[0].v_pointer;
#line 25 "../src/ImageManager.vala"
	if (!object_p) {
#line 25 "../src/ImageManager.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 2136 "ImageManager.c"
	}
#line 25 "../src/ImageManager.vala"
	if (!value->data[0].v_pointer) {
#line 25 "../src/ImageManager.vala"
		*object_p = NULL;
#line 2142 "ImageManager.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 25 "../src/ImageManager.vala"
		*object_p = value->data[0].v_pointer;
#line 2146 "ImageManager.c"
	} else {
#line 25 "../src/ImageManager.vala"
		*object_p = image_manager_ref (value->data[0].v_pointer);
#line 2150 "ImageManager.c"
	}
#line 25 "../src/ImageManager.vala"
	return NULL;
#line 2154 "ImageManager.c"
}


GParamSpec*
param_spec_image_manager (const gchar* name,
                          const gchar* nick,
                          const gchar* blurb,
                          GType object_type,
                          GParamFlags flags)
{
	ParamSpecImageManager* spec;
#line 25 "../src/ImageManager.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_IMAGE_MANAGER), NULL);
#line 25 "../src/ImageManager.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 25 "../src/ImageManager.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 25 "../src/ImageManager.vala"
	return G_PARAM_SPEC (spec);
#line 2174 "ImageManager.c"
}


gpointer
value_get_image_manager (const GValue* value)
{
#line 25 "../src/ImageManager.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_IMAGE_MANAGER), NULL);
#line 25 "../src/ImageManager.vala"
	return value->data[0].v_pointer;
#line 2185 "ImageManager.c"
}


void
value_set_image_manager (GValue* value,
                         gpointer v_object)
{
	ImageManager * old;
#line 25 "../src/ImageManager.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_IMAGE_MANAGER));
#line 25 "../src/ImageManager.vala"
	old = value->data[0].v_pointer;
#line 25 "../src/ImageManager.vala"
	if (v_object) {
#line 25 "../src/ImageManager.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_IMAGE_MANAGER));
#line 25 "../src/ImageManager.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 25 "../src/ImageManager.vala"
		value->data[0].v_pointer = v_object;
#line 25 "../src/ImageManager.vala"
		image_manager_ref (value->data[0].v_pointer);
#line 2208 "ImageManager.c"
	} else {
#line 25 "../src/ImageManager.vala"
		value->data[0].v_pointer = NULL;
#line 2212 "ImageManager.c"
	}
#line 25 "../src/ImageManager.vala"
	if (old) {
#line 25 "../src/ImageManager.vala"
		image_manager_unref (old);
#line 2218 "ImageManager.c"
	}
}


void
value_take_image_manager (GValue* value,
                          gpointer v_object)
{
	ImageManager * old;
#line 25 "../src/ImageManager.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_IMAGE_MANAGER));
#line 25 "../src/ImageManager.vala"
	old = value->data[0].v_pointer;
#line 25 "../src/ImageManager.vala"
	if (v_object) {
#line 25 "../src/ImageManager.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_IMAGE_MANAGER));
#line 25 "../src/ImageManager.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 25 "../src/ImageManager.vala"
		value->data[0].v_pointer = v_object;
#line 2240 "ImageManager.c"
	} else {
#line 25 "../src/ImageManager.vala"
		value->data[0].v_pointer = NULL;
#line 2244 "ImageManager.c"
	}
#line 25 "../src/ImageManager.vala"
	if (old) {
#line 25 "../src/ImageManager.vala"
		image_manager_unref (old);
#line 2250 "ImageManager.c"
	}
}


static void
image_manager_class_init (ImageManagerClass * klass)
{
#line 25 "../src/ImageManager.vala"
	image_manager_parent_class = g_type_class_peek_parent (klass);
#line 25 "../src/ImageManager.vala"
	((ImageManagerClass *) klass)->finalize = image_manager_finalize;
#line 25 "../src/ImageManager.vala"
	g_type_class_adjust_private_offset (klass, &ImageManager_private_offset);
#line 2264 "ImageManager.c"
}


static void
image_manager_instance_init (ImageManager * self)
{
#line 25 "../src/ImageManager.vala"
	self->priv = image_manager_get_instance_private (self);
#line 118 "../src/ImageManager.vala"
	self->priv->_available = TRUE;
#line 25 "../src/ImageManager.vala"
	self->ref_count = 1;
#line 2277 "ImageManager.c"
}


static void
image_manager_finalize (ImageManager * obj)
{
	ImageManager * self;
#line 25 "../src/ImageManager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_IMAGE_MANAGER, ImageManager);
#line 25 "../src/ImageManager.vala"
	g_signal_handlers_destroy (self);
#line 117 "../src/ImageManager.vala"
	_g_array_unref0 (self->priv->_images);
#line 2291 "ImageManager.c"
}


GType
image_manager_get_type (void)
{
	static volatile gsize image_manager_type_id__volatile = 0;
	if (g_once_init_enter (&image_manager_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_image_manager_init, value_image_manager_free_value, value_image_manager_copy_value, value_image_manager_peek_pointer, "p", value_image_manager_collect_value, "p", value_image_manager_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (ImageManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) image_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ImageManager), 0, (GInstanceInitFunc) image_manager_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType image_manager_type_id;
		image_manager_type_id = g_type_register_fundamental (g_type_fundamental_next (), "ImageManager", &g_define_type_info, &g_define_type_fundamental_info, 0);
		ImageManager_private_offset = g_type_add_instance_private (image_manager_type_id, sizeof (ImageManagerPrivate));
		g_once_init_leave (&image_manager_type_id__volatile, image_manager_type_id);
	}
	return image_manager_type_id__volatile;
}


gpointer
image_manager_ref (gpointer instance)
{
	ImageManager * self;
	self = instance;
#line 25 "../src/ImageManager.vala"
	g_atomic_int_inc (&self->ref_count);
#line 25 "../src/ImageManager.vala"
	return instance;
#line 2321 "ImageManager.c"
}


void
image_manager_unref (gpointer instance)
{
	ImageManager * self;
	self = instance;
#line 25 "../src/ImageManager.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 25 "../src/ImageManager.vala"
		IMAGE_MANAGER_GET_CLASS (self)->finalize (self);
#line 25 "../src/ImageManager.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 2336 "ImageManager.c"
	}
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}


static gint
_vala_array_length (gpointer array)
{
	int length;
	length = 0;
	if (array) {
		while (((gpointer*) array)[length]) {
			length++;
		}
	}
	return length;
}



