/* Layout.c generated by valac 0.42.7, the Vala compiler
 * generated from Layout.vala, do not modify */

/*
* Copyright (c) 2018 (https://github.com/phase1geo/Minder)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Trevor Williams <phase1geo@gmail.com>
*/


#include <glib.h>
#include <glib-object.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <gtk/gtk.h>


#define TYPE_LAYOUT (layout_get_type ())
#define LAYOUT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LAYOUT, Layout))
#define LAYOUT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LAYOUT, LayoutClass))
#define IS_LAYOUT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LAYOUT))
#define IS_LAYOUT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LAYOUT))
#define LAYOUT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LAYOUT, LayoutClass))

typedef struct _Layout Layout;
typedef struct _LayoutClass LayoutClass;
typedef struct _LayoutPrivate LayoutPrivate;
typedef enum  {
	NODE_SIDE_LEFT = 1,
	NODE_SIDE_TOP = 2,
	NODE_SIDE_RIGHT = 4,
	NODE_SIDE_BOTTOM = 8
} NodeSide;


#define TYPE_NODE_SIDE (node_side_get_type ())

#define TYPE_NODE (node_get_type ())
#define NODE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NODE, Node))
#define NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NODE, NodeClass))
#define IS_NODE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NODE))
#define IS_NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NODE))
#define NODE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NODE, NodeClass))

typedef struct _Node Node;
typedef struct _NodeClass NodeClass;

#define TYPE_NODE_BOUNDS (node_bounds_get_type ())
typedef struct _NodeBounds NodeBounds;
enum  {
	LAYOUT_0_PROPERTY,
	LAYOUT_NAME_PROPERTY,
	LAYOUT_ICON_PROPERTY,
	LAYOUT_BALANCEABLE_PROPERTY,
	LAYOUT_NUM_PROPERTIES
};
static GParamSpec* layout_properties[LAYOUT_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block14Data Block14Data;
#define _g_array_unref0(var) ((var == NULL) ? NULL : (var = (g_array_unref (var), NULL)))

#define TYPE_DRAW_AREA (draw_area_get_type ())
#define DRAW_AREA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DRAW_AREA, DrawArea))
#define DRAW_AREA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DRAW_AREA, DrawAreaClass))
#define IS_DRAW_AREA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DRAW_AREA))
#define IS_DRAW_AREA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DRAW_AREA))
#define DRAW_AREA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DRAW_AREA, DrawAreaClass))

typedef struct _DrawArea DrawArea;
typedef struct _DrawAreaClass DrawAreaClass;

struct _NodeBounds {
	gdouble x;
	gdouble y;
	gdouble width;
	gdouble height;
};

struct _Layout {
	GObject parent_instance;
	LayoutPrivate * priv;
	gdouble _pc_gap;
	gdouble _rt_gap;
};

struct _LayoutClass {
	GObjectClass parent_class;
	NodeSide (*side_mapping) (Layout* self, NodeSide side);
	void (*initialize) (Layout* self, Node* parent);
	void (*bbox) (Layout* self, Node* parent, gint side_mask, NodeBounds* result);
	void (*adjust_tree) (Layout* self, Node* parent, gint child_index, gint side_mask, gdouble amount);
	void (*adjust_tree_all) (Layout* self, Node* n, NodeBounds* prev, gdouble amount, const gchar* msg);
	void (*propagate_side) (Layout* self, Node* parent, NodeSide side);
	NodeSide (*get_side) (Layout* self, Node* n);
	void (*set_side) (Layout* self, Node* current);
	void (*handle_update_by_edit) (Layout* self, Node* n, gdouble diffw, gdouble diffh);
	void (*handle_update_by_fold) (Layout* self, Node* n);
	gdouble (*get_insert_adjust) (Layout* self, Node* child);
	void (*handle_update_by_insert) (Layout* self, Node* parent, Node* child, gint pos);
	void (*handle_update_by_delete) (Layout* self, Node* parent, gint index, NodeSide side, gdouble size);
	void (*position_root) (Layout* self, Node* last, Node* n);
};

struct _LayoutPrivate {
	gchar* _name;
	gchar* _icon;
	gboolean _balanceable;
};

struct _Block14Data {
	int _ref_count_;
	Layout* self;
	Node* parent;
};


static gint Layout_private_offset;
static gpointer layout_parent_class = NULL;

GType layout_get_type (void) G_GNUC_CONST;
GType node_side_get_type (void) G_GNUC_CONST;
GType node_get_type (void) G_GNUC_CONST;
GType node_bounds_get_type (void) G_GNUC_CONST;
NodeBounds* node_bounds_dup (const NodeBounds* self);
void node_bounds_free (NodeBounds* self);
Layout* layout_new (void);
Layout* layout_construct (GType object_type);
NodeSide layout_side_mapping (Layout* self,
                              NodeSide side);
static NodeSide layout_real_side_mapping (Layout* self,
                                   NodeSide side);
void layout_initialize (Layout* self,
                        Node* parent);
static void layout_real_initialize (Layout* self,
                             Node* parent);
static Block14Data* block14_data_ref (Block14Data* _data14_);
static void block14_data_unref (void * _userdata_);
GArray* node_children (Node* self);
NodeSide node_get_side (Node* self);
void node_set_side (Node* self,
                    NodeSide value);
static void __lambda35_ (Layout* self,
                  Node* item);
void node_detach (Node* self,
                  NodeSide side);
static void ___lambda35__gfunc (gconstpointer data,
                         gpointer self);
static void __lambda49_ (Block14Data* _data14_,
                  Node* item);
void node_attach_init (Node* self,
                       Node* parent,
                       gint index);
static void ___lambda49__gfunc (gconstpointer data,
                         gpointer self);
static void _g_object_unref0_ (gpointer var);
static inline void _g_slist_free__g_object_unref0_ (GSList* self);
void layout_bbox (Layout* self,
                  Node* parent,
                  gint side_mask,
                  NodeBounds* result);
static void layout_real_bbox (Layout* self,
                       Node* parent,
                       gint side_mask,
                       NodeBounds* result);
void node_bbox (Node* self,
                gdouble* x,
                gdouble* y,
                gdouble* w,
                gdouble* h);
gboolean node_get_folded (Node* self);
void node_get_tree_bbox (Node* self,
                         NodeBounds * result);
static void layout_update_tree_size (Layout* self,
                              Node* n);
void node_set_tree_bbox (Node* self,
                         NodeBounds * value);
gint node_side_horizontal (void);
void node_set_tree_size (Node* self,
                         gdouble value);
gdouble layout_get_adjust (Layout* self,
                           Node* parent);
gdouble node_get_tree_size (Node* self);
void layout_adjust_tree (Layout* self,
                         Node* parent,
                         gint child_index,
                         gint side_mask,
                         gdouble amount);
static void layout_real_adjust_tree (Layout* self,
                              Node* parent,
                              gint child_index,
                              gint side_mask,
                              gdouble amount);
gdouble node_get_posy (Node* self);
void node_set_posy (Node* self,
                    gdouble value);
gdouble node_get_posx (Node* self);
void node_set_posx (Node* self,
                    gdouble value);
void layout_adjust_tree_all (Layout* self,
                             Node* n,
                             NodeBounds* prev,
                             gdouble amount,
                             const gchar* msg);
static void layout_real_adjust_tree_all (Layout* self,
                                  Node* n,
                                  NodeBounds* prev,
                                  gdouble amount,
                                  const gchar* msg);
Node* node_get_parent (Node* self);
gint node_index (Node* self);
GType draw_area_get_type (void) G_GNUC_CONST;
DrawArea* node_get_da (Node* self);
GArray* draw_area_get_nodes (DrawArea* self);
void draw_area_handle_tree_overlap (DrawArea* self,
                                    NodeBounds* prev);
void layout_propagate_side (Layout* self,
                            Node* parent,
                            NodeSide side);
static void layout_real_propagate_side (Layout* self,
                                 Node* parent,
                                 NodeSide side);
NodeSide layout_get_side (Layout* self,
                          Node* n);
static NodeSide layout_real_get_side (Layout* self,
                               Node* n);
Node* node_get_root (Node* self);
void layout_set_side (Layout* self,
                      Node* current);
static void layout_real_set_side (Layout* self,
                           Node* current);
gboolean node_is_root (Node* self);
void layout_handle_update_by_edit (Layout* self,
                                   Node* n,
                                   gdouble diffw,
                                   gdouble diffh);
static void layout_real_handle_update_by_edit (Layout* self,
                                        Node* n,
                                        gdouble diffw,
                                        gdouble diffh);
void node_adjust_posy_only (Node* self,
                            gdouble value);
void node_adjust_posx_only (Node* self,
                            gdouble value);
void layout_handle_update_by_fold (Layout* self,
                                   Node* n);
static void layout_real_handle_update_by_fold (Layout* self,
                                        Node* n);
static void layout_set_pc_gap (Layout* self,
                        Node* n);
gdouble node_task_width (Node* self);
gdouble layout_get_insert_adjust (Layout* self,
                                  Node* child);
static gdouble layout_real_get_insert_adjust (Layout* self,
                                       Node* child);
void layout_handle_update_by_insert (Layout* self,
                                     Node* parent,
                                     Node* child,
                                     gint pos);
static void layout_real_handle_update_by_insert (Layout* self,
                                          Node* parent,
                                          Node* child,
                                          gint pos);
gint node_side_count (Node* self,
                      NodeSide side);
void layout_handle_update_by_delete (Layout* self,
                                     Node* parent,
                                     gint index,
                                     NodeSide side,
                                     gdouble size);
static void layout_real_handle_update_by_delete (Layout* self,
                                          Node* parent,
                                          gint index,
                                          NodeSide side,
                                          gdouble size);
void layout_position_root (Layout* self,
                           Node* last,
                           Node* n);
static void layout_real_position_root (Layout* self,
                                Node* last,
                                Node* n);
const gchar* layout_get_name (Layout* self);
void layout_set_name (Layout* self,
                      const gchar* value);
const gchar* layout_get_icon (Layout* self);
void layout_set_icon (Layout* self,
                      const gchar* value);
gboolean layout_get_balanceable (Layout* self);
void layout_set_balanceable (Layout* self,
                             gboolean value);
static void layout_finalize (GObject * obj);
static void _vala_layout_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec);
static void _vala_layout_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec);


static inline gpointer
layout_get_instance_private (Layout* self)
{
	return G_STRUCT_MEMBER_P (self, Layout_private_offset);
}


Layout*
layout_construct (GType object_type)
{
	Layout * self = NULL;
#line 32 "../src/Layout.vala"
	self = (Layout*) g_object_new (object_type, NULL);
#line 32 "../src/Layout.vala"
	return self;
#line 335 "Layout.c"
}


Layout*
layout_new (void)
{
#line 32 "../src/Layout.vala"
	return layout_construct (TYPE_LAYOUT);
#line 344 "Layout.c"
}


static NodeSide
layout_real_side_mapping (Layout* self,
                          NodeSide side)
{
	NodeSide result = 0;
#line 39 "../src/Layout.vala"
	switch (side) {
#line 39 "../src/Layout.vala"
		case NODE_SIDE_LEFT:
#line 357 "Layout.c"
		{
#line 40 "../src/Layout.vala"
			result = NODE_SIDE_LEFT;
#line 40 "../src/Layout.vala"
			return result;
#line 363 "Layout.c"
		}
#line 39 "../src/Layout.vala"
		case NODE_SIDE_RIGHT:
#line 367 "Layout.c"
		{
#line 41 "../src/Layout.vala"
			result = NODE_SIDE_RIGHT;
#line 41 "../src/Layout.vala"
			return result;
#line 373 "Layout.c"
		}
#line 39 "../src/Layout.vala"
		case NODE_SIDE_TOP:
#line 377 "Layout.c"
		{
#line 42 "../src/Layout.vala"
			result = NODE_SIDE_LEFT;
#line 42 "../src/Layout.vala"
			return result;
#line 383 "Layout.c"
		}
#line 39 "../src/Layout.vala"
		case NODE_SIDE_BOTTOM:
#line 387 "Layout.c"
		{
#line 43 "../src/Layout.vala"
			result = NODE_SIDE_RIGHT;
#line 43 "../src/Layout.vala"
			return result;
#line 393 "Layout.c"
		}
		default:
#line 39 "../src/Layout.vala"
		break;
#line 398 "Layout.c"
	}
#line 45 "../src/Layout.vala"
	result = NODE_SIDE_RIGHT;
#line 45 "../src/Layout.vala"
	return result;
#line 404 "Layout.c"
}


NodeSide
layout_side_mapping (Layout* self,
                     NodeSide side)
{
#line 38 "../src/Layout.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 38 "../src/Layout.vala"
	return LAYOUT_GET_CLASS (self)->side_mapping (self, side);
#line 416 "Layout.c"
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 49 "../src/Layout.vala"
	return self ? g_object_ref (self) : NULL;
#line 425 "Layout.c"
}


static Block14Data*
block14_data_ref (Block14Data* _data14_)
{
#line 49 "../src/Layout.vala"
	g_atomic_int_inc (&_data14_->_ref_count_);
#line 49 "../src/Layout.vala"
	return _data14_;
#line 436 "Layout.c"
}


static void
block14_data_unref (void * _userdata_)
{
	Block14Data* _data14_;
	_data14_ = (Block14Data*) _userdata_;
#line 49 "../src/Layout.vala"
	if (g_atomic_int_dec_and_test (&_data14_->_ref_count_)) {
#line 447 "Layout.c"
		Layout* self;
#line 49 "../src/Layout.vala"
		self = _data14_->self;
#line 49 "../src/Layout.vala"
		_g_object_unref0 (_data14_->parent);
#line 49 "../src/Layout.vala"
		_g_object_unref0 (self);
#line 49 "../src/Layout.vala"
		g_slice_free (Block14Data, _data14_);
#line 457 "Layout.c"
	}
}


static void
__lambda35_ (Layout* self,
             Node* item)
{
	NodeSide _tmp0_;
	NodeSide _tmp1_;
#line 57 "../src/Layout.vala"
	g_return_if_fail (item != NULL);
#line 58 "../src/Layout.vala"
	_tmp0_ = node_get_side (item);
#line 58 "../src/Layout.vala"
	_tmp1_ = _tmp0_;
#line 58 "../src/Layout.vala"
	node_detach (item, _tmp1_);
#line 476 "Layout.c"
}


static void
___lambda35__gfunc (gconstpointer data,
                    gpointer self)
{
#line 57 "../src/Layout.vala"
	__lambda35_ ((Layout*) self, (Node*) data);
#line 486 "Layout.c"
}


static void
__lambda49_ (Block14Data* _data14_,
             Node* item)
{
	Layout* self;
#line 60 "../src/Layout.vala"
	self = _data14_->self;
#line 60 "../src/Layout.vala"
	g_return_if_fail (item != NULL);
#line 61 "../src/Layout.vala"
	node_attach_init (item, _data14_->parent, -1);
#line 501 "Layout.c"
}


static void
___lambda49__gfunc (gconstpointer data,
                    gpointer self)
{
#line 60 "../src/Layout.vala"
	__lambda49_ (self, (Node*) data);
#line 511 "Layout.c"
}


static void
_g_object_unref0_ (gpointer var)
{
#line 49 "../src/Layout.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 520 "Layout.c"
}


static inline void
_g_slist_free__g_object_unref0_ (GSList* self)
{
#line 49 "../src/Layout.vala"
	g_slist_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 529 "Layout.c"
}


static void
layout_real_initialize (Layout* self,
                        Node* parent)
{
	Block14Data* _data14_;
	Node* _tmp0_;
	GSList* list = NULL;
	GSList* _tmp21_;
	GSList* _tmp22_;
#line 49 "../src/Layout.vala"
	g_return_if_fail (parent != NULL);
#line 49 "../src/Layout.vala"
	_data14_ = g_slice_new0 (Block14Data);
#line 49 "../src/Layout.vala"
	_data14_->_ref_count_ = 1;
#line 49 "../src/Layout.vala"
	_data14_->self = g_object_ref (self);
#line 49 "../src/Layout.vala"
	_tmp0_ = _g_object_ref0 (parent);
#line 49 "../src/Layout.vala"
	_g_object_unref0 (_data14_->parent);
#line 49 "../src/Layout.vala"
	_data14_->parent = _tmp0_;
#line 50 "../src/Layout.vala"
	list = NULL;
#line 558 "Layout.c"
	{
		gint i = 0;
#line 51 "../src/Layout.vala"
		i = 0;
#line 563 "Layout.c"
		{
			gboolean _tmp1_ = FALSE;
#line 51 "../src/Layout.vala"
			_tmp1_ = TRUE;
#line 51 "../src/Layout.vala"
			while (TRUE) {
#line 570 "Layout.c"
				gint _tmp3_;
				GArray* _tmp4_;
				GArray* _tmp5_;
				guint _tmp6_;
				gboolean _tmp7_;
				Node* n = NULL;
				GArray* _tmp8_;
				GArray* _tmp9_;
				gint _tmp10_;
				Node* _tmp11_;
				Node* _tmp12_;
				Node* _tmp13_;
				Node* _tmp14_;
				Node* _tmp15_;
				Node* _tmp16_;
				NodeSide _tmp17_;
				NodeSide _tmp18_;
				Node* _tmp19_;
				Node* _tmp20_;
#line 51 "../src/Layout.vala"
				if (!_tmp1_) {
#line 592 "Layout.c"
					gint _tmp2_;
#line 51 "../src/Layout.vala"
					_tmp2_ = i;
#line 51 "../src/Layout.vala"
					i = _tmp2_ + 1;
#line 598 "Layout.c"
				}
#line 51 "../src/Layout.vala"
				_tmp1_ = FALSE;
#line 51 "../src/Layout.vala"
				_tmp3_ = i;
#line 51 "../src/Layout.vala"
				_tmp4_ = node_children (_data14_->parent);
#line 51 "../src/Layout.vala"
				_tmp5_ = _tmp4_;
#line 51 "../src/Layout.vala"
				_tmp6_ = _tmp5_->len;
#line 51 "../src/Layout.vala"
				_tmp7_ = !(((guint) _tmp3_) < _tmp6_);
#line 51 "../src/Layout.vala"
				_g_array_unref0 (_tmp5_);
#line 51 "../src/Layout.vala"
				if (_tmp7_) {
#line 51 "../src/Layout.vala"
					break;
#line 618 "Layout.c"
				}
#line 52 "../src/Layout.vala"
				_tmp8_ = node_children (_data14_->parent);
#line 52 "../src/Layout.vala"
				_tmp9_ = _tmp8_;
#line 52 "../src/Layout.vala"
				_tmp10_ = i;
#line 52 "../src/Layout.vala"
				_tmp11_ = g_array_index (_tmp9_, Node*, (guint) _tmp10_);
#line 52 "../src/Layout.vala"
				_tmp12_ = _g_object_ref0 (_tmp11_);
#line 52 "../src/Layout.vala"
				_tmp13_ = _tmp12_;
#line 52 "../src/Layout.vala"
				_g_array_unref0 (_tmp9_);
#line 52 "../src/Layout.vala"
				n = _tmp13_;
#line 53 "../src/Layout.vala"
				_tmp14_ = n;
#line 53 "../src/Layout.vala"
				layout_initialize (self, _tmp14_);
#line 54 "../src/Layout.vala"
				_tmp15_ = n;
#line 54 "../src/Layout.vala"
				_tmp16_ = n;
#line 54 "../src/Layout.vala"
				_tmp17_ = node_get_side (_tmp16_);
#line 54 "../src/Layout.vala"
				_tmp18_ = _tmp17_;
#line 54 "../src/Layout.vala"
				node_set_side (_tmp15_, layout_side_mapping (self, _tmp18_));
#line 55 "../src/Layout.vala"
				_tmp19_ = n;
#line 55 "../src/Layout.vala"
				_tmp20_ = _g_object_ref0 (_tmp19_);
#line 55 "../src/Layout.vala"
				list = g_slist_append (list, _tmp20_);
#line 51 "../src/Layout.vala"
				_g_object_unref0 (n);
#line 658 "Layout.c"
			}
		}
	}
#line 57 "../src/Layout.vala"
	_tmp21_ = list;
#line 57 "../src/Layout.vala"
	g_slist_foreach (_tmp21_, ___lambda35__gfunc, self);
#line 60 "../src/Layout.vala"
	_tmp22_ = list;
#line 60 "../src/Layout.vala"
	g_slist_foreach (_tmp22_, ___lambda49__gfunc, _data14_);
#line 49 "../src/Layout.vala"
	(list == NULL) ? NULL : (list = (_g_slist_free__g_object_unref0_ (list), NULL));
#line 49 "../src/Layout.vala"
	block14_data_unref (_data14_);
#line 49 "../src/Layout.vala"
	_data14_ = NULL;
#line 676 "Layout.c"
}


void
layout_initialize (Layout* self,
                   Node* parent)
{
#line 49 "../src/Layout.vala"
	g_return_if_fail (self != NULL);
#line 49 "../src/Layout.vala"
	LAYOUT_GET_CLASS (self)->initialize (self, parent);
#line 688 "Layout.c"
}


static void
layout_real_bbox (Layout* self,
                  Node* parent,
                  gint side_mask,
                  NodeBounds* result)
{
	NodeBounds nb = {0};
	NodeBounds _tmp0_ = {0};
	guint num_children = 0U;
	GArray* _tmp1_;
	GArray* _tmp2_;
	guint _tmp3_;
	guint _tmp4_;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_ = 0.0;
	gdouble _tmp7_ = 0.0;
	gdouble _tmp8_ = 0.0;
	gdouble x2 = 0.0;
	NodeBounds _tmp9_;
	gdouble _tmp10_;
	NodeBounds _tmp11_;
	gdouble _tmp12_;
	gdouble y2 = 0.0;
	NodeBounds _tmp13_;
	gdouble _tmp14_;
	NodeBounds _tmp15_;
	gdouble _tmp16_;
	gboolean _tmp17_ = FALSE;
	guint _tmp18_;
	gdouble _tmp82_;
	NodeBounds _tmp83_;
	gdouble _tmp84_;
	gdouble _tmp85_;
	NodeBounds _tmp86_;
	gdouble _tmp87_;
#line 66 "../src/Layout.vala"
	g_return_if_fail (parent != NULL);
#line 68 "../src/Layout.vala"
	_tmp0_.x = (gdouble) 0;
#line 68 "../src/Layout.vala"
	_tmp0_.y = (gdouble) 0;
#line 68 "../src/Layout.vala"
	_tmp0_.width = (gdouble) 0;
#line 68 "../src/Layout.vala"
	_tmp0_.height = (gdouble) 0;
#line 68 "../src/Layout.vala"
	nb = _tmp0_;
#line 69 "../src/Layout.vala"
	_tmp1_ = node_children (parent);
#line 69 "../src/Layout.vala"
	_tmp2_ = _tmp1_;
#line 69 "../src/Layout.vala"
	_tmp3_ = _tmp2_->len;
#line 69 "../src/Layout.vala"
	_tmp4_ = _tmp3_;
#line 69 "../src/Layout.vala"
	_g_array_unref0 (_tmp2_);
#line 69 "../src/Layout.vala"
	num_children = _tmp4_;
#line 71 "../src/Layout.vala"
	node_bbox (parent, &_tmp5_, &_tmp6_, &_tmp7_, &_tmp8_);
#line 71 "../src/Layout.vala"
	nb.x = _tmp5_;
#line 71 "../src/Layout.vala"
	nb.y = _tmp6_;
#line 71 "../src/Layout.vala"
	nb.width = _tmp7_;
#line 71 "../src/Layout.vala"
	nb.height = _tmp8_;
#line 73 "../src/Layout.vala"
	_tmp9_ = nb;
#line 73 "../src/Layout.vala"
	_tmp10_ = _tmp9_.x;
#line 73 "../src/Layout.vala"
	_tmp11_ = nb;
#line 73 "../src/Layout.vala"
	_tmp12_ = _tmp11_.width;
#line 73 "../src/Layout.vala"
	x2 = _tmp10_ + _tmp12_;
#line 74 "../src/Layout.vala"
	_tmp13_ = nb;
#line 74 "../src/Layout.vala"
	_tmp14_ = _tmp13_.y;
#line 74 "../src/Layout.vala"
	_tmp15_ = nb;
#line 74 "../src/Layout.vala"
	_tmp16_ = _tmp15_.height;
#line 74 "../src/Layout.vala"
	y2 = _tmp14_ + _tmp16_;
#line 76 "../src/Layout.vala"
	_tmp18_ = num_children;
#line 76 "../src/Layout.vala"
	if (_tmp18_ != ((guint) 0)) {
#line 785 "Layout.c"
		gboolean _tmp19_;
		gboolean _tmp20_;
#line 76 "../src/Layout.vala"
		_tmp19_ = node_get_folded (parent);
#line 76 "../src/Layout.vala"
		_tmp20_ = _tmp19_;
#line 76 "../src/Layout.vala"
		_tmp17_ = !_tmp20_;
#line 794 "Layout.c"
	} else {
#line 76 "../src/Layout.vala"
		_tmp17_ = FALSE;
#line 798 "Layout.c"
	}
#line 76 "../src/Layout.vala"
	if (_tmp17_) {
#line 802 "Layout.c"
		{
			gint i = 0;
#line 77 "../src/Layout.vala"
			i = 0;
#line 807 "Layout.c"
			{
				gboolean _tmp21_ = FALSE;
#line 77 "../src/Layout.vala"
				_tmp21_ = TRUE;
#line 77 "../src/Layout.vala"
				while (TRUE) {
#line 814 "Layout.c"
					gint _tmp23_;
					GArray* _tmp24_;
					GArray* _tmp25_;
					guint _tmp26_;
					gboolean _tmp27_;
					GArray* _tmp28_;
					GArray* _tmp29_;
					gint _tmp30_;
					Node* _tmp31_;
					NodeSide _tmp32_;
					NodeSide _tmp33_;
					gboolean _tmp34_;
#line 77 "../src/Layout.vala"
					if (!_tmp21_) {
#line 829 "Layout.c"
						gint _tmp22_;
#line 77 "../src/Layout.vala"
						_tmp22_ = i;
#line 77 "../src/Layout.vala"
						i = _tmp22_ + 1;
#line 835 "Layout.c"
					}
#line 77 "../src/Layout.vala"
					_tmp21_ = FALSE;
#line 77 "../src/Layout.vala"
					_tmp23_ = i;
#line 77 "../src/Layout.vala"
					_tmp24_ = node_children (parent);
#line 77 "../src/Layout.vala"
					_tmp25_ = _tmp24_;
#line 77 "../src/Layout.vala"
					_tmp26_ = _tmp25_->len;
#line 77 "../src/Layout.vala"
					_tmp27_ = !(((guint) _tmp23_) < _tmp26_);
#line 77 "../src/Layout.vala"
					_g_array_unref0 (_tmp25_);
#line 77 "../src/Layout.vala"
					if (_tmp27_) {
#line 77 "../src/Layout.vala"
						break;
#line 855 "Layout.c"
					}
#line 78 "../src/Layout.vala"
					_tmp28_ = node_children (parent);
#line 78 "../src/Layout.vala"
					_tmp29_ = _tmp28_;
#line 78 "../src/Layout.vala"
					_tmp30_ = i;
#line 78 "../src/Layout.vala"
					_tmp31_ = g_array_index (_tmp29_, Node*, (guint) _tmp30_);
#line 78 "../src/Layout.vala"
					_tmp32_ = node_get_side (_tmp31_);
#line 78 "../src/Layout.vala"
					_tmp33_ = _tmp32_;
#line 78 "../src/Layout.vala"
					_tmp34_ = (_tmp33_ & side_mask) != 0;
#line 78 "../src/Layout.vala"
					_g_array_unref0 (_tmp29_);
#line 78 "../src/Layout.vala"
					if (_tmp34_) {
#line 875 "Layout.c"
						NodeBounds cb = {0};
						GArray* _tmp35_;
						GArray* _tmp36_;
						gint _tmp37_;
						Node* _tmp38_;
						NodeBounds _tmp39_ = {0};
						NodeBounds _tmp40_;
						NodeBounds _tmp41_;
						gdouble _tmp42_ = 0.0;
						NodeBounds _tmp43_;
						gdouble _tmp44_;
						NodeBounds _tmp45_;
						gdouble _tmp46_;
						gdouble _tmp51_ = 0.0;
						NodeBounds _tmp52_;
						gdouble _tmp53_;
						NodeBounds _tmp54_;
						gdouble _tmp55_;
						gdouble _tmp60_ = 0.0;
						gdouble _tmp61_;
						NodeBounds _tmp62_;
						gdouble _tmp63_;
						NodeBounds _tmp64_;
						gdouble _tmp65_;
						gdouble _tmp71_ = 0.0;
						gdouble _tmp72_;
						NodeBounds _tmp73_;
						gdouble _tmp74_;
						NodeBounds _tmp75_;
						gdouble _tmp76_;
#line 79 "../src/Layout.vala"
						_tmp35_ = node_children (parent);
#line 79 "../src/Layout.vala"
						_tmp36_ = _tmp35_;
#line 79 "../src/Layout.vala"
						_tmp37_ = i;
#line 79 "../src/Layout.vala"
						_tmp38_ = g_array_index (_tmp36_, Node*, (guint) _tmp37_);
#line 79 "../src/Layout.vala"
						node_get_tree_bbox (_tmp38_, &_tmp39_);
#line 79 "../src/Layout.vala"
						_tmp40_ = _tmp39_;
#line 79 "../src/Layout.vala"
						_tmp41_ = _tmp40_;
#line 79 "../src/Layout.vala"
						_g_array_unref0 (_tmp36_);
#line 79 "../src/Layout.vala"
						cb = _tmp41_;
#line 80 "../src/Layout.vala"
						_tmp43_ = nb;
#line 80 "../src/Layout.vala"
						_tmp44_ = _tmp43_.x;
#line 80 "../src/Layout.vala"
						_tmp45_ = cb;
#line 80 "../src/Layout.vala"
						_tmp46_ = _tmp45_.x;
#line 80 "../src/Layout.vala"
						if (_tmp44_ < _tmp46_) {
#line 934 "Layout.c"
							NodeBounds _tmp47_;
							gdouble _tmp48_;
#line 80 "../src/Layout.vala"
							_tmp47_ = nb;
#line 80 "../src/Layout.vala"
							_tmp48_ = _tmp47_.x;
#line 80 "../src/Layout.vala"
							_tmp42_ = _tmp48_;
#line 943 "Layout.c"
						} else {
							NodeBounds _tmp49_;
							gdouble _tmp50_;
#line 80 "../src/Layout.vala"
							_tmp49_ = cb;
#line 80 "../src/Layout.vala"
							_tmp50_ = _tmp49_.x;
#line 80 "../src/Layout.vala"
							_tmp42_ = _tmp50_;
#line 953 "Layout.c"
						}
#line 80 "../src/Layout.vala"
						nb.x = _tmp42_;
#line 81 "../src/Layout.vala"
						_tmp52_ = nb;
#line 81 "../src/Layout.vala"
						_tmp53_ = _tmp52_.y;
#line 81 "../src/Layout.vala"
						_tmp54_ = cb;
#line 81 "../src/Layout.vala"
						_tmp55_ = _tmp54_.y;
#line 81 "../src/Layout.vala"
						if (_tmp53_ < _tmp55_) {
#line 967 "Layout.c"
							NodeBounds _tmp56_;
							gdouble _tmp57_;
#line 81 "../src/Layout.vala"
							_tmp56_ = nb;
#line 81 "../src/Layout.vala"
							_tmp57_ = _tmp56_.y;
#line 81 "../src/Layout.vala"
							_tmp51_ = _tmp57_;
#line 976 "Layout.c"
						} else {
							NodeBounds _tmp58_;
							gdouble _tmp59_;
#line 81 "../src/Layout.vala"
							_tmp58_ = cb;
#line 81 "../src/Layout.vala"
							_tmp59_ = _tmp58_.y;
#line 81 "../src/Layout.vala"
							_tmp51_ = _tmp59_;
#line 986 "Layout.c"
						}
#line 81 "../src/Layout.vala"
						nb.y = _tmp51_;
#line 82 "../src/Layout.vala"
						_tmp61_ = x2;
#line 82 "../src/Layout.vala"
						_tmp62_ = cb;
#line 82 "../src/Layout.vala"
						_tmp63_ = _tmp62_.x;
#line 82 "../src/Layout.vala"
						_tmp64_ = cb;
#line 82 "../src/Layout.vala"
						_tmp65_ = _tmp64_.width;
#line 82 "../src/Layout.vala"
						if (_tmp61_ < (_tmp63_ + _tmp65_)) {
#line 1002 "Layout.c"
							NodeBounds _tmp66_;
							gdouble _tmp67_;
							NodeBounds _tmp68_;
							gdouble _tmp69_;
#line 82 "../src/Layout.vala"
							_tmp66_ = cb;
#line 82 "../src/Layout.vala"
							_tmp67_ = _tmp66_.x;
#line 82 "../src/Layout.vala"
							_tmp68_ = cb;
#line 82 "../src/Layout.vala"
							_tmp69_ = _tmp68_.width;
#line 82 "../src/Layout.vala"
							_tmp60_ = _tmp67_ + _tmp69_;
#line 1017 "Layout.c"
						} else {
							gdouble _tmp70_;
#line 82 "../src/Layout.vala"
							_tmp70_ = x2;
#line 82 "../src/Layout.vala"
							_tmp60_ = _tmp70_;
#line 1024 "Layout.c"
						}
#line 82 "../src/Layout.vala"
						x2 = _tmp60_;
#line 83 "../src/Layout.vala"
						_tmp72_ = y2;
#line 83 "../src/Layout.vala"
						_tmp73_ = cb;
#line 83 "../src/Layout.vala"
						_tmp74_ = _tmp73_.y;
#line 83 "../src/Layout.vala"
						_tmp75_ = cb;
#line 83 "../src/Layout.vala"
						_tmp76_ = _tmp75_.height;
#line 83 "../src/Layout.vala"
						if (_tmp72_ < (_tmp74_ + _tmp76_)) {
#line 1040 "Layout.c"
							NodeBounds _tmp77_;
							gdouble _tmp78_;
							NodeBounds _tmp79_;
							gdouble _tmp80_;
#line 83 "../src/Layout.vala"
							_tmp77_ = cb;
#line 83 "../src/Layout.vala"
							_tmp78_ = _tmp77_.y;
#line 83 "../src/Layout.vala"
							_tmp79_ = cb;
#line 83 "../src/Layout.vala"
							_tmp80_ = _tmp79_.height;
#line 83 "../src/Layout.vala"
							_tmp71_ = _tmp78_ + _tmp80_;
#line 1055 "Layout.c"
						} else {
							gdouble _tmp81_;
#line 83 "../src/Layout.vala"
							_tmp81_ = y2;
#line 83 "../src/Layout.vala"
							_tmp71_ = _tmp81_;
#line 1062 "Layout.c"
						}
#line 83 "../src/Layout.vala"
						y2 = _tmp71_;
#line 1066 "Layout.c"
					}
				}
			}
		}
	}
#line 88 "../src/Layout.vala"
	_tmp82_ = x2;
#line 88 "../src/Layout.vala"
	_tmp83_ = nb;
#line 88 "../src/Layout.vala"
	_tmp84_ = _tmp83_.x;
#line 88 "../src/Layout.vala"
	nb.width = _tmp82_ - _tmp84_;
#line 89 "../src/Layout.vala"
	_tmp85_ = y2;
#line 89 "../src/Layout.vala"
	_tmp86_ = nb;
#line 89 "../src/Layout.vala"
	_tmp87_ = _tmp86_.y;
#line 89 "../src/Layout.vala"
	nb.height = _tmp85_ - _tmp87_;
#line 91 "../src/Layout.vala"
	*result = nb;
#line 91 "../src/Layout.vala"
	return;
#line 1092 "Layout.c"
}


void
layout_bbox (Layout* self,
             Node* parent,
             gint side_mask,
             NodeBounds* result)
{
#line 66 "../src/Layout.vala"
	g_return_if_fail (self != NULL);
#line 66 "../src/Layout.vala"
	LAYOUT_GET_CLASS (self)->bbox (self, parent, side_mask, result);
#line 1106 "Layout.c"
}


static void
layout_update_tree_size (Layout* self,
                         Node* n)
{
	NodeBounds nb = {0};
	NodeBounds _tmp0_ = {0};
	NodeBounds _tmp1_;
	gdouble _tmp2_ = 0.0;
	NodeSide _tmp3_;
	NodeSide _tmp4_;
#line 96 "../src/Layout.vala"
	g_return_if_fail (self != NULL);
#line 96 "../src/Layout.vala"
	g_return_if_fail (n != NULL);
#line 99 "../src/Layout.vala"
	layout_bbox (self, n, -1, &_tmp0_);
#line 99 "../src/Layout.vala"
	nb = _tmp0_;
#line 102 "../src/Layout.vala"
	_tmp1_ = nb;
#line 102 "../src/Layout.vala"
	node_set_tree_bbox (n, &_tmp1_);
#line 105 "../src/Layout.vala"
	_tmp3_ = node_get_side (n);
#line 105 "../src/Layout.vala"
	_tmp4_ = _tmp3_;
#line 105 "../src/Layout.vala"
	if ((_tmp4_ & node_side_horizontal ()) != 0) {
#line 1138 "Layout.c"
		NodeBounds _tmp5_;
		gdouble _tmp6_;
#line 105 "../src/Layout.vala"
		_tmp5_ = nb;
#line 105 "../src/Layout.vala"
		_tmp6_ = _tmp5_.height;
#line 105 "../src/Layout.vala"
		_tmp2_ = _tmp6_;
#line 1147 "Layout.c"
	} else {
		NodeBounds _tmp7_;
		gdouble _tmp8_;
#line 105 "../src/Layout.vala"
		_tmp7_ = nb;
#line 105 "../src/Layout.vala"
		_tmp8_ = _tmp7_.width;
#line 105 "../src/Layout.vala"
		_tmp2_ = _tmp8_;
#line 1157 "Layout.c"
	}
#line 105 "../src/Layout.vala"
	node_set_tree_size (n, _tmp2_);
#line 1161 "Layout.c"
}


gdouble
layout_get_adjust (Layout* self,
                   Node* parent)
{
	gdouble result = 0.0;
	gdouble orig_tree_size = 0.0;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_;
#line 113 "../src/Layout.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 113 "../src/Layout.vala"
	g_return_val_if_fail (parent != NULL, 0.0);
#line 115 "../src/Layout.vala"
	_tmp0_ = node_get_tree_size (parent);
#line 115 "../src/Layout.vala"
	_tmp1_ = _tmp0_;
#line 115 "../src/Layout.vala"
	orig_tree_size = _tmp1_;
#line 117 "../src/Layout.vala"
	layout_update_tree_size (self, parent);
#line 119 "../src/Layout.vala"
	_tmp3_ = orig_tree_size;
#line 119 "../src/Layout.vala"
	if (_tmp3_ == ((gdouble) 0)) {
#line 119 "../src/Layout.vala"
		_tmp2_ = (gdouble) 0;
#line 1193 "Layout.c"
	} else {
		gdouble _tmp4_;
		gdouble _tmp5_;
		gdouble _tmp6_;
#line 119 "../src/Layout.vala"
		_tmp4_ = node_get_tree_size (parent);
#line 119 "../src/Layout.vala"
		_tmp5_ = _tmp4_;
#line 119 "../src/Layout.vala"
		_tmp6_ = orig_tree_size;
#line 119 "../src/Layout.vala"
		_tmp2_ = _tmp5_ - _tmp6_;
#line 1206 "Layout.c"
	}
#line 119 "../src/Layout.vala"
	result = _tmp2_;
#line 119 "../src/Layout.vala"
	return result;
#line 1212 "Layout.c"
}


static void
layout_real_adjust_tree (Layout* self,
                         Node* parent,
                         gint child_index,
                         gint side_mask,
                         gdouble amount)
{
#line 124 "../src/Layout.vala"
	g_return_if_fail (parent != NULL);
#line 1225 "Layout.c"
	{
		gint i = 0;
#line 126 "../src/Layout.vala"
		i = 0;
#line 1230 "Layout.c"
		{
			gboolean _tmp0_ = FALSE;
#line 126 "../src/Layout.vala"
			_tmp0_ = TRUE;
#line 126 "../src/Layout.vala"
			while (TRUE) {
#line 1237 "Layout.c"
				gint _tmp2_;
				GArray* _tmp3_;
				GArray* _tmp4_;
				guint _tmp5_;
				gboolean _tmp6_;
				gint _tmp7_;
#line 126 "../src/Layout.vala"
				if (!_tmp0_) {
#line 1246 "Layout.c"
					gint _tmp1_;
#line 126 "../src/Layout.vala"
					_tmp1_ = i;
#line 126 "../src/Layout.vala"
					i = _tmp1_ + 1;
#line 1252 "Layout.c"
				}
#line 126 "../src/Layout.vala"
				_tmp0_ = FALSE;
#line 126 "../src/Layout.vala"
				_tmp2_ = i;
#line 126 "../src/Layout.vala"
				_tmp3_ = node_children (parent);
#line 126 "../src/Layout.vala"
				_tmp4_ = _tmp3_;
#line 126 "../src/Layout.vala"
				_tmp5_ = _tmp4_->len;
#line 126 "../src/Layout.vala"
				_tmp6_ = !(((guint) _tmp2_) < _tmp5_);
#line 126 "../src/Layout.vala"
				_g_array_unref0 (_tmp4_);
#line 126 "../src/Layout.vala"
				if (_tmp6_) {
#line 126 "../src/Layout.vala"
					break;
#line 1272 "Layout.c"
				}
#line 127 "../src/Layout.vala"
				_tmp7_ = i;
#line 127 "../src/Layout.vala"
				if (_tmp7_ != child_index) {
#line 1278 "Layout.c"
					Node* n = NULL;
					GArray* _tmp8_;
					GArray* _tmp9_;
					gint _tmp10_;
					Node* _tmp11_;
					Node* _tmp12_;
					Node* _tmp13_;
					Node* _tmp14_;
					NodeSide _tmp15_;
					NodeSide _tmp16_;
#line 128 "../src/Layout.vala"
					_tmp8_ = node_children (parent);
#line 128 "../src/Layout.vala"
					_tmp9_ = _tmp8_;
#line 128 "../src/Layout.vala"
					_tmp10_ = i;
#line 128 "../src/Layout.vala"
					_tmp11_ = g_array_index (_tmp9_, Node*, (guint) _tmp10_);
#line 128 "../src/Layout.vala"
					_tmp12_ = _g_object_ref0 (_tmp11_);
#line 128 "../src/Layout.vala"
					_tmp13_ = _tmp12_;
#line 128 "../src/Layout.vala"
					_g_array_unref0 (_tmp9_);
#line 128 "../src/Layout.vala"
					n = _tmp13_;
#line 129 "../src/Layout.vala"
					_tmp14_ = n;
#line 129 "../src/Layout.vala"
					_tmp15_ = node_get_side (_tmp14_);
#line 129 "../src/Layout.vala"
					_tmp16_ = _tmp15_;
#line 129 "../src/Layout.vala"
					if ((_tmp16_ & side_mask) != 0) {
#line 1313 "Layout.c"
						Node* _tmp17_;
						NodeSide _tmp18_;
						NodeSide _tmp19_;
#line 130 "../src/Layout.vala"
						_tmp17_ = n;
#line 130 "../src/Layout.vala"
						_tmp18_ = node_get_side (_tmp17_);
#line 130 "../src/Layout.vala"
						_tmp19_ = _tmp18_;
#line 130 "../src/Layout.vala"
						if ((_tmp19_ & node_side_horizontal ()) != 0) {
#line 1325 "Layout.c"
							Node* _tmp20_;
							Node* _tmp21_;
							gdouble _tmp22_;
							gdouble _tmp23_;
#line 131 "../src/Layout.vala"
							_tmp20_ = n;
#line 131 "../src/Layout.vala"
							_tmp21_ = n;
#line 131 "../src/Layout.vala"
							_tmp22_ = node_get_posy (_tmp21_);
#line 131 "../src/Layout.vala"
							_tmp23_ = _tmp22_;
#line 131 "../src/Layout.vala"
							node_set_posy (_tmp21_, _tmp23_ + amount);
#line 1340 "Layout.c"
						} else {
							Node* _tmp24_;
							Node* _tmp25_;
							gdouble _tmp26_;
							gdouble _tmp27_;
#line 133 "../src/Layout.vala"
							_tmp24_ = n;
#line 133 "../src/Layout.vala"
							_tmp25_ = n;
#line 133 "../src/Layout.vala"
							_tmp26_ = node_get_posx (_tmp25_);
#line 133 "../src/Layout.vala"
							_tmp27_ = _tmp26_;
#line 133 "../src/Layout.vala"
							node_set_posx (_tmp25_, _tmp27_ + amount);
#line 1356 "Layout.c"
						}
					}
#line 127 "../src/Layout.vala"
					_g_object_unref0 (n);
#line 1361 "Layout.c"
				} else {
#line 137 "../src/Layout.vala"
					amount = 0 - amount;
#line 1365 "Layout.c"
				}
			}
		}
	}
}


void
layout_adjust_tree (Layout* self,
                    Node* parent,
                    gint child_index,
                    gint side_mask,
                    gdouble amount)
{
#line 124 "../src/Layout.vala"
	g_return_if_fail (self != NULL);
#line 124 "../src/Layout.vala"
	LAYOUT_GET_CLASS (self)->adjust_tree (self, parent, child_index, side_mask, amount);
#line 1384 "Layout.c"
}


static void
layout_real_adjust_tree_all (Layout* self,
                             Node* n,
                             NodeBounds* prev,
                             gdouble amount,
                             const gchar* msg)
{
	Node* parent = NULL;
	Node* _tmp0_;
	Node* _tmp1_;
	Node* _tmp2_;
	Node* last = NULL;
	Node* _tmp3_;
	gint index = 0;
	GArray* nodes = NULL;
	DrawArea* _tmp4_;
	DrawArea* _tmp5_;
	GArray* _tmp6_;
#line 144 "../src/Layout.vala"
	g_return_if_fail (n != NULL);
#line 144 "../src/Layout.vala"
	g_return_if_fail (prev != NULL);
#line 144 "../src/Layout.vala"
	g_return_if_fail (msg != NULL);
#line 146 "../src/Layout.vala"
	_tmp0_ = node_get_parent (n);
#line 146 "../src/Layout.vala"
	_tmp1_ = _tmp0_;
#line 146 "../src/Layout.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 146 "../src/Layout.vala"
	parent = _tmp2_;
#line 147 "../src/Layout.vala"
	_tmp3_ = _g_object_ref0 (n);
#line 147 "../src/Layout.vala"
	last = _tmp3_;
#line 148 "../src/Layout.vala"
	index = node_index (n);
#line 149 "../src/Layout.vala"
	_tmp4_ = node_get_da (n);
#line 149 "../src/Layout.vala"
	_tmp5_ = _tmp4_;
#line 149 "../src/Layout.vala"
	_tmp6_ = draw_area_get_nodes (_tmp5_);
#line 149 "../src/Layout.vala"
	nodes = _tmp6_;
#line 151 "../src/Layout.vala"
	while (TRUE) {
#line 1436 "Layout.c"
		Node* _tmp7_;
		Node* _tmp8_;
		gint _tmp9_;
		NodeSide _tmp10_;
		NodeSide _tmp11_;
		Node* _tmp12_;
		NodeBounds _tmp13_ = {0};
		NodeBounds _tmp14_;
		Node* _tmp15_;
		Node* _tmp16_;
		Node* _tmp17_;
		Node* _tmp18_;
		Node* _tmp19_;
		Node* _tmp20_;
		Node* _tmp21_;
		Node* _tmp22_;
#line 151 "../src/Layout.vala"
		_tmp7_ = parent;
#line 151 "../src/Layout.vala"
		if (!(_tmp7_ != NULL)) {
#line 151 "../src/Layout.vala"
			break;
#line 1459 "Layout.c"
		}
#line 152 "../src/Layout.vala"
		_tmp8_ = parent;
#line 152 "../src/Layout.vala"
		_tmp9_ = index;
#line 152 "../src/Layout.vala"
		_tmp10_ = node_get_side (n);
#line 152 "../src/Layout.vala"
		_tmp11_ = _tmp10_;
#line 152 "../src/Layout.vala"
		layout_adjust_tree (self, _tmp8_, _tmp9_, (gint) _tmp11_, amount);
#line 153 "../src/Layout.vala"
		_tmp12_ = parent;
#line 153 "../src/Layout.vala"
		node_get_tree_bbox (_tmp12_, &_tmp13_);
#line 153 "../src/Layout.vala"
		_tmp14_ = _tmp13_;
#line 153 "../src/Layout.vala"
		*prev = _tmp14_;
#line 154 "../src/Layout.vala"
		_tmp15_ = parent;
#line 154 "../src/Layout.vala"
		amount = 0 - (layout_get_adjust (self, _tmp15_) / 2);
#line 155 "../src/Layout.vala"
		_tmp16_ = parent;
#line 155 "../src/Layout.vala"
		index = node_index (_tmp16_);
#line 156 "../src/Layout.vala"
		_tmp17_ = parent;
#line 156 "../src/Layout.vala"
		_tmp18_ = _g_object_ref0 (_tmp17_);
#line 156 "../src/Layout.vala"
		_g_object_unref0 (last);
#line 156 "../src/Layout.vala"
		last = _tmp18_;
#line 157 "../src/Layout.vala"
		_tmp19_ = parent;
#line 157 "../src/Layout.vala"
		_tmp20_ = node_get_parent (_tmp19_);
#line 157 "../src/Layout.vala"
		_tmp21_ = _tmp20_;
#line 157 "../src/Layout.vala"
		_tmp22_ = _g_object_ref0 (_tmp21_);
#line 157 "../src/Layout.vala"
		_g_object_unref0 (parent);
#line 157 "../src/Layout.vala"
		parent = _tmp22_;
#line 1507 "Layout.c"
	}
	{
		gint i = 0;
#line 160 "../src/Layout.vala"
		i = 0;
#line 1513 "Layout.c"
		{
			gboolean _tmp23_ = FALSE;
#line 160 "../src/Layout.vala"
			_tmp23_ = TRUE;
#line 160 "../src/Layout.vala"
			while (TRUE) {
#line 1520 "Layout.c"
				gint _tmp25_;
				GArray* _tmp26_;
				guint _tmp27_;
				GArray* _tmp28_;
				gint _tmp29_;
				Node* _tmp30_;
				Node* _tmp31_;
#line 160 "../src/Layout.vala"
				if (!_tmp23_) {
#line 1530 "Layout.c"
					gint _tmp24_;
#line 160 "../src/Layout.vala"
					_tmp24_ = i;
#line 160 "../src/Layout.vala"
					i = _tmp24_ + 1;
#line 1536 "Layout.c"
				}
#line 160 "../src/Layout.vala"
				_tmp23_ = FALSE;
#line 160 "../src/Layout.vala"
				_tmp25_ = i;
#line 160 "../src/Layout.vala"
				_tmp26_ = nodes;
#line 160 "../src/Layout.vala"
				_tmp27_ = _tmp26_->len;
#line 160 "../src/Layout.vala"
				if (!(((guint) _tmp25_) < _tmp27_)) {
#line 160 "../src/Layout.vala"
					break;
#line 1550 "Layout.c"
				}
#line 161 "../src/Layout.vala"
				_tmp28_ = nodes;
#line 161 "../src/Layout.vala"
				_tmp29_ = i;
#line 161 "../src/Layout.vala"
				_tmp30_ = g_array_index (_tmp28_, Node*, (guint) _tmp29_);
#line 161 "../src/Layout.vala"
				_tmp31_ = last;
#line 161 "../src/Layout.vala"
				if (_tmp30_ == _tmp31_) {
#line 1562 "Layout.c"
					DrawArea* _tmp32_;
					DrawArea* _tmp33_;
					NodeBounds _tmp34_;
#line 162 "../src/Layout.vala"
					_tmp32_ = node_get_da (n);
#line 162 "../src/Layout.vala"
					_tmp33_ = _tmp32_;
#line 162 "../src/Layout.vala"
					_tmp34_ = *prev;
#line 162 "../src/Layout.vala"
					draw_area_handle_tree_overlap (_tmp33_, &_tmp34_);
#line 1574 "Layout.c"
				}
			}
		}
	}
#line 144 "../src/Layout.vala"
	_g_array_unref0 (nodes);
#line 144 "../src/Layout.vala"
	_g_object_unref0 (last);
#line 144 "../src/Layout.vala"
	_g_object_unref0 (parent);
#line 1585 "Layout.c"
}


void
layout_adjust_tree_all (Layout* self,
                        Node* n,
                        NodeBounds* prev,
                        gdouble amount,
                        const gchar* msg)
{
#line 144 "../src/Layout.vala"
	g_return_if_fail (self != NULL);
#line 144 "../src/Layout.vala"
	LAYOUT_GET_CLASS (self)->adjust_tree_all (self, n, prev, amount, msg);
#line 1600 "Layout.c"
}


static void
layout_real_propagate_side (Layout* self,
                            Node* parent,
                            NodeSide side)
{
	gdouble px = 0.0;
	gdouble py = 0.0;
	gdouble pw = 0.0;
	gdouble ph = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
#line 169 "../src/Layout.vala"
	g_return_if_fail (parent != NULL);
#line 173 "../src/Layout.vala"
	node_bbox (parent, &_tmp0_, &_tmp1_, &_tmp2_, &_tmp3_);
#line 173 "../src/Layout.vala"
	px = _tmp0_;
#line 173 "../src/Layout.vala"
	py = _tmp1_;
#line 173 "../src/Layout.vala"
	pw = _tmp2_;
#line 173 "../src/Layout.vala"
	ph = _tmp3_;
#line 1629 "Layout.c"
	{
		gint i = 0;
#line 175 "../src/Layout.vala"
		i = 0;
#line 1634 "Layout.c"
		{
			gboolean _tmp4_ = FALSE;
#line 175 "../src/Layout.vala"
			_tmp4_ = TRUE;
#line 175 "../src/Layout.vala"
			while (TRUE) {
#line 1641 "Layout.c"
				gint _tmp6_;
				GArray* _tmp7_;
				GArray* _tmp8_;
				guint _tmp9_;
				gboolean _tmp10_;
				Node* n = NULL;
				GArray* _tmp11_;
				GArray* _tmp12_;
				gint _tmp13_;
				Node* _tmp14_;
				Node* _tmp15_;
				Node* _tmp16_;
				Node* _tmp17_;
				NodeSide _tmp18_;
				NodeSide _tmp19_;
#line 175 "../src/Layout.vala"
				if (!_tmp4_) {
#line 1659 "Layout.c"
					gint _tmp5_;
#line 175 "../src/Layout.vala"
					_tmp5_ = i;
#line 175 "../src/Layout.vala"
					i = _tmp5_ + 1;
#line 1665 "Layout.c"
				}
#line 175 "../src/Layout.vala"
				_tmp4_ = FALSE;
#line 175 "../src/Layout.vala"
				_tmp6_ = i;
#line 175 "../src/Layout.vala"
				_tmp7_ = node_children (parent);
#line 175 "../src/Layout.vala"
				_tmp8_ = _tmp7_;
#line 175 "../src/Layout.vala"
				_tmp9_ = _tmp8_->len;
#line 175 "../src/Layout.vala"
				_tmp10_ = !(((guint) _tmp6_) < _tmp9_);
#line 175 "../src/Layout.vala"
				_g_array_unref0 (_tmp8_);
#line 175 "../src/Layout.vala"
				if (_tmp10_) {
#line 175 "../src/Layout.vala"
					break;
#line 1685 "Layout.c"
				}
#line 176 "../src/Layout.vala"
				_tmp11_ = node_children (parent);
#line 176 "../src/Layout.vala"
				_tmp12_ = _tmp11_;
#line 176 "../src/Layout.vala"
				_tmp13_ = i;
#line 176 "../src/Layout.vala"
				_tmp14_ = g_array_index (_tmp12_, Node*, (guint) _tmp13_);
#line 176 "../src/Layout.vala"
				_tmp15_ = _g_object_ref0 (_tmp14_);
#line 176 "../src/Layout.vala"
				_tmp16_ = _tmp15_;
#line 176 "../src/Layout.vala"
				_g_array_unref0 (_tmp12_);
#line 176 "../src/Layout.vala"
				n = _tmp16_;
#line 177 "../src/Layout.vala"
				_tmp17_ = n;
#line 177 "../src/Layout.vala"
				_tmp18_ = node_get_side (_tmp17_);
#line 177 "../src/Layout.vala"
				_tmp19_ = _tmp18_;
#line 177 "../src/Layout.vala"
				if (_tmp19_ != side) {
#line 1711 "Layout.c"
					Node* _tmp20_;
					Node* _tmp47_;
#line 178 "../src/Layout.vala"
					_tmp20_ = n;
#line 178 "../src/Layout.vala"
					node_set_side (_tmp20_, side);
#line 179 "../src/Layout.vala"
					switch (side) {
#line 179 "../src/Layout.vala"
						case NODE_SIDE_LEFT:
#line 1722 "Layout.c"
						{
							gdouble cx = 0.0;
							gdouble cy = 0.0;
							gdouble cw = 0.0;
							gdouble ch = 0.0;
							Node* _tmp21_;
							gdouble _tmp22_ = 0.0;
							gdouble _tmp23_ = 0.0;
							gdouble _tmp24_ = 0.0;
							gdouble _tmp25_ = 0.0;
							Node* _tmp26_;
							gdouble _tmp27_;
							gdouble _tmp28_;
							gdouble _tmp29_;
#line 182 "../src/Layout.vala"
							_tmp21_ = n;
#line 182 "../src/Layout.vala"
							node_bbox (_tmp21_, &_tmp22_, &_tmp23_, &_tmp24_, &_tmp25_);
#line 182 "../src/Layout.vala"
							cx = _tmp22_;
#line 182 "../src/Layout.vala"
							cy = _tmp23_;
#line 182 "../src/Layout.vala"
							cw = _tmp24_;
#line 182 "../src/Layout.vala"
							ch = _tmp25_;
#line 183 "../src/Layout.vala"
							_tmp26_ = n;
#line 183 "../src/Layout.vala"
							_tmp27_ = px;
#line 183 "../src/Layout.vala"
							_tmp28_ = self->_pc_gap;
#line 183 "../src/Layout.vala"
							_tmp29_ = cw;
#line 183 "../src/Layout.vala"
							node_set_posx (_tmp26_, (_tmp27_ - _tmp28_) - _tmp29_);
#line 184 "../src/Layout.vala"
							break;
#line 1761 "Layout.c"
						}
#line 179 "../src/Layout.vala"
						case NODE_SIDE_RIGHT:
#line 1765 "Layout.c"
						{
							Node* _tmp30_;
							gdouble _tmp31_;
							gdouble _tmp32_;
							gdouble _tmp33_;
#line 186 "../src/Layout.vala"
							_tmp30_ = n;
#line 186 "../src/Layout.vala"
							_tmp31_ = px;
#line 186 "../src/Layout.vala"
							_tmp32_ = pw;
#line 186 "../src/Layout.vala"
							_tmp33_ = self->_pc_gap;
#line 186 "../src/Layout.vala"
							node_set_posx (_tmp30_, (_tmp31_ + _tmp32_) + _tmp33_);
#line 187 "../src/Layout.vala"
							break;
#line 1783 "Layout.c"
						}
#line 179 "../src/Layout.vala"
						case NODE_SIDE_TOP:
#line 1787 "Layout.c"
						{
							gdouble cx = 0.0;
							gdouble cy = 0.0;
							gdouble cw = 0.0;
							gdouble ch = 0.0;
							Node* _tmp34_;
							gdouble _tmp35_ = 0.0;
							gdouble _tmp36_ = 0.0;
							gdouble _tmp37_ = 0.0;
							gdouble _tmp38_ = 0.0;
							Node* _tmp39_;
							gdouble _tmp40_;
							gdouble _tmp41_;
							gdouble _tmp42_;
#line 190 "../src/Layout.vala"
							_tmp34_ = n;
#line 190 "../src/Layout.vala"
							node_bbox (_tmp34_, &_tmp35_, &_tmp36_, &_tmp37_, &_tmp38_);
#line 190 "../src/Layout.vala"
							cx = _tmp35_;
#line 190 "../src/Layout.vala"
							cy = _tmp36_;
#line 190 "../src/Layout.vala"
							cw = _tmp37_;
#line 190 "../src/Layout.vala"
							ch = _tmp38_;
#line 191 "../src/Layout.vala"
							_tmp39_ = n;
#line 191 "../src/Layout.vala"
							_tmp40_ = py;
#line 191 "../src/Layout.vala"
							_tmp41_ = self->_pc_gap;
#line 191 "../src/Layout.vala"
							_tmp42_ = ch;
#line 191 "../src/Layout.vala"
							node_set_posy (_tmp39_, (_tmp40_ - _tmp41_) - _tmp42_);
#line 192 "../src/Layout.vala"
							break;
#line 1826 "Layout.c"
						}
#line 179 "../src/Layout.vala"
						case NODE_SIDE_BOTTOM:
#line 1830 "Layout.c"
						{
							Node* _tmp43_;
							gdouble _tmp44_;
							gdouble _tmp45_;
							gdouble _tmp46_;
#line 194 "../src/Layout.vala"
							_tmp43_ = n;
#line 194 "../src/Layout.vala"
							_tmp44_ = py;
#line 194 "../src/Layout.vala"
							_tmp45_ = ph;
#line 194 "../src/Layout.vala"
							_tmp46_ = self->_pc_gap;
#line 194 "../src/Layout.vala"
							node_set_posy (_tmp43_, (_tmp44_ + _tmp45_) + _tmp46_);
#line 195 "../src/Layout.vala"
							break;
#line 1848 "Layout.c"
						}
						default:
#line 179 "../src/Layout.vala"
						break;
#line 1853 "Layout.c"
					}
#line 197 "../src/Layout.vala"
					_tmp47_ = n;
#line 197 "../src/Layout.vala"
					layout_propagate_side (self, _tmp47_, side);
#line 1859 "Layout.c"
				}
#line 175 "../src/Layout.vala"
				_g_object_unref0 (n);
#line 1863 "Layout.c"
			}
		}
	}
}


void
layout_propagate_side (Layout* self,
                       Node* parent,
                       NodeSide side)
{
#line 169 "../src/Layout.vala"
	g_return_if_fail (self != NULL);
#line 169 "../src/Layout.vala"
	LAYOUT_GET_CLASS (self)->propagate_side (self, parent, side);
#line 1879 "Layout.c"
}


static NodeSide
layout_real_get_side (Layout* self,
                      Node* n)
{
	NodeSide result = 0;
	gdouble rx = 0.0;
	gdouble ry = 0.0;
	gdouble rw = 0.0;
	gdouble rh = 0.0;
	gdouble nx = 0.0;
	gdouble ny = 0.0;
	gdouble nw = 0.0;
	gdouble nh = 0.0;
	Node* _tmp0_;
	Node* _tmp1_;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_ = 0.0;
	gdouble _tmp7_ = 0.0;
	gdouble _tmp8_ = 0.0;
	gdouble _tmp9_ = 0.0;
	NodeSide _tmp10_;
	NodeSide _tmp11_;
#line 204 "../src/Layout.vala"
	g_return_val_if_fail (n != NULL, 0);
#line 207 "../src/Layout.vala"
	_tmp0_ = node_get_root (n);
#line 207 "../src/Layout.vala"
	_tmp1_ = _tmp0_;
#line 207 "../src/Layout.vala"
	node_bbox (_tmp1_, &_tmp2_, &_tmp3_, &_tmp4_, &_tmp5_);
#line 207 "../src/Layout.vala"
	rx = _tmp2_;
#line 207 "../src/Layout.vala"
	ry = _tmp3_;
#line 207 "../src/Layout.vala"
	rw = _tmp4_;
#line 207 "../src/Layout.vala"
	rh = _tmp5_;
#line 207 "../src/Layout.vala"
	_g_object_unref0 (_tmp1_);
#line 208 "../src/Layout.vala"
	node_bbox (n, &_tmp6_, &_tmp7_, &_tmp8_, &_tmp9_);
#line 208 "../src/Layout.vala"
	nx = _tmp6_;
#line 208 "../src/Layout.vala"
	ny = _tmp7_;
#line 208 "../src/Layout.vala"
	nw = _tmp8_;
#line 208 "../src/Layout.vala"
	nh = _tmp9_;
#line 209 "../src/Layout.vala"
	_tmp10_ = node_get_side (n);
#line 209 "../src/Layout.vala"
	_tmp11_ = _tmp10_;
#line 209 "../src/Layout.vala"
	if ((_tmp11_ & node_side_horizontal ()) != 0) {
#line 1942 "Layout.c"
		NodeSide _tmp12_ = 0;
		gdouble _tmp13_;
		gdouble _tmp14_;
		gdouble _tmp15_;
		gdouble _tmp16_;
#line 210 "../src/Layout.vala"
		_tmp13_ = nx;
#line 210 "../src/Layout.vala"
		_tmp14_ = nw;
#line 210 "../src/Layout.vala"
		_tmp15_ = rx;
#line 210 "../src/Layout.vala"
		_tmp16_ = rw;
#line 210 "../src/Layout.vala"
		if ((_tmp13_ + (_tmp14_ / 2)) > (_tmp15_ + (_tmp16_ / 2))) {
#line 210 "../src/Layout.vala"
			_tmp12_ = NODE_SIDE_RIGHT;
#line 1960 "Layout.c"
		} else {
#line 210 "../src/Layout.vala"
			_tmp12_ = NODE_SIDE_LEFT;
#line 1964 "Layout.c"
		}
#line 210 "../src/Layout.vala"
		result = _tmp12_;
#line 210 "../src/Layout.vala"
		return result;
#line 1970 "Layout.c"
	} else {
		NodeSide _tmp17_ = 0;
		gdouble _tmp18_;
		gdouble _tmp19_;
		gdouble _tmp20_;
		gdouble _tmp21_;
#line 212 "../src/Layout.vala"
		_tmp18_ = ny;
#line 212 "../src/Layout.vala"
		_tmp19_ = nh;
#line 212 "../src/Layout.vala"
		_tmp20_ = ry;
#line 212 "../src/Layout.vala"
		_tmp21_ = rh;
#line 212 "../src/Layout.vala"
		if ((_tmp18_ + (_tmp19_ / 2)) > (_tmp20_ + (_tmp21_ / 2))) {
#line 212 "../src/Layout.vala"
			_tmp17_ = NODE_SIDE_BOTTOM;
#line 1989 "Layout.c"
		} else {
#line 212 "../src/Layout.vala"
			_tmp17_ = NODE_SIDE_TOP;
#line 1993 "Layout.c"
		}
#line 212 "../src/Layout.vala"
		result = _tmp17_;
#line 212 "../src/Layout.vala"
		return result;
#line 1999 "Layout.c"
	}
}


NodeSide
layout_get_side (Layout* self,
                 Node* n)
{
#line 204 "../src/Layout.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 204 "../src/Layout.vala"
	return LAYOUT_GET_CLASS (self)->get_side (self, n);
#line 2012 "Layout.c"
}


static void
layout_real_set_side (Layout* self,
                      Node* current)
{
#line 217 "../src/Layout.vala"
	g_return_if_fail (current != NULL);
#line 218 "../src/Layout.vala"
	if (!node_is_root (current)) {
#line 2024 "Layout.c"
		NodeSide side = 0;
		NodeSide _tmp0_;
		NodeSide _tmp1_;
		NodeSide _tmp2_;
#line 219 "../src/Layout.vala"
		side = layout_get_side (self, current);
#line 220 "../src/Layout.vala"
		_tmp0_ = node_get_side (current);
#line 220 "../src/Layout.vala"
		_tmp1_ = _tmp0_;
#line 220 "../src/Layout.vala"
		_tmp2_ = side;
#line 220 "../src/Layout.vala"
		if (_tmp1_ != _tmp2_) {
#line 2039 "Layout.c"
			NodeSide _tmp3_;
			NodeSide _tmp4_;
#line 221 "../src/Layout.vala"
			_tmp3_ = side;
#line 221 "../src/Layout.vala"
			node_set_side (current, _tmp3_);
#line 222 "../src/Layout.vala"
			_tmp4_ = side;
#line 222 "../src/Layout.vala"
			layout_propagate_side (self, current, _tmp4_);
#line 2050 "Layout.c"
		}
	}
}


void
layout_set_side (Layout* self,
                 Node* current)
{
#line 217 "../src/Layout.vala"
	g_return_if_fail (self != NULL);
#line 217 "../src/Layout.vala"
	LAYOUT_GET_CLASS (self)->set_side (self, current);
#line 2064 "Layout.c"
}


static void
layout_real_handle_update_by_edit (Layout* self,
                                   Node* n,
                                   gdouble diffw,
                                   gdouble diffh)
{
	gdouble adjust = 0.0;
	NodeSide _tmp0_;
	NodeSide _tmp1_;
	NodeBounds _tmp50_ = {0};
	NodeBounds _tmp51_;
	gdouble _tmp52_;
#line 228 "../src/Layout.vala"
	g_return_if_fail (n != NULL);
#line 229 "../src/Layout.vala"
	adjust = 0 - (layout_get_adjust (self, n) / 2);
#line 230 "../src/Layout.vala"
	_tmp0_ = node_get_side (n);
#line 230 "../src/Layout.vala"
	_tmp1_ = _tmp0_;
#line 230 "../src/Layout.vala"
	if ((_tmp1_ & node_side_horizontal ()) != 0) {
#line 2090 "Layout.c"
		gboolean _tmp2_ = FALSE;
		Node* _tmp3_;
		Node* _tmp4_;
#line 231 "../src/Layout.vala"
		_tmp3_ = node_get_parent (n);
#line 231 "../src/Layout.vala"
		_tmp4_ = _tmp3_;
#line 231 "../src/Layout.vala"
		if (_tmp4_ != NULL) {
#line 231 "../src/Layout.vala"
			_tmp2_ = diffh != ((gdouble) 0);
#line 2102 "Layout.c"
		} else {
#line 231 "../src/Layout.vala"
			_tmp2_ = FALSE;
#line 2106 "Layout.c"
		}
#line 231 "../src/Layout.vala"
		if (_tmp2_) {
#line 232 "../src/Layout.vala"
			node_adjust_posy_only (n, 0 - (diffh / 2));
#line 2112 "Layout.c"
		}
#line 234 "../src/Layout.vala"
		if (diffw != ((gdouble) 0)) {
#line 2116 "Layout.c"
			NodeSide _tmp5_;
			NodeSide _tmp6_;
#line 235 "../src/Layout.vala"
			_tmp5_ = node_get_side (n);
#line 235 "../src/Layout.vala"
			_tmp6_ = _tmp5_;
#line 235 "../src/Layout.vala"
			if (_tmp6_ == NODE_SIDE_LEFT) {
#line 2125 "Layout.c"
				gdouble _tmp7_;
				gdouble _tmp8_;
#line 236 "../src/Layout.vala"
				_tmp7_ = node_get_posx (n);
#line 236 "../src/Layout.vala"
				_tmp8_ = _tmp7_;
#line 236 "../src/Layout.vala"
				node_set_posx (n, _tmp8_ - diffw);
#line 2134 "Layout.c"
			} else {
				{
					gint i = 0;
#line 238 "../src/Layout.vala"
					i = 0;
#line 2140 "Layout.c"
					{
						gboolean _tmp9_ = FALSE;
#line 238 "../src/Layout.vala"
						_tmp9_ = TRUE;
#line 238 "../src/Layout.vala"
						while (TRUE) {
#line 2147 "Layout.c"
							gint _tmp11_;
							GArray* _tmp12_;
							GArray* _tmp13_;
							guint _tmp14_;
							gboolean _tmp15_;
							GArray* _tmp16_;
							GArray* _tmp17_;
							gint _tmp18_;
							Node* _tmp19_;
							GArray* _tmp20_;
							GArray* _tmp21_;
							gint _tmp22_;
							Node* _tmp23_;
							gdouble _tmp24_;
							gdouble _tmp25_;
#line 238 "../src/Layout.vala"
							if (!_tmp9_) {
#line 2165 "Layout.c"
								gint _tmp10_;
#line 238 "../src/Layout.vala"
								_tmp10_ = i;
#line 238 "../src/Layout.vala"
								i = _tmp10_ + 1;
#line 2171 "Layout.c"
							}
#line 238 "../src/Layout.vala"
							_tmp9_ = FALSE;
#line 238 "../src/Layout.vala"
							_tmp11_ = i;
#line 238 "../src/Layout.vala"
							_tmp12_ = node_children (n);
#line 238 "../src/Layout.vala"
							_tmp13_ = _tmp12_;
#line 238 "../src/Layout.vala"
							_tmp14_ = _tmp13_->len;
#line 238 "../src/Layout.vala"
							_tmp15_ = !(((guint) _tmp11_) < _tmp14_);
#line 238 "../src/Layout.vala"
							_g_array_unref0 (_tmp13_);
#line 238 "../src/Layout.vala"
							if (_tmp15_) {
#line 238 "../src/Layout.vala"
								break;
#line 2191 "Layout.c"
							}
#line 239 "../src/Layout.vala"
							_tmp16_ = node_children (n);
#line 239 "../src/Layout.vala"
							_tmp17_ = _tmp16_;
#line 239 "../src/Layout.vala"
							_tmp18_ = i;
#line 239 "../src/Layout.vala"
							_tmp19_ = g_array_index (_tmp17_, Node*, (guint) _tmp18_);
#line 239 "../src/Layout.vala"
							_tmp20_ = node_children (n);
#line 239 "../src/Layout.vala"
							_tmp21_ = _tmp20_;
#line 239 "../src/Layout.vala"
							_tmp22_ = i;
#line 239 "../src/Layout.vala"
							_tmp23_ = g_array_index (_tmp21_, Node*, (guint) _tmp22_);
#line 239 "../src/Layout.vala"
							_tmp24_ = node_get_posx (_tmp23_);
#line 239 "../src/Layout.vala"
							_tmp25_ = _tmp24_;
#line 239 "../src/Layout.vala"
							node_set_posx (_tmp23_, _tmp25_ + diffw);
#line 239 "../src/Layout.vala"
							_g_array_unref0 (_tmp21_);
#line 239 "../src/Layout.vala"
							_g_array_unref0 (_tmp17_);
#line 2219 "Layout.c"
						}
					}
				}
			}
		}
	} else {
		gboolean _tmp26_ = FALSE;
		Node* _tmp27_;
		Node* _tmp28_;
#line 244 "../src/Layout.vala"
		_tmp27_ = node_get_parent (n);
#line 244 "../src/Layout.vala"
		_tmp28_ = _tmp27_;
#line 244 "../src/Layout.vala"
		if (_tmp28_ != NULL) {
#line 244 "../src/Layout.vala"
			_tmp26_ = diffw != ((gdouble) 0);
#line 2237 "Layout.c"
		} else {
#line 244 "../src/Layout.vala"
			_tmp26_ = FALSE;
#line 2241 "Layout.c"
		}
#line 244 "../src/Layout.vala"
		if (_tmp26_) {
#line 245 "../src/Layout.vala"
			node_adjust_posx_only (n, 0 - (diffw / 2));
#line 2247 "Layout.c"
		}
#line 247 "../src/Layout.vala"
		if (diffh != ((gdouble) 0)) {
#line 2251 "Layout.c"
			NodeSide _tmp29_;
			NodeSide _tmp30_;
#line 248 "../src/Layout.vala"
			_tmp29_ = node_get_side (n);
#line 248 "../src/Layout.vala"
			_tmp30_ = _tmp29_;
#line 248 "../src/Layout.vala"
			if (_tmp30_ == NODE_SIDE_TOP) {
#line 2260 "Layout.c"
				gdouble _tmp31_;
				gdouble _tmp32_;
#line 249 "../src/Layout.vala"
				_tmp31_ = node_get_posy (n);
#line 249 "../src/Layout.vala"
				_tmp32_ = _tmp31_;
#line 249 "../src/Layout.vala"
				node_set_posy (n, _tmp32_ - diffh);
#line 2269 "Layout.c"
			} else {
				{
					gint i = 0;
#line 251 "../src/Layout.vala"
					i = 0;
#line 2275 "Layout.c"
					{
						gboolean _tmp33_ = FALSE;
#line 251 "../src/Layout.vala"
						_tmp33_ = TRUE;
#line 251 "../src/Layout.vala"
						while (TRUE) {
#line 2282 "Layout.c"
							gint _tmp35_;
							GArray* _tmp36_;
							GArray* _tmp37_;
							guint _tmp38_;
							gboolean _tmp39_;
							GArray* _tmp40_;
							GArray* _tmp41_;
							gint _tmp42_;
							Node* _tmp43_;
							GArray* _tmp44_;
							GArray* _tmp45_;
							gint _tmp46_;
							Node* _tmp47_;
							gdouble _tmp48_;
							gdouble _tmp49_;
#line 251 "../src/Layout.vala"
							if (!_tmp33_) {
#line 2300 "Layout.c"
								gint _tmp34_;
#line 251 "../src/Layout.vala"
								_tmp34_ = i;
#line 251 "../src/Layout.vala"
								i = _tmp34_ + 1;
#line 2306 "Layout.c"
							}
#line 251 "../src/Layout.vala"
							_tmp33_ = FALSE;
#line 251 "../src/Layout.vala"
							_tmp35_ = i;
#line 251 "../src/Layout.vala"
							_tmp36_ = node_children (n);
#line 251 "../src/Layout.vala"
							_tmp37_ = _tmp36_;
#line 251 "../src/Layout.vala"
							_tmp38_ = _tmp37_->len;
#line 251 "../src/Layout.vala"
							_tmp39_ = !(((guint) _tmp35_) < _tmp38_);
#line 251 "../src/Layout.vala"
							_g_array_unref0 (_tmp37_);
#line 251 "../src/Layout.vala"
							if (_tmp39_) {
#line 251 "../src/Layout.vala"
								break;
#line 2326 "Layout.c"
							}
#line 252 "../src/Layout.vala"
							_tmp40_ = node_children (n);
#line 252 "../src/Layout.vala"
							_tmp41_ = _tmp40_;
#line 252 "../src/Layout.vala"
							_tmp42_ = i;
#line 252 "../src/Layout.vala"
							_tmp43_ = g_array_index (_tmp41_, Node*, (guint) _tmp42_);
#line 252 "../src/Layout.vala"
							_tmp44_ = node_children (n);
#line 252 "../src/Layout.vala"
							_tmp45_ = _tmp44_;
#line 252 "../src/Layout.vala"
							_tmp46_ = i;
#line 252 "../src/Layout.vala"
							_tmp47_ = g_array_index (_tmp45_, Node*, (guint) _tmp46_);
#line 252 "../src/Layout.vala"
							_tmp48_ = node_get_posy (_tmp47_);
#line 252 "../src/Layout.vala"
							_tmp49_ = _tmp48_;
#line 252 "../src/Layout.vala"
							node_set_posy (_tmp47_, _tmp49_ + diffh);
#line 252 "../src/Layout.vala"
							_g_array_unref0 (_tmp45_);
#line 252 "../src/Layout.vala"
							_g_array_unref0 (_tmp41_);
#line 2354 "Layout.c"
						}
					}
				}
			}
		}
	}
#line 257 "../src/Layout.vala"
	node_get_tree_bbox (n, &_tmp50_);
#line 257 "../src/Layout.vala"
	_tmp51_ = _tmp50_;
#line 257 "../src/Layout.vala"
	_tmp52_ = adjust;
#line 257 "../src/Layout.vala"
	layout_adjust_tree_all (self, n, &_tmp51_, _tmp52_, "by_edit");
#line 2369 "Layout.c"
}


void
layout_handle_update_by_edit (Layout* self,
                              Node* n,
                              gdouble diffw,
                              gdouble diffh)
{
#line 228 "../src/Layout.vala"
	g_return_if_fail (self != NULL);
#line 228 "../src/Layout.vala"
	LAYOUT_GET_CLASS (self)->handle_update_by_edit (self, n, diffw, diffh);
#line 2383 "Layout.c"
}


static void
layout_real_handle_update_by_fold (Layout* self,
                                   Node* n)
{
	NodeBounds _tmp0_ = {0};
	NodeBounds _tmp1_;
#line 261 "../src/Layout.vala"
	g_return_if_fail (n != NULL);
#line 262 "../src/Layout.vala"
	node_get_tree_bbox (n, &_tmp0_);
#line 262 "../src/Layout.vala"
	_tmp1_ = _tmp0_;
#line 262 "../src/Layout.vala"
	layout_adjust_tree_all (self, n, &_tmp1_, 0 - (layout_get_adjust (self, n) / 2), "by_fold");
#line 2401 "Layout.c"
}


void
layout_handle_update_by_fold (Layout* self,
                              Node* n)
{
#line 261 "../src/Layout.vala"
	g_return_if_fail (self != NULL);
#line 261 "../src/Layout.vala"
	LAYOUT_GET_CLASS (self)->handle_update_by_fold (self, n);
#line 2413 "Layout.c"
}


static void
layout_set_pc_gap (Layout* self,
                   Node* n)
{
	gdouble px = 0.0;
	gdouble py = 0.0;
	gdouble pw = 0.0;
	gdouble ph = 0.0;
	Node* _tmp0_;
	Node* _tmp1_;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	NodeSide _tmp6_;
	NodeSide _tmp7_;
#line 266 "../src/Layout.vala"
	g_return_if_fail (self != NULL);
#line 266 "../src/Layout.vala"
	g_return_if_fail (n != NULL);
#line 268 "../src/Layout.vala"
	_tmp0_ = node_get_parent (n);
#line 268 "../src/Layout.vala"
	_tmp1_ = _tmp0_;
#line 268 "../src/Layout.vala"
	node_bbox (_tmp1_, &_tmp2_, &_tmp3_, &_tmp4_, &_tmp5_);
#line 268 "../src/Layout.vala"
	px = _tmp2_;
#line 268 "../src/Layout.vala"
	py = _tmp3_;
#line 268 "../src/Layout.vala"
	pw = _tmp4_;
#line 268 "../src/Layout.vala"
	ph = _tmp5_;
#line 269 "../src/Layout.vala"
	_tmp6_ = node_get_side (n);
#line 269 "../src/Layout.vala"
	_tmp7_ = _tmp6_;
#line 269 "../src/Layout.vala"
	switch (_tmp7_) {
#line 269 "../src/Layout.vala"
		case NODE_SIDE_LEFT:
#line 2459 "Layout.c"
		{
			gdouble cx = 0.0;
			gdouble cy = 0.0;
			gdouble cw = 0.0;
			gdouble ch = 0.0;
			gdouble _tmp8_ = 0.0;
			gdouble _tmp9_ = 0.0;
			gdouble _tmp10_ = 0.0;
			gdouble _tmp11_ = 0.0;
			gdouble _tmp12_;
			gdouble _tmp13_;
			gdouble _tmp14_;
#line 272 "../src/Layout.vala"
			node_bbox (n, &_tmp8_, &_tmp9_, &_tmp10_, &_tmp11_);
#line 272 "../src/Layout.vala"
			cx = _tmp8_;
#line 272 "../src/Layout.vala"
			cy = _tmp9_;
#line 272 "../src/Layout.vala"
			cw = _tmp10_;
#line 272 "../src/Layout.vala"
			ch = _tmp11_;
#line 273 "../src/Layout.vala"
			_tmp12_ = px;
#line 273 "../src/Layout.vala"
			_tmp13_ = cw;
#line 273 "../src/Layout.vala"
			_tmp14_ = self->_pc_gap;
#line 273 "../src/Layout.vala"
			node_set_posx (n, _tmp12_ - (_tmp13_ + _tmp14_));
#line 274 "../src/Layout.vala"
			break;
#line 2492 "Layout.c"
		}
#line 269 "../src/Layout.vala"
		case NODE_SIDE_RIGHT:
#line 2496 "Layout.c"
		{
			gdouble _tmp15_;
			gdouble _tmp16_;
			gdouble _tmp17_;
			Node* _tmp18_;
			Node* _tmp19_;
#line 276 "../src/Layout.vala"
			_tmp15_ = px;
#line 276 "../src/Layout.vala"
			_tmp16_ = pw;
#line 276 "../src/Layout.vala"
			_tmp17_ = self->_pc_gap;
#line 276 "../src/Layout.vala"
			_tmp18_ = node_get_parent (n);
#line 276 "../src/Layout.vala"
			_tmp19_ = _tmp18_;
#line 276 "../src/Layout.vala"
			node_set_posx (n, (_tmp15_ + (_tmp16_ + _tmp17_)) - node_task_width (_tmp19_));
#line 277 "../src/Layout.vala"
			break;
#line 2517 "Layout.c"
		}
#line 269 "../src/Layout.vala"
		case NODE_SIDE_TOP:
#line 2521 "Layout.c"
		{
			gdouble cx = 0.0;
			gdouble cy = 0.0;
			gdouble cw = 0.0;
			gdouble ch = 0.0;
			gdouble _tmp20_ = 0.0;
			gdouble _tmp21_ = 0.0;
			gdouble _tmp22_ = 0.0;
			gdouble _tmp23_ = 0.0;
			gdouble _tmp24_;
			gdouble _tmp25_;
			gdouble _tmp26_;
#line 280 "../src/Layout.vala"
			node_bbox (n, &_tmp20_, &_tmp21_, &_tmp22_, &_tmp23_);
#line 280 "../src/Layout.vala"
			cx = _tmp20_;
#line 280 "../src/Layout.vala"
			cy = _tmp21_;
#line 280 "../src/Layout.vala"
			cw = _tmp22_;
#line 280 "../src/Layout.vala"
			ch = _tmp23_;
#line 281 "../src/Layout.vala"
			_tmp24_ = py;
#line 281 "../src/Layout.vala"
			_tmp25_ = ch;
#line 281 "../src/Layout.vala"
			_tmp26_ = self->_pc_gap;
#line 281 "../src/Layout.vala"
			node_set_posy (n, _tmp24_ - (_tmp25_ + _tmp26_));
#line 282 "../src/Layout.vala"
			break;
#line 2554 "Layout.c"
		}
#line 269 "../src/Layout.vala"
		case NODE_SIDE_BOTTOM:
#line 2558 "Layout.c"
		{
			gdouble _tmp27_;
			gdouble _tmp28_;
			gdouble _tmp29_;
#line 284 "../src/Layout.vala"
			_tmp27_ = py;
#line 284 "../src/Layout.vala"
			_tmp28_ = ph;
#line 284 "../src/Layout.vala"
			_tmp29_ = self->_pc_gap;
#line 284 "../src/Layout.vala"
			node_set_posy (n, _tmp27_ + (_tmp28_ + _tmp29_));
#line 285 "../src/Layout.vala"
			break;
#line 2573 "Layout.c"
		}
		default:
#line 269 "../src/Layout.vala"
		break;
#line 2578 "Layout.c"
	}
}


static gdouble
layout_real_get_insert_adjust (Layout* self,
                               Node* child)
{
	gdouble result = 0.0;
	gdouble _tmp0_;
	gdouble _tmp1_;
#line 290 "../src/Layout.vala"
	g_return_val_if_fail (child != NULL, 0.0);
#line 291 "../src/Layout.vala"
	_tmp0_ = node_get_tree_size (child);
#line 291 "../src/Layout.vala"
	_tmp1_ = _tmp0_;
#line 291 "../src/Layout.vala"
	result = _tmp1_ / 2;
#line 291 "../src/Layout.vala"
	return result;
#line 2600 "Layout.c"
}


gdouble
layout_get_insert_adjust (Layout* self,
                          Node* child)
{
#line 290 "../src/Layout.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 290 "../src/Layout.vala"
	return LAYOUT_GET_CLASS (self)->get_insert_adjust (self, child);
#line 2612 "Layout.c"
}


static void
layout_real_handle_update_by_insert (Layout* self,
                                     Node* parent,
                                     Node* child,
                                     gint pos)
{
	gdouble ox = 0.0;
	gdouble oy = 0.0;
	gdouble ow = 0.0;
	gdouble oh = 0.0;
	gdouble adjust = 0.0;
	NodeBounds cb = {0};
	NodeBounds _tmp0_ = {0};
	NodeBounds _tmp1_;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	NodeSide _tmp6_;
	NodeSide _tmp7_;
	NodeBounds _tmp78_ = {0};
	NodeBounds _tmp79_;
	gdouble _tmp80_;
#line 295 "../src/Layout.vala"
	g_return_if_fail (parent != NULL);
#line 295 "../src/Layout.vala"
	g_return_if_fail (child != NULL);
#line 300 "../src/Layout.vala"
	layout_update_tree_size (self, child);
#line 302 "../src/Layout.vala"
	node_get_tree_bbox (child, &_tmp0_);
#line 302 "../src/Layout.vala"
	_tmp1_ = _tmp0_;
#line 302 "../src/Layout.vala"
	cb = _tmp1_;
#line 304 "../src/Layout.vala"
	node_bbox (child, &_tmp2_, &_tmp3_, &_tmp4_, &_tmp5_);
#line 304 "../src/Layout.vala"
	ox = _tmp2_;
#line 304 "../src/Layout.vala"
	oy = _tmp3_;
#line 304 "../src/Layout.vala"
	ow = _tmp4_;
#line 304 "../src/Layout.vala"
	oh = _tmp5_;
#line 305 "../src/Layout.vala"
	layout_set_pc_gap (self, child);
#line 306 "../src/Layout.vala"
	adjust = layout_get_insert_adjust (self, child);
#line 312 "../src/Layout.vala"
	_tmp6_ = node_get_side (child);
#line 312 "../src/Layout.vala"
	_tmp7_ = _tmp6_;
#line 312 "../src/Layout.vala"
	if (node_side_count (parent, _tmp7_) == 1) {
#line 2671 "Layout.c"
		gdouble px = 0.0;
		gdouble py = 0.0;
		gdouble pw = 0.0;
		gdouble ph = 0.0;
		gdouble _tmp8_ = 0.0;
		gdouble _tmp9_ = 0.0;
		gdouble _tmp10_ = 0.0;
		gdouble _tmp11_ = 0.0;
		NodeSide _tmp12_;
		NodeSide _tmp13_;
#line 314 "../src/Layout.vala"
		node_bbox (parent, &_tmp8_, &_tmp9_, &_tmp10_, &_tmp11_);
#line 314 "../src/Layout.vala"
		px = _tmp8_;
#line 314 "../src/Layout.vala"
		py = _tmp9_;
#line 314 "../src/Layout.vala"
		pw = _tmp10_;
#line 314 "../src/Layout.vala"
		ph = _tmp11_;
#line 315 "../src/Layout.vala"
		_tmp12_ = node_get_side (child);
#line 315 "../src/Layout.vala"
		_tmp13_ = _tmp12_;
#line 315 "../src/Layout.vala"
		if ((_tmp13_ & node_side_horizontal ()) != 0) {
#line 2698 "Layout.c"
			gdouble _tmp14_;
			gdouble _tmp15_;
			gdouble _tmp16_;
#line 316 "../src/Layout.vala"
			_tmp14_ = py;
#line 316 "../src/Layout.vala"
			_tmp15_ = ph;
#line 316 "../src/Layout.vala"
			_tmp16_ = oh;
#line 316 "../src/Layout.vala"
			node_set_posy (child, _tmp14_ + ((_tmp15_ / 2) - (_tmp16_ / 2)));
#line 2710 "Layout.c"
		} else {
			gdouble _tmp17_;
			gdouble _tmp18_;
			gdouble _tmp19_;
#line 318 "../src/Layout.vala"
			_tmp17_ = px;
#line 318 "../src/Layout.vala"
			_tmp18_ = pw;
#line 318 "../src/Layout.vala"
			_tmp19_ = ow;
#line 318 "../src/Layout.vala"
			node_set_posx (child, _tmp17_ + ((_tmp18_ / 2) - (_tmp19_ / 2)));
#line 2723 "Layout.c"
		}
	} else {
		gboolean _tmp20_ = FALSE;
		GArray* _tmp21_;
		GArray* _tmp22_;
		guint _tmp23_;
		gboolean _tmp24_;
#line 325 "../src/Layout.vala"
		_tmp21_ = node_children (parent);
#line 325 "../src/Layout.vala"
		_tmp22_ = _tmp21_;
#line 325 "../src/Layout.vala"
		_tmp23_ = _tmp22_->len;
#line 325 "../src/Layout.vala"
		_tmp24_ = ((guint) (pos + 1)) == _tmp23_;
#line 325 "../src/Layout.vala"
		_g_array_unref0 (_tmp22_);
#line 325 "../src/Layout.vala"
		if (_tmp24_) {
#line 325 "../src/Layout.vala"
			_tmp20_ = TRUE;
#line 2745 "Layout.c"
		} else {
			GArray* _tmp25_;
			GArray* _tmp26_;
			Node* _tmp27_;
			NodeSide _tmp28_;
			NodeSide _tmp29_;
			NodeSide _tmp30_;
			NodeSide _tmp31_;
#line 325 "../src/Layout.vala"
			_tmp25_ = node_children (parent);
#line 325 "../src/Layout.vala"
			_tmp26_ = _tmp25_;
#line 325 "../src/Layout.vala"
			_tmp27_ = g_array_index (_tmp26_, Node*, (guint) (pos + 1));
#line 325 "../src/Layout.vala"
			_tmp28_ = node_get_side (_tmp27_);
#line 325 "../src/Layout.vala"
			_tmp29_ = _tmp28_;
#line 325 "../src/Layout.vala"
			_tmp30_ = node_get_side (child);
#line 325 "../src/Layout.vala"
			_tmp31_ = _tmp30_;
#line 325 "../src/Layout.vala"
			_tmp20_ = _tmp29_ != _tmp31_;
#line 325 "../src/Layout.vala"
			_g_array_unref0 (_tmp26_);
#line 2772 "Layout.c"
		}
#line 325 "../src/Layout.vala"
		if (_tmp20_) {
#line 2776 "Layout.c"
			NodeBounds sb = {0};
			GArray* _tmp32_;
			GArray* _tmp33_;
			Node* _tmp34_;
			NodeSide _tmp35_;
			NodeSide _tmp36_;
			NodeBounds _tmp37_ = {0};
			NodeBounds _tmp38_;
			NodeSide _tmp39_;
			NodeSide _tmp40_;
#line 326 "../src/Layout.vala"
			_tmp32_ = node_children (parent);
#line 326 "../src/Layout.vala"
			_tmp33_ = _tmp32_;
#line 326 "../src/Layout.vala"
			_tmp34_ = g_array_index (_tmp33_, Node*, (guint) (pos - 1));
#line 326 "../src/Layout.vala"
			_tmp35_ = node_get_side (child);
#line 326 "../src/Layout.vala"
			_tmp36_ = _tmp35_;
#line 326 "../src/Layout.vala"
			layout_bbox (self, _tmp34_, (gint) _tmp36_, &_tmp37_);
#line 326 "../src/Layout.vala"
			_tmp38_ = _tmp37_;
#line 326 "../src/Layout.vala"
			_g_array_unref0 (_tmp33_);
#line 326 "../src/Layout.vala"
			sb = _tmp38_;
#line 327 "../src/Layout.vala"
			_tmp39_ = node_get_side (child);
#line 327 "../src/Layout.vala"
			_tmp40_ = _tmp39_;
#line 327 "../src/Layout.vala"
			if ((_tmp40_ & node_side_horizontal ()) != 0) {
#line 2811 "Layout.c"
				NodeBounds _tmp41_;
				gdouble _tmp42_;
				NodeBounds _tmp43_;
				gdouble _tmp44_;
				gdouble _tmp45_;
				NodeBounds _tmp46_;
				gdouble _tmp47_;
				gdouble _tmp48_;
#line 328 "../src/Layout.vala"
				_tmp41_ = sb;
#line 328 "../src/Layout.vala"
				_tmp42_ = _tmp41_.y;
#line 328 "../src/Layout.vala"
				_tmp43_ = sb;
#line 328 "../src/Layout.vala"
				_tmp44_ = _tmp43_.height;
#line 328 "../src/Layout.vala"
				_tmp45_ = oy;
#line 328 "../src/Layout.vala"
				_tmp46_ = cb;
#line 328 "../src/Layout.vala"
				_tmp47_ = _tmp46_.y;
#line 328 "../src/Layout.vala"
				_tmp48_ = adjust;
#line 328 "../src/Layout.vala"
				node_set_posy (child, ((_tmp42_ + _tmp44_) + (_tmp45_ - _tmp47_)) - _tmp48_);
#line 2838 "Layout.c"
			} else {
				NodeBounds _tmp49_;
				gdouble _tmp50_;
				NodeBounds _tmp51_;
				gdouble _tmp52_;
				gdouble _tmp53_;
				NodeBounds _tmp54_;
				gdouble _tmp55_;
				gdouble _tmp56_;
#line 330 "../src/Layout.vala"
				_tmp49_ = sb;
#line 330 "../src/Layout.vala"
				_tmp50_ = _tmp49_.x;
#line 330 "../src/Layout.vala"
				_tmp51_ = sb;
#line 330 "../src/Layout.vala"
				_tmp52_ = _tmp51_.width;
#line 330 "../src/Layout.vala"
				_tmp53_ = ox;
#line 330 "../src/Layout.vala"
				_tmp54_ = cb;
#line 330 "../src/Layout.vala"
				_tmp55_ = _tmp54_.x;
#line 330 "../src/Layout.vala"
				_tmp56_ = adjust;
#line 330 "../src/Layout.vala"
				node_set_posx (child, ((_tmp50_ + _tmp52_) + (_tmp53_ - _tmp55_)) - _tmp56_);
#line 2866 "Layout.c"
			}
		} else {
			NodeBounds sb = {0};
			GArray* _tmp57_;
			GArray* _tmp58_;
			Node* _tmp59_;
			NodeSide _tmp60_;
			NodeSide _tmp61_;
			NodeBounds _tmp62_ = {0};
			NodeBounds _tmp63_;
			NodeSide _tmp64_;
			NodeSide _tmp65_;
#line 335 "../src/Layout.vala"
			_tmp57_ = node_children (parent);
#line 335 "../src/Layout.vala"
			_tmp58_ = _tmp57_;
#line 335 "../src/Layout.vala"
			_tmp59_ = g_array_index (_tmp58_, Node*, (guint) (pos + 1));
#line 335 "../src/Layout.vala"
			_tmp60_ = node_get_side (child);
#line 335 "../src/Layout.vala"
			_tmp61_ = _tmp60_;
#line 335 "../src/Layout.vala"
			layout_bbox (self, _tmp59_, (gint) _tmp61_, &_tmp62_);
#line 335 "../src/Layout.vala"
			_tmp63_ = _tmp62_;
#line 335 "../src/Layout.vala"
			_g_array_unref0 (_tmp58_);
#line 335 "../src/Layout.vala"
			sb = _tmp63_;
#line 336 "../src/Layout.vala"
			_tmp64_ = node_get_side (child);
#line 336 "../src/Layout.vala"
			_tmp65_ = _tmp64_;
#line 336 "../src/Layout.vala"
			if ((_tmp65_ & node_side_horizontal ()) != 0) {
#line 2903 "Layout.c"
				NodeBounds _tmp66_;
				gdouble _tmp67_;
				gdouble _tmp68_;
				NodeBounds _tmp69_;
				gdouble _tmp70_;
				gdouble _tmp71_;
#line 337 "../src/Layout.vala"
				_tmp66_ = sb;
#line 337 "../src/Layout.vala"
				_tmp67_ = _tmp66_.y;
#line 337 "../src/Layout.vala"
				_tmp68_ = oy;
#line 337 "../src/Layout.vala"
				_tmp69_ = cb;
#line 337 "../src/Layout.vala"
				_tmp70_ = _tmp69_.y;
#line 337 "../src/Layout.vala"
				_tmp71_ = adjust;
#line 337 "../src/Layout.vala"
				node_set_posy (child, (_tmp67_ + (_tmp68_ - _tmp70_)) - _tmp71_);
#line 2924 "Layout.c"
			} else {
				NodeBounds _tmp72_;
				gdouble _tmp73_;
				gdouble _tmp74_;
				NodeBounds _tmp75_;
				gdouble _tmp76_;
				gdouble _tmp77_;
#line 339 "../src/Layout.vala"
				_tmp72_ = sb;
#line 339 "../src/Layout.vala"
				_tmp73_ = _tmp72_.x;
#line 339 "../src/Layout.vala"
				_tmp74_ = ox;
#line 339 "../src/Layout.vala"
				_tmp75_ = cb;
#line 339 "../src/Layout.vala"
				_tmp76_ = _tmp75_.x;
#line 339 "../src/Layout.vala"
				_tmp77_ = adjust;
#line 339 "../src/Layout.vala"
				node_set_posx (child, (_tmp73_ + (_tmp74_ - _tmp76_)) - _tmp77_);
#line 2946 "Layout.c"
			}
		}
	}
#line 343 "../src/Layout.vala"
	node_get_tree_bbox (child, &_tmp78_);
#line 343 "../src/Layout.vala"
	_tmp79_ = _tmp78_;
#line 343 "../src/Layout.vala"
	_tmp80_ = adjust;
#line 343 "../src/Layout.vala"
	layout_adjust_tree_all (self, child, &_tmp79_, 0 - _tmp80_, "by_insert");
#line 2958 "Layout.c"
}


void
layout_handle_update_by_insert (Layout* self,
                                Node* parent,
                                Node* child,
                                gint pos)
{
#line 295 "../src/Layout.vala"
	g_return_if_fail (self != NULL);
#line 295 "../src/Layout.vala"
	LAYOUT_GET_CLASS (self)->handle_update_by_insert (self, parent, child, pos);
#line 2972 "Layout.c"
}


static void
layout_real_handle_update_by_delete (Layout* self,
                                     Node* parent,
                                     gint index,
                                     NodeSide side,
                                     gdouble size)
{
	gdouble adjust = 0.0;
	NodeBounds _tmp33_ = {0};
	NodeBounds _tmp34_;
#line 348 "../src/Layout.vala"
	g_return_if_fail (parent != NULL);
#line 350 "../src/Layout.vala"
	adjust = size / 2;
#line 2990 "Layout.c"
	{
		gint i = 0;
#line 353 "../src/Layout.vala"
		i = 0;
#line 2995 "Layout.c"
		{
			gboolean _tmp0_ = FALSE;
#line 353 "../src/Layout.vala"
			_tmp0_ = TRUE;
#line 353 "../src/Layout.vala"
			while (TRUE) {
#line 3002 "Layout.c"
				gint _tmp2_;
				GArray* _tmp3_;
				GArray* _tmp4_;
				guint _tmp5_;
				gboolean _tmp6_;
				Node* n = NULL;
				GArray* _tmp7_;
				GArray* _tmp8_;
				gint _tmp9_;
				Node* _tmp10_;
				Node* _tmp11_;
				Node* _tmp12_;
				Node* _tmp13_;
				NodeSide _tmp14_;
				NodeSide _tmp15_;
#line 353 "../src/Layout.vala"
				if (!_tmp0_) {
#line 3020 "Layout.c"
					gint _tmp1_;
#line 353 "../src/Layout.vala"
					_tmp1_ = i;
#line 353 "../src/Layout.vala"
					i = _tmp1_ + 1;
#line 3026 "Layout.c"
				}
#line 353 "../src/Layout.vala"
				_tmp0_ = FALSE;
#line 353 "../src/Layout.vala"
				_tmp2_ = i;
#line 353 "../src/Layout.vala"
				_tmp3_ = node_children (parent);
#line 353 "../src/Layout.vala"
				_tmp4_ = _tmp3_;
#line 353 "../src/Layout.vala"
				_tmp5_ = _tmp4_->len;
#line 353 "../src/Layout.vala"
				_tmp6_ = !(((guint) _tmp2_) < _tmp5_);
#line 353 "../src/Layout.vala"
				_g_array_unref0 (_tmp4_);
#line 353 "../src/Layout.vala"
				if (_tmp6_) {
#line 353 "../src/Layout.vala"
					break;
#line 3046 "Layout.c"
				}
#line 354 "../src/Layout.vala"
				_tmp7_ = node_children (parent);
#line 354 "../src/Layout.vala"
				_tmp8_ = _tmp7_;
#line 354 "../src/Layout.vala"
				_tmp9_ = i;
#line 354 "../src/Layout.vala"
				_tmp10_ = g_array_index (_tmp8_, Node*, (guint) _tmp9_);
#line 354 "../src/Layout.vala"
				_tmp11_ = _g_object_ref0 (_tmp10_);
#line 354 "../src/Layout.vala"
				_tmp12_ = _tmp11_;
#line 354 "../src/Layout.vala"
				_g_array_unref0 (_tmp8_);
#line 354 "../src/Layout.vala"
				n = _tmp12_;
#line 355 "../src/Layout.vala"
				_tmp13_ = n;
#line 355 "../src/Layout.vala"
				_tmp14_ = node_get_side (_tmp13_);
#line 355 "../src/Layout.vala"
				_tmp15_ = _tmp14_;
#line 355 "../src/Layout.vala"
				if (_tmp15_ == side) {
#line 3072 "Layout.c"
					gdouble _tmp16_ = 0.0;
					gint _tmp17_;
					gdouble current_adjust = 0.0;
					Node* _tmp20_;
					NodeSide _tmp21_;
					NodeSide _tmp22_;
#line 356 "../src/Layout.vala"
					_tmp17_ = i;
#line 356 "../src/Layout.vala"
					if (_tmp17_ >= index) {
#line 3083 "Layout.c"
						gdouble _tmp18_;
#line 356 "../src/Layout.vala"
						_tmp18_ = adjust;
#line 356 "../src/Layout.vala"
						_tmp16_ = 0 - _tmp18_;
#line 3089 "Layout.c"
					} else {
						gdouble _tmp19_;
#line 356 "../src/Layout.vala"
						_tmp19_ = adjust;
#line 356 "../src/Layout.vala"
						_tmp16_ = _tmp19_;
#line 3096 "Layout.c"
					}
#line 356 "../src/Layout.vala"
					current_adjust = _tmp16_;
#line 357 "../src/Layout.vala"
					_tmp20_ = n;
#line 357 "../src/Layout.vala"
					_tmp21_ = node_get_side (_tmp20_);
#line 357 "../src/Layout.vala"
					_tmp22_ = _tmp21_;
#line 357 "../src/Layout.vala"
					if ((_tmp22_ & node_side_horizontal ()) != 0) {
#line 3108 "Layout.c"
						Node* _tmp23_;
						Node* _tmp24_;
						gdouble _tmp25_;
						gdouble _tmp26_;
						gdouble _tmp27_;
#line 358 "../src/Layout.vala"
						_tmp23_ = n;
#line 358 "../src/Layout.vala"
						_tmp24_ = n;
#line 358 "../src/Layout.vala"
						_tmp25_ = node_get_posy (_tmp24_);
#line 358 "../src/Layout.vala"
						_tmp26_ = _tmp25_;
#line 358 "../src/Layout.vala"
						_tmp27_ = current_adjust;
#line 358 "../src/Layout.vala"
						node_set_posy (_tmp24_, _tmp26_ + _tmp27_);
#line 3126 "Layout.c"
					} else {
						Node* _tmp28_;
						Node* _tmp29_;
						gdouble _tmp30_;
						gdouble _tmp31_;
						gdouble _tmp32_;
#line 360 "../src/Layout.vala"
						_tmp28_ = n;
#line 360 "../src/Layout.vala"
						_tmp29_ = n;
#line 360 "../src/Layout.vala"
						_tmp30_ = node_get_posx (_tmp29_);
#line 360 "../src/Layout.vala"
						_tmp31_ = _tmp30_;
#line 360 "../src/Layout.vala"
						_tmp32_ = current_adjust;
#line 360 "../src/Layout.vala"
						node_set_posx (_tmp29_, _tmp31_ + _tmp32_);
#line 3145 "Layout.c"
					}
				}
#line 353 "../src/Layout.vala"
				_g_object_unref0 (n);
#line 3150 "Layout.c"
			}
		}
	}
#line 366 "../src/Layout.vala"
	node_get_tree_bbox (parent, &_tmp33_);
#line 366 "../src/Layout.vala"
	_tmp34_ = _tmp33_;
#line 366 "../src/Layout.vala"
	layout_adjust_tree_all (self, parent, &_tmp34_, 0 - (layout_get_adjust (self, parent) / 2), "by_delete");
#line 3160 "Layout.c"
}


void
layout_handle_update_by_delete (Layout* self,
                                Node* parent,
                                gint index,
                                NodeSide side,
                                gdouble size)
{
#line 348 "../src/Layout.vala"
	g_return_if_fail (self != NULL);
#line 348 "../src/Layout.vala"
	LAYOUT_GET_CLASS (self)->handle_update_by_delete (self, parent, index, side, size);
#line 3175 "Layout.c"
}


static void
layout_real_position_root (Layout* self,
                           Node* last,
                           Node* n)
{
	NodeBounds nb = {0};
	NodeBounds _tmp0_ = {0};
	NodeBounds _tmp1_;
	gdouble _tmp2_;
	gdouble _tmp3_;
	NodeBounds _tmp4_;
	gdouble _tmp5_;
	NodeBounds _tmp6_;
	gdouble _tmp7_;
	gdouble _tmp8_;
#line 371 "../src/Layout.vala"
	g_return_if_fail (last != NULL);
#line 371 "../src/Layout.vala"
	g_return_if_fail (n != NULL);
#line 372 "../src/Layout.vala"
	node_get_tree_bbox (last, &_tmp0_);
#line 372 "../src/Layout.vala"
	_tmp1_ = _tmp0_;
#line 372 "../src/Layout.vala"
	nb = _tmp1_;
#line 373 "../src/Layout.vala"
	_tmp2_ = node_get_posx (last);
#line 373 "../src/Layout.vala"
	_tmp3_ = _tmp2_;
#line 373 "../src/Layout.vala"
	node_set_posx (n, _tmp3_);
#line 374 "../src/Layout.vala"
	_tmp4_ = nb;
#line 374 "../src/Layout.vala"
	_tmp5_ = _tmp4_.y;
#line 374 "../src/Layout.vala"
	_tmp6_ = nb;
#line 374 "../src/Layout.vala"
	_tmp7_ = _tmp6_.height;
#line 374 "../src/Layout.vala"
	_tmp8_ = self->_rt_gap;
#line 374 "../src/Layout.vala"
	node_set_posy (n, (_tmp5_ + _tmp7_) + _tmp8_);
#line 3222 "Layout.c"
}


void
layout_position_root (Layout* self,
                      Node* last,
                      Node* n)
{
#line 371 "../src/Layout.vala"
	g_return_if_fail (self != NULL);
#line 371 "../src/Layout.vala"
	LAYOUT_GET_CLASS (self)->position_root (self, last, n);
#line 3235 "Layout.c"
}


const gchar*
layout_get_name (Layout* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 27 "../src/Layout.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 27 "../src/Layout.vala"
	_tmp0_ = self->priv->_name;
#line 27 "../src/Layout.vala"
	result = _tmp0_;
#line 27 "../src/Layout.vala"
	return result;
#line 3252 "Layout.c"
}


void
layout_set_name (Layout* self,
                 const gchar* value)
{
#line 27 "../src/Layout.vala"
	g_return_if_fail (self != NULL);
#line 27 "../src/Layout.vala"
	if (g_strcmp0 (value, layout_get_name (self)) != 0) {
#line 3264 "Layout.c"
		gchar* _tmp0_;
#line 27 "../src/Layout.vala"
		_tmp0_ = g_strdup (value);
#line 27 "../src/Layout.vala"
		_g_free0 (self->priv->_name);
#line 27 "../src/Layout.vala"
		self->priv->_name = _tmp0_;
#line 27 "../src/Layout.vala"
		g_object_notify_by_pspec ((GObject *) self, layout_properties[LAYOUT_NAME_PROPERTY]);
#line 3274 "Layout.c"
	}
}


const gchar*
layout_get_icon (Layout* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 28 "../src/Layout.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 28 "../src/Layout.vala"
	_tmp0_ = self->priv->_icon;
#line 28 "../src/Layout.vala"
	result = _tmp0_;
#line 28 "../src/Layout.vala"
	return result;
#line 3292 "Layout.c"
}


void
layout_set_icon (Layout* self,
                 const gchar* value)
{
#line 28 "../src/Layout.vala"
	g_return_if_fail (self != NULL);
#line 28 "../src/Layout.vala"
	if (g_strcmp0 (value, layout_get_icon (self)) != 0) {
#line 3304 "Layout.c"
		gchar* _tmp0_;
#line 28 "../src/Layout.vala"
		_tmp0_ = g_strdup (value);
#line 28 "../src/Layout.vala"
		_g_free0 (self->priv->_icon);
#line 28 "../src/Layout.vala"
		self->priv->_icon = _tmp0_;
#line 28 "../src/Layout.vala"
		g_object_notify_by_pspec ((GObject *) self, layout_properties[LAYOUT_ICON_PROPERTY]);
#line 3314 "Layout.c"
	}
}


gboolean
layout_get_balanceable (Layout* self)
{
	gboolean result;
	gboolean _tmp0_;
#line 29 "../src/Layout.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 29 "../src/Layout.vala"
	_tmp0_ = self->priv->_balanceable;
#line 29 "../src/Layout.vala"
	result = _tmp0_;
#line 29 "../src/Layout.vala"
	return result;
#line 3332 "Layout.c"
}


void
layout_set_balanceable (Layout* self,
                        gboolean value)
{
#line 29 "../src/Layout.vala"
	g_return_if_fail (self != NULL);
#line 29 "../src/Layout.vala"
	if (layout_get_balanceable (self) != value) {
#line 29 "../src/Layout.vala"
		self->priv->_balanceable = value;
#line 29 "../src/Layout.vala"
		g_object_notify_by_pspec ((GObject *) self, layout_properties[LAYOUT_BALANCEABLE_PROPERTY]);
#line 3348 "Layout.c"
	}
}


static void
layout_class_init (LayoutClass * klass)
{
#line 22 "../src/Layout.vala"
	layout_parent_class = g_type_class_peek_parent (klass);
#line 22 "../src/Layout.vala"
	g_type_class_adjust_private_offset (klass, &Layout_private_offset);
#line 22 "../src/Layout.vala"
	((LayoutClass *) klass)->side_mapping = (NodeSide (*) (Layout*, NodeSide)) layout_real_side_mapping;
#line 22 "../src/Layout.vala"
	((LayoutClass *) klass)->initialize = (void (*) (Layout*, Node*)) layout_real_initialize;
#line 22 "../src/Layout.vala"
	((LayoutClass *) klass)->bbox = (void (*) (Layout*, Node*, gint, NodeBounds*)) layout_real_bbox;
#line 22 "../src/Layout.vala"
	((LayoutClass *) klass)->adjust_tree = (void (*) (Layout*, Node*, gint, gint, gdouble)) layout_real_adjust_tree;
#line 22 "../src/Layout.vala"
	((LayoutClass *) klass)->adjust_tree_all = (void (*) (Layout*, Node*, NodeBounds*, gdouble, const gchar*)) layout_real_adjust_tree_all;
#line 22 "../src/Layout.vala"
	((LayoutClass *) klass)->propagate_side = (void (*) (Layout*, Node*, NodeSide)) layout_real_propagate_side;
#line 22 "../src/Layout.vala"
	((LayoutClass *) klass)->get_side = (NodeSide (*) (Layout*, Node*)) layout_real_get_side;
#line 22 "../src/Layout.vala"
	((LayoutClass *) klass)->set_side = (void (*) (Layout*, Node*)) layout_real_set_side;
#line 22 "../src/Layout.vala"
	((LayoutClass *) klass)->handle_update_by_edit = (void (*) (Layout*, Node*, gdouble, gdouble)) layout_real_handle_update_by_edit;
#line 22 "../src/Layout.vala"
	((LayoutClass *) klass)->handle_update_by_fold = (void (*) (Layout*, Node*)) layout_real_handle_update_by_fold;
#line 22 "../src/Layout.vala"
	((LayoutClass *) klass)->get_insert_adjust = (gdouble (*) (Layout*, Node*)) layout_real_get_insert_adjust;
#line 22 "../src/Layout.vala"
	((LayoutClass *) klass)->handle_update_by_insert = (void (*) (Layout*, Node*, Node*, gint)) layout_real_handle_update_by_insert;
#line 22 "../src/Layout.vala"
	((LayoutClass *) klass)->handle_update_by_delete = (void (*) (Layout*, Node*, gint, NodeSide, gdouble)) layout_real_handle_update_by_delete;
#line 22 "../src/Layout.vala"
	((LayoutClass *) klass)->position_root = (void (*) (Layout*, Node*, Node*)) layout_real_position_root;
#line 22 "../src/Layout.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_layout_get_property;
#line 22 "../src/Layout.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_layout_set_property;
#line 22 "../src/Layout.vala"
	G_OBJECT_CLASS (klass)->finalize = layout_finalize;
#line 22 "../src/Layout.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LAYOUT_NAME_PROPERTY, layout_properties[LAYOUT_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../src/Layout.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LAYOUT_ICON_PROPERTY, layout_properties[LAYOUT_ICON_PROPERTY] = g_param_spec_string ("icon", "icon", "icon", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 22 "../src/Layout.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), LAYOUT_BALANCEABLE_PROPERTY, layout_properties[LAYOUT_BALANCEABLE_PROPERTY] = g_param_spec_boolean ("balanceable", "balanceable", "balanceable", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 3400 "Layout.c"
}


static void
layout_instance_init (Layout * self)
{
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 22 "../src/Layout.vala"
	self->priv = layout_get_instance_private (self);
#line 24 "../src/Layout.vala"
	self->_pc_gap = (gdouble) 100;
#line 25 "../src/Layout.vala"
	self->_rt_gap = (gdouble) 100;
#line 27 "../src/Layout.vala"
	_tmp0_ = g_strdup ("");
#line 27 "../src/Layout.vala"
	self->priv->_name = _tmp0_;
#line 28 "../src/Layout.vala"
	_tmp1_ = g_strdup ("");
#line 28 "../src/Layout.vala"
	self->priv->_icon = _tmp1_;
#line 29 "../src/Layout.vala"
	self->priv->_balanceable = FALSE;
#line 3425 "Layout.c"
}


static void
layout_finalize (GObject * obj)
{
	Layout * self;
#line 22 "../src/Layout.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_LAYOUT, Layout);
#line 27 "../src/Layout.vala"
	_g_free0 (self->priv->_name);
#line 28 "../src/Layout.vala"
	_g_free0 (self->priv->_icon);
#line 22 "../src/Layout.vala"
	G_OBJECT_CLASS (layout_parent_class)->finalize (obj);
#line 3441 "Layout.c"
}


GType
layout_get_type (void)
{
	static volatile gsize layout_type_id__volatile = 0;
	if (g_once_init_enter (&layout_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (LayoutClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) layout_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Layout), 0, (GInstanceInitFunc) layout_instance_init, NULL };
		GType layout_type_id;
		layout_type_id = g_type_register_static (G_TYPE_OBJECT, "Layout", &g_define_type_info, 0);
		Layout_private_offset = g_type_add_instance_private (layout_type_id, sizeof (LayoutPrivate));
		g_once_init_leave (&layout_type_id__volatile, layout_type_id);
	}
	return layout_type_id__volatile;
}


static void
_vala_layout_get_property (GObject * object,
                           guint property_id,
                           GValue * value,
                           GParamSpec * pspec)
{
	Layout * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_LAYOUT, Layout);
#line 22 "../src/Layout.vala"
	switch (property_id) {
#line 22 "../src/Layout.vala"
		case LAYOUT_NAME_PROPERTY:
#line 22 "../src/Layout.vala"
		g_value_set_string (value, layout_get_name (self));
#line 22 "../src/Layout.vala"
		break;
#line 22 "../src/Layout.vala"
		case LAYOUT_ICON_PROPERTY:
#line 22 "../src/Layout.vala"
		g_value_set_string (value, layout_get_icon (self));
#line 22 "../src/Layout.vala"
		break;
#line 22 "../src/Layout.vala"
		case LAYOUT_BALANCEABLE_PROPERTY:
#line 22 "../src/Layout.vala"
		g_value_set_boolean (value, layout_get_balanceable (self));
#line 22 "../src/Layout.vala"
		break;
#line 3488 "Layout.c"
		default:
#line 22 "../src/Layout.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../src/Layout.vala"
		break;
#line 3494 "Layout.c"
	}
}


static void
_vala_layout_set_property (GObject * object,
                           guint property_id,
                           const GValue * value,
                           GParamSpec * pspec)
{
	Layout * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_LAYOUT, Layout);
#line 22 "../src/Layout.vala"
	switch (property_id) {
#line 22 "../src/Layout.vala"
		case LAYOUT_NAME_PROPERTY:
#line 22 "../src/Layout.vala"
		layout_set_name (self, g_value_get_string (value));
#line 22 "../src/Layout.vala"
		break;
#line 22 "../src/Layout.vala"
		case LAYOUT_ICON_PROPERTY:
#line 22 "../src/Layout.vala"
		layout_set_icon (self, g_value_get_string (value));
#line 22 "../src/Layout.vala"
		break;
#line 22 "../src/Layout.vala"
		case LAYOUT_BALANCEABLE_PROPERTY:
#line 22 "../src/Layout.vala"
		layout_set_balanceable (self, g_value_get_boolean (value));
#line 22 "../src/Layout.vala"
		break;
#line 3527 "Layout.c"
		default:
#line 22 "../src/Layout.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 22 "../src/Layout.vala"
		break;
#line 3533 "Layout.c"
	}
}



