/* LinkType.c generated by valac 0.42.7, the Vala compiler
 * generated from LinkType.vala, do not modify */

/*
* Copyright (c) 2018 (https://github.com/phase1geo/Minder)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Trevor Williams <phase1geo@gmail.com>
*/


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <cairo.h>
#include <float.h>
#include <math.h>


#define TYPE_LINK_TYPE (link_type_get_type ())
#define LINK_TYPE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LINK_TYPE, LinkType))
#define IS_LINK_TYPE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LINK_TYPE))
#define LINK_TYPE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_LINK_TYPE, LinkTypeIface))

typedef struct _LinkType LinkType;
typedef struct _LinkTypeIface LinkTypeIface;

#define TYPE_NODE (node_get_type ())
#define NODE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NODE, Node))
#define NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NODE, NodeClass))
#define IS_NODE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NODE))
#define IS_NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NODE))
#define NODE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NODE, NodeClass))

typedef struct _Node Node;
typedef struct _NodeClass NodeClass;

#define TYPE_STYLE (style_get_type ())
#define STYLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_STYLE, Style))
#define STYLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_STYLE, StyleClass))
#define IS_STYLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_STYLE))
#define IS_STYLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_STYLE))
#define STYLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_STYLE, StyleClass))

typedef struct _Style Style;
typedef struct _StyleClass StyleClass;

struct _LinkTypeIface {
	GTypeInterface parent_iface;
	gchar* (*name) (LinkType* self);
	gchar* (*display_name) (LinkType* self);
	gchar* (*icon_name) (LinkType* self);
	void (*draw) (LinkType* self, cairo_t* ctx, Node* to_node, gdouble from_x, gdouble from_y, gdouble to_x, gdouble to_y, gdouble* fx, gdouble* fy, gdouble* tx, gdouble* ty);
};



GType node_get_type (void) G_GNUC_CONST;
GType link_type_get_type (void) G_GNUC_CONST;
gchar* link_type_name (LinkType* self);
gchar* link_type_display_name (LinkType* self);
gchar* link_type_icon_name (LinkType* self);
gpointer style_ref (gpointer instance);
void style_unref (gpointer instance);
GParamSpec* param_spec_style (const gchar* name,
                              const gchar* nick,
                              const gchar* blurb,
                              GType object_type,
                              GParamFlags flags);
void value_set_style (GValue* value,
                      gpointer v_object);
void value_take_style (GValue* value,
                       gpointer v_object);
gpointer value_get_style (const GValue* value);
GType style_get_type (void) G_GNUC_CONST;
gdouble link_type_adjust_a (LinkType* self,
                            Style* style);
gboolean* style_get_link_arrow (Style* self);
gint* style_get_link_width (Style* self);
gint* style_get_node_borderwidth (Style* self);
gdouble link_type_adjust_tip (LinkType* self,
                              Style* style);
void link_type_draw (LinkType* self,
                     cairo_t* ctx,
                     Node* to_node,
                     gdouble from_x,
                     gdouble from_y,
                     gdouble to_x,
                     gdouble to_y,
                     gdouble* fx,
                     gdouble* fy,
                     gdouble* tx,
                     gdouble* ty);


gchar*
link_type_name (LinkType* self)
{
#line 25 "../src/LinkType.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 25 "../src/LinkType.vala"
	return LINK_TYPE_GET_INTERFACE (self)->name (self);
#line 119 "LinkType.c"
}


gchar*
link_type_display_name (LinkType* self)
{
#line 28 "../src/LinkType.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 28 "../src/LinkType.vala"
	return LINK_TYPE_GET_INTERFACE (self)->display_name (self);
#line 130 "LinkType.c"
}


gchar*
link_type_icon_name (LinkType* self)
{
#line 31 "../src/LinkType.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 31 "../src/LinkType.vala"
	return LINK_TYPE_GET_INTERFACE (self)->icon_name (self);
#line 141 "LinkType.c"
}


gdouble
link_type_adjust_a (LinkType* self,
                    Style* style)
{
	gdouble result = 0.0;
	gint _tmp0_ = 0;
	gboolean* _tmp1_;
	gboolean* _tmp2_;
#line 33 "../src/LinkType.vala"
	g_return_val_if_fail (style != NULL, 0.0);
#line 34 "../src/LinkType.vala"
	_tmp1_ = style_get_link_arrow (style);
#line 34 "../src/LinkType.vala"
	_tmp2_ = _tmp1_;
#line 34 "../src/LinkType.vala"
	if (*_tmp2_) {
#line 161 "LinkType.c"
		gint* _tmp3_;
		gint* _tmp4_;
		gint* _tmp5_;
		gint* _tmp6_;
#line 34 "../src/LinkType.vala"
		_tmp3_ = style_get_link_width (style);
#line 34 "../src/LinkType.vala"
		_tmp4_ = _tmp3_;
#line 34 "../src/LinkType.vala"
		_tmp5_ = style_get_node_borderwidth (style);
#line 34 "../src/LinkType.vala"
		_tmp6_ = _tmp5_;
#line 34 "../src/LinkType.vala"
		_tmp0_ = ((*_tmp4_) / 2) + (((*_tmp6_) / 2) + 2);
#line 176 "LinkType.c"
	} else {
#line 34 "../src/LinkType.vala"
		_tmp0_ = 0;
#line 180 "LinkType.c"
	}
#line 34 "../src/LinkType.vala"
	result = (gdouble) _tmp0_;
#line 34 "../src/LinkType.vala"
	return result;
#line 186 "LinkType.c"
}


gdouble
link_type_adjust_tip (LinkType* self,
                      Style* style)
{
	gdouble result = 0.0;
	gint* _tmp0_;
	gint* _tmp1_;
#line 37 "../src/LinkType.vala"
	g_return_val_if_fail (style != NULL, 0.0);
#line 38 "../src/LinkType.vala"
	_tmp0_ = style_get_link_width (style);
#line 38 "../src/LinkType.vala"
	_tmp1_ = _tmp0_;
#line 38 "../src/LinkType.vala"
	result = (gdouble) (((*_tmp1_) / 2) + 1);
#line 38 "../src/LinkType.vala"
	return result;
#line 207 "LinkType.c"
}


void
link_type_draw (LinkType* self,
                cairo_t* ctx,
                Node* to_node,
                gdouble from_x,
                gdouble from_y,
                gdouble to_x,
                gdouble to_y,
                gdouble* fx,
                gdouble* fy,
                gdouble* tx,
                gdouble* ty)
{
#line 42 "../src/LinkType.vala"
	g_return_if_fail (self != NULL);
#line 42 "../src/LinkType.vala"
	LINK_TYPE_GET_INTERFACE (self)->draw (self, ctx, to_node, from_x, from_y, to_x, to_y, fx, fy, tx, ty);
#line 228 "LinkType.c"
}


static void
link_type_default_init (LinkTypeIface * iface)
{
}


GType
link_type_get_type (void)
{
	static volatile gsize link_type_type_id__volatile = 0;
	if (g_once_init_enter (&link_type_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (LinkTypeIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) link_type_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType link_type_type_id;
		link_type_type_id = g_type_register_static (G_TYPE_INTERFACE, "LinkType", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (link_type_type_id, G_TYPE_OBJECT);
		g_once_init_leave (&link_type_type_id__volatile, link_type_type_id);
	}
	return link_type_type_id__volatile;
}



