/* NodeImage.c generated by valac 0.42.7, the Vala compiler
 * generated from NodeImage.vala, do not modify */

/*
* Copyright (c) 2018 (https://github.com/phase1geo/Minder)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Trevor Williams <phase1geo@gmail.com>
*/


#include <glib.h>
#include <glib-object.h>
#include <libxml/tree.h>
#include <cairo.h>
#include <gdk-pixbuf/gdk-pixbuf.h>
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>
#include <float.h>
#include <math.h>
#include <gtk/gtk.h>
#include <gobject/gvaluecollector.h>


#define TYPE_NODE_IMAGE (node_image_get_type ())
#define NODE_IMAGE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NODE_IMAGE, NodeImage))
#define NODE_IMAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NODE_IMAGE, NodeImageClass))
#define IS_NODE_IMAGE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NODE_IMAGE))
#define IS_NODE_IMAGE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NODE_IMAGE))
#define NODE_IMAGE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NODE_IMAGE, NodeImageClass))

typedef struct _NodeImage NodeImage;
typedef struct _NodeImageClass NodeImageClass;
typedef struct _NodeImagePrivate NodeImagePrivate;
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_IMAGE_MANAGER (image_manager_get_type ())
#define IMAGE_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_IMAGE_MANAGER, ImageManager))
#define IMAGE_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_IMAGE_MANAGER, ImageManagerClass))
#define IS_IMAGE_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_IMAGE_MANAGER))
#define IS_IMAGE_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_IMAGE_MANAGER))
#define IMAGE_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_IMAGE_MANAGER, ImageManagerClass))

typedef struct _ImageManager ImageManager;
typedef struct _ImageManagerClass ImageManagerClass;
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _ParamSpecNodeImage ParamSpecNodeImage;

struct _NodeImage {
	GTypeInstance parent_instance;
	volatile int ref_count;
	NodeImagePrivate * priv;
};

struct _NodeImageClass {
	GTypeClass parent_class;
	void (*finalize) (NodeImage *self);
	void (*save) (NodeImage* self, xmlNode* parent);
};

struct _NodeImagePrivate {
	cairo_surface_t* _surface;
	GdkPixbuf* _buf;
	gint _id;
	gboolean _valid;
	gint _crop_x;
	gint _crop_y;
	gint _crop_w;
	gint _crop_h;
};

struct _ParamSpecNodeImage {
	GParamSpec parent_instance;
};


static gint NodeImage_private_offset;
static gpointer node_image_parent_class = NULL;

gpointer node_image_ref (gpointer instance);
void node_image_unref (gpointer instance);
GParamSpec* param_spec_node_image (const gchar* name,
                                   const gchar* nick,
                                   const gchar* blurb,
                                   GType object_type,
                                   GParamFlags flags);
void value_set_node_image (GValue* value,
                           gpointer v_object);
void value_take_node_image (GValue* value,
                            gpointer v_object);
gpointer value_get_node_image (const GValue* value);
GType node_image_get_type (void) G_GNUC_CONST;
#define NODE_IMAGE_EDIT_WIDTH 600
#define NODE_IMAGE_EDIT_HEIGHT 600
gpointer image_manager_ref (gpointer instance);
void image_manager_unref (gpointer instance);
GParamSpec* param_spec_image_manager (const gchar* name,
                                      const gchar* nick,
                                      const gchar* blurb,
                                      GType object_type,
                                      GParamFlags flags);
void value_set_image_manager (GValue* value,
                              gpointer v_object);
void value_take_image_manager (GValue* value,
                               gpointer v_object);
gpointer value_get_image_manager (const GValue* value);
GType image_manager_get_type (void) G_GNUC_CONST;
NodeImage* node_image_new (ImageManager* im,
                           gint id,
                           gint width);
NodeImage* node_image_construct (GType object_type,
                                 ImageManager* im,
                                 gint id,
                                 gint width);
static gboolean node_image_load (NodeImage* self,
                          ImageManager* im,
                          gint id,
                          gboolean init);
void node_image_set_width (NodeImage* self,
                           gint width);
NodeImage* node_image_new_from_uri (ImageManager* im,
                                    const gchar* uri,
                                    gint width);
NodeImage* node_image_construct_from_uri (GType object_type,
                                          ImageManager* im,
                                          const gchar* uri,
                                          gint width);
gint image_manager_add_image (ImageManager* self,
                              const gchar* uri);
void image_manager_set_valid (ImageManager* self,
                              gint id,
                              gboolean value);
NodeImage* node_image_new_from_node_image (ImageManager* im,
                                           NodeImage* ni,
                                           gint width);
NodeImage* node_image_construct_from_node_image (GType object_type,
                                                 ImageManager* im,
                                                 NodeImage* ni,
                                                 gint width);
gchar* image_manager_get_uri (ImageManager* self,
                              gint id);
gint node_image_get_id (NodeImage* self);
gint node_image_get_crop_x (NodeImage* self);
void node_image_set_crop_x (NodeImage* self,
                            gint value);
gint node_image_get_crop_y (NodeImage* self);
void node_image_set_crop_y (NodeImage* self,
                            gint value);
gint node_image_get_crop_w (NodeImage* self);
void node_image_set_crop_w (NodeImage* self,
                            gint value);
gint node_image_get_crop_h (NodeImage* self);
void node_image_set_crop_h (NodeImage* self,
                            gint value);
NodeImage* node_image_new_from_xml (ImageManager* im,
                                    xmlNode* n,
                                    gint width);
NodeImage* node_image_construct_from_xml (GType object_type,
                                          ImageManager* im,
                                          xmlNode* n,
                                          gint width);
void node_image_set_id (NodeImage* self,
                        gint value);
static void node_image_set_valid (NodeImage* self,
                           gboolean value);
gchar* image_manager_get_file (ImageManager* self,
                               gint id);
gboolean node_image_get_valid (NodeImage* self);
cairo_surface_t* node_image_get_surface (NodeImage* self);
GdkPixbuf* node_image_get_pixbuf (NodeImage* self);
void node_image_draw (NodeImage* self,
                      cairo_t* ctx,
                      gdouble x,
                      gdouble y,
                      gdouble opacity);
void node_image_set_image (NodeImage* self,
                           GtkImage* img);
void node_image_save (NodeImage* self,
                      xmlNode* parent);
static void node_image_real_save (NodeImage* self,
                           xmlNode* parent);
gint node_image_get_width (NodeImage* self);
gint node_image_get_height (NodeImage* self);
static void node_image_finalize (NodeImage * obj);


static inline gpointer
node_image_get_instance_private (NodeImage* self)
{
	return G_STRUCT_MEMBER_P (self, NodeImage_private_offset);
}


NodeImage*
node_image_construct (GType object_type,
                      ImageManager* im,
                      gint id,
                      gint width)
{
	NodeImage* self = NULL;
#line 53 "../src/NodeImage.vala"
	g_return_val_if_fail (im != NULL, NULL);
#line 53 "../src/NodeImage.vala"
	self = (NodeImage*) g_type_create_instance (object_type);
#line 54 "../src/NodeImage.vala"
	if (node_image_load (self, im, id, TRUE)) {
#line 55 "../src/NodeImage.vala"
		node_image_set_width (self, width);
#line 227 "NodeImage.c"
	}
#line 53 "../src/NodeImage.vala"
	return self;
#line 231 "NodeImage.c"
}


NodeImage*
node_image_new (ImageManager* im,
                gint id,
                gint width)
{
#line 53 "../src/NodeImage.vala"
	return node_image_construct (TYPE_NODE_IMAGE, im, id, width);
#line 242 "NodeImage.c"
}


NodeImage*
node_image_construct_from_uri (GType object_type,
                               ImageManager* im,
                               const gchar* uri,
                               gint width)
{
	NodeImage* self = NULL;
	gint id = 0;
	gint _tmp0_;
#line 60 "../src/NodeImage.vala"
	g_return_val_if_fail (im != NULL, NULL);
#line 60 "../src/NodeImage.vala"
	g_return_val_if_fail (uri != NULL, NULL);
#line 60 "../src/NodeImage.vala"
	self = (NodeImage*) g_type_create_instance (object_type);
#line 61 "../src/NodeImage.vala"
	id = image_manager_add_image (im, uri);
#line 62 "../src/NodeImage.vala"
	_tmp0_ = id;
#line 62 "../src/NodeImage.vala"
	if (_tmp0_ != -1) {
#line 267 "NodeImage.c"
		gint _tmp1_;
#line 63 "../src/NodeImage.vala"
		_tmp1_ = id;
#line 63 "../src/NodeImage.vala"
		if (node_image_load (self, im, _tmp1_, TRUE)) {
#line 64 "../src/NodeImage.vala"
			node_image_set_width (self, width);
#line 275 "NodeImage.c"
		} else {
			gint _tmp2_;
#line 66 "../src/NodeImage.vala"
			_tmp2_ = id;
#line 66 "../src/NodeImage.vala"
			image_manager_set_valid (im, _tmp2_, FALSE);
#line 282 "NodeImage.c"
		}
	}
#line 60 "../src/NodeImage.vala"
	return self;
#line 287 "NodeImage.c"
}


NodeImage*
node_image_new_from_uri (ImageManager* im,
                         const gchar* uri,
                         gint width)
{
#line 60 "../src/NodeImage.vala"
	return node_image_construct_from_uri (TYPE_NODE_IMAGE, im, uri, width);
#line 298 "NodeImage.c"
}


NodeImage*
node_image_construct_from_node_image (GType object_type,
                                      ImageManager* im,
                                      NodeImage* ni,
                                      gint width)
{
	NodeImage* self = NULL;
	gchar* uri = NULL;
	gint _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
#line 72 "../src/NodeImage.vala"
	g_return_val_if_fail (im != NULL, NULL);
#line 72 "../src/NodeImage.vala"
	g_return_val_if_fail (ni != NULL, NULL);
#line 72 "../src/NodeImage.vala"
	self = (NodeImage*) g_type_create_instance (object_type);
#line 73 "../src/NodeImage.vala"
	_tmp0_ = ni->priv->_id;
#line 73 "../src/NodeImage.vala"
	_tmp1_ = image_manager_get_uri (im, _tmp0_);
#line 73 "../src/NodeImage.vala"
	uri = _tmp1_;
#line 74 "../src/NodeImage.vala"
	_tmp2_ = uri;
#line 74 "../src/NodeImage.vala"
	if (g_strcmp0 (_tmp2_, "") != 0) {
#line 329 "NodeImage.c"
		gint id = 0;
		const gchar* _tmp3_;
		gint _tmp4_;
#line 75 "../src/NodeImage.vala"
		_tmp3_ = uri;
#line 75 "../src/NodeImage.vala"
		id = image_manager_add_image (im, _tmp3_);
#line 76 "../src/NodeImage.vala"
		_tmp4_ = id;
#line 76 "../src/NodeImage.vala"
		if (_tmp4_ != -1) {
#line 341 "NodeImage.c"
			gint _tmp5_;
			gint _tmp6_;
			gint _tmp7_;
			gint _tmp8_;
			gint _tmp9_;
#line 77 "../src/NodeImage.vala"
			_tmp5_ = ni->priv->_crop_x;
#line 77 "../src/NodeImage.vala"
			node_image_set_crop_x (self, _tmp5_);
#line 78 "../src/NodeImage.vala"
			_tmp6_ = ni->priv->_crop_y;
#line 78 "../src/NodeImage.vala"
			node_image_set_crop_y (self, _tmp6_);
#line 79 "../src/NodeImage.vala"
			_tmp7_ = ni->priv->_crop_w;
#line 79 "../src/NodeImage.vala"
			node_image_set_crop_w (self, _tmp7_);
#line 80 "../src/NodeImage.vala"
			_tmp8_ = ni->priv->_crop_h;
#line 80 "../src/NodeImage.vala"
			node_image_set_crop_h (self, _tmp8_);
#line 81 "../src/NodeImage.vala"
			_tmp9_ = id;
#line 81 "../src/NodeImage.vala"
			if (node_image_load (self, im, _tmp9_, FALSE)) {
#line 82 "../src/NodeImage.vala"
				node_image_set_width (self, width);
#line 369 "NodeImage.c"
			} else {
				gint _tmp10_;
#line 84 "../src/NodeImage.vala"
				_tmp10_ = id;
#line 84 "../src/NodeImage.vala"
				image_manager_set_valid (im, _tmp10_, FALSE);
#line 376 "NodeImage.c"
			}
		}
	}
#line 72 "../src/NodeImage.vala"
	_g_free0 (uri);
#line 72 "../src/NodeImage.vala"
	return self;
#line 384 "NodeImage.c"
}


NodeImage*
node_image_new_from_node_image (ImageManager* im,
                                NodeImage* ni,
                                gint width)
{
#line 72 "../src/NodeImage.vala"
	return node_image_construct_from_node_image (TYPE_NODE_IMAGE, im, ni, width);
#line 395 "NodeImage.c"
}


NodeImage*
node_image_construct_from_xml (GType object_type,
                               ImageManager* im,
                               xmlNode* n,
                               gint width)
{
	NodeImage* self = NULL;
	gchar* i = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* x = NULL;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* y = NULL;
	gchar* _tmp6_;
	const gchar* _tmp7_;
	gchar* w = NULL;
	gchar* _tmp9_;
	const gchar* _tmp10_;
	gchar* h = NULL;
	gchar* _tmp12_;
	const gchar* _tmp13_;
	gint _tmp15_;
#line 91 "../src/NodeImage.vala"
	g_return_val_if_fail (im != NULL, NULL);
#line 91 "../src/NodeImage.vala"
	self = (NodeImage*) g_type_create_instance (object_type);
#line 93 "../src/NodeImage.vala"
	_tmp0_ = (gchar*) xmlGetProp (n, (xmlChar*) "id");
#line 93 "../src/NodeImage.vala"
	i = _tmp0_;
#line 94 "../src/NodeImage.vala"
	_tmp1_ = i;
#line 94 "../src/NodeImage.vala"
	if (_tmp1_ != NULL) {
#line 434 "NodeImage.c"
		const gchar* _tmp2_;
#line 95 "../src/NodeImage.vala"
		_tmp2_ = i;
#line 95 "../src/NodeImage.vala"
		node_image_set_id (self, atoi (_tmp2_));
#line 440 "NodeImage.c"
	}
#line 98 "../src/NodeImage.vala"
	_tmp3_ = (gchar*) xmlGetProp (n, (xmlChar*) "x");
#line 98 "../src/NodeImage.vala"
	x = _tmp3_;
#line 99 "../src/NodeImage.vala"
	_tmp4_ = x;
#line 99 "../src/NodeImage.vala"
	if (_tmp4_ != NULL) {
#line 450 "NodeImage.c"
		const gchar* _tmp5_;
#line 100 "../src/NodeImage.vala"
		_tmp5_ = x;
#line 100 "../src/NodeImage.vala"
		node_image_set_crop_x (self, atoi (_tmp5_));
#line 456 "NodeImage.c"
	}
#line 103 "../src/NodeImage.vala"
	_tmp6_ = (gchar*) xmlGetProp (n, (xmlChar*) "y");
#line 103 "../src/NodeImage.vala"
	y = _tmp6_;
#line 104 "../src/NodeImage.vala"
	_tmp7_ = y;
#line 104 "../src/NodeImage.vala"
	if (_tmp7_ != NULL) {
#line 466 "NodeImage.c"
		const gchar* _tmp8_;
#line 105 "../src/NodeImage.vala"
		_tmp8_ = y;
#line 105 "../src/NodeImage.vala"
		node_image_set_crop_y (self, atoi (_tmp8_));
#line 472 "NodeImage.c"
	}
#line 108 "../src/NodeImage.vala"
	_tmp9_ = (gchar*) xmlGetProp (n, (xmlChar*) "w");
#line 108 "../src/NodeImage.vala"
	w = _tmp9_;
#line 109 "../src/NodeImage.vala"
	_tmp10_ = w;
#line 109 "../src/NodeImage.vala"
	if (_tmp10_ != NULL) {
#line 482 "NodeImage.c"
		const gchar* _tmp11_;
#line 110 "../src/NodeImage.vala"
		_tmp11_ = w;
#line 110 "../src/NodeImage.vala"
		node_image_set_crop_w (self, atoi (_tmp11_));
#line 488 "NodeImage.c"
	}
#line 113 "../src/NodeImage.vala"
	_tmp12_ = (gchar*) xmlGetProp (n, (xmlChar*) "h");
#line 113 "../src/NodeImage.vala"
	h = _tmp12_;
#line 114 "../src/NodeImage.vala"
	_tmp13_ = h;
#line 114 "../src/NodeImage.vala"
	if (_tmp13_ != NULL) {
#line 498 "NodeImage.c"
		const gchar* _tmp14_;
#line 115 "../src/NodeImage.vala"
		_tmp14_ = h;
#line 115 "../src/NodeImage.vala"
		node_image_set_crop_h (self, atoi (_tmp14_));
#line 504 "NodeImage.c"
	}
#line 119 "../src/NodeImage.vala"
	_tmp15_ = self->priv->_id;
#line 119 "../src/NodeImage.vala"
	if (_tmp15_ != -1) {
#line 510 "NodeImage.c"
		gint _tmp16_;
#line 120 "../src/NodeImage.vala"
		_tmp16_ = self->priv->_id;
#line 120 "../src/NodeImage.vala"
		if (node_image_load (self, im, _tmp16_, FALSE)) {
#line 121 "../src/NodeImage.vala"
			node_image_set_width (self, width);
#line 518 "NodeImage.c"
		}
	}
#line 91 "../src/NodeImage.vala"
	_g_free0 (h);
#line 91 "../src/NodeImage.vala"
	_g_free0 (w);
#line 91 "../src/NodeImage.vala"
	_g_free0 (y);
#line 91 "../src/NodeImage.vala"
	_g_free0 (x);
#line 91 "../src/NodeImage.vala"
	_g_free0 (i);
#line 91 "../src/NodeImage.vala"
	return self;
#line 533 "NodeImage.c"
}


NodeImage*
node_image_new_from_xml (ImageManager* im,
                         xmlNode* n,
                         gint width)
{
#line 91 "../src/NodeImage.vala"
	return node_image_construct_from_xml (TYPE_NODE_IMAGE, im, n, width);
#line 544 "NodeImage.c"
}


static gboolean
node_image_load (NodeImage* self,
                 ImageManager* im,
                 gint id,
                 gboolean init)
{
	gboolean result = FALSE;
	gboolean _tmp9_;
	GError* _inner_error0_ = NULL;
#line 128 "../src/NodeImage.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 128 "../src/NodeImage.vala"
	g_return_val_if_fail (im != NULL, FALSE);
#line 130 "../src/NodeImage.vala"
	node_image_set_id (self, id);
#line 131 "../src/NodeImage.vala"
	node_image_set_valid (self, TRUE);
#line 565 "NodeImage.c"
	{
		gchar* fname = NULL;
		gchar* _tmp0_;
		const gchar* _tmp1_;
		GdkPixbuf* buf = NULL;
		const gchar* _tmp2_;
		GdkPixbuf* _tmp3_;
		GdkPixbuf* _tmp4_;
		cairo_surface_t* _tmp5_;
#line 137 "../src/NodeImage.vala"
		_tmp0_ = image_manager_get_file (im, id);
#line 137 "../src/NodeImage.vala"
		fname = _tmp0_;
#line 138 "../src/NodeImage.vala"
		_tmp1_ = fname;
#line 138 "../src/NodeImage.vala"
		if (_tmp1_ == NULL) {
#line 139 "../src/NodeImage.vala"
			node_image_set_valid (self, FALSE);
#line 140 "../src/NodeImage.vala"
			result = FALSE;
#line 140 "../src/NodeImage.vala"
			_g_free0 (fname);
#line 140 "../src/NodeImage.vala"
			return result;
#line 591 "NodeImage.c"
		}
#line 144 "../src/NodeImage.vala"
		_tmp2_ = fname;
#line 144 "../src/NodeImage.vala"
		_tmp3_ = gdk_pixbuf_new_from_file_at_size (_tmp2_, NODE_IMAGE_EDIT_WIDTH, NODE_IMAGE_EDIT_HEIGHT, &_inner_error0_);
#line 144 "../src/NodeImage.vala"
		buf = _tmp3_;
#line 144 "../src/NodeImage.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 144 "../src/NodeImage.vala"
			_g_free0 (fname);
#line 603 "NodeImage.c"
			goto __catch23_g_error;
		}
#line 145 "../src/NodeImage.vala"
		_tmp4_ = buf;
#line 145 "../src/NodeImage.vala"
		_tmp5_ = gdk_cairo_surface_create_from_pixbuf (_tmp4_, 1, NULL);
#line 145 "../src/NodeImage.vala"
		_cairo_surface_destroy0 (self->priv->_surface);
#line 145 "../src/NodeImage.vala"
		self->priv->_surface = (cairo_surface_t*) _tmp5_;
#line 148 "../src/NodeImage.vala"
		if (init) {
#line 616 "NodeImage.c"
			cairo_surface_t* _tmp6_;
			cairo_surface_t* _tmp7_;
#line 149 "../src/NodeImage.vala"
			node_image_set_crop_x (self, 0);
#line 150 "../src/NodeImage.vala"
			node_image_set_crop_y (self, 0);
#line 151 "../src/NodeImage.vala"
			_tmp6_ = self->priv->_surface;
#line 151 "../src/NodeImage.vala"
			node_image_set_crop_w (self, cairo_image_surface_get_width (_tmp6_));
#line 152 "../src/NodeImage.vala"
			_tmp7_ = self->priv->_surface;
#line 152 "../src/NodeImage.vala"
			node_image_set_crop_h (self, cairo_image_surface_get_height (_tmp7_));
#line 631 "NodeImage.c"
		}
#line 134 "../src/NodeImage.vala"
		_g_object_unref0 (buf);
#line 134 "../src/NodeImage.vala"
		_g_free0 (fname);
#line 637 "NodeImage.c"
	}
	goto __finally23;
	__catch23_g_error:
	{
		GError* e = NULL;
#line 134 "../src/NodeImage.vala"
		e = _inner_error0_;
#line 134 "../src/NodeImage.vala"
		_inner_error0_ = NULL;
#line 156 "../src/NodeImage.vala"
		node_image_set_valid (self, FALSE);
#line 134 "../src/NodeImage.vala"
		_g_error_free0 (e);
#line 651 "NodeImage.c"
	}
	__finally23:
#line 134 "../src/NodeImage.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 656 "NodeImage.c"
		gboolean _tmp8_ = FALSE;
#line 134 "../src/NodeImage.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 134 "../src/NodeImage.vala"
		g_clear_error (&_inner_error0_);
#line 134 "../src/NodeImage.vala"
		return _tmp8_;
#line 664 "NodeImage.c"
	}
#line 159 "../src/NodeImage.vala"
	_tmp9_ = self->priv->_valid;
#line 159 "../src/NodeImage.vala"
	result = _tmp9_;
#line 159 "../src/NodeImage.vala"
	return result;
#line 672 "NodeImage.c"
}


void
node_image_set_width (NodeImage* self,
                      gint width)
{
	gdouble scale = 0.0;
	gint _tmp0_;
	GdkPixbuf* buf = NULL;
	cairo_surface_t* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	GdkPixbuf* _tmp6_;
	gint _tmp7_;
	GdkPixbuf* _tmp8_;
#line 168 "../src/NodeImage.vala"
	g_return_if_fail (self != NULL);
#line 170 "../src/NodeImage.vala"
	_tmp0_ = self->priv->_crop_w;
#line 170 "../src/NodeImage.vala"
	scale = (width * 1.0) / _tmp0_;
#line 171 "../src/NodeImage.vala"
	_tmp1_ = self->priv->_surface;
#line 171 "../src/NodeImage.vala"
	_tmp2_ = self->priv->_crop_x;
#line 171 "../src/NodeImage.vala"
	_tmp3_ = self->priv->_crop_y;
#line 171 "../src/NodeImage.vala"
	_tmp4_ = self->priv->_crop_w;
#line 171 "../src/NodeImage.vala"
	_tmp5_ = self->priv->_crop_h;
#line 171 "../src/NodeImage.vala"
	_tmp6_ = gdk_pixbuf_get_from_surface (_tmp1_, _tmp2_, _tmp3_, _tmp4_, _tmp5_);
#line 171 "../src/NodeImage.vala"
	buf = _tmp6_;
#line 173 "../src/NodeImage.vala"
	_tmp7_ = self->priv->_crop_h;
#line 173 "../src/NodeImage.vala"
	_tmp8_ = gdk_pixbuf_scale_simple (buf, width, (gint) (_tmp7_ * scale), GDK_INTERP_BILINEAR);
#line 173 "../src/NodeImage.vala"
	_g_object_unref0 (self->priv->_buf);
#line 173 "../src/NodeImage.vala"
	self->priv->_buf = _tmp8_;
#line 168 "../src/NodeImage.vala"
	_g_object_unref0 (buf);
#line 721 "NodeImage.c"
}


static gpointer
_cairo_surface_reference0 (gpointer self)
{
#line 179 "../src/NodeImage.vala"
	return self ? cairo_surface_reference (self) : NULL;
#line 730 "NodeImage.c"
}


cairo_surface_t*
node_image_get_surface (NodeImage* self)
{
	cairo_surface_t* result = NULL;
	cairo_surface_t* _tmp0_;
	cairo_surface_t* _tmp1_;
#line 178 "../src/NodeImage.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 179 "../src/NodeImage.vala"
	_tmp0_ = self->priv->_surface;
#line 179 "../src/NodeImage.vala"
	_tmp1_ = _cairo_surface_reference0 (_tmp0_);
#line 179 "../src/NodeImage.vala"
	result = _tmp1_;
#line 179 "../src/NodeImage.vala"
	return result;
#line 750 "NodeImage.c"
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 184 "../src/NodeImage.vala"
	return self ? g_object_ref (self) : NULL;
#line 759 "NodeImage.c"
}


GdkPixbuf*
node_image_get_pixbuf (NodeImage* self)
{
	GdkPixbuf* result = NULL;
	GdkPixbuf* _tmp0_;
	GdkPixbuf* _tmp1_;
#line 183 "../src/NodeImage.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 184 "../src/NodeImage.vala"
	_tmp0_ = self->priv->_buf;
#line 184 "../src/NodeImage.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 184 "../src/NodeImage.vala"
	result = _tmp1_;
#line 184 "../src/NodeImage.vala"
	return result;
#line 779 "NodeImage.c"
}


void
node_image_draw (NodeImage* self,
                 cairo_t* ctx,
                 gdouble x,
                 gdouble y,
                 gdouble opacity)
{
	GdkPixbuf* _tmp0_;
#line 188 "../src/NodeImage.vala"
	g_return_if_fail (self != NULL);
#line 188 "../src/NodeImage.vala"
	g_return_if_fail (ctx != NULL);
#line 189 "../src/NodeImage.vala"
	_tmp0_ = self->priv->_buf;
#line 189 "../src/NodeImage.vala"
	gdk_cairo_set_source_pixbuf (ctx, _tmp0_, x, y);
#line 190 "../src/NodeImage.vala"
	cairo_paint_with_alpha (ctx, opacity);
#line 801 "NodeImage.c"
}


void
node_image_set_image (NodeImage* self,
                      GtkImage* img)
{
	gdouble scale_width = 0.0;
	GdkPixbuf* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gdouble scale_height = 0.0;
	GdkPixbuf* _tmp3_;
	gint _tmp4_;
	gint _tmp5_;
	gint w = 0;
	gint h = 0;
	gdouble _tmp6_;
	gdouble _tmp7_;
	GdkPixbuf* buf = NULL;
	GdkPixbuf* _tmp16_;
	gint _tmp17_;
	gint _tmp18_;
	GdkPixbuf* _tmp19_;
#line 195 "../src/NodeImage.vala"
	g_return_if_fail (self != NULL);
#line 195 "../src/NodeImage.vala"
	g_return_if_fail (img != NULL);
#line 197 "../src/NodeImage.vala"
	_tmp0_ = self->priv->_buf;
#line 197 "../src/NodeImage.vala"
	_tmp1_ = gdk_pixbuf_get_width (_tmp0_);
#line 197 "../src/NodeImage.vala"
	_tmp2_ = _tmp1_;
#line 197 "../src/NodeImage.vala"
	scale_width = 300.0 / _tmp2_;
#line 198 "../src/NodeImage.vala"
	_tmp3_ = self->priv->_buf;
#line 198 "../src/NodeImage.vala"
	_tmp4_ = gdk_pixbuf_get_height (_tmp3_);
#line 198 "../src/NodeImage.vala"
	_tmp5_ = _tmp4_;
#line 198 "../src/NodeImage.vala"
	scale_height = 300.0 / _tmp5_;
#line 199 "../src/NodeImage.vala"
	w = 300;
#line 200 "../src/NodeImage.vala"
	h = 300;
#line 203 "../src/NodeImage.vala"
	_tmp6_ = scale_width;
#line 203 "../src/NodeImage.vala"
	_tmp7_ = scale_height;
#line 203 "../src/NodeImage.vala"
	if (_tmp6_ < _tmp7_) {
#line 856 "NodeImage.c"
		gdouble _tmp8_;
		GdkPixbuf* _tmp9_;
		gint _tmp10_;
		gint _tmp11_;
#line 204 "../src/NodeImage.vala"
		_tmp8_ = scale_width;
#line 204 "../src/NodeImage.vala"
		_tmp9_ = self->priv->_buf;
#line 204 "../src/NodeImage.vala"
		_tmp10_ = gdk_pixbuf_get_height (_tmp9_);
#line 204 "../src/NodeImage.vala"
		_tmp11_ = _tmp10_;
#line 204 "../src/NodeImage.vala"
		h = (gint) (_tmp8_ * _tmp11_);
#line 871 "NodeImage.c"
	} else {
		gdouble _tmp12_;
		GdkPixbuf* _tmp13_;
		gint _tmp14_;
		gint _tmp15_;
#line 206 "../src/NodeImage.vala"
		_tmp12_ = scale_height;
#line 206 "../src/NodeImage.vala"
		_tmp13_ = self->priv->_buf;
#line 206 "../src/NodeImage.vala"
		_tmp14_ = gdk_pixbuf_get_width (_tmp13_);
#line 206 "../src/NodeImage.vala"
		_tmp15_ = _tmp14_;
#line 206 "../src/NodeImage.vala"
		w = (gint) (_tmp12_ * _tmp15_);
#line 887 "NodeImage.c"
	}
#line 210 "../src/NodeImage.vala"
	_tmp16_ = self->priv->_buf;
#line 210 "../src/NodeImage.vala"
	_tmp17_ = w;
#line 210 "../src/NodeImage.vala"
	_tmp18_ = h;
#line 210 "../src/NodeImage.vala"
	_tmp19_ = gdk_pixbuf_scale_simple (_tmp16_, _tmp17_, _tmp18_, GDK_INTERP_BILINEAR);
#line 210 "../src/NodeImage.vala"
	buf = _tmp19_;
#line 211 "../src/NodeImage.vala"
	gtk_image_set_from_pixbuf (img, buf);
#line 195 "../src/NodeImage.vala"
	_g_object_unref0 (buf);
#line 903 "NodeImage.c"
}


static void
node_image_real_save (NodeImage* self,
                      xmlNode* parent)
{
	xmlNode* n = NULL;
	xmlNode* _tmp0_;
	gint _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gint _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gint _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	gint _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	gint _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
#line 218 "../src/NodeImage.vala"
	_tmp0_ = xmlNewNode (NULL, (xmlChar*) "nodeimage");
#line 218 "../src/NodeImage.vala"
	n = _tmp0_;
#line 220 "../src/NodeImage.vala"
	_tmp1_ = self->priv->_id;
#line 220 "../src/NodeImage.vala"
	_tmp2_ = g_strdup_printf ("%i", _tmp1_);
#line 220 "../src/NodeImage.vala"
	_tmp3_ = _tmp2_;
#line 220 "../src/NodeImage.vala"
	xmlNewProp (n, (xmlChar*) "id", (xmlChar*) _tmp3_);
#line 220 "../src/NodeImage.vala"
	_g_free0 (_tmp3_);
#line 221 "../src/NodeImage.vala"
	_tmp4_ = self->priv->_crop_x;
#line 221 "../src/NodeImage.vala"
	_tmp5_ = g_strdup_printf ("%i", _tmp4_);
#line 221 "../src/NodeImage.vala"
	_tmp6_ = _tmp5_;
#line 221 "../src/NodeImage.vala"
	xmlNewProp (n, (xmlChar*) "x", (xmlChar*) _tmp6_);
#line 221 "../src/NodeImage.vala"
	_g_free0 (_tmp6_);
#line 222 "../src/NodeImage.vala"
	_tmp7_ = self->priv->_crop_y;
#line 222 "../src/NodeImage.vala"
	_tmp8_ = g_strdup_printf ("%i", _tmp7_);
#line 222 "../src/NodeImage.vala"
	_tmp9_ = _tmp8_;
#line 222 "../src/NodeImage.vala"
	xmlNewProp (n, (xmlChar*) "y", (xmlChar*) _tmp9_);
#line 222 "../src/NodeImage.vala"
	_g_free0 (_tmp9_);
#line 223 "../src/NodeImage.vala"
	_tmp10_ = self->priv->_crop_w;
#line 223 "../src/NodeImage.vala"
	_tmp11_ = g_strdup_printf ("%i", _tmp10_);
#line 223 "../src/NodeImage.vala"
	_tmp12_ = _tmp11_;
#line 223 "../src/NodeImage.vala"
	xmlNewProp (n, (xmlChar*) "w", (xmlChar*) _tmp12_);
#line 223 "../src/NodeImage.vala"
	_g_free0 (_tmp12_);
#line 224 "../src/NodeImage.vala"
	_tmp13_ = self->priv->_crop_h;
#line 224 "../src/NodeImage.vala"
	_tmp14_ = g_strdup_printf ("%i", _tmp13_);
#line 224 "../src/NodeImage.vala"
	_tmp15_ = _tmp14_;
#line 224 "../src/NodeImage.vala"
	xmlNewProp (n, (xmlChar*) "h", (xmlChar*) _tmp15_);
#line 224 "../src/NodeImage.vala"
	_g_free0 (_tmp15_);
#line 226 "../src/NodeImage.vala"
	xmlAddChild (parent, n);
#line 984 "NodeImage.c"
}


void
node_image_save (NodeImage* self,
                 xmlNode* parent)
{
#line 216 "../src/NodeImage.vala"
	g_return_if_fail (self != NULL);
#line 216 "../src/NodeImage.vala"
	NODE_IMAGE_GET_CLASS (self)->save (self, parent);
#line 996 "NodeImage.c"
}


gint
node_image_get_id (NodeImage* self)
{
	gint result;
	gint _tmp0_;
#line 35 "../src/NodeImage.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 35 "../src/NodeImage.vala"
	_tmp0_ = self->priv->_id;
#line 35 "../src/NodeImage.vala"
	result = _tmp0_;
#line 35 "../src/NodeImage.vala"
	return result;
#line 1013 "NodeImage.c"
}


void
node_image_set_id (NodeImage* self,
                   gint value)
{
#line 35 "../src/NodeImage.vala"
	g_return_if_fail (self != NULL);
#line 35 "../src/NodeImage.vala"
	self->priv->_id = value;
#line 1025 "NodeImage.c"
}


gboolean
node_image_get_valid (NodeImage* self)
{
	gboolean result;
	gboolean _tmp0_;
#line 36 "../src/NodeImage.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 36 "../src/NodeImage.vala"
	_tmp0_ = self->priv->_valid;
#line 36 "../src/NodeImage.vala"
	result = _tmp0_;
#line 36 "../src/NodeImage.vala"
	return result;
#line 1042 "NodeImage.c"
}


static void
node_image_set_valid (NodeImage* self,
                      gboolean value)
{
#line 36 "../src/NodeImage.vala"
	g_return_if_fail (self != NULL);
#line 36 "../src/NodeImage.vala"
	self->priv->_valid = value;
#line 1054 "NodeImage.c"
}


gint
node_image_get_crop_x (NodeImage* self)
{
	gint result;
	gint _tmp0_;
#line 37 "../src/NodeImage.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 37 "../src/NodeImage.vala"
	_tmp0_ = self->priv->_crop_x;
#line 37 "../src/NodeImage.vala"
	result = _tmp0_;
#line 37 "../src/NodeImage.vala"
	return result;
#line 1071 "NodeImage.c"
}


void
node_image_set_crop_x (NodeImage* self,
                       gint value)
{
#line 37 "../src/NodeImage.vala"
	g_return_if_fail (self != NULL);
#line 37 "../src/NodeImage.vala"
	self->priv->_crop_x = value;
#line 1083 "NodeImage.c"
}


gint
node_image_get_crop_y (NodeImage* self)
{
	gint result;
	gint _tmp0_;
#line 38 "../src/NodeImage.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 38 "../src/NodeImage.vala"
	_tmp0_ = self->priv->_crop_y;
#line 38 "../src/NodeImage.vala"
	result = _tmp0_;
#line 38 "../src/NodeImage.vala"
	return result;
#line 1100 "NodeImage.c"
}


void
node_image_set_crop_y (NodeImage* self,
                       gint value)
{
#line 38 "../src/NodeImage.vala"
	g_return_if_fail (self != NULL);
#line 38 "../src/NodeImage.vala"
	self->priv->_crop_y = value;
#line 1112 "NodeImage.c"
}


gint
node_image_get_crop_w (NodeImage* self)
{
	gint result;
	gint _tmp0_;
#line 39 "../src/NodeImage.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 39 "../src/NodeImage.vala"
	_tmp0_ = self->priv->_crop_w;
#line 39 "../src/NodeImage.vala"
	result = _tmp0_;
#line 39 "../src/NodeImage.vala"
	return result;
#line 1129 "NodeImage.c"
}


void
node_image_set_crop_w (NodeImage* self,
                       gint value)
{
#line 39 "../src/NodeImage.vala"
	g_return_if_fail (self != NULL);
#line 39 "../src/NodeImage.vala"
	self->priv->_crop_w = value;
#line 1141 "NodeImage.c"
}


gint
node_image_get_crop_h (NodeImage* self)
{
	gint result;
	gint _tmp0_;
#line 40 "../src/NodeImage.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 40 "../src/NodeImage.vala"
	_tmp0_ = self->priv->_crop_h;
#line 40 "../src/NodeImage.vala"
	result = _tmp0_;
#line 40 "../src/NodeImage.vala"
	return result;
#line 1158 "NodeImage.c"
}


void
node_image_set_crop_h (NodeImage* self,
                       gint value)
{
#line 40 "../src/NodeImage.vala"
	g_return_if_fail (self != NULL);
#line 40 "../src/NodeImage.vala"
	self->priv->_crop_h = value;
#line 1170 "NodeImage.c"
}


gint
node_image_get_width (NodeImage* self)
{
	gint result;
	GdkPixbuf* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 42 "../src/NodeImage.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 43 "../src/NodeImage.vala"
	_tmp0_ = self->priv->_buf;
#line 43 "../src/NodeImage.vala"
	_tmp1_ = gdk_pixbuf_get_width (_tmp0_);
#line 43 "../src/NodeImage.vala"
	_tmp2_ = _tmp1_;
#line 43 "../src/NodeImage.vala"
	result = _tmp2_;
#line 43 "../src/NodeImage.vala"
	return result;
#line 1193 "NodeImage.c"
}


gint
node_image_get_height (NodeImage* self)
{
	gint result;
	GdkPixbuf* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 47 "../src/NodeImage.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 48 "../src/NodeImage.vala"
	_tmp0_ = self->priv->_buf;
#line 48 "../src/NodeImage.vala"
	_tmp1_ = gdk_pixbuf_get_height (_tmp0_);
#line 48 "../src/NodeImage.vala"
	_tmp2_ = _tmp1_;
#line 48 "../src/NodeImage.vala"
	result = _tmp2_;
#line 48 "../src/NodeImage.vala"
	return result;
#line 1216 "NodeImage.c"
}


static void
value_node_image_init (GValue* value)
{
#line 27 "../src/NodeImage.vala"
	value->data[0].v_pointer = NULL;
#line 1225 "NodeImage.c"
}


static void
value_node_image_free_value (GValue* value)
{
#line 27 "../src/NodeImage.vala"
	if (value->data[0].v_pointer) {
#line 27 "../src/NodeImage.vala"
		node_image_unref (value->data[0].v_pointer);
#line 1236 "NodeImage.c"
	}
}


static void
value_node_image_copy_value (const GValue* src_value,
                             GValue* dest_value)
{
#line 27 "../src/NodeImage.vala"
	if (src_value->data[0].v_pointer) {
#line 27 "../src/NodeImage.vala"
		dest_value->data[0].v_pointer = node_image_ref (src_value->data[0].v_pointer);
#line 1249 "NodeImage.c"
	} else {
#line 27 "../src/NodeImage.vala"
		dest_value->data[0].v_pointer = NULL;
#line 1253 "NodeImage.c"
	}
}


static gpointer
value_node_image_peek_pointer (const GValue* value)
{
#line 27 "../src/NodeImage.vala"
	return value->data[0].v_pointer;
#line 1263 "NodeImage.c"
}


static gchar*
value_node_image_collect_value (GValue* value,
                                guint n_collect_values,
                                GTypeCValue* collect_values,
                                guint collect_flags)
{
#line 27 "../src/NodeImage.vala"
	if (collect_values[0].v_pointer) {
#line 1275 "NodeImage.c"
		NodeImage * object;
		object = collect_values[0].v_pointer;
#line 27 "../src/NodeImage.vala"
		if (object->parent_instance.g_class == NULL) {
#line 27 "../src/NodeImage.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1282 "NodeImage.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 27 "../src/NodeImage.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 1286 "NodeImage.c"
		}
#line 27 "../src/NodeImage.vala"
		value->data[0].v_pointer = node_image_ref (object);
#line 1290 "NodeImage.c"
	} else {
#line 27 "../src/NodeImage.vala"
		value->data[0].v_pointer = NULL;
#line 1294 "NodeImage.c"
	}
#line 27 "../src/NodeImage.vala"
	return NULL;
#line 1298 "NodeImage.c"
}


static gchar*
value_node_image_lcopy_value (const GValue* value,
                              guint n_collect_values,
                              GTypeCValue* collect_values,
                              guint collect_flags)
{
	NodeImage ** object_p;
	object_p = collect_values[0].v_pointer;
#line 27 "../src/NodeImage.vala"
	if (!object_p) {
#line 27 "../src/NodeImage.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 1314 "NodeImage.c"
	}
#line 27 "../src/NodeImage.vala"
	if (!value->data[0].v_pointer) {
#line 27 "../src/NodeImage.vala"
		*object_p = NULL;
#line 1320 "NodeImage.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 27 "../src/NodeImage.vala"
		*object_p = value->data[0].v_pointer;
#line 1324 "NodeImage.c"
	} else {
#line 27 "../src/NodeImage.vala"
		*object_p = node_image_ref (value->data[0].v_pointer);
#line 1328 "NodeImage.c"
	}
#line 27 "../src/NodeImage.vala"
	return NULL;
#line 1332 "NodeImage.c"
}


GParamSpec*
param_spec_node_image (const gchar* name,
                       const gchar* nick,
                       const gchar* blurb,
                       GType object_type,
                       GParamFlags flags)
{
	ParamSpecNodeImage* spec;
#line 27 "../src/NodeImage.vala"
	g_return_val_if_fail (g_type_is_a (object_type, TYPE_NODE_IMAGE), NULL);
#line 27 "../src/NodeImage.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 27 "../src/NodeImage.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 27 "../src/NodeImage.vala"
	return G_PARAM_SPEC (spec);
#line 1352 "NodeImage.c"
}


gpointer
value_get_node_image (const GValue* value)
{
#line 27 "../src/NodeImage.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_NODE_IMAGE), NULL);
#line 27 "../src/NodeImage.vala"
	return value->data[0].v_pointer;
#line 1363 "NodeImage.c"
}


void
value_set_node_image (GValue* value,
                      gpointer v_object)
{
	NodeImage * old;
#line 27 "../src/NodeImage.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_NODE_IMAGE));
#line 27 "../src/NodeImage.vala"
	old = value->data[0].v_pointer;
#line 27 "../src/NodeImage.vala"
	if (v_object) {
#line 27 "../src/NodeImage.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_NODE_IMAGE));
#line 27 "../src/NodeImage.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 27 "../src/NodeImage.vala"
		value->data[0].v_pointer = v_object;
#line 27 "../src/NodeImage.vala"
		node_image_ref (value->data[0].v_pointer);
#line 1386 "NodeImage.c"
	} else {
#line 27 "../src/NodeImage.vala"
		value->data[0].v_pointer = NULL;
#line 1390 "NodeImage.c"
	}
#line 27 "../src/NodeImage.vala"
	if (old) {
#line 27 "../src/NodeImage.vala"
		node_image_unref (old);
#line 1396 "NodeImage.c"
	}
}


void
value_take_node_image (GValue* value,
                       gpointer v_object)
{
	NodeImage * old;
#line 27 "../src/NodeImage.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, TYPE_NODE_IMAGE));
#line 27 "../src/NodeImage.vala"
	old = value->data[0].v_pointer;
#line 27 "../src/NodeImage.vala"
	if (v_object) {
#line 27 "../src/NodeImage.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, TYPE_NODE_IMAGE));
#line 27 "../src/NodeImage.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 27 "../src/NodeImage.vala"
		value->data[0].v_pointer = v_object;
#line 1418 "NodeImage.c"
	} else {
#line 27 "../src/NodeImage.vala"
		value->data[0].v_pointer = NULL;
#line 1422 "NodeImage.c"
	}
#line 27 "../src/NodeImage.vala"
	if (old) {
#line 27 "../src/NodeImage.vala"
		node_image_unref (old);
#line 1428 "NodeImage.c"
	}
}


static void
node_image_class_init (NodeImageClass * klass)
{
#line 27 "../src/NodeImage.vala"
	node_image_parent_class = g_type_class_peek_parent (klass);
#line 27 "../src/NodeImage.vala"
	((NodeImageClass *) klass)->finalize = node_image_finalize;
#line 27 "../src/NodeImage.vala"
	g_type_class_adjust_private_offset (klass, &NodeImage_private_offset);
#line 27 "../src/NodeImage.vala"
	((NodeImageClass *) klass)->save = (void (*) (NodeImage*, xmlNode*)) node_image_real_save;
#line 1444 "NodeImage.c"
}


static void
node_image_instance_init (NodeImage * self)
{
#line 27 "../src/NodeImage.vala"
	self->priv = node_image_get_instance_private (self);
#line 35 "../src/NodeImage.vala"
	self->priv->_id = -1;
#line 36 "../src/NodeImage.vala"
	self->priv->_valid = FALSE;
#line 37 "../src/NodeImage.vala"
	self->priv->_crop_x = 0;
#line 38 "../src/NodeImage.vala"
	self->priv->_crop_y = 0;
#line 39 "../src/NodeImage.vala"
	self->priv->_crop_w = 0;
#line 40 "../src/NodeImage.vala"
	self->priv->_crop_h = 0;
#line 27 "../src/NodeImage.vala"
	self->ref_count = 1;
#line 1467 "NodeImage.c"
}


static void
node_image_finalize (NodeImage * obj)
{
	NodeImage * self;
#line 27 "../src/NodeImage.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_NODE_IMAGE, NodeImage);
#line 27 "../src/NodeImage.vala"
	g_signal_handlers_destroy (self);
#line 32 "../src/NodeImage.vala"
	_cairo_surface_destroy0 (self->priv->_surface);
#line 33 "../src/NodeImage.vala"
	_g_object_unref0 (self->priv->_buf);
#line 1483 "NodeImage.c"
}


GType
node_image_get_type (void)
{
	static volatile gsize node_image_type_id__volatile = 0;
	if (g_once_init_enter (&node_image_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { value_node_image_init, value_node_image_free_value, value_node_image_copy_value, value_node_image_peek_pointer, "p", value_node_image_collect_value, "p", value_node_image_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (NodeImageClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) node_image_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (NodeImage), 0, (GInstanceInitFunc) node_image_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType node_image_type_id;
		node_image_type_id = g_type_register_fundamental (g_type_fundamental_next (), "NodeImage", &g_define_type_info, &g_define_type_fundamental_info, 0);
		NodeImage_private_offset = g_type_add_instance_private (node_image_type_id, sizeof (NodeImagePrivate));
		g_once_init_leave (&node_image_type_id__volatile, node_image_type_id);
	}
	return node_image_type_id__volatile;
}


gpointer
node_image_ref (gpointer instance)
{
	NodeImage * self;
	self = instance;
#line 27 "../src/NodeImage.vala"
	g_atomic_int_inc (&self->ref_count);
#line 27 "../src/NodeImage.vala"
	return instance;
#line 1513 "NodeImage.c"
}


void
node_image_unref (gpointer instance)
{
	NodeImage * self;
	self = instance;
#line 27 "../src/NodeImage.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 27 "../src/NodeImage.vala"
		NODE_IMAGE_GET_CLASS (self)->finalize (self);
#line 27 "../src/NodeImage.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 1528 "NodeImage.c"
	}
}



