/* Partitioner.c generated by valac 0.42.7, the Vala compiler
 * generated from Partitioner.vala, do not modify */

/*
* Copyright (c) 2018 (https://github.com/phase1geo/Minder)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Trevor Williams <phase1geo@gmail.com>
*/
/*
 This class stores a pointer to a node to partition as well as its pixel size
 that is used for balancing purposes.
*/


#include <glib.h>
#include <glib-object.h>
#include <float.h>
#include <math.h>


#define TYPE_PART_NODE (part_node_get_type ())
#define PART_NODE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PART_NODE, PartNode))
#define PART_NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PART_NODE, PartNodeClass))
#define IS_PART_NODE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PART_NODE))
#define IS_PART_NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PART_NODE))
#define PART_NODE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PART_NODE, PartNodeClass))

typedef struct _PartNode PartNode;
typedef struct _PartNodeClass PartNodeClass;
typedef struct _PartNodePrivate PartNodePrivate;

#define TYPE_NODE (node_get_type ())
#define NODE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NODE, Node))
#define NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NODE, NodeClass))
#define IS_NODE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NODE))
#define IS_NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NODE))
#define NODE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NODE, NodeClass))

typedef struct _Node Node;
typedef struct _NodeClass NodeClass;
enum  {
	PART_NODE_0_PROPERTY,
	PART_NODE_NUM_PROPERTIES
};
static GParamSpec* part_node_properties[PART_NODE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

#define TYPE_NODE_BOUNDS (node_bounds_get_type ())
typedef struct _NodeBounds NodeBounds;
typedef enum  {
	NODE_SIDE_LEFT = 1,
	NODE_SIDE_TOP = 2,
	NODE_SIDE_RIGHT = 4,
	NODE_SIDE_BOTTOM = 8
} NodeSide;


#define TYPE_NODE_SIDE (node_side_get_type ())

#define TYPE_LAYOUT (layout_get_type ())
#define LAYOUT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LAYOUT, Layout))
#define LAYOUT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LAYOUT, LayoutClass))
#define IS_LAYOUT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LAYOUT))
#define IS_LAYOUT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LAYOUT))
#define LAYOUT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LAYOUT, LayoutClass))

typedef struct _Layout Layout;
typedef struct _LayoutClass LayoutClass;

#define TYPE_PARTITIONER (partitioner_get_type ())
#define PARTITIONER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_PARTITIONER, Partitioner))
#define PARTITIONER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_PARTITIONER, PartitionerClass))
#define IS_PARTITIONER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_PARTITIONER))
#define IS_PARTITIONER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_PARTITIONER))
#define PARTITIONER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_PARTITIONER, PartitionerClass))

typedef struct _Partitioner Partitioner;
typedef struct _PartitionerClass PartitionerClass;
typedef struct _PartitionerPrivate PartitionerPrivate;
enum  {
	PARTITIONER_0_PROPERTY,
	PARTITIONER_NUM_PROPERTIES
};
static GParamSpec* partitioner_properties[PARTITIONER_NUM_PROPERTIES];
#define _g_array_unref0(var) ((var == NULL) ? NULL : (var = (g_array_unref (var), NULL)))
typedef struct _Block20Data Block20Data;

struct _PartNode {
	GObject parent_instance;
	PartNodePrivate * priv;
};

struct _PartNodeClass {
	GObjectClass parent_class;
};

struct _PartNodePrivate {
	Node* _node;
	gdouble _size;
};

struct _NodeBounds {
	gdouble x;
	gdouble y;
	gdouble width;
	gdouble height;
};

struct _Partitioner {
	GObject parent_instance;
	PartitionerPrivate * priv;
};

struct _PartitionerClass {
	GObjectClass parent_class;
	void (*partition) (Partitioner* self, Node* root, GSList* data);
};

struct _Block20Data {
	int _ref_count_;
	Partitioner* self;
	gdouble sum0;
	gdouble sum1;
	gint size0;
	Node* root;
};


static gint PartNode_private_offset;
static gpointer part_node_parent_class = NULL;
static gpointer partitioner_parent_class = NULL;

GType part_node_get_type (void) G_GNUC_CONST;
GType node_get_type (void) G_GNUC_CONST;
PartNode* part_node_new (Node* n);
PartNode* part_node_construct (GType object_type,
                               Node* n);
GType node_bounds_get_type (void) G_GNUC_CONST;
NodeBounds* node_bounds_dup (const NodeBounds* self);
void node_bounds_free (NodeBounds* self);
void node_get_tree_bbox (Node* self,
                         NodeBounds * result);
GType node_side_get_type (void) G_GNUC_CONST;
NodeSide node_get_side (Node* self);
gdouble part_node_size (PartNode* self);
Node* part_node_node (PartNode* self);
void part_node_update_node (PartNode* self,
                            Node* root,
                            gint index,
                            gint side);
void node_set_side (Node* self,
                    NodeSide value);
GType layout_get_type (void) G_GNUC_CONST;
Layout* node_get_layout (Node* self);
void layout_propagate_side (Layout* self,
                            Node* parent,
                            NodeSide side);
void node_attach_init (Node* self,
                       Node* parent,
                       gint index);
static void part_node_finalize (GObject * obj);
GType partitioner_get_type (void) G_GNUC_CONST;
Partitioner* partitioner_new (void);
Partitioner* partitioner_construct (GType object_type);
void partitioner_partition_node (Partitioner* self,
                                 Node* root);
GArray* node_children (Node* self);
static gint ___lambda71_ (PartNode* a,
                   PartNode* b);
gint node_id (Node* self);
static gint ____lambda71__gcompare_func (gconstpointer a,
                                  gconstpointer b);
static gint ___lambda72_ (PartNode* a,
                   PartNode* b);
static gint ____lambda72__gcompare_func (gconstpointer a,
                                  gconstpointer b);
void partitioner_partition (Partitioner* self,
                            Node* root,
                            GSList* data);
static void _g_object_unref0_ (gpointer var);
static inline void _g_slist_free__g_object_unref0_ (GSList* self);
static void partitioner_real_partition (Partitioner* self,
                                 Node* root,
                                 GSList* data);
static Block20Data* block20_data_ref (Block20Data* _data20_);
static void block20_data_unref (void * _userdata_);
static void __lambda73_ (Partitioner* self,
                  PartNode* item);
void node_detach (Node* self,
                  NodeSide side);
static void ___lambda73__gfunc (gconstpointer data,
                         gpointer self);
static void __lambda74_ (Block20Data* _data20_,
                  PartNode* item);
static void ___lambda74__gfunc (gconstpointer data,
                         gpointer self);


static inline gpointer
part_node_get_instance_private (PartNode* self)
{
	return G_STRUCT_MEMBER_P (self, PartNode_private_offset);
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 39 "../src/Partitioner.vala"
	return self ? g_object_ref (self) : NULL;
#line 227 "Partitioner.c"
}


PartNode*
part_node_construct (GType object_type,
                     Node* n)
{
	PartNode * self = NULL;
	NodeBounds nb = {0};
	NodeBounds _tmp0_ = {0};
	NodeBounds _tmp1_;
	gboolean _tmp2_ = FALSE;
	NodeSide _tmp3_;
	NodeSide _tmp4_;
	Node* _tmp11_;
#line 32 "../src/Partitioner.vala"
	g_return_val_if_fail (n != NULL, NULL);
#line 32 "../src/Partitioner.vala"
	self = (PartNode*) g_object_new (object_type, NULL);
#line 33 "../src/Partitioner.vala"
	node_get_tree_bbox (n, &_tmp0_);
#line 33 "../src/Partitioner.vala"
	_tmp1_ = _tmp0_;
#line 33 "../src/Partitioner.vala"
	nb = _tmp1_;
#line 34 "../src/Partitioner.vala"
	_tmp3_ = node_get_side (n);
#line 34 "../src/Partitioner.vala"
	_tmp4_ = _tmp3_;
#line 34 "../src/Partitioner.vala"
	if (_tmp4_ == NODE_SIDE_LEFT) {
#line 34 "../src/Partitioner.vala"
		_tmp2_ = TRUE;
#line 261 "Partitioner.c"
	} else {
		NodeSide _tmp5_;
		NodeSide _tmp6_;
#line 34 "../src/Partitioner.vala"
		_tmp5_ = node_get_side (n);
#line 34 "../src/Partitioner.vala"
		_tmp6_ = _tmp5_;
#line 34 "../src/Partitioner.vala"
		_tmp2_ = _tmp6_ == NODE_SIDE_RIGHT;
#line 271 "Partitioner.c"
	}
#line 34 "../src/Partitioner.vala"
	if (_tmp2_) {
#line 275 "Partitioner.c"
		NodeBounds _tmp7_;
		gdouble _tmp8_;
#line 35 "../src/Partitioner.vala"
		_tmp7_ = nb;
#line 35 "../src/Partitioner.vala"
		_tmp8_ = _tmp7_.height;
#line 35 "../src/Partitioner.vala"
		self->priv->_size = _tmp8_;
#line 284 "Partitioner.c"
	} else {
		NodeBounds _tmp9_;
		gdouble _tmp10_;
#line 37 "../src/Partitioner.vala"
		_tmp9_ = nb;
#line 37 "../src/Partitioner.vala"
		_tmp10_ = _tmp9_.width;
#line 37 "../src/Partitioner.vala"
		self->priv->_size = _tmp10_;
#line 294 "Partitioner.c"
	}
#line 39 "../src/Partitioner.vala"
	_tmp11_ = _g_object_ref0 (n);
#line 39 "../src/Partitioner.vala"
	_g_object_unref0 (self->priv->_node);
#line 39 "../src/Partitioner.vala"
	self->priv->_node = _tmp11_;
#line 32 "../src/Partitioner.vala"
	return self;
#line 304 "Partitioner.c"
}


PartNode*
part_node_new (Node* n)
{
#line 32 "../src/Partitioner.vala"
	return part_node_construct (TYPE_PART_NODE, n);
#line 313 "Partitioner.c"
}


gdouble
part_node_size (PartNode* self)
{
	gdouble result = 0.0;
	gdouble _tmp0_;
#line 43 "../src/Partitioner.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 43 "../src/Partitioner.vala"
	_tmp0_ = self->priv->_size;
#line 43 "../src/Partitioner.vala"
	result = _tmp0_;
#line 43 "../src/Partitioner.vala"
	return result;
#line 330 "Partitioner.c"
}


Node*
part_node_node (PartNode* self)
{
	Node* result = NULL;
	Node* _tmp0_;
	Node* _tmp1_;
#line 46 "../src/Partitioner.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 46 "../src/Partitioner.vala"
	_tmp0_ = self->priv->_node;
#line 46 "../src/Partitioner.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 46 "../src/Partitioner.vala"
	result = _tmp1_;
#line 46 "../src/Partitioner.vala"
	return result;
#line 350 "Partitioner.c"
}


void
part_node_update_node (PartNode* self,
                       Node* root,
                       gint index,
                       gint side)
{
	NodeSide orig_side = 0;
	Node* _tmp0_;
	NodeSide _tmp1_;
	NodeSide _tmp2_;
	gboolean _tmp3_ = FALSE;
	Node* _tmp4_;
	NodeSide _tmp5_;
	NodeSide _tmp6_;
	NodeSide _tmp14_;
	Node* _tmp15_;
	NodeSide _tmp16_;
	NodeSide _tmp17_;
	Node* _tmp25_;
#line 49 "../src/Partitioner.vala"
	g_return_if_fail (self != NULL);
#line 49 "../src/Partitioner.vala"
	g_return_if_fail (root != NULL);
#line 50 "../src/Partitioner.vala"
	_tmp0_ = self->priv->_node;
#line 50 "../src/Partitioner.vala"
	_tmp1_ = node_get_side (_tmp0_);
#line 50 "../src/Partitioner.vala"
	_tmp2_ = _tmp1_;
#line 50 "../src/Partitioner.vala"
	orig_side = _tmp2_;
#line 51 "../src/Partitioner.vala"
	_tmp4_ = self->priv->_node;
#line 51 "../src/Partitioner.vala"
	_tmp5_ = node_get_side (_tmp4_);
#line 51 "../src/Partitioner.vala"
	_tmp6_ = _tmp5_;
#line 51 "../src/Partitioner.vala"
	if (_tmp6_ == NODE_SIDE_LEFT) {
#line 51 "../src/Partitioner.vala"
		_tmp3_ = TRUE;
#line 395 "Partitioner.c"
	} else {
		Node* _tmp7_;
		NodeSide _tmp8_;
		NodeSide _tmp9_;
#line 51 "../src/Partitioner.vala"
		_tmp7_ = self->priv->_node;
#line 51 "../src/Partitioner.vala"
		_tmp8_ = node_get_side (_tmp7_);
#line 51 "../src/Partitioner.vala"
		_tmp9_ = _tmp8_;
#line 51 "../src/Partitioner.vala"
		_tmp3_ = _tmp9_ == NODE_SIDE_RIGHT;
#line 408 "Partitioner.c"
	}
#line 51 "../src/Partitioner.vala"
	if (_tmp3_) {
#line 412 "Partitioner.c"
		NodeSide _tmp10_ = 0;
		Node* _tmp11_;
#line 52 "../src/Partitioner.vala"
		if (side == 0) {
#line 52 "../src/Partitioner.vala"
			_tmp10_ = NODE_SIDE_LEFT;
#line 419 "Partitioner.c"
		} else {
#line 52 "../src/Partitioner.vala"
			_tmp10_ = NODE_SIDE_RIGHT;
#line 423 "Partitioner.c"
		}
#line 52 "../src/Partitioner.vala"
		_tmp11_ = self->priv->_node;
#line 52 "../src/Partitioner.vala"
		node_set_side (_tmp11_, _tmp10_);
#line 429 "Partitioner.c"
	} else {
		NodeSide _tmp12_ = 0;
		Node* _tmp13_;
#line 54 "../src/Partitioner.vala"
		if (side == 0) {
#line 54 "../src/Partitioner.vala"
			_tmp12_ = NODE_SIDE_TOP;
#line 437 "Partitioner.c"
		} else {
#line 54 "../src/Partitioner.vala"
			_tmp12_ = NODE_SIDE_BOTTOM;
#line 441 "Partitioner.c"
		}
#line 54 "../src/Partitioner.vala"
		_tmp13_ = self->priv->_node;
#line 54 "../src/Partitioner.vala"
		node_set_side (_tmp13_, _tmp12_);
#line 447 "Partitioner.c"
	}
#line 56 "../src/Partitioner.vala"
	_tmp14_ = orig_side;
#line 56 "../src/Partitioner.vala"
	_tmp15_ = self->priv->_node;
#line 56 "../src/Partitioner.vala"
	_tmp16_ = node_get_side (_tmp15_);
#line 56 "../src/Partitioner.vala"
	_tmp17_ = _tmp16_;
#line 56 "../src/Partitioner.vala"
	if (_tmp14_ != _tmp17_) {
#line 459 "Partitioner.c"
		Node* _tmp18_;
		Layout* _tmp19_;
		Layout* _tmp20_;
		Node* _tmp21_;
		Node* _tmp22_;
		NodeSide _tmp23_;
		NodeSide _tmp24_;
#line 57 "../src/Partitioner.vala"
		_tmp18_ = self->priv->_node;
#line 57 "../src/Partitioner.vala"
		_tmp19_ = node_get_layout (_tmp18_);
#line 57 "../src/Partitioner.vala"
		_tmp20_ = _tmp19_;
#line 57 "../src/Partitioner.vala"
		_tmp21_ = self->priv->_node;
#line 57 "../src/Partitioner.vala"
		_tmp22_ = self->priv->_node;
#line 57 "../src/Partitioner.vala"
		_tmp23_ = node_get_side (_tmp22_);
#line 57 "../src/Partitioner.vala"
		_tmp24_ = _tmp23_;
#line 57 "../src/Partitioner.vala"
		layout_propagate_side (_tmp20_, _tmp21_, _tmp24_);
#line 483 "Partitioner.c"
	}
#line 59 "../src/Partitioner.vala"
	_tmp25_ = self->priv->_node;
#line 59 "../src/Partitioner.vala"
	node_attach_init (_tmp25_, root, index);
#line 489 "Partitioner.c"
}


static void
part_node_class_init (PartNodeClass * klass)
{
#line 26 "../src/Partitioner.vala"
	part_node_parent_class = g_type_class_peek_parent (klass);
#line 26 "../src/Partitioner.vala"
	g_type_class_adjust_private_offset (klass, &PartNode_private_offset);
#line 26 "../src/Partitioner.vala"
	G_OBJECT_CLASS (klass)->finalize = part_node_finalize;
#line 502 "Partitioner.c"
}


static void
part_node_instance_init (PartNode * self)
{
#line 26 "../src/Partitioner.vala"
	self->priv = part_node_get_instance_private (self);
#line 28 "../src/Partitioner.vala"
	self->priv->_node = NULL;
#line 513 "Partitioner.c"
}


static void
part_node_finalize (GObject * obj)
{
	PartNode * self;
#line 26 "../src/Partitioner.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_PART_NODE, PartNode);
#line 28 "../src/Partitioner.vala"
	_g_object_unref0 (self->priv->_node);
#line 26 "../src/Partitioner.vala"
	G_OBJECT_CLASS (part_node_parent_class)->finalize (obj);
#line 527 "Partitioner.c"
}


GType
part_node_get_type (void)
{
	static volatile gsize part_node_type_id__volatile = 0;
	if (g_once_init_enter (&part_node_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PartNodeClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) part_node_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (PartNode), 0, (GInstanceInitFunc) part_node_instance_init, NULL };
		GType part_node_type_id;
		part_node_type_id = g_type_register_static (G_TYPE_OBJECT, "PartNode", &g_define_type_info, 0);
		PartNode_private_offset = g_type_add_instance_private (part_node_type_id, sizeof (PartNodePrivate));
		g_once_init_leave (&part_node_type_id__volatile, part_node_type_id);
	}
	return part_node_type_id__volatile;
}


Partitioner*
partitioner_construct (GType object_type)
{
	Partitioner * self = NULL;
#line 71 "../src/Partitioner.vala"
	self = (Partitioner*) g_object_new (object_type, NULL);
#line 71 "../src/Partitioner.vala"
	return self;
#line 554 "Partitioner.c"
}


Partitioner*
partitioner_new (void)
{
#line 71 "../src/Partitioner.vala"
	return partitioner_construct (TYPE_PARTITIONER);
#line 563 "Partitioner.c"
}


static gint
___lambda71_ (PartNode* a,
              PartNode* b)
{
	gint result = 0;
	gint _tmp0_ = 0;
	Node* _tmp1_;
	Node* _tmp2_;
	Node* _tmp3_;
	Node* _tmp4_;
	gboolean _tmp5_;
#line 82 "../src/Partitioner.vala"
	g_return_val_if_fail (a != NULL, 0);
#line 82 "../src/Partitioner.vala"
	g_return_val_if_fail (b != NULL, 0);
#line 83 "../src/Partitioner.vala"
	_tmp1_ = part_node_node (a);
#line 83 "../src/Partitioner.vala"
	_tmp2_ = _tmp1_;
#line 83 "../src/Partitioner.vala"
	_tmp3_ = part_node_node (b);
#line 83 "../src/Partitioner.vala"
	_tmp4_ = _tmp3_;
#line 83 "../src/Partitioner.vala"
	_tmp5_ = node_id (_tmp2_) < node_id (_tmp4_);
#line 83 "../src/Partitioner.vala"
	_g_object_unref0 (_tmp4_);
#line 83 "../src/Partitioner.vala"
	_g_object_unref0 (_tmp2_);
#line 83 "../src/Partitioner.vala"
	if (_tmp5_) {
#line 83 "../src/Partitioner.vala"
		_tmp0_ = 1;
#line 600 "Partitioner.c"
	} else {
#line 83 "../src/Partitioner.vala"
		_tmp0_ = -1;
#line 604 "Partitioner.c"
	}
#line 83 "../src/Partitioner.vala"
	result = _tmp0_;
#line 83 "../src/Partitioner.vala"
	return result;
#line 610 "Partitioner.c"
}


static gint
____lambda71__gcompare_func (gconstpointer a,
                             gconstpointer b)
{
	gint result;
	result = ___lambda71_ ((PartNode*) a, (PartNode*) b);
#line 82 "../src/Partitioner.vala"
	return result;
#line 622 "Partitioner.c"
}


static gint
___lambda72_ (PartNode* a,
              PartNode* b)
{
	gint result = 0;
	gint _tmp0_ = 0;
#line 85 "../src/Partitioner.vala"
	g_return_val_if_fail (a != NULL, 0);
#line 85 "../src/Partitioner.vala"
	g_return_val_if_fail (b != NULL, 0);
#line 86 "../src/Partitioner.vala"
	if (part_node_size (a) < part_node_size (b)) {
#line 86 "../src/Partitioner.vala"
		_tmp0_ = 1;
#line 640 "Partitioner.c"
	} else {
		gint _tmp1_ = 0;
#line 86 "../src/Partitioner.vala"
		if (part_node_size (a) == part_node_size (b)) {
#line 86 "../src/Partitioner.vala"
			_tmp1_ = 0;
#line 647 "Partitioner.c"
		} else {
#line 86 "../src/Partitioner.vala"
			_tmp1_ = -1;
#line 651 "Partitioner.c"
		}
#line 86 "../src/Partitioner.vala"
		_tmp0_ = _tmp1_;
#line 655 "Partitioner.c"
	}
#line 86 "../src/Partitioner.vala"
	result = _tmp0_;
#line 86 "../src/Partitioner.vala"
	return result;
#line 661 "Partitioner.c"
}


static gint
____lambda72__gcompare_func (gconstpointer a,
                             gconstpointer b)
{
	gint result;
	result = ___lambda72_ ((PartNode*) a, (PartNode*) b);
#line 85 "../src/Partitioner.vala"
	return result;
#line 673 "Partitioner.c"
}


static void
_g_object_unref0_ (gpointer var)
{
#line 75 "../src/Partitioner.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 682 "Partitioner.c"
}


static inline void
_g_slist_free__g_object_unref0_ (GSList* self)
{
#line 75 "../src/Partitioner.vala"
	g_slist_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 691 "Partitioner.c"
}


void
partitioner_partition_node (Partitioner* self,
                            Node* root)
{
	GArray* _tmp0_;
	GArray* _tmp1_;
	guint _tmp2_;
	gboolean _tmp3_;
#line 74 "../src/Partitioner.vala"
	g_return_if_fail (self != NULL);
#line 74 "../src/Partitioner.vala"
	g_return_if_fail (root != NULL);
#line 75 "../src/Partitioner.vala"
	_tmp0_ = node_children (root);
#line 75 "../src/Partitioner.vala"
	_tmp1_ = _tmp0_;
#line 75 "../src/Partitioner.vala"
	_tmp2_ = _tmp1_->len;
#line 75 "../src/Partitioner.vala"
	_tmp3_ = _tmp2_ > ((guint) 2);
#line 75 "../src/Partitioner.vala"
	_g_array_unref0 (_tmp1_);
#line 75 "../src/Partitioner.vala"
	if (_tmp3_) {
#line 719 "Partitioner.c"
		GSList* data = NULL;
		GCompareFunc pn_cmp1 = NULL;
		GCompareFunc pn_cmp2 = NULL;
		GCompareFunc _tmp21_;
		GCompareFunc _tmp22_;
		GSList* _tmp23_;
#line 76 "../src/Partitioner.vala"
		data = NULL;
#line 728 "Partitioner.c"
		{
			gint i = 0;
#line 77 "../src/Partitioner.vala"
			i = 0;
#line 733 "Partitioner.c"
			{
				gboolean _tmp4_ = FALSE;
#line 77 "../src/Partitioner.vala"
				_tmp4_ = TRUE;
#line 77 "../src/Partitioner.vala"
				while (TRUE) {
#line 740 "Partitioner.c"
					gint _tmp6_;
					GArray* _tmp7_;
					GArray* _tmp8_;
					guint _tmp9_;
					gboolean _tmp10_;
					Node* node = NULL;
					GArray* _tmp11_;
					GArray* _tmp12_;
					gint _tmp13_;
					Node* _tmp14_;
					Node* _tmp15_;
					Node* _tmp16_;
					PartNode* pn = NULL;
					Node* _tmp17_;
					PartNode* _tmp18_;
					PartNode* _tmp19_;
					PartNode* _tmp20_;
#line 77 "../src/Partitioner.vala"
					if (!_tmp4_) {
#line 760 "Partitioner.c"
						gint _tmp5_;
#line 77 "../src/Partitioner.vala"
						_tmp5_ = i;
#line 77 "../src/Partitioner.vala"
						i = _tmp5_ + 1;
#line 766 "Partitioner.c"
					}
#line 77 "../src/Partitioner.vala"
					_tmp4_ = FALSE;
#line 77 "../src/Partitioner.vala"
					_tmp6_ = i;
#line 77 "../src/Partitioner.vala"
					_tmp7_ = node_children (root);
#line 77 "../src/Partitioner.vala"
					_tmp8_ = _tmp7_;
#line 77 "../src/Partitioner.vala"
					_tmp9_ = _tmp8_->len;
#line 77 "../src/Partitioner.vala"
					_tmp10_ = !(((guint) _tmp6_) < _tmp9_);
#line 77 "../src/Partitioner.vala"
					_g_array_unref0 (_tmp8_);
#line 77 "../src/Partitioner.vala"
					if (_tmp10_) {
#line 77 "../src/Partitioner.vala"
						break;
#line 786 "Partitioner.c"
					}
#line 78 "../src/Partitioner.vala"
					_tmp11_ = node_children (root);
#line 78 "../src/Partitioner.vala"
					_tmp12_ = _tmp11_;
#line 78 "../src/Partitioner.vala"
					_tmp13_ = i;
#line 78 "../src/Partitioner.vala"
					_tmp14_ = g_array_index (_tmp12_, Node*, (guint) _tmp13_);
#line 78 "../src/Partitioner.vala"
					_tmp15_ = _g_object_ref0 (_tmp14_);
#line 78 "../src/Partitioner.vala"
					_tmp16_ = _tmp15_;
#line 78 "../src/Partitioner.vala"
					_g_array_unref0 (_tmp12_);
#line 78 "../src/Partitioner.vala"
					node = _tmp16_;
#line 79 "../src/Partitioner.vala"
					_tmp17_ = node;
#line 79 "../src/Partitioner.vala"
					_tmp18_ = part_node_new (_tmp17_);
#line 79 "../src/Partitioner.vala"
					pn = _tmp18_;
#line 80 "../src/Partitioner.vala"
					_tmp19_ = pn;
#line 80 "../src/Partitioner.vala"
					_tmp20_ = _g_object_ref0 (_tmp19_);
#line 80 "../src/Partitioner.vala"
					data = g_slist_append (data, _tmp20_);
#line 77 "../src/Partitioner.vala"
					_g_object_unref0 (pn);
#line 77 "../src/Partitioner.vala"
					_g_object_unref0 (node);
#line 820 "Partitioner.c"
				}
			}
		}
#line 82 "../src/Partitioner.vala"
		pn_cmp1 = ____lambda71__gcompare_func;
#line 85 "../src/Partitioner.vala"
		pn_cmp2 = ____lambda72__gcompare_func;
#line 88 "../src/Partitioner.vala"
		_tmp21_ = pn_cmp1;
#line 88 "../src/Partitioner.vala"
		data = g_slist_sort (data, _tmp21_);
#line 89 "../src/Partitioner.vala"
		_tmp22_ = pn_cmp2;
#line 89 "../src/Partitioner.vala"
		data = g_slist_sort (data, _tmp22_);
#line 90 "../src/Partitioner.vala"
		_tmp23_ = data;
#line 90 "../src/Partitioner.vala"
		partitioner_partition (self, root, _tmp23_);
#line 75 "../src/Partitioner.vala"
		(data == NULL) ? NULL : (data = (_g_slist_free__g_object_unref0_ (data), NULL));
#line 842 "Partitioner.c"
	}
}


static Block20Data*
block20_data_ref (Block20Data* _data20_)
{
#line 100 "../src/Partitioner.vala"
	g_atomic_int_inc (&_data20_->_ref_count_);
#line 100 "../src/Partitioner.vala"
	return _data20_;
#line 854 "Partitioner.c"
}


static void
block20_data_unref (void * _userdata_)
{
	Block20Data* _data20_;
	_data20_ = (Block20Data*) _userdata_;
#line 100 "../src/Partitioner.vala"
	if (g_atomic_int_dec_and_test (&_data20_->_ref_count_)) {
#line 865 "Partitioner.c"
		Partitioner* self;
#line 100 "../src/Partitioner.vala"
		self = _data20_->self;
#line 100 "../src/Partitioner.vala"
		_g_object_unref0 (_data20_->root);
#line 100 "../src/Partitioner.vala"
		_g_object_unref0 (self);
#line 100 "../src/Partitioner.vala"
		g_slice_free (Block20Data, _data20_);
#line 875 "Partitioner.c"
	}
}


static void
__lambda73_ (Partitioner* self,
             PartNode* item)
{
	Node* _tmp0_;
	Node* _tmp1_;
	Node* _tmp2_;
	Node* _tmp3_;
	NodeSide _tmp4_;
	NodeSide _tmp5_;
#line 107 "../src/Partitioner.vala"
	g_return_if_fail (item != NULL);
#line 108 "../src/Partitioner.vala"
	_tmp0_ = part_node_node (item);
#line 108 "../src/Partitioner.vala"
	_tmp1_ = _tmp0_;
#line 108 "../src/Partitioner.vala"
	_tmp2_ = part_node_node (item);
#line 108 "../src/Partitioner.vala"
	_tmp3_ = _tmp2_;
#line 108 "../src/Partitioner.vala"
	_tmp4_ = node_get_side (_tmp3_);
#line 108 "../src/Partitioner.vala"
	_tmp5_ = _tmp4_;
#line 108 "../src/Partitioner.vala"
	node_detach (_tmp1_, _tmp5_);
#line 108 "../src/Partitioner.vala"
	_g_object_unref0 (_tmp3_);
#line 108 "../src/Partitioner.vala"
	_g_object_unref0 (_tmp1_);
#line 910 "Partitioner.c"
}


static void
___lambda73__gfunc (gconstpointer data,
                    gpointer self)
{
#line 107 "../src/Partitioner.vala"
	__lambda73_ ((Partitioner*) self, (PartNode*) data);
#line 920 "Partitioner.c"
}


static void
__lambda74_ (Block20Data* _data20_,
             PartNode* item)
{
	Partitioner* self;
#line 112 "../src/Partitioner.vala"
	self = _data20_->self;
#line 112 "../src/Partitioner.vala"
	g_return_if_fail (item != NULL);
#line 113 "../src/Partitioner.vala"
	if (_data20_->sum0 < _data20_->sum1) {
#line 935 "Partitioner.c"
		gint _tmp0_;
#line 114 "../src/Partitioner.vala"
		_data20_->sum0 = _data20_->sum0 + part_node_size (item);
#line 115 "../src/Partitioner.vala"
		part_node_update_node (item, _data20_->root, _data20_->size0, 0);
#line 116 "../src/Partitioner.vala"
		_tmp0_ = _data20_->size0;
#line 116 "../src/Partitioner.vala"
		_data20_->size0 = _tmp0_ + 1;
#line 945 "Partitioner.c"
	} else {
#line 118 "../src/Partitioner.vala"
		_data20_->sum1 = _data20_->sum1 + part_node_size (item);
#line 119 "../src/Partitioner.vala"
		part_node_update_node (item, _data20_->root, -1, 1);
#line 951 "Partitioner.c"
	}
}


static void
___lambda74__gfunc (gconstpointer data,
                    gpointer self)
{
#line 112 "../src/Partitioner.vala"
	__lambda74_ (self, (PartNode*) data);
#line 962 "Partitioner.c"
}


static void
partitioner_real_partition (Partitioner* self,
                            Node* root,
                            GSList* data)
{
	Block20Data* _data20_;
	Node* _tmp0_;
#line 100 "../src/Partitioner.vala"
	g_return_if_fail (root != NULL);
#line 100 "../src/Partitioner.vala"
	_data20_ = g_slice_new0 (Block20Data);
#line 100 "../src/Partitioner.vala"
	_data20_->_ref_count_ = 1;
#line 100 "../src/Partitioner.vala"
	_data20_->self = g_object_ref (self);
#line 100 "../src/Partitioner.vala"
	_tmp0_ = _g_object_ref0 (root);
#line 100 "../src/Partitioner.vala"
	_g_object_unref0 (_data20_->root);
#line 100 "../src/Partitioner.vala"
	_data20_->root = _tmp0_;
#line 102 "../src/Partitioner.vala"
	_data20_->sum0 = (gdouble) 0;
#line 103 "../src/Partitioner.vala"
	_data20_->sum1 = (gdouble) 0;
#line 104 "../src/Partitioner.vala"
	_data20_->size0 = 0;
#line 107 "../src/Partitioner.vala"
	g_slist_foreach (data, ___lambda73__gfunc, self);
#line 112 "../src/Partitioner.vala"
	g_slist_foreach (data, ___lambda74__gfunc, _data20_);
#line 100 "../src/Partitioner.vala"
	block20_data_unref (_data20_);
#line 100 "../src/Partitioner.vala"
	_data20_ = NULL;
#line 1001 "Partitioner.c"
}


void
partitioner_partition (Partitioner* self,
                       Node* root,
                       GSList* data)
{
#line 100 "../src/Partitioner.vala"
	g_return_if_fail (self != NULL);
#line 100 "../src/Partitioner.vala"
	PARTITIONER_GET_CLASS (self)->partition (self, root, data);
#line 1014 "Partitioner.c"
}


static void
partitioner_class_init (PartitionerClass * klass)
{
#line 68 "../src/Partitioner.vala"
	partitioner_parent_class = g_type_class_peek_parent (klass);
#line 68 "../src/Partitioner.vala"
	((PartitionerClass *) klass)->partition = (void (*) (Partitioner*, Node*, GSList*)) partitioner_real_partition;
#line 1025 "Partitioner.c"
}


static void
partitioner_instance_init (Partitioner * self)
{
}


GType
partitioner_get_type (void)
{
	static volatile gsize partitioner_type_id__volatile = 0;
	if (g_once_init_enter (&partitioner_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (PartitionerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) partitioner_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Partitioner), 0, (GInstanceInitFunc) partitioner_instance_init, NULL };
		GType partitioner_type_id;
		partitioner_type_id = g_type_register_static (G_TYPE_OBJECT, "Partitioner", &g_define_type_info, 0);
		g_once_init_leave (&partitioner_type_id__volatile, partitioner_type_id);
	}
	return partitioner_type_id__volatile;
}



