/* Theme.c generated by valac 0.42.7, the Vala compiler
 * generated from Theme.vala, do not modify */

/*
* Copyright (c) 2018 (https://github.com/phase1geo/Minder)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Trevor Williams <phase1geo@gmail.com>
*/


#include <glib.h>
#include <glib-object.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>
#include <gtk/gtk.h>
#include <stdio.h>
#include <cairo.h>
#include <libxml/tree.h>
#include <pango/pango.h>
#include <float.h>
#include <math.h>
#include <pango/pangocairo.h>


#define TYPE_THEME (theme_get_type ())
#define THEME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THEME, Theme))
#define THEME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THEME, ThemeClass))
#define IS_THEME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THEME))
#define IS_THEME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THEME))
#define THEME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THEME, ThemeClass))

typedef struct _Theme Theme;
typedef struct _ThemeClass ThemeClass;
typedef struct _ThemePrivate ThemePrivate;
enum  {
	THEME_0_PROPERTY,
	THEME_NAME_PROPERTY,
	THEME_INDEX_PROPERTY,
	THEME_PREFER_DARK_PROPERTY,
	THEME_CUSTOM_PROPERTY,
	THEME_TEMPORARY_PROPERTY,
	THEME_NUM_PROPERTIES
};
static GParamSpec* theme_properties[THEME_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_array_unref0(var) ((var == NULL) ? NULL : (var = (g_array_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
#define __vala_PangoFontDescription_free0(var) ((var == NULL) ? NULL : (var = (_vala_PangoFontDescription_free (var), NULL)))
#define _cairo_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_destroy (var), NULL)))
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))

struct _Theme {
	GObject parent_instance;
	ThemePrivate * priv;
};

struct _ThemeClass {
	GObjectClass parent_class;
};

struct _ThemePrivate {
	GeeHashMap* _colors;
	gchar* _name;
	gint _index;
	gboolean _prefer_dark;
	gboolean _custom;
	gboolean _temporary;
};


static gint Theme_private_offset;
static gpointer theme_parent_class = NULL;

GType theme_get_type (void) G_GNUC_CONST;
Theme* theme_new (void);
Theme* theme_construct (GType object_type);
static GdkRGBA* _gdk_rgba_dup (GdkRGBA* self);
Theme* theme_new_from_theme (Theme* theme);
Theme* theme_construct_from_theme (GType object_type,
                                   Theme* theme);
void theme_copy (Theme* self,
                 Theme* theme);
const gchar* theme_get_name (Theme* self);
void theme_set_name (Theme* self,
                     const gchar* value);
gint theme_get_index (Theme* self);
void theme_set_index (Theme* self,
                      gint value);
gboolean theme_get_prefer_dark (Theme* self);
void theme_set_prefer_dark (Theme* self,
                            gboolean value);
gboolean theme_get_custom (Theme* self);
void theme_set_custom (Theme* self,
                       gboolean value);
gboolean theme_get_temporary (Theme* self);
void theme_set_temporary (Theme* self,
                          gboolean value);
GArray* theme_colors (Theme* self);
static void _g_free0_ (gpointer var);
static void _vala_gchar_free_function_content_of (gpointer data);
gboolean theme_matches (Theme* self,
                        Theme* theme);
gboolean theme_set_color (Theme* self,
                          const gchar* name,
                          GdkRGBA* color);
GdkRGBA* theme_get_color (Theme* self,
                          const gchar* name);
GdkRGBA* theme_next_color (Theme* self);
void theme_link_color (Theme* self,
                       gint index,
                       GdkRGBA* result);
gint theme_num_link_colors (void);
gint theme_get_color_index (Theme* self,
                            GdkRGBA* color);
void theme_color_from_string (Theme* self,
                              const gchar* value,
                              GdkRGBA* result);
GtkCssProvider* theme_get_css_provider (Theme* self);
static void theme_set_context_color (Theme* self,
                              cairo_t* ctx,
                              GdkRGBA* color);
void theme_load (Theme* self,
                 xmlNode* n);
xmlNode* theme_save (Theme* self);
gchar* utils_color_from_rgba (GdkRGBA* rgba);
cairo_surface_t* theme_make_icon (Theme* self);
void connection_draw_arrow (cairo_t* ctx,
                            gint line_width,
                            gdouble tipx,
                            gdouble tipy,
                            gdouble tailx,
                            gdouble taily,
                            gdouble arrowLength);
static void _vala_PangoFontDescription_free (PangoFontDescription* self);
static void theme_finalize (GObject * obj);
static void _vala_theme_get_property (GObject * object,
                               guint property_id,
                               GValue * value,
                               GParamSpec * pspec);
static void _vala_theme_set_property (GObject * object,
                               guint property_id,
                               const GValue * value,
                               GParamSpec * pspec);


static inline gpointer
theme_get_instance_private (Theme* self)
{
	return G_STRUCT_MEMBER_P (self, Theme_private_offset);
}


static GdkRGBA*
_gdk_rgba_dup (GdkRGBA* self)
{
	GdkRGBA* dup;
#line 38 "../src/Theme.vala"
	dup = g_new0 (GdkRGBA, 1);
#line 38 "../src/Theme.vala"
	memcpy (dup, self, sizeof (GdkRGBA));
#line 38 "../src/Theme.vala"
	return dup;
#line 182 "Theme.c"
}


Theme*
theme_construct (GType object_type)
{
	Theme * self = NULL;
	GeeHashMap* _tmp0_;
	GeeHashMap* _tmp1_;
	GeeHashMap* _tmp2_;
	GeeHashMap* _tmp3_;
	GeeHashMap* _tmp4_;
	GeeHashMap* _tmp5_;
	GeeHashMap* _tmp6_;
	GeeHashMap* _tmp7_;
	GeeHashMap* _tmp8_;
	GeeHashMap* _tmp9_;
	GeeHashMap* _tmp10_;
	GeeHashMap* _tmp11_;
	GeeHashMap* _tmp12_;
	GeeHashMap* _tmp13_;
	GeeHashMap* _tmp14_;
	GeeHashMap* _tmp15_;
	GeeHashMap* _tmp16_;
	GeeHashMap* _tmp17_;
	GeeHashMap* _tmp18_;
	GeeHashMap* _tmp19_;
#line 37 "../src/Theme.vala"
	self = (Theme*) g_object_new (object_type, NULL);
#line 38 "../src/Theme.vala"
	_tmp0_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, gdk_rgba_get_type (), (GBoxedCopyFunc) _gdk_rgba_dup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 38 "../src/Theme.vala"
	_g_object_unref0 (self->priv->_colors);
#line 38 "../src/Theme.vala"
	self->priv->_colors = _tmp0_;
#line 39 "../src/Theme.vala"
	_tmp1_ = self->priv->_colors;
#line 39 "../src/Theme.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp1_, "background", NULL);
#line 40 "../src/Theme.vala"
	_tmp2_ = self->priv->_colors;
#line 40 "../src/Theme.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp2_, "foreground", NULL);
#line 41 "../src/Theme.vala"
	_tmp3_ = self->priv->_colors;
#line 41 "../src/Theme.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp3_, "root_background", NULL);
#line 42 "../src/Theme.vala"
	_tmp4_ = self->priv->_colors;
#line 42 "../src/Theme.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp4_, "root_foreground", NULL);
#line 43 "../src/Theme.vala"
	_tmp5_ = self->priv->_colors;
#line 43 "../src/Theme.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp5_, "nodesel_background", NULL);
#line 44 "../src/Theme.vala"
	_tmp6_ = self->priv->_colors;
#line 44 "../src/Theme.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp6_, "nodesel_foreground", NULL);
#line 45 "../src/Theme.vala"
	_tmp7_ = self->priv->_colors;
#line 45 "../src/Theme.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp7_, "textsel_background", NULL);
#line 46 "../src/Theme.vala"
	_tmp8_ = self->priv->_colors;
#line 46 "../src/Theme.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp8_, "textsel_foreground", NULL);
#line 47 "../src/Theme.vala"
	_tmp9_ = self->priv->_colors;
#line 47 "../src/Theme.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp9_, "text_cursor", NULL);
#line 48 "../src/Theme.vala"
	_tmp10_ = self->priv->_colors;
#line 48 "../src/Theme.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp10_, "attachable", NULL);
#line 49 "../src/Theme.vala"
	_tmp11_ = self->priv->_colors;
#line 49 "../src/Theme.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp11_, "connection", NULL);
#line 50 "../src/Theme.vala"
	_tmp12_ = self->priv->_colors;
#line 50 "../src/Theme.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp12_, "link_color0", NULL);
#line 51 "../src/Theme.vala"
	_tmp13_ = self->priv->_colors;
#line 51 "../src/Theme.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp13_, "link_color1", NULL);
#line 52 "../src/Theme.vala"
	_tmp14_ = self->priv->_colors;
#line 52 "../src/Theme.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp14_, "link_color2", NULL);
#line 53 "../src/Theme.vala"
	_tmp15_ = self->priv->_colors;
#line 53 "../src/Theme.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp15_, "link_color3", NULL);
#line 54 "../src/Theme.vala"
	_tmp16_ = self->priv->_colors;
#line 54 "../src/Theme.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp16_, "link_color4", NULL);
#line 55 "../src/Theme.vala"
	_tmp17_ = self->priv->_colors;
#line 55 "../src/Theme.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp17_, "link_color5", NULL);
#line 56 "../src/Theme.vala"
	_tmp18_ = self->priv->_colors;
#line 56 "../src/Theme.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp18_, "link_color6", NULL);
#line 57 "../src/Theme.vala"
	_tmp19_ = self->priv->_colors;
#line 57 "../src/Theme.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _tmp19_, "link_color7", NULL);
#line 37 "../src/Theme.vala"
	return self;
#line 296 "Theme.c"
}


Theme*
theme_new (void)
{
#line 37 "../src/Theme.vala"
	return theme_construct (TYPE_THEME);
#line 305 "Theme.c"
}


Theme*
theme_construct_from_theme (GType object_type,
                            Theme* theme)
{
	Theme * self = NULL;
#line 61 "../src/Theme.vala"
	g_return_val_if_fail (theme != NULL, NULL);
#line 61 "../src/Theme.vala"
	self = (Theme*) g_object_new (object_type, NULL);
#line 62 "../src/Theme.vala"
	theme_copy (self, theme);
#line 61 "../src/Theme.vala"
	return self;
#line 322 "Theme.c"
}


Theme*
theme_new_from_theme (Theme* theme)
{
#line 61 "../src/Theme.vala"
	return theme_construct_from_theme (TYPE_THEME, theme);
#line 331 "Theme.c"
}


void
theme_copy (Theme* self,
            Theme* theme)
{
	const gchar* _tmp0_;
	gint _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_;
	GeeHashMap* _tmp5_;
	GeeMapIterator* it = NULL;
	GeeHashMap* _tmp6_;
	GeeMapIterator* _tmp7_;
#line 66 "../src/Theme.vala"
	g_return_if_fail (self != NULL);
#line 66 "../src/Theme.vala"
	g_return_if_fail (theme != NULL);
#line 67 "../src/Theme.vala"
	_tmp0_ = theme->priv->_name;
#line 67 "../src/Theme.vala"
	theme_set_name (self, _tmp0_);
#line 68 "../src/Theme.vala"
	_tmp1_ = theme->priv->_index;
#line 68 "../src/Theme.vala"
	theme_set_index (self, _tmp1_);
#line 69 "../src/Theme.vala"
	_tmp2_ = theme->priv->_prefer_dark;
#line 69 "../src/Theme.vala"
	theme_set_prefer_dark (self, _tmp2_);
#line 70 "../src/Theme.vala"
	_tmp3_ = theme->priv->_custom;
#line 70 "../src/Theme.vala"
	theme_set_custom (self, _tmp3_);
#line 71 "../src/Theme.vala"
	_tmp4_ = theme->priv->_temporary;
#line 71 "../src/Theme.vala"
	theme_set_temporary (self, _tmp4_);
#line 72 "../src/Theme.vala"
	_tmp5_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, gdk_rgba_get_type (), (GBoxedCopyFunc) _gdk_rgba_dup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 72 "../src/Theme.vala"
	_g_object_unref0 (self->priv->_colors);
#line 72 "../src/Theme.vala"
	self->priv->_colors = _tmp5_;
#line 73 "../src/Theme.vala"
	_tmp6_ = theme->priv->_colors;
#line 73 "../src/Theme.vala"
	_tmp7_ = gee_abstract_map_map_iterator ((GeeAbstractMap*) _tmp6_);
#line 73 "../src/Theme.vala"
	it = _tmp7_;
#line 74 "../src/Theme.vala"
	while (TRUE) {
#line 386 "Theme.c"
		GeeMapIterator* _tmp8_;
		GeeHashMap* _tmp9_;
		GeeMapIterator* _tmp10_;
		gpointer _tmp11_;
		gchar* _tmp12_;
		GeeMapIterator* _tmp13_;
		gpointer _tmp14_;
		GdkRGBA _tmp15_;
#line 74 "../src/Theme.vala"
		_tmp8_ = it;
#line 74 "../src/Theme.vala"
		if (!gee_map_iterator_next (_tmp8_)) {
#line 74 "../src/Theme.vala"
			break;
#line 401 "Theme.c"
		}
#line 75 "../src/Theme.vala"
		_tmp9_ = self->priv->_colors;
#line 75 "../src/Theme.vala"
		_tmp10_ = it;
#line 75 "../src/Theme.vala"
		_tmp11_ = gee_map_iterator_get_key (_tmp10_);
#line 75 "../src/Theme.vala"
		_tmp12_ = (gchar*) ((gchar*) _tmp11_);
#line 75 "../src/Theme.vala"
		_tmp13_ = it;
#line 75 "../src/Theme.vala"
		_tmp14_ = gee_map_iterator_get_value (_tmp13_);
#line 75 "../src/Theme.vala"
		_tmp15_ = (GdkRGBA) (*((GdkRGBA*) _tmp14_));
#line 75 "../src/Theme.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp9_, _tmp12_, &_tmp15_);
#line 75 "../src/Theme.vala"
		_g_free0 (_tmp12_);
#line 421 "Theme.c"
	}
#line 66 "../src/Theme.vala"
	_g_object_unref0 (it);
#line 425 "Theme.c"
}


static void
_g_free0_ (gpointer var)
{
#line 81 "../src/Theme.vala"
	var = (g_free (var), NULL);
#line 434 "Theme.c"
}


static void
_vala_gchar_free_function_content_of (gpointer data)
{
	gchar* self;
#line 81 "../src/Theme.vala"
	self = *((gchar**) data);
#line 81 "../src/Theme.vala"
	_g_free0_ (self);
#line 446 "Theme.c"
}


GArray*
theme_colors (Theme* self)
{
	GArray* result = NULL;
	GArray* cs = NULL;
	GArray* _tmp0_;
	GeeMapIterator* it = NULL;
	GeeHashMap* _tmp1_;
	GeeMapIterator* _tmp2_;
#line 80 "../src/Theme.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 81 "../src/Theme.vala"
	_tmp0_ = g_array_new (TRUE, TRUE, sizeof (gchar*));
#line 81 "../src/Theme.vala"
	g_array_set_clear_func (_tmp0_, _vala_gchar_free_function_content_of);
#line 81 "../src/Theme.vala"
	cs = _tmp0_;
#line 82 "../src/Theme.vala"
	_tmp1_ = self->priv->_colors;
#line 82 "../src/Theme.vala"
	_tmp2_ = gee_abstract_map_map_iterator ((GeeAbstractMap*) _tmp1_);
#line 82 "../src/Theme.vala"
	it = _tmp2_;
#line 83 "../src/Theme.vala"
	while (TRUE) {
#line 475 "Theme.c"
		GeeMapIterator* _tmp3_;
		gchar* name = NULL;
		GeeMapIterator* _tmp4_;
		gpointer _tmp5_;
		GArray* _tmp6_;
		const gchar* _tmp7_;
		gchar* _tmp8_;
#line 83 "../src/Theme.vala"
		_tmp3_ = it;
#line 83 "../src/Theme.vala"
		if (!gee_map_iterator_next (_tmp3_)) {
#line 83 "../src/Theme.vala"
			break;
#line 489 "Theme.c"
		}
#line 84 "../src/Theme.vala"
		_tmp4_ = it;
#line 84 "../src/Theme.vala"
		_tmp5_ = gee_map_iterator_get_key (_tmp4_);
#line 84 "../src/Theme.vala"
		name = (gchar*) ((gchar*) _tmp5_);
#line 85 "../src/Theme.vala"
		_tmp6_ = cs;
#line 85 "../src/Theme.vala"
		_tmp7_ = name;
#line 85 "../src/Theme.vala"
		_tmp8_ = g_strdup (_tmp7_);
#line 85 "../src/Theme.vala"
		g_array_append_val (_tmp6_, _tmp8_);
#line 83 "../src/Theme.vala"
		_g_free0 (name);
#line 507 "Theme.c"
	}
#line 87 "../src/Theme.vala"
	result = cs;
#line 87 "../src/Theme.vala"
	_g_object_unref0 (it);
#line 87 "../src/Theme.vala"
	return result;
#line 515 "Theme.c"
}


gboolean
theme_matches (Theme* self,
               Theme* theme)
{
	gboolean result = FALSE;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
#line 91 "../src/Theme.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 91 "../src/Theme.vala"
	g_return_val_if_fail (theme != NULL, FALSE);
#line 92 "../src/Theme.vala"
	_tmp0_ = self->priv->_name;
#line 92 "../src/Theme.vala"
	_tmp1_ = theme->priv->_name;
#line 92 "../src/Theme.vala"
	if (g_strcmp0 (_tmp0_, _tmp1_) == 0) {
#line 536 "Theme.c"
		gboolean _tmp2_;
#line 93 "../src/Theme.vala"
		_tmp2_ = self->priv->_custom;
#line 93 "../src/Theme.vala"
		if (_tmp2_) {
#line 542 "Theme.c"
			GeeMapIterator* it = NULL;
			GeeHashMap* _tmp3_;
			GeeMapIterator* _tmp4_;
			gboolean _tmp19_;
			gboolean _tmp20_;
#line 94 "../src/Theme.vala"
			_tmp3_ = self->priv->_colors;
#line 94 "../src/Theme.vala"
			_tmp4_ = gee_abstract_map_map_iterator ((GeeAbstractMap*) _tmp3_);
#line 94 "../src/Theme.vala"
			it = _tmp4_;
#line 95 "../src/Theme.vala"
			while (TRUE) {
#line 556 "Theme.c"
				GeeMapIterator* _tmp5_;
				gchar* key = NULL;
				GeeMapIterator* _tmp6_;
				gpointer _tmp7_;
				GeeHashMap* _tmp8_;
				const gchar* _tmp9_;
				gpointer _tmp10_;
				GdkRGBA* _tmp11_;
				GeeHashMap* _tmp12_;
				const gchar* _tmp13_;
				gpointer _tmp14_;
				GdkRGBA* _tmp15_;
				GdkRGBA _tmp16_;
				GdkRGBA _tmp17_;
				gboolean _tmp18_;
#line 95 "../src/Theme.vala"
				_tmp5_ = it;
#line 95 "../src/Theme.vala"
				if (!gee_map_iterator_next (_tmp5_)) {
#line 95 "../src/Theme.vala"
					break;
#line 578 "Theme.c"
				}
#line 96 "../src/Theme.vala"
				_tmp6_ = it;
#line 96 "../src/Theme.vala"
				_tmp7_ = gee_map_iterator_get_key (_tmp6_);
#line 96 "../src/Theme.vala"
				key = (gchar*) _tmp7_;
#line 97 "../src/Theme.vala"
				_tmp8_ = self->priv->_colors;
#line 97 "../src/Theme.vala"
				_tmp9_ = key;
#line 97 "../src/Theme.vala"
				_tmp10_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp8_, _tmp9_);
#line 97 "../src/Theme.vala"
				_tmp11_ = (GdkRGBA*) _tmp10_;
#line 97 "../src/Theme.vala"
				_tmp12_ = theme->priv->_colors;
#line 97 "../src/Theme.vala"
				_tmp13_ = key;
#line 97 "../src/Theme.vala"
				_tmp14_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp12_, _tmp13_);
#line 97 "../src/Theme.vala"
				_tmp15_ = (GdkRGBA*) _tmp14_;
#line 97 "../src/Theme.vala"
				_tmp16_ = *_tmp11_;
#line 97 "../src/Theme.vala"
				_tmp17_ = *_tmp15_;
#line 97 "../src/Theme.vala"
				_tmp18_ = !gdk_rgba_equal (&_tmp16_, &_tmp17_);
#line 97 "../src/Theme.vala"
				_g_free0 (_tmp15_);
#line 97 "../src/Theme.vala"
				_g_free0 (_tmp11_);
#line 97 "../src/Theme.vala"
				if (_tmp18_) {
#line 98 "../src/Theme.vala"
					result = FALSE;
#line 98 "../src/Theme.vala"
					_g_free0 (key);
#line 98 "../src/Theme.vala"
					_g_object_unref0 (it);
#line 98 "../src/Theme.vala"
					return result;
#line 622 "Theme.c"
				}
#line 95 "../src/Theme.vala"
				_g_free0 (key);
#line 626 "Theme.c"
			}
#line 101 "../src/Theme.vala"
			_tmp19_ = self->priv->_prefer_dark;
#line 101 "../src/Theme.vala"
			_tmp20_ = theme->priv->_prefer_dark;
#line 101 "../src/Theme.vala"
			result = _tmp19_ == _tmp20_;
#line 101 "../src/Theme.vala"
			_g_object_unref0 (it);
#line 101 "../src/Theme.vala"
			return result;
#line 638 "Theme.c"
		}
#line 103 "../src/Theme.vala"
		result = TRUE;
#line 103 "../src/Theme.vala"
		return result;
#line 644 "Theme.c"
	}
#line 105 "../src/Theme.vala"
	result = FALSE;
#line 105 "../src/Theme.vala"
	return result;
#line 650 "Theme.c"
}


gboolean
theme_set_color (Theme* self,
                 const gchar* name,
                 GdkRGBA* color)
{
	gboolean result = FALSE;
	GeeHashMap* _tmp0_;
#line 109 "../src/Theme.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 109 "../src/Theme.vala"
	g_return_val_if_fail (name != NULL, FALSE);
#line 109 "../src/Theme.vala"
	g_return_val_if_fail (color != NULL, FALSE);
#line 110 "../src/Theme.vala"
	_tmp0_ = self->priv->_colors;
#line 110 "../src/Theme.vala"
	if (gee_abstract_map_has_key ((GeeAbstractMap*) _tmp0_, name)) {
#line 671 "Theme.c"
		GeeHashMap* _tmp1_;
		GdkRGBA _tmp2_;
#line 111 "../src/Theme.vala"
		_tmp1_ = self->priv->_colors;
#line 111 "../src/Theme.vala"
		_tmp2_ = *color;
#line 111 "../src/Theme.vala"
		gee_abstract_map_set ((GeeAbstractMap*) _tmp1_, name, &_tmp2_);
#line 112 "../src/Theme.vala"
		result = TRUE;
#line 112 "../src/Theme.vala"
		return result;
#line 684 "Theme.c"
	}
#line 114 "../src/Theme.vala"
	result = FALSE;
#line 114 "../src/Theme.vala"
	return result;
#line 690 "Theme.c"
}


GdkRGBA*
theme_get_color (Theme* self,
                 const gchar* name)
{
	GdkRGBA* result = NULL;
	GeeHashMap* _tmp0_;
#line 118 "../src/Theme.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 118 "../src/Theme.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 119 "../src/Theme.vala"
	_tmp0_ = self->priv->_colors;
#line 119 "../src/Theme.vala"
	if (gee_abstract_map_has_key ((GeeAbstractMap*) _tmp0_, name)) {
#line 708 "Theme.c"
		GeeHashMap* _tmp1_;
		gpointer _tmp2_;
#line 120 "../src/Theme.vala"
		_tmp1_ = self->priv->_colors;
#line 120 "../src/Theme.vala"
		_tmp2_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp1_, name);
#line 120 "../src/Theme.vala"
		result = (GdkRGBA*) _tmp2_;
#line 120 "../src/Theme.vala"
		return result;
#line 719 "Theme.c"
	}
#line 122 "../src/Theme.vala"
	result = NULL;
#line 122 "../src/Theme.vala"
	return result;
#line 725 "Theme.c"
}


static gpointer
__gdk_rgba_dup0 (gpointer self)
{
#line 127 "../src/Theme.vala"
	return self ? _gdk_rgba_dup (self) : NULL;
#line 734 "Theme.c"
}


GdkRGBA*
theme_next_color (Theme* self)
{
	GdkRGBA* result = NULL;
	gint _tmp0_;
	GdkRGBA _tmp1_ = {0};
	GdkRGBA* _tmp2_;
#line 126 "../src/Theme.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 127 "../src/Theme.vala"
	_tmp0_ = self->priv->_index;
#line 127 "../src/Theme.vala"
	theme_set_index (self, _tmp0_ + 1);
#line 127 "../src/Theme.vala"
	theme_link_color (self, _tmp0_ % 8, &_tmp1_);
#line 127 "../src/Theme.vala"
	_tmp2_ = __gdk_rgba_dup0 (&_tmp1_);
#line 127 "../src/Theme.vala"
	result = _tmp2_;
#line 127 "../src/Theme.vala"
	return result;
#line 759 "Theme.c"
}


gint
theme_num_link_colors (void)
{
	gint result = 0;
#line 132 "../src/Theme.vala"
	result = 8;
#line 132 "../src/Theme.vala"
	return result;
#line 771 "Theme.c"
}


void
theme_link_color (Theme* self,
                  gint index,
                  GdkRGBA* result)
{
	GeeHashMap* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gpointer _tmp3_;
	GdkRGBA* _tmp4_;
	GdkRGBA _tmp5_;
#line 136 "../src/Theme.vala"
	g_return_if_fail (self != NULL);
#line 137 "../src/Theme.vala"
	_tmp0_ = self->priv->_colors;
#line 137 "../src/Theme.vala"
	_tmp1_ = g_strdup_printf ("link_color%d", index % 8);
#line 137 "../src/Theme.vala"
	_tmp2_ = _tmp1_;
#line 137 "../src/Theme.vala"
	_tmp3_ = gee_abstract_map_get ((GeeAbstractMap*) _tmp0_, _tmp2_);
#line 137 "../src/Theme.vala"
	_tmp4_ = (GdkRGBA*) _tmp3_;
#line 137 "../src/Theme.vala"
	_tmp5_ = *_tmp4_;
#line 137 "../src/Theme.vala"
	_g_free0 (_tmp4_);
#line 137 "../src/Theme.vala"
	_g_free0 (_tmp2_);
#line 137 "../src/Theme.vala"
	*result = _tmp5_;
#line 137 "../src/Theme.vala"
	return;
#line 808 "Theme.c"
}


gint
theme_get_color_index (Theme* self,
                       GdkRGBA* color)
{
	gint result = 0;
	gchar* color_str = NULL;
	gchar* _tmp0_;
#line 145 "../src/Theme.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 145 "../src/Theme.vala"
	g_return_val_if_fail (color != NULL, 0);
#line 146 "../src/Theme.vala"
	_tmp0_ = gdk_rgba_to_string (color);
#line 146 "../src/Theme.vala"
	color_str = _tmp0_;
#line 827 "Theme.c"
	{
		gint i = 0;
#line 147 "../src/Theme.vala"
		i = 0;
#line 832 "Theme.c"
		{
			gboolean _tmp1_ = FALSE;
#line 147 "../src/Theme.vala"
			_tmp1_ = TRUE;
#line 147 "../src/Theme.vala"
			while (TRUE) {
#line 839 "Theme.c"
				gint _tmp3_;
				GdkRGBA* lc = NULL;
				gint _tmp4_;
				GdkRGBA _tmp5_ = {0};
				GdkRGBA* _tmp6_;
				gboolean _tmp7_ = FALSE;
				GdkRGBA* _tmp8_;
#line 147 "../src/Theme.vala"
				if (!_tmp1_) {
#line 849 "Theme.c"
					gint _tmp2_;
#line 147 "../src/Theme.vala"
					_tmp2_ = i;
#line 147 "../src/Theme.vala"
					i = _tmp2_ + 1;
#line 855 "Theme.c"
				}
#line 147 "../src/Theme.vala"
				_tmp1_ = FALSE;
#line 147 "../src/Theme.vala"
				_tmp3_ = i;
#line 147 "../src/Theme.vala"
				if (!(_tmp3_ < 8)) {
#line 147 "../src/Theme.vala"
					break;
#line 865 "Theme.c"
				}
#line 148 "../src/Theme.vala"
				_tmp4_ = i;
#line 148 "../src/Theme.vala"
				theme_link_color (self, _tmp4_, &_tmp5_);
#line 148 "../src/Theme.vala"
				_tmp6_ = __gdk_rgba_dup0 (&_tmp5_);
#line 148 "../src/Theme.vala"
				lc = _tmp6_;
#line 149 "../src/Theme.vala"
				_tmp8_ = lc;
#line 149 "../src/Theme.vala"
				if (_tmp8_ != NULL) {
#line 879 "Theme.c"
					GdkRGBA* _tmp9_;
					gchar* _tmp10_;
					gchar* _tmp11_;
					const gchar* _tmp12_;
#line 149 "../src/Theme.vala"
					_tmp9_ = lc;
#line 149 "../src/Theme.vala"
					_tmp10_ = gdk_rgba_to_string (_tmp9_);
#line 149 "../src/Theme.vala"
					_tmp11_ = _tmp10_;
#line 149 "../src/Theme.vala"
					_tmp12_ = color_str;
#line 149 "../src/Theme.vala"
					_tmp7_ = g_strcmp0 (_tmp11_, _tmp12_) == 0;
#line 149 "../src/Theme.vala"
					_g_free0 (_tmp11_);
#line 896 "Theme.c"
				} else {
#line 149 "../src/Theme.vala"
					_tmp7_ = FALSE;
#line 900 "Theme.c"
				}
#line 149 "../src/Theme.vala"
				if (_tmp7_) {
#line 150 "../src/Theme.vala"
					result = i;
#line 150 "../src/Theme.vala"
					_g_free0 (lc);
#line 150 "../src/Theme.vala"
					_g_free0 (color_str);
#line 150 "../src/Theme.vala"
					return result;
#line 912 "Theme.c"
				}
#line 147 "../src/Theme.vala"
				_g_free0 (lc);
#line 916 "Theme.c"
			}
		}
	}
#line 153 "../src/Theme.vala"
	result = -1;
#line 153 "../src/Theme.vala"
	_g_free0 (color_str);
#line 153 "../src/Theme.vala"
	return result;
#line 926 "Theme.c"
}


void
theme_color_from_string (Theme* self,
                         const gchar* value,
                         GdkRGBA* result)
{
	GdkRGBA c = {0};
	GdkRGBA _tmp0_ = {0};
#line 157 "../src/Theme.vala"
	g_return_if_fail (self != NULL);
#line 157 "../src/Theme.vala"
	g_return_if_fail (value != NULL);
#line 158 "../src/Theme.vala"
	_tmp0_.red = 1.0;
#line 158 "../src/Theme.vala"
	_tmp0_.green = 1.0;
#line 158 "../src/Theme.vala"
	_tmp0_.blue = 1.0;
#line 158 "../src/Theme.vala"
	_tmp0_.alpha = 1.0;
#line 158 "../src/Theme.vala"
	c = _tmp0_;
#line 159 "../src/Theme.vala"
	gdk_rgba_parse (&c, value);
#line 160 "../src/Theme.vala"
	*result = c;
#line 160 "../src/Theme.vala"
	return;
#line 957 "Theme.c"
}


GtkCssProvider*
theme_get_css_provider (Theme* self)
{
	GtkCssProvider* result = NULL;
	GtkCssProvider* provider = NULL;
	GtkCssProvider* _tmp0_;
	GError* _inner_error0_ = NULL;
#line 164 "../src/Theme.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 165 "../src/Theme.vala"
	_tmp0_ = gtk_css_provider_new ();
#line 165 "../src/Theme.vala"
	provider = _tmp0_;
#line 974 "Theme.c"
	{
		gchar* css_data = NULL;
		GdkRGBA* _tmp1_;
		GdkRGBA* _tmp2_;
		gchar* _tmp3_;
		gchar* _tmp4_;
		gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
		gchar* _tmp8_;
#line 167 "../src/Theme.vala"
		_tmp1_ = theme_get_color (self, "background");
#line 167 "../src/Theme.vala"
		_tmp2_ = _tmp1_;
#line 167 "../src/Theme.vala"
		_tmp3_ = gdk_rgba_to_string (_tmp2_);
#line 167 "../src/Theme.vala"
		_tmp4_ = _tmp3_;
#line 167 "../src/Theme.vala"
		_tmp5_ = g_strconcat ("@define-color colorPrimary #603461; " "@define-color textColorPrimary @SILVER_100; " "@define-color colorAccent #603461; " ".theme-selected { background: #087DFF; } " ".canvas { background: ", _tmp4_, NULL);
#line 167 "../src/Theme.vala"
		_tmp6_ = _tmp5_;
#line 167 "../src/Theme.vala"
		_tmp7_ = g_strconcat (_tmp6_, "; }", NULL);
#line 167 "../src/Theme.vala"
		_tmp8_ = _tmp7_;
#line 167 "../src/Theme.vala"
		_g_free0 (_tmp6_);
#line 167 "../src/Theme.vala"
		_g_free0 (_tmp4_);
#line 167 "../src/Theme.vala"
		_g_free0 (_tmp2_);
#line 167 "../src/Theme.vala"
		css_data = _tmp8_;
#line 172 "../src/Theme.vala"
		gtk_css_provider_load_from_data (provider, css_data, (gssize) -1, &_inner_error0_);
#line 172 "../src/Theme.vala"
		if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 172 "../src/Theme.vala"
			_g_free0 (css_data);
#line 1015 "Theme.c"
			goto __catch28_g_error;
		}
#line 166 "../src/Theme.vala"
		_g_free0 (css_data);
#line 1020 "Theme.c"
	}
	goto __finally28;
	__catch28_g_error:
	{
		GError* e = NULL;
		FILE* _tmp9_;
		GError* _tmp10_;
		const gchar* _tmp11_;
#line 166 "../src/Theme.vala"
		e = _inner_error0_;
#line 166 "../src/Theme.vala"
		_inner_error0_ = NULL;
#line 174 "../src/Theme.vala"
		_tmp9_ = stdout;
#line 174 "../src/Theme.vala"
		_tmp10_ = e;
#line 174 "../src/Theme.vala"
		_tmp11_ = _tmp10_->message;
#line 174 "../src/Theme.vala"
		fprintf (_tmp9_, "Unable to load background color: %s", _tmp11_);
#line 166 "../src/Theme.vala"
		_g_error_free0 (e);
#line 1043 "Theme.c"
	}
	__finally28:
#line 166 "../src/Theme.vala"
	if (G_UNLIKELY (_inner_error0_ != NULL)) {
#line 166 "../src/Theme.vala"
		_g_object_unref0 (provider);
#line 166 "../src/Theme.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error0_->message, g_quark_to_string (_inner_error0_->domain), _inner_error0_->code);
#line 166 "../src/Theme.vala"
		g_clear_error (&_inner_error0_);
#line 166 "../src/Theme.vala"
		return NULL;
#line 1056 "Theme.c"
	}
#line 176 "../src/Theme.vala"
	result = provider;
#line 176 "../src/Theme.vala"
	return result;
#line 1062 "Theme.c"
}


static void
theme_set_context_color (Theme* self,
                         cairo_t* ctx,
                         GdkRGBA* color)
{
	GdkRGBA _tmp0_;
	gdouble _tmp1_;
	GdkRGBA _tmp2_;
	gdouble _tmp3_;
	GdkRGBA _tmp4_;
	gdouble _tmp5_;
	GdkRGBA _tmp6_;
	gdouble _tmp7_;
#line 180 "../src/Theme.vala"
	g_return_if_fail (self != NULL);
#line 180 "../src/Theme.vala"
	g_return_if_fail (ctx != NULL);
#line 180 "../src/Theme.vala"
	g_return_if_fail (color != NULL);
#line 181 "../src/Theme.vala"
	_tmp0_ = *color;
#line 181 "../src/Theme.vala"
	_tmp1_ = _tmp0_.red;
#line 181 "../src/Theme.vala"
	_tmp2_ = *color;
#line 181 "../src/Theme.vala"
	_tmp3_ = _tmp2_.green;
#line 181 "../src/Theme.vala"
	_tmp4_ = *color;
#line 181 "../src/Theme.vala"
	_tmp5_ = _tmp4_.blue;
#line 181 "../src/Theme.vala"
	_tmp6_ = *color;
#line 181 "../src/Theme.vala"
	_tmp7_ = _tmp6_.alpha;
#line 181 "../src/Theme.vala"
	cairo_set_source_rgba (ctx, _tmp1_, _tmp3_, _tmp5_, _tmp7_);
#line 1103 "Theme.c"
}


static gboolean
bool_parse (const gchar* str)
{
	gboolean result = FALSE;
#line 44 "glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, FALSE);
#line 45 "glib-2.0.vapi"
	if (g_strcmp0 (str, "true") == 0) {
#line 46 "glib-2.0.vapi"
		result = TRUE;
#line 46 "glib-2.0.vapi"
		return result;
#line 1119 "Theme.c"
	} else {
#line 48 "glib-2.0.vapi"
		result = FALSE;
#line 48 "glib-2.0.vapi"
		return result;
#line 1125 "Theme.c"
	}
}


void
theme_load (Theme* self,
            xmlNode* n)
{
	gchar* nn = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* idx = NULL;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	GArray* cs = NULL;
	GArray* _tmp6_;
	gchar* d = NULL;
	gchar* _tmp22_;
	const gchar* _tmp23_;
#line 185 "../src/Theme.vala"
	g_return_if_fail (self != NULL);
#line 187 "../src/Theme.vala"
	_tmp0_ = (gchar*) xmlGetProp (n, (xmlChar*) "name");
#line 187 "../src/Theme.vala"
	nn = _tmp0_;
#line 188 "../src/Theme.vala"
	_tmp1_ = nn;
#line 188 "../src/Theme.vala"
	if (_tmp1_ != NULL) {
#line 1155 "Theme.c"
		const gchar* _tmp2_;
#line 189 "../src/Theme.vala"
		_tmp2_ = nn;
#line 189 "../src/Theme.vala"
		theme_set_name (self, _tmp2_);
#line 1161 "Theme.c"
	}
#line 192 "../src/Theme.vala"
	_tmp3_ = (gchar*) xmlGetProp (n, (xmlChar*) "index");
#line 192 "../src/Theme.vala"
	idx = _tmp3_;
#line 193 "../src/Theme.vala"
	_tmp4_ = idx;
#line 193 "../src/Theme.vala"
	if (_tmp4_ != NULL) {
#line 1171 "Theme.c"
		const gchar* _tmp5_;
#line 194 "../src/Theme.vala"
		_tmp5_ = idx;
#line 194 "../src/Theme.vala"
		theme_set_index (self, atoi (_tmp5_));
#line 1177 "Theme.c"
	}
#line 197 "../src/Theme.vala"
	_tmp6_ = theme_colors (self);
#line 197 "../src/Theme.vala"
	cs = _tmp6_;
#line 1183 "Theme.c"
	{
		gint i = 0;
#line 198 "../src/Theme.vala"
		i = 0;
#line 1188 "Theme.c"
		{
			gboolean _tmp7_ = FALSE;
#line 198 "../src/Theme.vala"
			_tmp7_ = TRUE;
#line 198 "../src/Theme.vala"
			while (TRUE) {
#line 1195 "Theme.c"
				gint _tmp9_;
				GArray* _tmp10_;
				guint _tmp11_;
				gchar* name = NULL;
				GArray* _tmp12_;
				gint _tmp13_;
				const gchar* _tmp14_;
				gchar* _tmp15_;
				gchar* s = NULL;
				const gchar* _tmp16_;
				gchar* _tmp17_;
				const gchar* _tmp18_;
#line 198 "../src/Theme.vala"
				if (!_tmp7_) {
#line 1210 "Theme.c"
					gint _tmp8_;
#line 198 "../src/Theme.vala"
					_tmp8_ = i;
#line 198 "../src/Theme.vala"
					i = _tmp8_ + 1;
#line 1216 "Theme.c"
				}
#line 198 "../src/Theme.vala"
				_tmp7_ = FALSE;
#line 198 "../src/Theme.vala"
				_tmp9_ = i;
#line 198 "../src/Theme.vala"
				_tmp10_ = cs;
#line 198 "../src/Theme.vala"
				_tmp11_ = _tmp10_->len;
#line 198 "../src/Theme.vala"
				if (!(((guint) _tmp9_) < _tmp11_)) {
#line 198 "../src/Theme.vala"
					break;
#line 1230 "Theme.c"
				}
#line 199 "../src/Theme.vala"
				_tmp12_ = cs;
#line 199 "../src/Theme.vala"
				_tmp13_ = i;
#line 199 "../src/Theme.vala"
				_tmp14_ = g_array_index (_tmp12_, gchar*, (guint) _tmp13_);
#line 199 "../src/Theme.vala"
				_tmp15_ = g_strdup (_tmp14_);
#line 199 "../src/Theme.vala"
				name = _tmp15_;
#line 200 "../src/Theme.vala"
				_tmp16_ = name;
#line 200 "../src/Theme.vala"
				_tmp17_ = (gchar*) xmlGetProp (n, (xmlChar*) _tmp16_);
#line 200 "../src/Theme.vala"
				s = _tmp17_;
#line 201 "../src/Theme.vala"
				_tmp18_ = s;
#line 201 "../src/Theme.vala"
				if (_tmp18_ != NULL) {
#line 1252 "Theme.c"
					const gchar* _tmp19_;
					const gchar* _tmp20_;
					GdkRGBA _tmp21_ = {0};
#line 202 "../src/Theme.vala"
					_tmp19_ = name;
#line 202 "../src/Theme.vala"
					_tmp20_ = s;
#line 202 "../src/Theme.vala"
					theme_color_from_string (self, _tmp20_, &_tmp21_);
#line 202 "../src/Theme.vala"
					theme_set_color (self, _tmp19_, &_tmp21_);
#line 1264 "Theme.c"
				}
#line 198 "../src/Theme.vala"
				_g_free0 (s);
#line 198 "../src/Theme.vala"
				_g_free0 (name);
#line 1270 "Theme.c"
			}
		}
	}
#line 206 "../src/Theme.vala"
	_tmp22_ = (gchar*) xmlGetProp (n, (xmlChar*) "prefer_dark");
#line 206 "../src/Theme.vala"
	d = _tmp22_;
#line 207 "../src/Theme.vala"
	_tmp23_ = d;
#line 207 "../src/Theme.vala"
	if (_tmp23_ != NULL) {
#line 1282 "Theme.c"
		const gchar* _tmp24_;
#line 208 "../src/Theme.vala"
		_tmp24_ = d;
#line 208 "../src/Theme.vala"
		theme_set_prefer_dark (self, bool_parse (_tmp24_));
#line 1288 "Theme.c"
	}
#line 185 "../src/Theme.vala"
	_g_free0 (d);
#line 185 "../src/Theme.vala"
	_g_array_unref0 (cs);
#line 185 "../src/Theme.vala"
	_g_free0 (idx);
#line 185 "../src/Theme.vala"
	_g_free0 (nn);
#line 1298 "Theme.c"
}


static gchar*
bool_to_string (gboolean self)
{
	gchar* result = NULL;
#line 37 "glib-2.0.vapi"
	if (self) {
#line 1308 "Theme.c"
		gchar* _tmp0_;
#line 38 "glib-2.0.vapi"
		_tmp0_ = g_strdup ("true");
#line 38 "glib-2.0.vapi"
		result = _tmp0_;
#line 38 "glib-2.0.vapi"
		return result;
#line 1316 "Theme.c"
	} else {
		gchar* _tmp1_;
#line 40 "glib-2.0.vapi"
		_tmp1_ = g_strdup ("false");
#line 40 "glib-2.0.vapi"
		result = _tmp1_;
#line 40 "glib-2.0.vapi"
		return result;
#line 1325 "Theme.c"
	}
}


xmlNode*
theme_save (Theme* self)
{
	xmlNode* result = NULL;
	xmlNode* n = NULL;
	xmlNode* _tmp0_;
	xmlNode* _tmp1_;
	const gchar* _tmp2_;
	xmlNode* _tmp3_;
	gint _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gboolean _tmp7_;
	xmlNode* _tmp30_;
#line 214 "../src/Theme.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 216 "../src/Theme.vala"
	_tmp0_ = xmlNewNode (NULL, (xmlChar*) "theme");
#line 216 "../src/Theme.vala"
	n = _tmp0_;
#line 218 "../src/Theme.vala"
	_tmp1_ = n;
#line 218 "../src/Theme.vala"
	_tmp2_ = self->priv->_name;
#line 218 "../src/Theme.vala"
	xmlNewProp (_tmp1_, (xmlChar*) "name", (xmlChar*) _tmp2_);
#line 219 "../src/Theme.vala"
	_tmp3_ = n;
#line 219 "../src/Theme.vala"
	_tmp4_ = self->priv->_index;
#line 219 "../src/Theme.vala"
	_tmp5_ = g_strdup_printf ("%i", _tmp4_);
#line 219 "../src/Theme.vala"
	_tmp6_ = _tmp5_;
#line 219 "../src/Theme.vala"
	xmlNewProp (_tmp3_, (xmlChar*) "index", (xmlChar*) _tmp6_);
#line 219 "../src/Theme.vala"
	_g_free0 (_tmp6_);
#line 221 "../src/Theme.vala"
	_tmp7_ = self->priv->_custom;
#line 221 "../src/Theme.vala"
	if (_tmp7_) {
#line 1372 "Theme.c"
		GArray* cs = NULL;
		GArray* _tmp8_;
		xmlNode* _tmp26_;
		gboolean _tmp27_;
		gchar* _tmp28_;
		gchar* _tmp29_;
#line 223 "../src/Theme.vala"
		_tmp8_ = theme_colors (self);
#line 223 "../src/Theme.vala"
		cs = _tmp8_;
#line 1383 "Theme.c"
		{
			gint i = 0;
#line 224 "../src/Theme.vala"
			i = 0;
#line 1388 "Theme.c"
			{
				gboolean _tmp9_ = FALSE;
#line 224 "../src/Theme.vala"
				_tmp9_ = TRUE;
#line 224 "../src/Theme.vala"
				while (TRUE) {
#line 1395 "Theme.c"
					gint _tmp11_;
					GArray* _tmp12_;
					guint _tmp13_;
					gchar* name = NULL;
					GArray* _tmp14_;
					gint _tmp15_;
					const gchar* _tmp16_;
					gchar* _tmp17_;
					xmlNode* _tmp18_;
					const gchar* _tmp19_;
					const gchar* _tmp20_;
					GdkRGBA* _tmp21_;
					GdkRGBA* _tmp22_;
					GdkRGBA _tmp23_;
					gchar* _tmp24_;
					gchar* _tmp25_;
#line 224 "../src/Theme.vala"
					if (!_tmp9_) {
#line 1414 "Theme.c"
						gint _tmp10_;
#line 224 "../src/Theme.vala"
						_tmp10_ = i;
#line 224 "../src/Theme.vala"
						i = _tmp10_ + 1;
#line 1420 "Theme.c"
					}
#line 224 "../src/Theme.vala"
					_tmp9_ = FALSE;
#line 224 "../src/Theme.vala"
					_tmp11_ = i;
#line 224 "../src/Theme.vala"
					_tmp12_ = cs;
#line 224 "../src/Theme.vala"
					_tmp13_ = _tmp12_->len;
#line 224 "../src/Theme.vala"
					if (!(((guint) _tmp11_) < _tmp13_)) {
#line 224 "../src/Theme.vala"
						break;
#line 1434 "Theme.c"
					}
#line 225 "../src/Theme.vala"
					_tmp14_ = cs;
#line 225 "../src/Theme.vala"
					_tmp15_ = i;
#line 225 "../src/Theme.vala"
					_tmp16_ = g_array_index (_tmp14_, gchar*, (guint) _tmp15_);
#line 225 "../src/Theme.vala"
					_tmp17_ = g_strdup (_tmp16_);
#line 225 "../src/Theme.vala"
					name = _tmp17_;
#line 226 "../src/Theme.vala"
					_tmp18_ = n;
#line 226 "../src/Theme.vala"
					_tmp19_ = name;
#line 226 "../src/Theme.vala"
					_tmp20_ = name;
#line 226 "../src/Theme.vala"
					_tmp21_ = theme_get_color (self, _tmp20_);
#line 226 "../src/Theme.vala"
					_tmp22_ = _tmp21_;
#line 226 "../src/Theme.vala"
					_tmp23_ = *_tmp22_;
#line 226 "../src/Theme.vala"
					_tmp24_ = utils_color_from_rgba (&_tmp23_);
#line 226 "../src/Theme.vala"
					_tmp25_ = _tmp24_;
#line 226 "../src/Theme.vala"
					xmlNewProp (_tmp18_, (xmlChar*) _tmp19_, (xmlChar*) _tmp25_);
#line 226 "../src/Theme.vala"
					_g_free0 (_tmp25_);
#line 226 "../src/Theme.vala"
					_g_free0 (_tmp22_);
#line 224 "../src/Theme.vala"
					_g_free0 (name);
#line 1470 "Theme.c"
				}
			}
		}
#line 229 "../src/Theme.vala"
		_tmp26_ = n;
#line 229 "../src/Theme.vala"
		_tmp27_ = self->priv->_prefer_dark;
#line 229 "../src/Theme.vala"
		_tmp28_ = bool_to_string (_tmp27_);
#line 229 "../src/Theme.vala"
		_tmp29_ = _tmp28_;
#line 229 "../src/Theme.vala"
		xmlNewProp (_tmp26_, (xmlChar*) "prefer_dark", (xmlChar*) _tmp29_);
#line 229 "../src/Theme.vala"
		_g_free0 (_tmp29_);
#line 221 "../src/Theme.vala"
		_g_array_unref0 (cs);
#line 1488 "Theme.c"
	}
#line 233 "../src/Theme.vala"
	_tmp30_ = n;
#line 233 "../src/Theme.vala"
	result = _tmp30_;
#line 233 "../src/Theme.vala"
	return result;
#line 1496 "Theme.c"
}


static void
_vala_PangoFontDescription_free (PangoFontDescription* self)
{
#line 406 "../src/Theme.vala"
	g_boxed_free (pango_font_description_get_type (), self);
#line 1505 "Theme.c"
}


cairo_surface_t*
theme_make_icon (Theme* self)
{
	cairo_surface_t* result = NULL;
	cairo_surface_t* surface = NULL;
	cairo_surface_t* _tmp0_;
	cairo_t* ctx = NULL;
	cairo_t* _tmp1_;
	gint width = 0;
	gint height = 0;
	PangoFontDescription* font_desc = NULL;
	PangoFontDescription* _tmp2_;
	GdkRGBA* _tmp3_;
	GdkRGBA* _tmp4_;
	GdkRGBA _tmp5_;
	GdkRGBA _tmp6_ = {0};
	GdkRGBA _tmp7_ = {0};
	GdkRGBA _tmp8_ = {0};
	GdkRGBA _tmp9_ = {0};
	GdkRGBA _tmp10_ = {0};
	GdkRGBA _tmp11_ = {0};
	GdkRGBA _tmp12_ = {0};
	GdkRGBA _tmp13_ = {0};
	GdkRGBA _tmp14_ = {0};
	GdkRGBA _tmp15_ = {0};
	PangoLayout* root_text = NULL;
	PangoLayout* _tmp16_;
	const gchar* _tmp17_;
	gint _tmp18_ = 0;
	gint _tmp19_ = 0;
	gint _tmp20_;
	gdouble r = 0.0;
	gdouble x = 0.0;
	gdouble y = 0.0;
	gint _tmp21_;
	gdouble w = 0.0;
	gdouble h = 0.0;
	gint _tmp22_;
	GdkRGBA* _tmp23_;
	GdkRGBA* _tmp24_;
	GdkRGBA _tmp25_;
	PangoLayout* node_text = NULL;
	PangoLayout* _tmp26_;
	GdkRGBA* _tmp27_;
	GdkRGBA* _tmp28_;
	GdkRGBA _tmp29_;
	gint _tmp30_;
	gint _tmp31_;
	gint _tmp32_ = 0;
	gint _tmp33_ = 0;
	gint _tmp34_;
	gint _tmp35_;
	GdkRGBA* _tmp36_;
	GdkRGBA* _tmp37_;
	GdkRGBA _tmp38_;
	gint _tmp39_;
	gint _tmp40_;
	GdkRGBA* _tmp41_;
	GdkRGBA* _tmp42_;
	GdkRGBA _tmp43_;
	gint _tmp44_;
	gint _tmp45_;
	GdkRGBA* _tmp46_;
	GdkRGBA* _tmp47_;
	GdkRGBA _tmp48_;
	gint _tmp49_;
	gint _tmp50_;
	GdkRGBA* _tmp51_;
	GdkRGBA* _tmp52_;
	GdkRGBA _tmp53_;
	gint _tmp54_;
	gint _tmp55_;
	GdkRGBA* _tmp56_;
	GdkRGBA* _tmp57_;
	GdkRGBA _tmp58_;
	gint _tmp59_;
	gint _tmp60_;
	GdkRGBA* _tmp61_;
	GdkRGBA* _tmp62_;
	GdkRGBA _tmp63_;
	gint _tmp64_;
	gint _tmp65_;
	GdkRGBA* _tmp66_;
	GdkRGBA* _tmp67_;
	GdkRGBA _tmp68_;
	gdouble p[6] = {0};
	gdouble _tmp69_[6] = {0};
	gdouble* _tmp70_;
	gdouble* _tmp71_;
	gint _tmp71__length1;
	gdouble _tmp72_;
	gdouble _tmp73_;
	gdouble _tmp74_;
	gdouble _tmp75_;
	gdouble _tmp76_;
	gdouble _tmp77_;
	gdouble _tmp78_;
	gdouble _tmp79_;
	gdouble _tmp80_;
	gdouble _tmp81_;
	gdouble _tmp82_;
	gdouble _tmp83_;
	gdouble _tmp84_;
	gdouble _tmp85_;
	gdouble _tmp86_;
	gdouble _tmp87_;
	gdouble _tmp88_;
	gdouble _tmp89_;
	gdouble _tmp90_;
	gdouble _tmp91_;
#line 238 "../src/Theme.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 240 "../src/Theme.vala"
	_tmp0_ = cairo_image_surface_create (CAIRO_FORMAT_ARGB32, 200, 100);
#line 240 "../src/Theme.vala"
	surface = _tmp0_;
#line 241 "../src/Theme.vala"
	_tmp1_ = cairo_create (surface);
#line 241 "../src/Theme.vala"
	ctx = _tmp1_;
#line 244 "../src/Theme.vala"
	_tmp2_ = pango_font_description_new ();
#line 244 "../src/Theme.vala"
	font_desc = _tmp2_;
#line 245 "../src/Theme.vala"
	pango_font_description_set_family (font_desc, "Sans");
#line 246 "../src/Theme.vala"
	pango_font_description_set_size (font_desc, 10 * PANGO_SCALE);
#line 249 "../src/Theme.vala"
	_tmp3_ = theme_get_color (self, "background");
#line 249 "../src/Theme.vala"
	_tmp4_ = _tmp3_;
#line 249 "../src/Theme.vala"
	_tmp5_ = *_tmp4_;
#line 249 "../src/Theme.vala"
	theme_set_context_color (self, ctx, &_tmp5_);
#line 249 "../src/Theme.vala"
	_g_free0 (_tmp4_);
#line 250 "../src/Theme.vala"
	cairo_rectangle (ctx, (gdouble) 0, (gdouble) 0, (gdouble) 200, (gdouble) 100);
#line 251 "../src/Theme.vala"
	cairo_fill (ctx);
#line 254 "../src/Theme.vala"
	theme_link_color (self, 0, &_tmp6_);
#line 254 "../src/Theme.vala"
	theme_set_context_color (self, ctx, &_tmp6_);
#line 255 "../src/Theme.vala"
	cairo_set_line_cap (ctx, CAIRO_LINE_CAP_ROUND);
#line 256 "../src/Theme.vala"
	cairo_set_line_width (ctx, (gdouble) 4);
#line 257 "../src/Theme.vala"
	cairo_move_to (ctx, (gdouble) 100, (gdouble) 50);
#line 258 "../src/Theme.vala"
	cairo_line_to (ctx, (gdouble) 50, (gdouble) 25);
#line 259 "../src/Theme.vala"
	cairo_stroke (ctx);
#line 260 "../src/Theme.vala"
	theme_link_color (self, 0, &_tmp7_);
#line 260 "../src/Theme.vala"
	theme_set_context_color (self, ctx, &_tmp7_);
#line 261 "../src/Theme.vala"
	cairo_set_line_cap (ctx, CAIRO_LINE_CAP_ROUND);
#line 262 "../src/Theme.vala"
	cairo_set_line_width (ctx, (gdouble) 4);
#line 263 "../src/Theme.vala"
	cairo_move_to (ctx, (gdouble) 50, (gdouble) 25);
#line 264 "../src/Theme.vala"
	cairo_line_to (ctx, (gdouble) 10, (gdouble) 25);
#line 265 "../src/Theme.vala"
	cairo_stroke (ctx);
#line 267 "../src/Theme.vala"
	theme_link_color (self, 1, &_tmp8_);
#line 267 "../src/Theme.vala"
	theme_set_context_color (self, ctx, &_tmp8_);
#line 268 "../src/Theme.vala"
	cairo_set_line_cap (ctx, CAIRO_LINE_CAP_ROUND);
#line 269 "../src/Theme.vala"
	cairo_set_line_width (ctx, (gdouble) 4);
#line 270 "../src/Theme.vala"
	cairo_move_to (ctx, (gdouble) 100, (gdouble) 50);
#line 271 "../src/Theme.vala"
	cairo_line_to (ctx, (gdouble) 10, (gdouble) 50);
#line 272 "../src/Theme.vala"
	cairo_stroke (ctx);
#line 274 "../src/Theme.vala"
	theme_link_color (self, 2, &_tmp9_);
#line 274 "../src/Theme.vala"
	theme_set_context_color (self, ctx, &_tmp9_);
#line 275 "../src/Theme.vala"
	cairo_set_line_cap (ctx, CAIRO_LINE_CAP_ROUND);
#line 276 "../src/Theme.vala"
	cairo_set_line_width (ctx, (gdouble) 4);
#line 277 "../src/Theme.vala"
	cairo_move_to (ctx, (gdouble) 100, (gdouble) 50);
#line 278 "../src/Theme.vala"
	cairo_line_to (ctx, (gdouble) 50, (gdouble) 75);
#line 279 "../src/Theme.vala"
	cairo_stroke (ctx);
#line 280 "../src/Theme.vala"
	theme_link_color (self, 2, &_tmp10_);
#line 280 "../src/Theme.vala"
	theme_set_context_color (self, ctx, &_tmp10_);
#line 281 "../src/Theme.vala"
	cairo_set_line_cap (ctx, CAIRO_LINE_CAP_ROUND);
#line 282 "../src/Theme.vala"
	cairo_set_line_width (ctx, (gdouble) 4);
#line 283 "../src/Theme.vala"
	cairo_move_to (ctx, (gdouble) 50, (gdouble) 75);
#line 284 "../src/Theme.vala"
	cairo_line_to (ctx, (gdouble) 10, (gdouble) 75);
#line 285 "../src/Theme.vala"
	cairo_stroke (ctx);
#line 287 "../src/Theme.vala"
	theme_link_color (self, 3, &_tmp11_);
#line 287 "../src/Theme.vala"
	theme_set_context_color (self, ctx, &_tmp11_);
#line 288 "../src/Theme.vala"
	cairo_set_line_cap (ctx, CAIRO_LINE_CAP_ROUND);
#line 289 "../src/Theme.vala"
	cairo_set_line_width (ctx, (gdouble) 4);
#line 290 "../src/Theme.vala"
	cairo_move_to (ctx, (gdouble) 100, (gdouble) 50);
#line 291 "../src/Theme.vala"
	cairo_line_to (ctx, (gdouble) 150, (gdouble) 25);
#line 292 "../src/Theme.vala"
	cairo_stroke (ctx);
#line 293 "../src/Theme.vala"
	theme_link_color (self, 3, &_tmp12_);
#line 293 "../src/Theme.vala"
	theme_set_context_color (self, ctx, &_tmp12_);
#line 294 "../src/Theme.vala"
	cairo_set_line_cap (ctx, CAIRO_LINE_CAP_ROUND);
#line 295 "../src/Theme.vala"
	cairo_set_line_width (ctx, (gdouble) 4);
#line 296 "../src/Theme.vala"
	cairo_move_to (ctx, (gdouble) 150, (gdouble) 25);
#line 297 "../src/Theme.vala"
	cairo_line_to (ctx, (gdouble) 190, (gdouble) 25);
#line 298 "../src/Theme.vala"
	cairo_stroke (ctx);
#line 300 "../src/Theme.vala"
	theme_link_color (self, 4, &_tmp13_);
#line 300 "../src/Theme.vala"
	theme_set_context_color (self, ctx, &_tmp13_);
#line 301 "../src/Theme.vala"
	cairo_set_line_cap (ctx, CAIRO_LINE_CAP_ROUND);
#line 302 "../src/Theme.vala"
	cairo_set_line_width (ctx, (gdouble) 4);
#line 303 "../src/Theme.vala"
	cairo_move_to (ctx, (gdouble) 100, (gdouble) 50);
#line 304 "../src/Theme.vala"
	cairo_line_to (ctx, (gdouble) 190, (gdouble) 50);
#line 305 "../src/Theme.vala"
	cairo_stroke (ctx);
#line 307 "../src/Theme.vala"
	theme_link_color (self, 5, &_tmp14_);
#line 307 "../src/Theme.vala"
	theme_set_context_color (self, ctx, &_tmp14_);
#line 308 "../src/Theme.vala"
	cairo_set_line_cap (ctx, CAIRO_LINE_CAP_ROUND);
#line 309 "../src/Theme.vala"
	cairo_set_line_width (ctx, (gdouble) 4);
#line 310 "../src/Theme.vala"
	cairo_move_to (ctx, (gdouble) 100, (gdouble) 50);
#line 311 "../src/Theme.vala"
	cairo_line_to (ctx, (gdouble) 150, (gdouble) 75);
#line 312 "../src/Theme.vala"
	cairo_stroke (ctx);
#line 313 "../src/Theme.vala"
	theme_link_color (self, 5, &_tmp15_);
#line 313 "../src/Theme.vala"
	theme_set_context_color (self, ctx, &_tmp15_);
#line 314 "../src/Theme.vala"
	cairo_set_line_cap (ctx, CAIRO_LINE_CAP_ROUND);
#line 315 "../src/Theme.vala"
	cairo_set_line_width (ctx, (gdouble) 4);
#line 316 "../src/Theme.vala"
	cairo_move_to (ctx, (gdouble) 150, (gdouble) 75);
#line 317 "../src/Theme.vala"
	cairo_line_to (ctx, (gdouble) 190, (gdouble) 75);
#line 318 "../src/Theme.vala"
	cairo_stroke (ctx);
#line 321 "../src/Theme.vala"
	_tmp16_ = pango_cairo_create_layout (ctx);
#line 321 "../src/Theme.vala"
	root_text = _tmp16_;
#line 322 "../src/Theme.vala"
	pango_layout_set_font_description (root_text, font_desc);
#line 323 "../src/Theme.vala"
	pango_layout_set_width (root_text, 70 * PANGO_SCALE);
#line 324 "../src/Theme.vala"
	pango_layout_set_wrap (root_text, PANGO_WRAP_WORD_CHAR);
#line 325 "../src/Theme.vala"
	_tmp17_ = self->priv->_name;
#line 325 "../src/Theme.vala"
	pango_layout_set_text (root_text, _tmp17_, -1);
#line 326 "../src/Theme.vala"
	pango_layout_get_pixel_size (root_text, &_tmp18_, &_tmp19_);
#line 326 "../src/Theme.vala"
	width = _tmp18_;
#line 326 "../src/Theme.vala"
	height = _tmp19_;
#line 328 "../src/Theme.vala"
	_tmp20_ = height;
#line 328 "../src/Theme.vala"
	height = _tmp20_ + 4;
#line 331 "../src/Theme.vala"
	r = (gdouble) 4;
#line 332 "../src/Theme.vala"
	x = (gdouble) 65;
#line 333 "../src/Theme.vala"
	_tmp21_ = height;
#line 333 "../src/Theme.vala"
	y = (gdouble) ((100 - _tmp21_) / 2);
#line 334 "../src/Theme.vala"
	w = (gdouble) 70;
#line 335 "../src/Theme.vala"
	_tmp22_ = height;
#line 335 "../src/Theme.vala"
	h = (gdouble) _tmp22_;
#line 336 "../src/Theme.vala"
	_tmp23_ = theme_get_color (self, "root_background");
#line 336 "../src/Theme.vala"
	_tmp24_ = _tmp23_;
#line 336 "../src/Theme.vala"
	_tmp25_ = *_tmp24_;
#line 336 "../src/Theme.vala"
	theme_set_context_color (self, ctx, &_tmp25_);
#line 336 "../src/Theme.vala"
	_g_free0 (_tmp24_);
#line 337 "../src/Theme.vala"
	cairo_set_line_width (ctx, (gdouble) 1);
#line 338 "../src/Theme.vala"
	cairo_move_to (ctx, x + r, y);
#line 339 "../src/Theme.vala"
	cairo_line_to (ctx, (x + w) - r, y);
#line 340 "../src/Theme.vala"
	cairo_curve_to (ctx, x + w, y, x + w, y, x + w, y + r);
#line 341 "../src/Theme.vala"
	cairo_line_to (ctx, x + w, (y + h) - r);
#line 342 "../src/Theme.vala"
	cairo_curve_to (ctx, x + w, y + h, x + w, y + h, (x + w) - r, y + h);
#line 343 "../src/Theme.vala"
	cairo_line_to (ctx, x + r, y + h);
#line 344 "../src/Theme.vala"
	cairo_curve_to (ctx, x, y + h, x, y + h, x, (y + h) - r);
#line 345 "../src/Theme.vala"
	cairo_line_to (ctx, x, y + r);
#line 346 "../src/Theme.vala"
	cairo_curve_to (ctx, x, y, x, y, x + r, y);
#line 347 "../src/Theme.vala"
	cairo_fill (ctx);
#line 350 "../src/Theme.vala"
	_tmp26_ = pango_cairo_create_layout (ctx);
#line 350 "../src/Theme.vala"
	node_text = _tmp26_;
#line 351 "../src/Theme.vala"
	pango_layout_set_font_description (node_text, font_desc);
#line 352 "../src/Theme.vala"
	pango_layout_set_width (node_text, 40 * PANGO_SCALE);
#line 353 "../src/Theme.vala"
	pango_layout_set_wrap (node_text, PANGO_WRAP_WORD_CHAR);
#line 354 "../src/Theme.vala"
	pango_layout_set_text (node_text, "Node", -1);
#line 357 "../src/Theme.vala"
	_tmp27_ = theme_get_color (self, "root_foreground");
#line 357 "../src/Theme.vala"
	_tmp28_ = _tmp27_;
#line 357 "../src/Theme.vala"
	_tmp29_ = *_tmp28_;
#line 357 "../src/Theme.vala"
	theme_set_context_color (self, ctx, &_tmp29_);
#line 357 "../src/Theme.vala"
	_g_free0 (_tmp28_);
#line 358 "../src/Theme.vala"
	_tmp30_ = width;
#line 358 "../src/Theme.vala"
	_tmp31_ = height;
#line 358 "../src/Theme.vala"
	cairo_move_to (ctx, (gdouble) (100 - (_tmp30_ / 2)), (gdouble) (50 - (_tmp31_ / 2)));
#line 359 "../src/Theme.vala"
	pango_cairo_show_layout (ctx, root_text);
#line 361 "../src/Theme.vala"
	pango_layout_get_size (node_text, &_tmp32_, &_tmp33_);
#line 361 "../src/Theme.vala"
	width = _tmp32_;
#line 361 "../src/Theme.vala"
	height = _tmp33_;
#line 362 "../src/Theme.vala"
	_tmp34_ = width;
#line 362 "../src/Theme.vala"
	width = _tmp34_ / PANGO_SCALE;
#line 363 "../src/Theme.vala"
	_tmp35_ = height;
#line 363 "../src/Theme.vala"
	height = _tmp35_ / PANGO_SCALE;
#line 365 "../src/Theme.vala"
	_tmp36_ = theme_get_color (self, "foreground");
#line 365 "../src/Theme.vala"
	_tmp37_ = _tmp36_;
#line 365 "../src/Theme.vala"
	_tmp38_ = *_tmp37_;
#line 365 "../src/Theme.vala"
	theme_set_context_color (self, ctx, &_tmp38_);
#line 365 "../src/Theme.vala"
	_g_free0 (_tmp37_);
#line 366 "../src/Theme.vala"
	_tmp39_ = width;
#line 366 "../src/Theme.vala"
	_tmp40_ = height;
#line 366 "../src/Theme.vala"
	cairo_move_to (ctx, (gdouble) (30 - (_tmp39_ / 2)), (gdouble) (25 - (_tmp40_ + 2)));
#line 367 "../src/Theme.vala"
	pango_cairo_show_layout (ctx, node_text);
#line 369 "../src/Theme.vala"
	_tmp41_ = theme_get_color (self, "foreground");
#line 369 "../src/Theme.vala"
	_tmp42_ = _tmp41_;
#line 369 "../src/Theme.vala"
	_tmp43_ = *_tmp42_;
#line 369 "../src/Theme.vala"
	theme_set_context_color (self, ctx, &_tmp43_);
#line 369 "../src/Theme.vala"
	_g_free0 (_tmp42_);
#line 370 "../src/Theme.vala"
	_tmp44_ = width;
#line 370 "../src/Theme.vala"
	_tmp45_ = height;
#line 370 "../src/Theme.vala"
	cairo_move_to (ctx, (gdouble) (30 - (_tmp44_ / 2)), (gdouble) (50 - (_tmp45_ + 2)));
#line 371 "../src/Theme.vala"
	pango_cairo_show_layout (ctx, node_text);
#line 373 "../src/Theme.vala"
	_tmp46_ = theme_get_color (self, "foreground");
#line 373 "../src/Theme.vala"
	_tmp47_ = _tmp46_;
#line 373 "../src/Theme.vala"
	_tmp48_ = *_tmp47_;
#line 373 "../src/Theme.vala"
	theme_set_context_color (self, ctx, &_tmp48_);
#line 373 "../src/Theme.vala"
	_g_free0 (_tmp47_);
#line 374 "../src/Theme.vala"
	_tmp49_ = width;
#line 374 "../src/Theme.vala"
	_tmp50_ = height;
#line 374 "../src/Theme.vala"
	cairo_move_to (ctx, (gdouble) (30 - (_tmp49_ / 2)), (gdouble) (75 - (_tmp50_ + 2)));
#line 375 "../src/Theme.vala"
	pango_cairo_show_layout (ctx, node_text);
#line 377 "../src/Theme.vala"
	_tmp51_ = theme_get_color (self, "foreground");
#line 377 "../src/Theme.vala"
	_tmp52_ = _tmp51_;
#line 377 "../src/Theme.vala"
	_tmp53_ = *_tmp52_;
#line 377 "../src/Theme.vala"
	theme_set_context_color (self, ctx, &_tmp53_);
#line 377 "../src/Theme.vala"
	_g_free0 (_tmp52_);
#line 378 "../src/Theme.vala"
	_tmp54_ = width;
#line 378 "../src/Theme.vala"
	_tmp55_ = height;
#line 378 "../src/Theme.vala"
	cairo_move_to (ctx, (gdouble) (170 - (_tmp54_ / 2)), (gdouble) (25 - (_tmp55_ + 2)));
#line 379 "../src/Theme.vala"
	pango_cairo_show_layout (ctx, node_text);
#line 381 "../src/Theme.vala"
	_tmp56_ = theme_get_color (self, "foreground");
#line 381 "../src/Theme.vala"
	_tmp57_ = _tmp56_;
#line 381 "../src/Theme.vala"
	_tmp58_ = *_tmp57_;
#line 381 "../src/Theme.vala"
	theme_set_context_color (self, ctx, &_tmp58_);
#line 381 "../src/Theme.vala"
	_g_free0 (_tmp57_);
#line 382 "../src/Theme.vala"
	_tmp59_ = width;
#line 382 "../src/Theme.vala"
	_tmp60_ = height;
#line 382 "../src/Theme.vala"
	cairo_move_to (ctx, (gdouble) (170 - (_tmp59_ / 2)), (gdouble) (50 - (_tmp60_ + 2)));
#line 383 "../src/Theme.vala"
	pango_cairo_show_layout (ctx, node_text);
#line 385 "../src/Theme.vala"
	_tmp61_ = theme_get_color (self, "foreground");
#line 385 "../src/Theme.vala"
	_tmp62_ = _tmp61_;
#line 385 "../src/Theme.vala"
	_tmp63_ = *_tmp62_;
#line 385 "../src/Theme.vala"
	theme_set_context_color (self, ctx, &_tmp63_);
#line 385 "../src/Theme.vala"
	_g_free0 (_tmp62_);
#line 386 "../src/Theme.vala"
	_tmp64_ = width;
#line 386 "../src/Theme.vala"
	_tmp65_ = height;
#line 386 "../src/Theme.vala"
	cairo_move_to (ctx, (gdouble) (170 - (_tmp64_ / 2)), (gdouble) (75 - (_tmp65_ + 2)));
#line 387 "../src/Theme.vala"
	pango_cairo_show_layout (ctx, node_text);
#line 390 "../src/Theme.vala"
	_tmp66_ = theme_get_color (self, "connection");
#line 390 "../src/Theme.vala"
	_tmp67_ = _tmp66_;
#line 390 "../src/Theme.vala"
	_tmp68_ = *_tmp67_;
#line 390 "../src/Theme.vala"
	theme_set_context_color (self, ctx, &_tmp68_);
#line 390 "../src/Theme.vala"
	_g_free0 (_tmp67_);
#line 391 "../src/Theme.vala"
	_tmp69_[0] = (gdouble) 60;
#line 391 "../src/Theme.vala"
	_tmp69_[1] = (gdouble) 15;
#line 391 "../src/Theme.vala"
	_tmp69_[2] = (gdouble) 100;
#line 391 "../src/Theme.vala"
	_tmp69_[3] = (gdouble) 5;
#line 391 "../src/Theme.vala"
	_tmp69_[4] = (gdouble) 140;
#line 391 "../src/Theme.vala"
	_tmp69_[5] = (gdouble) 15;
#line 391 "../src/Theme.vala"
	memcpy (p, _tmp69_, 6 * sizeof (gdouble));
#line 392 "../src/Theme.vala"
	cairo_set_line_width (ctx, (gdouble) 2);
#line 393 "../src/Theme.vala"
	_tmp70_ = g_new0 (gdouble, 2);
#line 393 "../src/Theme.vala"
	_tmp70_[0] = (gdouble) 3;
#line 393 "../src/Theme.vala"
	_tmp70_[1] = (gdouble) 5;
#line 393 "../src/Theme.vala"
	_tmp71_ = _tmp70_;
#line 393 "../src/Theme.vala"
	_tmp71__length1 = 2;
#line 393 "../src/Theme.vala"
	cairo_set_dash (ctx, _tmp71_, 2, (gdouble) 0);
#line 393 "../src/Theme.vala"
	_tmp71_ = (g_free (_tmp71_), NULL);
#line 394 "../src/Theme.vala"
	_tmp72_ = p[0];
#line 394 "../src/Theme.vala"
	_tmp73_ = p[1];
#line 394 "../src/Theme.vala"
	cairo_move_to (ctx, _tmp72_, _tmp73_);
#line 395 "../src/Theme.vala"
	_tmp74_ = p[2];
#line 395 "../src/Theme.vala"
	_tmp75_ = p[0];
#line 395 "../src/Theme.vala"
	_tmp76_ = p[3];
#line 395 "../src/Theme.vala"
	_tmp77_ = p[1];
#line 395 "../src/Theme.vala"
	_tmp78_ = p[2];
#line 395 "../src/Theme.vala"
	_tmp79_ = p[4];
#line 395 "../src/Theme.vala"
	_tmp80_ = p[3];
#line 395 "../src/Theme.vala"
	_tmp81_ = p[5];
#line 395 "../src/Theme.vala"
	_tmp82_ = p[4];
#line 395 "../src/Theme.vala"
	_tmp83_ = p[5];
#line 395 "../src/Theme.vala"
	cairo_curve_to (ctx, ((2.0 / 3.0) * _tmp74_) + ((1.0 / 3.0) * _tmp75_), ((2.0 / 3.0) * _tmp76_) + ((1.0 / 3.0) * _tmp77_), ((2.0 / 3.0) * _tmp78_) + ((1.0 / 3.0) * _tmp79_), ((2.0 / 3.0) * _tmp80_) + ((1.0 / 3.0) * _tmp81_), _tmp82_, _tmp83_);
#line 402 "../src/Theme.vala"
	cairo_stroke (ctx);
#line 403 "../src/Theme.vala"
	_tmp84_ = p[0];
#line 403 "../src/Theme.vala"
	_tmp85_ = p[1];
#line 403 "../src/Theme.vala"
	_tmp86_ = p[2];
#line 403 "../src/Theme.vala"
	_tmp87_ = p[3];
#line 403 "../src/Theme.vala"
	connection_draw_arrow (ctx, 2, _tmp84_, _tmp85_, _tmp86_, _tmp87_, (gdouble) 7);
#line 404 "../src/Theme.vala"
	_tmp88_ = p[4];
#line 404 "../src/Theme.vala"
	_tmp89_ = p[5];
#line 404 "../src/Theme.vala"
	_tmp90_ = p[2];
#line 404 "../src/Theme.vala"
	_tmp91_ = p[3];
#line 404 "../src/Theme.vala"
	connection_draw_arrow (ctx, 2, _tmp88_, _tmp89_, _tmp90_, _tmp91_, (gdouble) 7);
#line 406 "../src/Theme.vala"
	result = surface;
#line 406 "../src/Theme.vala"
	_g_object_unref0 (node_text);
#line 406 "../src/Theme.vala"
	_g_object_unref0 (root_text);
#line 406 "../src/Theme.vala"
	__vala_PangoFontDescription_free0 (font_desc);
#line 406 "../src/Theme.vala"
	_cairo_destroy0 (ctx);
#line 406 "../src/Theme.vala"
	return result;
#line 2115 "Theme.c"
}


const gchar*
theme_get_name (Theme* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 30 "../src/Theme.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 30 "../src/Theme.vala"
	_tmp0_ = self->priv->_name;
#line 30 "../src/Theme.vala"
	result = _tmp0_;
#line 30 "../src/Theme.vala"
	return result;
#line 2132 "Theme.c"
}


void
theme_set_name (Theme* self,
                const gchar* value)
{
#line 30 "../src/Theme.vala"
	g_return_if_fail (self != NULL);
#line 30 "../src/Theme.vala"
	if (g_strcmp0 (value, theme_get_name (self)) != 0) {
#line 2144 "Theme.c"
		gchar* _tmp0_;
#line 30 "../src/Theme.vala"
		_tmp0_ = g_strdup (value);
#line 30 "../src/Theme.vala"
		_g_free0 (self->priv->_name);
#line 30 "../src/Theme.vala"
		self->priv->_name = _tmp0_;
#line 30 "../src/Theme.vala"
		g_object_notify_by_pspec ((GObject *) self, theme_properties[THEME_NAME_PROPERTY]);
#line 2154 "Theme.c"
	}
}


gint
theme_get_index (Theme* self)
{
	gint result;
	gint _tmp0_;
#line 31 "../src/Theme.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 31 "../src/Theme.vala"
	_tmp0_ = self->priv->_index;
#line 31 "../src/Theme.vala"
	result = _tmp0_;
#line 31 "../src/Theme.vala"
	return result;
#line 2172 "Theme.c"
}


void
theme_set_index (Theme* self,
                 gint value)
{
#line 31 "../src/Theme.vala"
	g_return_if_fail (self != NULL);
#line 31 "../src/Theme.vala"
	if (theme_get_index (self) != value) {
#line 31 "../src/Theme.vala"
		self->priv->_index = value;
#line 31 "../src/Theme.vala"
		g_object_notify_by_pspec ((GObject *) self, theme_properties[THEME_INDEX_PROPERTY]);
#line 2188 "Theme.c"
	}
}


gboolean
theme_get_prefer_dark (Theme* self)
{
	gboolean result;
	gboolean _tmp0_;
#line 32 "../src/Theme.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 32 "../src/Theme.vala"
	_tmp0_ = self->priv->_prefer_dark;
#line 32 "../src/Theme.vala"
	result = _tmp0_;
#line 32 "../src/Theme.vala"
	return result;
#line 2206 "Theme.c"
}


void
theme_set_prefer_dark (Theme* self,
                       gboolean value)
{
#line 32 "../src/Theme.vala"
	g_return_if_fail (self != NULL);
#line 32 "../src/Theme.vala"
	if (theme_get_prefer_dark (self) != value) {
#line 32 "../src/Theme.vala"
		self->priv->_prefer_dark = value;
#line 32 "../src/Theme.vala"
		g_object_notify_by_pspec ((GObject *) self, theme_properties[THEME_PREFER_DARK_PROPERTY]);
#line 2222 "Theme.c"
	}
}


gboolean
theme_get_custom (Theme* self)
{
	gboolean result;
	gboolean _tmp0_;
#line 33 "../src/Theme.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 33 "../src/Theme.vala"
	_tmp0_ = self->priv->_custom;
#line 33 "../src/Theme.vala"
	result = _tmp0_;
#line 33 "../src/Theme.vala"
	return result;
#line 2240 "Theme.c"
}


void
theme_set_custom (Theme* self,
                  gboolean value)
{
#line 33 "../src/Theme.vala"
	g_return_if_fail (self != NULL);
#line 33 "../src/Theme.vala"
	if (theme_get_custom (self) != value) {
#line 33 "../src/Theme.vala"
		self->priv->_custom = value;
#line 33 "../src/Theme.vala"
		g_object_notify_by_pspec ((GObject *) self, theme_properties[THEME_CUSTOM_PROPERTY]);
#line 2256 "Theme.c"
	}
}


gboolean
theme_get_temporary (Theme* self)
{
	gboolean result;
	gboolean _tmp0_;
#line 34 "../src/Theme.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 34 "../src/Theme.vala"
	_tmp0_ = self->priv->_temporary;
#line 34 "../src/Theme.vala"
	result = _tmp0_;
#line 34 "../src/Theme.vala"
	return result;
#line 2274 "Theme.c"
}


void
theme_set_temporary (Theme* self,
                     gboolean value)
{
#line 34 "../src/Theme.vala"
	g_return_if_fail (self != NULL);
#line 34 "../src/Theme.vala"
	if (theme_get_temporary (self) != value) {
#line 34 "../src/Theme.vala"
		self->priv->_temporary = value;
#line 34 "../src/Theme.vala"
		g_object_notify_by_pspec ((GObject *) self, theme_properties[THEME_TEMPORARY_PROPERTY]);
#line 2290 "Theme.c"
	}
}


static void
theme_class_init (ThemeClass * klass)
{
#line 26 "../src/Theme.vala"
	theme_parent_class = g_type_class_peek_parent (klass);
#line 26 "../src/Theme.vala"
	g_type_class_adjust_private_offset (klass, &Theme_private_offset);
#line 26 "../src/Theme.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_theme_get_property;
#line 26 "../src/Theme.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_theme_set_property;
#line 26 "../src/Theme.vala"
	G_OBJECT_CLASS (klass)->finalize = theme_finalize;
#line 26 "../src/Theme.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), THEME_NAME_PROPERTY, theme_properties[THEME_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 26 "../src/Theme.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), THEME_INDEX_PROPERTY, theme_properties[THEME_INDEX_PROPERTY] = g_param_spec_int ("index", "index", "index", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 26 "../src/Theme.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), THEME_PREFER_DARK_PROPERTY, theme_properties[THEME_PREFER_DARK_PROPERTY] = g_param_spec_boolean ("prefer-dark", "prefer-dark", "prefer-dark", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 26 "../src/Theme.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), THEME_CUSTOM_PROPERTY, theme_properties[THEME_CUSTOM_PROPERTY] = g_param_spec_boolean ("custom", "custom", "custom", TRUE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 26 "../src/Theme.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), THEME_TEMPORARY_PROPERTY, theme_properties[THEME_TEMPORARY_PROPERTY] = g_param_spec_boolean ("temporary", "temporary", "temporary", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2318 "Theme.c"
}


static void
theme_instance_init (Theme * self)
{
#line 26 "../src/Theme.vala"
	self->priv = theme_get_instance_private (self);
#line 31 "../src/Theme.vala"
	self->priv->_index = 0;
#line 32 "../src/Theme.vala"
	self->priv->_prefer_dark = FALSE;
#line 33 "../src/Theme.vala"
	self->priv->_custom = TRUE;
#line 34 "../src/Theme.vala"
	self->priv->_temporary = FALSE;
#line 2335 "Theme.c"
}


static void
theme_finalize (GObject * obj)
{
	Theme * self;
#line 26 "../src/Theme.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_THEME, Theme);
#line 28 "../src/Theme.vala"
	_g_object_unref0 (self->priv->_colors);
#line 30 "../src/Theme.vala"
	_g_free0 (self->priv->_name);
#line 26 "../src/Theme.vala"
	G_OBJECT_CLASS (theme_parent_class)->finalize (obj);
#line 2351 "Theme.c"
}


GType
theme_get_type (void)
{
	static volatile gsize theme_type_id__volatile = 0;
	if (g_once_init_enter (&theme_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ThemeClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) theme_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Theme), 0, (GInstanceInitFunc) theme_instance_init, NULL };
		GType theme_type_id;
		theme_type_id = g_type_register_static (G_TYPE_OBJECT, "Theme", &g_define_type_info, 0);
		Theme_private_offset = g_type_add_instance_private (theme_type_id, sizeof (ThemePrivate));
		g_once_init_leave (&theme_type_id__volatile, theme_type_id);
	}
	return theme_type_id__volatile;
}


static void
_vala_theme_get_property (GObject * object,
                          guint property_id,
                          GValue * value,
                          GParamSpec * pspec)
{
	Theme * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_THEME, Theme);
#line 26 "../src/Theme.vala"
	switch (property_id) {
#line 26 "../src/Theme.vala"
		case THEME_NAME_PROPERTY:
#line 26 "../src/Theme.vala"
		g_value_set_string (value, theme_get_name (self));
#line 26 "../src/Theme.vala"
		break;
#line 26 "../src/Theme.vala"
		case THEME_INDEX_PROPERTY:
#line 26 "../src/Theme.vala"
		g_value_set_int (value, theme_get_index (self));
#line 26 "../src/Theme.vala"
		break;
#line 26 "../src/Theme.vala"
		case THEME_PREFER_DARK_PROPERTY:
#line 26 "../src/Theme.vala"
		g_value_set_boolean (value, theme_get_prefer_dark (self));
#line 26 "../src/Theme.vala"
		break;
#line 26 "../src/Theme.vala"
		case THEME_CUSTOM_PROPERTY:
#line 26 "../src/Theme.vala"
		g_value_set_boolean (value, theme_get_custom (self));
#line 26 "../src/Theme.vala"
		break;
#line 26 "../src/Theme.vala"
		case THEME_TEMPORARY_PROPERTY:
#line 26 "../src/Theme.vala"
		g_value_set_boolean (value, theme_get_temporary (self));
#line 26 "../src/Theme.vala"
		break;
#line 2410 "Theme.c"
		default:
#line 26 "../src/Theme.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 26 "../src/Theme.vala"
		break;
#line 2416 "Theme.c"
	}
}


static void
_vala_theme_set_property (GObject * object,
                          guint property_id,
                          const GValue * value,
                          GParamSpec * pspec)
{
	Theme * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_THEME, Theme);
#line 26 "../src/Theme.vala"
	switch (property_id) {
#line 26 "../src/Theme.vala"
		case THEME_NAME_PROPERTY:
#line 26 "../src/Theme.vala"
		theme_set_name (self, g_value_get_string (value));
#line 26 "../src/Theme.vala"
		break;
#line 26 "../src/Theme.vala"
		case THEME_INDEX_PROPERTY:
#line 26 "../src/Theme.vala"
		theme_set_index (self, g_value_get_int (value));
#line 26 "../src/Theme.vala"
		break;
#line 26 "../src/Theme.vala"
		case THEME_PREFER_DARK_PROPERTY:
#line 26 "../src/Theme.vala"
		theme_set_prefer_dark (self, g_value_get_boolean (value));
#line 26 "../src/Theme.vala"
		break;
#line 26 "../src/Theme.vala"
		case THEME_CUSTOM_PROPERTY:
#line 26 "../src/Theme.vala"
		theme_set_custom (self, g_value_get_boolean (value));
#line 26 "../src/Theme.vala"
		break;
#line 26 "../src/Theme.vala"
		case THEME_TEMPORARY_PROPERTY:
#line 26 "../src/Theme.vala"
		theme_set_temporary (self, g_value_get_boolean (value));
#line 26 "../src/Theme.vala"
		break;
#line 2461 "Theme.c"
		default:
#line 26 "../src/Theme.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 26 "../src/Theme.vala"
		break;
#line 2467 "Theme.c"
	}
}



