/* UndoBuffer.c generated by valac 0.42.7, the Vala compiler
 * generated from UndoBuffer.vala, do not modify */

/*
* Copyright (c) 2018 (https://github.com/phase1geo/Minder)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Trevor Williams <phase1geo@gmail.com>
*/


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <stdio.h>


#define TYPE_UNDO_BUFFER (undo_buffer_get_type ())
#define UNDO_BUFFER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_UNDO_BUFFER, UndoBuffer))
#define UNDO_BUFFER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_UNDO_BUFFER, UndoBufferClass))
#define IS_UNDO_BUFFER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_UNDO_BUFFER))
#define IS_UNDO_BUFFER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_UNDO_BUFFER))
#define UNDO_BUFFER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_UNDO_BUFFER, UndoBufferClass))

typedef struct _UndoBuffer UndoBuffer;
typedef struct _UndoBufferClass UndoBufferClass;
typedef struct _UndoBufferPrivate UndoBufferPrivate;

#define TYPE_DRAW_AREA (draw_area_get_type ())
#define DRAW_AREA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DRAW_AREA, DrawArea))
#define DRAW_AREA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DRAW_AREA, DrawAreaClass))
#define IS_DRAW_AREA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DRAW_AREA))
#define IS_DRAW_AREA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DRAW_AREA))
#define DRAW_AREA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DRAW_AREA, DrawAreaClass))

typedef struct _DrawArea DrawArea;
typedef struct _DrawAreaClass DrawAreaClass;

#define TYPE_UNDO_ITEM (undo_item_get_type ())
#define UNDO_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_UNDO_ITEM, UndoItem))
#define UNDO_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_UNDO_ITEM, UndoItemClass))
#define IS_UNDO_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_UNDO_ITEM))
#define IS_UNDO_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_UNDO_ITEM))
#define UNDO_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_UNDO_ITEM, UndoItemClass))

typedef struct _UndoItem UndoItem;
typedef struct _UndoItemClass UndoItemClass;
enum  {
	UNDO_BUFFER_0_PROPERTY,
	UNDO_BUFFER_NUM_PROPERTIES
};
static GParamSpec* undo_buffer_properties[UNDO_BUFFER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_array_unref0(var) ((var == NULL) ? NULL : (var = (g_array_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
enum  {
	UNDO_BUFFER_BUFFER_CHANGED_SIGNAL,
	UNDO_BUFFER_NUM_SIGNALS
};
static guint undo_buffer_signals[UNDO_BUFFER_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _UndoBuffer {
	GObject parent_instance;
	UndoBufferPrivate * priv;
};

struct _UndoBufferClass {
	GObjectClass parent_class;
};

struct _UndoBufferPrivate {
	DrawArea* _da;
	GArray* _undo_buffer;
	GArray* _redo_buffer;
	gboolean _debug;
};


static gint UndoBuffer_private_offset;
static gpointer undo_buffer_parent_class = NULL;
static gint undo_buffer__current_id;
static gint undo_buffer__current_id = 0;

GType undo_buffer_get_type (void) G_GNUC_CONST;
GType draw_area_get_type (void) G_GNUC_CONST;
GType undo_item_get_type (void) G_GNUC_CONST;
UndoBuffer* undo_buffer_new (DrawArea* da);
UndoBuffer* undo_buffer_construct (GType object_type,
                                   DrawArea* da);
static void _g_object_unref0_ (gpointer var);
static void _vala_UndoItem_free_function_content_of (gpointer data);
void undo_buffer_clear (UndoBuffer* self);
gboolean undo_buffer_undoable (UndoBuffer* self);
gboolean undo_buffer_redoable (UndoBuffer* self);
void undo_buffer_undo (UndoBuffer* self);
void undo_item_undo (UndoItem* self,
                     DrawArea* da);
void undo_buffer_output (UndoBuffer* self,
                         const gchar* msg);
void undo_buffer_redo (UndoBuffer* self);
void undo_item_redo (UndoItem* self,
                     DrawArea* da);
gchar* undo_buffer_undo_tooltip (UndoBuffer* self);
const gchar* undo_item_get_name (UndoItem* self);
gchar* undo_buffer_redo_tooltip (UndoBuffer* self);
void undo_buffer_add_item (UndoBuffer* self,
                           UndoItem* item);
void undo_item_set_id (UndoItem* self,
                       gint value);
void undo_buffer_replace_item (UndoBuffer* self,
                               UndoItem* item);
gboolean undo_item_matches (UndoItem* self,
                            UndoItem* item);
void undo_item_replace_with_item (UndoItem* self,
                                  UndoItem* item);
gchar* undo_item_to_string (UndoItem* self);
static void undo_buffer_finalize (GObject * obj);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);


static inline gpointer
undo_buffer_get_instance_private (UndoBuffer* self)
{
	return G_STRUCT_MEMBER_P (self, UndoBuffer_private_offset);
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 36 "../src/UndoBuffer.vala"
	return self ? g_object_ref (self) : NULL;
#line 160 "UndoBuffer.c"
}


static void
_g_object_unref0_ (gpointer var)
{
#line 37 "../src/UndoBuffer.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 169 "UndoBuffer.c"
}


static void
_vala_UndoItem_free_function_content_of (gpointer data)
{
	UndoItem* self;
#line 37 "../src/UndoBuffer.vala"
	self = *((UndoItem**) data);
#line 37 "../src/UndoBuffer.vala"
	_g_object_unref0_ (self);
#line 181 "UndoBuffer.c"
}


UndoBuffer*
undo_buffer_construct (GType object_type,
                       DrawArea* da)
{
	UndoBuffer * self = NULL;
	DrawArea* _tmp0_;
	GArray* _tmp1_;
	GArray* _tmp2_;
#line 35 "../src/UndoBuffer.vala"
	g_return_val_if_fail (da != NULL, NULL);
#line 35 "../src/UndoBuffer.vala"
	self = (UndoBuffer*) g_object_new (object_type, NULL);
#line 36 "../src/UndoBuffer.vala"
	_tmp0_ = _g_object_ref0 (da);
#line 36 "../src/UndoBuffer.vala"
	_g_object_unref0 (self->priv->_da);
#line 36 "../src/UndoBuffer.vala"
	self->priv->_da = _tmp0_;
#line 37 "../src/UndoBuffer.vala"
	_tmp1_ = g_array_new (TRUE, TRUE, sizeof (UndoItem*));
#line 37 "../src/UndoBuffer.vala"
	g_array_set_clear_func (_tmp1_, _vala_UndoItem_free_function_content_of);
#line 37 "../src/UndoBuffer.vala"
	_g_array_unref0 (self->priv->_undo_buffer);
#line 37 "../src/UndoBuffer.vala"
	self->priv->_undo_buffer = _tmp1_;
#line 38 "../src/UndoBuffer.vala"
	_tmp2_ = g_array_new (TRUE, TRUE, sizeof (UndoItem*));
#line 38 "../src/UndoBuffer.vala"
	g_array_set_clear_func (_tmp2_, _vala_UndoItem_free_function_content_of);
#line 38 "../src/UndoBuffer.vala"
	_g_array_unref0 (self->priv->_redo_buffer);
#line 38 "../src/UndoBuffer.vala"
	self->priv->_redo_buffer = _tmp2_;
#line 35 "../src/UndoBuffer.vala"
	return self;
#line 221 "UndoBuffer.c"
}


UndoBuffer*
undo_buffer_new (DrawArea* da)
{
#line 35 "../src/UndoBuffer.vala"
	return undo_buffer_construct (TYPE_UNDO_BUFFER, da);
#line 230 "UndoBuffer.c"
}


static gpointer*
vala_g_array_remove_range (GArray* self,
                           guint index,
                           guint length,
                           int* result_length1)
{
	gpointer* result = NULL;
	guint _tmp0_;
	gpointer* ga = NULL;
	gpointer* _tmp1_;
	gint ga_length1;
	gint _ga_size_;
	gpointer* _tmp10_;
	gint _tmp10__length1;
#line 5314 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 5315 "glib-2.0.vapi"
	_tmp0_ = self->len;
#line 5315 "glib-2.0.vapi"
	_vala_assert (_tmp0_ >= (index + length), "this.length >= index + length");
#line 5316 "glib-2.0.vapi"
	_tmp1_ = g_new0 (gpointer, length);
#line 5316 "glib-2.0.vapi"
	ga = _tmp1_;
#line 5316 "glib-2.0.vapi"
	ga_length1 = length;
#line 5316 "glib-2.0.vapi"
	_ga_size_ = ga_length1;
#line 262 "UndoBuffer.c"
	{
		guint i = 0U;
#line 5317 "glib-2.0.vapi"
		i = (guint) 0;
#line 267 "UndoBuffer.c"
		{
			gboolean _tmp2_ = FALSE;
#line 5317 "glib-2.0.vapi"
			_tmp2_ = TRUE;
#line 5317 "glib-2.0.vapi"
			while (TRUE) {
#line 274 "UndoBuffer.c"
				guint _tmp4_;
				gpointer* _tmp5_;
				gint _tmp5__length1;
				guint _tmp6_;
				gpointer* _tmp7_;
				gint _tmp7__length1;
				guint _tmp8_;
				gpointer _tmp9_;
#line 5317 "glib-2.0.vapi"
				if (!_tmp2_) {
#line 285 "UndoBuffer.c"
					guint _tmp3_;
#line 5317 "glib-2.0.vapi"
					_tmp3_ = i;
#line 5317 "glib-2.0.vapi"
					i = _tmp3_ + 1;
#line 291 "UndoBuffer.c"
				}
#line 5317 "glib-2.0.vapi"
				_tmp2_ = FALSE;
#line 5317 "glib-2.0.vapi"
				_tmp4_ = i;
#line 5317 "glib-2.0.vapi"
				if (!(_tmp4_ < length)) {
#line 5317 "glib-2.0.vapi"
					break;
#line 301 "UndoBuffer.c"
				}
#line 5318 "glib-2.0.vapi"
				_tmp5_ = ga;
#line 5318 "glib-2.0.vapi"
				_tmp5__length1 = ga_length1;
#line 5318 "glib-2.0.vapi"
				_tmp6_ = i;
#line 5318 "glib-2.0.vapi"
				_tmp7_ = self->data;
#line 5318 "glib-2.0.vapi"
				_tmp7__length1 = (gint) self->len;
#line 5318 "glib-2.0.vapi"
				_tmp8_ = i;
#line 5318 "glib-2.0.vapi"
				_tmp9_ = _tmp7_[_tmp8_ + index];
#line 5318 "glib-2.0.vapi"
				_tmp7_[_tmp8_ + index] = NULL;
#line 5318 "glib-2.0.vapi"
				_tmp5_[_tmp6_] = _tmp9_;
#line 321 "UndoBuffer.c"
			}
		}
	}
#line 5320 "glib-2.0.vapi"
	g_array_remove_range (self, index, length);
#line 5321 "glib-2.0.vapi"
	_tmp10_ = ga;
#line 5321 "glib-2.0.vapi"
	_tmp10__length1 = ga_length1;
#line 5321 "glib-2.0.vapi"
	if (result_length1) {
#line 5321 "glib-2.0.vapi"
		*result_length1 = _tmp10__length1;
#line 335 "UndoBuffer.c"
	}
#line 5321 "glib-2.0.vapi"
	result = _tmp10_;
#line 5321 "glib-2.0.vapi"
	return result;
#line 341 "UndoBuffer.c"
}


void
undo_buffer_clear (UndoBuffer* self)
{
	GArray* _tmp0_;
	GArray* _tmp1_;
	guint _tmp2_;
	gint _tmp3_ = 0;
	gpointer* _tmp4_;
	UndoItem** _tmp5_;
	gint _tmp5__length1;
	GArray* _tmp6_;
	GArray* _tmp7_;
	guint _tmp8_;
	gint _tmp9_ = 0;
	gpointer* _tmp10_;
	UndoItem** _tmp11_;
	gint _tmp11__length1;
	DrawArea* _tmp12_;
#line 42 "../src/UndoBuffer.vala"
	g_return_if_fail (self != NULL);
#line 43 "../src/UndoBuffer.vala"
	_tmp0_ = self->priv->_undo_buffer;
#line 43 "../src/UndoBuffer.vala"
	_tmp1_ = self->priv->_undo_buffer;
#line 43 "../src/UndoBuffer.vala"
	_tmp2_ = _tmp1_->len;
#line 43 "../src/UndoBuffer.vala"
	_tmp4_ = vala_g_array_remove_range (_tmp0_, (guint) 0, _tmp2_, &_tmp3_);
#line 43 "../src/UndoBuffer.vala"
	_tmp5_ = _tmp4_;
#line 43 "../src/UndoBuffer.vala"
	_tmp5__length1 = _tmp3_;
#line 43 "../src/UndoBuffer.vala"
	_tmp5_ = (_vala_array_free (_tmp5_, _tmp5__length1, (GDestroyNotify) g_object_unref), NULL);
#line 44 "../src/UndoBuffer.vala"
	_tmp6_ = self->priv->_redo_buffer;
#line 44 "../src/UndoBuffer.vala"
	_tmp7_ = self->priv->_redo_buffer;
#line 44 "../src/UndoBuffer.vala"
	_tmp8_ = _tmp7_->len;
#line 44 "../src/UndoBuffer.vala"
	_tmp10_ = vala_g_array_remove_range (_tmp6_, (guint) 0, _tmp8_, &_tmp9_);
#line 44 "../src/UndoBuffer.vala"
	_tmp11_ = _tmp10_;
#line 44 "../src/UndoBuffer.vala"
	_tmp11__length1 = _tmp9_;
#line 44 "../src/UndoBuffer.vala"
	_tmp11_ = (_vala_array_free (_tmp11_, _tmp11__length1, (GDestroyNotify) g_object_unref), NULL);
#line 45 "../src/UndoBuffer.vala"
	_tmp12_ = self->priv->_da;
#line 45 "../src/UndoBuffer.vala"
	g_signal_emit (self, undo_buffer_signals[UNDO_BUFFER_BUFFER_CHANGED_SIGNAL], 0, _tmp12_);
#line 397 "UndoBuffer.c"
}


gboolean
undo_buffer_undoable (UndoBuffer* self)
{
	gboolean result = FALSE;
	GArray* _tmp0_;
	guint _tmp1_;
#line 49 "../src/UndoBuffer.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 50 "../src/UndoBuffer.vala"
	_tmp0_ = self->priv->_undo_buffer;
#line 50 "../src/UndoBuffer.vala"
	_tmp1_ = _tmp0_->len;
#line 50 "../src/UndoBuffer.vala"
	result = _tmp1_ > ((guint) 0);
#line 50 "../src/UndoBuffer.vala"
	return result;
#line 417 "UndoBuffer.c"
}


gboolean
undo_buffer_redoable (UndoBuffer* self)
{
	gboolean result = FALSE;
	GArray* _tmp0_;
	guint _tmp1_;
#line 54 "../src/UndoBuffer.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 55 "../src/UndoBuffer.vala"
	_tmp0_ = self->priv->_redo_buffer;
#line 55 "../src/UndoBuffer.vala"
	_tmp1_ = _tmp0_->len;
#line 55 "../src/UndoBuffer.vala"
	result = _tmp1_ > ((guint) 0);
#line 55 "../src/UndoBuffer.vala"
	return result;
#line 437 "UndoBuffer.c"
}


static gpointer
vala_g_array_remove_index (GArray* self,
                           guint index)
{
	gpointer result = NULL;
	guint _tmp0_;
	gpointer g = NULL;
	gpointer* _tmp1_;
	gint _tmp1__length1;
	gpointer _tmp2_;
#line 5300 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 5301 "glib-2.0.vapi"
	_tmp0_ = self->len;
#line 5301 "glib-2.0.vapi"
	_vala_assert (_tmp0_ > index, "length > index");
#line 5302 "glib-2.0.vapi"
	_tmp1_ = self->data;
#line 5302 "glib-2.0.vapi"
	_tmp1__length1 = (gint) self->len;
#line 5302 "glib-2.0.vapi"
	_tmp2_ = _tmp1_[index];
#line 5302 "glib-2.0.vapi"
	_tmp1_[index] = NULL;
#line 5302 "glib-2.0.vapi"
	g = _tmp2_;
#line 5303 "glib-2.0.vapi"
	g_array_remove_index (self, index);
#line 5304 "glib-2.0.vapi"
	result = g;
#line 5304 "glib-2.0.vapi"
	return result;
#line 473 "UndoBuffer.c"
}


void
undo_buffer_undo (UndoBuffer* self)
{
#line 59 "../src/UndoBuffer.vala"
	g_return_if_fail (self != NULL);
#line 60 "../src/UndoBuffer.vala"
	if (undo_buffer_undoable (self)) {
#line 484 "UndoBuffer.c"
		UndoItem* item = NULL;
		GArray* _tmp0_;
		GArray* _tmp1_;
		guint _tmp2_;
		UndoItem* _tmp3_;
		UndoItem* _tmp4_;
		UndoItem* _tmp5_;
		DrawArea* _tmp6_;
		GArray* _tmp7_;
		GArray* _tmp8_;
		guint _tmp9_;
		UndoItem* _tmp10_;
		UndoItem* _tmp11_;
		GArray* _tmp12_;
		UndoItem* _tmp13_;
		UndoItem* _tmp14_;
		DrawArea* _tmp15_;
#line 61 "../src/UndoBuffer.vala"
		_tmp0_ = self->priv->_undo_buffer;
#line 61 "../src/UndoBuffer.vala"
		_tmp1_ = self->priv->_undo_buffer;
#line 61 "../src/UndoBuffer.vala"
		_tmp2_ = _tmp1_->len;
#line 61 "../src/UndoBuffer.vala"
		_tmp3_ = g_array_index (_tmp0_, UndoItem*, _tmp2_ - 1);
#line 61 "../src/UndoBuffer.vala"
		_tmp4_ = _g_object_ref0 (_tmp3_);
#line 61 "../src/UndoBuffer.vala"
		item = _tmp4_;
#line 62 "../src/UndoBuffer.vala"
		_tmp5_ = item;
#line 62 "../src/UndoBuffer.vala"
		_tmp6_ = self->priv->_da;
#line 62 "../src/UndoBuffer.vala"
		undo_item_undo (_tmp5_, _tmp6_);
#line 63 "../src/UndoBuffer.vala"
		_tmp7_ = self->priv->_undo_buffer;
#line 63 "../src/UndoBuffer.vala"
		_tmp8_ = self->priv->_undo_buffer;
#line 63 "../src/UndoBuffer.vala"
		_tmp9_ = _tmp8_->len;
#line 63 "../src/UndoBuffer.vala"
		_tmp10_ = vala_g_array_remove_index (_tmp7_, _tmp9_ - 1);
#line 63 "../src/UndoBuffer.vala"
		_tmp11_ = _tmp10_;
#line 63 "../src/UndoBuffer.vala"
		_g_object_unref0 (_tmp11_);
#line 64 "../src/UndoBuffer.vala"
		_tmp12_ = self->priv->_redo_buffer;
#line 64 "../src/UndoBuffer.vala"
		_tmp13_ = item;
#line 64 "../src/UndoBuffer.vala"
		_tmp14_ = _g_object_ref0 (_tmp13_);
#line 64 "../src/UndoBuffer.vala"
		g_array_append_val (_tmp12_, _tmp14_);
#line 65 "../src/UndoBuffer.vala"
		_tmp15_ = self->priv->_da;
#line 65 "../src/UndoBuffer.vala"
		g_signal_emit (self, undo_buffer_signals[UNDO_BUFFER_BUFFER_CHANGED_SIGNAL], 0, _tmp15_);
#line 60 "../src/UndoBuffer.vala"
		_g_object_unref0 (item);
#line 546 "UndoBuffer.c"
	}
#line 67 "../src/UndoBuffer.vala"
	undo_buffer_output (self, "AFTER UNDO");
#line 550 "UndoBuffer.c"
}


void
undo_buffer_redo (UndoBuffer* self)
{
#line 71 "../src/UndoBuffer.vala"
	g_return_if_fail (self != NULL);
#line 72 "../src/UndoBuffer.vala"
	if (undo_buffer_redoable (self)) {
#line 561 "UndoBuffer.c"
		UndoItem* item = NULL;
		GArray* _tmp0_;
		GArray* _tmp1_;
		guint _tmp2_;
		UndoItem* _tmp3_;
		UndoItem* _tmp4_;
		UndoItem* _tmp5_;
		DrawArea* _tmp6_;
		GArray* _tmp7_;
		GArray* _tmp8_;
		guint _tmp9_;
		UndoItem* _tmp10_;
		UndoItem* _tmp11_;
		GArray* _tmp12_;
		UndoItem* _tmp13_;
		UndoItem* _tmp14_;
		DrawArea* _tmp15_;
#line 73 "../src/UndoBuffer.vala"
		_tmp0_ = self->priv->_redo_buffer;
#line 73 "../src/UndoBuffer.vala"
		_tmp1_ = self->priv->_redo_buffer;
#line 73 "../src/UndoBuffer.vala"
		_tmp2_ = _tmp1_->len;
#line 73 "../src/UndoBuffer.vala"
		_tmp3_ = g_array_index (_tmp0_, UndoItem*, _tmp2_ - 1);
#line 73 "../src/UndoBuffer.vala"
		_tmp4_ = _g_object_ref0 (_tmp3_);
#line 73 "../src/UndoBuffer.vala"
		item = _tmp4_;
#line 74 "../src/UndoBuffer.vala"
		_tmp5_ = item;
#line 74 "../src/UndoBuffer.vala"
		_tmp6_ = self->priv->_da;
#line 74 "../src/UndoBuffer.vala"
		undo_item_redo (_tmp5_, _tmp6_);
#line 75 "../src/UndoBuffer.vala"
		_tmp7_ = self->priv->_redo_buffer;
#line 75 "../src/UndoBuffer.vala"
		_tmp8_ = self->priv->_redo_buffer;
#line 75 "../src/UndoBuffer.vala"
		_tmp9_ = _tmp8_->len;
#line 75 "../src/UndoBuffer.vala"
		_tmp10_ = vala_g_array_remove_index (_tmp7_, _tmp9_ - 1);
#line 75 "../src/UndoBuffer.vala"
		_tmp11_ = _tmp10_;
#line 75 "../src/UndoBuffer.vala"
		_g_object_unref0 (_tmp11_);
#line 76 "../src/UndoBuffer.vala"
		_tmp12_ = self->priv->_undo_buffer;
#line 76 "../src/UndoBuffer.vala"
		_tmp13_ = item;
#line 76 "../src/UndoBuffer.vala"
		_tmp14_ = _g_object_ref0 (_tmp13_);
#line 76 "../src/UndoBuffer.vala"
		g_array_append_val (_tmp12_, _tmp14_);
#line 77 "../src/UndoBuffer.vala"
		_tmp15_ = self->priv->_da;
#line 77 "../src/UndoBuffer.vala"
		g_signal_emit (self, undo_buffer_signals[UNDO_BUFFER_BUFFER_CHANGED_SIGNAL], 0, _tmp15_);
#line 72 "../src/UndoBuffer.vala"
		_g_object_unref0 (item);
#line 623 "UndoBuffer.c"
	}
#line 79 "../src/UndoBuffer.vala"
	undo_buffer_output (self, "AFTER REDO");
#line 627 "UndoBuffer.c"
}


gchar*
undo_buffer_undo_tooltip (UndoBuffer* self)
{
	gchar* result = NULL;
	GArray* _tmp0_;
	guint _tmp1_;
	GArray* _tmp3_;
	GArray* _tmp4_;
	guint _tmp5_;
	UndoItem* _tmp6_;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
#line 83 "../src/UndoBuffer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 84 "../src/UndoBuffer.vala"
	_tmp0_ = self->priv->_undo_buffer;
#line 84 "../src/UndoBuffer.vala"
	_tmp1_ = _tmp0_->len;
#line 84 "../src/UndoBuffer.vala"
	if (_tmp1_ == ((guint) 0)) {
#line 652 "UndoBuffer.c"
		gchar* _tmp2_;
#line 84 "../src/UndoBuffer.vala"
		_tmp2_ = g_strdup ("");
#line 84 "../src/UndoBuffer.vala"
		result = _tmp2_;
#line 84 "../src/UndoBuffer.vala"
		return result;
#line 660 "UndoBuffer.c"
	}
#line 85 "../src/UndoBuffer.vala"
	_tmp3_ = self->priv->_undo_buffer;
#line 85 "../src/UndoBuffer.vala"
	_tmp4_ = self->priv->_undo_buffer;
#line 85 "../src/UndoBuffer.vala"
	_tmp5_ = _tmp4_->len;
#line 85 "../src/UndoBuffer.vala"
	_tmp6_ = g_array_index (_tmp3_, UndoItem*, _tmp5_ - 1);
#line 85 "../src/UndoBuffer.vala"
	_tmp7_ = undo_item_get_name (_tmp6_);
#line 85 "../src/UndoBuffer.vala"
	_tmp8_ = _tmp7_;
#line 85 "../src/UndoBuffer.vala"
	_tmp9_ = g_strconcat (_ ("Undo "), _tmp8_, NULL);
#line 85 "../src/UndoBuffer.vala"
	result = _tmp9_;
#line 85 "../src/UndoBuffer.vala"
	return result;
#line 680 "UndoBuffer.c"
}


gchar*
undo_buffer_redo_tooltip (UndoBuffer* self)
{
	gchar* result = NULL;
	GArray* _tmp0_;
	guint _tmp1_;
	GArray* _tmp3_;
	GArray* _tmp4_;
	guint _tmp5_;
	UndoItem* _tmp6_;
	const gchar* _tmp7_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
#line 89 "../src/UndoBuffer.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 90 "../src/UndoBuffer.vala"
	_tmp0_ = self->priv->_redo_buffer;
#line 90 "../src/UndoBuffer.vala"
	_tmp1_ = _tmp0_->len;
#line 90 "../src/UndoBuffer.vala"
	if (_tmp1_ == ((guint) 0)) {
#line 705 "UndoBuffer.c"
		gchar* _tmp2_;
#line 90 "../src/UndoBuffer.vala"
		_tmp2_ = g_strdup ("");
#line 90 "../src/UndoBuffer.vala"
		result = _tmp2_;
#line 90 "../src/UndoBuffer.vala"
		return result;
#line 713 "UndoBuffer.c"
	}
#line 91 "../src/UndoBuffer.vala"
	_tmp3_ = self->priv->_redo_buffer;
#line 91 "../src/UndoBuffer.vala"
	_tmp4_ = self->priv->_redo_buffer;
#line 91 "../src/UndoBuffer.vala"
	_tmp5_ = _tmp4_->len;
#line 91 "../src/UndoBuffer.vala"
	_tmp6_ = g_array_index (_tmp3_, UndoItem*, _tmp5_ - 1);
#line 91 "../src/UndoBuffer.vala"
	_tmp7_ = undo_item_get_name (_tmp6_);
#line 91 "../src/UndoBuffer.vala"
	_tmp8_ = _tmp7_;
#line 91 "../src/UndoBuffer.vala"
	_tmp9_ = g_strconcat (_ ("Redo "), _tmp8_, NULL);
#line 91 "../src/UndoBuffer.vala"
	result = _tmp9_;
#line 91 "../src/UndoBuffer.vala"
	return result;
#line 733 "UndoBuffer.c"
}


void
undo_buffer_add_item (UndoBuffer* self,
                      UndoItem* item)
{
	gint _tmp0_;
	GArray* _tmp1_;
	UndoItem* _tmp2_;
	GArray* _tmp3_;
	GArray* _tmp4_;
	guint _tmp5_;
	gint _tmp6_ = 0;
	gpointer* _tmp7_;
	UndoItem** _tmp8_;
	gint _tmp8__length1;
	DrawArea* _tmp9_;
#line 95 "../src/UndoBuffer.vala"
	g_return_if_fail (self != NULL);
#line 95 "../src/UndoBuffer.vala"
	g_return_if_fail (item != NULL);
#line 96 "../src/UndoBuffer.vala"
	_tmp0_ = undo_buffer__current_id;
#line 96 "../src/UndoBuffer.vala"
	undo_buffer__current_id = _tmp0_ + 1;
#line 96 "../src/UndoBuffer.vala"
	undo_item_set_id (item, _tmp0_);
#line 97 "../src/UndoBuffer.vala"
	_tmp1_ = self->priv->_undo_buffer;
#line 97 "../src/UndoBuffer.vala"
	_tmp2_ = _g_object_ref0 (item);
#line 97 "../src/UndoBuffer.vala"
	g_array_append_val (_tmp1_, _tmp2_);
#line 98 "../src/UndoBuffer.vala"
	_tmp3_ = self->priv->_redo_buffer;
#line 98 "../src/UndoBuffer.vala"
	_tmp4_ = self->priv->_redo_buffer;
#line 98 "../src/UndoBuffer.vala"
	_tmp5_ = _tmp4_->len;
#line 98 "../src/UndoBuffer.vala"
	_tmp7_ = vala_g_array_remove_range (_tmp3_, (guint) 0, _tmp5_, &_tmp6_);
#line 98 "../src/UndoBuffer.vala"
	_tmp8_ = _tmp7_;
#line 98 "../src/UndoBuffer.vala"
	_tmp8__length1 = _tmp6_;
#line 98 "../src/UndoBuffer.vala"
	_tmp8_ = (_vala_array_free (_tmp8_, _tmp8__length1, (GDestroyNotify) g_object_unref), NULL);
#line 99 "../src/UndoBuffer.vala"
	_tmp9_ = self->priv->_da;
#line 99 "../src/UndoBuffer.vala"
	g_signal_emit (self, undo_buffer_signals[UNDO_BUFFER_BUFFER_CHANGED_SIGNAL], 0, _tmp9_);
#line 100 "../src/UndoBuffer.vala"
	undo_buffer_output (self, "ITEM ADDED");
#line 788 "UndoBuffer.c"
}


void
undo_buffer_replace_item (UndoBuffer* self,
                          UndoItem* item)
{
	gint _tmp0_;
	GArray* _tmp1_;
	guint _tmp2_;
#line 107 "../src/UndoBuffer.vala"
	g_return_if_fail (self != NULL);
#line 107 "../src/UndoBuffer.vala"
	g_return_if_fail (item != NULL);
#line 108 "../src/UndoBuffer.vala"
	_tmp0_ = undo_buffer__current_id;
#line 108 "../src/UndoBuffer.vala"
	undo_buffer__current_id = _tmp0_ + 1;
#line 108 "../src/UndoBuffer.vala"
	undo_item_set_id (item, _tmp0_);
#line 109 "../src/UndoBuffer.vala"
	_tmp1_ = self->priv->_undo_buffer;
#line 109 "../src/UndoBuffer.vala"
	_tmp2_ = _tmp1_->len;
#line 109 "../src/UndoBuffer.vala"
	if (_tmp2_ > ((guint) 0)) {
#line 815 "UndoBuffer.c"
		UndoItem* last = NULL;
		GArray* _tmp3_;
		GArray* _tmp4_;
		guint _tmp5_;
		UndoItem* _tmp6_;
		UndoItem* _tmp7_;
		gboolean _tmp8_ = FALSE;
		UndoItem* _tmp9_;
#line 110 "../src/UndoBuffer.vala"
		_tmp3_ = self->priv->_undo_buffer;
#line 110 "../src/UndoBuffer.vala"
		_tmp4_ = self->priv->_undo_buffer;
#line 110 "../src/UndoBuffer.vala"
		_tmp5_ = _tmp4_->len;
#line 110 "../src/UndoBuffer.vala"
		_tmp6_ = g_array_index (_tmp3_, UndoItem*, _tmp5_ - 1);
#line 110 "../src/UndoBuffer.vala"
		_tmp7_ = _g_object_ref0 (_tmp6_);
#line 110 "../src/UndoBuffer.vala"
		last = _tmp7_;
#line 111 "../src/UndoBuffer.vala"
		_tmp9_ = last;
#line 111 "../src/UndoBuffer.vala"
		if (G_TYPE_FROM_INSTANCE ((GObject*) _tmp9_) == G_TYPE_FROM_INSTANCE ((GObject*) item)) {
#line 840 "UndoBuffer.c"
			UndoItem* _tmp10_;
#line 111 "../src/UndoBuffer.vala"
			_tmp10_ = last;
#line 111 "../src/UndoBuffer.vala"
			_tmp8_ = undo_item_matches (_tmp10_, item);
#line 846 "UndoBuffer.c"
		} else {
#line 111 "../src/UndoBuffer.vala"
			_tmp8_ = FALSE;
#line 850 "UndoBuffer.c"
		}
#line 111 "../src/UndoBuffer.vala"
		if (_tmp8_) {
#line 854 "UndoBuffer.c"
			UndoItem* _tmp11_;
			DrawArea* _tmp12_;
#line 112 "../src/UndoBuffer.vala"
			_tmp11_ = last;
#line 112 "../src/UndoBuffer.vala"
			undo_item_replace_with_item (_tmp11_, item);
#line 113 "../src/UndoBuffer.vala"
			_tmp12_ = self->priv->_da;
#line 113 "../src/UndoBuffer.vala"
			g_signal_emit (self, undo_buffer_signals[UNDO_BUFFER_BUFFER_CHANGED_SIGNAL], 0, _tmp12_);
#line 114 "../src/UndoBuffer.vala"
			undo_buffer_output (self, "ITEM REPLACED");
#line 115 "../src/UndoBuffer.vala"
			_g_object_unref0 (last);
#line 115 "../src/UndoBuffer.vala"
			return;
#line 871 "UndoBuffer.c"
		}
#line 109 "../src/UndoBuffer.vala"
		_g_object_unref0 (last);
#line 875 "UndoBuffer.c"
	}
#line 118 "../src/UndoBuffer.vala"
	undo_buffer_add_item (self, item);
#line 879 "UndoBuffer.c"
}


void
undo_buffer_output (UndoBuffer* self,
                    const gchar* msg)
{
	gboolean _tmp0_;
#line 122 "../src/UndoBuffer.vala"
	g_return_if_fail (self != NULL);
#line 122 "../src/UndoBuffer.vala"
	g_return_if_fail (msg != NULL);
#line 123 "../src/UndoBuffer.vala"
	_tmp0_ = self->priv->_debug;
#line 123 "../src/UndoBuffer.vala"
	if (_tmp0_) {
#line 896 "UndoBuffer.c"
		FILE* _tmp1_;
		FILE* _tmp13_;
#line 124 "../src/UndoBuffer.vala"
		_tmp1_ = stdout;
#line 124 "../src/UndoBuffer.vala"
		fprintf (_tmp1_, "%s\n  Undo Buffer\n-----------\n", msg);
#line 903 "UndoBuffer.c"
		{
			gint i = 0;
#line 125 "../src/UndoBuffer.vala"
			i = 0;
#line 908 "UndoBuffer.c"
			{
				gboolean _tmp2_ = FALSE;
#line 125 "../src/UndoBuffer.vala"
				_tmp2_ = TRUE;
#line 125 "../src/UndoBuffer.vala"
				while (TRUE) {
#line 915 "UndoBuffer.c"
					gint _tmp4_;
					GArray* _tmp5_;
					guint _tmp6_;
					FILE* _tmp7_;
					GArray* _tmp8_;
					gint _tmp9_;
					UndoItem* _tmp10_;
					gchar* _tmp11_;
					gchar* _tmp12_;
#line 125 "../src/UndoBuffer.vala"
					if (!_tmp2_) {
#line 927 "UndoBuffer.c"
						gint _tmp3_;
#line 125 "../src/UndoBuffer.vala"
						_tmp3_ = i;
#line 125 "../src/UndoBuffer.vala"
						i = _tmp3_ + 1;
#line 933 "UndoBuffer.c"
					}
#line 125 "../src/UndoBuffer.vala"
					_tmp2_ = FALSE;
#line 125 "../src/UndoBuffer.vala"
					_tmp4_ = i;
#line 125 "../src/UndoBuffer.vala"
					_tmp5_ = self->priv->_undo_buffer;
#line 125 "../src/UndoBuffer.vala"
					_tmp6_ = _tmp5_->len;
#line 125 "../src/UndoBuffer.vala"
					if (!(((guint) _tmp4_) < _tmp6_)) {
#line 125 "../src/UndoBuffer.vala"
						break;
#line 947 "UndoBuffer.c"
					}
#line 126 "../src/UndoBuffer.vala"
					_tmp7_ = stdout;
#line 126 "../src/UndoBuffer.vala"
					_tmp8_ = self->priv->_undo_buffer;
#line 126 "../src/UndoBuffer.vala"
					_tmp9_ = i;
#line 126 "../src/UndoBuffer.vala"
					_tmp10_ = g_array_index (_tmp8_, UndoItem*, (guint) _tmp9_);
#line 126 "../src/UndoBuffer.vala"
					_tmp11_ = undo_item_to_string (_tmp10_);
#line 126 "../src/UndoBuffer.vala"
					_tmp12_ = _tmp11_;
#line 126 "../src/UndoBuffer.vala"
					fprintf (_tmp7_, "    %s\n", _tmp12_);
#line 126 "../src/UndoBuffer.vala"
					_g_free0 (_tmp12_);
#line 965 "UndoBuffer.c"
				}
			}
		}
#line 128 "../src/UndoBuffer.vala"
		_tmp13_ = stdout;
#line 128 "../src/UndoBuffer.vala"
		fprintf (_tmp13_, "  Redo Buffer\n-----------\n");
#line 973 "UndoBuffer.c"
		{
			gint i = 0;
#line 129 "../src/UndoBuffer.vala"
			i = 0;
#line 978 "UndoBuffer.c"
			{
				gboolean _tmp14_ = FALSE;
#line 129 "../src/UndoBuffer.vala"
				_tmp14_ = TRUE;
#line 129 "../src/UndoBuffer.vala"
				while (TRUE) {
#line 985 "UndoBuffer.c"
					gint _tmp16_;
					GArray* _tmp17_;
					guint _tmp18_;
					FILE* _tmp19_;
					GArray* _tmp20_;
					gint _tmp21_;
					UndoItem* _tmp22_;
					gchar* _tmp23_;
					gchar* _tmp24_;
#line 129 "../src/UndoBuffer.vala"
					if (!_tmp14_) {
#line 997 "UndoBuffer.c"
						gint _tmp15_;
#line 129 "../src/UndoBuffer.vala"
						_tmp15_ = i;
#line 129 "../src/UndoBuffer.vala"
						i = _tmp15_ + 1;
#line 1003 "UndoBuffer.c"
					}
#line 129 "../src/UndoBuffer.vala"
					_tmp14_ = FALSE;
#line 129 "../src/UndoBuffer.vala"
					_tmp16_ = i;
#line 129 "../src/UndoBuffer.vala"
					_tmp17_ = self->priv->_redo_buffer;
#line 129 "../src/UndoBuffer.vala"
					_tmp18_ = _tmp17_->len;
#line 129 "../src/UndoBuffer.vala"
					if (!(((guint) _tmp16_) < _tmp18_)) {
#line 129 "../src/UndoBuffer.vala"
						break;
#line 1017 "UndoBuffer.c"
					}
#line 130 "../src/UndoBuffer.vala"
					_tmp19_ = stdout;
#line 130 "../src/UndoBuffer.vala"
					_tmp20_ = self->priv->_redo_buffer;
#line 130 "../src/UndoBuffer.vala"
					_tmp21_ = i;
#line 130 "../src/UndoBuffer.vala"
					_tmp22_ = g_array_index (_tmp20_, UndoItem*, (guint) _tmp21_);
#line 130 "../src/UndoBuffer.vala"
					_tmp23_ = undo_item_to_string (_tmp22_);
#line 130 "../src/UndoBuffer.vala"
					_tmp24_ = _tmp23_;
#line 130 "../src/UndoBuffer.vala"
					fprintf (_tmp19_, "    %s\n", _tmp24_);
#line 130 "../src/UndoBuffer.vala"
					_g_free0 (_tmp24_);
#line 1035 "UndoBuffer.c"
				}
			}
		}
	}
}


static void
undo_buffer_class_init (UndoBufferClass * klass)
{
#line 24 "../src/UndoBuffer.vala"
	undo_buffer_parent_class = g_type_class_peek_parent (klass);
#line 24 "../src/UndoBuffer.vala"
	g_type_class_adjust_private_offset (klass, &UndoBuffer_private_offset);
#line 24 "../src/UndoBuffer.vala"
	G_OBJECT_CLASS (klass)->finalize = undo_buffer_finalize;
#line 24 "../src/UndoBuffer.vala"
	undo_buffer_signals[UNDO_BUFFER_BUFFER_CHANGED_SIGNAL] = g_signal_new ("buffer-changed", TYPE_UNDO_BUFFER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_DRAW_AREA);
#line 1054 "UndoBuffer.c"
}


static void
undo_buffer_instance_init (UndoBuffer * self)
{
#line 24 "../src/UndoBuffer.vala"
	self->priv = undo_buffer_get_instance_private (self);
#line 29 "../src/UndoBuffer.vala"
	self->priv->_debug = FALSE;
#line 1065 "UndoBuffer.c"
}


static void
undo_buffer_finalize (GObject * obj)
{
	UndoBuffer * self;
#line 24 "../src/UndoBuffer.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_UNDO_BUFFER, UndoBuffer);
#line 26 "../src/UndoBuffer.vala"
	_g_object_unref0 (self->priv->_da);
#line 27 "../src/UndoBuffer.vala"
	_g_array_unref0 (self->priv->_undo_buffer);
#line 28 "../src/UndoBuffer.vala"
	_g_array_unref0 (self->priv->_redo_buffer);
#line 24 "../src/UndoBuffer.vala"
	G_OBJECT_CLASS (undo_buffer_parent_class)->finalize (obj);
#line 1083 "UndoBuffer.c"
}


GType
undo_buffer_get_type (void)
{
	static volatile gsize undo_buffer_type_id__volatile = 0;
	if (g_once_init_enter (&undo_buffer_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (UndoBufferClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) undo_buffer_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (UndoBuffer), 0, (GInstanceInitFunc) undo_buffer_instance_init, NULL };
		GType undo_buffer_type_id;
		undo_buffer_type_id = g_type_register_static (G_TYPE_OBJECT, "UndoBuffer", &g_define_type_info, 0);
		UndoBuffer_private_offset = g_type_add_instance_private (undo_buffer_type_id, sizeof (UndoBufferPrivate));
		g_once_init_leave (&undo_buffer_type_id__volatile, undo_buffer_type_id);
	}
	return undo_buffer_type_id__volatile;
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



