/* UndoItem.c generated by valac 0.42.7, the Vala compiler
 * generated from UndoItem.vala, do not modify */

/*
* Copyright (c) 2018 (https://github.com/phase1geo/Minder)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Trevor Williams <phase1geo@gmail.com>
*/


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>


#define TYPE_UNDO_ITEM (undo_item_get_type ())
#define UNDO_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_UNDO_ITEM, UndoItem))
#define UNDO_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_UNDO_ITEM, UndoItemClass))
#define IS_UNDO_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_UNDO_ITEM))
#define IS_UNDO_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_UNDO_ITEM))
#define UNDO_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_UNDO_ITEM, UndoItemClass))

typedef struct _UndoItem UndoItem;
typedef struct _UndoItemClass UndoItemClass;
typedef struct _UndoItemPrivate UndoItemPrivate;

#define TYPE_DRAW_AREA (draw_area_get_type ())
#define DRAW_AREA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DRAW_AREA, DrawArea))
#define DRAW_AREA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DRAW_AREA, DrawAreaClass))
#define IS_DRAW_AREA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DRAW_AREA))
#define IS_DRAW_AREA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DRAW_AREA))
#define DRAW_AREA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DRAW_AREA, DrawAreaClass))

typedef struct _DrawArea DrawArea;
typedef struct _DrawAreaClass DrawAreaClass;
enum  {
	UNDO_ITEM_0_PROPERTY,
	UNDO_ITEM_NAME_PROPERTY,
	UNDO_ITEM_ID_PROPERTY,
	UNDO_ITEM_NUM_PROPERTIES
};
static GParamSpec* undo_item_properties[UNDO_ITEM_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))

struct _UndoItem {
	GObject parent_instance;
	UndoItemPrivate * priv;
};

struct _UndoItemClass {
	GObjectClass parent_class;
	void (*undo) (UndoItem* self, DrawArea* da);
	void (*redo) (UndoItem* self, DrawArea* da);
	gboolean (*matches) (UndoItem* self, UndoItem* item);
	void (*replace_with_item) (UndoItem* self, UndoItem* item);
	gchar* (*to_string) (UndoItem* self);
};

struct _UndoItemPrivate {
	gchar* _name;
	gint _id;
};


static gint UndoItem_private_offset;
static gpointer undo_item_parent_class = NULL;

GType undo_item_get_type (void) G_GNUC_CONST;
GType draw_area_get_type (void) G_GNUC_CONST;
UndoItem* undo_item_new (const gchar* name);
UndoItem* undo_item_construct (GType object_type,
                               const gchar* name);
void undo_item_set_name (UndoItem* self,
                         const gchar* value);
void undo_item_undo (UndoItem* self,
                     DrawArea* da);
static void undo_item_real_undo (UndoItem* self,
                          DrawArea* da);
void undo_item_redo (UndoItem* self,
                     DrawArea* da);
static void undo_item_real_redo (UndoItem* self,
                          DrawArea* da);
gboolean undo_item_matches (UndoItem* self,
                            UndoItem* item);
static gboolean undo_item_real_matches (UndoItem* self,
                                 UndoItem* item);
void undo_item_replace_with_item (UndoItem* self,
                                  UndoItem* item);
static void undo_item_real_replace_with_item (UndoItem* self,
                                       UndoItem* item);
gchar* undo_item_to_string (UndoItem* self);
static gchar* undo_item_real_to_string (UndoItem* self);
const gchar* undo_item_get_name (UndoItem* self);
gint undo_item_get_id (UndoItem* self);
void undo_item_set_id (UndoItem* self,
                       gint value);
static void undo_item_finalize (GObject * obj);
static void _vala_undo_item_get_property (GObject * object,
                                   guint property_id,
                                   GValue * value,
                                   GParamSpec * pspec);
static void _vala_undo_item_set_property (GObject * object,
                                   guint property_id,
                                   const GValue * value,
                                   GParamSpec * pspec);


static inline gpointer
undo_item_get_instance_private (UndoItem* self)
{
	return G_STRUCT_MEMBER_P (self, UndoItem_private_offset);
}


UndoItem*
undo_item_construct (GType object_type,
                     const gchar* name)
{
	UndoItem * self = NULL;
#line 30 "../src/UndoItem.vala"
	g_return_val_if_fail (name != NULL, NULL);
#line 30 "../src/UndoItem.vala"
	self = (UndoItem*) g_object_new (object_type, NULL);
#line 31 "../src/UndoItem.vala"
	undo_item_set_name (self, name);
#line 30 "../src/UndoItem.vala"
	return self;
#line 146 "UndoItem.c"
}


UndoItem*
undo_item_new (const gchar* name)
{
#line 30 "../src/UndoItem.vala"
	return undo_item_construct (TYPE_UNDO_ITEM, name);
#line 155 "UndoItem.c"
}


static void
undo_item_real_undo (UndoItem* self,
                     DrawArea* da)
{
#line 35 "../src/UndoItem.vala"
	g_return_if_fail (da != NULL);
#line 165 "UndoItem.c"
}


void
undo_item_undo (UndoItem* self,
                DrawArea* da)
{
#line 35 "../src/UndoItem.vala"
	g_return_if_fail (self != NULL);
#line 35 "../src/UndoItem.vala"
	UNDO_ITEM_GET_CLASS (self)->undo (self, da);
#line 177 "UndoItem.c"
}


static void
undo_item_real_redo (UndoItem* self,
                     DrawArea* da)
{
#line 38 "../src/UndoItem.vala"
	g_return_if_fail (da != NULL);
#line 187 "UndoItem.c"
}


void
undo_item_redo (UndoItem* self,
                DrawArea* da)
{
#line 38 "../src/UndoItem.vala"
	g_return_if_fail (self != NULL);
#line 38 "../src/UndoItem.vala"
	UNDO_ITEM_GET_CLASS (self)->redo (self, da);
#line 199 "UndoItem.c"
}


static gboolean
undo_item_real_matches (UndoItem* self,
                        UndoItem* item)
{
	gboolean result = FALSE;
#line 41 "../src/UndoItem.vala"
	g_return_val_if_fail (item != NULL, FALSE);
#line 42 "../src/UndoItem.vala"
	result = FALSE;
#line 42 "../src/UndoItem.vala"
	return result;
#line 214 "UndoItem.c"
}


gboolean
undo_item_matches (UndoItem* self,
                   UndoItem* item)
{
#line 41 "../src/UndoItem.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 41 "../src/UndoItem.vala"
	return UNDO_ITEM_GET_CLASS (self)->matches (self, item);
#line 226 "UndoItem.c"
}


static void
undo_item_real_replace_with_item (UndoItem* self,
                                  UndoItem* item)
{
#line 45 "../src/UndoItem.vala"
	g_return_if_fail (item != NULL);
#line 236 "UndoItem.c"
}


void
undo_item_replace_with_item (UndoItem* self,
                             UndoItem* item)
{
#line 45 "../src/UndoItem.vala"
	g_return_if_fail (self != NULL);
#line 45 "../src/UndoItem.vala"
	UNDO_ITEM_GET_CLASS (self)->replace_with_item (self, item);
#line 248 "UndoItem.c"
}


static gchar*
undo_item_real_to_string (UndoItem* self)
{
	gchar* result = NULL;
	const gchar* _tmp0_;
	gint _tmp1_;
	gchar* _tmp2_;
#line 50 "../src/UndoItem.vala"
	_tmp0_ = self->priv->_name;
#line 50 "../src/UndoItem.vala"
	_tmp1_ = self->priv->_id;
#line 50 "../src/UndoItem.vala"
	_tmp2_ = g_strdup_printf ("%s [%d]", _tmp0_, _tmp1_);
#line 50 "../src/UndoItem.vala"
	result = _tmp2_;
#line 50 "../src/UndoItem.vala"
	return result;
#line 269 "UndoItem.c"
}


gchar*
undo_item_to_string (UndoItem* self)
{
#line 49 "../src/UndoItem.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 49 "../src/UndoItem.vala"
	return UNDO_ITEM_GET_CLASS (self)->to_string (self);
#line 280 "UndoItem.c"
}


const gchar*
undo_item_get_name (UndoItem* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 26 "../src/UndoItem.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 26 "../src/UndoItem.vala"
	_tmp0_ = self->priv->_name;
#line 26 "../src/UndoItem.vala"
	result = _tmp0_;
#line 26 "../src/UndoItem.vala"
	return result;
#line 297 "UndoItem.c"
}


void
undo_item_set_name (UndoItem* self,
                    const gchar* value)
{
#line 26 "../src/UndoItem.vala"
	g_return_if_fail (self != NULL);
#line 26 "../src/UndoItem.vala"
	if (g_strcmp0 (value, undo_item_get_name (self)) != 0) {
#line 309 "UndoItem.c"
		gchar* _tmp0_;
#line 26 "../src/UndoItem.vala"
		_tmp0_ = g_strdup (value);
#line 26 "../src/UndoItem.vala"
		_g_free0 (self->priv->_name);
#line 26 "../src/UndoItem.vala"
		self->priv->_name = _tmp0_;
#line 26 "../src/UndoItem.vala"
		g_object_notify_by_pspec ((GObject *) self, undo_item_properties[UNDO_ITEM_NAME_PROPERTY]);
#line 319 "UndoItem.c"
	}
}


gint
undo_item_get_id (UndoItem* self)
{
	gint result;
	gint _tmp0_;
#line 27 "../src/UndoItem.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 27 "../src/UndoItem.vala"
	_tmp0_ = self->priv->_id;
#line 27 "../src/UndoItem.vala"
	result = _tmp0_;
#line 27 "../src/UndoItem.vala"
	return result;
#line 337 "UndoItem.c"
}


void
undo_item_set_id (UndoItem* self,
                  gint value)
{
#line 27 "../src/UndoItem.vala"
	g_return_if_fail (self != NULL);
#line 27 "../src/UndoItem.vala"
	if (undo_item_get_id (self) != value) {
#line 27 "../src/UndoItem.vala"
		self->priv->_id = value;
#line 27 "../src/UndoItem.vala"
		g_object_notify_by_pspec ((GObject *) self, undo_item_properties[UNDO_ITEM_ID_PROPERTY]);
#line 353 "UndoItem.c"
	}
}


static void
undo_item_class_init (UndoItemClass * klass)
{
#line 24 "../src/UndoItem.vala"
	undo_item_parent_class = g_type_class_peek_parent (klass);
#line 24 "../src/UndoItem.vala"
	g_type_class_adjust_private_offset (klass, &UndoItem_private_offset);
#line 24 "../src/UndoItem.vala"
	((UndoItemClass *) klass)->undo = (void (*) (UndoItem*, DrawArea*)) undo_item_real_undo;
#line 24 "../src/UndoItem.vala"
	((UndoItemClass *) klass)->redo = (void (*) (UndoItem*, DrawArea*)) undo_item_real_redo;
#line 24 "../src/UndoItem.vala"
	((UndoItemClass *) klass)->matches = (gboolean (*) (UndoItem*, UndoItem*)) undo_item_real_matches;
#line 24 "../src/UndoItem.vala"
	((UndoItemClass *) klass)->replace_with_item = (void (*) (UndoItem*, UndoItem*)) undo_item_real_replace_with_item;
#line 24 "../src/UndoItem.vala"
	((UndoItemClass *) klass)->to_string = (gchar* (*) (UndoItem*)) undo_item_real_to_string;
#line 24 "../src/UndoItem.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_undo_item_get_property;
#line 24 "../src/UndoItem.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_undo_item_set_property;
#line 24 "../src/UndoItem.vala"
	G_OBJECT_CLASS (klass)->finalize = undo_item_finalize;
#line 24 "../src/UndoItem.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), UNDO_ITEM_NAME_PROPERTY, undo_item_properties[UNDO_ITEM_NAME_PROPERTY] = g_param_spec_string ("name", "name", "name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 24 "../src/UndoItem.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), UNDO_ITEM_ID_PROPERTY, undo_item_properties[UNDO_ITEM_ID_PROPERTY] = g_param_spec_int ("id", "id", "id", G_MININT, G_MAXINT, -1, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 385 "UndoItem.c"
}


static void
undo_item_instance_init (UndoItem * self)
{
	gchar* _tmp0_;
#line 24 "../src/UndoItem.vala"
	self->priv = undo_item_get_instance_private (self);
#line 26 "../src/UndoItem.vala"
	_tmp0_ = g_strdup ("");
#line 26 "../src/UndoItem.vala"
	self->priv->_name = _tmp0_;
#line 27 "../src/UndoItem.vala"
	self->priv->_id = -1;
#line 401 "UndoItem.c"
}


static void
undo_item_finalize (GObject * obj)
{
	UndoItem * self;
#line 24 "../src/UndoItem.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_UNDO_ITEM, UndoItem);
#line 26 "../src/UndoItem.vala"
	_g_free0 (self->priv->_name);
#line 24 "../src/UndoItem.vala"
	G_OBJECT_CLASS (undo_item_parent_class)->finalize (obj);
#line 415 "UndoItem.c"
}


GType
undo_item_get_type (void)
{
	static volatile gsize undo_item_type_id__volatile = 0;
	if (g_once_init_enter (&undo_item_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (UndoItemClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) undo_item_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (UndoItem), 0, (GInstanceInitFunc) undo_item_instance_init, NULL };
		GType undo_item_type_id;
		undo_item_type_id = g_type_register_static (G_TYPE_OBJECT, "UndoItem", &g_define_type_info, 0);
		UndoItem_private_offset = g_type_add_instance_private (undo_item_type_id, sizeof (UndoItemPrivate));
		g_once_init_leave (&undo_item_type_id__volatile, undo_item_type_id);
	}
	return undo_item_type_id__volatile;
}


static void
_vala_undo_item_get_property (GObject * object,
                              guint property_id,
                              GValue * value,
                              GParamSpec * pspec)
{
	UndoItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_UNDO_ITEM, UndoItem);
#line 24 "../src/UndoItem.vala"
	switch (property_id) {
#line 24 "../src/UndoItem.vala"
		case UNDO_ITEM_NAME_PROPERTY:
#line 24 "../src/UndoItem.vala"
		g_value_set_string (value, undo_item_get_name (self));
#line 24 "../src/UndoItem.vala"
		break;
#line 24 "../src/UndoItem.vala"
		case UNDO_ITEM_ID_PROPERTY:
#line 24 "../src/UndoItem.vala"
		g_value_set_int (value, undo_item_get_id (self));
#line 24 "../src/UndoItem.vala"
		break;
#line 456 "UndoItem.c"
		default:
#line 24 "../src/UndoItem.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../src/UndoItem.vala"
		break;
#line 462 "UndoItem.c"
	}
}


static void
_vala_undo_item_set_property (GObject * object,
                              guint property_id,
                              const GValue * value,
                              GParamSpec * pspec)
{
	UndoItem * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_UNDO_ITEM, UndoItem);
#line 24 "../src/UndoItem.vala"
	switch (property_id) {
#line 24 "../src/UndoItem.vala"
		case UNDO_ITEM_NAME_PROPERTY:
#line 24 "../src/UndoItem.vala"
		undo_item_set_name (self, g_value_get_string (value));
#line 24 "../src/UndoItem.vala"
		break;
#line 24 "../src/UndoItem.vala"
		case UNDO_ITEM_ID_PROPERTY:
#line 24 "../src/UndoItem.vala"
		undo_item_set_id (self, g_value_get_int (value));
#line 24 "../src/UndoItem.vala"
		break;
#line 489 "UndoItem.c"
		default:
#line 24 "../src/UndoItem.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../src/UndoItem.vala"
		break;
#line 495 "UndoItem.c"
	}
}



