/* LayoutManual.c generated by valac 0.42.7, the Vala compiler
 * generated from LayoutManual.vala, do not modify */

/*
* Copyright (c) 2018 (https://github.com/phase1geo/Minder)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Trevor Williams <phase1geo@gmail.com>
*/


#include <glib.h>
#include <glib-object.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>


#define TYPE_LAYOUT (layout_get_type ())
#define LAYOUT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LAYOUT, Layout))
#define LAYOUT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LAYOUT, LayoutClass))
#define IS_LAYOUT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LAYOUT))
#define IS_LAYOUT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LAYOUT))
#define LAYOUT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LAYOUT, LayoutClass))

typedef struct _Layout Layout;
typedef struct _LayoutClass LayoutClass;
typedef struct _LayoutPrivate LayoutPrivate;
typedef enum  {
	NODE_SIDE_LEFT = 1,
	NODE_SIDE_TOP = 2,
	NODE_SIDE_RIGHT = 4,
	NODE_SIDE_BOTTOM = 8
} NodeSide;


#define TYPE_NODE_SIDE (node_side_get_type ())

#define TYPE_NODE (node_get_type ())
#define NODE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NODE, Node))
#define NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NODE, NodeClass))
#define IS_NODE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NODE))
#define IS_NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NODE))
#define NODE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NODE, NodeClass))

typedef struct _Node Node;
typedef struct _NodeClass NodeClass;

#define TYPE_NODE_BOUNDS (node_bounds_get_type ())
typedef struct _NodeBounds NodeBounds;

#define TYPE_LAYOUT_MANUAL (layout_manual_get_type ())
#define LAYOUT_MANUAL(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LAYOUT_MANUAL, LayoutManual))
#define LAYOUT_MANUAL_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LAYOUT_MANUAL, LayoutManualClass))
#define IS_LAYOUT_MANUAL(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LAYOUT_MANUAL))
#define IS_LAYOUT_MANUAL_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LAYOUT_MANUAL))
#define LAYOUT_MANUAL_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LAYOUT_MANUAL, LayoutManualClass))

typedef struct _LayoutManual LayoutManual;
typedef struct _LayoutManualClass LayoutManualClass;
typedef struct _LayoutManualPrivate LayoutManualPrivate;
enum  {
	LAYOUT_MANUAL_0_PROPERTY,
	LAYOUT_MANUAL_NUM_PROPERTIES
};
static GParamSpec* layout_manual_properties[LAYOUT_MANUAL_NUM_PROPERTIES];

struct _NodeBounds {
	gdouble x;
	gdouble y;
	gdouble width;
	gdouble height;
};

struct _Layout {
	GObject parent_instance;
	LayoutPrivate * priv;
	gdouble _pc_gap;
	gdouble _rt_gap;
};

struct _LayoutClass {
	GObjectClass parent_class;
	NodeSide (*side_mapping) (Layout* self, NodeSide side);
	void (*initialize) (Layout* self, Node* parent);
	void (*bbox) (Layout* self, Node* parent, gint side_mask, NodeBounds* result);
	void (*adjust_tree) (Layout* self, Node* parent, gint child_index, gint side_mask, gdouble amount);
	void (*adjust_tree_all) (Layout* self, Node* n, NodeBounds* prev, gdouble amount, const gchar* msg);
	void (*propagate_side) (Layout* self, Node* parent, NodeSide side);
	NodeSide (*get_side) (Layout* self, Node* n);
	void (*set_side) (Layout* self, Node* current);
	void (*handle_update_by_edit) (Layout* self, Node* n, gdouble diffw, gdouble diffh);
	void (*handle_update_by_fold) (Layout* self, Node* n);
	gdouble (*get_insert_adjust) (Layout* self, Node* child);
	void (*handle_update_by_insert) (Layout* self, Node* parent, Node* child, gint pos);
	void (*handle_update_by_delete) (Layout* self, Node* parent, gint index, NodeSide side, gdouble size);
	void (*position_root) (Layout* self, Node* last, Node* n);
};

struct _LayoutManual {
	Layout parent_instance;
	LayoutManualPrivate * priv;
};

struct _LayoutManualClass {
	LayoutClass parent_class;
};


static gpointer layout_manual_parent_class = NULL;

GType layout_get_type (void) G_GNUC_CONST;
GType node_side_get_type (void) G_GNUC_CONST;
GType node_get_type (void) G_GNUC_CONST;
GType node_bounds_get_type (void) G_GNUC_CONST;
NodeBounds* node_bounds_dup (const NodeBounds* self);
void node_bounds_free (NodeBounds* self);
GType layout_manual_get_type (void) G_GNUC_CONST;
LayoutManual* layout_manual_new (void);
LayoutManual* layout_manual_construct (GType object_type);
Layout* layout_new (void);
Layout* layout_construct (GType object_type);
void layout_set_name (Layout* self,
                      const gchar* value);
void layout_set_icon (Layout* self,
                      const gchar* value);
void layout_set_balanceable (Layout* self,
                             gboolean value);
static void layout_manual_real_initialize (Layout* base,
                                    Node* parent);
static NodeSide layout_manual_real_side_mapping (Layout* base,
                                          NodeSide side);
static void layout_manual_real_handle_update_by_edit (Layout* base,
                                               Node* n,
                                               gdouble diffw,
                                               gdouble diffh);
static void layout_manual_real_handle_update_by_fold (Layout* base,
                                               Node* n);
static void layout_manual_real_handle_update_by_insert (Layout* base,
                                                 Node* parent,
                                                 Node* child,
                                                 gint pos);
gboolean node_get_attached (Node* self);
void layout_handle_update_by_insert (Layout* self,
                                     Node* parent,
                                     Node* child,
                                     gint pos);
static void layout_manual_real_handle_update_by_delete (Layout* base,
                                                 Node* parent,
                                                 gint index,
                                                 NodeSide side,
                                                 gdouble size);


LayoutManual*
layout_manual_construct (GType object_type)
{
	LayoutManual * self = NULL;
#line 25 "../src/layouts/LayoutManual.vala"
	self = (LayoutManual*) layout_construct (object_type);
#line 26 "../src/layouts/LayoutManual.vala"
	layout_set_name ((Layout*) self, _ ("Manual"));
#line 27 "../src/layouts/LayoutManual.vala"
	layout_set_icon ((Layout*) self, "minder-layout-manual-symbolic");
#line 28 "../src/layouts/LayoutManual.vala"
	layout_set_balanceable ((Layout*) self, FALSE);
#line 25 "../src/layouts/LayoutManual.vala"
	return self;
#line 186 "LayoutManual.c"
}


LayoutManual*
layout_manual_new (void)
{
#line 25 "../src/layouts/LayoutManual.vala"
	return layout_manual_construct (TYPE_LAYOUT_MANUAL);
#line 195 "LayoutManual.c"
}


static void
layout_manual_real_initialize (Layout* base,
                               Node* parent)
{
	LayoutManual * self;
#line 32 "../src/layouts/LayoutManual.vala"
	self = (LayoutManual*) base;
#line 32 "../src/layouts/LayoutManual.vala"
	g_return_if_fail (parent != NULL);
#line 208 "LayoutManual.c"
}


static NodeSide
layout_manual_real_side_mapping (Layout* base,
                                 NodeSide side)
{
	LayoutManual * self;
	NodeSide result = 0;
#line 35 "../src/layouts/LayoutManual.vala"
	self = (LayoutManual*) base;
#line 36 "../src/layouts/LayoutManual.vala"
	result = side;
#line 36 "../src/layouts/LayoutManual.vala"
	return result;
#line 224 "LayoutManual.c"
}


static void
layout_manual_real_handle_update_by_edit (Layout* base,
                                          Node* n,
                                          gdouble diffw,
                                          gdouble diffh)
{
	LayoutManual * self;
#line 40 "../src/layouts/LayoutManual.vala"
	self = (LayoutManual*) base;
#line 40 "../src/layouts/LayoutManual.vala"
	g_return_if_fail (n != NULL);
#line 239 "LayoutManual.c"
}


static void
layout_manual_real_handle_update_by_fold (Layout* base,
                                          Node* n)
{
	LayoutManual * self;
#line 43 "../src/layouts/LayoutManual.vala"
	self = (LayoutManual*) base;
#line 43 "../src/layouts/LayoutManual.vala"
	g_return_if_fail (n != NULL);
#line 252 "LayoutManual.c"
}


static void
layout_manual_real_handle_update_by_insert (Layout* base,
                                            Node* parent,
                                            Node* child,
                                            gint pos)
{
	LayoutManual * self;
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 46 "../src/layouts/LayoutManual.vala"
	self = (LayoutManual*) base;
#line 46 "../src/layouts/LayoutManual.vala"
	g_return_if_fail (parent != NULL);
#line 46 "../src/layouts/LayoutManual.vala"
	g_return_if_fail (child != NULL);
#line 47 "../src/layouts/LayoutManual.vala"
	_tmp0_ = node_get_attached (child);
#line 47 "../src/layouts/LayoutManual.vala"
	_tmp1_ = _tmp0_;
#line 47 "../src/layouts/LayoutManual.vala"
	if (!_tmp1_) {
#line 48 "../src/layouts/LayoutManual.vala"
		LAYOUT_CLASS (layout_manual_parent_class)->handle_update_by_insert (G_TYPE_CHECK_INSTANCE_CAST (self, TYPE_LAYOUT, Layout), parent, child, pos);
#line 279 "LayoutManual.c"
	}
}


static void
layout_manual_real_handle_update_by_delete (Layout* base,
                                            Node* parent,
                                            gint index,
                                            NodeSide side,
                                            gdouble size)
{
	LayoutManual * self;
#line 53 "../src/layouts/LayoutManual.vala"
	self = (LayoutManual*) base;
#line 53 "../src/layouts/LayoutManual.vala"
	g_return_if_fail (parent != NULL);
#line 296 "LayoutManual.c"
}


static void
layout_manual_class_init (LayoutManualClass * klass)
{
#line 22 "../src/layouts/LayoutManual.vala"
	layout_manual_parent_class = g_type_class_peek_parent (klass);
#line 22 "../src/layouts/LayoutManual.vala"
	((LayoutClass *) klass)->initialize = (void (*) (Layout*, Node*)) layout_manual_real_initialize;
#line 22 "../src/layouts/LayoutManual.vala"
	((LayoutClass *) klass)->side_mapping = (NodeSide (*) (Layout*, NodeSide)) layout_manual_real_side_mapping;
#line 22 "../src/layouts/LayoutManual.vala"
	((LayoutClass *) klass)->handle_update_by_edit = (void (*) (Layout*, Node*, gdouble, gdouble)) layout_manual_real_handle_update_by_edit;
#line 22 "../src/layouts/LayoutManual.vala"
	((LayoutClass *) klass)->handle_update_by_fold = (void (*) (Layout*, Node*)) layout_manual_real_handle_update_by_fold;
#line 22 "../src/layouts/LayoutManual.vala"
	((LayoutClass *) klass)->handle_update_by_insert = (void (*) (Layout*, Node*, Node*, gint)) layout_manual_real_handle_update_by_insert;
#line 22 "../src/layouts/LayoutManual.vala"
	((LayoutClass *) klass)->handle_update_by_delete = (void (*) (Layout*, Node*, gint, NodeSide, gdouble)) layout_manual_real_handle_update_by_delete;
#line 317 "LayoutManual.c"
}


static void
layout_manual_instance_init (LayoutManual * self)
{
}


GType
layout_manual_get_type (void)
{
	static volatile gsize layout_manual_type_id__volatile = 0;
	if (g_once_init_enter (&layout_manual_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (LayoutManualClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) layout_manual_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LayoutManual), 0, (GInstanceInitFunc) layout_manual_instance_init, NULL };
		GType layout_manual_type_id;
		layout_manual_type_id = g_type_register_static (TYPE_LAYOUT, "LayoutManual", &g_define_type_info, 0);
		g_once_init_leave (&layout_manual_type_id__volatile, layout_manual_type_id);
	}
	return layout_manual_type_id__volatile;
}



