/* LinkTypeStraight.c generated by valac 0.42.7, the Vala compiler
 * generated from LinkTypeStraight.vala, do not modify */

/*
* Copyright (c) 2018 (https://github.com/phase1geo/Minder)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Trevor Williams <phase1geo@gmail.com>
*/


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <cairo.h>
#include <float.h>
#include <math.h>
#include <glib/gi18n-lib.h>


#define TYPE_LINK_TYPE (link_type_get_type ())
#define LINK_TYPE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LINK_TYPE, LinkType))
#define IS_LINK_TYPE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LINK_TYPE))
#define LINK_TYPE_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), TYPE_LINK_TYPE, LinkTypeIface))

typedef struct _LinkType LinkType;
typedef struct _LinkTypeIface LinkTypeIface;

#define TYPE_NODE (node_get_type ())
#define NODE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NODE, Node))
#define NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NODE, NodeClass))
#define IS_NODE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NODE))
#define IS_NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NODE))
#define NODE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NODE, NodeClass))

typedef struct _Node Node;
typedef struct _NodeClass NodeClass;

#define TYPE_LINK_TYPE_STRAIGHT (link_type_straight_get_type ())
#define LINK_TYPE_STRAIGHT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_LINK_TYPE_STRAIGHT, LinkTypeStraight))
#define LINK_TYPE_STRAIGHT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_LINK_TYPE_STRAIGHT, LinkTypeStraightClass))
#define IS_LINK_TYPE_STRAIGHT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_LINK_TYPE_STRAIGHT))
#define IS_LINK_TYPE_STRAIGHT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_LINK_TYPE_STRAIGHT))
#define LINK_TYPE_STRAIGHT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_LINK_TYPE_STRAIGHT, LinkTypeStraightClass))

typedef struct _LinkTypeStraight LinkTypeStraight;
typedef struct _LinkTypeStraightClass LinkTypeStraightClass;
typedef struct _LinkTypeStraightPrivate LinkTypeStraightPrivate;
enum  {
	LINK_TYPE_STRAIGHT_0_PROPERTY,
	LINK_TYPE_STRAIGHT_NUM_PROPERTIES
};
static GParamSpec* link_type_straight_properties[LINK_TYPE_STRAIGHT_NUM_PROPERTIES];
typedef enum  {
	NODE_SIDE_LEFT = 1,
	NODE_SIDE_TOP = 2,
	NODE_SIDE_RIGHT = 4,
	NODE_SIDE_BOTTOM = 8
} NodeSide;


#define TYPE_NODE_SIDE (node_side_get_type ())

#define TYPE_STYLE (style_get_type ())
#define STYLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_STYLE, Style))
#define STYLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_STYLE, StyleClass))
#define IS_STYLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_STYLE))
#define IS_STYLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_STYLE))
#define STYLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_STYLE, StyleClass))

typedef struct _Style Style;
typedef struct _StyleClass StyleClass;
#define _style_unref0(var) ((var == NULL) ? NULL : (var = (style_unref (var), NULL)))

struct _LinkTypeIface {
	GTypeInterface parent_iface;
	gchar* (*name) (LinkType* self);
	gchar* (*display_name) (LinkType* self);
	gchar* (*icon_name) (LinkType* self);
	void (*draw) (LinkType* self, cairo_t* ctx, Node* to_node, gdouble from_x, gdouble from_y, gdouble to_x, gdouble to_y, gdouble* fx, gdouble* fy, gdouble* tx, gdouble* ty);
};

struct _LinkTypeStraight {
	GObject parent_instance;
	LinkTypeStraightPrivate * priv;
};

struct _LinkTypeStraightClass {
	GObjectClass parent_class;
};


static gpointer link_type_straight_parent_class = NULL;
static LinkTypeIface * link_type_straight_link_type_parent_iface = NULL;

GType node_get_type (void) G_GNUC_CONST;
GType link_type_get_type (void) G_GNUC_CONST;
GType link_type_straight_get_type (void) G_GNUC_CONST;
LinkTypeStraight* link_type_straight_new (void);
LinkTypeStraight* link_type_straight_construct (GType object_type);
static gchar* link_type_straight_real_name (LinkType* base);
static gchar* link_type_straight_real_display_name (LinkType* base);
static gchar* link_type_straight_real_icon_name (LinkType* base);
GType node_side_get_type (void) G_GNUC_CONST;
static gdouble link_type_straight_adjust_b (LinkTypeStraight* self,
                                     NodeSide side,
                                     gdouble adjust,
                                     gdouble x,
                                     gdouble y);
static gdouble link_type_straight_calc_to_x (LinkTypeStraight* self,
                                      Node* to_node,
                                      gboolean from_lt_to,
                                      gdouble adjusted,
                                      gdouble adjustA,
                                      gboolean* force);
gdouble node_get_posx (Node* self);
gdouble node_get_width (Node* self);
static gdouble link_type_straight_calc_to_y (LinkTypeStraight* self,
                                      Node* to_node,
                                      gboolean from_lt_to,
                                      gdouble adjusted,
                                      gdouble adjustA,
                                      gboolean* force);
gdouble node_get_posy (Node* self);
gdouble node_get_height (Node* self);
static void link_type_straight_real_draw (LinkType* base,
                                   cairo_t* ctx,
                                   Node* to_node,
                                   gdouble from_x,
                                   gdouble from_y,
                                   gdouble to_x,
                                   gdouble to_y,
                                   gdouble* tailx,
                                   gdouble* taily,
                                   gdouble* tipx,
                                   gdouble* tipy);
gpointer style_ref (gpointer instance);
void style_unref (gpointer instance);
GParamSpec* param_spec_style (const gchar* name,
                              const gchar* nick,
                              const gchar* blurb,
                              GType object_type,
                              GParamFlags flags);
void value_set_style (GValue* value,
                      gpointer v_object);
void value_take_style (GValue* value,
                       gpointer v_object);
gpointer value_get_style (const GValue* value);
GType style_get_type (void) G_GNUC_CONST;
Style* node_get_style (Node* self);
NodeSide node_get_side (Node* self);
gdouble link_type_adjust_a (LinkType* self,
                            Style* style);
gboolean* style_get_link_arrow (Style* self);
gdouble link_type_adjust_tip (LinkType* self,
                              Style* style);


LinkTypeStraight*
link_type_straight_construct (GType object_type)
{
	LinkTypeStraight * self = NULL;
#line 25 "../src/styles/LinkTypeStraight.vala"
	self = (LinkTypeStraight*) g_object_new (object_type, NULL);
#line 25 "../src/styles/LinkTypeStraight.vala"
	return self;
#line 183 "LinkTypeStraight.c"
}


LinkTypeStraight*
link_type_straight_new (void)
{
#line 25 "../src/styles/LinkTypeStraight.vala"
	return link_type_straight_construct (TYPE_LINK_TYPE_STRAIGHT);
#line 192 "LinkTypeStraight.c"
}


static gchar*
link_type_straight_real_name (LinkType* base)
{
	LinkTypeStraight * self;
	gchar* result = NULL;
	gchar* _tmp0_;
#line 28 "../src/styles/LinkTypeStraight.vala"
	self = (LinkTypeStraight*) base;
#line 29 "../src/styles/LinkTypeStraight.vala"
	_tmp0_ = g_strdup ("straight");
#line 29 "../src/styles/LinkTypeStraight.vala"
	result = _tmp0_;
#line 29 "../src/styles/LinkTypeStraight.vala"
	return result;
#line 210 "LinkTypeStraight.c"
}


static gchar*
link_type_straight_real_display_name (LinkType* base)
{
	LinkTypeStraight * self;
	gchar* result = NULL;
	gchar* _tmp0_;
#line 33 "../src/styles/LinkTypeStraight.vala"
	self = (LinkTypeStraight*) base;
#line 34 "../src/styles/LinkTypeStraight.vala"
	_tmp0_ = g_strdup (_ ("Straight"));
#line 34 "../src/styles/LinkTypeStraight.vala"
	result = _tmp0_;
#line 34 "../src/styles/LinkTypeStraight.vala"
	return result;
#line 228 "LinkTypeStraight.c"
}


static gchar*
link_type_straight_real_icon_name (LinkType* base)
{
	LinkTypeStraight * self;
	gchar* result = NULL;
	gchar* _tmp0_;
#line 38 "../src/styles/LinkTypeStraight.vala"
	self = (LinkTypeStraight*) base;
#line 39 "../src/styles/LinkTypeStraight.vala"
	_tmp0_ = g_strdup ("minder-link-straight-symbolic");
#line 39 "../src/styles/LinkTypeStraight.vala"
	result = _tmp0_;
#line 39 "../src/styles/LinkTypeStraight.vala"
	return result;
#line 246 "LinkTypeStraight.c"
}


static gdouble
link_type_straight_adjust_b (LinkTypeStraight* self,
                             NodeSide side,
                             gdouble adjust,
                             gdouble x,
                             gdouble y)
{
	gdouble result = 0.0;
#line 42 "../src/styles/LinkTypeStraight.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 43 "../src/styles/LinkTypeStraight.vala"
	switch (side) {
#line 43 "../src/styles/LinkTypeStraight.vala"
		case NODE_SIDE_LEFT:
#line 264 "LinkTypeStraight.c"
		{
#line 44 "../src/styles/LinkTypeStraight.vala"
			result = (adjust * y) / x;
#line 44 "../src/styles/LinkTypeStraight.vala"
			return result;
#line 270 "LinkTypeStraight.c"
		}
#line 43 "../src/styles/LinkTypeStraight.vala"
		case NODE_SIDE_RIGHT:
#line 274 "LinkTypeStraight.c"
		{
#line 45 "../src/styles/LinkTypeStraight.vala"
			result = (adjust * y) / x;
#line 45 "../src/styles/LinkTypeStraight.vala"
			return result;
#line 280 "LinkTypeStraight.c"
		}
#line 43 "../src/styles/LinkTypeStraight.vala"
		case NODE_SIDE_TOP:
#line 284 "LinkTypeStraight.c"
		{
#line 46 "../src/styles/LinkTypeStraight.vala"
			result = (adjust * x) / y;
#line 46 "../src/styles/LinkTypeStraight.vala"
			return result;
#line 290 "LinkTypeStraight.c"
		}
#line 43 "../src/styles/LinkTypeStraight.vala"
		case NODE_SIDE_BOTTOM:
#line 294 "LinkTypeStraight.c"
		{
#line 47 "../src/styles/LinkTypeStraight.vala"
			result = (adjust * x) / y;
#line 47 "../src/styles/LinkTypeStraight.vala"
			return result;
#line 300 "LinkTypeStraight.c"
		}
		default:
#line 43 "../src/styles/LinkTypeStraight.vala"
		break;
#line 305 "LinkTypeStraight.c"
	}
#line 49 "../src/styles/LinkTypeStraight.vala"
	result = (gdouble) 0;
#line 49 "../src/styles/LinkTypeStraight.vala"
	return result;
#line 311 "LinkTypeStraight.c"
}


static gdouble
link_type_straight_calc_to_x (LinkTypeStraight* self,
                              Node* to_node,
                              gboolean from_lt_to,
                              gdouble adjusted,
                              gdouble adjustA,
                              gboolean* force)
{
	gdouble result = 0.0;
	gdouble left = 0.0;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble right = 0.0;
	gdouble _tmp2_;
	gdouble _tmp3_;
	gdouble _tmp4_;
	gdouble _tmp5_;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
	gdouble _tmp8_;
#line 52 "../src/styles/LinkTypeStraight.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 52 "../src/styles/LinkTypeStraight.vala"
	g_return_val_if_fail (to_node != NULL, 0.0);
#line 53 "../src/styles/LinkTypeStraight.vala"
	_tmp0_ = node_get_posx (to_node);
#line 53 "../src/styles/LinkTypeStraight.vala"
	_tmp1_ = _tmp0_;
#line 53 "../src/styles/LinkTypeStraight.vala"
	left = _tmp1_ - adjustA;
#line 54 "../src/styles/LinkTypeStraight.vala"
	_tmp2_ = node_get_posx (to_node);
#line 54 "../src/styles/LinkTypeStraight.vala"
	_tmp3_ = _tmp2_;
#line 54 "../src/styles/LinkTypeStraight.vala"
	_tmp4_ = node_get_width (to_node);
#line 54 "../src/styles/LinkTypeStraight.vala"
	_tmp5_ = _tmp4_;
#line 54 "../src/styles/LinkTypeStraight.vala"
	right = (_tmp3_ + _tmp5_) + adjustA;
#line 55 "../src/styles/LinkTypeStraight.vala"
	_tmp8_ = left;
#line 55 "../src/styles/LinkTypeStraight.vala"
	if (adjusted < _tmp8_) {
#line 55 "../src/styles/LinkTypeStraight.vala"
		_tmp7_ = TRUE;
#line 361 "LinkTypeStraight.c"
	} else {
		gdouble _tmp9_;
#line 55 "../src/styles/LinkTypeStraight.vala"
		_tmp9_ = right;
#line 55 "../src/styles/LinkTypeStraight.vala"
		_tmp7_ = adjusted > _tmp9_;
#line 368 "LinkTypeStraight.c"
	}
#line 55 "../src/styles/LinkTypeStraight.vala"
	if (_tmp7_) {
#line 55 "../src/styles/LinkTypeStraight.vala"
		_tmp6_ = TRUE;
#line 374 "LinkTypeStraight.c"
	} else {
#line 55 "../src/styles/LinkTypeStraight.vala"
		_tmp6_ = *force;
#line 378 "LinkTypeStraight.c"
	}
#line 55 "../src/styles/LinkTypeStraight.vala"
	if (_tmp6_) {
#line 382 "LinkTypeStraight.c"
		gdouble _tmp10_ = 0.0;
#line 56 "../src/styles/LinkTypeStraight.vala"
		*force = TRUE;
#line 57 "../src/styles/LinkTypeStraight.vala"
		if (from_lt_to) {
#line 388 "LinkTypeStraight.c"
			gdouble _tmp11_;
#line 57 "../src/styles/LinkTypeStraight.vala"
			_tmp11_ = left;
#line 57 "../src/styles/LinkTypeStraight.vala"
			_tmp10_ = _tmp11_;
#line 394 "LinkTypeStraight.c"
		} else {
			gdouble _tmp12_;
#line 57 "../src/styles/LinkTypeStraight.vala"
			_tmp12_ = right;
#line 57 "../src/styles/LinkTypeStraight.vala"
			_tmp10_ = _tmp12_;
#line 401 "LinkTypeStraight.c"
		}
#line 57 "../src/styles/LinkTypeStraight.vala"
		result = _tmp10_;
#line 57 "../src/styles/LinkTypeStraight.vala"
		return result;
#line 407 "LinkTypeStraight.c"
	}
#line 59 "../src/styles/LinkTypeStraight.vala"
	result = adjusted;
#line 59 "../src/styles/LinkTypeStraight.vala"
	return result;
#line 413 "LinkTypeStraight.c"
}


static gdouble
link_type_straight_calc_to_y (LinkTypeStraight* self,
                              Node* to_node,
                              gboolean from_lt_to,
                              gdouble adjusted,
                              gdouble adjustA,
                              gboolean* force)
{
	gdouble result = 0.0;
	gdouble top = 0.0;
	gdouble _tmp0_;
	gdouble _tmp1_;
	gdouble bottom = 0.0;
	gdouble _tmp2_;
	gdouble _tmp3_;
	gdouble _tmp4_;
	gdouble _tmp5_;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
	gdouble _tmp8_;
#line 62 "../src/styles/LinkTypeStraight.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 62 "../src/styles/LinkTypeStraight.vala"
	g_return_val_if_fail (to_node != NULL, 0.0);
#line 63 "../src/styles/LinkTypeStraight.vala"
	_tmp0_ = node_get_posy (to_node);
#line 63 "../src/styles/LinkTypeStraight.vala"
	_tmp1_ = _tmp0_;
#line 63 "../src/styles/LinkTypeStraight.vala"
	top = _tmp1_ - adjustA;
#line 64 "../src/styles/LinkTypeStraight.vala"
	_tmp2_ = node_get_posy (to_node);
#line 64 "../src/styles/LinkTypeStraight.vala"
	_tmp3_ = _tmp2_;
#line 64 "../src/styles/LinkTypeStraight.vala"
	_tmp4_ = node_get_height (to_node);
#line 64 "../src/styles/LinkTypeStraight.vala"
	_tmp5_ = _tmp4_;
#line 64 "../src/styles/LinkTypeStraight.vala"
	bottom = (_tmp3_ + _tmp5_) + adjustA;
#line 65 "../src/styles/LinkTypeStraight.vala"
	_tmp8_ = top;
#line 65 "../src/styles/LinkTypeStraight.vala"
	if (adjusted < _tmp8_) {
#line 65 "../src/styles/LinkTypeStraight.vala"
		_tmp7_ = TRUE;
#line 463 "LinkTypeStraight.c"
	} else {
		gdouble _tmp9_;
#line 65 "../src/styles/LinkTypeStraight.vala"
		_tmp9_ = bottom;
#line 65 "../src/styles/LinkTypeStraight.vala"
		_tmp7_ = adjusted > _tmp9_;
#line 470 "LinkTypeStraight.c"
	}
#line 65 "../src/styles/LinkTypeStraight.vala"
	if (_tmp7_) {
#line 65 "../src/styles/LinkTypeStraight.vala"
		_tmp6_ = TRUE;
#line 476 "LinkTypeStraight.c"
	} else {
#line 65 "../src/styles/LinkTypeStraight.vala"
		_tmp6_ = *force;
#line 480 "LinkTypeStraight.c"
	}
#line 65 "../src/styles/LinkTypeStraight.vala"
	if (_tmp6_) {
#line 484 "LinkTypeStraight.c"
		gdouble _tmp10_ = 0.0;
#line 66 "../src/styles/LinkTypeStraight.vala"
		*force = TRUE;
#line 67 "../src/styles/LinkTypeStraight.vala"
		if (from_lt_to) {
#line 490 "LinkTypeStraight.c"
			gdouble _tmp11_;
#line 67 "../src/styles/LinkTypeStraight.vala"
			_tmp11_ = top;
#line 67 "../src/styles/LinkTypeStraight.vala"
			_tmp10_ = _tmp11_;
#line 496 "LinkTypeStraight.c"
		} else {
			gdouble _tmp12_;
#line 67 "../src/styles/LinkTypeStraight.vala"
			_tmp12_ = bottom;
#line 67 "../src/styles/LinkTypeStraight.vala"
			_tmp10_ = _tmp12_;
#line 503 "LinkTypeStraight.c"
		}
#line 67 "../src/styles/LinkTypeStraight.vala"
		result = _tmp10_;
#line 67 "../src/styles/LinkTypeStraight.vala"
		return result;
#line 509 "LinkTypeStraight.c"
	}
#line 69 "../src/styles/LinkTypeStraight.vala"
	result = adjusted;
#line 69 "../src/styles/LinkTypeStraight.vala"
	return result;
#line 515 "LinkTypeStraight.c"
}


static gpointer
_style_ref0 (gpointer self)
{
#line 77 "../src/styles/LinkTypeStraight.vala"
	return self ? style_ref (self) : NULL;
#line 524 "LinkTypeStraight.c"
}


static void
link_type_straight_real_draw (LinkType* base,
                              cairo_t* ctx,
                              Node* to_node,
                              gdouble from_x,
                              gdouble from_y,
                              gdouble to_x,
                              gdouble to_y,
                              gdouble* tailx,
                              gdouble* taily,
                              gdouble* tipx,
                              gdouble* tipy)
{
	LinkTypeStraight * self;
	gdouble _vala_tailx = 0.0;
	gdouble _vala_taily = 0.0;
	gdouble _vala_tipx = 0.0;
	gdouble _vala_tipy = 0.0;
	Style* style = NULL;
	Style* _tmp0_;
	Style* _tmp1_;
	Style* _tmp2_;
	NodeSide side = 0;
	NodeSide _tmp3_;
	NodeSide _tmp4_;
	gdouble x = 0.0;
	gdouble y = 0.0;
	gdouble adjustA = 0.0;
	Style* _tmp5_;
	gdouble _tmp6_ = 0.0;
	Style* _tmp7_;
	gboolean* _tmp8_;
	gboolean* _tmp9_;
	gdouble adjustB = 0.0;
	gdouble adjustT = 0.0;
	Style* _tmp14_;
	gboolean force = FALSE;
	gdouble _tmp15_;
	NodeSide _tmp16_;
#line 73 "../src/styles/LinkTypeStraight.vala"
	self = (LinkTypeStraight*) base;
#line 73 "../src/styles/LinkTypeStraight.vala"
	g_return_if_fail (ctx != NULL);
#line 73 "../src/styles/LinkTypeStraight.vala"
	g_return_if_fail (to_node != NULL);
#line 77 "../src/styles/LinkTypeStraight.vala"
	_tmp0_ = node_get_style (to_node);
#line 77 "../src/styles/LinkTypeStraight.vala"
	_tmp1_ = _tmp0_;
#line 77 "../src/styles/LinkTypeStraight.vala"
	_tmp2_ = _style_ref0 (_tmp1_);
#line 77 "../src/styles/LinkTypeStraight.vala"
	style = _tmp2_;
#line 78 "../src/styles/LinkTypeStraight.vala"
	_tmp3_ = node_get_side (to_node);
#line 78 "../src/styles/LinkTypeStraight.vala"
	_tmp4_ = _tmp3_;
#line 78 "../src/styles/LinkTypeStraight.vala"
	side = _tmp4_;
#line 79 "../src/styles/LinkTypeStraight.vala"
	x = to_x - from_x;
#line 80 "../src/styles/LinkTypeStraight.vala"
	y = to_y - from_y;
#line 81 "../src/styles/LinkTypeStraight.vala"
	_tmp5_ = style;
#line 81 "../src/styles/LinkTypeStraight.vala"
	adjustA = link_type_adjust_a ((LinkType*) self, _tmp5_);
#line 82 "../src/styles/LinkTypeStraight.vala"
	_tmp7_ = style;
#line 82 "../src/styles/LinkTypeStraight.vala"
	_tmp8_ = style_get_link_arrow (_tmp7_);
#line 82 "../src/styles/LinkTypeStraight.vala"
	_tmp9_ = _tmp8_;
#line 82 "../src/styles/LinkTypeStraight.vala"
	if (*_tmp9_) {
#line 603 "LinkTypeStraight.c"
		NodeSide _tmp10_;
		gdouble _tmp11_;
		gdouble _tmp12_;
		gdouble _tmp13_;
#line 82 "../src/styles/LinkTypeStraight.vala"
		_tmp10_ = side;
#line 82 "../src/styles/LinkTypeStraight.vala"
		_tmp11_ = adjustA;
#line 82 "../src/styles/LinkTypeStraight.vala"
		_tmp12_ = x;
#line 82 "../src/styles/LinkTypeStraight.vala"
		_tmp13_ = y;
#line 82 "../src/styles/LinkTypeStraight.vala"
		_tmp6_ = link_type_straight_adjust_b (self, _tmp10_, _tmp11_, _tmp12_, _tmp13_);
#line 618 "LinkTypeStraight.c"
	} else {
#line 82 "../src/styles/LinkTypeStraight.vala"
		_tmp6_ = (gdouble) 0;
#line 622 "LinkTypeStraight.c"
	}
#line 82 "../src/styles/LinkTypeStraight.vala"
	adjustB = _tmp6_;
#line 83 "../src/styles/LinkTypeStraight.vala"
	_tmp14_ = style;
#line 83 "../src/styles/LinkTypeStraight.vala"
	adjustT = link_type_adjust_tip ((LinkType*) self, _tmp14_);
#line 84 "../src/styles/LinkTypeStraight.vala"
	force = FALSE;
#line 86 "../src/styles/LinkTypeStraight.vala"
	_vala_tipy = (gdouble) 0;
#line 86 "../src/styles/LinkTypeStraight.vala"
	_tmp15_ = _vala_tipy;
#line 86 "../src/styles/LinkTypeStraight.vala"
	_vala_tipx = _tmp15_;
#line 87 "../src/styles/LinkTypeStraight.vala"
	_vala_tailx = from_x;
#line 88 "../src/styles/LinkTypeStraight.vala"
	_vala_taily = from_y;
#line 90 "../src/styles/LinkTypeStraight.vala"
	_tmp16_ = side;
#line 90 "../src/styles/LinkTypeStraight.vala"
	switch (_tmp16_) {
#line 90 "../src/styles/LinkTypeStraight.vala"
		case NODE_SIDE_LEFT:
#line 648 "LinkTypeStraight.c"
		{
			gdouble _tmp17_;
			gdouble _tmp18_;
			gdouble _tmp19_;
			gdouble _tmp20_;
			gdouble _tmp21_;
			NodeSide _tmp22_;
			gdouble _tmp23_;
			gdouble _tmp24_;
			gdouble _tmp25_;
			gdouble _tmp26_;
			gdouble _tmp27_;
#line 92 "../src/styles/LinkTypeStraight.vala"
			_tmp17_ = adjustA;
#line 92 "../src/styles/LinkTypeStraight.vala"
			to_x = to_x + _tmp17_;
#line 93 "../src/styles/LinkTypeStraight.vala"
			_tmp18_ = adjustB;
#line 93 "../src/styles/LinkTypeStraight.vala"
			_tmp19_ = adjustA;
#line 93 "../src/styles/LinkTypeStraight.vala"
			_tmp20_ = link_type_straight_calc_to_y (self, to_node, from_y < to_y, to_y + _tmp18_, _tmp19_, &force);
#line 93 "../src/styles/LinkTypeStraight.vala"
			to_y = _tmp20_;
#line 94 "../src/styles/LinkTypeStraight.vala"
			_tmp21_ = adjustT;
#line 94 "../src/styles/LinkTypeStraight.vala"
			_vala_tipx = to_x - _tmp21_;
#line 95 "../src/styles/LinkTypeStraight.vala"
			_tmp22_ = side;
#line 95 "../src/styles/LinkTypeStraight.vala"
			_tmp23_ = adjustT;
#line 95 "../src/styles/LinkTypeStraight.vala"
			_tmp24_ = x;
#line 95 "../src/styles/LinkTypeStraight.vala"
			_tmp25_ = y;
#line 95 "../src/styles/LinkTypeStraight.vala"
			_tmp26_ = adjustT;
#line 95 "../src/styles/LinkTypeStraight.vala"
			_tmp27_ = link_type_straight_calc_to_y (self, to_node, from_y < to_y, to_y - link_type_straight_adjust_b (self, _tmp22_, _tmp23_, _tmp24_, _tmp25_), _tmp26_, &force);
#line 95 "../src/styles/LinkTypeStraight.vala"
			_vala_tipy = _tmp27_;
#line 96 "../src/styles/LinkTypeStraight.vala"
			break;
#line 693 "LinkTypeStraight.c"
		}
#line 90 "../src/styles/LinkTypeStraight.vala"
		case NODE_SIDE_RIGHT:
#line 697 "LinkTypeStraight.c"
		{
			gdouble _tmp28_;
			gdouble _tmp29_;
			gdouble _tmp30_;
			gdouble _tmp31_;
			gdouble _tmp32_;
			NodeSide _tmp33_;
			gdouble _tmp34_;
			gdouble _tmp35_;
			gdouble _tmp36_;
			gdouble _tmp37_;
			gdouble _tmp38_;
#line 98 "../src/styles/LinkTypeStraight.vala"
			_tmp28_ = adjustA;
#line 98 "../src/styles/LinkTypeStraight.vala"
			to_x = to_x - _tmp28_;
#line 99 "../src/styles/LinkTypeStraight.vala"
			_tmp29_ = adjustB;
#line 99 "../src/styles/LinkTypeStraight.vala"
			_tmp30_ = adjustA;
#line 99 "../src/styles/LinkTypeStraight.vala"
			_tmp31_ = link_type_straight_calc_to_y (self, to_node, from_y < to_y, to_y - _tmp29_, _tmp30_, &force);
#line 99 "../src/styles/LinkTypeStraight.vala"
			to_y = _tmp31_;
#line 100 "../src/styles/LinkTypeStraight.vala"
			_tmp32_ = adjustT;
#line 100 "../src/styles/LinkTypeStraight.vala"
			_vala_tipx = to_x + _tmp32_;
#line 101 "../src/styles/LinkTypeStraight.vala"
			_tmp33_ = side;
#line 101 "../src/styles/LinkTypeStraight.vala"
			_tmp34_ = adjustT;
#line 101 "../src/styles/LinkTypeStraight.vala"
			_tmp35_ = x;
#line 101 "../src/styles/LinkTypeStraight.vala"
			_tmp36_ = y;
#line 101 "../src/styles/LinkTypeStraight.vala"
			_tmp37_ = adjustT;
#line 101 "../src/styles/LinkTypeStraight.vala"
			_tmp38_ = link_type_straight_calc_to_y (self, to_node, from_y < to_y, to_y + link_type_straight_adjust_b (self, _tmp33_, _tmp34_, _tmp35_, _tmp36_), _tmp37_, &force);
#line 101 "../src/styles/LinkTypeStraight.vala"
			_vala_tipy = _tmp38_;
#line 102 "../src/styles/LinkTypeStraight.vala"
			break;
#line 742 "LinkTypeStraight.c"
		}
#line 90 "../src/styles/LinkTypeStraight.vala"
		case NODE_SIDE_TOP:
#line 746 "LinkTypeStraight.c"
		{
			gdouble _tmp39_;
			gdouble _tmp40_;
			gdouble _tmp41_;
			gdouble _tmp42_;
			gdouble _tmp43_;
			NodeSide _tmp44_;
			gdouble _tmp45_;
			gdouble _tmp46_;
			gdouble _tmp47_;
			gdouble _tmp48_;
			gdouble _tmp49_;
#line 104 "../src/styles/LinkTypeStraight.vala"
			_tmp39_ = adjustA;
#line 104 "../src/styles/LinkTypeStraight.vala"
			to_y = to_y + _tmp39_;
#line 105 "../src/styles/LinkTypeStraight.vala"
			_tmp40_ = adjustB;
#line 105 "../src/styles/LinkTypeStraight.vala"
			_tmp41_ = adjustA;
#line 105 "../src/styles/LinkTypeStraight.vala"
			_tmp42_ = link_type_straight_calc_to_x (self, to_node, from_x < to_x, to_x + _tmp40_, _tmp41_, &force);
#line 105 "../src/styles/LinkTypeStraight.vala"
			to_x = _tmp42_;
#line 106 "../src/styles/LinkTypeStraight.vala"
			_tmp43_ = adjustT;
#line 106 "../src/styles/LinkTypeStraight.vala"
			_vala_tipy = to_y - _tmp43_;
#line 107 "../src/styles/LinkTypeStraight.vala"
			_tmp44_ = side;
#line 107 "../src/styles/LinkTypeStraight.vala"
			_tmp45_ = adjustT;
#line 107 "../src/styles/LinkTypeStraight.vala"
			_tmp46_ = x;
#line 107 "../src/styles/LinkTypeStraight.vala"
			_tmp47_ = y;
#line 107 "../src/styles/LinkTypeStraight.vala"
			_tmp48_ = adjustT;
#line 107 "../src/styles/LinkTypeStraight.vala"
			_tmp49_ = link_type_straight_calc_to_x (self, to_node, from_x < to_x, to_x - link_type_straight_adjust_b (self, _tmp44_, _tmp45_, _tmp46_, _tmp47_), _tmp48_, &force);
#line 107 "../src/styles/LinkTypeStraight.vala"
			_vala_tipx = _tmp49_;
#line 108 "../src/styles/LinkTypeStraight.vala"
			break;
#line 791 "LinkTypeStraight.c"
		}
#line 90 "../src/styles/LinkTypeStraight.vala"
		case NODE_SIDE_BOTTOM:
#line 795 "LinkTypeStraight.c"
		{
			gdouble _tmp50_;
			gdouble _tmp51_;
			gdouble _tmp52_;
			gdouble _tmp53_;
			gdouble _tmp54_;
			NodeSide _tmp55_;
			gdouble _tmp56_;
			gdouble _tmp57_;
			gdouble _tmp58_;
			gdouble _tmp59_;
			gdouble _tmp60_;
#line 110 "../src/styles/LinkTypeStraight.vala"
			_tmp50_ = adjustA;
#line 110 "../src/styles/LinkTypeStraight.vala"
			to_y = to_y - _tmp50_;
#line 111 "../src/styles/LinkTypeStraight.vala"
			_tmp51_ = adjustB;
#line 111 "../src/styles/LinkTypeStraight.vala"
			_tmp52_ = adjustA;
#line 111 "../src/styles/LinkTypeStraight.vala"
			_tmp53_ = link_type_straight_calc_to_x (self, to_node, from_x < to_x, to_x - _tmp51_, _tmp52_, &force);
#line 111 "../src/styles/LinkTypeStraight.vala"
			to_x = _tmp53_;
#line 112 "../src/styles/LinkTypeStraight.vala"
			_tmp54_ = adjustT;
#line 112 "../src/styles/LinkTypeStraight.vala"
			_vala_tipy = to_y + _tmp54_;
#line 113 "../src/styles/LinkTypeStraight.vala"
			_tmp55_ = side;
#line 113 "../src/styles/LinkTypeStraight.vala"
			_tmp56_ = adjustT;
#line 113 "../src/styles/LinkTypeStraight.vala"
			_tmp57_ = x;
#line 113 "../src/styles/LinkTypeStraight.vala"
			_tmp58_ = y;
#line 113 "../src/styles/LinkTypeStraight.vala"
			_tmp59_ = adjustT;
#line 113 "../src/styles/LinkTypeStraight.vala"
			_tmp60_ = link_type_straight_calc_to_x (self, to_node, from_x < to_x, to_x + link_type_straight_adjust_b (self, _tmp55_, _tmp56_, _tmp57_, _tmp58_), _tmp59_, &force);
#line 113 "../src/styles/LinkTypeStraight.vala"
			_vala_tipx = _tmp60_;
#line 114 "../src/styles/LinkTypeStraight.vala"
			break;
#line 840 "LinkTypeStraight.c"
		}
		default:
#line 90 "../src/styles/LinkTypeStraight.vala"
		break;
#line 845 "LinkTypeStraight.c"
	}
#line 117 "../src/styles/LinkTypeStraight.vala"
	cairo_move_to (ctx, from_x, from_y);
#line 118 "../src/styles/LinkTypeStraight.vala"
	cairo_line_to (ctx, to_x, to_y);
#line 119 "../src/styles/LinkTypeStraight.vala"
	cairo_stroke (ctx);
#line 73 "../src/styles/LinkTypeStraight.vala"
	_style_unref0 (style);
#line 73 "../src/styles/LinkTypeStraight.vala"
	if (tailx) {
#line 73 "../src/styles/LinkTypeStraight.vala"
		*tailx = _vala_tailx;
#line 859 "LinkTypeStraight.c"
	}
#line 73 "../src/styles/LinkTypeStraight.vala"
	if (taily) {
#line 73 "../src/styles/LinkTypeStraight.vala"
		*taily = _vala_taily;
#line 865 "LinkTypeStraight.c"
	}
#line 73 "../src/styles/LinkTypeStraight.vala"
	if (tipx) {
#line 73 "../src/styles/LinkTypeStraight.vala"
		*tipx = _vala_tipx;
#line 871 "LinkTypeStraight.c"
	}
#line 73 "../src/styles/LinkTypeStraight.vala"
	if (tipy) {
#line 73 "../src/styles/LinkTypeStraight.vala"
		*tipy = _vala_tipy;
#line 877 "LinkTypeStraight.c"
	}
}


static void
link_type_straight_class_init (LinkTypeStraightClass * klass)
{
#line 22 "../src/styles/LinkTypeStraight.vala"
	link_type_straight_parent_class = g_type_class_peek_parent (klass);
#line 887 "LinkTypeStraight.c"
}


static void
link_type_straight_link_type_interface_init (LinkTypeIface * iface)
{
#line 22 "../src/styles/LinkTypeStraight.vala"
	link_type_straight_link_type_parent_iface = g_type_interface_peek_parent (iface);
#line 22 "../src/styles/LinkTypeStraight.vala"
	iface->name = (gchar* (*) (LinkType*)) link_type_straight_real_name;
#line 22 "../src/styles/LinkTypeStraight.vala"
	iface->display_name = (gchar* (*) (LinkType*)) link_type_straight_real_display_name;
#line 22 "../src/styles/LinkTypeStraight.vala"
	iface->icon_name = (gchar* (*) (LinkType*)) link_type_straight_real_icon_name;
#line 22 "../src/styles/LinkTypeStraight.vala"
	iface->draw = (void (*) (LinkType*, cairo_t*, Node*, gdouble, gdouble, gdouble, gdouble, gdouble*, gdouble*, gdouble*, gdouble*)) link_type_straight_real_draw;
#line 904 "LinkTypeStraight.c"
}


static void
link_type_straight_instance_init (LinkTypeStraight * self)
{
}


GType
link_type_straight_get_type (void)
{
	static volatile gsize link_type_straight_type_id__volatile = 0;
	if (g_once_init_enter (&link_type_straight_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (LinkTypeStraightClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) link_type_straight_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (LinkTypeStraight), 0, (GInstanceInitFunc) link_type_straight_instance_init, NULL };
		static const GInterfaceInfo link_type_info = { (GInterfaceInitFunc) link_type_straight_link_type_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType link_type_straight_type_id;
		link_type_straight_type_id = g_type_register_static (G_TYPE_OBJECT, "LinkTypeStraight", &g_define_type_info, 0);
		g_type_add_interface_static (link_type_straight_type_id, TYPE_LINK_TYPE, &link_type_info);
		g_once_init_leave (&link_type_straight_type_id__volatile, link_type_straight_type_id);
	}
	return link_type_straight_type_id__volatile;
}



