/* UndoNodeResize.c generated by valac 0.42.7, the Vala compiler
 * generated from UndoNodeResize.vala, do not modify */

/*
* Copyright (c) 2018 (https://github.com/phase1geo/Minder)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Trevor Williams <phase1geo@gmail.com>
*/


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>
#include <float.h>
#include <math.h>


#define TYPE_UNDO_ITEM (undo_item_get_type ())
#define UNDO_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_UNDO_ITEM, UndoItem))
#define UNDO_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_UNDO_ITEM, UndoItemClass))
#define IS_UNDO_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_UNDO_ITEM))
#define IS_UNDO_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_UNDO_ITEM))
#define UNDO_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_UNDO_ITEM, UndoItemClass))

typedef struct _UndoItem UndoItem;
typedef struct _UndoItemClass UndoItemClass;
typedef struct _UndoItemPrivate UndoItemPrivate;

#define TYPE_DRAW_AREA (draw_area_get_type ())
#define DRAW_AREA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DRAW_AREA, DrawArea))
#define DRAW_AREA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DRAW_AREA, DrawAreaClass))
#define IS_DRAW_AREA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DRAW_AREA))
#define IS_DRAW_AREA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DRAW_AREA))
#define DRAW_AREA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DRAW_AREA, DrawAreaClass))

typedef struct _DrawArea DrawArea;
typedef struct _DrawAreaClass DrawAreaClass;

#define TYPE_UNDO_NODE_RESIZE (undo_node_resize_get_type ())
#define UNDO_NODE_RESIZE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_UNDO_NODE_RESIZE, UndoNodeResize))
#define UNDO_NODE_RESIZE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_UNDO_NODE_RESIZE, UndoNodeResizeClass))
#define IS_UNDO_NODE_RESIZE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_UNDO_NODE_RESIZE))
#define IS_UNDO_NODE_RESIZE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_UNDO_NODE_RESIZE))
#define UNDO_NODE_RESIZE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_UNDO_NODE_RESIZE, UndoNodeResizeClass))

typedef struct _UndoNodeResize UndoNodeResize;
typedef struct _UndoNodeResizeClass UndoNodeResizeClass;
typedef struct _UndoNodeResizePrivate UndoNodeResizePrivate;

#define TYPE_NODE (node_get_type ())
#define NODE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NODE, Node))
#define NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NODE, NodeClass))
#define IS_NODE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NODE))
#define IS_NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NODE))
#define NODE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NODE, NodeClass))

typedef struct _Node Node;
typedef struct _NodeClass NodeClass;
enum  {
	UNDO_NODE_RESIZE_0_PROPERTY,
	UNDO_NODE_RESIZE_NUM_PROPERTIES
};
static GParamSpec* undo_node_resize_properties[UNDO_NODE_RESIZE_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _UndoItem {
	GObject parent_instance;
	UndoItemPrivate * priv;
};

struct _UndoItemClass {
	GObjectClass parent_class;
	void (*undo) (UndoItem* self, DrawArea* da);
	void (*redo) (UndoItem* self, DrawArea* da);
	gboolean (*matches) (UndoItem* self, UndoItem* item);
	void (*replace_with_item) (UndoItem* self, UndoItem* item);
	gchar* (*to_string) (UndoItem* self);
};

struct _UndoNodeResize {
	UndoItem parent_instance;
	UndoNodeResizePrivate * priv;
};

struct _UndoNodeResizeClass {
	UndoItemClass parent_class;
};

struct _UndoNodeResizePrivate {
	Node* _node;
	gint _old_width;
	gint _new_width;
};


static gint UndoNodeResize_private_offset;
static gpointer undo_node_resize_parent_class = NULL;

GType undo_item_get_type (void) G_GNUC_CONST;
GType draw_area_get_type (void) G_GNUC_CONST;
GType undo_node_resize_get_type (void) G_GNUC_CONST;
GType node_get_type (void) G_GNUC_CONST;
UndoNodeResize* undo_node_resize_new (Node* n,
                                      gint old_width);
UndoNodeResize* undo_node_resize_construct (GType object_type,
                                            Node* n,
                                            gint old_width);
UndoItem* undo_item_new (const gchar* name);
UndoItem* undo_item_construct (GType object_type,
                               const gchar* name);
gint node_max_width (Node* self);
static void undo_node_resize_real_undo (UndoItem* base,
                                 DrawArea* da);
void node_resize (Node* self,
                  gdouble diff);
static void undo_node_resize_real_redo (UndoItem* base,
                                 DrawArea* da);
static void undo_node_resize_finalize (GObject * obj);


static inline gpointer
undo_node_resize_get_instance_private (UndoNodeResize* self)
{
	return G_STRUCT_MEMBER_P (self, UndoNodeResize_private_offset);
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 33 "../src/undo_actions/UndoNodeResize.vala"
	return self ? g_object_ref (self) : NULL;
#line 152 "UndoNodeResize.c"
}


UndoNodeResize*
undo_node_resize_construct (GType object_type,
                            Node* n,
                            gint old_width)
{
	UndoNodeResize * self = NULL;
	Node* _tmp0_;
#line 31 "../src/undo_actions/UndoNodeResize.vala"
	g_return_val_if_fail (n != NULL, NULL);
#line 32 "../src/undo_actions/UndoNodeResize.vala"
	self = (UndoNodeResize*) undo_item_construct (object_type, _ ("node resize"));
#line 33 "../src/undo_actions/UndoNodeResize.vala"
	_tmp0_ = _g_object_ref0 (n);
#line 33 "../src/undo_actions/UndoNodeResize.vala"
	_g_object_unref0 (self->priv->_node);
#line 33 "../src/undo_actions/UndoNodeResize.vala"
	self->priv->_node = _tmp0_;
#line 34 "../src/undo_actions/UndoNodeResize.vala"
	self->priv->_old_width = old_width;
#line 35 "../src/undo_actions/UndoNodeResize.vala"
	self->priv->_new_width = node_max_width (n);
#line 31 "../src/undo_actions/UndoNodeResize.vala"
	return self;
#line 179 "UndoNodeResize.c"
}


UndoNodeResize*
undo_node_resize_new (Node* n,
                      gint old_width)
{
#line 31 "../src/undo_actions/UndoNodeResize.vala"
	return undo_node_resize_construct (TYPE_UNDO_NODE_RESIZE, n, old_width);
#line 189 "UndoNodeResize.c"
}


static void
undo_node_resize_real_undo (UndoItem* base,
                            DrawArea* da)
{
	UndoNodeResize * self;
	Node* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 39 "../src/undo_actions/UndoNodeResize.vala"
	self = (UndoNodeResize*) base;
#line 39 "../src/undo_actions/UndoNodeResize.vala"
	g_return_if_fail (da != NULL);
#line 40 "../src/undo_actions/UndoNodeResize.vala"
	_tmp0_ = self->priv->_node;
#line 40 "../src/undo_actions/UndoNodeResize.vala"
	_tmp1_ = self->priv->_old_width;
#line 40 "../src/undo_actions/UndoNodeResize.vala"
	_tmp2_ = self->priv->_new_width;
#line 40 "../src/undo_actions/UndoNodeResize.vala"
	node_resize (_tmp0_, (gdouble) (_tmp1_ - _tmp2_));
#line 41 "../src/undo_actions/UndoNodeResize.vala"
	gtk_widget_queue_draw ((GtkWidget*) da);
#line 42 "../src/undo_actions/UndoNodeResize.vala"
	g_signal_emit_by_name (da, "changed");
#line 217 "UndoNodeResize.c"
}


static void
undo_node_resize_real_redo (UndoItem* base,
                            DrawArea* da)
{
	UndoNodeResize * self;
	Node* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 46 "../src/undo_actions/UndoNodeResize.vala"
	self = (UndoNodeResize*) base;
#line 46 "../src/undo_actions/UndoNodeResize.vala"
	g_return_if_fail (da != NULL);
#line 47 "../src/undo_actions/UndoNodeResize.vala"
	_tmp0_ = self->priv->_node;
#line 47 "../src/undo_actions/UndoNodeResize.vala"
	_tmp1_ = self->priv->_new_width;
#line 47 "../src/undo_actions/UndoNodeResize.vala"
	_tmp2_ = self->priv->_old_width;
#line 47 "../src/undo_actions/UndoNodeResize.vala"
	node_resize (_tmp0_, (gdouble) (_tmp1_ - _tmp2_));
#line 48 "../src/undo_actions/UndoNodeResize.vala"
	gtk_widget_queue_draw ((GtkWidget*) da);
#line 49 "../src/undo_actions/UndoNodeResize.vala"
	g_signal_emit_by_name (da, "changed");
#line 245 "UndoNodeResize.c"
}


static void
undo_node_resize_class_init (UndoNodeResizeClass * klass)
{
#line 24 "../src/undo_actions/UndoNodeResize.vala"
	undo_node_resize_parent_class = g_type_class_peek_parent (klass);
#line 24 "../src/undo_actions/UndoNodeResize.vala"
	g_type_class_adjust_private_offset (klass, &UndoNodeResize_private_offset);
#line 24 "../src/undo_actions/UndoNodeResize.vala"
	((UndoItemClass *) klass)->undo = (void (*) (UndoItem*, DrawArea*)) undo_node_resize_real_undo;
#line 24 "../src/undo_actions/UndoNodeResize.vala"
	((UndoItemClass *) klass)->redo = (void (*) (UndoItem*, DrawArea*)) undo_node_resize_real_redo;
#line 24 "../src/undo_actions/UndoNodeResize.vala"
	G_OBJECT_CLASS (klass)->finalize = undo_node_resize_finalize;
#line 262 "UndoNodeResize.c"
}


static void
undo_node_resize_instance_init (UndoNodeResize * self)
{
#line 24 "../src/undo_actions/UndoNodeResize.vala"
	self->priv = undo_node_resize_get_instance_private (self);
#line 271 "UndoNodeResize.c"
}


static void
undo_node_resize_finalize (GObject * obj)
{
	UndoNodeResize * self;
#line 24 "../src/undo_actions/UndoNodeResize.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_UNDO_NODE_RESIZE, UndoNodeResize);
#line 26 "../src/undo_actions/UndoNodeResize.vala"
	_g_object_unref0 (self->priv->_node);
#line 24 "../src/undo_actions/UndoNodeResize.vala"
	G_OBJECT_CLASS (undo_node_resize_parent_class)->finalize (obj);
#line 285 "UndoNodeResize.c"
}


GType
undo_node_resize_get_type (void)
{
	static volatile gsize undo_node_resize_type_id__volatile = 0;
	if (g_once_init_enter (&undo_node_resize_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (UndoNodeResizeClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) undo_node_resize_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (UndoNodeResize), 0, (GInstanceInitFunc) undo_node_resize_instance_init, NULL };
		GType undo_node_resize_type_id;
		undo_node_resize_type_id = g_type_register_static (TYPE_UNDO_ITEM, "UndoNodeResize", &g_define_type_info, 0);
		UndoNodeResize_private_offset = g_type_add_instance_private (undo_node_resize_type_id, sizeof (UndoNodeResizePrivate));
		g_once_init_leave (&undo_node_resize_type_id__volatile, undo_node_resize_type_id);
	}
	return undo_node_resize_type_id__volatile;
}



