/* UndoNodeTask.c generated by valac 0.42.7, the Vala compiler
 * generated from UndoNodeTask.vala, do not modify */

/*
* Copyright (c) 2018 (https://github.com/phase1geo/Minder)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Trevor Williams <phase1geo@gmail.com>
*/


#include <glib.h>
#include <glib-object.h>
#include <gtk/gtk.h>
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>


#define TYPE_UNDO_ITEM (undo_item_get_type ())
#define UNDO_ITEM(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_UNDO_ITEM, UndoItem))
#define UNDO_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_UNDO_ITEM, UndoItemClass))
#define IS_UNDO_ITEM(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_UNDO_ITEM))
#define IS_UNDO_ITEM_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_UNDO_ITEM))
#define UNDO_ITEM_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_UNDO_ITEM, UndoItemClass))

typedef struct _UndoItem UndoItem;
typedef struct _UndoItemClass UndoItemClass;
typedef struct _UndoItemPrivate UndoItemPrivate;

#define TYPE_DRAW_AREA (draw_area_get_type ())
#define DRAW_AREA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DRAW_AREA, DrawArea))
#define DRAW_AREA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DRAW_AREA, DrawAreaClass))
#define IS_DRAW_AREA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DRAW_AREA))
#define IS_DRAW_AREA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DRAW_AREA))
#define DRAW_AREA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DRAW_AREA, DrawAreaClass))

typedef struct _DrawArea DrawArea;
typedef struct _DrawAreaClass DrawAreaClass;

#define TYPE_UNDO_NODE_TASK (undo_node_task_get_type ())
#define UNDO_NODE_TASK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_UNDO_NODE_TASK, UndoNodeTask))
#define UNDO_NODE_TASK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_UNDO_NODE_TASK, UndoNodeTaskClass))
#define IS_UNDO_NODE_TASK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_UNDO_NODE_TASK))
#define IS_UNDO_NODE_TASK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_UNDO_NODE_TASK))
#define UNDO_NODE_TASK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_UNDO_NODE_TASK, UndoNodeTaskClass))

typedef struct _UndoNodeTask UndoNodeTask;
typedef struct _UndoNodeTaskClass UndoNodeTaskClass;
typedef struct _UndoNodeTaskPrivate UndoNodeTaskPrivate;

#define TYPE_NODE (node_get_type ())
#define NODE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NODE, Node))
#define NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NODE, NodeClass))
#define IS_NODE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NODE))
#define IS_NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NODE))
#define NODE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NODE, NodeClass))

typedef struct _Node Node;
typedef struct _NodeClass NodeClass;
enum  {
	UNDO_NODE_TASK_0_PROPERTY,
	UNDO_NODE_TASK_NUM_PROPERTIES
};
static GParamSpec* undo_node_task_properties[UNDO_NODE_TASK_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))

struct _UndoItem {
	GObject parent_instance;
	UndoItemPrivate * priv;
};

struct _UndoItemClass {
	GObjectClass parent_class;
	void (*undo) (UndoItem* self, DrawArea* da);
	void (*redo) (UndoItem* self, DrawArea* da);
	gboolean (*matches) (UndoItem* self, UndoItem* item);
	void (*replace_with_item) (UndoItem* self, UndoItem* item);
	gchar* (*to_string) (UndoItem* self);
};

struct _UndoNodeTask {
	UndoItem parent_instance;
	UndoNodeTaskPrivate * priv;
};

struct _UndoNodeTaskClass {
	UndoItemClass parent_class;
};

struct _UndoNodeTaskPrivate {
	Node* _node;
	gboolean _old_enable;
	gboolean _old_done;
	gboolean _new_enable;
	gboolean _new_done;
};


static gint UndoNodeTask_private_offset;
static gpointer undo_node_task_parent_class = NULL;

GType undo_item_get_type (void) G_GNUC_CONST;
GType draw_area_get_type (void) G_GNUC_CONST;
GType undo_node_task_get_type (void) G_GNUC_CONST;
GType node_get_type (void) G_GNUC_CONST;
UndoNodeTask* undo_node_task_new (Node* n,
                                  gboolean new_enable,
                                  gboolean new_done);
UndoNodeTask* undo_node_task_construct (GType object_type,
                                        Node* n,
                                        gboolean new_enable,
                                        gboolean new_done);
UndoItem* undo_item_new (const gchar* name);
UndoItem* undo_item_construct (GType object_type,
                               const gchar* name);
gboolean node_task_enabled (Node* self);
gboolean node_task_done (Node* self);
static void undo_node_task_real_undo (UndoItem* base,
                               DrawArea* da);
void node_enable_task (Node* self,
                       gboolean task);
void node_set_task_done (Node* self,
                         gboolean done);
static void undo_node_task_real_redo (UndoItem* base,
                               DrawArea* da);
static void undo_node_task_finalize (GObject * obj);


static inline gpointer
undo_node_task_get_instance_private (UndoNodeTask* self)
{
	return G_STRUCT_MEMBER_P (self, UndoNodeTask_private_offset);
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 35 "../src/undo_actions/UndoNodeTask.vala"
	return self ? g_object_ref (self) : NULL;
#line 157 "UndoNodeTask.c"
}


UndoNodeTask*
undo_node_task_construct (GType object_type,
                          Node* n,
                          gboolean new_enable,
                          gboolean new_done)
{
	UndoNodeTask * self = NULL;
	Node* _tmp0_;
#line 33 "../src/undo_actions/UndoNodeTask.vala"
	g_return_val_if_fail (n != NULL, NULL);
#line 34 "../src/undo_actions/UndoNodeTask.vala"
	self = (UndoNodeTask*) undo_item_construct (object_type, _ ("node task change"));
#line 35 "../src/undo_actions/UndoNodeTask.vala"
	_tmp0_ = _g_object_ref0 (n);
#line 35 "../src/undo_actions/UndoNodeTask.vala"
	_g_object_unref0 (self->priv->_node);
#line 35 "../src/undo_actions/UndoNodeTask.vala"
	self->priv->_node = _tmp0_;
#line 36 "../src/undo_actions/UndoNodeTask.vala"
	self->priv->_old_enable = node_task_enabled (n);
#line 37 "../src/undo_actions/UndoNodeTask.vala"
	self->priv->_old_done = node_task_done (n);
#line 38 "../src/undo_actions/UndoNodeTask.vala"
	self->priv->_new_enable = new_enable;
#line 39 "../src/undo_actions/UndoNodeTask.vala"
	self->priv->_new_done = new_done;
#line 33 "../src/undo_actions/UndoNodeTask.vala"
	return self;
#line 189 "UndoNodeTask.c"
}


UndoNodeTask*
undo_node_task_new (Node* n,
                    gboolean new_enable,
                    gboolean new_done)
{
#line 33 "../src/undo_actions/UndoNodeTask.vala"
	return undo_node_task_construct (TYPE_UNDO_NODE_TASK, n, new_enable, new_done);
#line 200 "UndoNodeTask.c"
}


static void
undo_node_task_real_undo (UndoItem* base,
                          DrawArea* da)
{
	UndoNodeTask * self;
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 43 "../src/undo_actions/UndoNodeTask.vala"
	self = (UndoNodeTask*) base;
#line 43 "../src/undo_actions/UndoNodeTask.vala"
	g_return_if_fail (da != NULL);
#line 44 "../src/undo_actions/UndoNodeTask.vala"
	_tmp0_ = self->priv->_old_enable;
#line 44 "../src/undo_actions/UndoNodeTask.vala"
	_tmp1_ = self->priv->_new_enable;
#line 44 "../src/undo_actions/UndoNodeTask.vala"
	if (_tmp0_ != _tmp1_) {
#line 221 "UndoNodeTask.c"
		Node* _tmp2_;
		gboolean _tmp3_;
#line 45 "../src/undo_actions/UndoNodeTask.vala"
		_tmp2_ = self->priv->_node;
#line 45 "../src/undo_actions/UndoNodeTask.vala"
		_tmp3_ = self->priv->_old_enable;
#line 45 "../src/undo_actions/UndoNodeTask.vala"
		node_enable_task (_tmp2_, _tmp3_);
#line 230 "UndoNodeTask.c"
	} else {
		Node* _tmp4_;
		gboolean _tmp5_;
#line 47 "../src/undo_actions/UndoNodeTask.vala"
		_tmp4_ = self->priv->_node;
#line 47 "../src/undo_actions/UndoNodeTask.vala"
		_tmp5_ = self->priv->_old_done;
#line 47 "../src/undo_actions/UndoNodeTask.vala"
		node_set_task_done (_tmp4_, _tmp5_);
#line 240 "UndoNodeTask.c"
	}
#line 49 "../src/undo_actions/UndoNodeTask.vala"
	gtk_widget_queue_draw ((GtkWidget*) da);
#line 50 "../src/undo_actions/UndoNodeTask.vala"
	g_signal_emit_by_name (da, "current-changed", da);
#line 51 "../src/undo_actions/UndoNodeTask.vala"
	g_signal_emit_by_name (da, "changed");
#line 248 "UndoNodeTask.c"
}


static void
undo_node_task_real_redo (UndoItem* base,
                          DrawArea* da)
{
	UndoNodeTask * self;
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 55 "../src/undo_actions/UndoNodeTask.vala"
	self = (UndoNodeTask*) base;
#line 55 "../src/undo_actions/UndoNodeTask.vala"
	g_return_if_fail (da != NULL);
#line 56 "../src/undo_actions/UndoNodeTask.vala"
	_tmp0_ = self->priv->_old_enable;
#line 56 "../src/undo_actions/UndoNodeTask.vala"
	_tmp1_ = self->priv->_new_enable;
#line 56 "../src/undo_actions/UndoNodeTask.vala"
	if (_tmp0_ != _tmp1_) {
#line 269 "UndoNodeTask.c"
		Node* _tmp2_;
		gboolean _tmp3_;
#line 57 "../src/undo_actions/UndoNodeTask.vala"
		_tmp2_ = self->priv->_node;
#line 57 "../src/undo_actions/UndoNodeTask.vala"
		_tmp3_ = self->priv->_new_enable;
#line 57 "../src/undo_actions/UndoNodeTask.vala"
		node_enable_task (_tmp2_, _tmp3_);
#line 278 "UndoNodeTask.c"
	} else {
		Node* _tmp4_;
		gboolean _tmp5_;
#line 59 "../src/undo_actions/UndoNodeTask.vala"
		_tmp4_ = self->priv->_node;
#line 59 "../src/undo_actions/UndoNodeTask.vala"
		_tmp5_ = self->priv->_new_done;
#line 59 "../src/undo_actions/UndoNodeTask.vala"
		node_set_task_done (_tmp4_, _tmp5_);
#line 288 "UndoNodeTask.c"
	}
#line 61 "../src/undo_actions/UndoNodeTask.vala"
	gtk_widget_queue_draw ((GtkWidget*) da);
#line 62 "../src/undo_actions/UndoNodeTask.vala"
	g_signal_emit_by_name (da, "current-changed", da);
#line 63 "../src/undo_actions/UndoNodeTask.vala"
	g_signal_emit_by_name (da, "changed");
#line 296 "UndoNodeTask.c"
}


static void
undo_node_task_class_init (UndoNodeTaskClass * klass)
{
#line 24 "../src/undo_actions/UndoNodeTask.vala"
	undo_node_task_parent_class = g_type_class_peek_parent (klass);
#line 24 "../src/undo_actions/UndoNodeTask.vala"
	g_type_class_adjust_private_offset (klass, &UndoNodeTask_private_offset);
#line 24 "../src/undo_actions/UndoNodeTask.vala"
	((UndoItemClass *) klass)->undo = (void (*) (UndoItem*, DrawArea*)) undo_node_task_real_undo;
#line 24 "../src/undo_actions/UndoNodeTask.vala"
	((UndoItemClass *) klass)->redo = (void (*) (UndoItem*, DrawArea*)) undo_node_task_real_redo;
#line 24 "../src/undo_actions/UndoNodeTask.vala"
	G_OBJECT_CLASS (klass)->finalize = undo_node_task_finalize;
#line 313 "UndoNodeTask.c"
}


static void
undo_node_task_instance_init (UndoNodeTask * self)
{
#line 24 "../src/undo_actions/UndoNodeTask.vala"
	self->priv = undo_node_task_get_instance_private (self);
#line 322 "UndoNodeTask.c"
}


static void
undo_node_task_finalize (GObject * obj)
{
	UndoNodeTask * self;
#line 24 "../src/undo_actions/UndoNodeTask.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_UNDO_NODE_TASK, UndoNodeTask);
#line 26 "../src/undo_actions/UndoNodeTask.vala"
	_g_object_unref0 (self->priv->_node);
#line 24 "../src/undo_actions/UndoNodeTask.vala"
	G_OBJECT_CLASS (undo_node_task_parent_class)->finalize (obj);
#line 336 "UndoNodeTask.c"
}


GType
undo_node_task_get_type (void)
{
	static volatile gsize undo_node_task_type_id__volatile = 0;
	if (g_once_init_enter (&undo_node_task_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (UndoNodeTaskClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) undo_node_task_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (UndoNodeTask), 0, (GInstanceInitFunc) undo_node_task_instance_init, NULL };
		GType undo_node_task_type_id;
		undo_node_task_type_id = g_type_register_static (TYPE_UNDO_ITEM, "UndoNodeTask", &g_define_type_info, 0);
		UndoNodeTask_private_offset = g_type_add_instance_private (undo_node_task_type_id, sizeof (UndoNodeTaskPrivate));
		g_once_init_leave (&undo_node_task_type_id__volatile, undo_node_task_type_id);
	}
	return undo_node_task_type_id__volatile;
}



