/* Connection.c generated by valac 0.42.7, the Vala compiler
 * generated from Connection.vala, do not modify */

/*
* Copyright (c) 2018 (https://github.com/phase1geo/Minder)
*
* This program is free software; you can redistribute it and/or
* modify it under the terms of the GNU General Public
* License as published by the Free Software Foundation; either
* version 2 of the License, or (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
* General Public License for more details.
*
* You should have received a copy of the GNU General Public
* License along with this program; if not, write to the
* Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
* Boston, MA 02110-1301 USA
*
* Authored by: Trevor Williams <phase1geo@gmail.com>
*/


#include <glib.h>
#include <glib-object.h>
#include <cairo.h>
#include <float.h>
#include <math.h>
#include <stdlib.h>
#include <string.h>
#include <gdk/gdk.h>
#include <gtk/gtk.h>
#include <libxml/tree.h>
#include <gee.h>
#include <pango/pango.h>
#include <glib/gi18n-lib.h>
#include <granite.h>

typedef enum  {
	CONN_MODE_NONE = 0,
	CONN_MODE_LINKING,
	CONN_MODE_CONNECTING,
	CONN_MODE_SELECTED,
	CONN_MODE_ADJUSTING,
	CONN_MODE_EDITABLE
} ConnMode;


#define TYPE_CONN_MODE (conn_mode_get_type ())

#define TYPE_CONNECTION (connection_get_type ())
#define CONNECTION(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CONNECTION, Connection))
#define CONNECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CONNECTION, ConnectionClass))
#define IS_CONNECTION(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CONNECTION))
#define IS_CONNECTION_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CONNECTION))
#define CONNECTION_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CONNECTION, ConnectionClass))

typedef struct _Connection Connection;
typedef struct _ConnectionClass ConnectionClass;
typedef struct _ConnectionPrivate ConnectionPrivate;

#define TYPE_THEME (theme_get_type ())
#define THEME(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_THEME, Theme))
#define THEME_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_THEME, ThemeClass))
#define IS_THEME(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_THEME))
#define IS_THEME_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_THEME))
#define THEME_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_THEME, ThemeClass))

typedef struct _Theme Theme;
typedef struct _ThemeClass ThemeClass;

#define TYPE_NODE (node_get_type ())
#define NODE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_NODE, Node))
#define NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_NODE, NodeClass))
#define IS_NODE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_NODE))
#define IS_NODE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_NODE))
#define NODE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_NODE, NodeClass))

typedef struct _Node Node;
typedef struct _NodeClass NodeClass;

#define TYPE_STYLE (style_get_type ())
#define STYLE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_STYLE, Style))
#define STYLE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_STYLE, StyleClass))
#define IS_STYLE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_STYLE))
#define IS_STYLE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_STYLE))
#define STYLE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_STYLE, StyleClass))

typedef struct _Style Style;
typedef struct _StyleClass StyleClass;

#define TYPE_BEZIER (bezier_get_type ())
#define BEZIER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_BEZIER, Bezier))
#define BEZIER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_BEZIER, BezierClass))
#define IS_BEZIER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_BEZIER))
#define IS_BEZIER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_BEZIER))
#define BEZIER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_BEZIER, BezierClass))

typedef struct _Bezier Bezier;
typedef struct _BezierClass BezierClass;

#define TYPE_CANVAS_TEXT (canvas_text_get_type ())
#define CANVAS_TEXT(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CANVAS_TEXT, CanvasText))
#define CANVAS_TEXT_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CANVAS_TEXT, CanvasTextClass))
#define IS_CANVAS_TEXT(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CANVAS_TEXT))
#define IS_CANVAS_TEXT_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CANVAS_TEXT))
#define CANVAS_TEXT_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CANVAS_TEXT, CanvasTextClass))

typedef struct _CanvasText CanvasText;
typedef struct _CanvasTextClass CanvasTextClass;
enum  {
	CONNECTION_0_PROPERTY,
	CONNECTION_TITLE_PROPERTY,
	CONNECTION_NOTE_PROPERTY,
	CONNECTION_MODE_PROPERTY,
	CONNECTION_FROM_NODE_PROPERTY,
	CONNECTION_TO_NODE_PROPERTY,
	CONNECTION_STYLE_PROPERTY,
	CONNECTION_ALPHA_PROPERTY,
	CONNECTION_COLOR_PROPERTY,
	CONNECTION_NUM_PROPERTIES
};
static GParamSpec* connection_properties[CONNECTION_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _style_unref0(var) ((var == NULL) ? NULL : (var = (style_unref (var), NULL)))
#define _bezier_unref0(var) ((var == NULL) ? NULL : (var = (bezier_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))

#define TYPE_DRAW_AREA (draw_area_get_type ())
#define DRAW_AREA(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DRAW_AREA, DrawArea))
#define DRAW_AREA_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DRAW_AREA, DrawAreaClass))
#define IS_DRAW_AREA(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DRAW_AREA))
#define IS_DRAW_AREA_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DRAW_AREA))
#define DRAW_AREA_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DRAW_AREA, DrawAreaClass))

typedef struct _DrawArea DrawArea;
typedef struct _DrawAreaClass DrawAreaClass;

#define TYPE_STYLES (styles_get_type ())
#define STYLES(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_STYLES, Styles))
#define STYLES_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_STYLES, StylesClass))
#define IS_STYLES(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_STYLES))
#define IS_STYLES_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_STYLES))
#define STYLES_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_STYLES, StylesClass))

typedef struct _Styles Styles;
typedef struct _StylesClass StylesClass;
#define _cairo_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_destroy (var), NULL)))
#define _cairo_surface_destroy0(var) ((var == NULL) ? NULL : (var = (cairo_surface_destroy (var), NULL)))

struct _Connection {
	GObject parent_instance;
	ConnectionPrivate * priv;
};

struct _ConnectionClass {
	GObjectClass parent_class;
	void (*draw) (Connection* self, cairo_t* ctx, Theme* theme);
};

struct _ConnectionPrivate {
	gint RADIUS;
	ConnMode _mode;
	Node* _from_node;
	Node* _to_node;
	gdouble _posx;
	gdouble _posy;
	gdouble _dragx;
	gdouble _dragy;
	Style* _style;
	Bezier* _curve;
	CanvasText* _title;
	gchar* _note;
	gdouble _max_width;
	gdouble _alpha;
	GdkRGBA _color;
};


static gint Connection_private_offset;
static gpointer connection_parent_class = NULL;
extern Styles* style_inspector_styles;

GType conn_mode_get_type (void) G_GNUC_CONST;
GType connection_get_type (void) G_GNUC_CONST;
GType theme_get_type (void) G_GNUC_CONST;
GType node_get_type (void) G_GNUC_CONST;
gpointer style_ref (gpointer instance);
void style_unref (gpointer instance);
GParamSpec* param_spec_style (const gchar* name,
                              const gchar* nick,
                              const gchar* blurb,
                              GType object_type,
                              GParamFlags flags);
void value_set_style (GValue* value,
                      gpointer v_object);
void value_take_style (GValue* value,
                       gpointer v_object);
gpointer value_get_style (const GValue* value);
GType style_get_type (void) G_GNUC_CONST;
gpointer bezier_ref (gpointer instance);
void bezier_unref (gpointer instance);
GParamSpec* param_spec_bezier (const gchar* name,
                               const gchar* nick,
                               const gchar* blurb,
                               GType object_type,
                               GParamFlags flags);
void value_set_bezier (GValue* value,
                       gpointer v_object);
void value_take_bezier (GValue* value,
                        gpointer v_object);
gpointer value_get_bezier (const GValue* value);
GType bezier_get_type (void) G_GNUC_CONST;
GType canvas_text_get_type (void) G_GNUC_CONST;
Style* style_new (void);
Style* style_construct (GType object_type);
GType draw_area_get_type (void) G_GNUC_CONST;
Connection* connection_new (DrawArea* da,
                            Node* from_node);
Connection* connection_construct (GType object_type,
                                  DrawArea* da,
                                  Node* from_node);
void node_bbox (Node* self,
                gdouble* x,
                gdouble* y,
                gdouble* w,
                gdouble* h);
void connection_connect_node (Connection* self,
                              Node* node);
static void connection_position_title (Connection* self);
Bezier* bezier_new_with_endpoints (gdouble x0,
                                   gdouble y0,
                                   gdouble x1,
                                   gdouble y1);
Bezier* bezier_construct_with_endpoints (GType object_type,
                                         gdouble x0,
                                         gdouble y0,
                                         gdouble x1,
                                         gdouble y1);
Theme* draw_area_get_theme (DrawArea* self);
GdkRGBA* theme_get_color (Theme* self,
                          const gchar* name);
gpointer styles_ref (gpointer instance);
void styles_unref (gpointer instance);
GParamSpec* param_spec_styles (const gchar* name,
                               const gchar* nick,
                               const gchar* blurb,
                               GType object_type,
                               GParamFlags flags);
void value_set_styles (GValue* value,
                       gpointer v_object);
void value_take_styles (GValue* value,
                        gpointer v_object);
gpointer value_get_styles (const GValue* value);
GType styles_get_type (void) G_GNUC_CONST;
Style* styles_get_global_style (Styles* self);
void connection_set_style (Connection* self,
                           Style* value);
Connection* connection_new_from_connection (DrawArea* da,
                                            Connection* conn);
Connection* connection_construct_from_connection (GType object_type,
                                                  DrawArea* da,
                                                  Connection* conn);
Bezier* bezier_new (void);
Bezier* bezier_construct (GType object_type);
void connection_copy (Connection* self,
                      DrawArea* da,
                      Connection* conn);
Connection* connection_new_from_xml (DrawArea* da,
                                     xmlNode* n,
                                     GArray* nodes,
                                     GeeHashMap* id_map);
Connection* connection_construct_from_xml (GType object_type,
                                           DrawArea* da,
                                           xmlNode* n,
                                           GArray* nodes,
                                           GeeHashMap* id_map);
static void connection_load (Connection* self,
                      DrawArea* da,
                      xmlNode* node,
                      GArray* nodes,
                      GeeHashMap* id_map);
void bezier_copy (Bezier* self,
                  Bezier* b);
CanvasText* connection_get_title (Connection* self);
static void _connection_position_title_canvas_text_resized (CanvasText* _sender,
                                                     gpointer self);
CanvasText* canvas_text_new (DrawArea* da,
                             gdouble max_width);
CanvasText* canvas_text_construct (GType object_type,
                                   DrawArea* da,
                                   gdouble max_width);
void canvas_text_copy (CanvasText* self,
                       CanvasText* ct);
ConnMode connection_get_mode (Connection* self);
void connection_set_mode (Connection* self,
                          ConnMode value);
Style* connection_get_style (Connection* self);
void connection_get_color (Connection* self,
                           GdkRGBA * result);
void connection_set_color (Connection* self,
                           GdkRGBA * value);
void connection_bbox (Connection* self,
                      gdouble* x,
                      gdouble* y,
                      gdouble* w,
                      gdouble* h);
void connection_edit_title_begin (Connection* self,
                                  DrawArea* da);
CanvasText* canvas_text_new_with_text (DrawArea* da,
                                       gdouble max_width,
                                       const gchar* txt);
CanvasText* canvas_text_construct_with_text (GType object_type,
                                             DrawArea* da,
                                             gdouble max_width,
                                             const gchar* txt);
void canvas_text_set_font (CanvasText* self,
                           PangoFontDescription* font);
PangoFontDescription* style_get_connection_font (Style* self);
void connection_edit_title_end (Connection* self);
const gchar* canvas_text_get_text (CanvasText* self);
void connection_change_title (Connection* self,
                              DrawArea* da,
                              const gchar* title,
                              gboolean allow_empty);
void canvas_text_set_text (CanvasText* self,
                           const gchar* value);
const gchar* connection_get_note (Connection* self);
gint* style_get_connection_padding (Style* self);
gdouble canvas_text_get_width (CanvasText* self);
gdouble canvas_text_get_height (CanvasText* self);
void canvas_text_set_posx (CanvasText* self,
                           gdouble value);
void canvas_text_set_posy (CanvasText* self,
                           gdouble value);
static void connection_end_moved (Connection* self,
                           Node* node,
                           gdouble diffx,
                           gdouble diffy);
static void _connection_end_moved_node_moved (Node* _sender,
                                       gdouble diffx,
                                       gdouble diffy,
                                       gpointer self);
static void connection_end_resized (Connection* self,
                             Node* node,
                             gdouble diffw,
                             gdouble diffh);
static void _connection_end_resized_node_resized (Node* _sender,
                                           gdouble diffw,
                                           gdouble diffh,
                                           gpointer self);
void connection_disconnect_node (Connection* self,
                                 Node* node);
Connection* node_get_last_selected_connection (Node* self);
void node_set_last_selected_connection (Node* self,
                                        Connection* value);
void connection_connect_to (Connection* self,
                            Node* node);
void bezier_set_point (Bezier* self,
                       gint pindex,
                       gdouble x,
                       gdouble y);
void bezier_get_point (Bezier* self,
                       gint pindex,
                       gdouble* x,
                       gdouble* y);
void bezier_update_control_from_drag_handle (Bezier* self,
                                             gdouble x,
                                             gdouble y);
static void connection_set_connect_point (Connection* self,
                                   Node* node);
void connection_disconnect_from_node (Connection* self,
                                      gboolean from);
void bezier_get_from_point (Bezier* self,
                            gdouble* x,
                            gdouble* y);
void bezier_get_to_point (Bezier* self,
                          gdouble* x,
                          gdouble* y);
void connection_draw_to (Connection* self,
                         gdouble x,
                         gdouble y);
gboolean connection_attached_to_node (Connection* self,
                                      Node* node);
Style* node_get_style (Node* self);
gint* style_get_node_borderwidth (Style* self);
gint* style_get_connection_width (Style* self);
gint* style_get_node_margin (Style* self);
void bezier_set_connect_point (Bezier* self,
                               gboolean from,
                               gdouble top,
                               gdouble bottom,
                               gdouble left,
                               gdouble right);
gboolean connection_on_curve (Connection* self,
                              gdouble x,
                              gdouble y);
gboolean bezier_within_range (Bezier* self,
                              gdouble x,
                              gdouble y);
static gboolean connection_within_handle (Connection* self,
                                   gdouble hx,
                                   gdouble hy,
                                   gdouble x,
                                   gdouble y);
gboolean connection_within_drag_handle (Connection* self,
                                        gdouble x,
                                        gdouble y);
static void connection_title_bbox (Connection* self,
                            gdouble* x,
                            gdouble* y,
                            gdouble* w,
                            gdouble* h);
gboolean connection_within_from_handle (Connection* self,
                                        gdouble x,
                                        gdouble y);
static gboolean connection_within_endpoint_handle (Connection* self,
                                            gboolean from,
                                            gdouble x,
                                            gdouble y);
gboolean connection_within_to_handle (Connection* self,
                                      gdouble x,
                                      gdouble y);
gboolean connection_within_title (Connection* self,
                                  gdouble x,
                                  gdouble y);
gboolean canvas_text_is_within (CanvasText* self,
                                gdouble x,
                                gdouble y);
gboolean connection_within_note (Connection* self,
                                 gdouble x,
                                 gdouble y);
static void connection_note_bbox (Connection* self,
                           gdouble* x,
                           gdouble* y,
                           gdouble* w,
                           gdouble* h);
gboolean utils_is_within_bounds (gdouble x,
                                 gdouble y,
                                 gdouble bx,
                                 gdouble by,
                                 gdouble bw,
                                 gdouble bh);
static gint* _int_dup (gint* self);
gdouble canvas_text_get_posx (CanvasText* self);
gdouble canvas_text_get_posy (CanvasText* self);
void connection_move_drag_handle (Connection* self,
                                  gdouble x,
                                  gdouble y);
Node* draw_area_get_node (DrawArea* self,
                          GArray* nodes,
                          gint id);
void connection_set_note (Connection* self,
                          const gchar* value);
void style_load_connection (Style* self,
                            xmlNode* node);
void connection_save (Connection* self,
                      xmlNode* parent);
gint node_id (Node* self);
void style_save_connection (Style* self,
                            xmlNode* parent);
void connection_get_match_items (Connection* self,
                                 const gchar* pattern,
                                 gboolean* search_opts,
                                 int search_opts_length1,
                                 GtkListStore* * matches);
void utils_match_string (const gchar* pattern,
                         const gchar* value,
                         const gchar* type,
                         Node* node,
                         Connection* conn,
                         GtkListStore* * matches);
void connection_draw (Connection* self,
                      cairo_t* ctx,
                      Theme* theme);
static void connection_real_draw (Connection* self,
                           cairo_t* ctx,
                           Theme* theme);
gboolean node_is_root (Node* self);
Node* node_get_parent (Node* self);
gboolean node_get_folded (Node* self);
void style_draw_connection (Style* self,
                            cairo_t* ctx);
void utils_set_context_color_with_alpha (cairo_t* ctx,
                                         GdkRGBA* color,
                                         gdouble alpha);
gdouble connection_get_alpha (Connection* self);
const gchar* style_get_connection_arrow (Style* self);
void connection_draw_arrow (cairo_t* ctx,
                            gint line_width,
                            gdouble tipx,
                            gdouble tipy,
                            gdouble tailx,
                            gdouble taily,
                            gdouble arrowLength);
static void connection_draw_title (Connection* self,
                            cairo_t* ctx,
                            Theme* theme);
void canvas_text_draw (CanvasText* self,
                       cairo_t* ctx,
                       Theme* theme,
                       GdkRGBA* fg,
                       gdouble alpha);
static void connection_draw_note (Connection* self,
                           cairo_t* ctx,
                           GdkRGBA* color);
cairo_surface_t* connection_make_arrow_icon (const gchar* type);
void canvas_text_set_edit (CanvasText* self,
                           gboolean value);
void canvas_text_set_cursor_all (CanvasText* self,
                                 gboolean motion);
void canvas_text_clear_selection (CanvasText* self);
Node* connection_get_from_node (Connection* self);
void connection_set_from_node (Connection* self,
                               Node* value);
Node* connection_get_to_node (Connection* self);
void connection_set_to_node (Connection* self,
                             Node* value);
gboolean style_copy (Style* self,
                     Style* s);
void connection_set_alpha (Connection* self,
                           gdouble value);
static gboolean _gdk_rgba_equal (const GdkRGBA * s1,
                          const GdkRGBA * s2);
static void connection_finalize (GObject * obj);
static void _vala_connection_get_property (GObject * object,
                                    guint property_id,
                                    GValue * value,
                                    GParamSpec * pspec);
static void _vala_connection_set_property (GObject * object,
                                    guint property_id,
                                    const GValue * value,
                                    GParamSpec * pspec);


GType
conn_mode_get_type (void)
{
	static volatile gsize conn_mode_type_id__volatile = 0;
	if (g_once_init_enter (&conn_mode_type_id__volatile)) {
		static const GEnumValue values[] = {{CONN_MODE_NONE, "CONN_MODE_NONE", "none"}, {CONN_MODE_LINKING, "CONN_MODE_LINKING", "linking"}, {CONN_MODE_CONNECTING, "CONN_MODE_CONNECTING", "connecting"}, {CONN_MODE_SELECTED, "CONN_MODE_SELECTED", "selected"}, {CONN_MODE_ADJUSTING, "CONN_MODE_ADJUSTING", "adjusting"}, {CONN_MODE_EDITABLE, "CONN_MODE_EDITABLE", "editable"}, {0, NULL, NULL}};
		GType conn_mode_type_id;
		conn_mode_type_id = g_enum_register_static ("ConnMode", values);
		g_once_init_leave (&conn_mode_type_id__volatile, conn_mode_type_id);
	}
	return conn_mode_type_id__volatile;
}


static inline gpointer
connection_get_instance_private (Connection* self)
{
	return G_STRUCT_MEMBER_P (self, Connection_private_offset);
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 128 "../src/Connection.vala"
	return self ? g_object_ref (self) : NULL;
#line 565 "Connection.c"
}


Connection*
connection_construct (GType object_type,
                      DrawArea* da,
                      Node* from_node)
{
	Connection * self = NULL;
	gdouble x = 0.0;
	gdouble y = 0.0;
	gdouble w = 0.0;
	gdouble h = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	Node* _tmp4_;
	Node* _tmp5_;
	gdouble _tmp6_;
	gdouble _tmp7_;
	gdouble _tmp8_;
	gdouble _tmp9_;
	gdouble _tmp10_;
	gdouble _tmp11_;
	Bezier* _tmp12_;
	Theme* _tmp13_;
	Theme* _tmp14_;
	GdkRGBA* _tmp15_;
	GdkRGBA* _tmp16_;
	Styles* _tmp17_;
	Style* _tmp18_;
	Style* _tmp19_;
#line 123 "../src/Connection.vala"
	g_return_val_if_fail (da != NULL, NULL);
#line 123 "../src/Connection.vala"
	g_return_val_if_fail (from_node != NULL, NULL);
#line 123 "../src/Connection.vala"
	self = (Connection*) g_object_new (object_type, NULL);
#line 125 "../src/Connection.vala"
	node_bbox (from_node, &_tmp0_, &_tmp1_, &_tmp2_, &_tmp3_);
#line 125 "../src/Connection.vala"
	x = _tmp0_;
#line 125 "../src/Connection.vala"
	y = _tmp1_;
#line 125 "../src/Connection.vala"
	w = _tmp2_;
#line 125 "../src/Connection.vala"
	h = _tmp3_;
#line 126 "../src/Connection.vala"
	self->priv->_posx = x + (w / 2);
#line 127 "../src/Connection.vala"
	self->priv->_posy = y + (h / 2);
#line 128 "../src/Connection.vala"
	_tmp4_ = _g_object_ref0 (from_node);
#line 128 "../src/Connection.vala"
	_g_object_unref0 (self->priv->_from_node);
#line 128 "../src/Connection.vala"
	self->priv->_from_node = _tmp4_;
#line 129 "../src/Connection.vala"
	_tmp5_ = self->priv->_from_node;
#line 129 "../src/Connection.vala"
	connection_connect_node (self, _tmp5_);
#line 130 "../src/Connection.vala"
	_tmp6_ = self->priv->_posx;
#line 130 "../src/Connection.vala"
	self->priv->_dragx = _tmp6_;
#line 131 "../src/Connection.vala"
	_tmp7_ = self->priv->_posy;
#line 131 "../src/Connection.vala"
	self->priv->_dragy = _tmp7_;
#line 132 "../src/Connection.vala"
	connection_position_title (self);
#line 133 "../src/Connection.vala"
	_tmp8_ = self->priv->_posx;
#line 133 "../src/Connection.vala"
	_tmp9_ = self->priv->_posy;
#line 133 "../src/Connection.vala"
	_tmp10_ = self->priv->_posx;
#line 133 "../src/Connection.vala"
	_tmp11_ = self->priv->_posy;
#line 133 "../src/Connection.vala"
	_tmp12_ = bezier_new_with_endpoints (_tmp8_, _tmp9_, _tmp10_, _tmp11_);
#line 133 "../src/Connection.vala"
	_bezier_unref0 (self->priv->_curve);
#line 133 "../src/Connection.vala"
	self->priv->_curve = _tmp12_;
#line 134 "../src/Connection.vala"
	_tmp13_ = draw_area_get_theme (da);
#line 134 "../src/Connection.vala"
	_tmp14_ = _tmp13_;
#line 134 "../src/Connection.vala"
	_tmp15_ = theme_get_color (_tmp14_, "connection");
#line 134 "../src/Connection.vala"
	_tmp16_ = _tmp15_;
#line 134 "../src/Connection.vala"
	self->priv->_color = *_tmp16_;
#line 134 "../src/Connection.vala"
	_g_free0 (_tmp16_);
#line 134 "../src/Connection.vala"
	_g_object_unref0 (_tmp14_);
#line 135 "../src/Connection.vala"
	_tmp17_ = style_inspector_styles;
#line 135 "../src/Connection.vala"
	_tmp18_ = styles_get_global_style (_tmp17_);
#line 135 "../src/Connection.vala"
	_tmp19_ = _tmp18_;
#line 135 "../src/Connection.vala"
	connection_set_style (self, _tmp19_);
#line 135 "../src/Connection.vala"
	_style_unref0 (_tmp19_);
#line 123 "../src/Connection.vala"
	return self;
#line 679 "Connection.c"
}


Connection*
connection_new (DrawArea* da,
                Node* from_node)
{
#line 123 "../src/Connection.vala"
	return connection_construct (TYPE_CONNECTION, da, from_node);
#line 689 "Connection.c"
}


Connection*
connection_construct_from_connection (GType object_type,
                                      DrawArea* da,
                                      Connection* conn)
{
	Connection * self = NULL;
	Bezier* _tmp0_;
#line 139 "../src/Connection.vala"
	g_return_val_if_fail (da != NULL, NULL);
#line 139 "../src/Connection.vala"
	g_return_val_if_fail (conn != NULL, NULL);
#line 139 "../src/Connection.vala"
	self = (Connection*) g_object_new (object_type, NULL);
#line 140 "../src/Connection.vala"
	_tmp0_ = bezier_new ();
#line 140 "../src/Connection.vala"
	_bezier_unref0 (self->priv->_curve);
#line 140 "../src/Connection.vala"
	self->priv->_curve = _tmp0_;
#line 141 "../src/Connection.vala"
	connection_copy (self, da, conn);
#line 139 "../src/Connection.vala"
	return self;
#line 716 "Connection.c"
}


Connection*
connection_new_from_connection (DrawArea* da,
                                Connection* conn)
{
#line 139 "../src/Connection.vala"
	return connection_construct_from_connection (TYPE_CONNECTION, da, conn);
#line 726 "Connection.c"
}


Connection*
connection_construct_from_xml (GType object_type,
                               DrawArea* da,
                               xmlNode* n,
                               GArray* nodes,
                               GeeHashMap* id_map)
{
	Connection * self = NULL;
	Styles* _tmp0_;
	Style* _tmp1_;
	Style* _tmp2_;
#line 145 "../src/Connection.vala"
	g_return_val_if_fail (da != NULL, NULL);
#line 145 "../src/Connection.vala"
	g_return_val_if_fail (nodes != NULL, NULL);
#line 145 "../src/Connection.vala"
	g_return_val_if_fail (id_map != NULL, NULL);
#line 145 "../src/Connection.vala"
	self = (Connection*) g_object_new (object_type, NULL);
#line 146 "../src/Connection.vala"
	_tmp0_ = style_inspector_styles;
#line 146 "../src/Connection.vala"
	_tmp1_ = styles_get_global_style (_tmp0_);
#line 146 "../src/Connection.vala"
	_tmp2_ = _tmp1_;
#line 146 "../src/Connection.vala"
	connection_set_style (self, _tmp2_);
#line 146 "../src/Connection.vala"
	_style_unref0 (_tmp2_);
#line 147 "../src/Connection.vala"
	connection_load (self, da, n, nodes, id_map);
#line 145 "../src/Connection.vala"
	return self;
#line 763 "Connection.c"
}


Connection*
connection_new_from_xml (DrawArea* da,
                         xmlNode* n,
                         GArray* nodes,
                         GeeHashMap* id_map)
{
#line 145 "../src/Connection.vala"
	return connection_construct_from_xml (TYPE_CONNECTION, da, n, nodes, id_map);
#line 775 "Connection.c"
}


static void
_connection_position_title_canvas_text_resized (CanvasText* _sender,
                                                gpointer self)
{
#line 160 "../src/Connection.vala"
	connection_position_title ((Connection*) self);
#line 785 "Connection.c"
}


void
connection_copy (Connection* self,
                 DrawArea* da,
                 Connection* conn)
{
	Node* _tmp0_;
	Node* _tmp1_;
	Node* _tmp2_;
	Node* _tmp3_;
	gdouble _tmp4_;
	gdouble _tmp5_;
	Bezier* _tmp6_;
	Bezier* _tmp7_;
	CanvasText* _tmp8_;
	CanvasText* _tmp9_;
	ConnMode _tmp21_;
	ConnMode _tmp22_;
	Style* _tmp23_;
	Style* _tmp24_;
	GdkRGBA _tmp25_;
#line 151 "../src/Connection.vala"
	g_return_if_fail (self != NULL);
#line 151 "../src/Connection.vala"
	g_return_if_fail (da != NULL);
#line 151 "../src/Connection.vala"
	g_return_if_fail (conn != NULL);
#line 152 "../src/Connection.vala"
	_tmp0_ = conn->priv->_from_node;
#line 152 "../src/Connection.vala"
	_tmp1_ = _g_object_ref0 (_tmp0_);
#line 152 "../src/Connection.vala"
	_g_object_unref0 (self->priv->_from_node);
#line 152 "../src/Connection.vala"
	self->priv->_from_node = _tmp1_;
#line 153 "../src/Connection.vala"
	_tmp2_ = conn->priv->_to_node;
#line 153 "../src/Connection.vala"
	_tmp3_ = _g_object_ref0 (_tmp2_);
#line 153 "../src/Connection.vala"
	_g_object_unref0 (self->priv->_to_node);
#line 153 "../src/Connection.vala"
	self->priv->_to_node = _tmp3_;
#line 154 "../src/Connection.vala"
	_tmp4_ = conn->priv->_dragx;
#line 154 "../src/Connection.vala"
	self->priv->_dragx = _tmp4_;
#line 155 "../src/Connection.vala"
	_tmp5_ = conn->priv->_dragy;
#line 155 "../src/Connection.vala"
	self->priv->_dragy = _tmp5_;
#line 156 "../src/Connection.vala"
	connection_position_title (self);
#line 157 "../src/Connection.vala"
	_tmp6_ = self->priv->_curve;
#line 157 "../src/Connection.vala"
	_tmp7_ = conn->priv->_curve;
#line 157 "../src/Connection.vala"
	bezier_copy (_tmp6_, _tmp7_);
#line 158 "../src/Connection.vala"
	_tmp8_ = connection_get_title (conn);
#line 158 "../src/Connection.vala"
	_tmp9_ = _tmp8_;
#line 158 "../src/Connection.vala"
	if (_tmp9_ == NULL) {
#line 853 "Connection.c"
		CanvasText* _tmp10_;
#line 159 "../src/Connection.vala"
		_tmp10_ = self->priv->_title;
#line 159 "../src/Connection.vala"
		if (_tmp10_ != NULL) {
#line 859 "Connection.c"
			CanvasText* _tmp11_;
			guint _tmp12_;
#line 160 "../src/Connection.vala"
			_tmp11_ = self->priv->_title;
#line 160 "../src/Connection.vala"
			g_signal_parse_name ("resized", TYPE_CANVAS_TEXT, &_tmp12_, NULL, FALSE);
#line 160 "../src/Connection.vala"
			g_signal_handlers_disconnect_matched (_tmp11_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp12_, 0, NULL, (GCallback) _connection_position_title_canvas_text_resized, self);
#line 868 "Connection.c"
		}
#line 162 "../src/Connection.vala"
		_g_object_unref0 (self->priv->_title);
#line 162 "../src/Connection.vala"
		self->priv->_title = NULL;
#line 874 "Connection.c"
	} else {
		CanvasText* _tmp13_;
		CanvasText* _tmp14_;
		CanvasText* _tmp18_;
		CanvasText* _tmp19_;
		CanvasText* _tmp20_;
#line 164 "../src/Connection.vala"
		_tmp13_ = connection_get_title (self);
#line 164 "../src/Connection.vala"
		_tmp14_ = _tmp13_;
#line 164 "../src/Connection.vala"
		if (_tmp14_ == NULL) {
#line 887 "Connection.c"
			gdouble _tmp15_;
			CanvasText* _tmp16_;
			CanvasText* _tmp17_;
#line 165 "../src/Connection.vala"
			_tmp15_ = self->priv->_max_width;
#line 165 "../src/Connection.vala"
			_tmp16_ = canvas_text_new (da, _tmp15_);
#line 165 "../src/Connection.vala"
			_g_object_unref0 (self->priv->_title);
#line 165 "../src/Connection.vala"
			self->priv->_title = _tmp16_;
#line 166 "../src/Connection.vala"
			_tmp17_ = self->priv->_title;
#line 166 "../src/Connection.vala"
			g_signal_connect_object (_tmp17_, "resized", (GCallback) _connection_position_title_canvas_text_resized, self, 0);
#line 903 "Connection.c"
		}
#line 168 "../src/Connection.vala"
		_tmp18_ = self->priv->_title;
#line 168 "../src/Connection.vala"
		_tmp19_ = connection_get_title (conn);
#line 168 "../src/Connection.vala"
		_tmp20_ = _tmp19_;
#line 168 "../src/Connection.vala"
		canvas_text_copy (_tmp18_, _tmp20_);
#line 913 "Connection.c"
	}
#line 170 "../src/Connection.vala"
	_tmp21_ = connection_get_mode (conn);
#line 170 "../src/Connection.vala"
	_tmp22_ = _tmp21_;
#line 170 "../src/Connection.vala"
	connection_set_mode (self, _tmp22_);
#line 171 "../src/Connection.vala"
	_tmp23_ = connection_get_style (conn);
#line 171 "../src/Connection.vala"
	_tmp24_ = _tmp23_;
#line 171 "../src/Connection.vala"
	connection_set_style (self, _tmp24_);
#line 172 "../src/Connection.vala"
	_tmp25_ = conn->priv->_color;
#line 172 "../src/Connection.vala"
	connection_set_color (self, &_tmp25_);
#line 931 "Connection.c"
}


void
connection_bbox (Connection* self,
                 gdouble* x,
                 gdouble* y,
                 gdouble* w,
                 gdouble* h)
{
	gdouble _vala_x = 0.0;
	gdouble _vala_y = 0.0;
	gdouble _vala_w = 0.0;
	gdouble _vala_h = 0.0;
	gdouble fx = 0.0;
	gdouble fy = 0.0;
	gdouble fw = 0.0;
	gdouble fh = 0.0;
	gdouble tx = 0.0;
	gdouble ty = 0.0;
	gdouble tw = 0.0;
	gdouble th = 0.0;
	gboolean _tmp0_ = FALSE;
	Node* _tmp1_;
#line 176 "../src/Connection.vala"
	g_return_if_fail (self != NULL);
#line 179 "../src/Connection.vala"
	_tmp1_ = self->priv->_from_node;
#line 179 "../src/Connection.vala"
	if (_tmp1_ != NULL) {
#line 962 "Connection.c"
		Node* _tmp2_;
#line 179 "../src/Connection.vala"
		_tmp2_ = self->priv->_to_node;
#line 179 "../src/Connection.vala"
		_tmp0_ = _tmp2_ != NULL;
#line 968 "Connection.c"
	} else {
#line 179 "../src/Connection.vala"
		_tmp0_ = FALSE;
#line 972 "Connection.c"
	}
#line 179 "../src/Connection.vala"
	if (_tmp0_) {
#line 976 "Connection.c"
		Node* _tmp3_;
		gdouble _tmp4_ = 0.0;
		gdouble _tmp5_ = 0.0;
		gdouble _tmp6_ = 0.0;
		gdouble _tmp7_ = 0.0;
		Node* _tmp8_;
		gdouble _tmp9_ = 0.0;
		gdouble _tmp10_ = 0.0;
		gdouble _tmp11_ = 0.0;
		gdouble _tmp12_ = 0.0;
		gdouble _tmp13_ = 0.0;
		gdouble _tmp14_;
		gdouble _tmp15_;
		gdouble _tmp18_ = 0.0;
		gdouble _tmp19_;
		gdouble _tmp20_;
		gdouble _tmp23_ = 0.0;
		gdouble _tmp24_;
		gdouble _tmp25_;
		gdouble _tmp26_;
		gdouble _tmp27_;
		gdouble _tmp34_ = 0.0;
		gdouble _tmp35_;
		gdouble _tmp36_;
		gdouble _tmp37_;
		gdouble _tmp38_;
#line 180 "../src/Connection.vala"
		_tmp3_ = self->priv->_from_node;
#line 180 "../src/Connection.vala"
		node_bbox (_tmp3_, &_tmp4_, &_tmp5_, &_tmp6_, &_tmp7_);
#line 180 "../src/Connection.vala"
		fx = _tmp4_;
#line 180 "../src/Connection.vala"
		fy = _tmp5_;
#line 180 "../src/Connection.vala"
		fw = _tmp6_;
#line 180 "../src/Connection.vala"
		fh = _tmp7_;
#line 181 "../src/Connection.vala"
		_tmp8_ = self->priv->_to_node;
#line 181 "../src/Connection.vala"
		node_bbox (_tmp8_, &_tmp9_, &_tmp10_, &_tmp11_, &_tmp12_);
#line 181 "../src/Connection.vala"
		tx = _tmp9_;
#line 181 "../src/Connection.vala"
		ty = _tmp10_;
#line 181 "../src/Connection.vala"
		tw = _tmp11_;
#line 181 "../src/Connection.vala"
		th = _tmp12_;
#line 182 "../src/Connection.vala"
		_tmp14_ = fx;
#line 182 "../src/Connection.vala"
		_tmp15_ = tx;
#line 182 "../src/Connection.vala"
		if (_tmp14_ < _tmp15_) {
#line 1033 "Connection.c"
			gdouble _tmp16_;
#line 182 "../src/Connection.vala"
			_tmp16_ = fx;
#line 182 "../src/Connection.vala"
			_tmp13_ = _tmp16_;
#line 1039 "Connection.c"
		} else {
			gdouble _tmp17_;
#line 182 "../src/Connection.vala"
			_tmp17_ = tx;
#line 182 "../src/Connection.vala"
			_tmp13_ = _tmp17_;
#line 1046 "Connection.c"
		}
#line 182 "../src/Connection.vala"
		_vala_x = _tmp13_;
#line 183 "../src/Connection.vala"
		_tmp19_ = fy;
#line 183 "../src/Connection.vala"
		_tmp20_ = ty;
#line 183 "../src/Connection.vala"
		if (_tmp19_ < _tmp20_) {
#line 1056 "Connection.c"
			gdouble _tmp21_;
#line 183 "../src/Connection.vala"
			_tmp21_ = fy;
#line 183 "../src/Connection.vala"
			_tmp18_ = _tmp21_;
#line 1062 "Connection.c"
		} else {
			gdouble _tmp22_;
#line 183 "../src/Connection.vala"
			_tmp22_ = ty;
#line 183 "../src/Connection.vala"
			_tmp18_ = _tmp22_;
#line 1069 "Connection.c"
		}
#line 183 "../src/Connection.vala"
		_vala_y = _tmp18_;
#line 184 "../src/Connection.vala"
		_tmp24_ = fx;
#line 184 "../src/Connection.vala"
		_tmp25_ = fw;
#line 184 "../src/Connection.vala"
		_tmp26_ = tx;
#line 184 "../src/Connection.vala"
		_tmp27_ = tw;
#line 184 "../src/Connection.vala"
		if ((_tmp24_ + _tmp25_) > (_tmp26_ + _tmp27_)) {
#line 1083 "Connection.c"
			gdouble _tmp28_;
			gdouble _tmp29_;
			gdouble _tmp30_;
#line 184 "../src/Connection.vala"
			_tmp28_ = fx;
#line 184 "../src/Connection.vala"
			_tmp29_ = fw;
#line 184 "../src/Connection.vala"
			_tmp30_ = _vala_x;
#line 184 "../src/Connection.vala"
			_tmp23_ = (_tmp28_ + _tmp29_) - _tmp30_;
#line 1095 "Connection.c"
		} else {
			gdouble _tmp31_;
			gdouble _tmp32_;
			gdouble _tmp33_;
#line 184 "../src/Connection.vala"
			_tmp31_ = tx;
#line 184 "../src/Connection.vala"
			_tmp32_ = tw;
#line 184 "../src/Connection.vala"
			_tmp33_ = _vala_x;
#line 184 "../src/Connection.vala"
			_tmp23_ = (_tmp31_ + _tmp32_) - _tmp33_;
#line 1108 "Connection.c"
		}
#line 184 "../src/Connection.vala"
		_vala_w = _tmp23_;
#line 185 "../src/Connection.vala"
		_tmp35_ = fy;
#line 185 "../src/Connection.vala"
		_tmp36_ = fh;
#line 185 "../src/Connection.vala"
		_tmp37_ = ty;
#line 185 "../src/Connection.vala"
		_tmp38_ = th;
#line 185 "../src/Connection.vala"
		if ((_tmp35_ + _tmp36_) > (_tmp37_ + _tmp38_)) {
#line 1122 "Connection.c"
			gdouble _tmp39_;
			gdouble _tmp40_;
			gdouble _tmp41_;
#line 185 "../src/Connection.vala"
			_tmp39_ = fy;
#line 185 "../src/Connection.vala"
			_tmp40_ = fh;
#line 185 "../src/Connection.vala"
			_tmp41_ = _vala_y;
#line 185 "../src/Connection.vala"
			_tmp34_ = (_tmp39_ + _tmp40_) - _tmp41_;
#line 1134 "Connection.c"
		} else {
			gdouble _tmp42_;
			gdouble _tmp43_;
			gdouble _tmp44_;
#line 185 "../src/Connection.vala"
			_tmp42_ = ty;
#line 185 "../src/Connection.vala"
			_tmp43_ = th;
#line 185 "../src/Connection.vala"
			_tmp44_ = _vala_y;
#line 185 "../src/Connection.vala"
			_tmp34_ = (_tmp42_ + _tmp43_) - _tmp44_;
#line 1147 "Connection.c"
		}
#line 185 "../src/Connection.vala"
		_vala_h = _tmp34_;
#line 1151 "Connection.c"
	} else {
		Node* _tmp45_;
#line 186 "../src/Connection.vala"
		_tmp45_ = self->priv->_from_node;
#line 186 "../src/Connection.vala"
		if (_tmp45_ != NULL) {
#line 1158 "Connection.c"
			Node* _tmp46_;
			gdouble _tmp47_ = 0.0;
			gdouble _tmp48_ = 0.0;
			gdouble _tmp49_ = 0.0;
			gdouble _tmp50_ = 0.0;
#line 187 "../src/Connection.vala"
			_tmp46_ = self->priv->_from_node;
#line 187 "../src/Connection.vala"
			node_bbox (_tmp46_, &_tmp47_, &_tmp48_, &_tmp49_, &_tmp50_);
#line 187 "../src/Connection.vala"
			_vala_x = _tmp47_;
#line 187 "../src/Connection.vala"
			_vala_y = _tmp48_;
#line 187 "../src/Connection.vala"
			_vala_w = _tmp49_;
#line 187 "../src/Connection.vala"
			_vala_h = _tmp50_;
#line 1176 "Connection.c"
		} else {
			Node* _tmp51_;
#line 188 "../src/Connection.vala"
			_tmp51_ = self->priv->_to_node;
#line 188 "../src/Connection.vala"
			if (_tmp51_ != NULL) {
#line 1183 "Connection.c"
				Node* _tmp52_;
				gdouble _tmp53_ = 0.0;
				gdouble _tmp54_ = 0.0;
				gdouble _tmp55_ = 0.0;
				gdouble _tmp56_ = 0.0;
#line 189 "../src/Connection.vala"
				_tmp52_ = self->priv->_to_node;
#line 189 "../src/Connection.vala"
				node_bbox (_tmp52_, &_tmp53_, &_tmp54_, &_tmp55_, &_tmp56_);
#line 189 "../src/Connection.vala"
				_vala_x = _tmp53_;
#line 189 "../src/Connection.vala"
				_vala_y = _tmp54_;
#line 189 "../src/Connection.vala"
				_vala_w = _tmp55_;
#line 189 "../src/Connection.vala"
				_vala_h = _tmp56_;
#line 1201 "Connection.c"
			} else {
#line 191 "../src/Connection.vala"
				_vala_x = (gdouble) 0;
#line 192 "../src/Connection.vala"
				_vala_y = (gdouble) 0;
#line 193 "../src/Connection.vala"
				_vala_w = (gdouble) 0;
#line 194 "../src/Connection.vala"
				_vala_h = (gdouble) 0;
#line 1211 "Connection.c"
			}
		}
	}
#line 176 "../src/Connection.vala"
	if (x) {
#line 176 "../src/Connection.vala"
		*x = _vala_x;
#line 1219 "Connection.c"
	}
#line 176 "../src/Connection.vala"
	if (y) {
#line 176 "../src/Connection.vala"
		*y = _vala_y;
#line 1225 "Connection.c"
	}
#line 176 "../src/Connection.vala"
	if (w) {
#line 176 "../src/Connection.vala"
		*w = _vala_w;
#line 1231 "Connection.c"
	}
#line 176 "../src/Connection.vala"
	if (h) {
#line 176 "../src/Connection.vala"
		*h = _vala_h;
#line 1237 "Connection.c"
	}
}


void
connection_edit_title_begin (Connection* self,
                             DrawArea* da)
{
	CanvasText* _tmp0_;
	gdouble _tmp1_;
	CanvasText* _tmp2_;
	CanvasText* _tmp3_;
	CanvasText* _tmp4_;
	Style* _tmp5_;
	Style* _tmp6_;
	PangoFontDescription* _tmp7_;
	PangoFontDescription* _tmp8_;
#line 199 "../src/Connection.vala"
	g_return_if_fail (self != NULL);
#line 199 "../src/Connection.vala"
	g_return_if_fail (da != NULL);
#line 200 "../src/Connection.vala"
	_tmp0_ = self->priv->_title;
#line 200 "../src/Connection.vala"
	if (_tmp0_ != NULL) {
#line 200 "../src/Connection.vala"
		return;
#line 1265 "Connection.c"
	}
#line 201 "../src/Connection.vala"
	_tmp1_ = self->priv->_max_width;
#line 201 "../src/Connection.vala"
	_tmp2_ = canvas_text_new_with_text (da, _tmp1_, "");
#line 201 "../src/Connection.vala"
	_g_object_unref0 (self->priv->_title);
#line 201 "../src/Connection.vala"
	self->priv->_title = _tmp2_;
#line 202 "../src/Connection.vala"
	_tmp3_ = self->priv->_title;
#line 202 "../src/Connection.vala"
	g_signal_connect_object (_tmp3_, "resized", (GCallback) _connection_position_title_canvas_text_resized, self, 0);
#line 203 "../src/Connection.vala"
	_tmp4_ = self->priv->_title;
#line 203 "../src/Connection.vala"
	_tmp5_ = connection_get_style (self);
#line 203 "../src/Connection.vala"
	_tmp6_ = _tmp5_;
#line 203 "../src/Connection.vala"
	_tmp7_ = style_get_connection_font (_tmp6_);
#line 203 "../src/Connection.vala"
	_tmp8_ = _tmp7_;
#line 203 "../src/Connection.vala"
	canvas_text_set_font (_tmp4_, _tmp8_);
#line 204 "../src/Connection.vala"
	connection_position_title (self);
#line 1293 "Connection.c"
}


void
connection_edit_title_end (Connection* self)
{
	gboolean _tmp0_ = FALSE;
	CanvasText* _tmp1_;
	CanvasText* _tmp5_;
	guint _tmp6_;
#line 208 "../src/Connection.vala"
	g_return_if_fail (self != NULL);
#line 209 "../src/Connection.vala"
	_tmp1_ = self->priv->_title;
#line 209 "../src/Connection.vala"
	if (_tmp1_ == NULL) {
#line 209 "../src/Connection.vala"
		_tmp0_ = TRUE;
#line 1312 "Connection.c"
	} else {
		CanvasText* _tmp2_;
		const gchar* _tmp3_;
		const gchar* _tmp4_;
#line 209 "../src/Connection.vala"
		_tmp2_ = self->priv->_title;
#line 209 "../src/Connection.vala"
		_tmp3_ = canvas_text_get_text (_tmp2_);
#line 209 "../src/Connection.vala"
		_tmp4_ = _tmp3_;
#line 209 "../src/Connection.vala"
		_tmp0_ = g_strcmp0 (_tmp4_, "") != 0;
#line 1325 "Connection.c"
	}
#line 209 "../src/Connection.vala"
	if (_tmp0_) {
#line 209 "../src/Connection.vala"
		return;
#line 1331 "Connection.c"
	}
#line 210 "../src/Connection.vala"
	_tmp5_ = self->priv->_title;
#line 210 "../src/Connection.vala"
	g_signal_parse_name ("resized", TYPE_CANVAS_TEXT, &_tmp6_, NULL, FALSE);
#line 210 "../src/Connection.vala"
	g_signal_handlers_disconnect_matched (_tmp5_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp6_, 0, NULL, (GCallback) _connection_position_title_canvas_text_resized, self);
#line 211 "../src/Connection.vala"
	_g_object_unref0 (self->priv->_title);
#line 211 "../src/Connection.vala"
	self->priv->_title = NULL;
#line 1343 "Connection.c"
}


void
connection_change_title (Connection* self,
                         DrawArea* da,
                         const gchar* title,
                         gboolean allow_empty)
{
	gboolean _tmp0_ = FALSE;
#line 215 "../src/Connection.vala"
	g_return_if_fail (self != NULL);
#line 215 "../src/Connection.vala"
	g_return_if_fail (da != NULL);
#line 215 "../src/Connection.vala"
	g_return_if_fail (title != NULL);
#line 216 "../src/Connection.vala"
	if (g_strcmp0 (title, "") == 0) {
#line 216 "../src/Connection.vala"
		_tmp0_ = !allow_empty;
#line 1364 "Connection.c"
	} else {
#line 216 "../src/Connection.vala"
		_tmp0_ = FALSE;
#line 1368 "Connection.c"
	}
#line 216 "../src/Connection.vala"
	if (_tmp0_) {
#line 1372 "Connection.c"
		CanvasText* _tmp1_;
#line 217 "../src/Connection.vala"
		_tmp1_ = self->priv->_title;
#line 217 "../src/Connection.vala"
		if (_tmp1_ != NULL) {
#line 1378 "Connection.c"
			CanvasText* _tmp2_;
			guint _tmp3_;
#line 218 "../src/Connection.vala"
			_tmp2_ = self->priv->_title;
#line 218 "../src/Connection.vala"
			g_signal_parse_name ("resized", TYPE_CANVAS_TEXT, &_tmp3_, NULL, FALSE);
#line 218 "../src/Connection.vala"
			g_signal_handlers_disconnect_matched (_tmp2_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _connection_position_title_canvas_text_resized, self);
#line 1387 "Connection.c"
		}
#line 220 "../src/Connection.vala"
		_g_object_unref0 (self->priv->_title);
#line 220 "../src/Connection.vala"
		self->priv->_title = NULL;
#line 1393 "Connection.c"
	} else {
		CanvasText* _tmp4_;
#line 221 "../src/Connection.vala"
		_tmp4_ = self->priv->_title;
#line 221 "../src/Connection.vala"
		if (_tmp4_ == NULL) {
#line 1400 "Connection.c"
			gdouble _tmp5_;
			CanvasText* _tmp6_;
			CanvasText* _tmp7_;
			CanvasText* _tmp8_;
			Style* _tmp9_;
			Style* _tmp10_;
			PangoFontDescription* _tmp11_;
			PangoFontDescription* _tmp12_;
#line 222 "../src/Connection.vala"
			_tmp5_ = self->priv->_max_width;
#line 222 "../src/Connection.vala"
			_tmp6_ = canvas_text_new_with_text (da, _tmp5_, title);
#line 222 "../src/Connection.vala"
			_g_object_unref0 (self->priv->_title);
#line 222 "../src/Connection.vala"
			self->priv->_title = _tmp6_;
#line 223 "../src/Connection.vala"
			_tmp7_ = self->priv->_title;
#line 223 "../src/Connection.vala"
			g_signal_connect_object (_tmp7_, "resized", (GCallback) _connection_position_title_canvas_text_resized, self, 0);
#line 224 "../src/Connection.vala"
			_tmp8_ = self->priv->_title;
#line 224 "../src/Connection.vala"
			_tmp9_ = connection_get_style (self);
#line 224 "../src/Connection.vala"
			_tmp10_ = _tmp9_;
#line 224 "../src/Connection.vala"
			_tmp11_ = style_get_connection_font (_tmp10_);
#line 224 "../src/Connection.vala"
			_tmp12_ = _tmp11_;
#line 224 "../src/Connection.vala"
			canvas_text_set_font (_tmp8_, _tmp12_);
#line 225 "../src/Connection.vala"
			connection_position_title (self);
#line 1435 "Connection.c"
		} else {
			CanvasText* _tmp13_;
#line 227 "../src/Connection.vala"
			_tmp13_ = self->priv->_title;
#line 227 "../src/Connection.vala"
			canvas_text_set_text (_tmp13_, title);
#line 1442 "Connection.c"
		}
	}
}


static void
connection_position_title (Connection* self)
{
	CanvasText* _tmp0_;
	CanvasText* _tmp1_;
#line 232 "../src/Connection.vala"
	g_return_if_fail (self != NULL);
#line 233 "../src/Connection.vala"
	_tmp0_ = connection_get_title (self);
#line 233 "../src/Connection.vala"
	_tmp1_ = _tmp0_;
#line 233 "../src/Connection.vala"
	if (_tmp1_ != NULL) {
#line 1461 "Connection.c"
		gint _tmp2_ = 0;
		const gchar* _tmp3_;
		const gchar* _tmp4_;
		gint _tmp5_;
		gint _tmp6_;
		gdouble width = 0.0;
		CanvasText* _tmp11_;
		CanvasText* _tmp12_;
		gdouble _tmp13_;
		gdouble _tmp14_;
		gdouble _tmp15_ = 0.0;
		CanvasText* _tmp16_;
		CanvasText* _tmp17_;
		gdouble _tmp18_;
		gdouble _tmp19_;
		gdouble height = 0.0;
		CanvasText* _tmp24_;
		gdouble _tmp25_;
		gdouble _tmp26_;
		CanvasText* _tmp27_;
		gdouble _tmp28_;
		gdouble _tmp29_;
#line 234 "../src/Connection.vala"
		_tmp3_ = connection_get_note (self);
#line 234 "../src/Connection.vala"
		_tmp4_ = _tmp3_;
#line 234 "../src/Connection.vala"
		_tmp5_ = strlen (_tmp4_);
#line 234 "../src/Connection.vala"
		_tmp6_ = _tmp5_;
#line 234 "../src/Connection.vala"
		if (_tmp6_ > 0) {
#line 1494 "Connection.c"
			Style* _tmp7_;
			Style* _tmp8_;
			gint* _tmp9_;
			gint* _tmp10_;
#line 234 "../src/Connection.vala"
			_tmp7_ = connection_get_style (self);
#line 234 "../src/Connection.vala"
			_tmp8_ = _tmp7_;
#line 234 "../src/Connection.vala"
			_tmp9_ = style_get_connection_padding (_tmp8_);
#line 234 "../src/Connection.vala"
			_tmp10_ = _tmp9_;
#line 234 "../src/Connection.vala"
			_tmp2_ = (*_tmp10_) + 11;
#line 1509 "Connection.c"
		} else {
#line 234 "../src/Connection.vala"
			_tmp2_ = 0;
#line 1513 "Connection.c"
		}
#line 234 "../src/Connection.vala"
		_tmp11_ = connection_get_title (self);
#line 234 "../src/Connection.vala"
		_tmp12_ = _tmp11_;
#line 234 "../src/Connection.vala"
		_tmp13_ = canvas_text_get_width (_tmp12_);
#line 234 "../src/Connection.vala"
		_tmp14_ = _tmp13_;
#line 234 "../src/Connection.vala"
		width = _tmp14_ + _tmp2_;
#line 235 "../src/Connection.vala"
		_tmp16_ = connection_get_title (self);
#line 235 "../src/Connection.vala"
		_tmp17_ = _tmp16_;
#line 235 "../src/Connection.vala"
		_tmp18_ = canvas_text_get_height (_tmp17_);
#line 235 "../src/Connection.vala"
		_tmp19_ = _tmp18_;
#line 235 "../src/Connection.vala"
		if (_tmp19_ < ((gdouble) 11)) {
#line 235 "../src/Connection.vala"
			_tmp15_ = (gdouble) 11;
#line 1537 "Connection.c"
		} else {
			CanvasText* _tmp20_;
			CanvasText* _tmp21_;
			gdouble _tmp22_;
			gdouble _tmp23_;
#line 235 "../src/Connection.vala"
			_tmp20_ = connection_get_title (self);
#line 235 "../src/Connection.vala"
			_tmp21_ = _tmp20_;
#line 235 "../src/Connection.vala"
			_tmp22_ = canvas_text_get_height (_tmp21_);
#line 235 "../src/Connection.vala"
			_tmp23_ = _tmp22_;
#line 235 "../src/Connection.vala"
			_tmp15_ = _tmp23_;
#line 1553 "Connection.c"
		}
#line 235 "../src/Connection.vala"
		height = _tmp15_;
#line 236 "../src/Connection.vala"
		_tmp24_ = self->priv->_title;
#line 236 "../src/Connection.vala"
		_tmp25_ = self->priv->_dragx;
#line 236 "../src/Connection.vala"
		_tmp26_ = width;
#line 236 "../src/Connection.vala"
		canvas_text_set_posx (_tmp24_, _tmp25_ - (_tmp26_ / 2));
#line 237 "../src/Connection.vala"
		_tmp27_ = self->priv->_title;
#line 237 "../src/Connection.vala"
		_tmp28_ = self->priv->_dragy;
#line 237 "../src/Connection.vala"
		_tmp29_ = height;
#line 237 "../src/Connection.vala"
		canvas_text_set_posy (_tmp27_, _tmp28_ - (_tmp29_ / 2));
#line 1573 "Connection.c"
	}
}


static void
_connection_end_moved_node_moved (Node* _sender,
                                  gdouble diffx,
                                  gdouble diffy,
                                  gpointer self)
{
#line 243 "../src/Connection.vala"
	connection_end_moved ((Connection*) self, _sender, diffx, diffy);
#line 1586 "Connection.c"
}


static void
_connection_end_resized_node_resized (Node* _sender,
                                      gdouble diffw,
                                      gdouble diffh,
                                      gpointer self)
{
#line 244 "../src/Connection.vala"
	connection_end_resized ((Connection*) self, _sender, diffw, diffh);
#line 1598 "Connection.c"
}


void
connection_connect_node (Connection* self,
                         Node* node)
{
#line 242 "../src/Connection.vala"
	g_return_if_fail (self != NULL);
#line 242 "../src/Connection.vala"
	g_return_if_fail (node != NULL);
#line 243 "../src/Connection.vala"
	g_signal_connect_object (node, "moved", (GCallback) _connection_end_moved_node_moved, self, 0);
#line 244 "../src/Connection.vala"
	g_signal_connect_object (node, "resized", (GCallback) _connection_end_resized_node_resized, self, 0);
#line 1614 "Connection.c"
}


void
connection_disconnect_node (Connection* self,
                            Node* node)
{
	guint _tmp0_;
	guint _tmp1_;
	Connection* _tmp2_;
	Connection* _tmp3_;
#line 248 "../src/Connection.vala"
	g_return_if_fail (self != NULL);
#line 248 "../src/Connection.vala"
	g_return_if_fail (node != NULL);
#line 249 "../src/Connection.vala"
	g_signal_parse_name ("moved", TYPE_NODE, &_tmp0_, NULL, FALSE);
#line 249 "../src/Connection.vala"
	g_signal_handlers_disconnect_matched (node, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp0_, 0, NULL, (GCallback) _connection_end_moved_node_moved, self);
#line 250 "../src/Connection.vala"
	g_signal_parse_name ("resized", TYPE_NODE, &_tmp1_, NULL, FALSE);
#line 250 "../src/Connection.vala"
	g_signal_handlers_disconnect_matched (node, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _connection_end_resized_node_resized, self);
#line 251 "../src/Connection.vala"
	_tmp2_ = node_get_last_selected_connection (node);
#line 251 "../src/Connection.vala"
	_tmp3_ = _tmp2_;
#line 251 "../src/Connection.vala"
	if (_tmp3_ == self) {
#line 252 "../src/Connection.vala"
		node_set_last_selected_connection (node, NULL);
#line 1646 "Connection.c"
	}
}


void
connection_connect_to (Connection* self,
                       Node* node)
{
	gdouble fx = 0.0;
	gdouble fy = 0.0;
	gdouble tx = 0.0;
	gdouble ty = 0.0;
	gdouble x = 0.0;
	gdouble y = 0.0;
	gdouble w = 0.0;
	gdouble h = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	Node* _tmp4_;
	gint _tmp7_ = 0;
	Node* _tmp8_;
	Bezier* _tmp9_;
	gdouble _tmp10_;
	gdouble _tmp11_;
	gdouble _tmp12_;
	gdouble _tmp13_;
	Bezier* _tmp14_;
	gdouble _tmp15_ = 0.0;
	gdouble _tmp16_ = 0.0;
	Bezier* _tmp17_;
	gdouble _tmp18_ = 0.0;
	gdouble _tmp19_ = 0.0;
	Bezier* _tmp20_;
	gdouble _tmp21_;
	gdouble _tmp22_;
#line 257 "../src/Connection.vala"
	g_return_if_fail (self != NULL);
#line 257 "../src/Connection.vala"
	g_return_if_fail (node != NULL);
#line 260 "../src/Connection.vala"
	node_bbox (node, &_tmp0_, &_tmp1_, &_tmp2_, &_tmp3_);
#line 260 "../src/Connection.vala"
	x = _tmp0_;
#line 260 "../src/Connection.vala"
	y = _tmp1_;
#line 260 "../src/Connection.vala"
	w = _tmp2_;
#line 260 "../src/Connection.vala"
	h = _tmp3_;
#line 261 "../src/Connection.vala"
	_tmp4_ = self->priv->_from_node;
#line 261 "../src/Connection.vala"
	if (_tmp4_ == NULL) {
#line 1702 "Connection.c"
		Node* _tmp5_;
#line 262 "../src/Connection.vala"
		_tmp5_ = _g_object_ref0 (node);
#line 262 "../src/Connection.vala"
		_g_object_unref0 (self->priv->_from_node);
#line 262 "../src/Connection.vala"
		self->priv->_from_node = _tmp5_;
#line 1710 "Connection.c"
	} else {
		Node* _tmp6_;
#line 264 "../src/Connection.vala"
		_tmp6_ = _g_object_ref0 (node);
#line 264 "../src/Connection.vala"
		_g_object_unref0 (self->priv->_to_node);
#line 264 "../src/Connection.vala"
		self->priv->_to_node = _tmp6_;
#line 1719 "Connection.c"
	}
#line 266 "../src/Connection.vala"
	connection_connect_node (self, node);
#line 267 "../src/Connection.vala"
	_tmp8_ = self->priv->_from_node;
#line 267 "../src/Connection.vala"
	if (_tmp8_ == node) {
#line 267 "../src/Connection.vala"
		_tmp7_ = 0;
#line 1729 "Connection.c"
	} else {
#line 267 "../src/Connection.vala"
		_tmp7_ = 2;
#line 1733 "Connection.c"
	}
#line 267 "../src/Connection.vala"
	_tmp9_ = self->priv->_curve;
#line 267 "../src/Connection.vala"
	_tmp10_ = x;
#line 267 "../src/Connection.vala"
	_tmp11_ = w;
#line 267 "../src/Connection.vala"
	_tmp12_ = y;
#line 267 "../src/Connection.vala"
	_tmp13_ = h;
#line 267 "../src/Connection.vala"
	bezier_set_point (_tmp9_, _tmp7_, _tmp10_ + (_tmp11_ / 2), _tmp12_ + (_tmp13_ / 2));
#line 268 "../src/Connection.vala"
	_tmp14_ = self->priv->_curve;
#line 268 "../src/Connection.vala"
	bezier_get_point (_tmp14_, 0, &_tmp15_, &_tmp16_);
#line 268 "../src/Connection.vala"
	fx = _tmp15_;
#line 268 "../src/Connection.vala"
	fy = _tmp16_;
#line 269 "../src/Connection.vala"
	_tmp17_ = self->priv->_curve;
#line 269 "../src/Connection.vala"
	bezier_get_point (_tmp17_, 2, &_tmp18_, &_tmp19_);
#line 269 "../src/Connection.vala"
	tx = _tmp18_;
#line 269 "../src/Connection.vala"
	ty = _tmp19_;
#line 270 "../src/Connection.vala"
	self->priv->_dragx = (fx + tx) / 2;
#line 271 "../src/Connection.vala"
	self->priv->_dragy = (fy + ty) / 2;
#line 272 "../src/Connection.vala"
	connection_position_title (self);
#line 273 "../src/Connection.vala"
	_tmp20_ = self->priv->_curve;
#line 273 "../src/Connection.vala"
	_tmp21_ = self->priv->_dragx;
#line 273 "../src/Connection.vala"
	_tmp22_ = self->priv->_dragy;
#line 273 "../src/Connection.vala"
	bezier_update_control_from_drag_handle (_tmp20_, _tmp21_, _tmp22_);
#line 274 "../src/Connection.vala"
	connection_set_connect_point (self, node);
#line 1779 "Connection.c"
}


void
connection_disconnect_from_node (Connection* self,
                                 gboolean from)
{
#line 278 "../src/Connection.vala"
	g_return_if_fail (self != NULL);
#line 279 "../src/Connection.vala"
	if (from) {
#line 1791 "Connection.c"
		Bezier* _tmp0_;
		gdouble _tmp1_ = 0.0;
		gdouble _tmp2_ = 0.0;
		Node* _tmp3_;
#line 280 "../src/Connection.vala"
		_tmp0_ = self->priv->_curve;
#line 280 "../src/Connection.vala"
		bezier_get_from_point (_tmp0_, &_tmp1_, &_tmp2_);
#line 280 "../src/Connection.vala"
		self->priv->_posx = _tmp1_;
#line 280 "../src/Connection.vala"
		self->priv->_posy = _tmp2_;
#line 281 "../src/Connection.vala"
		_tmp3_ = self->priv->_from_node;
#line 281 "../src/Connection.vala"
		connection_disconnect_node (self, _tmp3_);
#line 282 "../src/Connection.vala"
		_g_object_unref0 (self->priv->_from_node);
#line 282 "../src/Connection.vala"
		self->priv->_from_node = NULL;
#line 1812 "Connection.c"
	} else {
		Bezier* _tmp4_;
		gdouble _tmp5_ = 0.0;
		gdouble _tmp6_ = 0.0;
		Node* _tmp7_;
#line 284 "../src/Connection.vala"
		_tmp4_ = self->priv->_curve;
#line 284 "../src/Connection.vala"
		bezier_get_to_point (_tmp4_, &_tmp5_, &_tmp6_);
#line 284 "../src/Connection.vala"
		self->priv->_posx = _tmp5_;
#line 284 "../src/Connection.vala"
		self->priv->_posy = _tmp6_;
#line 285 "../src/Connection.vala"
		_tmp7_ = self->priv->_to_node;
#line 285 "../src/Connection.vala"
		connection_disconnect_node (self, _tmp7_);
#line 286 "../src/Connection.vala"
		_g_object_unref0 (self->priv->_to_node);
#line 286 "../src/Connection.vala"
		self->priv->_to_node = NULL;
#line 1834 "Connection.c"
	}
#line 288 "../src/Connection.vala"
	connection_set_mode (self, CONN_MODE_CONNECTING);
#line 1838 "Connection.c"
}


void
connection_draw_to (Connection* self,
                    gdouble x,
                    gdouble y)
{
	gdouble nx = 0.0;
	gdouble ny = 0.0;
	Node* _tmp0_ = NULL;
	Node* _tmp1_;
	Node* node = NULL;
	Node* _tmp4_;
	gint _tmp5_ = 0;
	Node* _tmp6_;
	Node* _tmp7_;
	Bezier* _tmp8_;
	gdouble _tmp9_ = 0.0;
	gdouble _tmp10_ = 0.0;
	Bezier* _tmp11_;
	gdouble _tmp12_;
	gdouble _tmp13_;
	Node* _tmp14_;
#line 292 "../src/Connection.vala"
	g_return_if_fail (self != NULL);
#line 294 "../src/Connection.vala"
	_tmp1_ = self->priv->_from_node;
#line 294 "../src/Connection.vala"
	if (_tmp1_ != NULL) {
#line 1869 "Connection.c"
		Node* _tmp2_;
#line 294 "../src/Connection.vala"
		_tmp2_ = self->priv->_from_node;
#line 294 "../src/Connection.vala"
		_tmp0_ = _tmp2_;
#line 1875 "Connection.c"
	} else {
		Node* _tmp3_;
#line 294 "../src/Connection.vala"
		_tmp3_ = self->priv->_to_node;
#line 294 "../src/Connection.vala"
		_tmp0_ = _tmp3_;
#line 1882 "Connection.c"
	}
#line 294 "../src/Connection.vala"
	_tmp4_ = _g_object_ref0 (_tmp0_);
#line 294 "../src/Connection.vala"
	node = _tmp4_;
#line 295 "../src/Connection.vala"
	self->priv->_posx = x;
#line 296 "../src/Connection.vala"
	self->priv->_posy = y;
#line 297 "../src/Connection.vala"
	_tmp6_ = node;
#line 297 "../src/Connection.vala"
	_tmp7_ = self->priv->_from_node;
#line 297 "../src/Connection.vala"
	if (_tmp6_ == _tmp7_) {
#line 297 "../src/Connection.vala"
		_tmp5_ = 0;
#line 1900 "Connection.c"
	} else {
#line 297 "../src/Connection.vala"
		_tmp5_ = 2;
#line 1904 "Connection.c"
	}
#line 297 "../src/Connection.vala"
	_tmp8_ = self->priv->_curve;
#line 297 "../src/Connection.vala"
	bezier_get_point (_tmp8_, _tmp5_, &_tmp9_, &_tmp10_);
#line 297 "../src/Connection.vala"
	nx = _tmp9_;
#line 297 "../src/Connection.vala"
	ny = _tmp10_;
#line 298 "../src/Connection.vala"
	self->priv->_dragx = (nx + x) / 2;
#line 299 "../src/Connection.vala"
	self->priv->_dragy = (ny + y) / 2;
#line 300 "../src/Connection.vala"
	connection_position_title (self);
#line 301 "../src/Connection.vala"
	_tmp11_ = self->priv->_curve;
#line 301 "../src/Connection.vala"
	_tmp12_ = self->priv->_dragx;
#line 301 "../src/Connection.vala"
	_tmp13_ = self->priv->_dragy;
#line 301 "../src/Connection.vala"
	bezier_update_control_from_drag_handle (_tmp11_, _tmp12_, _tmp13_);
#line 302 "../src/Connection.vala"
	_tmp14_ = node;
#line 302 "../src/Connection.vala"
	connection_set_connect_point (self, _tmp14_);
#line 292 "../src/Connection.vala"
	_g_object_unref0 (node);
#line 1934 "Connection.c"
}


static void
connection_end_moved (Connection* self,
                      Node* node,
                      gdouble diffx,
                      gdouble diffy)
{
	gdouble x = 0.0;
	gdouble y = 0.0;
	gdouble w = 0.0;
	gdouble h = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gint _tmp4_ = 0;
	Node* _tmp5_;
	Bezier* _tmp6_;
	gdouble _tmp7_;
	gdouble _tmp8_;
	gdouble _tmp9_;
	gdouble _tmp10_;
	gdouble _tmp11_;
	gdouble _tmp12_;
	Bezier* _tmp13_;
	gdouble _tmp14_;
	gdouble _tmp15_;
	Node* _tmp16_;
	Node* _tmp17_;
#line 306 "../src/Connection.vala"
	g_return_if_fail (self != NULL);
#line 306 "../src/Connection.vala"
	g_return_if_fail (node != NULL);
#line 308 "../src/Connection.vala"
	node_bbox (node, &_tmp0_, &_tmp1_, &_tmp2_, &_tmp3_);
#line 308 "../src/Connection.vala"
	x = _tmp0_;
#line 308 "../src/Connection.vala"
	y = _tmp1_;
#line 308 "../src/Connection.vala"
	w = _tmp2_;
#line 308 "../src/Connection.vala"
	h = _tmp3_;
#line 309 "../src/Connection.vala"
	_tmp5_ = self->priv->_from_node;
#line 309 "../src/Connection.vala"
	if (_tmp5_ == node) {
#line 309 "../src/Connection.vala"
		_tmp4_ = 0;
#line 1986 "Connection.c"
	} else {
#line 309 "../src/Connection.vala"
		_tmp4_ = 2;
#line 1990 "Connection.c"
	}
#line 309 "../src/Connection.vala"
	_tmp6_ = self->priv->_curve;
#line 309 "../src/Connection.vala"
	_tmp7_ = x;
#line 309 "../src/Connection.vala"
	_tmp8_ = w;
#line 309 "../src/Connection.vala"
	_tmp9_ = y;
#line 309 "../src/Connection.vala"
	_tmp10_ = h;
#line 309 "../src/Connection.vala"
	bezier_set_point (_tmp6_, _tmp4_, _tmp7_ + (_tmp8_ / 2), _tmp9_ + (_tmp10_ / 2));
#line 310 "../src/Connection.vala"
	_tmp11_ = self->priv->_dragx;
#line 310 "../src/Connection.vala"
	self->priv->_dragx = _tmp11_ + (diffx / 2);
#line 311 "../src/Connection.vala"
	_tmp12_ = self->priv->_dragy;
#line 311 "../src/Connection.vala"
	self->priv->_dragy = _tmp12_ + (diffy / 2);
#line 312 "../src/Connection.vala"
	connection_position_title (self);
#line 313 "../src/Connection.vala"
	_tmp13_ = self->priv->_curve;
#line 313 "../src/Connection.vala"
	_tmp14_ = self->priv->_dragx;
#line 313 "../src/Connection.vala"
	_tmp15_ = self->priv->_dragy;
#line 313 "../src/Connection.vala"
	bezier_update_control_from_drag_handle (_tmp13_, _tmp14_, _tmp15_);
#line 314 "../src/Connection.vala"
	_tmp16_ = self->priv->_from_node;
#line 314 "../src/Connection.vala"
	connection_set_connect_point (self, _tmp16_);
#line 315 "../src/Connection.vala"
	_tmp17_ = self->priv->_to_node;
#line 315 "../src/Connection.vala"
	if (_tmp17_ != NULL) {
#line 2030 "Connection.c"
		Node* _tmp18_;
#line 316 "../src/Connection.vala"
		_tmp18_ = self->priv->_to_node;
#line 316 "../src/Connection.vala"
		connection_set_connect_point (self, _tmp18_);
#line 2036 "Connection.c"
	}
}


static void
connection_end_resized (Connection* self,
                        Node* node,
                        gdouble diffw,
                        gdouble diffh)
{
	gdouble x = 0.0;
	gdouble y = 0.0;
	gdouble w = 0.0;
	gdouble h = 0.0;
	gdouble _tmp0_ = 0.0;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	gdouble _tmp3_ = 0.0;
	gint _tmp4_ = 0;
	Node* _tmp5_;
	Bezier* _tmp6_;
	gdouble _tmp7_;
	gdouble _tmp8_;
	gdouble _tmp9_;
	gdouble _tmp10_;
	gdouble _tmp11_;
	gdouble _tmp12_;
	Bezier* _tmp13_;
	gdouble _tmp14_;
	gdouble _tmp15_;
	Node* _tmp16_;
	Node* _tmp17_;
#line 321 "../src/Connection.vala"
	g_return_if_fail (self != NULL);
#line 321 "../src/Connection.vala"
	g_return_if_fail (node != NULL);
#line 323 "../src/Connection.vala"
	node_bbox (node, &_tmp0_, &_tmp1_, &_tmp2_, &_tmp3_);
#line 323 "../src/Connection.vala"
	x = _tmp0_;
#line 323 "../src/Connection.vala"
	y = _tmp1_;
#line 323 "../src/Connection.vala"
	w = _tmp2_;
#line 323 "../src/Connection.vala"
	h = _tmp3_;
#line 324 "../src/Connection.vala"
	_tmp5_ = self->priv->_from_node;
#line 324 "../src/Connection.vala"
	if (_tmp5_ == node) {
#line 324 "../src/Connection.vala"
		_tmp4_ = 0;
#line 2089 "Connection.c"
	} else {
#line 324 "../src/Connection.vala"
		_tmp4_ = 2;
#line 2093 "Connection.c"
	}
#line 324 "../src/Connection.vala"
	_tmp6_ = self->priv->_curve;
#line 324 "../src/Connection.vala"
	_tmp7_ = x;
#line 324 "../src/Connection.vala"
	_tmp8_ = w;
#line 324 "../src/Connection.vala"
	_tmp9_ = y;
#line 324 "../src/Connection.vala"
	_tmp10_ = h;
#line 324 "../src/Connection.vala"
	bezier_set_point (_tmp6_, _tmp4_, _tmp7_ + (_tmp8_ / 2), _tmp9_ + (_tmp10_ / 2));
#line 325 "../src/Connection.vala"
	_tmp11_ = self->priv->_dragx;
#line 325 "../src/Connection.vala"
	self->priv->_dragx = _tmp11_ + (diffw / 2);
#line 326 "../src/Connection.vala"
	_tmp12_ = self->priv->_dragy;
#line 326 "../src/Connection.vala"
	self->priv->_dragy = _tmp12_ + (diffh / 2);
#line 327 "../src/Connection.vala"
	connection_position_title (self);
#line 328 "../src/Connection.vala"
	_tmp13_ = self->priv->_curve;
#line 328 "../src/Connection.vala"
	_tmp14_ = self->priv->_dragx;
#line 328 "../src/Connection.vala"
	_tmp15_ = self->priv->_dragy;
#line 328 "../src/Connection.vala"
	bezier_update_control_from_drag_handle (_tmp13_, _tmp14_, _tmp15_);
#line 329 "../src/Connection.vala"
	_tmp16_ = self->priv->_from_node;
#line 329 "../src/Connection.vala"
	connection_set_connect_point (self, _tmp16_);
#line 330 "../src/Connection.vala"
	_tmp17_ = self->priv->_to_node;
#line 330 "../src/Connection.vala"
	connection_set_connect_point (self, _tmp17_);
#line 2133 "Connection.c"
}


gboolean
connection_attached_to_node (Connection* self,
                             Node* node)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	Node* _tmp1_;
#line 334 "../src/Connection.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 334 "../src/Connection.vala"
	g_return_val_if_fail (node != NULL, FALSE);
#line 335 "../src/Connection.vala"
	_tmp1_ = self->priv->_from_node;
#line 335 "../src/Connection.vala"
	if (_tmp1_ == node) {
#line 335 "../src/Connection.vala"
		_tmp0_ = TRUE;
#line 2154 "Connection.c"
	} else {
		Node* _tmp2_;
#line 335 "../src/Connection.vala"
		_tmp2_ = self->priv->_to_node;
#line 335 "../src/Connection.vala"
		_tmp0_ = _tmp2_ == node;
#line 2161 "Connection.c"
	}
#line 335 "../src/Connection.vala"
	result = _tmp0_;
#line 335 "../src/Connection.vala"
	return result;
#line 2167 "Connection.c"
}


static void
connection_set_connect_point (Connection* self,
                              Node* node)
{
	gdouble x = 0.0;
	gdouble y = 0.0;
	gdouble w = 0.0;
	gdouble h = 0.0;
	gdouble bw = 0.0;
	Style* _tmp0_;
	Style* _tmp1_;
	gint* _tmp2_;
	gint* _tmp3_;
	gdouble extra = 0.0;
	Style* _tmp4_;
	Style* _tmp5_;
	gint* _tmp6_;
	gint* _tmp7_;
	gdouble margin = 0.0;
	Style* _tmp8_;
	Style* _tmp9_;
	gint* _tmp10_;
	gint* _tmp11_;
	gdouble _tmp12_ = 0.0;
	gdouble _tmp13_ = 0.0;
	gdouble _tmp14_ = 0.0;
	gdouble _tmp15_ = 0.0;
	gdouble _tmp16_;
	gdouble _tmp17_;
	gdouble _tmp18_;
	gdouble _tmp19_;
	Bezier* _tmp20_;
	Node* _tmp21_;
	gdouble _tmp22_;
	gdouble _tmp23_;
	gdouble _tmp24_;
	gdouble _tmp25_;
	gdouble _tmp26_;
	gdouble _tmp27_;
#line 339 "../src/Connection.vala"
	g_return_if_fail (self != NULL);
#line 339 "../src/Connection.vala"
	g_return_if_fail (node != NULL);
#line 342 "../src/Connection.vala"
	_tmp0_ = node_get_style (node);
#line 342 "../src/Connection.vala"
	_tmp1_ = _tmp0_;
#line 342 "../src/Connection.vala"
	_tmp2_ = style_get_node_borderwidth (_tmp1_);
#line 342 "../src/Connection.vala"
	_tmp3_ = _tmp2_;
#line 342 "../src/Connection.vala"
	bw = *_tmp3_;
#line 343 "../src/Connection.vala"
	_tmp4_ = connection_get_style (self);
#line 343 "../src/Connection.vala"
	_tmp5_ = _tmp4_;
#line 343 "../src/Connection.vala"
	_tmp6_ = style_get_connection_width (_tmp5_);
#line 343 "../src/Connection.vala"
	_tmp7_ = _tmp6_;
#line 343 "../src/Connection.vala"
	extra = bw + ((*_tmp7_) / 2);
#line 344 "../src/Connection.vala"
	_tmp8_ = node_get_style (node);
#line 344 "../src/Connection.vala"
	_tmp9_ = _tmp8_;
#line 344 "../src/Connection.vala"
	_tmp10_ = style_get_node_margin (_tmp9_);
#line 344 "../src/Connection.vala"
	_tmp11_ = _tmp10_;
#line 344 "../src/Connection.vala"
	margin = *_tmp11_;
#line 346 "../src/Connection.vala"
	node_bbox (node, &_tmp12_, &_tmp13_, &_tmp14_, &_tmp15_);
#line 346 "../src/Connection.vala"
	x = _tmp12_;
#line 346 "../src/Connection.vala"
	y = _tmp13_;
#line 346 "../src/Connection.vala"
	w = _tmp14_;
#line 346 "../src/Connection.vala"
	h = _tmp15_;
#line 349 "../src/Connection.vala"
	_tmp16_ = x;
#line 349 "../src/Connection.vala"
	x = _tmp16_ + margin;
#line 350 "../src/Connection.vala"
	_tmp17_ = y;
#line 350 "../src/Connection.vala"
	y = _tmp17_ + margin;
#line 351 "../src/Connection.vala"
	_tmp18_ = w;
#line 351 "../src/Connection.vala"
	w = _tmp18_ - (margin * 2);
#line 352 "../src/Connection.vala"
	_tmp19_ = h;
#line 352 "../src/Connection.vala"
	h = _tmp19_ - (margin * 2);
#line 354 "../src/Connection.vala"
	_tmp20_ = self->priv->_curve;
#line 354 "../src/Connection.vala"
	_tmp21_ = self->priv->_from_node;
#line 354 "../src/Connection.vala"
	_tmp22_ = y;
#line 354 "../src/Connection.vala"
	_tmp23_ = y;
#line 354 "../src/Connection.vala"
	_tmp24_ = h;
#line 354 "../src/Connection.vala"
	_tmp25_ = x;
#line 354 "../src/Connection.vala"
	_tmp26_ = x;
#line 354 "../src/Connection.vala"
	_tmp27_ = w;
#line 354 "../src/Connection.vala"
	bezier_set_connect_point (_tmp20_, node == _tmp21_, _tmp22_ - extra, (_tmp23_ + _tmp24_) + extra, _tmp25_ - extra, (_tmp26_ + _tmp27_) + extra);
#line 2288 "Connection.c"
}


gboolean
connection_on_curve (Connection* self,
                     gdouble x,
                     gdouble y)
{
	gboolean result = FALSE;
	gdouble fx = 0.0;
	gdouble fy = 0.0;
	gdouble tx = 0.0;
	gdouble ty = 0.0;
	Bezier* _tmp0_;
	gdouble _tmp1_ = 0.0;
	gdouble _tmp2_ = 0.0;
	Bezier* _tmp3_;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	Bezier* curve = NULL;
	Bezier* _tmp6_;
	gdouble _tmp7_;
	gdouble _tmp8_;
#line 359 "../src/Connection.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 361 "../src/Connection.vala"
	_tmp0_ = self->priv->_curve;
#line 361 "../src/Connection.vala"
	bezier_get_from_point (_tmp0_, &_tmp1_, &_tmp2_);
#line 361 "../src/Connection.vala"
	fx = _tmp1_;
#line 361 "../src/Connection.vala"
	fy = _tmp2_;
#line 362 "../src/Connection.vala"
	_tmp3_ = self->priv->_curve;
#line 362 "../src/Connection.vala"
	bezier_get_to_point (_tmp3_, &_tmp4_, &_tmp5_);
#line 362 "../src/Connection.vala"
	tx = _tmp4_;
#line 362 "../src/Connection.vala"
	ty = _tmp5_;
#line 363 "../src/Connection.vala"
	_tmp6_ = bezier_new_with_endpoints (fx, fy, tx, ty);
#line 363 "../src/Connection.vala"
	curve = _tmp6_;
#line 364 "../src/Connection.vala"
	_tmp7_ = self->priv->_dragx;
#line 364 "../src/Connection.vala"
	_tmp8_ = self->priv->_dragy;
#line 364 "../src/Connection.vala"
	bezier_update_control_from_drag_handle (curve, _tmp7_, _tmp8_);
#line 365 "../src/Connection.vala"
	result = bezier_within_range (curve, x, y);
#line 365 "../src/Connection.vala"
	_bezier_unref0 (curve);
#line 365 "../src/Connection.vala"
	return result;
#line 2346 "Connection.c"
}


static gboolean
connection_within_handle (Connection* self,
                          gdouble hx,
                          gdouble hy,
                          gdouble x,
                          gdouble y)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gint _tmp3_;
#line 369 "../src/Connection.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 370 "../src/Connection.vala"
	_tmp3_ = self->priv->RADIUS;
#line 370 "../src/Connection.vala"
	if ((hx - _tmp3_) <= x) {
#line 2368 "Connection.c"
		gint _tmp4_;
#line 370 "../src/Connection.vala"
		_tmp4_ = self->priv->RADIUS;
#line 370 "../src/Connection.vala"
		_tmp2_ = x <= (hx + _tmp4_);
#line 2374 "Connection.c"
	} else {
#line 370 "../src/Connection.vala"
		_tmp2_ = FALSE;
#line 2378 "Connection.c"
	}
#line 370 "../src/Connection.vala"
	if (_tmp2_) {
#line 2382 "Connection.c"
		gint _tmp5_;
#line 370 "../src/Connection.vala"
		_tmp5_ = self->priv->RADIUS;
#line 370 "../src/Connection.vala"
		_tmp1_ = (hy - _tmp5_) <= y;
#line 2388 "Connection.c"
	} else {
#line 370 "../src/Connection.vala"
		_tmp1_ = FALSE;
#line 2392 "Connection.c"
	}
#line 370 "../src/Connection.vala"
	if (_tmp1_) {
#line 2396 "Connection.c"
		gint _tmp6_;
#line 370 "../src/Connection.vala"
		_tmp6_ = self->priv->RADIUS;
#line 370 "../src/Connection.vala"
		_tmp0_ = y <= (hy + _tmp6_);
#line 2402 "Connection.c"
	} else {
#line 370 "../src/Connection.vala"
		_tmp0_ = FALSE;
#line 2406 "Connection.c"
	}
#line 370 "../src/Connection.vala"
	result = _tmp0_;
#line 370 "../src/Connection.vala"
	return result;
#line 2412 "Connection.c"
}


gboolean
connection_within_drag_handle (Connection* self,
                               gdouble x,
                               gdouble y)
{
	gboolean result = FALSE;
	ConnMode _tmp0_;
	ConnMode _tmp1_;
#line 374 "../src/Connection.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 375 "../src/Connection.vala"
	_tmp0_ = connection_get_mode (self);
#line 375 "../src/Connection.vala"
	_tmp1_ = _tmp0_;
#line 375 "../src/Connection.vala"
	if (_tmp1_ == CONN_MODE_SELECTED) {
#line 2432 "Connection.c"
		gboolean _tmp2_ = FALSE;
		CanvasText* _tmp3_;
		CanvasText* _tmp4_;
#line 376 "../src/Connection.vala"
		_tmp3_ = connection_get_title (self);
#line 376 "../src/Connection.vala"
		_tmp4_ = _tmp3_;
#line 376 "../src/Connection.vala"
		if (_tmp4_ == NULL) {
#line 2442 "Connection.c"
			const gchar* _tmp5_;
			const gchar* _tmp6_;
			gint _tmp7_;
			gint _tmp8_;
#line 376 "../src/Connection.vala"
			_tmp5_ = connection_get_note (self);
#line 376 "../src/Connection.vala"
			_tmp6_ = _tmp5_;
#line 376 "../src/Connection.vala"
			_tmp7_ = strlen (_tmp6_);
#line 376 "../src/Connection.vala"
			_tmp8_ = _tmp7_;
#line 376 "../src/Connection.vala"
			_tmp2_ = _tmp8_ == 0;
#line 2457 "Connection.c"
		} else {
#line 376 "../src/Connection.vala"
			_tmp2_ = FALSE;
#line 2461 "Connection.c"
		}
#line 376 "../src/Connection.vala"
		if (_tmp2_) {
#line 2465 "Connection.c"
			gdouble _tmp9_;
			gdouble _tmp10_;
#line 377 "../src/Connection.vala"
			_tmp9_ = self->priv->_dragx;
#line 377 "../src/Connection.vala"
			_tmp10_ = self->priv->_dragy;
#line 377 "../src/Connection.vala"
			result = connection_within_handle (self, _tmp9_, _tmp10_, x, y);
#line 377 "../src/Connection.vala"
			return result;
#line 2476 "Connection.c"
		} else {
			gdouble tx = 0.0;
			gdouble ty = 0.0;
			gdouble tw = 0.0;
			gdouble th = 0.0;
			gdouble _tmp11_ = 0.0;
			gdouble _tmp12_ = 0.0;
			gdouble _tmp13_ = 0.0;
			gdouble _tmp14_ = 0.0;
			gdouble _tmp15_;
			gdouble _tmp16_;
			gdouble _tmp17_;
			Style* _tmp18_;
			gint* _tmp19_;
			gint* _tmp20_;
#line 380 "../src/Connection.vala"
			connection_title_bbox (self, &_tmp11_, &_tmp12_, &_tmp13_, &_tmp14_);
#line 380 "../src/Connection.vala"
			tx = _tmp11_;
#line 380 "../src/Connection.vala"
			ty = _tmp12_;
#line 380 "../src/Connection.vala"
			tw = _tmp13_;
#line 380 "../src/Connection.vala"
			th = _tmp14_;
#line 381 "../src/Connection.vala"
			_tmp15_ = self->priv->_dragx;
#line 381 "../src/Connection.vala"
			_tmp16_ = self->priv->_dragy;
#line 381 "../src/Connection.vala"
			_tmp17_ = th;
#line 381 "../src/Connection.vala"
			_tmp18_ = self->priv->_style;
#line 381 "../src/Connection.vala"
			_tmp19_ = style_get_connection_padding (_tmp18_);
#line 381 "../src/Connection.vala"
			_tmp20_ = _tmp19_;
#line 381 "../src/Connection.vala"
			result = connection_within_handle (self, _tmp15_, (_tmp16_ + (_tmp17_ / 2)) + (*_tmp20_), x, y);
#line 381 "../src/Connection.vala"
			return result;
#line 2518 "Connection.c"
		}
	}
#line 384 "../src/Connection.vala"
	result = FALSE;
#line 384 "../src/Connection.vala"
	return result;
#line 2525 "Connection.c"
}


gboolean
connection_within_from_handle (Connection* self,
                               gdouble x,
                               gdouble y)
{
	gboolean result = FALSE;
#line 388 "../src/Connection.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 389 "../src/Connection.vala"
	result = connection_within_endpoint_handle (self, TRUE, x, y);
#line 389 "../src/Connection.vala"
	return result;
#line 2541 "Connection.c"
}


gboolean
connection_within_to_handle (Connection* self,
                             gdouble x,
                             gdouble y)
{
	gboolean result = FALSE;
#line 393 "../src/Connection.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 394 "../src/Connection.vala"
	result = connection_within_endpoint_handle (self, FALSE, x, y);
#line 394 "../src/Connection.vala"
	return result;
#line 2557 "Connection.c"
}


static gboolean
connection_within_endpoint_handle (Connection* self,
                                   gboolean from,
                                   gdouble x,
                                   gdouble y)
{
	gboolean result = FALSE;
	ConnMode _tmp0_;
	ConnMode _tmp1_;
#line 398 "../src/Connection.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 399 "../src/Connection.vala"
	_tmp0_ = connection_get_mode (self);
#line 399 "../src/Connection.vala"
	_tmp1_ = _tmp0_;
#line 399 "../src/Connection.vala"
	if (_tmp1_ == CONN_MODE_SELECTED) {
#line 2578 "Connection.c"
		gdouble px = 0.0;
		gdouble py = 0.0;
		gdouble _tmp8_;
		gdouble _tmp9_;
#line 401 "../src/Connection.vala"
		if (from) {
#line 2585 "Connection.c"
			Bezier* _tmp2_;
			gdouble _tmp3_ = 0.0;
			gdouble _tmp4_ = 0.0;
#line 402 "../src/Connection.vala"
			_tmp2_ = self->priv->_curve;
#line 402 "../src/Connection.vala"
			bezier_get_from_point (_tmp2_, &_tmp3_, &_tmp4_);
#line 402 "../src/Connection.vala"
			px = _tmp3_;
#line 402 "../src/Connection.vala"
			py = _tmp4_;
#line 2597 "Connection.c"
		} else {
			Bezier* _tmp5_;
			gdouble _tmp6_ = 0.0;
			gdouble _tmp7_ = 0.0;
#line 404 "../src/Connection.vala"
			_tmp5_ = self->priv->_curve;
#line 404 "../src/Connection.vala"
			bezier_get_to_point (_tmp5_, &_tmp6_, &_tmp7_);
#line 404 "../src/Connection.vala"
			px = _tmp6_;
#line 404 "../src/Connection.vala"
			py = _tmp7_;
#line 2610 "Connection.c"
		}
#line 406 "../src/Connection.vala"
		_tmp8_ = px;
#line 406 "../src/Connection.vala"
		_tmp9_ = py;
#line 406 "../src/Connection.vala"
		result = connection_within_handle (self, _tmp8_, _tmp9_, x, y);
#line 406 "../src/Connection.vala"
		return result;
#line 2620 "Connection.c"
	}
#line 408 "../src/Connection.vala"
	result = FALSE;
#line 408 "../src/Connection.vala"
	return result;
#line 2626 "Connection.c"
}


gboolean
connection_within_title (Connection* self,
                         gdouble x,
                         gdouble y)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	CanvasText* _tmp1_;
#line 412 "../src/Connection.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 413 "../src/Connection.vala"
	_tmp1_ = self->priv->_title;
#line 413 "../src/Connection.vala"
	if (_tmp1_ != NULL) {
#line 2644 "Connection.c"
		CanvasText* _tmp2_;
#line 413 "../src/Connection.vala"
		_tmp2_ = self->priv->_title;
#line 413 "../src/Connection.vala"
		_tmp0_ = canvas_text_is_within (_tmp2_, x, y);
#line 2650 "Connection.c"
	} else {
#line 413 "../src/Connection.vala"
		_tmp0_ = FALSE;
#line 2654 "Connection.c"
	}
#line 413 "../src/Connection.vala"
	result = _tmp0_;
#line 413 "../src/Connection.vala"
	return result;
#line 2660 "Connection.c"
}


gboolean
connection_within_note (Connection* self,
                        gdouble x,
                        gdouble y)
{
	gboolean result = FALSE;
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	gdouble nx = 0.0;
	gdouble ny = 0.0;
	gdouble nw = 0.0;
	gdouble nh = 0.0;
	gdouble _tmp4_ = 0.0;
	gdouble _tmp5_ = 0.0;
	gdouble _tmp6_ = 0.0;
	gdouble _tmp7_ = 0.0;
	gdouble _tmp8_;
	gdouble _tmp9_;
	gdouble _tmp10_;
	gdouble _tmp11_;
#line 417 "../src/Connection.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 418 "../src/Connection.vala"
	_tmp0_ = connection_get_note (self);
#line 418 "../src/Connection.vala"
	_tmp1_ = _tmp0_;
#line 418 "../src/Connection.vala"
	_tmp2_ = strlen (_tmp1_);
#line 418 "../src/Connection.vala"
	_tmp3_ = _tmp2_;
#line 418 "../src/Connection.vala"
	if (_tmp3_ == 0) {
#line 418 "../src/Connection.vala"
		result = FALSE;
#line 418 "../src/Connection.vala"
		return result;
#line 2702 "Connection.c"
	}
#line 420 "../src/Connection.vala"
	connection_note_bbox (self, &_tmp4_, &_tmp5_, &_tmp6_, &_tmp7_);
#line 420 "../src/Connection.vala"
	nx = _tmp4_;
#line 420 "../src/Connection.vala"
	ny = _tmp5_;
#line 420 "../src/Connection.vala"
	nw = _tmp6_;
#line 420 "../src/Connection.vala"
	nh = _tmp7_;
#line 421 "../src/Connection.vala"
	_tmp8_ = nx;
#line 421 "../src/Connection.vala"
	_tmp9_ = ny;
#line 421 "../src/Connection.vala"
	_tmp10_ = nw;
#line 421 "../src/Connection.vala"
	_tmp11_ = nh;
#line 421 "../src/Connection.vala"
	result = utils_is_within_bounds (x, y, _tmp8_, _tmp9_, _tmp10_, _tmp11_);
#line 421 "../src/Connection.vala"
	return result;
#line 2726 "Connection.c"
}


static gint*
_int_dup (gint* self)
{
	gint* dup;
#line 426 "../src/Connection.vala"
	dup = g_new0 (gint, 1);
#line 426 "../src/Connection.vala"
	memcpy (dup, self, sizeof (gint));
#line 426 "../src/Connection.vala"
	return dup;
#line 2740 "Connection.c"
}


static gpointer
__int_dup0 (gpointer self)
{
#line 426 "../src/Connection.vala"
	return self ? _int_dup (self) : NULL;
#line 2749 "Connection.c"
}


static void
connection_title_bbox (Connection* self,
                       gdouble* x,
                       gdouble* y,
                       gdouble* w,
                       gdouble* h)
{
	gdouble _vala_x = 0.0;
	gdouble _vala_y = 0.0;
	gdouble _vala_w = 0.0;
	gdouble _vala_h = 0.0;
	gint* _tmp0_ = NULL;
	Style* _tmp1_;
	Style* _tmp2_;
	gint* _tmp3_;
	gint* _tmp4_;
	gint* padding = NULL;
	gint* _tmp6_;
	CanvasText* _tmp7_;
#line 425 "../src/Connection.vala"
	g_return_if_fail (self != NULL);
#line 426 "../src/Connection.vala"
	_tmp1_ = connection_get_style (self);
#line 426 "../src/Connection.vala"
	_tmp2_ = _tmp1_;
#line 426 "../src/Connection.vala"
	_tmp3_ = style_get_connection_padding (_tmp2_);
#line 426 "../src/Connection.vala"
	_tmp4_ = _tmp3_;
#line 426 "../src/Connection.vala"
	_tmp0_ = _tmp4_;
#line 426 "../src/Connection.vala"
	if (_tmp0_ == NULL) {
#line 2786 "Connection.c"
		gint _tmp5_;
#line 426 "../src/Connection.vala"
		_tmp5_ = 0;
#line 426 "../src/Connection.vala"
		_tmp0_ = &_tmp5_;
#line 2792 "Connection.c"
	}
#line 426 "../src/Connection.vala"
	_tmp6_ = __int_dup0 (_tmp0_);
#line 426 "../src/Connection.vala"
	padding = _tmp6_;
#line 427 "../src/Connection.vala"
	_tmp7_ = self->priv->_title;
#line 427 "../src/Connection.vala"
	if (_tmp7_ != NULL) {
#line 2802 "Connection.c"
		CanvasText* _tmp8_;
		gdouble _tmp9_;
		gdouble _tmp10_;
		gint* _tmp11_;
		CanvasText* _tmp12_;
		gdouble _tmp13_;
		gdouble _tmp14_;
		gint* _tmp15_;
		gint _tmp16_ = 0;
		const gchar* _tmp17_;
		const gchar* _tmp18_;
		gint _tmp19_;
		gint _tmp20_;
		CanvasText* _tmp22_;
		gdouble _tmp23_;
		gdouble _tmp24_;
		gint* _tmp25_;
		gdouble _tmp26_ = 0.0;
		CanvasText* _tmp27_;
		gdouble _tmp28_;
		gdouble _tmp29_;
		gint* _tmp33_;
#line 428 "../src/Connection.vala"
		_tmp8_ = self->priv->_title;
#line 428 "../src/Connection.vala"
		_tmp9_ = canvas_text_get_posx (_tmp8_);
#line 428 "../src/Connection.vala"
		_tmp10_ = _tmp9_;
#line 428 "../src/Connection.vala"
		_tmp11_ = padding;
#line 428 "../src/Connection.vala"
		_vala_x = _tmp10_ - (*_tmp11_);
#line 429 "../src/Connection.vala"
		_tmp12_ = self->priv->_title;
#line 429 "../src/Connection.vala"
		_tmp13_ = canvas_text_get_posy (_tmp12_);
#line 429 "../src/Connection.vala"
		_tmp14_ = _tmp13_;
#line 429 "../src/Connection.vala"
		_tmp15_ = padding;
#line 429 "../src/Connection.vala"
		_vala_y = _tmp14_ - (*_tmp15_);
#line 430 "../src/Connection.vala"
		_tmp17_ = connection_get_note (self);
#line 430 "../src/Connection.vala"
		_tmp18_ = _tmp17_;
#line 430 "../src/Connection.vala"
		_tmp19_ = strlen (_tmp18_);
#line 430 "../src/Connection.vala"
		_tmp20_ = _tmp19_;
#line 430 "../src/Connection.vala"
		if (_tmp20_ > 0) {
#line 2855 "Connection.c"
			gint* _tmp21_;
#line 430 "../src/Connection.vala"
			_tmp21_ = padding;
#line 430 "../src/Connection.vala"
			_tmp16_ = (*_tmp21_) + 11;
#line 2861 "Connection.c"
		} else {
#line 430 "../src/Connection.vala"
			_tmp16_ = 0;
#line 2865 "Connection.c"
		}
#line 430 "../src/Connection.vala"
		_tmp22_ = self->priv->_title;
#line 430 "../src/Connection.vala"
		_tmp23_ = canvas_text_get_width (_tmp22_);
#line 430 "../src/Connection.vala"
		_tmp24_ = _tmp23_;
#line 430 "../src/Connection.vala"
		_tmp25_ = padding;
#line 430 "../src/Connection.vala"
		_vala_w = (_tmp24_ + ((*_tmp25_) * 2)) + _tmp16_;
#line 431 "../src/Connection.vala"
		_tmp27_ = self->priv->_title;
#line 431 "../src/Connection.vala"
		_tmp28_ = canvas_text_get_height (_tmp27_);
#line 431 "../src/Connection.vala"
		_tmp29_ = _tmp28_;
#line 431 "../src/Connection.vala"
		if (_tmp29_ < ((gdouble) 11)) {
#line 431 "../src/Connection.vala"
			_tmp26_ = (gdouble) 11;
#line 2887 "Connection.c"
		} else {
			CanvasText* _tmp30_;
			gdouble _tmp31_;
			gdouble _tmp32_;
#line 431 "../src/Connection.vala"
			_tmp30_ = self->priv->_title;
#line 431 "../src/Connection.vala"
			_tmp31_ = canvas_text_get_height (_tmp30_);
#line 431 "../src/Connection.vala"
			_tmp32_ = _tmp31_;
#line 431 "../src/Connection.vala"
			_tmp26_ = _tmp32_;
#line 2900 "Connection.c"
		}
#line 431 "../src/Connection.vala"
		_tmp33_ = padding;
#line 431 "../src/Connection.vala"
		_vala_h = _tmp26_ + ((*_tmp33_) * 2);
#line 2906 "Connection.c"
	} else {
		gdouble _tmp34_;
		gint* _tmp35_;
		gdouble _tmp36_;
		gint* _tmp37_;
		gint* _tmp38_;
		gint* _tmp39_;
#line 433 "../src/Connection.vala"
		_tmp34_ = self->priv->_dragx;
#line 433 "../src/Connection.vala"
		_tmp35_ = padding;
#line 433 "../src/Connection.vala"
		_vala_x = _tmp34_ - ((*_tmp35_) + 5);
#line 434 "../src/Connection.vala"
		_tmp36_ = self->priv->_dragy;
#line 434 "../src/Connection.vala"
		_tmp37_ = padding;
#line 434 "../src/Connection.vala"
		_vala_y = _tmp36_ - ((*_tmp37_) + 5);
#line 435 "../src/Connection.vala"
		_tmp38_ = padding;
#line 435 "../src/Connection.vala"
		_vala_w = (gdouble) (11 + ((*_tmp38_) * 2));
#line 436 "../src/Connection.vala"
		_tmp39_ = padding;
#line 436 "../src/Connection.vala"
		_vala_h = (gdouble) (11 + ((*_tmp39_) * 2));
#line 2934 "Connection.c"
	}
#line 425 "../src/Connection.vala"
	_g_free0 (padding);
#line 425 "../src/Connection.vala"
	if (x) {
#line 425 "../src/Connection.vala"
		*x = _vala_x;
#line 2942 "Connection.c"
	}
#line 425 "../src/Connection.vala"
	if (y) {
#line 425 "../src/Connection.vala"
		*y = _vala_y;
#line 2948 "Connection.c"
	}
#line 425 "../src/Connection.vala"
	if (w) {
#line 425 "../src/Connection.vala"
		*w = _vala_w;
#line 2954 "Connection.c"
	}
#line 425 "../src/Connection.vala"
	if (h) {
#line 425 "../src/Connection.vala"
		*h = _vala_h;
#line 2960 "Connection.c"
	}
}


static void
connection_note_bbox (Connection* self,
                      gdouble* x,
                      gdouble* y,
                      gdouble* w,
                      gdouble* h)
{
	gdouble _vala_x = 0.0;
	gdouble _vala_y = 0.0;
	gdouble _vala_w = 0.0;
	gdouble _vala_h = 0.0;
	gdouble tx = 0.0;
	gdouble ty = 0.0;
	gdouble tw = 0.0;
	gdouble th = 0.0;
	gint* _tmp0_ = NULL;
	Style* _tmp1_;
	Style* _tmp2_;
	gint* _tmp3_;
	gint* _tmp4_;
	gint* padding = NULL;
	gint* _tmp6_;
	gdouble _tmp7_ = 0.0;
	gdouble _tmp8_ = 0.0;
	gdouble _tmp9_ = 0.0;
	gdouble _tmp10_ = 0.0;
#line 441 "../src/Connection.vala"
	g_return_if_fail (self != NULL);
#line 444 "../src/Connection.vala"
	_tmp1_ = connection_get_style (self);
#line 444 "../src/Connection.vala"
	_tmp2_ = _tmp1_;
#line 444 "../src/Connection.vala"
	_tmp3_ = style_get_connection_padding (_tmp2_);
#line 444 "../src/Connection.vala"
	_tmp4_ = _tmp3_;
#line 444 "../src/Connection.vala"
	_tmp0_ = _tmp4_;
#line 444 "../src/Connection.vala"
	if (_tmp0_ == NULL) {
#line 3005 "Connection.c"
		gint _tmp5_;
#line 444 "../src/Connection.vala"
		_tmp5_ = 0;
#line 444 "../src/Connection.vala"
		_tmp0_ = &_tmp5_;
#line 3011 "Connection.c"
	}
#line 444 "../src/Connection.vala"
	_tmp6_ = __int_dup0 (_tmp0_);
#line 444 "../src/Connection.vala"
	padding = _tmp6_;
#line 446 "../src/Connection.vala"
	connection_title_bbox (self, &_tmp7_, &_tmp8_, &_tmp9_, &_tmp10_);
#line 446 "../src/Connection.vala"
	tx = _tmp7_;
#line 446 "../src/Connection.vala"
	ty = _tmp8_;
#line 446 "../src/Connection.vala"
	tw = _tmp9_;
#line 446 "../src/Connection.vala"
	th = _tmp10_;
#line 448 "../src/Connection.vala"
	_vala_x = (tx + tw) - ((*padding) + 11);
#line 449 "../src/Connection.vala"
	_vala_y = (ty + (th / 2)) - 5;
#line 450 "../src/Connection.vala"
	_vala_w = (gdouble) 11;
#line 451 "../src/Connection.vala"
	_vala_h = (gdouble) 11;
#line 441 "../src/Connection.vala"
	_g_free0 (padding);
#line 441 "../src/Connection.vala"
	if (x) {
#line 441 "../src/Connection.vala"
		*x = _vala_x;
#line 3041 "Connection.c"
	}
#line 441 "../src/Connection.vala"
	if (y) {
#line 441 "../src/Connection.vala"
		*y = _vala_y;
#line 3047 "Connection.c"
	}
#line 441 "../src/Connection.vala"
	if (w) {
#line 441 "../src/Connection.vala"
		*w = _vala_w;
#line 3053 "Connection.c"
	}
#line 441 "../src/Connection.vala"
	if (h) {
#line 441 "../src/Connection.vala"
		*h = _vala_h;
#line 3059 "Connection.c"
	}
}


void
connection_move_drag_handle (Connection* self,
                             gdouble x,
                             gdouble y)
{
	CanvasText* _tmp0_;
	CanvasText* _tmp1_;
	Bezier* _tmp8_;
	gdouble _tmp9_;
	gdouble _tmp10_;
	Node* _tmp11_;
	Node* _tmp12_;
#line 456 "../src/Connection.vala"
	g_return_if_fail (self != NULL);
#line 457 "../src/Connection.vala"
	connection_set_mode (self, CONN_MODE_ADJUSTING);
#line 458 "../src/Connection.vala"
	connection_position_title (self);
#line 459 "../src/Connection.vala"
	self->priv->_dragx = x;
#line 460 "../src/Connection.vala"
	self->priv->_dragy = y;
#line 461 "../src/Connection.vala"
	_tmp0_ = connection_get_title (self);
#line 461 "../src/Connection.vala"
	_tmp1_ = _tmp0_;
#line 461 "../src/Connection.vala"
	if (_tmp1_ != NULL) {
#line 3092 "Connection.c"
		gdouble tx = 0.0;
		gdouble ty = 0.0;
		gdouble tw = 0.0;
		gdouble th = 0.0;
		gdouble _tmp2_ = 0.0;
		gdouble _tmp3_ = 0.0;
		gdouble _tmp4_ = 0.0;
		gdouble _tmp5_ = 0.0;
		gdouble _tmp6_;
		gdouble _tmp7_;
#line 463 "../src/Connection.vala"
		connection_title_bbox (self, &_tmp2_, &_tmp3_, &_tmp4_, &_tmp5_);
#line 463 "../src/Connection.vala"
		tx = _tmp2_;
#line 463 "../src/Connection.vala"
		ty = _tmp3_;
#line 463 "../src/Connection.vala"
		tw = _tmp4_;
#line 463 "../src/Connection.vala"
		th = _tmp5_;
#line 464 "../src/Connection.vala"
		_tmp6_ = self->priv->_dragy;
#line 464 "../src/Connection.vala"
		_tmp7_ = th;
#line 464 "../src/Connection.vala"
		self->priv->_dragy = _tmp6_ - (_tmp7_ / 2);
#line 3119 "Connection.c"
	}
#line 466 "../src/Connection.vala"
	_tmp8_ = self->priv->_curve;
#line 466 "../src/Connection.vala"
	_tmp9_ = self->priv->_dragx;
#line 466 "../src/Connection.vala"
	_tmp10_ = self->priv->_dragy;
#line 466 "../src/Connection.vala"
	bezier_update_control_from_drag_handle (_tmp8_, _tmp9_, _tmp10_);
#line 467 "../src/Connection.vala"
	_tmp11_ = self->priv->_from_node;
#line 467 "../src/Connection.vala"
	connection_set_connect_point (self, _tmp11_);
#line 468 "../src/Connection.vala"
	_tmp12_ = self->priv->_to_node;
#line 468 "../src/Connection.vala"
	connection_set_connect_point (self, _tmp12_);
#line 3137 "Connection.c"
}


static gdouble
double_parse (const gchar* str)
{
	gdouble result = 0.0;
#line 944 "glib-2.0.vapi"
	g_return_val_if_fail (str != NULL, 0.0);
#line 945 "glib-2.0.vapi"
	result = g_ascii_strtod (str, NULL);
#line 945 "glib-2.0.vapi"
	return result;
#line 3151 "Connection.c"
}


static void
connection_load (Connection* self,
                 DrawArea* da,
                 xmlNode* node,
                 GArray* nodes,
                 GeeHashMap* id_map)
{
	gchar* f = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
	gchar* t = NULL;
	gchar* _tmp6_;
	const gchar* _tmp7_;
	gchar* x = NULL;
	gchar* _tmp12_;
	const gchar* _tmp13_;
	gchar* y = NULL;
	gchar* _tmp15_;
	const gchar* _tmp16_;
	gchar* n = NULL;
	gchar* _tmp18_;
	const gchar* _tmp19_;
	gchar* c = NULL;
	gchar* _tmp21_;
	const gchar* _tmp22_;
	gdouble fx = 0.0;
	gdouble fy = 0.0;
	gdouble fw = 0.0;
	gdouble fh = 0.0;
	gdouble tx = 0.0;
	gdouble ty = 0.0;
	gdouble tw = 0.0;
	gdouble th = 0.0;
	Node* _tmp28_;
	gdouble _tmp29_ = 0.0;
	gdouble _tmp30_ = 0.0;
	gdouble _tmp31_ = 0.0;
	gdouble _tmp32_ = 0.0;
	Node* _tmp33_;
	gdouble _tmp34_ = 0.0;
	gdouble _tmp35_ = 0.0;
	gdouble _tmp36_ = 0.0;
	gdouble _tmp37_ = 0.0;
	gdouble _tmp38_;
	gdouble _tmp39_;
	gdouble _tmp40_;
	gdouble _tmp41_;
	gdouble _tmp42_;
	gdouble _tmp43_;
	gdouble _tmp44_;
	gdouble _tmp45_;
	Bezier* _tmp46_;
	Bezier* _tmp47_;
	gdouble _tmp48_;
	gdouble _tmp49_;
	Node* _tmp50_;
	Node* _tmp51_;
#line 472 "../src/Connection.vala"
	g_return_if_fail (self != NULL);
#line 472 "../src/Connection.vala"
	g_return_if_fail (da != NULL);
#line 472 "../src/Connection.vala"
	g_return_if_fail (nodes != NULL);
#line 472 "../src/Connection.vala"
	g_return_if_fail (id_map != NULL);
#line 474 "../src/Connection.vala"
	_tmp0_ = (gchar*) xmlGetProp (node, (xmlChar*) "from_id");
#line 474 "../src/Connection.vala"
	f = _tmp0_;
#line 475 "../src/Connection.vala"
	_tmp1_ = f;
#line 475 "../src/Connection.vala"
	if (_tmp1_ != NULL) {
#line 3228 "Connection.c"
		const gchar* _tmp2_;
		gpointer _tmp3_;
		Node* _tmp4_;
		Node* _tmp5_;
#line 476 "../src/Connection.vala"
		_tmp2_ = f;
#line 476 "../src/Connection.vala"
		_tmp3_ = gee_abstract_map_get ((GeeAbstractMap*) id_map, (gpointer) ((gintptr) atoi (_tmp2_)));
#line 476 "../src/Connection.vala"
		_tmp4_ = draw_area_get_node (da, nodes, (gint) ((gintptr) _tmp3_));
#line 476 "../src/Connection.vala"
		_g_object_unref0 (self->priv->_from_node);
#line 476 "../src/Connection.vala"
		self->priv->_from_node = _tmp4_;
#line 477 "../src/Connection.vala"
		_tmp5_ = self->priv->_from_node;
#line 477 "../src/Connection.vala"
		connection_connect_node (self, _tmp5_);
#line 3247 "Connection.c"
	}
#line 480 "../src/Connection.vala"
	_tmp6_ = (gchar*) xmlGetProp (node, (xmlChar*) "to_id");
#line 480 "../src/Connection.vala"
	t = _tmp6_;
#line 481 "../src/Connection.vala"
	_tmp7_ = t;
#line 481 "../src/Connection.vala"
	if (_tmp7_ != NULL) {
#line 3257 "Connection.c"
		const gchar* _tmp8_;
		gpointer _tmp9_;
		Node* _tmp10_;
		Node* _tmp11_;
#line 482 "../src/Connection.vala"
		_tmp8_ = t;
#line 482 "../src/Connection.vala"
		_tmp9_ = gee_abstract_map_get ((GeeAbstractMap*) id_map, (gpointer) ((gintptr) atoi (_tmp8_)));
#line 482 "../src/Connection.vala"
		_tmp10_ = draw_area_get_node (da, nodes, (gint) ((gintptr) _tmp9_));
#line 482 "../src/Connection.vala"
		_g_object_unref0 (self->priv->_to_node);
#line 482 "../src/Connection.vala"
		self->priv->_to_node = _tmp10_;
#line 483 "../src/Connection.vala"
		_tmp11_ = self->priv->_to_node;
#line 483 "../src/Connection.vala"
		connection_connect_node (self, _tmp11_);
#line 3276 "Connection.c"
	}
#line 486 "../src/Connection.vala"
	_tmp12_ = (gchar*) xmlGetProp (node, (xmlChar*) "drag_x");
#line 486 "../src/Connection.vala"
	x = _tmp12_;
#line 487 "../src/Connection.vala"
	_tmp13_ = x;
#line 487 "../src/Connection.vala"
	if (_tmp13_ != NULL) {
#line 3286 "Connection.c"
		const gchar* _tmp14_;
#line 488 "../src/Connection.vala"
		_tmp14_ = x;
#line 488 "../src/Connection.vala"
		self->priv->_dragx = double_parse (_tmp14_);
#line 3292 "Connection.c"
	}
#line 491 "../src/Connection.vala"
	_tmp15_ = (gchar*) xmlGetProp (node, (xmlChar*) "drag_y");
#line 491 "../src/Connection.vala"
	y = _tmp15_;
#line 492 "../src/Connection.vala"
	_tmp16_ = y;
#line 492 "../src/Connection.vala"
	if (_tmp16_ != NULL) {
#line 3302 "Connection.c"
		const gchar* _tmp17_;
#line 493 "../src/Connection.vala"
		_tmp17_ = y;
#line 493 "../src/Connection.vala"
		self->priv->_dragy = double_parse (_tmp17_);
#line 3308 "Connection.c"
	}
#line 496 "../src/Connection.vala"
	_tmp18_ = (gchar*) xmlGetProp (node, (xmlChar*) "note");
#line 496 "../src/Connection.vala"
	n = _tmp18_;
#line 497 "../src/Connection.vala"
	_tmp19_ = n;
#line 497 "../src/Connection.vala"
	if (_tmp19_ != NULL) {
#line 3318 "Connection.c"
		const gchar* _tmp20_;
#line 498 "../src/Connection.vala"
		_tmp20_ = n;
#line 498 "../src/Connection.vala"
		connection_set_note (self, _tmp20_);
#line 3324 "Connection.c"
	}
#line 501 "../src/Connection.vala"
	_tmp21_ = (gchar*) xmlGetProp (node, (xmlChar*) "color");
#line 501 "../src/Connection.vala"
	c = _tmp21_;
#line 502 "../src/Connection.vala"
	_tmp22_ = c;
#line 502 "../src/Connection.vala"
	if (_tmp22_ != NULL) {
#line 3334 "Connection.c"
		const gchar* _tmp23_;
#line 503 "../src/Connection.vala"
		_tmp23_ = c;
#line 503 "../src/Connection.vala"
		gdk_rgba_parse (&self->priv->_color, _tmp23_);
#line 3340 "Connection.c"
	} else {
		Theme* _tmp24_;
		Theme* _tmp25_;
		GdkRGBA* _tmp26_;
		GdkRGBA* _tmp27_;
#line 505 "../src/Connection.vala"
		_tmp24_ = draw_area_get_theme (da);
#line 505 "../src/Connection.vala"
		_tmp25_ = _tmp24_;
#line 505 "../src/Connection.vala"
		_tmp26_ = theme_get_color (_tmp25_, "connection");
#line 505 "../src/Connection.vala"
		_tmp27_ = _tmp26_;
#line 505 "../src/Connection.vala"
		self->priv->_color = *_tmp27_;
#line 505 "../src/Connection.vala"
		_g_free0 (_tmp27_);
#line 505 "../src/Connection.vala"
		_g_object_unref0 (_tmp25_);
#line 3360 "Connection.c"
	}
#line 511 "../src/Connection.vala"
	_tmp28_ = self->priv->_from_node;
#line 511 "../src/Connection.vala"
	node_bbox (_tmp28_, &_tmp29_, &_tmp30_, &_tmp31_, &_tmp32_);
#line 511 "../src/Connection.vala"
	fx = _tmp29_;
#line 511 "../src/Connection.vala"
	fy = _tmp30_;
#line 511 "../src/Connection.vala"
	fw = _tmp31_;
#line 511 "../src/Connection.vala"
	fh = _tmp32_;
#line 512 "../src/Connection.vala"
	_tmp33_ = self->priv->_to_node;
#line 512 "../src/Connection.vala"
	node_bbox (_tmp33_, &_tmp34_, &_tmp35_, &_tmp36_, &_tmp37_);
#line 512 "../src/Connection.vala"
	tx = _tmp34_;
#line 512 "../src/Connection.vala"
	ty = _tmp35_;
#line 512 "../src/Connection.vala"
	tw = _tmp36_;
#line 512 "../src/Connection.vala"
	th = _tmp37_;
#line 513 "../src/Connection.vala"
	_tmp38_ = fx;
#line 513 "../src/Connection.vala"
	_tmp39_ = fw;
#line 513 "../src/Connection.vala"
	_tmp40_ = fy;
#line 513 "../src/Connection.vala"
	_tmp41_ = fh;
#line 513 "../src/Connection.vala"
	_tmp42_ = tx;
#line 513 "../src/Connection.vala"
	_tmp43_ = tw;
#line 513 "../src/Connection.vala"
	_tmp44_ = ty;
#line 513 "../src/Connection.vala"
	_tmp45_ = th;
#line 513 "../src/Connection.vala"
	_tmp46_ = bezier_new_with_endpoints (_tmp38_ + (_tmp39_ / 2), _tmp40_ + (_tmp41_ / 2), _tmp42_ + (_tmp43_ / 2), _tmp44_ + (_tmp45_ / 2));
#line 513 "../src/Connection.vala"
	_bezier_unref0 (self->priv->_curve);
#line 513 "../src/Connection.vala"
	self->priv->_curve = _tmp46_;
#line 514 "../src/Connection.vala"
	_tmp47_ = self->priv->_curve;
#line 514 "../src/Connection.vala"
	_tmp48_ = self->priv->_dragx;
#line 514 "../src/Connection.vala"
	_tmp49_ = self->priv->_dragy;
#line 514 "../src/Connection.vala"
	bezier_update_control_from_drag_handle (_tmp47_, _tmp48_, _tmp49_);
#line 515 "../src/Connection.vala"
	_tmp50_ = self->priv->_from_node;
#line 515 "../src/Connection.vala"
	connection_set_connect_point (self, _tmp50_);
#line 516 "../src/Connection.vala"
	_tmp51_ = self->priv->_to_node;
#line 516 "../src/Connection.vala"
	connection_set_connect_point (self, _tmp51_);
#line 3424 "Connection.c"
	{
		xmlNode* it = NULL;
		xmlNode* _tmp52_;
#line 519 "../src/Connection.vala"
		_tmp52_ = node->children;
#line 519 "../src/Connection.vala"
		it = _tmp52_;
#line 3432 "Connection.c"
		{
			gboolean _tmp53_ = FALSE;
#line 519 "../src/Connection.vala"
			_tmp53_ = TRUE;
#line 519 "../src/Connection.vala"
			while (TRUE) {
#line 3439 "Connection.c"
				xmlNode* _tmp56_;
				xmlNode* _tmp57_;
				xmlElementType _tmp58_;
#line 519 "../src/Connection.vala"
				if (!_tmp53_) {
#line 3445 "Connection.c"
					xmlNode* _tmp54_;
					xmlNode* _tmp55_;
#line 519 "../src/Connection.vala"
					_tmp54_ = it;
#line 519 "../src/Connection.vala"
					_tmp55_ = _tmp54_->next;
#line 519 "../src/Connection.vala"
					it = _tmp55_;
#line 3454 "Connection.c"
				}
#line 519 "../src/Connection.vala"
				_tmp53_ = FALSE;
#line 519 "../src/Connection.vala"
				_tmp56_ = it;
#line 519 "../src/Connection.vala"
				if (!(_tmp56_ != NULL)) {
#line 519 "../src/Connection.vala"
					break;
#line 3464 "Connection.c"
				}
#line 520 "../src/Connection.vala"
				_tmp57_ = it;
#line 520 "../src/Connection.vala"
				_tmp58_ = _tmp57_->type;
#line 520 "../src/Connection.vala"
				if (_tmp58_ == XML_ELEMENT_NODE) {
#line 3472 "Connection.c"
					xmlNode* _tmp59_;
					const gchar* _tmp60_;
					const gchar* _tmp61_;
					GQuark _tmp63_ = 0U;
#line 521 "../src/Connection.vala"
					static GQuark _tmp62_label0 = 0;
#line 521 "../src/Connection.vala"
					static GQuark _tmp62_label1 = 0;
#line 521 "../src/Connection.vala"
					static GQuark _tmp62_label2 = 0;
#line 521 "../src/Connection.vala"
					_tmp59_ = it;
#line 521 "../src/Connection.vala"
					_tmp60_ = _tmp59_->name;
#line 521 "../src/Connection.vala"
					_tmp61_ = _tmp60_;
#line 521 "../src/Connection.vala"
					_tmp63_ = (NULL == _tmp61_) ? 0 : g_quark_from_string (_tmp61_);
#line 521 "../src/Connection.vala"
					if (_tmp63_ == ((0 != _tmp62_label0) ? _tmp62_label0 : (_tmp62_label0 = g_quark_from_static_string ("style")))) {
#line 521 "../src/Connection.vala"
						switch (0) {
#line 3495 "Connection.c"
							default:
							{
								Style* _tmp64_;
								Style* _tmp65_;
								xmlNode* _tmp66_;
#line 522 "../src/Connection.vala"
								_tmp64_ = connection_get_style (self);
#line 522 "../src/Connection.vala"
								_tmp65_ = _tmp64_;
#line 522 "../src/Connection.vala"
								_tmp66_ = it;
#line 522 "../src/Connection.vala"
								style_load_connection (_tmp65_, _tmp66_);
#line 522 "../src/Connection.vala"
								break;
#line 3511 "Connection.c"
							}
						}
					} else if (_tmp63_ == ((0 != _tmp62_label1) ? _tmp62_label1 : (_tmp62_label1 = g_quark_from_static_string ("title")))) {
#line 521 "../src/Connection.vala"
						switch (0) {
#line 3517 "Connection.c"
							default:
							{
								gboolean _tmp67_ = FALSE;
								xmlNode* _tmp68_;
								xmlNode* _tmp69_;
#line 524 "../src/Connection.vala"
								_tmp68_ = it;
#line 524 "../src/Connection.vala"
								_tmp69_ = _tmp68_->children;
#line 524 "../src/Connection.vala"
								if (_tmp69_ != NULL) {
#line 3529 "Connection.c"
									xmlNode* _tmp70_;
									xmlNode* _tmp71_;
									xmlElementType _tmp72_;
#line 524 "../src/Connection.vala"
									_tmp70_ = it;
#line 524 "../src/Connection.vala"
									_tmp71_ = _tmp70_->children;
#line 524 "../src/Connection.vala"
									_tmp72_ = _tmp71_->type;
#line 524 "../src/Connection.vala"
									_tmp67_ = _tmp72_ == XML_TEXT_NODE;
#line 3541 "Connection.c"
								} else {
#line 524 "../src/Connection.vala"
									_tmp67_ = FALSE;
#line 3545 "Connection.c"
								}
#line 524 "../src/Connection.vala"
								if (_tmp67_) {
#line 3549 "Connection.c"
									xmlNode* _tmp73_;
									xmlNode* _tmp74_;
									gchar* _tmp75_;
									gchar* _tmp76_;
#line 525 "../src/Connection.vala"
									_tmp73_ = it;
#line 525 "../src/Connection.vala"
									_tmp74_ = _tmp73_->children;
#line 525 "../src/Connection.vala"
									_tmp75_ = (gchar*) xmlNodeGetContent (_tmp74_);
#line 525 "../src/Connection.vala"
									_tmp76_ = _tmp75_;
#line 525 "../src/Connection.vala"
									connection_change_title (self, da, _tmp76_, FALSE);
#line 525 "../src/Connection.vala"
									_g_free0 (_tmp76_);
#line 3566 "Connection.c"
								}
#line 527 "../src/Connection.vala"
								break;
#line 3570 "Connection.c"
							}
						}
					} else if (_tmp63_ == ((0 != _tmp62_label2) ? _tmp62_label2 : (_tmp62_label2 = g_quark_from_static_string ("note")))) {
#line 521 "../src/Connection.vala"
						switch (0) {
#line 3576 "Connection.c"
							default:
							{
								gboolean _tmp77_ = FALSE;
								xmlNode* _tmp78_;
								xmlNode* _tmp79_;
#line 529 "../src/Connection.vala"
								_tmp78_ = it;
#line 529 "../src/Connection.vala"
								_tmp79_ = _tmp78_->children;
#line 529 "../src/Connection.vala"
								if (_tmp79_ != NULL) {
#line 3588 "Connection.c"
									xmlNode* _tmp80_;
									xmlNode* _tmp81_;
									xmlElementType _tmp82_;
#line 529 "../src/Connection.vala"
									_tmp80_ = it;
#line 529 "../src/Connection.vala"
									_tmp81_ = _tmp80_->children;
#line 529 "../src/Connection.vala"
									_tmp82_ = _tmp81_->type;
#line 529 "../src/Connection.vala"
									_tmp77_ = _tmp82_ == XML_TEXT_NODE;
#line 3600 "Connection.c"
								} else {
#line 529 "../src/Connection.vala"
									_tmp77_ = FALSE;
#line 3604 "Connection.c"
								}
#line 529 "../src/Connection.vala"
								if (_tmp77_) {
#line 3608 "Connection.c"
									xmlNode* _tmp83_;
									xmlNode* _tmp84_;
									gchar* _tmp85_;
									gchar* _tmp86_;
#line 530 "../src/Connection.vala"
									_tmp83_ = it;
#line 530 "../src/Connection.vala"
									_tmp84_ = _tmp83_->children;
#line 530 "../src/Connection.vala"
									_tmp85_ = (gchar*) xmlNodeGetContent (_tmp84_);
#line 530 "../src/Connection.vala"
									_tmp86_ = _tmp85_;
#line 530 "../src/Connection.vala"
									connection_set_note (self, _tmp86_);
#line 530 "../src/Connection.vala"
									_g_free0 (_tmp86_);
#line 3625 "Connection.c"
								}
#line 532 "../src/Connection.vala"
								break;
#line 3629 "Connection.c"
							}
						}
					}
				}
			}
		}
	}
#line 472 "../src/Connection.vala"
	_g_free0 (c);
#line 472 "../src/Connection.vala"
	_g_free0 (n);
#line 472 "../src/Connection.vala"
	_g_free0 (y);
#line 472 "../src/Connection.vala"
	_g_free0 (x);
#line 472 "../src/Connection.vala"
	_g_free0 (t);
#line 472 "../src/Connection.vala"
	_g_free0 (f);
#line 3649 "Connection.c"
}


static gchar*
double_to_string (gdouble self)
{
	gchar* result = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
	gint _tmp1__length1;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
#line 938 "glib-2.0.vapi"
	_tmp0_ = g_new0 (gchar, G_ASCII_DTOSTR_BUF_SIZE);
#line 938 "glib-2.0.vapi"
	_tmp1_ = _tmp0_;
#line 938 "glib-2.0.vapi"
	_tmp1__length1 = G_ASCII_DTOSTR_BUF_SIZE;
#line 938 "glib-2.0.vapi"
	_tmp2_ = g_ascii_dtostr (_tmp1_, G_ASCII_DTOSTR_BUF_SIZE, self);
#line 938 "glib-2.0.vapi"
	_tmp3_ = g_strdup (_tmp2_);
#line 938 "glib-2.0.vapi"
	_tmp4_ = _tmp3_;
#line 938 "glib-2.0.vapi"
	_tmp1_ = (g_free (_tmp1_), NULL);
#line 938 "glib-2.0.vapi"
	result = _tmp4_;
#line 938 "glib-2.0.vapi"
	return result;
#line 3681 "Connection.c"
}


void
connection_save (Connection* self,
                 xmlNode* parent)
{
	xmlNode* n = NULL;
	xmlNode* _tmp0_;
	xmlNode* _tmp1_;
	Node* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	xmlNode* _tmp5_;
	Node* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	xmlNode* _tmp9_;
	gdouble _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	xmlNode* _tmp13_;
	gdouble _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	xmlNode* _tmp17_;
	gchar* _tmp18_;
	gchar* _tmp19_;
	Style* _tmp20_;
	Style* _tmp21_;
	xmlNode* _tmp22_;
	const gchar* _tmp23_ = NULL;
	CanvasText* _tmp24_;
	CanvasText* _tmp25_;
	xmlNode* _tmp30_;
	xmlNode* _tmp31_;
	const gchar* _tmp32_;
	const gchar* _tmp33_;
	xmlNode* _tmp34_;
#line 540 "../src/Connection.vala"
	g_return_if_fail (self != NULL);
#line 542 "../src/Connection.vala"
	_tmp0_ = xmlNewNode (NULL, (xmlChar*) "connection");
#line 542 "../src/Connection.vala"
	n = _tmp0_;
#line 543 "../src/Connection.vala"
	_tmp1_ = n;
#line 543 "../src/Connection.vala"
	_tmp2_ = self->priv->_from_node;
#line 543 "../src/Connection.vala"
	_tmp3_ = g_strdup_printf ("%i", node_id (_tmp2_));
#line 543 "../src/Connection.vala"
	_tmp4_ = _tmp3_;
#line 543 "../src/Connection.vala"
	xmlSetProp (_tmp1_, (xmlChar*) "from_id", (xmlChar*) _tmp4_);
#line 543 "../src/Connection.vala"
	_g_free0 (_tmp4_);
#line 544 "../src/Connection.vala"
	_tmp5_ = n;
#line 544 "../src/Connection.vala"
	_tmp6_ = self->priv->_to_node;
#line 544 "../src/Connection.vala"
	_tmp7_ = g_strdup_printf ("%i", node_id (_tmp6_));
#line 544 "../src/Connection.vala"
	_tmp8_ = _tmp7_;
#line 544 "../src/Connection.vala"
	xmlSetProp (_tmp5_, (xmlChar*) "to_id", (xmlChar*) _tmp8_);
#line 544 "../src/Connection.vala"
	_g_free0 (_tmp8_);
#line 545 "../src/Connection.vala"
	_tmp9_ = n;
#line 545 "../src/Connection.vala"
	_tmp10_ = self->priv->_dragx;
#line 545 "../src/Connection.vala"
	_tmp11_ = double_to_string (_tmp10_);
#line 545 "../src/Connection.vala"
	_tmp12_ = _tmp11_;
#line 545 "../src/Connection.vala"
	xmlSetProp (_tmp9_, (xmlChar*) "drag_x", (xmlChar*) _tmp12_);
#line 545 "../src/Connection.vala"
	_g_free0 (_tmp12_);
#line 546 "../src/Connection.vala"
	_tmp13_ = n;
#line 546 "../src/Connection.vala"
	_tmp14_ = self->priv->_dragy;
#line 546 "../src/Connection.vala"
	_tmp15_ = double_to_string (_tmp14_);
#line 546 "../src/Connection.vala"
	_tmp16_ = _tmp15_;
#line 546 "../src/Connection.vala"
	xmlSetProp (_tmp13_, (xmlChar*) "drag_y", (xmlChar*) _tmp16_);
#line 546 "../src/Connection.vala"
	_g_free0 (_tmp16_);
#line 547 "../src/Connection.vala"
	_tmp17_ = n;
#line 547 "../src/Connection.vala"
	_tmp18_ = gdk_rgba_to_string (&self->priv->_color);
#line 547 "../src/Connection.vala"
	_tmp19_ = _tmp18_;
#line 547 "../src/Connection.vala"
	xmlSetProp (_tmp17_, (xmlChar*) "color", (xmlChar*) _tmp19_);
#line 547 "../src/Connection.vala"
	_g_free0 (_tmp19_);
#line 550 "../src/Connection.vala"
	_tmp20_ = connection_get_style (self);
#line 550 "../src/Connection.vala"
	_tmp21_ = _tmp20_;
#line 550 "../src/Connection.vala"
	_tmp22_ = n;
#line 550 "../src/Connection.vala"
	style_save_connection (_tmp21_, _tmp22_);
#line 552 "../src/Connection.vala"
	_tmp24_ = connection_get_title (self);
#line 552 "../src/Connection.vala"
	_tmp25_ = _tmp24_;
#line 552 "../src/Connection.vala"
	if (_tmp25_ != NULL) {
#line 3799 "Connection.c"
		CanvasText* _tmp26_;
		CanvasText* _tmp27_;
		const gchar* _tmp28_;
		const gchar* _tmp29_;
#line 552 "../src/Connection.vala"
		_tmp26_ = connection_get_title (self);
#line 552 "../src/Connection.vala"
		_tmp27_ = _tmp26_;
#line 552 "../src/Connection.vala"
		_tmp28_ = canvas_text_get_text (_tmp27_);
#line 552 "../src/Connection.vala"
		_tmp29_ = _tmp28_;
#line 552 "../src/Connection.vala"
		_tmp23_ = _tmp29_;
#line 3814 "Connection.c"
	} else {
#line 552 "../src/Connection.vala"
		_tmp23_ = "";
#line 3818 "Connection.c"
	}
#line 552 "../src/Connection.vala"
	_tmp30_ = n;
#line 552 "../src/Connection.vala"
	xmlNewTextChild (_tmp30_, NULL, (xmlChar*) "title", (xmlChar*) _tmp23_);
#line 553 "../src/Connection.vala"
	_tmp31_ = n;
#line 553 "../src/Connection.vala"
	_tmp32_ = connection_get_note (self);
#line 553 "../src/Connection.vala"
	_tmp33_ = _tmp32_;
#line 553 "../src/Connection.vala"
	xmlNewTextChild (_tmp31_, NULL, (xmlChar*) "note", (xmlChar*) _tmp33_);
#line 555 "../src/Connection.vala"
	_tmp34_ = n;
#line 555 "../src/Connection.vala"
	xmlAddChild (parent, _tmp34_);
#line 3836 "Connection.c"
}


void
connection_get_match_items (Connection* self,
                            const gchar* pattern,
                            gboolean* search_opts,
                            int search_opts_length1,
                            GtkListStore* * matches)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean _tmp10_;
#line 563 "../src/Connection.vala"
	g_return_if_fail (self != NULL);
#line 563 "../src/Connection.vala"
	g_return_if_fail (pattern != NULL);
#line 563 "../src/Connection.vala"
	g_return_if_fail (*matches != NULL);
#line 564 "../src/Connection.vala"
	_tmp1_ = search_opts[2];
#line 564 "../src/Connection.vala"
	if (_tmp1_) {
#line 3860 "Connection.c"
		CanvasText* _tmp2_;
		CanvasText* _tmp3_;
#line 564 "../src/Connection.vala"
		_tmp2_ = connection_get_title (self);
#line 564 "../src/Connection.vala"
		_tmp3_ = _tmp2_;
#line 564 "../src/Connection.vala"
		_tmp0_ = _tmp3_ != NULL;
#line 3869 "Connection.c"
	} else {
#line 564 "../src/Connection.vala"
		_tmp0_ = FALSE;
#line 3873 "Connection.c"
	}
#line 564 "../src/Connection.vala"
	if (_tmp0_) {
#line 3877 "Connection.c"
		CanvasText* _tmp4_;
		CanvasText* _tmp5_;
		const gchar* _tmp6_;
		const gchar* _tmp7_;
		gchar* _tmp8_;
		gchar* _tmp9_;
#line 565 "../src/Connection.vala"
		_tmp4_ = connection_get_title (self);
#line 565 "../src/Connection.vala"
		_tmp5_ = _tmp4_;
#line 565 "../src/Connection.vala"
		_tmp6_ = canvas_text_get_text (_tmp5_);
#line 565 "../src/Connection.vala"
		_tmp7_ = _tmp6_;
#line 565 "../src/Connection.vala"
		_tmp8_ = g_strdup_printf ("<b><i>%s:</i></b>", _ ("Connection Title"));
#line 565 "../src/Connection.vala"
		_tmp9_ = _tmp8_;
#line 565 "../src/Connection.vala"
		utils_match_string (pattern, _tmp7_, _tmp9_, NULL, self, matches);
#line 565 "../src/Connection.vala"
		_g_free0 (_tmp9_);
#line 3900 "Connection.c"
	}
#line 567 "../src/Connection.vala"
	_tmp10_ = search_opts[3];
#line 567 "../src/Connection.vala"
	if (_tmp10_) {
#line 3906 "Connection.c"
		const gchar* _tmp11_;
		const gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
#line 568 "../src/Connection.vala"
		_tmp11_ = connection_get_note (self);
#line 568 "../src/Connection.vala"
		_tmp12_ = _tmp11_;
#line 568 "../src/Connection.vala"
		_tmp13_ = g_strdup_printf ("<b><i>%s:</i></b>", _ ("Connection Note"));
#line 568 "../src/Connection.vala"
		_tmp14_ = _tmp13_;
#line 568 "../src/Connection.vala"
		utils_match_string (pattern, _tmp12_, _tmp14_, NULL, self, matches);
#line 568 "../src/Connection.vala"
		_g_free0 (_tmp14_);
#line 3923 "Connection.c"
	}
}


static void
connection_real_draw (Connection* self,
                      cairo_t* ctx,
                      Theme* theme)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	Node* _tmp3_;
	gdouble start_x = 0.0;
	gdouble start_y = 0.0;
	gdouble end_x = 0.0;
	gdouble end_y = 0.0;
	gdouble dragx = 0.0;
	gdouble _tmp19_;
	gdouble dragy = 0.0;
	gdouble _tmp20_;
	GdkRGBA* _tmp21_ = NULL;
	ConnMode _tmp22_;
	ConnMode _tmp23_;
	GdkRGBA bg = {0};
	Node* _tmp26_;
	Node* _tmp32_;
	gdouble cx = 0.0;
	gdouble cy = 0.0;
	gdouble _tmp38_;
	gdouble _tmp39_;
	gdouble _tmp40_;
	gdouble _tmp41_;
	gdouble _tmp42_;
	gdouble _tmp43_;
	gdouble _tmp44_;
	gdouble _tmp45_;
	Style* _tmp46_;
	Style* _tmp47_;
	GdkRGBA _tmp48_;
	gdouble _tmp49_;
	gdouble _tmp50_;
	gdouble _tmp51_;
	gdouble _tmp52_;
	gdouble _tmp53_;
	gdouble _tmp54_;
	gdouble _tmp55_;
	gdouble _tmp56_;
	gdouble _tmp57_;
	gdouble _tmp58_;
	gdouble _tmp59_;
	gdouble _tmp60_;
	gdouble _tmp61_;
	gdouble* _tmp62_;
	gdouble* _tmp63_;
	gint _tmp63__length1;
	ConnMode _tmp64_;
	ConnMode _tmp65_;
	gboolean _tmp100_ = FALSE;
	CanvasText* _tmp101_;
	CanvasText* _tmp102_;
	ConnMode _tmp126_;
	ConnMode _tmp127_;
#line 573 "../src/Connection.vala"
	g_return_if_fail (ctx != NULL);
#line 573 "../src/Connection.vala"
	g_return_if_fail (theme != NULL);
#line 576 "../src/Connection.vala"
	_tmp3_ = self->priv->_from_node;
#line 576 "../src/Connection.vala"
	if (_tmp3_ != NULL) {
#line 3995 "Connection.c"
		Node* _tmp4_;
#line 576 "../src/Connection.vala"
		_tmp4_ = self->priv->_from_node;
#line 576 "../src/Connection.vala"
		_tmp2_ = !node_is_root (_tmp4_);
#line 4001 "Connection.c"
	} else {
#line 576 "../src/Connection.vala"
		_tmp2_ = FALSE;
#line 4005 "Connection.c"
	}
#line 576 "../src/Connection.vala"
	if (_tmp2_) {
#line 4009 "Connection.c"
		Node* _tmp5_;
		Node* _tmp6_;
		Node* _tmp7_;
		gboolean _tmp8_;
		gboolean _tmp9_;
#line 576 "../src/Connection.vala"
		_tmp5_ = self->priv->_from_node;
#line 576 "../src/Connection.vala"
		_tmp6_ = node_get_parent (_tmp5_);
#line 576 "../src/Connection.vala"
		_tmp7_ = _tmp6_;
#line 576 "../src/Connection.vala"
		_tmp8_ = node_get_folded (_tmp7_);
#line 576 "../src/Connection.vala"
		_tmp9_ = _tmp8_;
#line 576 "../src/Connection.vala"
		_tmp1_ = _tmp9_;
#line 4027 "Connection.c"
	} else {
#line 576 "../src/Connection.vala"
		_tmp1_ = FALSE;
#line 4031 "Connection.c"
	}
#line 576 "../src/Connection.vala"
	if (_tmp1_) {
#line 576 "../src/Connection.vala"
		_tmp0_ = TRUE;
#line 4037 "Connection.c"
	} else {
		gboolean _tmp10_ = FALSE;
		gboolean _tmp11_ = FALSE;
		Node* _tmp12_;
#line 577 "../src/Connection.vala"
		_tmp12_ = self->priv->_to_node;
#line 577 "../src/Connection.vala"
		if (_tmp12_ != NULL) {
#line 4046 "Connection.c"
			Node* _tmp13_;
#line 577 "../src/Connection.vala"
			_tmp13_ = self->priv->_to_node;
#line 577 "../src/Connection.vala"
			_tmp11_ = !node_is_root (_tmp13_);
#line 4052 "Connection.c"
		} else {
#line 577 "../src/Connection.vala"
			_tmp11_ = FALSE;
#line 4056 "Connection.c"
		}
#line 577 "../src/Connection.vala"
		if (_tmp11_) {
#line 4060 "Connection.c"
			Node* _tmp14_;
			Node* _tmp15_;
			Node* _tmp16_;
			gboolean _tmp17_;
			gboolean _tmp18_;
#line 577 "../src/Connection.vala"
			_tmp14_ = self->priv->_to_node;
#line 577 "../src/Connection.vala"
			_tmp15_ = node_get_parent (_tmp14_);
#line 577 "../src/Connection.vala"
			_tmp16_ = _tmp15_;
#line 577 "../src/Connection.vala"
			_tmp17_ = node_get_folded (_tmp16_);
#line 577 "../src/Connection.vala"
			_tmp18_ = _tmp17_;
#line 577 "../src/Connection.vala"
			_tmp10_ = _tmp18_;
#line 4078 "Connection.c"
		} else {
#line 577 "../src/Connection.vala"
			_tmp10_ = FALSE;
#line 4082 "Connection.c"
		}
#line 577 "../src/Connection.vala"
		_tmp0_ = _tmp10_;
#line 4086 "Connection.c"
	}
#line 576 "../src/Connection.vala"
	if (_tmp0_) {
#line 578 "../src/Connection.vala"
		return;
#line 4092 "Connection.c"
	}
#line 583 "../src/Connection.vala"
	_tmp19_ = self->priv->_dragx;
#line 583 "../src/Connection.vala"
	dragx = _tmp19_;
#line 584 "../src/Connection.vala"
	_tmp20_ = self->priv->_dragy;
#line 584 "../src/Connection.vala"
	dragy = _tmp20_;
#line 585 "../src/Connection.vala"
	_tmp22_ = connection_get_mode (self);
#line 585 "../src/Connection.vala"
	_tmp23_ = _tmp22_;
#line 585 "../src/Connection.vala"
	if (_tmp23_ == CONN_MODE_NONE) {
#line 4108 "Connection.c"
		GdkRGBA* _tmp24_;
#line 585 "../src/Connection.vala"
		_tmp24_ = theme_get_color (theme, "background");
#line 585 "../src/Connection.vala"
		_g_free0 (_tmp21_);
#line 585 "../src/Connection.vala"
		_tmp21_ = _tmp24_;
#line 4116 "Connection.c"
	} else {
		GdkRGBA* _tmp25_;
#line 585 "../src/Connection.vala"
		_tmp25_ = theme_get_color (theme, "nodesel_background");
#line 585 "../src/Connection.vala"
		_g_free0 (_tmp21_);
#line 585 "../src/Connection.vala"
		_tmp21_ = _tmp25_;
#line 4125 "Connection.c"
	}
#line 585 "../src/Connection.vala"
	bg = *_tmp21_;
#line 587 "../src/Connection.vala"
	_tmp26_ = self->priv->_from_node;
#line 587 "../src/Connection.vala"
	if (_tmp26_ == NULL) {
#line 4133 "Connection.c"
		gdouble _tmp27_;
		gdouble _tmp28_;
#line 588 "../src/Connection.vala"
		_tmp27_ = self->priv->_posx;
#line 588 "../src/Connection.vala"
		start_x = _tmp27_;
#line 589 "../src/Connection.vala"
		_tmp28_ = self->priv->_posy;
#line 589 "../src/Connection.vala"
		start_y = _tmp28_;
#line 4144 "Connection.c"
	} else {
		Bezier* _tmp29_;
		gdouble _tmp30_ = 0.0;
		gdouble _tmp31_ = 0.0;
#line 591 "../src/Connection.vala"
		_tmp29_ = self->priv->_curve;
#line 591 "../src/Connection.vala"
		bezier_get_from_point (_tmp29_, &_tmp30_, &_tmp31_);
#line 591 "../src/Connection.vala"
		start_x = _tmp30_;
#line 591 "../src/Connection.vala"
		start_y = _tmp31_;
#line 4157 "Connection.c"
	}
#line 594 "../src/Connection.vala"
	_tmp32_ = self->priv->_to_node;
#line 594 "../src/Connection.vala"
	if (_tmp32_ == NULL) {
#line 4163 "Connection.c"
		gdouble _tmp33_;
		gdouble _tmp34_;
#line 595 "../src/Connection.vala"
		_tmp33_ = self->priv->_posx;
#line 595 "../src/Connection.vala"
		end_x = _tmp33_;
#line 596 "../src/Connection.vala"
		_tmp34_ = self->priv->_posy;
#line 596 "../src/Connection.vala"
		end_y = _tmp34_;
#line 4174 "Connection.c"
	} else {
		Bezier* _tmp35_;
		gdouble _tmp36_ = 0.0;
		gdouble _tmp37_ = 0.0;
#line 598 "../src/Connection.vala"
		_tmp35_ = self->priv->_curve;
#line 598 "../src/Connection.vala"
		bezier_get_to_point (_tmp35_, &_tmp36_, &_tmp37_);
#line 598 "../src/Connection.vala"
		end_x = _tmp36_;
#line 598 "../src/Connection.vala"
		end_y = _tmp37_;
#line 4187 "Connection.c"
	}
#line 605 "../src/Connection.vala"
	_tmp38_ = dragx;
#line 605 "../src/Connection.vala"
	_tmp39_ = start_x;
#line 605 "../src/Connection.vala"
	_tmp40_ = end_x;
#line 605 "../src/Connection.vala"
	_tmp41_ = dragx;
#line 605 "../src/Connection.vala"
	cx = _tmp38_ - (((_tmp39_ + _tmp40_) * 0.5) - _tmp41_);
#line 606 "../src/Connection.vala"
	_tmp42_ = dragy;
#line 606 "../src/Connection.vala"
	_tmp43_ = start_y;
#line 606 "../src/Connection.vala"
	_tmp44_ = end_y;
#line 606 "../src/Connection.vala"
	_tmp45_ = dragy;
#line 606 "../src/Connection.vala"
	cy = _tmp42_ - (((_tmp43_ + _tmp44_) * 0.5) - _tmp45_);
#line 609 "../src/Connection.vala"
	cairo_save (ctx);
#line 610 "../src/Connection.vala"
	_tmp46_ = connection_get_style (self);
#line 610 "../src/Connection.vala"
	_tmp47_ = _tmp46_;
#line 610 "../src/Connection.vala"
	style_draw_connection (_tmp47_, ctx);
#line 611 "../src/Connection.vala"
	_tmp48_ = self->priv->_color;
#line 611 "../src/Connection.vala"
	_tmp49_ = self->priv->_alpha;
#line 611 "../src/Connection.vala"
	utils_set_context_color_with_alpha (ctx, &_tmp48_, _tmp49_);
#line 614 "../src/Connection.vala"
	_tmp50_ = start_x;
#line 614 "../src/Connection.vala"
	_tmp51_ = start_y;
#line 614 "../src/Connection.vala"
	cairo_move_to (ctx, _tmp50_, _tmp51_);
#line 615 "../src/Connection.vala"
	_tmp52_ = cx;
#line 615 "../src/Connection.vala"
	_tmp53_ = start_x;
#line 615 "../src/Connection.vala"
	_tmp54_ = cy;
#line 615 "../src/Connection.vala"
	_tmp55_ = start_y;
#line 615 "../src/Connection.vala"
	_tmp56_ = cx;
#line 615 "../src/Connection.vala"
	_tmp57_ = end_x;
#line 615 "../src/Connection.vala"
	_tmp58_ = cy;
#line 615 "../src/Connection.vala"
	_tmp59_ = end_y;
#line 615 "../src/Connection.vala"
	_tmp60_ = end_x;
#line 615 "../src/Connection.vala"
	_tmp61_ = end_y;
#line 615 "../src/Connection.vala"
	cairo_curve_to (ctx, ((2.0 / 3.0) * _tmp52_) + ((1.0 / 3.0) * _tmp53_), ((2.0 / 3.0) * _tmp54_) + ((1.0 / 3.0) * _tmp55_), ((2.0 / 3.0) * _tmp56_) + ((1.0 / 3.0) * _tmp57_), ((2.0 / 3.0) * _tmp58_) + ((1.0 / 3.0) * _tmp59_), _tmp60_, _tmp61_);
#line 622 "../src/Connection.vala"
	cairo_stroke (ctx);
#line 624 "../src/Connection.vala"
	_tmp62_ = g_new0 (gdouble, 0);
#line 624 "../src/Connection.vala"
	_tmp63_ = _tmp62_;
#line 624 "../src/Connection.vala"
	_tmp63__length1 = 0;
#line 624 "../src/Connection.vala"
	cairo_set_dash (ctx, _tmp63_, 0, (gdouble) 0);
#line 624 "../src/Connection.vala"
	_tmp63_ = (g_free (_tmp63_), NULL);
#line 627 "../src/Connection.vala"
	_tmp64_ = connection_get_mode (self);
#line 627 "../src/Connection.vala"
	_tmp65_ = _tmp64_;
#line 627 "../src/Connection.vala"
	if (_tmp65_ != CONN_MODE_SELECTED) {
#line 4269 "Connection.c"
		gboolean _tmp66_ = FALSE;
		Style* _tmp67_;
		Style* _tmp68_;
		const gchar* _tmp69_;
		const gchar* _tmp70_;
		gboolean _tmp83_ = FALSE;
		Style* _tmp84_;
		Style* _tmp85_;
		const gchar* _tmp86_;
		const gchar* _tmp87_;
#line 628 "../src/Connection.vala"
		_tmp67_ = connection_get_style (self);
#line 628 "../src/Connection.vala"
		_tmp68_ = _tmp67_;
#line 628 "../src/Connection.vala"
		_tmp69_ = style_get_connection_arrow (_tmp68_);
#line 628 "../src/Connection.vala"
		_tmp70_ = _tmp69_;
#line 628 "../src/Connection.vala"
		if (g_strcmp0 (_tmp70_, "fromto") == 0) {
#line 628 "../src/Connection.vala"
			_tmp66_ = TRUE;
#line 4292 "Connection.c"
		} else {
			Style* _tmp71_;
			Style* _tmp72_;
			const gchar* _tmp73_;
			const gchar* _tmp74_;
#line 628 "../src/Connection.vala"
			_tmp71_ = connection_get_style (self);
#line 628 "../src/Connection.vala"
			_tmp72_ = _tmp71_;
#line 628 "../src/Connection.vala"
			_tmp73_ = style_get_connection_arrow (_tmp72_);
#line 628 "../src/Connection.vala"
			_tmp74_ = _tmp73_;
#line 628 "../src/Connection.vala"
			_tmp66_ = g_strcmp0 (_tmp74_, "both") == 0;
#line 4308 "Connection.c"
		}
#line 628 "../src/Connection.vala"
		if (_tmp66_) {
#line 4312 "Connection.c"
			Style* _tmp75_;
			Style* _tmp76_;
			gint* _tmp77_;
			gint* _tmp78_;
			gdouble _tmp79_;
			gdouble _tmp80_;
			gdouble _tmp81_;
			gdouble _tmp82_;
#line 629 "../src/Connection.vala"
			_tmp75_ = connection_get_style (self);
#line 629 "../src/Connection.vala"
			_tmp76_ = _tmp75_;
#line 629 "../src/Connection.vala"
			_tmp77_ = style_get_connection_width (_tmp76_);
#line 629 "../src/Connection.vala"
			_tmp78_ = _tmp77_;
#line 629 "../src/Connection.vala"
			_tmp79_ = end_x;
#line 629 "../src/Connection.vala"
			_tmp80_ = end_y;
#line 629 "../src/Connection.vala"
			_tmp81_ = cx;
#line 629 "../src/Connection.vala"
			_tmp82_ = cy;
#line 629 "../src/Connection.vala"
			connection_draw_arrow (ctx, *_tmp78_, _tmp79_, _tmp80_, _tmp81_, _tmp82_, (gdouble) 0);
#line 4339 "Connection.c"
		}
#line 631 "../src/Connection.vala"
		_tmp84_ = connection_get_style (self);
#line 631 "../src/Connection.vala"
		_tmp85_ = _tmp84_;
#line 631 "../src/Connection.vala"
		_tmp86_ = style_get_connection_arrow (_tmp85_);
#line 631 "../src/Connection.vala"
		_tmp87_ = _tmp86_;
#line 631 "../src/Connection.vala"
		if (g_strcmp0 (_tmp87_, "tofrom") == 0) {
#line 631 "../src/Connection.vala"
			_tmp83_ = TRUE;
#line 4353 "Connection.c"
		} else {
			Style* _tmp88_;
			Style* _tmp89_;
			const gchar* _tmp90_;
			const gchar* _tmp91_;
#line 631 "../src/Connection.vala"
			_tmp88_ = connection_get_style (self);
#line 631 "../src/Connection.vala"
			_tmp89_ = _tmp88_;
#line 631 "../src/Connection.vala"
			_tmp90_ = style_get_connection_arrow (_tmp89_);
#line 631 "../src/Connection.vala"
			_tmp91_ = _tmp90_;
#line 631 "../src/Connection.vala"
			_tmp83_ = g_strcmp0 (_tmp91_, "both") == 0;
#line 4369 "Connection.c"
		}
#line 631 "../src/Connection.vala"
		if (_tmp83_) {
#line 4373 "Connection.c"
			Style* _tmp92_;
			Style* _tmp93_;
			gint* _tmp94_;
			gint* _tmp95_;
			gdouble _tmp96_;
			gdouble _tmp97_;
			gdouble _tmp98_;
			gdouble _tmp99_;
#line 632 "../src/Connection.vala"
			_tmp92_ = connection_get_style (self);
#line 632 "../src/Connection.vala"
			_tmp93_ = _tmp92_;
#line 632 "../src/Connection.vala"
			_tmp94_ = style_get_connection_width (_tmp93_);
#line 632 "../src/Connection.vala"
			_tmp95_ = _tmp94_;
#line 632 "../src/Connection.vala"
			_tmp96_ = start_x;
#line 632 "../src/Connection.vala"
			_tmp97_ = start_y;
#line 632 "../src/Connection.vala"
			_tmp98_ = cx;
#line 632 "../src/Connection.vala"
			_tmp99_ = cy;
#line 632 "../src/Connection.vala"
			connection_draw_arrow (ctx, *_tmp95_, _tmp96_, _tmp97_, _tmp98_, _tmp99_, (gdouble) 0);
#line 4400 "Connection.c"
		}
	}
#line 637 "../src/Connection.vala"
	_tmp101_ = connection_get_title (self);
#line 637 "../src/Connection.vala"
	_tmp102_ = _tmp101_;
#line 637 "../src/Connection.vala"
	if (_tmp102_ != NULL) {
#line 637 "../src/Connection.vala"
		_tmp100_ = TRUE;
#line 4411 "Connection.c"
	} else {
		const gchar* _tmp103_;
		const gchar* _tmp104_;
		gint _tmp105_;
		gint _tmp106_;
#line 637 "../src/Connection.vala"
		_tmp103_ = connection_get_note (self);
#line 637 "../src/Connection.vala"
		_tmp104_ = _tmp103_;
#line 637 "../src/Connection.vala"
		_tmp105_ = strlen (_tmp104_);
#line 637 "../src/Connection.vala"
		_tmp106_ = _tmp105_;
#line 637 "../src/Connection.vala"
		_tmp100_ = _tmp106_ > 0;
#line 4427 "Connection.c"
	}
#line 637 "../src/Connection.vala"
	if (_tmp100_) {
#line 639 "../src/Connection.vala"
		connection_draw_title (self, ctx, theme);
#line 4433 "Connection.c"
	} else {
		ConnMode _tmp107_;
		ConnMode _tmp108_;
#line 642 "../src/Connection.vala"
		_tmp107_ = connection_get_mode (self);
#line 642 "../src/Connection.vala"
		_tmp108_ = _tmp107_;
#line 642 "../src/Connection.vala"
		if (_tmp108_ != CONN_MODE_NONE) {
#line 4443 "Connection.c"
			GdkRGBA _tmp109_;
			gdouble _tmp110_;
			GdkRGBA _tmp111_;
			gdouble _tmp112_;
			GdkRGBA _tmp113_;
			gdouble _tmp114_;
			gdouble _tmp115_;
			gdouble _tmp116_;
			gdouble _tmp117_;
			gint _tmp118_;
			GdkRGBA _tmp119_;
			gdouble _tmp120_;
			GdkRGBA _tmp121_;
			gdouble _tmp122_;
			GdkRGBA _tmp123_;
			gdouble _tmp124_;
			gdouble _tmp125_;
#line 643 "../src/Connection.vala"
			cairo_set_line_width (ctx, (gdouble) 1);
#line 644 "../src/Connection.vala"
			_tmp109_ = bg;
#line 644 "../src/Connection.vala"
			_tmp110_ = _tmp109_.red;
#line 644 "../src/Connection.vala"
			_tmp111_ = bg;
#line 644 "../src/Connection.vala"
			_tmp112_ = _tmp111_.green;
#line 644 "../src/Connection.vala"
			_tmp113_ = bg;
#line 644 "../src/Connection.vala"
			_tmp114_ = _tmp113_.blue;
#line 644 "../src/Connection.vala"
			_tmp115_ = self->priv->_alpha;
#line 644 "../src/Connection.vala"
			cairo_set_source_rgba (ctx, _tmp110_, _tmp112_, _tmp114_, _tmp115_);
#line 645 "../src/Connection.vala"
			_tmp116_ = dragx;
#line 645 "../src/Connection.vala"
			_tmp117_ = dragy;
#line 645 "../src/Connection.vala"
			_tmp118_ = self->priv->RADIUS;
#line 645 "../src/Connection.vala"
			cairo_arc (ctx, _tmp116_, _tmp117_, (gdouble) _tmp118_, (gdouble) 0, 2 * G_PI);
#line 646 "../src/Connection.vala"
			cairo_fill_preserve (ctx);
#line 647 "../src/Connection.vala"
			_tmp119_ = self->priv->_color;
#line 647 "../src/Connection.vala"
			_tmp120_ = _tmp119_.red;
#line 647 "../src/Connection.vala"
			_tmp121_ = self->priv->_color;
#line 647 "../src/Connection.vala"
			_tmp122_ = _tmp121_.green;
#line 647 "../src/Connection.vala"
			_tmp123_ = self->priv->_color;
#line 647 "../src/Connection.vala"
			_tmp124_ = _tmp123_.blue;
#line 647 "../src/Connection.vala"
			_tmp125_ = self->priv->_alpha;
#line 647 "../src/Connection.vala"
			cairo_set_source_rgba (ctx, _tmp120_, _tmp122_, _tmp124_, _tmp125_);
#line 648 "../src/Connection.vala"
			cairo_stroke (ctx);
#line 4507 "Connection.c"
		}
	}
#line 652 "../src/Connection.vala"
	_tmp126_ = connection_get_mode (self);
#line 652 "../src/Connection.vala"
	_tmp127_ = _tmp126_;
#line 652 "../src/Connection.vala"
	if (_tmp127_ == CONN_MODE_SELECTED) {
#line 4516 "Connection.c"
		GdkRGBA _tmp128_;
		gdouble _tmp129_;
		GdkRGBA _tmp130_;
		gdouble _tmp131_;
		GdkRGBA _tmp132_;
		gdouble _tmp133_;
		gdouble _tmp134_;
		gdouble _tmp135_;
		gdouble _tmp136_;
		gint _tmp137_;
		GdkRGBA _tmp138_;
		gdouble _tmp139_;
		GdkRGBA _tmp140_;
		gdouble _tmp141_;
		GdkRGBA _tmp142_;
		gdouble _tmp143_;
		gdouble _tmp144_;
		GdkRGBA _tmp145_;
		gdouble _tmp146_;
		GdkRGBA _tmp147_;
		gdouble _tmp148_;
		GdkRGBA _tmp149_;
		gdouble _tmp150_;
		gdouble _tmp151_;
		gdouble _tmp152_;
		gdouble _tmp153_;
		gint _tmp154_;
		GdkRGBA _tmp155_;
		gdouble _tmp156_;
		GdkRGBA _tmp157_;
		gdouble _tmp158_;
		GdkRGBA _tmp159_;
		gdouble _tmp160_;
		gdouble _tmp161_;
#line 654 "../src/Connection.vala"
		_tmp128_ = bg;
#line 654 "../src/Connection.vala"
		_tmp129_ = _tmp128_.red;
#line 654 "../src/Connection.vala"
		_tmp130_ = bg;
#line 654 "../src/Connection.vala"
		_tmp131_ = _tmp130_.green;
#line 654 "../src/Connection.vala"
		_tmp132_ = bg;
#line 654 "../src/Connection.vala"
		_tmp133_ = _tmp132_.blue;
#line 654 "../src/Connection.vala"
		_tmp134_ = self->priv->_alpha;
#line 654 "../src/Connection.vala"
		cairo_set_source_rgba (ctx, _tmp129_, _tmp131_, _tmp133_, _tmp134_);
#line 655 "../src/Connection.vala"
		_tmp135_ = start_x;
#line 655 "../src/Connection.vala"
		_tmp136_ = start_y;
#line 655 "../src/Connection.vala"
		_tmp137_ = self->priv->RADIUS;
#line 655 "../src/Connection.vala"
		cairo_arc (ctx, _tmp135_, _tmp136_, (gdouble) _tmp137_, (gdouble) 0, 2 * G_PI);
#line 656 "../src/Connection.vala"
		cairo_fill_preserve (ctx);
#line 657 "../src/Connection.vala"
		_tmp138_ = self->priv->_color;
#line 657 "../src/Connection.vala"
		_tmp139_ = _tmp138_.red;
#line 657 "../src/Connection.vala"
		_tmp140_ = self->priv->_color;
#line 657 "../src/Connection.vala"
		_tmp141_ = _tmp140_.green;
#line 657 "../src/Connection.vala"
		_tmp142_ = self->priv->_color;
#line 657 "../src/Connection.vala"
		_tmp143_ = _tmp142_.blue;
#line 657 "../src/Connection.vala"
		_tmp144_ = self->priv->_alpha;
#line 657 "../src/Connection.vala"
		cairo_set_source_rgba (ctx, _tmp139_, _tmp141_, _tmp143_, _tmp144_);
#line 658 "../src/Connection.vala"
		cairo_stroke (ctx);
#line 660 "../src/Connection.vala"
		_tmp145_ = bg;
#line 660 "../src/Connection.vala"
		_tmp146_ = _tmp145_.red;
#line 660 "../src/Connection.vala"
		_tmp147_ = bg;
#line 660 "../src/Connection.vala"
		_tmp148_ = _tmp147_.green;
#line 660 "../src/Connection.vala"
		_tmp149_ = bg;
#line 660 "../src/Connection.vala"
		_tmp150_ = _tmp149_.blue;
#line 660 "../src/Connection.vala"
		_tmp151_ = self->priv->_alpha;
#line 660 "../src/Connection.vala"
		cairo_set_source_rgba (ctx, _tmp146_, _tmp148_, _tmp150_, _tmp151_);
#line 661 "../src/Connection.vala"
		_tmp152_ = end_x;
#line 661 "../src/Connection.vala"
		_tmp153_ = end_y;
#line 661 "../src/Connection.vala"
		_tmp154_ = self->priv->RADIUS;
#line 661 "../src/Connection.vala"
		cairo_arc (ctx, _tmp152_, _tmp153_, (gdouble) _tmp154_, (gdouble) 0, 2 * G_PI);
#line 662 "../src/Connection.vala"
		cairo_fill_preserve (ctx);
#line 663 "../src/Connection.vala"
		_tmp155_ = self->priv->_color;
#line 663 "../src/Connection.vala"
		_tmp156_ = _tmp155_.red;
#line 663 "../src/Connection.vala"
		_tmp157_ = self->priv->_color;
#line 663 "../src/Connection.vala"
		_tmp158_ = _tmp157_.green;
#line 663 "../src/Connection.vala"
		_tmp159_ = self->priv->_color;
#line 663 "../src/Connection.vala"
		_tmp160_ = _tmp159_.blue;
#line 663 "../src/Connection.vala"
		_tmp161_ = self->priv->_alpha;
#line 663 "../src/Connection.vala"
		cairo_set_source_rgba (ctx, _tmp156_, _tmp158_, _tmp160_, _tmp161_);
#line 664 "../src/Connection.vala"
		cairo_stroke (ctx);
#line 4639 "Connection.c"
	}
#line 668 "../src/Connection.vala"
	cairo_restore (ctx);
#line 573 "../src/Connection.vala"
	_g_free0 (_tmp21_);
#line 4645 "Connection.c"
}


void
connection_draw (Connection* self,
                 cairo_t* ctx,
                 Theme* theme)
{
#line 573 "../src/Connection.vala"
	g_return_if_fail (self != NULL);
#line 573 "../src/Connection.vala"
	CONNECTION_GET_CLASS (self)->draw (self, ctx, theme);
#line 4658 "Connection.c"
}


static void
connection_draw_title (Connection* self,
                       cairo_t* ctx,
                       Theme* theme)
{
	GdkRGBA* fg = NULL;
	GdkRGBA* _tmp0_;
	gint* _tmp1_ = NULL;
	Style* _tmp2_;
	gint* _tmp3_;
	gint* _tmp4_;
	gint* padding = NULL;
	gint* _tmp6_;
	gdouble x = 0.0;
	gdouble y = 0.0;
	gdouble w = 0.0;
	gdouble h = 0.0;
	gdouble _tmp7_ = 0.0;
	gdouble _tmp8_ = 0.0;
	gdouble _tmp9_ = 0.0;
	gdouble _tmp10_ = 0.0;
	GdkRGBA _tmp11_;
	gdouble _tmp12_;
	GdkRGBA _tmp13_;
	gdouble _tmp14_;
	GdkRGBA _tmp15_;
	gdouble _tmp16_;
	gdouble _tmp17_;
	gdouble _tmp18_;
	gint* _tmp19_;
	gdouble _tmp20_;
	gint* _tmp21_;
	gdouble _tmp22_;
	gint* _tmp23_;
	gdouble _tmp24_;
	gint* _tmp25_;
	gint* _tmp26_;
	CanvasText* _tmp27_;
	GdkRGBA* _tmp32_;
	GdkRGBA _tmp33_;
	gboolean _tmp34_ = FALSE;
	ConnMode _tmp35_;
	ConnMode _tmp36_;
#line 675 "../src/Connection.vala"
	g_return_if_fail (self != NULL);
#line 675 "../src/Connection.vala"
	g_return_if_fail (ctx != NULL);
#line 675 "../src/Connection.vala"
	g_return_if_fail (theme != NULL);
#line 677 "../src/Connection.vala"
	_tmp0_ = theme_get_color (theme, "background");
#line 677 "../src/Connection.vala"
	fg = _tmp0_;
#line 678 "../src/Connection.vala"
	_tmp2_ = self->priv->_style;
#line 678 "../src/Connection.vala"
	_tmp3_ = style_get_connection_padding (_tmp2_);
#line 678 "../src/Connection.vala"
	_tmp4_ = _tmp3_;
#line 678 "../src/Connection.vala"
	_tmp1_ = _tmp4_;
#line 678 "../src/Connection.vala"
	if (_tmp1_ == NULL) {
#line 4725 "Connection.c"
		gint _tmp5_;
#line 678 "../src/Connection.vala"
		_tmp5_ = 0;
#line 678 "../src/Connection.vala"
		_tmp1_ = &_tmp5_;
#line 4731 "Connection.c"
	}
#line 678 "../src/Connection.vala"
	_tmp6_ = __int_dup0 (_tmp1_);
#line 678 "../src/Connection.vala"
	padding = _tmp6_;
#line 682 "../src/Connection.vala"
	connection_title_bbox (self, &_tmp7_, &_tmp8_, &_tmp9_, &_tmp10_);
#line 682 "../src/Connection.vala"
	x = _tmp7_;
#line 682 "../src/Connection.vala"
	y = _tmp8_;
#line 682 "../src/Connection.vala"
	w = _tmp9_;
#line 682 "../src/Connection.vala"
	h = _tmp10_;
#line 685 "../src/Connection.vala"
	_tmp11_ = self->priv->_color;
#line 685 "../src/Connection.vala"
	_tmp12_ = _tmp11_.red;
#line 685 "../src/Connection.vala"
	_tmp13_ = self->priv->_color;
#line 685 "../src/Connection.vala"
	_tmp14_ = _tmp13_.green;
#line 685 "../src/Connection.vala"
	_tmp15_ = self->priv->_color;
#line 685 "../src/Connection.vala"
	_tmp16_ = _tmp15_.blue;
#line 685 "../src/Connection.vala"
	_tmp17_ = self->priv->_alpha;
#line 685 "../src/Connection.vala"
	cairo_set_source_rgba (ctx, _tmp12_, _tmp14_, _tmp16_, _tmp17_);
#line 686 "../src/Connection.vala"
	_tmp18_ = x;
#line 686 "../src/Connection.vala"
	_tmp19_ = padding;
#line 686 "../src/Connection.vala"
	_tmp20_ = y;
#line 686 "../src/Connection.vala"
	_tmp21_ = padding;
#line 686 "../src/Connection.vala"
	_tmp22_ = w;
#line 686 "../src/Connection.vala"
	_tmp23_ = padding;
#line 686 "../src/Connection.vala"
	_tmp24_ = h;
#line 686 "../src/Connection.vala"
	_tmp25_ = padding;
#line 686 "../src/Connection.vala"
	_tmp26_ = padding;
#line 686 "../src/Connection.vala"
	granite_drawing_utilities_cairo_rounded_rectangle (ctx, _tmp18_ - (*_tmp19_), _tmp20_ - (*_tmp21_), _tmp22_ + ((*_tmp23_) * 2), _tmp24_ + ((*_tmp25_) * 2), (gdouble) ((*_tmp26_) * 2));
#line 688 "../src/Connection.vala"
	cairo_fill (ctx);
#line 691 "../src/Connection.vala"
	_tmp27_ = self->priv->_title;
#line 691 "../src/Connection.vala"
	if (_tmp27_ != NULL) {
#line 4789 "Connection.c"
		CanvasText* _tmp28_;
		GdkRGBA* _tmp29_;
		gdouble _tmp30_;
		GdkRGBA _tmp31_;
#line 692 "../src/Connection.vala"
		_tmp28_ = self->priv->_title;
#line 692 "../src/Connection.vala"
		_tmp29_ = fg;
#line 692 "../src/Connection.vala"
		_tmp30_ = self->priv->_alpha;
#line 692 "../src/Connection.vala"
		_tmp31_ = *_tmp29_;
#line 692 "../src/Connection.vala"
		canvas_text_draw (_tmp28_, ctx, theme, &_tmp31_, _tmp30_);
#line 4804 "Connection.c"
	}
#line 696 "../src/Connection.vala"
	_tmp32_ = fg;
#line 696 "../src/Connection.vala"
	_tmp33_ = *_tmp32_;
#line 696 "../src/Connection.vala"
	connection_draw_note (self, ctx, &_tmp33_);
#line 699 "../src/Connection.vala"
	_tmp35_ = connection_get_mode (self);
#line 699 "../src/Connection.vala"
	_tmp36_ = _tmp35_;
#line 699 "../src/Connection.vala"
	if (_tmp36_ == CONN_MODE_SELECTED) {
#line 699 "../src/Connection.vala"
		_tmp34_ = TRUE;
#line 4820 "Connection.c"
	} else {
		ConnMode _tmp37_;
		ConnMode _tmp38_;
#line 699 "../src/Connection.vala"
		_tmp37_ = connection_get_mode (self);
#line 699 "../src/Connection.vala"
		_tmp38_ = _tmp37_;
#line 699 "../src/Connection.vala"
		_tmp34_ = _tmp38_ == CONN_MODE_ADJUSTING;
#line 4830 "Connection.c"
	}
#line 699 "../src/Connection.vala"
	if (_tmp34_) {
#line 4834 "Connection.c"
		GdkRGBA bg = {0};
		GdkRGBA* _tmp39_;
		GdkRGBA* _tmp40_;
		GdkRGBA _tmp41_;
		GdkRGBA _tmp42_;
		gdouble _tmp43_;
		GdkRGBA _tmp44_;
		gdouble _tmp45_;
		GdkRGBA _tmp46_;
		gdouble _tmp47_;
		gdouble _tmp48_;
		gdouble _tmp49_;
		gdouble _tmp50_;
		gdouble _tmp51_;
		gint* _tmp52_;
		gint _tmp53_;
		GdkRGBA _tmp54_;
		gdouble _tmp55_;
		GdkRGBA _tmp56_;
		gdouble _tmp57_;
		GdkRGBA _tmp58_;
		gdouble _tmp59_;
		gdouble _tmp60_;
#line 701 "../src/Connection.vala"
		_tmp39_ = theme_get_color (theme, "nodesel_background");
#line 701 "../src/Connection.vala"
		_tmp40_ = _tmp39_;
#line 701 "../src/Connection.vala"
		_tmp41_ = *_tmp40_;
#line 701 "../src/Connection.vala"
		_g_free0 (_tmp40_);
#line 701 "../src/Connection.vala"
		bg = _tmp41_;
#line 703 "../src/Connection.vala"
		cairo_set_line_width (ctx, (gdouble) 1);
#line 704 "../src/Connection.vala"
		_tmp42_ = bg;
#line 704 "../src/Connection.vala"
		_tmp43_ = _tmp42_.red;
#line 704 "../src/Connection.vala"
		_tmp44_ = bg;
#line 704 "../src/Connection.vala"
		_tmp45_ = _tmp44_.green;
#line 704 "../src/Connection.vala"
		_tmp46_ = bg;
#line 704 "../src/Connection.vala"
		_tmp47_ = _tmp46_.blue;
#line 704 "../src/Connection.vala"
		_tmp48_ = self->priv->_alpha;
#line 704 "../src/Connection.vala"
		cairo_set_source_rgba (ctx, _tmp43_, _tmp45_, _tmp47_, _tmp48_);
#line 705 "../src/Connection.vala"
		_tmp49_ = self->priv->_dragx;
#line 705 "../src/Connection.vala"
		_tmp50_ = self->priv->_dragy;
#line 705 "../src/Connection.vala"
		_tmp51_ = h;
#line 705 "../src/Connection.vala"
		_tmp52_ = padding;
#line 705 "../src/Connection.vala"
		_tmp53_ = self->priv->RADIUS;
#line 705 "../src/Connection.vala"
		cairo_arc (ctx, _tmp49_, (_tmp50_ + (_tmp51_ / 2)) + (*_tmp52_), (gdouble) _tmp53_, (gdouble) 0, 2 * G_PI);
#line 706 "../src/Connection.vala"
		cairo_fill_preserve (ctx);
#line 707 "../src/Connection.vala"
		_tmp54_ = self->priv->_color;
#line 707 "../src/Connection.vala"
		_tmp55_ = _tmp54_.red;
#line 707 "../src/Connection.vala"
		_tmp56_ = self->priv->_color;
#line 707 "../src/Connection.vala"
		_tmp57_ = _tmp56_.green;
#line 707 "../src/Connection.vala"
		_tmp58_ = self->priv->_color;
#line 707 "../src/Connection.vala"
		_tmp59_ = _tmp58_.blue;
#line 707 "../src/Connection.vala"
		_tmp60_ = self->priv->_alpha;
#line 707 "../src/Connection.vala"
		cairo_set_source_rgba (ctx, _tmp55_, _tmp57_, _tmp59_, _tmp60_);
#line 708 "../src/Connection.vala"
		cairo_stroke (ctx);
#line 4918 "Connection.c"
	}
#line 675 "../src/Connection.vala"
	_g_free0 (padding);
#line 675 "../src/Connection.vala"
	_g_free0 (fg);
#line 4924 "Connection.c"
}


static void
connection_draw_note (Connection* self,
                      cairo_t* ctx,
                      GdkRGBA* color)
{
	const gchar* _tmp0_;
	const gchar* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
#line 715 "../src/Connection.vala"
	g_return_if_fail (self != NULL);
#line 715 "../src/Connection.vala"
	g_return_if_fail (ctx != NULL);
#line 715 "../src/Connection.vala"
	g_return_if_fail (color != NULL);
#line 717 "../src/Connection.vala"
	_tmp0_ = connection_get_note (self);
#line 717 "../src/Connection.vala"
	_tmp1_ = _tmp0_;
#line 717 "../src/Connection.vala"
	_tmp2_ = strlen (_tmp1_);
#line 717 "../src/Connection.vala"
	_tmp3_ = _tmp2_;
#line 717 "../src/Connection.vala"
	if (_tmp3_ > 0) {
#line 4953 "Connection.c"
		gdouble x = 0.0;
		gdouble y = 0.0;
		gdouble w = 0.0;
		gdouble h = 0.0;
		gdouble _tmp4_ = 0.0;
		gdouble _tmp5_ = 0.0;
		gdouble _tmp6_ = 0.0;
		gdouble _tmp7_ = 0.0;
		GdkRGBA _tmp8_;
		gdouble _tmp9_;
		gdouble _tmp10_;
		gdouble _tmp11_;
		gdouble _tmp12_;
		gdouble _tmp13_;
		gdouble _tmp14_;
		gdouble _tmp15_;
		gdouble _tmp16_;
		gdouble _tmp17_;
		gdouble _tmp18_;
		gdouble _tmp19_;
		gdouble _tmp20_;
		gdouble _tmp21_;
		gdouble _tmp22_;
		gdouble _tmp23_;
		gdouble _tmp24_;
		gdouble _tmp25_;
#line 721 "../src/Connection.vala"
		connection_note_bbox (self, &_tmp4_, &_tmp5_, &_tmp6_, &_tmp7_);
#line 721 "../src/Connection.vala"
		x = _tmp4_;
#line 721 "../src/Connection.vala"
		y = _tmp5_;
#line 721 "../src/Connection.vala"
		w = _tmp6_;
#line 721 "../src/Connection.vala"
		h = _tmp7_;
#line 723 "../src/Connection.vala"
		_tmp8_ = *color;
#line 723 "../src/Connection.vala"
		_tmp9_ = self->priv->_alpha;
#line 723 "../src/Connection.vala"
		utils_set_context_color_with_alpha (ctx, &_tmp8_, _tmp9_);
#line 724 "../src/Connection.vala"
		cairo_new_path (ctx);
#line 725 "../src/Connection.vala"
		cairo_set_line_width (ctx, (gdouble) 1);
#line 726 "../src/Connection.vala"
		_tmp10_ = x;
#line 726 "../src/Connection.vala"
		_tmp11_ = y;
#line 726 "../src/Connection.vala"
		cairo_move_to (ctx, _tmp10_ + 2, _tmp11_);
#line 727 "../src/Connection.vala"
		_tmp12_ = x;
#line 727 "../src/Connection.vala"
		_tmp13_ = y;
#line 727 "../src/Connection.vala"
		cairo_line_to (ctx, _tmp12_ + 10, _tmp13_);
#line 728 "../src/Connection.vala"
		cairo_stroke (ctx);
#line 729 "../src/Connection.vala"
		_tmp14_ = x;
#line 729 "../src/Connection.vala"
		_tmp15_ = y;
#line 729 "../src/Connection.vala"
		cairo_move_to (ctx, _tmp14_, _tmp15_ + 3);
#line 730 "../src/Connection.vala"
		_tmp16_ = x;
#line 730 "../src/Connection.vala"
		_tmp17_ = y;
#line 730 "../src/Connection.vala"
		cairo_line_to (ctx, _tmp16_ + 10, _tmp17_ + 3);
#line 731 "../src/Connection.vala"
		cairo_stroke (ctx);
#line 732 "../src/Connection.vala"
		_tmp18_ = x;
#line 732 "../src/Connection.vala"
		_tmp19_ = y;
#line 732 "../src/Connection.vala"
		cairo_move_to (ctx, _tmp18_, _tmp19_ + 6);
#line 733 "../src/Connection.vala"
		_tmp20_ = x;
#line 733 "../src/Connection.vala"
		_tmp21_ = y;
#line 733 "../src/Connection.vala"
		cairo_line_to (ctx, _tmp20_ + 10, _tmp21_ + 6);
#line 734 "../src/Connection.vala"
		cairo_stroke (ctx);
#line 735 "../src/Connection.vala"
		_tmp22_ = x;
#line 735 "../src/Connection.vala"
		_tmp23_ = y;
#line 735 "../src/Connection.vala"
		cairo_move_to (ctx, _tmp22_, _tmp23_ + 9);
#line 736 "../src/Connection.vala"
		_tmp24_ = x;
#line 736 "../src/Connection.vala"
		_tmp25_ = y;
#line 736 "../src/Connection.vala"
		cairo_line_to (ctx, _tmp24_ + 10, _tmp25_ + 9);
#line 737 "../src/Connection.vala"
		cairo_stroke (ctx);
#line 5056 "Connection.c"
	}
}


void
connection_draw_arrow (cairo_t* ctx,
                       gint line_width,
                       gdouble tipx,
                       gdouble tipy,
                       gdouble tailx,
                       gdouble taily,
                       gdouble arrowLength)
{
	gdouble extlen[8] = {0};
	gdouble _tmp0_[8] = {0};
	gdouble dx = 0.0;
	gdouble dy = 0.0;
	gdouble theta = 0.0;
	gdouble rad = 0.0;
	gdouble x1 = 0.0;
	gdouble y1 = 0.0;
	gdouble phi2 = 0.0;
	gdouble x2 = 0.0;
	gdouble y2 = 0.0;
#line 747 "../src/Connection.vala"
	g_return_if_fail (ctx != NULL);
#line 749 "../src/Connection.vala"
	_tmp0_[0] = (gdouble) 12;
#line 749 "../src/Connection.vala"
	_tmp0_[1] = (gdouble) 13;
#line 749 "../src/Connection.vala"
	_tmp0_[2] = (gdouble) 14;
#line 749 "../src/Connection.vala"
	_tmp0_[3] = (gdouble) 15;
#line 749 "../src/Connection.vala"
	_tmp0_[4] = (gdouble) 16;
#line 749 "../src/Connection.vala"
	_tmp0_[5] = (gdouble) 17;
#line 749 "../src/Connection.vala"
	_tmp0_[6] = (gdouble) 18;
#line 749 "../src/Connection.vala"
	_tmp0_[7] = (gdouble) 18;
#line 749 "../src/Connection.vala"
	memcpy (extlen, _tmp0_, 8 * sizeof (gdouble));
#line 751 "../src/Connection.vala"
	if (arrowLength == ((gdouble) 0)) {
#line 5103 "Connection.c"
		gdouble _tmp1_;
#line 752 "../src/Connection.vala"
		_tmp1_ = extlen[line_width - 1];
#line 752 "../src/Connection.vala"
		arrowLength = _tmp1_;
#line 5109 "Connection.c"
	}
#line 755 "../src/Connection.vala"
	dx = tipx - tailx;
#line 756 "../src/Connection.vala"
	dy = tipy - taily;
#line 758 "../src/Connection.vala"
	theta = atan2 (dy, dx);
#line 760 "../src/Connection.vala"
	rad = 35 * (G_PI / 180);
#line 761 "../src/Connection.vala"
	x1 = tipx - (arrowLength * cos (theta + rad));
#line 762 "../src/Connection.vala"
	y1 = tipy - (arrowLength * sin (theta + rad));
#line 764 "../src/Connection.vala"
	phi2 = -35 * (G_PI / 180);
#line 765 "../src/Connection.vala"
	x2 = tipx - (arrowLength * cos (theta + phi2));
#line 766 "../src/Connection.vala"
	y2 = tipy - (arrowLength * sin (theta + phi2));
#line 769 "../src/Connection.vala"
	cairo_set_line_width (ctx, (gdouble) 1);
#line 770 "../src/Connection.vala"
	cairo_move_to (ctx, tipx, tipy);
#line 771 "../src/Connection.vala"
	cairo_line_to (ctx, x1, y1);
#line 772 "../src/Connection.vala"
	cairo_line_to (ctx, x2, y2);
#line 773 "../src/Connection.vala"
	cairo_close_path (ctx);
#line 774 "../src/Connection.vala"
	cairo_fill (ctx);
#line 5141 "Connection.c"
}


cairo_surface_t*
connection_make_arrow_icon (const gchar* type)
{
	cairo_surface_t* result = NULL;
	cairo_surface_t* surface = NULL;
	cairo_surface_t* _tmp0_;
	cairo_t* ctx = NULL;
	cairo_surface_t* _tmp1_;
	cairo_t* _tmp2_;
	cairo_t* _tmp3_;
	cairo_t* _tmp4_;
	cairo_t* _tmp5_;
	cairo_t* _tmp6_;
	cairo_t* _tmp7_;
	cairo_t* _tmp8_;
	gboolean _tmp9_ = FALSE;
	gboolean _tmp11_ = FALSE;
#line 779 "../src/Connection.vala"
	g_return_val_if_fail (type != NULL, NULL);
#line 781 "../src/Connection.vala"
	_tmp0_ = cairo_image_surface_create (CAIRO_FORMAT_ARGB32, 100, 20);
#line 781 "../src/Connection.vala"
	surface = _tmp0_;
#line 782 "../src/Connection.vala"
	_tmp1_ = surface;
#line 782 "../src/Connection.vala"
	_tmp2_ = cairo_create (_tmp1_);
#line 782 "../src/Connection.vala"
	ctx = _tmp2_;
#line 784 "../src/Connection.vala"
	_tmp3_ = ctx;
#line 784 "../src/Connection.vala"
	cairo_set_source_rgba (_tmp3_, 0.5, 0.5, 0.5, (gdouble) 1);
#line 785 "../src/Connection.vala"
	_tmp4_ = ctx;
#line 785 "../src/Connection.vala"
	cairo_set_line_width (_tmp4_, (gdouble) 4);
#line 786 "../src/Connection.vala"
	_tmp5_ = ctx;
#line 786 "../src/Connection.vala"
	cairo_set_line_cap (_tmp5_, CAIRO_LINE_CAP_ROUND);
#line 787 "../src/Connection.vala"
	_tmp6_ = ctx;
#line 787 "../src/Connection.vala"
	cairo_move_to (_tmp6_, (gdouble) 15, (gdouble) 10);
#line 788 "../src/Connection.vala"
	_tmp7_ = ctx;
#line 788 "../src/Connection.vala"
	cairo_line_to (_tmp7_, (gdouble) 85, (gdouble) 10);
#line 789 "../src/Connection.vala"
	_tmp8_ = ctx;
#line 789 "../src/Connection.vala"
	cairo_stroke (_tmp8_);
#line 791 "../src/Connection.vala"
	if (g_strcmp0 (type, "fromto") == 0) {
#line 791 "../src/Connection.vala"
		_tmp9_ = TRUE;
#line 5202 "Connection.c"
	} else {
#line 791 "../src/Connection.vala"
		_tmp9_ = g_strcmp0 (type, "both") == 0;
#line 5206 "Connection.c"
	}
#line 791 "../src/Connection.vala"
	if (_tmp9_) {
#line 5210 "Connection.c"
		cairo_t* _tmp10_;
#line 792 "../src/Connection.vala"
		_tmp10_ = ctx;
#line 792 "../src/Connection.vala"
		connection_draw_arrow (_tmp10_, 4, (gdouble) 90, (gdouble) 10, (gdouble) 10, (gdouble) 10, (gdouble) 0);
#line 5216 "Connection.c"
	}
#line 794 "../src/Connection.vala"
	if (g_strcmp0 (type, "tofrom") == 0) {
#line 794 "../src/Connection.vala"
		_tmp11_ = TRUE;
#line 5222 "Connection.c"
	} else {
#line 794 "../src/Connection.vala"
		_tmp11_ = g_strcmp0 (type, "both") == 0;
#line 5226 "Connection.c"
	}
#line 794 "../src/Connection.vala"
	if (_tmp11_) {
#line 5230 "Connection.c"
		cairo_t* _tmp12_;
#line 795 "../src/Connection.vala"
		_tmp12_ = ctx;
#line 795 "../src/Connection.vala"
		connection_draw_arrow (_tmp12_, 4, (gdouble) 10, (gdouble) 10, (gdouble) 90, (gdouble) 10, (gdouble) 0);
#line 5236 "Connection.c"
	}
#line 798 "../src/Connection.vala"
	result = surface;
#line 798 "../src/Connection.vala"
	_cairo_destroy0 (ctx);
#line 798 "../src/Connection.vala"
	return result;
#line 5244 "Connection.c"
}


CanvasText*
connection_get_title (Connection* self)
{
	CanvasText* result;
	CanvasText* _tmp0_;
#line 55 "../src/Connection.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 56 "../src/Connection.vala"
	_tmp0_ = self->priv->_title;
#line 56 "../src/Connection.vala"
	result = _tmp0_;
#line 56 "../src/Connection.vala"
	return result;
#line 5261 "Connection.c"
}


const gchar*
connection_get_note (Connection* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 60 "../src/Connection.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 61 "../src/Connection.vala"
	_tmp0_ = self->priv->_note;
#line 61 "../src/Connection.vala"
	result = _tmp0_;
#line 61 "../src/Connection.vala"
	return result;
#line 5278 "Connection.c"
}


void
connection_set_note (Connection* self,
                     const gchar* value)
{
	gboolean was_empty = FALSE;
	const gchar* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	gchar* _tmp3_;
	gboolean _tmp4_;
	const gchar* _tmp5_;
	gint _tmp6_;
	gint _tmp7_;
#line 63 "../src/Connection.vala"
	g_return_if_fail (self != NULL);
#line 64 "../src/Connection.vala"
	_tmp0_ = self->priv->_note;
#line 64 "../src/Connection.vala"
	_tmp1_ = strlen (_tmp0_);
#line 64 "../src/Connection.vala"
	_tmp2_ = _tmp1_;
#line 64 "../src/Connection.vala"
	was_empty = _tmp2_ == 0;
#line 65 "../src/Connection.vala"
	_tmp3_ = g_strdup (value);
#line 65 "../src/Connection.vala"
	_g_free0 (self->priv->_note);
#line 65 "../src/Connection.vala"
	self->priv->_note = _tmp3_;
#line 66 "../src/Connection.vala"
	_tmp4_ = was_empty;
#line 66 "../src/Connection.vala"
	_tmp5_ = self->priv->_note;
#line 66 "../src/Connection.vala"
	_tmp6_ = strlen (_tmp5_);
#line 66 "../src/Connection.vala"
	_tmp7_ = _tmp6_;
#line 66 "../src/Connection.vala"
	if (_tmp4_ != (_tmp7_ == 0)) {
#line 67 "../src/Connection.vala"
		connection_position_title (self);
#line 5323 "Connection.c"
	}
#line 63 "../src/Connection.vala"
	g_object_notify_by_pspec ((GObject *) self, connection_properties[CONNECTION_NOTE_PROPERTY]);
#line 5327 "Connection.c"
}


ConnMode
connection_get_mode (Connection* self)
{
	ConnMode result;
	ConnMode _tmp0_;
#line 72 "../src/Connection.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 73 "../src/Connection.vala"
	_tmp0_ = self->priv->_mode;
#line 73 "../src/Connection.vala"
	result = _tmp0_;
#line 73 "../src/Connection.vala"
	return result;
#line 5344 "Connection.c"
}


void
connection_set_mode (Connection* self,
                     ConnMode value)
{
	ConnMode _tmp0_;
#line 75 "../src/Connection.vala"
	g_return_if_fail (self != NULL);
#line 76 "../src/Connection.vala"
	_tmp0_ = self->priv->_mode;
#line 76 "../src/Connection.vala"
	if (_tmp0_ != value) {
#line 5359 "Connection.c"
		ConnMode _tmp1_;
#line 77 "../src/Connection.vala"
		self->priv->_mode = value;
#line 78 "../src/Connection.vala"
		_tmp1_ = self->priv->_mode;
#line 78 "../src/Connection.vala"
		if (_tmp1_ == CONN_MODE_EDITABLE) {
#line 5367 "Connection.c"
			CanvasText* _tmp2_;
#line 79 "../src/Connection.vala"
			_tmp2_ = self->priv->_title;
#line 79 "../src/Connection.vala"
			if (_tmp2_ != NULL) {
#line 5373 "Connection.c"
				CanvasText* _tmp3_;
				CanvasText* _tmp4_;
#line 80 "../src/Connection.vala"
				_tmp3_ = self->priv->_title;
#line 80 "../src/Connection.vala"
				canvas_text_set_edit (_tmp3_, TRUE);
#line 81 "../src/Connection.vala"
				_tmp4_ = self->priv->_title;
#line 81 "../src/Connection.vala"
				canvas_text_set_cursor_all (_tmp4_, FALSE);
#line 5384 "Connection.c"
			}
		} else {
			CanvasText* _tmp5_;
#line 84 "../src/Connection.vala"
			_tmp5_ = self->priv->_title;
#line 84 "../src/Connection.vala"
			if (_tmp5_ != NULL) {
#line 5392 "Connection.c"
				CanvasText* _tmp6_;
				CanvasText* _tmp7_;
#line 85 "../src/Connection.vala"
				_tmp6_ = self->priv->_title;
#line 85 "../src/Connection.vala"
				canvas_text_set_edit (_tmp6_, FALSE);
#line 86 "../src/Connection.vala"
				_tmp7_ = self->priv->_title;
#line 86 "../src/Connection.vala"
				canvas_text_clear_selection (_tmp7_);
#line 5403 "Connection.c"
			}
		}
	}
#line 75 "../src/Connection.vala"
	g_object_notify_by_pspec ((GObject *) self, connection_properties[CONNECTION_MODE_PROPERTY]);
#line 5409 "Connection.c"
}


Node*
connection_get_from_node (Connection* self)
{
	Node* result;
	Node* _tmp0_;
#line 93 "../src/Connection.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 94 "../src/Connection.vala"
	_tmp0_ = self->priv->_from_node;
#line 94 "../src/Connection.vala"
	result = _tmp0_;
#line 94 "../src/Connection.vala"
	return result;
#line 5426 "Connection.c"
}


void
connection_set_from_node (Connection* self,
                          Node* value)
{
	Node* _tmp0_;
#line 96 "../src/Connection.vala"
	g_return_if_fail (self != NULL);
#line 97 "../src/Connection.vala"
	_tmp0_ = _g_object_ref0 (value);
#line 97 "../src/Connection.vala"
	_g_object_unref0 (self->priv->_from_node);
#line 97 "../src/Connection.vala"
	self->priv->_from_node = _tmp0_;
#line 96 "../src/Connection.vala"
	g_object_notify_by_pspec ((GObject *) self, connection_properties[CONNECTION_FROM_NODE_PROPERTY]);
#line 5445 "Connection.c"
}


Node*
connection_get_to_node (Connection* self)
{
	Node* result;
	Node* _tmp0_;
#line 101 "../src/Connection.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 102 "../src/Connection.vala"
	_tmp0_ = self->priv->_to_node;
#line 102 "../src/Connection.vala"
	result = _tmp0_;
#line 102 "../src/Connection.vala"
	return result;
#line 5462 "Connection.c"
}


void
connection_set_to_node (Connection* self,
                        Node* value)
{
	Node* _tmp0_;
#line 104 "../src/Connection.vala"
	g_return_if_fail (self != NULL);
#line 105 "../src/Connection.vala"
	_tmp0_ = _g_object_ref0 (value);
#line 105 "../src/Connection.vala"
	_g_object_unref0 (self->priv->_to_node);
#line 105 "../src/Connection.vala"
	self->priv->_to_node = _tmp0_;
#line 104 "../src/Connection.vala"
	g_object_notify_by_pspec ((GObject *) self, connection_properties[CONNECTION_TO_NODE_PROPERTY]);
#line 5481 "Connection.c"
}


Style*
connection_get_style (Connection* self)
{
	Style* result;
	Style* _tmp0_;
#line 109 "../src/Connection.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 110 "../src/Connection.vala"
	_tmp0_ = self->priv->_style;
#line 110 "../src/Connection.vala"
	result = _tmp0_;
#line 110 "../src/Connection.vala"
	return result;
#line 5498 "Connection.c"
}


void
connection_set_style (Connection* self,
                      Style* value)
{
	gboolean _tmp0_ = FALSE;
	Style* _tmp1_;
#line 112 "../src/Connection.vala"
	g_return_if_fail (self != NULL);
#line 113 "../src/Connection.vala"
	_tmp1_ = self->priv->_style;
#line 113 "../src/Connection.vala"
	if (style_copy (_tmp1_, value)) {
#line 5514 "Connection.c"
		CanvasText* _tmp2_;
#line 113 "../src/Connection.vala"
		_tmp2_ = self->priv->_title;
#line 113 "../src/Connection.vala"
		_tmp0_ = _tmp2_ != NULL;
#line 5520 "Connection.c"
	} else {
#line 113 "../src/Connection.vala"
		_tmp0_ = FALSE;
#line 5524 "Connection.c"
	}
#line 113 "../src/Connection.vala"
	if (_tmp0_) {
#line 5528 "Connection.c"
		CanvasText* _tmp3_;
		Style* _tmp4_;
		PangoFontDescription* _tmp5_;
		PangoFontDescription* _tmp6_;
#line 114 "../src/Connection.vala"
		_tmp3_ = self->priv->_title;
#line 114 "../src/Connection.vala"
		_tmp4_ = self->priv->_style;
#line 114 "../src/Connection.vala"
		_tmp5_ = style_get_connection_font (_tmp4_);
#line 114 "../src/Connection.vala"
		_tmp6_ = _tmp5_;
#line 114 "../src/Connection.vala"
		canvas_text_set_font (_tmp3_, _tmp6_);
#line 115 "../src/Connection.vala"
		connection_position_title (self);
#line 5545 "Connection.c"
	}
#line 112 "../src/Connection.vala"
	g_object_notify_by_pspec ((GObject *) self, connection_properties[CONNECTION_STYLE_PROPERTY]);
#line 5549 "Connection.c"
}


gdouble
connection_get_alpha (Connection* self)
{
	gdouble result;
	gdouble _tmp0_;
#line 119 "../src/Connection.vala"
	g_return_val_if_fail (self != NULL, 0.0);
#line 119 "../src/Connection.vala"
	_tmp0_ = self->priv->_alpha;
#line 119 "../src/Connection.vala"
	result = _tmp0_;
#line 119 "../src/Connection.vala"
	return result;
#line 5566 "Connection.c"
}


void
connection_set_alpha (Connection* self,
                      gdouble value)
{
#line 119 "../src/Connection.vala"
	g_return_if_fail (self != NULL);
#line 119 "../src/Connection.vala"
	if (connection_get_alpha (self) != value) {
#line 119 "../src/Connection.vala"
		self->priv->_alpha = value;
#line 119 "../src/Connection.vala"
		g_object_notify_by_pspec ((GObject *) self, connection_properties[CONNECTION_ALPHA_PROPERTY]);
#line 5582 "Connection.c"
	}
}


void
connection_get_color (Connection* self,
                      GdkRGBA * result)
{
	GdkRGBA _tmp0_;
#line 120 "../src/Connection.vala"
	g_return_if_fail (self != NULL);
#line 120 "../src/Connection.vala"
	_tmp0_ = self->priv->_color;
#line 120 "../src/Connection.vala"
	*result = _tmp0_;
#line 120 "../src/Connection.vala"
	return;
#line 5600 "Connection.c"
}


static gboolean
_gdk_rgba_equal (const GdkRGBA * s1,
                 const GdkRGBA * s2)
{
#line 120 "../src/Connection.vala"
	if (s1 == s2) {
#line 120 "../src/Connection.vala"
		return TRUE;
#line 5612 "Connection.c"
	}
#line 120 "../src/Connection.vala"
	if (s1 == NULL) {
#line 120 "../src/Connection.vala"
		return FALSE;
#line 5618 "Connection.c"
	}
#line 120 "../src/Connection.vala"
	if (s2 == NULL) {
#line 120 "../src/Connection.vala"
		return FALSE;
#line 5624 "Connection.c"
	}
#line 120 "../src/Connection.vala"
	if (s1->red != s2->red) {
#line 120 "../src/Connection.vala"
		return FALSE;
#line 5630 "Connection.c"
	}
#line 120 "../src/Connection.vala"
	if (s1->green != s2->green) {
#line 120 "../src/Connection.vala"
		return FALSE;
#line 5636 "Connection.c"
	}
#line 120 "../src/Connection.vala"
	if (s1->blue != s2->blue) {
#line 120 "../src/Connection.vala"
		return FALSE;
#line 5642 "Connection.c"
	}
#line 120 "../src/Connection.vala"
	if (s1->alpha != s2->alpha) {
#line 120 "../src/Connection.vala"
		return FALSE;
#line 5648 "Connection.c"
	}
#line 120 "../src/Connection.vala"
	return TRUE;
#line 5652 "Connection.c"
}


void
connection_set_color (Connection* self,
                      GdkRGBA * value)
{
	GdkRGBA old_value;
#line 120 "../src/Connection.vala"
	g_return_if_fail (self != NULL);
#line 120 "../src/Connection.vala"
	if (_gdk_rgba_equal (value, (connection_get_color (self, &old_value), &old_value)) != TRUE) {
#line 5665 "Connection.c"
		GdkRGBA _tmp0_;
#line 120 "../src/Connection.vala"
		_tmp0_ = *value;
#line 120 "../src/Connection.vala"
		self->priv->_color = _tmp0_;
#line 120 "../src/Connection.vala"
		g_object_notify_by_pspec ((GObject *) self, connection_properties[CONNECTION_COLOR_PROPERTY]);
#line 5673 "Connection.c"
	}
}


static void
connection_class_init (ConnectionClass * klass)
{
#line 38 "../src/Connection.vala"
	connection_parent_class = g_type_class_peek_parent (klass);
#line 38 "../src/Connection.vala"
	g_type_class_adjust_private_offset (klass, &Connection_private_offset);
#line 38 "../src/Connection.vala"
	((ConnectionClass *) klass)->draw = (void (*) (Connection*, cairo_t*, Theme*)) connection_real_draw;
#line 38 "../src/Connection.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_connection_get_property;
#line 38 "../src/Connection.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_connection_set_property;
#line 38 "../src/Connection.vala"
	G_OBJECT_CLASS (klass)->finalize = connection_finalize;
#line 38 "../src/Connection.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CONNECTION_TITLE_PROPERTY, connection_properties[CONNECTION_TITLE_PROPERTY] = g_param_spec_object ("title", "title", "title", TYPE_CANVAS_TEXT, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 38 "../src/Connection.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CONNECTION_NOTE_PROPERTY, connection_properties[CONNECTION_NOTE_PROPERTY] = g_param_spec_string ("note", "note", "note", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 38 "../src/Connection.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CONNECTION_MODE_PROPERTY, connection_properties[CONNECTION_MODE_PROPERTY] = g_param_spec_enum ("mode", "mode", "mode", TYPE_CONN_MODE, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 38 "../src/Connection.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CONNECTION_FROM_NODE_PROPERTY, connection_properties[CONNECTION_FROM_NODE_PROPERTY] = g_param_spec_object ("from-node", "from-node", "from-node", TYPE_NODE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 38 "../src/Connection.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CONNECTION_TO_NODE_PROPERTY, connection_properties[CONNECTION_TO_NODE_PROPERTY] = g_param_spec_object ("to-node", "to-node", "to-node", TYPE_NODE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 38 "../src/Connection.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CONNECTION_STYLE_PROPERTY, connection_properties[CONNECTION_STYLE_PROPERTY] = param_spec_style ("style", "style", "style", TYPE_STYLE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 38 "../src/Connection.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CONNECTION_ALPHA_PROPERTY, connection_properties[CONNECTION_ALPHA_PROPERTY] = g_param_spec_double ("alpha", "alpha", "alpha", -G_MAXDOUBLE, G_MAXDOUBLE, 1.0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 38 "../src/Connection.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CONNECTION_COLOR_PROPERTY, connection_properties[CONNECTION_COLOR_PROPERTY] = g_param_spec_boxed ("color", "color", "color", gdk_rgba_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 5709 "Connection.c"
}


static void
connection_instance_init (Connection * self)
{
	Style* _tmp0_;
	gchar* _tmp1_;
#line 38 "../src/Connection.vala"
	self->priv = connection_get_instance_private (self);
#line 40 "../src/Connection.vala"
	self->priv->RADIUS = 6;
#line 41 "../src/Connection.vala"
	self->priv->_mode = CONN_MODE_NONE;
#line 42 "../src/Connection.vala"
	self->priv->_from_node = NULL;
#line 43 "../src/Connection.vala"
	self->priv->_to_node = NULL;
#line 48 "../src/Connection.vala"
	_tmp0_ = style_new ();
#line 48 "../src/Connection.vala"
	self->priv->_style = _tmp0_;
#line 50 "../src/Connection.vala"
	self->priv->_title = NULL;
#line 51 "../src/Connection.vala"
	_tmp1_ = g_strdup ("");
#line 51 "../src/Connection.vala"
	self->priv->_note = _tmp1_;
#line 52 "../src/Connection.vala"
	self->priv->_max_width = (gdouble) 100;
#line 119 "../src/Connection.vala"
	self->priv->_alpha = 1.0;
#line 5742 "Connection.c"
}


static void
connection_finalize (GObject * obj)
{
	Connection * self;
#line 38 "../src/Connection.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CONNECTION, Connection);
#line 42 "../src/Connection.vala"
	_g_object_unref0 (self->priv->_from_node);
#line 43 "../src/Connection.vala"
	_g_object_unref0 (self->priv->_to_node);
#line 48 "../src/Connection.vala"
	_style_unref0 (self->priv->_style);
#line 49 "../src/Connection.vala"
	_bezier_unref0 (self->priv->_curve);
#line 50 "../src/Connection.vala"
	_g_object_unref0 (self->priv->_title);
#line 51 "../src/Connection.vala"
	_g_free0 (self->priv->_note);
#line 38 "../src/Connection.vala"
	G_OBJECT_CLASS (connection_parent_class)->finalize (obj);
#line 5766 "Connection.c"
}


GType
connection_get_type (void)
{
	static volatile gsize connection_type_id__volatile = 0;
	if (g_once_init_enter (&connection_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ConnectionClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) connection_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Connection), 0, (GInstanceInitFunc) connection_instance_init, NULL };
		GType connection_type_id;
		connection_type_id = g_type_register_static (G_TYPE_OBJECT, "Connection", &g_define_type_info, 0);
		Connection_private_offset = g_type_add_instance_private (connection_type_id, sizeof (ConnectionPrivate));
		g_once_init_leave (&connection_type_id__volatile, connection_type_id);
	}
	return connection_type_id__volatile;
}


static void
_vala_connection_get_property (GObject * object,
                               guint property_id,
                               GValue * value,
                               GParamSpec * pspec)
{
	Connection * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CONNECTION, Connection);
#line 38 "../src/Connection.vala"
	switch (property_id) {
#line 38 "../src/Connection.vala"
		case CONNECTION_TITLE_PROPERTY:
#line 38 "../src/Connection.vala"
		g_value_set_object (value, connection_get_title (self));
#line 38 "../src/Connection.vala"
		break;
#line 38 "../src/Connection.vala"
		case CONNECTION_NOTE_PROPERTY:
#line 38 "../src/Connection.vala"
		g_value_set_string (value, connection_get_note (self));
#line 38 "../src/Connection.vala"
		break;
#line 38 "../src/Connection.vala"
		case CONNECTION_MODE_PROPERTY:
#line 38 "../src/Connection.vala"
		g_value_set_enum (value, connection_get_mode (self));
#line 38 "../src/Connection.vala"
		break;
#line 38 "../src/Connection.vala"
		case CONNECTION_FROM_NODE_PROPERTY:
#line 38 "../src/Connection.vala"
		g_value_set_object (value, connection_get_from_node (self));
#line 38 "../src/Connection.vala"
		break;
#line 38 "../src/Connection.vala"
		case CONNECTION_TO_NODE_PROPERTY:
#line 38 "../src/Connection.vala"
		g_value_set_object (value, connection_get_to_node (self));
#line 38 "../src/Connection.vala"
		break;
#line 38 "../src/Connection.vala"
		case CONNECTION_STYLE_PROPERTY:
#line 38 "../src/Connection.vala"
		value_set_style (value, connection_get_style (self));
#line 38 "../src/Connection.vala"
		break;
#line 38 "../src/Connection.vala"
		case CONNECTION_ALPHA_PROPERTY:
#line 38 "../src/Connection.vala"
		g_value_set_double (value, connection_get_alpha (self));
#line 38 "../src/Connection.vala"
		break;
#line 38 "../src/Connection.vala"
		case CONNECTION_COLOR_PROPERTY:
#line 5839 "Connection.c"
		{
			GdkRGBA boxed;
#line 38 "../src/Connection.vala"
			connection_get_color (self, &boxed);
#line 38 "../src/Connection.vala"
			g_value_set_boxed (value, &boxed);
#line 5846 "Connection.c"
		}
#line 38 "../src/Connection.vala"
		break;
#line 5850 "Connection.c"
		default:
#line 38 "../src/Connection.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 38 "../src/Connection.vala"
		break;
#line 5856 "Connection.c"
	}
}


static void
_vala_connection_set_property (GObject * object,
                               guint property_id,
                               const GValue * value,
                               GParamSpec * pspec)
{
	Connection * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CONNECTION, Connection);
#line 38 "../src/Connection.vala"
	switch (property_id) {
#line 38 "../src/Connection.vala"
		case CONNECTION_NOTE_PROPERTY:
#line 38 "../src/Connection.vala"
		connection_set_note (self, g_value_get_string (value));
#line 38 "../src/Connection.vala"
		break;
#line 38 "../src/Connection.vala"
		case CONNECTION_MODE_PROPERTY:
#line 38 "../src/Connection.vala"
		connection_set_mode (self, g_value_get_enum (value));
#line 38 "../src/Connection.vala"
		break;
#line 38 "../src/Connection.vala"
		case CONNECTION_FROM_NODE_PROPERTY:
#line 38 "../src/Connection.vala"
		connection_set_from_node (self, g_value_get_object (value));
#line 38 "../src/Connection.vala"
		break;
#line 38 "../src/Connection.vala"
		case CONNECTION_TO_NODE_PROPERTY:
#line 38 "../src/Connection.vala"
		connection_set_to_node (self, g_value_get_object (value));
#line 38 "../src/Connection.vala"
		break;
#line 38 "../src/Connection.vala"
		case CONNECTION_STYLE_PROPERTY:
#line 38 "../src/Connection.vala"
		connection_set_style (self, value_get_style (value));
#line 38 "../src/Connection.vala"
		break;
#line 38 "../src/Connection.vala"
		case CONNECTION_ALPHA_PROPERTY:
#line 38 "../src/Connection.vala"
		connection_set_alpha (self, g_value_get_double (value));
#line 38 "../src/Connection.vala"
		break;
#line 38 "../src/Connection.vala"
		case CONNECTION_COLOR_PROPERTY:
#line 38 "../src/Connection.vala"
		connection_set_color (self, g_value_get_boxed (value));
#line 38 "../src/Connection.vala"
		break;
#line 5913 "Connection.c"
		default:
#line 38 "../src/Connection.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 38 "../src/Connection.vala"
		break;
#line 5919 "Connection.c"
	}
}



