/* DynamicNotebook.c generated by valac 0.42.7, the Vala compiler
 * generated from DynamicNotebook.vala, do not modify */

/*
 *  Copyright (C) 2011-2013 Tom Beckmann <tom@elementaryos.org>
 *
 *  This program or library is free software; you can redistribute it
 *  and/or modify it under the terms of the GNU Lesser General Public
 *  License as published by the Free Software Foundation; either
 *  version 3 of the License, or (at your option) any later version.
 *
 *  This library is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 *  Lesser General Public License for more details.
 *
 *  You should have received a copy of the GNU Lesser General
 *  Public License along with this library; if not, write to the
 *  Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 *  Boston, MA 02110-1301 USA.
 */
/* a mask to ignore modifiers like num lock or caps lock that are irrelevant to keyboard shortcuts*/


#include <glib.h>
#include <glib-object.h>
#include <gdk/gdk.h>
#include <gtk/gtk.h>
#include <granite.h>
#include <stdlib.h>
#include <string.h>
#include <gio/gio.h>
#include <pango/pango.h>
#include <glib/gi18n-lib.h>
#include <gee.h>
#include <cairo.h>
#include <float.h>
#include <math.h>


#define TYPE_TAB_PAGE_CONTAINER (tab_page_container_get_type ())
#define TAB_PAGE_CONTAINER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TAB_PAGE_CONTAINER, TabPageContainer))
#define TAB_PAGE_CONTAINER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TAB_PAGE_CONTAINER, TabPageContainerClass))
#define IS_TAB_PAGE_CONTAINER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TAB_PAGE_CONTAINER))
#define IS_TAB_PAGE_CONTAINER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TAB_PAGE_CONTAINER))
#define TAB_PAGE_CONTAINER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TAB_PAGE_CONTAINER, TabPageContainerClass))

typedef struct _TabPageContainer TabPageContainer;
typedef struct _TabPageContainerClass TabPageContainerClass;
typedef struct _TabPageContainerPrivate TabPageContainerPrivate;

#define TYPE_TAB (tab_get_type ())
#define TAB(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_TAB, Tab))
#define TAB_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_TAB, TabClass))
#define IS_TAB(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_TAB))
#define IS_TAB_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_TAB))
#define TAB_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_TAB, TabClass))

typedef struct _Tab Tab;
typedef struct _TabClass TabClass;
enum  {
	TAB_PAGE_CONTAINER_0_PROPERTY,
	TAB_PAGE_CONTAINER_TAB_PROPERTY,
	TAB_PAGE_CONTAINER_NUM_PROPERTIES
};
static GParamSpec* tab_page_container_properties[TAB_PAGE_CONTAINER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _TabPrivate TabPrivate;
enum  {
	TAB_0_PROPERTY,
	TAB_LABEL_PROPERTY,
	TAB_TOOLTIP_PROPERTY,
	TAB_PINNED_PROPERTY,
	TAB_PINNABLE_PROPERTY,
	TAB_RESTORE_DATA_PROPERTY,
	TAB_PAGE_PROPERTY,
	TAB_ICON_PROPERTY,
	TAB_WORKING_PROPERTY,
	TAB_ELLIPSIZE_MODE_PROPERTY,
	TAB_FIXED_PROPERTY,
	TAB_MENU_PROPERTY,
	TAB_CLOSABLE_PROPERTY,
	TAB_IS_CURRENT_TAB_PROPERTY,
	TAB_NUM_PROPERTIES
};
static GParamSpec* tab_properties[TAB_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _Block7Data Block7Data;
enum  {
	TAB_CLOSED_SIGNAL,
	TAB_CLOSE_OTHERS_SIGNAL,
	TAB_NEW_WINDOW_SIGNAL,
	TAB_DUPLICATE_SIGNAL,
	TAB_PIN_SWITCH_SIGNAL,
	TAB_NUM_SIGNALS
};
static guint tab_signals[TAB_NUM_SIGNALS] = {0};

#define TYPE_CLOSED_TABS (closed_tabs_get_type ())
#define CLOSED_TABS(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_CLOSED_TABS, ClosedTabs))
#define CLOSED_TABS_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_CLOSED_TABS, ClosedTabsClass))
#define IS_CLOSED_TABS(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_CLOSED_TABS))
#define IS_CLOSED_TABS_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_CLOSED_TABS))
#define CLOSED_TABS_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_CLOSED_TABS, ClosedTabsClass))

typedef struct _ClosedTabs ClosedTabs;
typedef struct _ClosedTabsClass ClosedTabsClass;
typedef struct _ClosedTabsPrivate ClosedTabsPrivate;

#define CLOSED_TABS_TYPE_ENTRY (closed_tabs_entry_get_type ())
typedef struct _ClosedTabsEntry ClosedTabsEntry;
enum  {
	CLOSED_TABS_0_PROPERTY,
	CLOSED_TABS_MAX_RESTORABLE_TABS_PROPERTY,
	CLOSED_TABS_EMPTY_PROPERTY,
	CLOSED_TABS_MENU_PROPERTY,
	CLOSED_TABS_NUM_PROPERTIES
};
static GParamSpec* closed_tabs_properties[CLOSED_TABS_NUM_PROPERTIES];
#define _closed_tabs_entry_free0(var) ((var == NULL) ? NULL : (var = (closed_tabs_entry_free (var), NULL)))
typedef struct _Block8Data Block8Data;
enum  {
	CLOSED_TABS_RESTORED_SIGNAL,
	CLOSED_TABS_CLEARED_SIGNAL,
	CLOSED_TABS_NUM_SIGNALS
};
static guint closed_tabs_signals[CLOSED_TABS_NUM_SIGNALS] = {0};

#define TYPE_DYNAMIC_NOTEBOOK (dynamic_notebook_get_type ())
#define DYNAMIC_NOTEBOOK(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_DYNAMIC_NOTEBOOK, DynamicNotebook))
#define DYNAMIC_NOTEBOOK_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_DYNAMIC_NOTEBOOK, DynamicNotebookClass))
#define IS_DYNAMIC_NOTEBOOK(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_DYNAMIC_NOTEBOOK))
#define IS_DYNAMIC_NOTEBOOK_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_DYNAMIC_NOTEBOOK))
#define DYNAMIC_NOTEBOOK_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_DYNAMIC_NOTEBOOK, DynamicNotebookClass))

typedef struct _DynamicNotebook DynamicNotebook;
typedef struct _DynamicNotebookClass DynamicNotebookClass;
typedef struct _DynamicNotebookPrivate DynamicNotebookPrivate;
typedef enum  {
	DYNAMIC_NOTEBOOK_TAB_BAR_BEHAVIOR_ALWAYS = 0,
	DYNAMIC_NOTEBOOK_TAB_BAR_BEHAVIOR_SINGLE = 1,
	DYNAMIC_NOTEBOOK_TAB_BAR_BEHAVIOR_NEVER = 2
} DynamicNotebookTabBarBehavior;


#define DYNAMIC_NOTEBOOK_TYPE_TAB_BAR_BEHAVIOR (dynamic_notebook_tab_bar_behavior_get_type ())
enum  {
	DYNAMIC_NOTEBOOK_0_PROPERTY,
	DYNAMIC_NOTEBOOK_N_TABS_PROPERTY,
	DYNAMIC_NOTEBOOK_SHOW_TABS_PROPERTY,
	DYNAMIC_NOTEBOOK_SHOW_ICONS_PROPERTY,
	DYNAMIC_NOTEBOOK_TABS_CLOSABLE_PROPERTY,
	DYNAMIC_NOTEBOOK_ALLOW_DRAG_PROPERTY,
	DYNAMIC_NOTEBOOK_ALLOW_NEW_WINDOW_PROPERTY,
	DYNAMIC_NOTEBOOK_ALLOW_DUPLICATION_PROPERTY,
	DYNAMIC_NOTEBOOK_ALLOW_RESTORING_PROPERTY,
	DYNAMIC_NOTEBOOK_MAX_RESTORABLE_TABS_PROPERTY,
	DYNAMIC_NOTEBOOK_ADD_BUTTON_VISIBLE_PROPERTY,
	DYNAMIC_NOTEBOOK_ALLOW_PINNING_PROPERTY,
	DYNAMIC_NOTEBOOK_FORCE_LEFT_PROPERTY,
	DYNAMIC_NOTEBOOK_ADD_BUTTON_TOOLTIP_PROPERTY,
	DYNAMIC_NOTEBOOK_CURRENT_PROPERTY,
	DYNAMIC_NOTEBOOK_TABS_PROPERTY,
	DYNAMIC_NOTEBOOK_GROUP_NAME_PROPERTY,
	DYNAMIC_NOTEBOOK_TAB_BAR_BEHAVIOR_PROPERTY,
	DYNAMIC_NOTEBOOK_MENU_PROPERTY,
	DYNAMIC_NOTEBOOK_NUM_PROPERTIES
};
static GParamSpec* dynamic_notebook_properties[DYNAMIC_NOTEBOOK_NUM_PROPERTIES];
typedef struct _Block9Data Block9Data;
typedef struct _Block10Data Block10Data;
typedef struct _Block11Data Block11Data;
enum  {
	DYNAMIC_NOTEBOOK_TAB_ADDED_SIGNAL,
	DYNAMIC_NOTEBOOK_TAB_REMOVED_SIGNAL,
	DYNAMIC_NOTEBOOK_TAB_SWITCHED_SIGNAL,
	DYNAMIC_NOTEBOOK_TAB_REORDERED_SIGNAL,
	DYNAMIC_NOTEBOOK_TAB_MOVED_SIGNAL,
	DYNAMIC_NOTEBOOK_TAB_DUPLICATED_SIGNAL,
	DYNAMIC_NOTEBOOK_TAB_RESTORED_SIGNAL,
	DYNAMIC_NOTEBOOK_NEW_TAB_REQUESTED_SIGNAL,
	DYNAMIC_NOTEBOOK_CLOSE_TAB_REQUESTED_SIGNAL,
	DYNAMIC_NOTEBOOK_NUM_SIGNALS
};
static guint dynamic_notebook_signals[DYNAMIC_NOTEBOOK_NUM_SIGNALS] = {0};
#define _vala_assert(expr, msg) if G_LIKELY (expr) ; else g_assertion_message_expr (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);
#define _vala_return_if_fail(expr, msg) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return; }
#define _vala_return_val_if_fail(expr, msg, val) if G_LIKELY (expr) ; else { g_return_if_fail_warning (G_LOG_DOMAIN, G_STRFUNC, msg); return val; }
#define _vala_warn_if_fail(expr, msg) if G_LIKELY (expr) ; else g_warn_message (G_LOG_DOMAIN, __FILE__, __LINE__, G_STRFUNC, msg);

struct _TabPageContainer {
	GtkEventBox parent_instance;
	TabPageContainerPrivate * priv;
};

struct _TabPageContainerClass {
	GtkEventBoxClass parent_class;
};

struct _TabPageContainerPrivate {
	Tab* _tab;
};

struct _Tab {
	GtkEventBox parent_instance;
	TabPrivate * priv;
	GraniteWidgetsDroppedDelegate dropped_callback;
	gpointer dropped_callback_target;
	GDestroyNotify dropped_callback_target_destroy_notify;
	TabPageContainer* page_container;
	GtkImage* _icon;
	GtkMenuItem* new_window_m;
	GtkMenuItem* duplicate_m;
	GtkMenuItem* pin_m;
};

struct _TabClass {
	GtkEventBoxClass parent_class;
};

struct _TabPrivate {
	GtkLabel* _label;
	gboolean _pinned;
	gboolean _pinnable;
	gchar* _restore_data;
	GtkSpinner* _working;
	gboolean __working;
	gboolean _fixed;
	GtkMenu* _menu;
	gboolean _closable;
	gboolean _is_current_tab;
	gboolean cursor_over_tab;
	gboolean cursor_over_close_button;
	GtkRevealer* close_button_revealer;
};

struct _Block7Data {
	int _ref_count_;
	Tab* self;
	GtkMenuItem* close_other_m;
};

struct _ClosedTabs {
	GObject parent_instance;
	ClosedTabsPrivate * priv;
};

struct _ClosedTabsClass {
	GObjectClass parent_class;
};

struct _ClosedTabsEntry {
	gchar* label;
	gchar* restore_data;
	GIcon* icon;
	GraniteWidgetsDroppedDelegate dropped_callback;
	gpointer dropped_callback_target;
};

struct _ClosedTabsPrivate {
	gint _max_restorable_tabs;
	GeeLinkedList* closed_tabs;
};

struct _Block8Data {
	int _ref_count_;
	ClosedTabs* self;
	ClosedTabsEntry* entry;
};

struct _DynamicNotebook {
	GtkEventBox parent_instance;
	DynamicNotebookPrivate * priv;
};

struct _DynamicNotebookClass {
	GtkEventBoxClass parent_class;
};

struct _DynamicNotebookPrivate {
	gboolean _show_icons;
	gboolean _tabs_closable;
	gboolean _allow_drag;
	gboolean _allow_new_window;
	gboolean _allow_duplication;
	gboolean _allow_restoring;
	gboolean _add_button_visible;
	gboolean _allow_pinning;
	gboolean _force_left;
	gchar* _add_button_tooltip;
	GList* _tabs;
	DynamicNotebookTabBarBehavior _tab_bar_behavior;
	GtkMenu* _menu;
	ClosedTabs* closed_tabs;
	GtkNotebook* notebook;
	gint tab_width;
	Tab* old_tab;
	GtkMenuItem* new_tab_m;
	GtkMenuItem* restore_tab_m;
	GtkButton* add_button;
	GtkButton* restore_button;
};

struct _Block9Data {
	int _ref_count_;
	DynamicNotebook* self;
	gboolean value;
};

struct _Block10Data {
	int _ref_count_;
	DynamicNotebook* self;
	gboolean value;
};

struct _Block11Data {
	int _ref_count_;
	DynamicNotebook* self;
	gboolean value;
};


static gint TabPageContainer_private_offset;
static gpointer tab_page_container_parent_class = NULL;
static gint Tab_private_offset;
static gpointer tab_parent_class = NULL;
static gint ClosedTabs_private_offset;
static gpointer closed_tabs_parent_class = NULL;
static gint DynamicNotebook_private_offset;
static gpointer dynamic_notebook_parent_class = NULL;

#define MODIFIER_MASK (((GDK_SHIFT_MASK | GDK_SUPER_MASK) | GDK_CONTROL_MASK) | GDK_MOD1_MASK)
GType tab_page_container_get_type (void) G_GNUC_CONST;
GType tab_get_type (void) G_GNUC_CONST;
TabPageContainer* tab_page_container_new (Tab* tab);
TabPageContainer* tab_page_container_construct (GType object_type,
                                                Tab* tab);
Tab* tab_page_container_get_tab (TabPageContainer* self);
void tab_page_container_set_tab (TabPageContainer* self,
                                 Tab* value);
static GObject * tab_page_container_constructor (GType type,
                                          guint n_construct_properties,
                                          GObjectConstructParam * construct_properties);
static void tab_page_container_finalize (GObject * obj);
static void _vala_tab_page_container_get_property (GObject * object,
                                            guint property_id,
                                            GValue * value,
                                            GParamSpec * pspec);
static void _vala_tab_page_container_set_property (GObject * object,
                                            guint property_id,
                                            const GValue * value,
                                            GParamSpec * pspec);
Tab* tab_new (const gchar* label,
              GIcon* icon,
              GtkWidget* page);
Tab* tab_construct (GType object_type,
                    const gchar* label,
                    GIcon* icon,
                    GtkWidget* page);
void tab_set_page (Tab* self,
                   GtkWidget* value);
void tab_close (Tab* self);
static void tab_update_close_button_visibility (Tab* self);
static gboolean tab_close_button_is_visible (Tab* self);
const gchar* tab_get_label (Tab* self);
void tab_set_label (Tab* self,
                    const gchar* value);
gchar* tab_get_tooltip (Tab* self);
void tab_set_tooltip (Tab* self,
                      const gchar* value);
gboolean tab_get_pinned (Tab* self);
void tab_set_pinned (Tab* self,
                     gboolean value);
gboolean tab_get_pinnable (Tab* self);
void tab_set_pinnable (Tab* self,
                       gboolean value);
const gchar* tab_get_restore_data (Tab* self);
void tab_set_restore_data (Tab* self,
                           const gchar* value);
GtkWidget* tab_get_page (Tab* self);
GIcon* tab_get_icon (Tab* self);
void tab_set_icon (Tab* self,
                   GIcon* value);
gboolean tab_get_working (Tab* self);
void tab_set_working (Tab* self,
                      gboolean value);
PangoEllipsizeMode tab_get_ellipsize_mode (Tab* self);
void tab_set_ellipsize_mode (Tab* self,
                             PangoEllipsizeMode value);
gboolean tab_get_fixed (Tab* self) G_GNUC_DEPRECATED;
void tab_set_fixed (Tab* self,
                    gboolean value) G_GNUC_DEPRECATED;
GtkMenu* tab_get_menu (Tab* self);
void tab_set_menu (Tab* self,
                   GtkMenu* value);
void tab_set_closable (Tab* self,
                       gboolean value);
void tab_set_is_current_tab (Tab* self,
                             gboolean value);
static GObject * tab_constructor (GType type,
                           guint n_construct_properties,
                           GObjectConstructParam * construct_properties);
static Block7Data* block7_data_ref (Block7Data* _data7_);
static void block7_data_unref (void * _userdata_);
static void _tab___lambda4_ (Tab* self);
static void __tab___lambda4__gtk_menu_item_activate (GtkMenuItem* _sender,
                                              gpointer self);
static void _tab___lambda5_ (Tab* self);
static void __tab___lambda5__gtk_menu_item_activate (GtkMenuItem* _sender,
                                              gpointer self);
static void _tab___lambda6_ (Tab* self);
static void __tab___lambda6__gtk_menu_item_activate (GtkMenuItem* _sender,
                                              gpointer self);
static void _tab___lambda7_ (Tab* self);
static void __tab___lambda7__gtk_menu_item_activate (GtkMenuItem* _sender,
                                              gpointer self);
static void _tab___lambda8_ (Tab* self);
static void __tab___lambda8__gtk_menu_item_activate (GtkMenuItem* _sender,
                                              gpointer self);
static gboolean _tab___lambda9_ (Tab* self,
                          GdkEventScroll* e);
static gboolean __tab___lambda9__gtk_widget_scroll_event (GtkWidget* _sender,
                                                   GdkEventScroll* event,
                                                   gpointer self);
static gboolean _tab___lambda10_ (Block7Data* _data7_,
                           GdkEventButton* e);
static gboolean __tab___lambda10__gtk_widget_button_press_event (GtkWidget* _sender,
                                                          GdkEventButton* event,
                                                          gpointer self);
static gboolean _tab___lambda11_ (Tab* self,
                           GdkEventCrossing* e);
static gboolean __tab___lambda11__gtk_widget_enter_notify_event (GtkWidget* _sender,
                                                          GdkEventCrossing* event,
                                                          gpointer self);
static gboolean _tab___lambda12_ (Tab* self,
                           GdkEventCrossing* e);
static gboolean __tab___lambda12__gtk_widget_leave_notify_event (GtkWidget* _sender,
                                                          GdkEventCrossing* event,
                                                          gpointer self);
static gboolean _tab___lambda13_ (Tab* self,
                           GdkEventCrossing* e);
static gboolean __tab___lambda13__gtk_widget_enter_notify_event (GtkWidget* _sender,
                                                          GdkEventCrossing* event,
                                                          gpointer self);
static gboolean _tab___lambda14_ (Tab* self,
                           GdkEventCrossing* e);
static gboolean __tab___lambda14__gtk_widget_leave_notify_event (GtkWidget* _sender,
                                                          GdkEventCrossing* event,
                                                          gpointer self);
static gboolean _tab___lambda15_ (Tab* self);
static gboolean __tab___lambda15__gtk_widget_button_press_event (GtkWidget* _sender,
                                                          GdkEventButton* event,
                                                          gpointer self);
static void _tab___lambda16_ (Tab* self);
static void __tab___lambda16__gtk_button_clicked (GtkButton* _sender,
                                           gpointer self);
static void tab_finalize (GObject * obj);
static void _vala_tab_get_property (GObject * object,
                             guint property_id,
                             GValue * value,
                             GParamSpec * pspec);
static void _vala_tab_set_property (GObject * object,
                             guint property_id,
                             const GValue * value,
                             GParamSpec * pspec);
GType closed_tabs_get_type (void) G_GNUC_CONST;
GType closed_tabs_entry_get_type (void) G_GNUC_CONST;
ClosedTabsEntry* closed_tabs_entry_dup (const ClosedTabsEntry* self);
void closed_tabs_entry_free (ClosedTabsEntry* self);
void closed_tabs_entry_copy (const ClosedTabsEntry* self,
                             ClosedTabsEntry* dest);
void closed_tabs_entry_destroy (ClosedTabsEntry* self);
ClosedTabs* closed_tabs_new (void);
ClosedTabs* closed_tabs_construct (GType object_type);
void closed_tabs_push (ClosedTabs* self,
                       Tab* tab);
gint closed_tabs_get_max_restorable_tabs (ClosedTabs* self);
void closed_tabs_pop (ClosedTabs* self,
                      ClosedTabsEntry* result);
void closed_tabs_pick (ClosedTabs* self,
                       const gchar* search,
                       ClosedTabsEntry* result);
void closed_tabs_set_max_restorable_tabs (ClosedTabs* self,
                                          gint value);
gboolean closed_tabs_get_empty (ClosedTabs* self);
GtkMenu* closed_tabs_get_menu (ClosedTabs* self);
static Block8Data* block8_data_ref (Block8Data* _data8_);
static void block8_data_unref (void * _userdata_);
static void _closed_tabs_menu_____lambda17_ (Block8Data* _data8_);
static void __closed_tabs_menu_____lambda17__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                              gpointer self);
static void _closed_tabs_menu____lambda18_ (ClosedTabs* self);
static void __closed_tabs_menu____lambda18__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                             gpointer self);
static void g_cclosure_user_marshal_VOID__STRING_STRING_OBJECT (GClosure * closure,
                                                         GValue * return_value,
                                                         guint n_param_values,
                                                         const GValue * param_values,
                                                         gpointer invocation_hint,
                                                         gpointer marshal_data);
static GObject * closed_tabs_constructor (GType type,
                                   guint n_construct_properties,
                                   GObjectConstructParam * construct_properties);
static void closed_tabs_finalize (GObject * obj);
static void _vala_closed_tabs_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec);
static void _vala_closed_tabs_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec);
GType dynamic_notebook_get_type (void) G_GNUC_CONST;
GType dynamic_notebook_tab_bar_behavior_get_type (void) G_GNUC_CONST;
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
#define DYNAMIC_NOTEBOOK_MAX_TAB_WIDTH 174
#define DYNAMIC_NOTEBOOK_TAB_WIDTH_PINNED 18
#define DYNAMIC_NOTEBOOK_ADD_BUTTON_PADDING 5
DynamicNotebook* dynamic_notebook_new (void);
DynamicNotebook* dynamic_notebook_construct (GType object_type);
static void dynamic_notebook_on_switch_page (DynamicNotebook* self,
                                      GtkWidget* page,
                                      guint pagenum);
static void dynamic_notebook_on_page_added (DynamicNotebook* self,
                                     GtkWidget* page,
                                     guint pagenum);
static void dynamic_notebook_insert_callbacks (DynamicNotebook* self,
                                        Tab* tab);
static void dynamic_notebook_update_tabs_visibility (DynamicNotebook* self);
static void dynamic_notebook_on_page_removed (DynamicNotebook* self,
                                       GtkWidget* page,
                                       guint pagenum);
static void dynamic_notebook_remove_callbacks (DynamicNotebook* self,
                                        Tab* tab);
static void dynamic_notebook_on_page_reordered (DynamicNotebook* self,
                                         GtkWidget* page,
                                         guint pagenum);
static void dynamic_notebook_recalc_order (DynamicNotebook* self);
static GtkNotebook* dynamic_notebook_on_create_window (DynamicNotebook* self,
                                                GtkWidget* page,
                                                gint x,
                                                gint y);
gint dynamic_notebook_get_n_tabs (DynamicNotebook* self);
gboolean dynamic_notebook_get_force_left (DynamicNotebook* self);
static void dynamic_notebook_recalc_size (DynamicNotebook* self);
static void dynamic_notebook_restore_last_tab (DynamicNotebook* self);
gboolean dynamic_notebook_get_allow_restoring (DynamicNotebook* self);
static void dynamic_notebook_switch_pin_tab (DynamicNotebook* self,
                                      Tab* tab);
gboolean dynamic_notebook_get_allow_pinning (DynamicNotebook* self);
void dynamic_notebook_remove_tab (DynamicNotebook* self,
                                  Tab* tab);
gint dynamic_notebook_get_tab_position (DynamicNotebook* self,
                                        Tab* tab);
void dynamic_notebook_next_page (DynamicNotebook* self);
void dynamic_notebook_previous_page (DynamicNotebook* self);
static void dynamic_notebook_real_show (GtkWidget* base);
GList* dynamic_notebook_get_children (DynamicNotebook* self);
void dynamic_notebook_set_tab_position (DynamicNotebook* self,
                                        Tab* tab,
                                        gint position);
Tab* dynamic_notebook_get_tab_by_index (DynamicNotebook* self,
                                        gint index);
Tab* dynamic_notebook_get_tab_by_widget (DynamicNotebook* self,
                                         GtkWidget* widget);
GtkWidget* dynamic_notebook_get_nth_page (DynamicNotebook* self,
                                          gint index);
guint dynamic_notebook_insert_tab (DynamicNotebook* self,
                                   Tab* tab,
                                   gint index);
GList* dynamic_notebook_get_tabs (DynamicNotebook* self);
gboolean dynamic_notebook_get_allow_drag (DynamicNotebook* self);
gboolean dynamic_notebook_get_allow_new_window (DynamicNotebook* self);
gboolean dynamic_notebook_get_allow_duplication (DynamicNotebook* self);
gboolean dynamic_notebook_get_tabs_closable (DynamicNotebook* self);
static void dynamic_notebook_on_tab_closed (DynamicNotebook* self,
                                     Tab* tab);
static void _dynamic_notebook_on_tab_closed_tab_closed (Tab* _sender,
                                                 gpointer self);
static void dynamic_notebook_on_close_others (DynamicNotebook* self,
                                       Tab* tab);
static void _dynamic_notebook_on_close_others_tab_close_others (Tab* _sender,
                                                         gpointer self);
static void dynamic_notebook_on_new_window (DynamicNotebook* self,
                                     Tab* tab);
static void _dynamic_notebook_on_new_window_tab_new_window (Tab* _sender,
                                                     gpointer self);
static void dynamic_notebook_on_duplicate (DynamicNotebook* self,
                                    Tab* tab);
static void _dynamic_notebook_on_duplicate_tab_duplicate (Tab* _sender,
                                                   gpointer self);
static void dynamic_notebook_on_pin_switch (DynamicNotebook* self,
                                     Tab* tab);
static void _dynamic_notebook_on_pin_switch_tab_pin_switch (Tab* _sender,
                                                     gpointer self);
gboolean dynamic_notebook_get_show_tabs (DynamicNotebook* self);
void dynamic_notebook_set_show_tabs (DynamicNotebook* self,
                                     gboolean value);
gboolean dynamic_notebook_get_show_icons (DynamicNotebook* self) G_GNUC_DEPRECATED;
void dynamic_notebook_set_show_icons (DynamicNotebook* self,
                                      gboolean value) G_GNUC_DEPRECATED;
void dynamic_notebook_set_tabs_closable (DynamicNotebook* self,
                                         gboolean value);
static Block9Data* block9_data_ref (Block9Data* _data9_);
static void block9_data_unref (void * _userdata_);
static void _dynamic_notebook_tabs_closable____lambda21_ (Block9Data* _data9_,
                                                   Tab* t);
static void __dynamic_notebook_tabs_closable____lambda21__gfunc (gconstpointer data,
                                                          gpointer self);
void dynamic_notebook_set_allow_drag (DynamicNotebook* self,
                                      gboolean value);
static Block10Data* block10_data_ref (Block10Data* _data10_);
static void block10_data_unref (void * _userdata_);
static void _dynamic_notebook_allow_drag___lambda19_ (Block10Data* _data10_,
                                               Tab* t);
static void __dynamic_notebook_allow_drag___lambda19__gfunc (gconstpointer data,
                                                      gpointer self);
void dynamic_notebook_set_allow_new_window (DynamicNotebook* self,
                                            gboolean value);
static Block11Data* block11_data_ref (Block11Data* _data11_);
static void block11_data_unref (void * _userdata_);
static void _dynamic_notebook_allow_new_window___lambda20_ (Block11Data* _data11_,
                                                     Tab* t);
static void __dynamic_notebook_allow_new_window___lambda20__gfunc (gconstpointer data,
                                                            gpointer self);
void dynamic_notebook_set_allow_duplication (DynamicNotebook* self,
                                             gboolean value);
void dynamic_notebook_set_allow_restoring (DynamicNotebook* self,
                                           gboolean value);
gint dynamic_notebook_get_max_restorable_tabs (DynamicNotebook* self);
void dynamic_notebook_set_max_restorable_tabs (DynamicNotebook* self,
                                               gint value);
gboolean dynamic_notebook_get_add_button_visible (DynamicNotebook* self);
void dynamic_notebook_set_add_button_visible (DynamicNotebook* self,
                                              gboolean value);
void dynamic_notebook_set_allow_pinning (DynamicNotebook* self,
                                         gboolean value);
void dynamic_notebook_set_force_left (DynamicNotebook* self,
                                      gboolean value);
const gchar* dynamic_notebook_get_add_button_tooltip (DynamicNotebook* self);
void dynamic_notebook_set_add_button_tooltip (DynamicNotebook* self,
                                              const gchar* value);
Tab* dynamic_notebook_get_current (DynamicNotebook* self);
void dynamic_notebook_set_current (DynamicNotebook* self,
                                   Tab* value);
const gchar* dynamic_notebook_get_group_name (DynamicNotebook* self);
void dynamic_notebook_set_group_name (DynamicNotebook* self,
                                      const gchar* value);
DynamicNotebookTabBarBehavior dynamic_notebook_get_tab_bar_behavior (DynamicNotebook* self);
void dynamic_notebook_set_tab_bar_behavior (DynamicNotebook* self,
                                            DynamicNotebookTabBarBehavior value);
GtkMenu* dynamic_notebook_get_menu (DynamicNotebook* self);
static void dynamic_notebook_set_menu (DynamicNotebook* self,
                                GtkMenu* value);
static void g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure,
                                                  GValue * return_value,
                                                  guint n_param_values,
                                                  const GValue * param_values,
                                                  gpointer invocation_hint,
                                                  gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__OBJECT_INT (GClosure * closure,
                                               GValue * return_value,
                                               guint n_param_values,
                                               const GValue * param_values,
                                               gpointer invocation_hint,
                                               gpointer marshal_data);
static void g_cclosure_user_marshal_VOID__OBJECT_INT_INT (GClosure * closure,
                                                   GValue * return_value,
                                                   guint n_param_values,
                                                   const GValue * param_values,
                                                   gpointer invocation_hint,
                                                   gpointer marshal_data);
static void g_cclosure_user_marshal_BOOLEAN__OBJECT (GClosure * closure,
                                              GValue * return_value,
                                              guint n_param_values,
                                              const GValue * param_values,
                                              gpointer invocation_hint,
                                              gpointer marshal_data);
static GObject * dynamic_notebook_constructor (GType type,
                                        guint n_construct_properties,
                                        GObjectConstructParam * construct_properties);
static gboolean _dynamic_notebook___lambda22_ (DynamicNotebook* self,
                                        cairo_t* ctx);
static gboolean __dynamic_notebook___lambda22__gtk_widget_draw (GtkWidget* _sender,
                                                         cairo_t* cr,
                                                         gpointer self);
static void _dynamic_notebook___lambda23_ (DynamicNotebook* self);
static void __dynamic_notebook___lambda23__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                            gpointer self);
static void _dynamic_notebook___lambda24_ (DynamicNotebook* self);
static void __dynamic_notebook___lambda24__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                            gpointer self);
static void _dynamic_notebook___lambda25_ (DynamicNotebook* self,
                                    const gchar* label,
                                    const gchar* restore_data,
                                    GIcon* icon);
static void __dynamic_notebook___lambda25__closed_tabs_restored (ClosedTabs* _sender,
                                                          const gchar* label,
                                                          const gchar* restore_data,
                                                          GIcon* icon,
                                                          gpointer self);
static void _dynamic_notebook___lambda26_ (DynamicNotebook* self);
static void __dynamic_notebook___lambda26__closed_tabs_cleared (ClosedTabs* _sender,
                                                         gpointer self);
static void _dynamic_notebook___lambda27_ (DynamicNotebook* self);
static void __dynamic_notebook___lambda27__gtk_button_clicked (GtkButton* _sender,
                                                        gpointer self);
static gboolean _dynamic_notebook___lambda28_ (DynamicNotebook* self,
                                        GdkEventButton* e);
static gboolean __dynamic_notebook___lambda28__gtk_widget_button_press_event (GtkWidget* _sender,
                                                                       GdkEventButton* event,
                                                                       gpointer self);
static void _dynamic_notebook___lambda29_ (DynamicNotebook* self);
static void __dynamic_notebook___lambda29__gtk_button_clicked (GtkButton* _sender,
                                                        gpointer self);
static void _dynamic_notebook___lambda30_ (DynamicNotebook* self);
static void __dynamic_notebook___lambda30__gtk_widget_size_allocate (GtkWidget* _sender,
                                                              GtkAllocation* allocation,
                                                              gpointer self);
static gboolean _dynamic_notebook___lambda31_ (DynamicNotebook* self,
                                        GdkEventButton* e);
static gboolean __dynamic_notebook___lambda31__gtk_widget_button_press_event (GtkWidget* _sender,
                                                                       GdkEventButton* event,
                                                                       gpointer self);
static gboolean _dynamic_notebook___lambda32_ (DynamicNotebook* self,
                                        GdkEventKey* e);
static gboolean __dynamic_notebook___lambda32__gtk_widget_key_press_event (GtkWidget* _sender,
                                                                    GdkEventKey* event,
                                                                    gpointer self);
static void _dynamic_notebook___lambda33_ (DynamicNotebook* self);
static void _dynamic_notebook_on_switch_page_gtk_notebook_switch_page (GtkNotebook* _sender,
                                                                GtkWidget* page,
                                                                guint page_num,
                                                                gpointer self);
static void _dynamic_notebook_on_page_added_gtk_notebook_page_added (GtkNotebook* _sender,
                                                              GtkWidget* child,
                                                              guint page_num,
                                                              gpointer self);
static void _dynamic_notebook_on_page_removed_gtk_notebook_page_removed (GtkNotebook* _sender,
                                                                  GtkWidget* child,
                                                                  guint page_num,
                                                                  gpointer self);
static void _dynamic_notebook_on_page_reordered_gtk_notebook_page_reordered (GtkNotebook* _sender,
                                                                      GtkWidget* child,
                                                                      guint page_num,
                                                                      gpointer self);
static GtkNotebook* _dynamic_notebook_on_create_window_gtk_notebook_create_window (GtkNotebook* _sender,
                                                                            GtkWidget* page,
                                                                            gint x,
                                                                            gint y,
                                                                            gpointer self);
static void __dynamic_notebook___lambda33__gtk_widget_destroy (GtkWidget* _sender,
                                                        gpointer self);
static void dynamic_notebook_finalize (GObject * obj);
static void _vala_dynamic_notebook_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec);
static void _vala_dynamic_notebook_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec);


static inline gpointer
tab_page_container_get_instance_private (TabPageContainer* self)
{
	return G_STRUCT_MEMBER_P (self, TabPageContainer_private_offset);
}


TabPageContainer*
tab_page_container_construct (GType object_type,
                              Tab* tab)
{
	TabPageContainer * self = NULL;
#line 34 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (tab != NULL, NULL);
#line 35 "../src/DynamicNotebook.vala"
	self = (TabPageContainer*) g_object_new (object_type, "tab", tab, NULL);
#line 34 "../src/DynamicNotebook.vala"
	return self;
#line 785 "DynamicNotebook.c"
}


TabPageContainer*
tab_page_container_new (Tab* tab)
{
#line 34 "../src/DynamicNotebook.vala"
	return tab_page_container_construct (TYPE_TAB_PAGE_CONTAINER, tab);
#line 794 "DynamicNotebook.c"
}


Tab*
tab_page_container_get_tab (TabPageContainer* self)
{
	Tab* result;
	Tab* _tmp0_;
#line 30 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 30 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->_tab;
#line 30 "../src/DynamicNotebook.vala"
	result = _tmp0_;
#line 30 "../src/DynamicNotebook.vala"
	return result;
#line 811 "DynamicNotebook.c"
}


void
tab_page_container_set_tab (TabPageContainer* self,
                            Tab* value)
{
#line 31 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 31 "../src/DynamicNotebook.vala"
	self->priv->_tab = value;
#line 31 "../src/DynamicNotebook.vala"
	g_object_notify_by_pspec ((GObject *) self, tab_page_container_properties[TAB_PAGE_CONTAINER_TAB_PROPERTY]);
#line 825 "DynamicNotebook.c"
}


static GObject *
tab_page_container_constructor (GType type,
                                guint n_construct_properties,
                                GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	TabPageContainer * self;
	GtkGrid* _tmp0_;
	GtkGrid* _tmp1_;
#line 38 "../src/DynamicNotebook.vala"
	parent_class = G_OBJECT_CLASS (tab_page_container_parent_class);
#line 38 "../src/DynamicNotebook.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 38 "../src/DynamicNotebook.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_TAB_PAGE_CONTAINER, TabPageContainer);
#line 39 "../src/DynamicNotebook.vala"
	_tmp0_ = (GtkGrid*) gtk_grid_new ();
#line 39 "../src/DynamicNotebook.vala"
	g_object_ref_sink (_tmp0_);
#line 39 "../src/DynamicNotebook.vala"
	_tmp1_ = _tmp0_;
#line 39 "../src/DynamicNotebook.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp1_);
#line 39 "../src/DynamicNotebook.vala"
	_g_object_unref0 (_tmp1_);
#line 38 "../src/DynamicNotebook.vala"
	return obj;
#line 857 "DynamicNotebook.c"
}


static void
tab_page_container_class_init (TabPageContainerClass * klass)
{
#line 26 "../src/DynamicNotebook.vala"
	tab_page_container_parent_class = g_type_class_peek_parent (klass);
#line 26 "../src/DynamicNotebook.vala"
	g_type_class_adjust_private_offset (klass, &TabPageContainer_private_offset);
#line 26 "../src/DynamicNotebook.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_tab_page_container_get_property;
#line 26 "../src/DynamicNotebook.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_tab_page_container_set_property;
#line 26 "../src/DynamicNotebook.vala"
	G_OBJECT_CLASS (klass)->constructor = tab_page_container_constructor;
#line 26 "../src/DynamicNotebook.vala"
	G_OBJECT_CLASS (klass)->finalize = tab_page_container_finalize;
#line 26 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TAB_PAGE_CONTAINER_TAB_PROPERTY, tab_page_container_properties[TAB_PAGE_CONTAINER_TAB_PROPERTY] = g_param_spec_object ("tab", "tab", "tab", TYPE_TAB, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 878 "DynamicNotebook.c"
}


static void
tab_page_container_instance_init (TabPageContainer * self)
{
#line 26 "../src/DynamicNotebook.vala"
	self->priv = tab_page_container_get_instance_private (self);
#line 27 "../src/DynamicNotebook.vala"
	self->priv->_tab = NULL;
#line 889 "DynamicNotebook.c"
}


static void
tab_page_container_finalize (GObject * obj)
{
	TabPageContainer * self;
#line 26 "../src/DynamicNotebook.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_TAB_PAGE_CONTAINER, TabPageContainer);
#line 26 "../src/DynamicNotebook.vala"
	G_OBJECT_CLASS (tab_page_container_parent_class)->finalize (obj);
#line 901 "DynamicNotebook.c"
}


GType
tab_page_container_get_type (void)
{
	static volatile gsize tab_page_container_type_id__volatile = 0;
	if (g_once_init_enter (&tab_page_container_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (TabPageContainerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tab_page_container_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (TabPageContainer), 0, (GInstanceInitFunc) tab_page_container_instance_init, NULL };
		GType tab_page_container_type_id;
		tab_page_container_type_id = g_type_register_static (gtk_event_box_get_type (), "TabPageContainer", &g_define_type_info, 0);
		TabPageContainer_private_offset = g_type_add_instance_private (tab_page_container_type_id, sizeof (TabPageContainerPrivate));
		g_once_init_leave (&tab_page_container_type_id__volatile, tab_page_container_type_id);
	}
	return tab_page_container_type_id__volatile;
}


static void
_vala_tab_page_container_get_property (GObject * object,
                                       guint property_id,
                                       GValue * value,
                                       GParamSpec * pspec)
{
	TabPageContainer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_TAB_PAGE_CONTAINER, TabPageContainer);
#line 26 "../src/DynamicNotebook.vala"
	switch (property_id) {
#line 26 "../src/DynamicNotebook.vala"
		case TAB_PAGE_CONTAINER_TAB_PROPERTY:
#line 26 "../src/DynamicNotebook.vala"
		g_value_set_object (value, tab_page_container_get_tab (self));
#line 26 "../src/DynamicNotebook.vala"
		break;
#line 936 "DynamicNotebook.c"
		default:
#line 26 "../src/DynamicNotebook.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 26 "../src/DynamicNotebook.vala"
		break;
#line 942 "DynamicNotebook.c"
	}
}


static void
_vala_tab_page_container_set_property (GObject * object,
                                       guint property_id,
                                       const GValue * value,
                                       GParamSpec * pspec)
{
	TabPageContainer * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_TAB_PAGE_CONTAINER, TabPageContainer);
#line 26 "../src/DynamicNotebook.vala"
	switch (property_id) {
#line 26 "../src/DynamicNotebook.vala"
		case TAB_PAGE_CONTAINER_TAB_PROPERTY:
#line 26 "../src/DynamicNotebook.vala"
		tab_page_container_set_tab (self, g_value_get_object (value));
#line 26 "../src/DynamicNotebook.vala"
		break;
#line 963 "DynamicNotebook.c"
		default:
#line 26 "../src/DynamicNotebook.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 26 "../src/DynamicNotebook.vala"
		break;
#line 969 "DynamicNotebook.c"
	}
}


static inline gpointer
tab_get_instance_private (Tab* self)
{
	return G_STRUCT_MEMBER_P (self, Tab_private_offset);
}


/**
         * With this you can construct a Tab. It is linked to the page that is shown on focus.
         * A Tab can have a icon on the right side. You can pass null on the constructor to
         * create a tab without a icon.
         **/
Tab*
tab_construct (GType object_type,
               const gchar* label,
               GIcon* icon,
               GtkWidget* page)
{
	Tab * self = NULL;
#line 212 "../src/DynamicNotebook.vala"
	self = (Tab*) g_object_new (object_type, "label", label, "icon", icon, NULL);
#line 213 "../src/DynamicNotebook.vala"
	if (page != NULL) {
#line 214 "../src/DynamicNotebook.vala"
		tab_set_page (self, page);
#line 999 "DynamicNotebook.c"
	}
#line 211 "../src/DynamicNotebook.vala"
	return self;
#line 1003 "DynamicNotebook.c"
}


Tab*
tab_new (const gchar* label,
         GIcon* icon,
         GtkWidget* page)
{
#line 211 "../src/DynamicNotebook.vala"
	return tab_construct (TYPE_TAB, label, icon, page);
#line 1014 "DynamicNotebook.c"
}


void
tab_close (Tab* self)
{
#line 374 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 375 "../src/DynamicNotebook.vala"
	g_signal_emit (self, tab_signals[TAB_CLOSED_SIGNAL], 0);
#line 1025 "DynamicNotebook.c"
}


static void
tab_update_close_button_visibility (Tab* self)
{
	GtkRevealer* _tmp0_;
	gboolean _tmp1_;
	GtkRevealer* _tmp2_;
	gboolean _tmp3_;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_;
	GtkRevealer* _tmp13_;
#line 378 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 381 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->close_button_revealer;
#line 381 "../src/DynamicNotebook.vala"
	_tmp1_ = self->priv->_pinned;
#line 381 "../src/DynamicNotebook.vala"
	gtk_widget_set_no_show_all ((GtkWidget*) _tmp0_, _tmp1_);
#line 382 "../src/DynamicNotebook.vala"
	_tmp2_ = self->priv->close_button_revealer;
#line 382 "../src/DynamicNotebook.vala"
	_tmp3_ = self->priv->_pinned;
#line 382 "../src/DynamicNotebook.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp2_, !_tmp3_);
#line 384 "../src/DynamicNotebook.vala"
	_tmp6_ = self->priv->_closable;
#line 384 "../src/DynamicNotebook.vala"
	if (_tmp6_) {
#line 1058 "DynamicNotebook.c"
		gboolean _tmp7_;
#line 384 "../src/DynamicNotebook.vala"
		_tmp7_ = self->priv->_pinned;
#line 384 "../src/DynamicNotebook.vala"
		_tmp5_ = !_tmp7_;
#line 1064 "DynamicNotebook.c"
	} else {
#line 384 "../src/DynamicNotebook.vala"
		_tmp5_ = FALSE;
#line 1068 "DynamicNotebook.c"
	}
#line 384 "../src/DynamicNotebook.vala"
	if (_tmp5_) {
#line 1072 "DynamicNotebook.c"
		gboolean _tmp8_ = FALSE;
		gboolean _tmp9_ = FALSE;
		gboolean _tmp10_;
#line 385 "../src/DynamicNotebook.vala"
		_tmp10_ = self->priv->cursor_over_tab;
#line 385 "../src/DynamicNotebook.vala"
		if (_tmp10_) {
#line 385 "../src/DynamicNotebook.vala"
			_tmp9_ = TRUE;
#line 1082 "DynamicNotebook.c"
		} else {
			gboolean _tmp11_;
#line 385 "../src/DynamicNotebook.vala"
			_tmp11_ = self->priv->cursor_over_close_button;
#line 385 "../src/DynamicNotebook.vala"
			_tmp9_ = _tmp11_;
#line 1089 "DynamicNotebook.c"
		}
#line 385 "../src/DynamicNotebook.vala"
		if (_tmp9_) {
#line 385 "../src/DynamicNotebook.vala"
			_tmp8_ = TRUE;
#line 1095 "DynamicNotebook.c"
		} else {
			gboolean _tmp12_;
#line 385 "../src/DynamicNotebook.vala"
			_tmp12_ = self->priv->_is_current_tab;
#line 385 "../src/DynamicNotebook.vala"
			_tmp8_ = _tmp12_;
#line 1102 "DynamicNotebook.c"
		}
#line 385 "../src/DynamicNotebook.vala"
		_tmp4_ = _tmp8_;
#line 1106 "DynamicNotebook.c"
	} else {
#line 384 "../src/DynamicNotebook.vala"
		_tmp4_ = FALSE;
#line 1110 "DynamicNotebook.c"
	}
#line 384 "../src/DynamicNotebook.vala"
	_tmp13_ = self->priv->close_button_revealer;
#line 384 "../src/DynamicNotebook.vala"
	gtk_revealer_set_reveal_child (_tmp13_, _tmp4_);
#line 1116 "DynamicNotebook.c"
}


static gboolean
tab_close_button_is_visible (Tab* self)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	GtkRevealer* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
#line 388 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 389 "../src/DynamicNotebook.vala"
	_tmp1_ = self->priv->close_button_revealer;
#line 389 "../src/DynamicNotebook.vala"
	_tmp2_ = gtk_widget_get_visible ((GtkWidget*) _tmp1_);
#line 389 "../src/DynamicNotebook.vala"
	_tmp3_ = _tmp2_;
#line 389 "../src/DynamicNotebook.vala"
	if (_tmp3_) {
#line 1138 "DynamicNotebook.c"
		GtkRevealer* _tmp4_;
		gboolean _tmp5_;
		gboolean _tmp6_;
#line 389 "../src/DynamicNotebook.vala"
		_tmp4_ = self->priv->close_button_revealer;
#line 389 "../src/DynamicNotebook.vala"
		_tmp5_ = gtk_revealer_get_child_revealed (_tmp4_);
#line 389 "../src/DynamicNotebook.vala"
		_tmp6_ = _tmp5_;
#line 389 "../src/DynamicNotebook.vala"
		_tmp0_ = _tmp6_;
#line 1150 "DynamicNotebook.c"
	} else {
#line 389 "../src/DynamicNotebook.vala"
		_tmp0_ = FALSE;
#line 1154 "DynamicNotebook.c"
	}
#line 389 "../src/DynamicNotebook.vala"
	result = _tmp0_;
#line 389 "../src/DynamicNotebook.vala"
	return result;
#line 1160 "DynamicNotebook.c"
}


const gchar*
tab_get_label (Tab* self)
{
	const gchar* result;
	GtkLabel* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
#line 49 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 49 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->_label;
#line 49 "../src/DynamicNotebook.vala"
	_tmp1_ = gtk_label_get_label (_tmp0_);
#line 49 "../src/DynamicNotebook.vala"
	_tmp2_ = _tmp1_;
#line 49 "../src/DynamicNotebook.vala"
	result = _tmp2_;
#line 49 "../src/DynamicNotebook.vala"
	return result;
#line 1183 "DynamicNotebook.c"
}


void
tab_set_label (Tab* self,
               const gchar* value)
{
	GtkLabel* _tmp0_;
#line 51 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 52 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->_label;
#line 52 "../src/DynamicNotebook.vala"
	gtk_label_set_label (_tmp0_, value);
#line 51 "../src/DynamicNotebook.vala"
	g_object_notify_by_pspec ((GObject *) self, tab_properties[TAB_LABEL_PROPERTY]);
#line 1200 "DynamicNotebook.c"
}


gchar*
tab_get_tooltip (Tab* self)
{
	gchar* result;
	GtkLabel* _tmp0_;
	gchar* _tmp1_;
#line 56 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 56 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->_label;
#line 56 "../src/DynamicNotebook.vala"
	_tmp1_ = gtk_widget_get_tooltip_text ((GtkWidget*) _tmp0_);
#line 56 "../src/DynamicNotebook.vala"
	result = _tmp1_;
#line 56 "../src/DynamicNotebook.vala"
	return result;
#line 1220 "DynamicNotebook.c"
}


void
tab_set_tooltip (Tab* self,
                 const gchar* value)
{
	GtkLabel* _tmp0_;
#line 57 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 57 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->_label;
#line 57 "../src/DynamicNotebook.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp0_, value);
#line 57 "../src/DynamicNotebook.vala"
	g_object_notify_by_pspec ((GObject *) self, tab_properties[TAB_TOOLTIP_PROPERTY]);
#line 1237 "DynamicNotebook.c"
}


gboolean
tab_get_pinned (Tab* self)
{
	gboolean result;
	gboolean _tmp0_;
#line 62 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 62 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->_pinned;
#line 62 "../src/DynamicNotebook.vala"
	result = _tmp0_;
#line 62 "../src/DynamicNotebook.vala"
	return result;
#line 1254 "DynamicNotebook.c"
}


void
tab_set_pinned (Tab* self,
                gboolean value)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 64 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 65 "../src/DynamicNotebook.vala"
	_tmp0_ = tab_get_pinnable (self);
#line 65 "../src/DynamicNotebook.vala"
	_tmp1_ = _tmp0_;
#line 65 "../src/DynamicNotebook.vala"
	if (_tmp1_) {
#line 1272 "DynamicNotebook.c"
		gboolean _tmp2_;
#line 66 "../src/DynamicNotebook.vala"
		_tmp2_ = self->priv->_pinned;
#line 66 "../src/DynamicNotebook.vala"
		if (value != _tmp2_) {
#line 67 "../src/DynamicNotebook.vala"
			if (value) {
#line 1280 "DynamicNotebook.c"
				GtkLabel* _tmp3_;
				GtkImage* _tmp4_;
				GtkSpinner* _tmp5_;
#line 68 "../src/DynamicNotebook.vala"
				_tmp3_ = self->priv->_label;
#line 68 "../src/DynamicNotebook.vala"
				gtk_widget_set_visible ((GtkWidget*) _tmp3_, FALSE);
#line 69 "../src/DynamicNotebook.vala"
				_tmp4_ = self->_icon;
#line 69 "../src/DynamicNotebook.vala"
				gtk_widget_set_margin_start ((GtkWidget*) _tmp4_, 1);
#line 70 "../src/DynamicNotebook.vala"
				_tmp5_ = self->priv->_working;
#line 70 "../src/DynamicNotebook.vala"
				gtk_widget_set_margin_start ((GtkWidget*) _tmp5_, 1);
#line 1296 "DynamicNotebook.c"
			} else {
				GtkLabel* _tmp6_;
				GtkImage* _tmp7_;
				GtkSpinner* _tmp8_;
#line 72 "../src/DynamicNotebook.vala"
				_tmp6_ = self->priv->_label;
#line 72 "../src/DynamicNotebook.vala"
				gtk_widget_set_visible ((GtkWidget*) _tmp6_, TRUE);
#line 73 "../src/DynamicNotebook.vala"
				_tmp7_ = self->_icon;
#line 73 "../src/DynamicNotebook.vala"
				gtk_widget_set_margin_start ((GtkWidget*) _tmp7_, 0);
#line 74 "../src/DynamicNotebook.vala"
				_tmp8_ = self->priv->_working;
#line 74 "../src/DynamicNotebook.vala"
				gtk_widget_set_margin_start ((GtkWidget*) _tmp8_, 0);
#line 1313 "DynamicNotebook.c"
			}
#line 77 "../src/DynamicNotebook.vala"
			self->priv->_pinned = value;
#line 78 "../src/DynamicNotebook.vala"
			tab_update_close_button_visibility (self);
#line 79 "../src/DynamicNotebook.vala"
			g_signal_emit (self, tab_signals[TAB_PIN_SWITCH_SIGNAL], 0);
#line 1321 "DynamicNotebook.c"
		}
	}
#line 64 "../src/DynamicNotebook.vala"
	g_object_notify_by_pspec ((GObject *) self, tab_properties[TAB_PINNED_PROPERTY]);
#line 1326 "DynamicNotebook.c"
}


gboolean
tab_get_pinnable (Tab* self)
{
	gboolean result;
	gboolean _tmp0_;
#line 87 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 87 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->_pinnable;
#line 87 "../src/DynamicNotebook.vala"
	result = _tmp0_;
#line 87 "../src/DynamicNotebook.vala"
	return result;
#line 1343 "DynamicNotebook.c"
}


void
tab_set_pinnable (Tab* self,
                  gboolean value)
{
#line 88 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 89 "../src/DynamicNotebook.vala"
	if (!value) {
#line 90 "../src/DynamicNotebook.vala"
		tab_set_pinned (self, FALSE);
#line 1357 "DynamicNotebook.c"
	}
#line 93 "../src/DynamicNotebook.vala"
	self->priv->_pinnable = value;
#line 88 "../src/DynamicNotebook.vala"
	g_object_notify_by_pspec ((GObject *) self, tab_properties[TAB_PINNABLE_PROPERTY]);
#line 1363 "DynamicNotebook.c"
}


const gchar*
tab_get_restore_data (Tab* self)
{
	const gchar* result;
	const gchar* _tmp0_;
#line 102 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 102 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->_restore_data;
#line 102 "../src/DynamicNotebook.vala"
	result = _tmp0_;
#line 102 "../src/DynamicNotebook.vala"
	return result;
#line 1380 "DynamicNotebook.c"
}


void
tab_set_restore_data (Tab* self,
                      const gchar* value)
{
#line 102 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 102 "../src/DynamicNotebook.vala"
	if (g_strcmp0 (value, tab_get_restore_data (self)) != 0) {
#line 1392 "DynamicNotebook.c"
		gchar* _tmp0_;
#line 102 "../src/DynamicNotebook.vala"
		_tmp0_ = g_strdup (value);
#line 102 "../src/DynamicNotebook.vala"
		_g_free0 (self->priv->_restore_data);
#line 102 "../src/DynamicNotebook.vala"
		self->priv->_restore_data = _tmp0_;
#line 102 "../src/DynamicNotebook.vala"
		g_object_notify_by_pspec ((GObject *) self, tab_properties[TAB_RESTORE_DATA_PROPERTY]);
#line 1402 "DynamicNotebook.c"
	}
}


GtkWidget*
tab_get_page (Tab* self)
{
	GtkWidget* result;
	TabPageContainer* _tmp0_;
	GtkWidget* _tmp1_;
#line 115 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 116 "../src/DynamicNotebook.vala"
	_tmp0_ = self->page_container;
#line 116 "../src/DynamicNotebook.vala"
	_tmp1_ = gtk_bin_get_child ((GtkBin*) _tmp0_);
#line 116 "../src/DynamicNotebook.vala"
	result = _tmp1_;
#line 116 "../src/DynamicNotebook.vala"
	return result;
#line 1423 "DynamicNotebook.c"
}


void
tab_set_page (Tab* self,
              GtkWidget* value)
{
	GtkWidget* container_child = NULL;
	TabPageContainer* _tmp0_;
	GtkWidget* _tmp1_;
	GtkWidget* _tmp2_;
	GtkContainer* value_parent = NULL;
	GtkContainer* _tmp5_;
	GtkContainer* _tmp6_;
	TabPageContainer* _tmp10_;
#line 118 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 119 "../src/DynamicNotebook.vala"
	_tmp0_ = self->page_container;
#line 119 "../src/DynamicNotebook.vala"
	_tmp1_ = gtk_bin_get_child ((GtkBin*) _tmp0_);
#line 119 "../src/DynamicNotebook.vala"
	container_child = _tmp1_;
#line 120 "../src/DynamicNotebook.vala"
	_tmp2_ = container_child;
#line 120 "../src/DynamicNotebook.vala"
	if (_tmp2_ != NULL) {
#line 1451 "DynamicNotebook.c"
		TabPageContainer* _tmp3_;
		GtkWidget* _tmp4_;
#line 121 "../src/DynamicNotebook.vala"
		_tmp3_ = self->page_container;
#line 121 "../src/DynamicNotebook.vala"
		_tmp4_ = container_child;
#line 121 "../src/DynamicNotebook.vala"
		gtk_container_remove ((GtkContainer*) _tmp3_, _tmp4_);
#line 1460 "DynamicNotebook.c"
	}
#line 124 "../src/DynamicNotebook.vala"
	_tmp5_ = gtk_widget_get_parent (value);
#line 124 "../src/DynamicNotebook.vala"
	value_parent = _tmp5_;
#line 125 "../src/DynamicNotebook.vala"
	_tmp6_ = value_parent;
#line 125 "../src/DynamicNotebook.vala"
	if (_tmp6_ != NULL) {
#line 1470 "DynamicNotebook.c"
		GtkContainer* _tmp7_;
		TabPageContainer* _tmp8_;
#line 126 "../src/DynamicNotebook.vala"
		_tmp7_ = value_parent;
#line 126 "../src/DynamicNotebook.vala"
		gtk_container_remove (_tmp7_, value);
#line 127 "../src/DynamicNotebook.vala"
		_tmp8_ = self->page_container;
#line 127 "../src/DynamicNotebook.vala"
		gtk_container_add ((GtkContainer*) _tmp8_, value);
#line 1481 "DynamicNotebook.c"
	} else {
		TabPageContainer* _tmp9_;
#line 129 "../src/DynamicNotebook.vala"
		_tmp9_ = self->page_container;
#line 129 "../src/DynamicNotebook.vala"
		gtk_container_add ((GtkContainer*) _tmp9_, value);
#line 1488 "DynamicNotebook.c"
	}
#line 132 "../src/DynamicNotebook.vala"
	_tmp10_ = self->page_container;
#line 132 "../src/DynamicNotebook.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp10_);
#line 118 "../src/DynamicNotebook.vala"
	g_object_notify_by_pspec ((GObject *) self, tab_properties[TAB_PAGE_PROPERTY]);
#line 1496 "DynamicNotebook.c"
}


GIcon*
tab_get_icon (Tab* self)
{
	GIcon* result;
	GtkImage* _tmp0_;
	GIcon* _tmp1_;
	GIcon* _tmp2_;
#line 138 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 138 "../src/DynamicNotebook.vala"
	_tmp0_ = self->_icon;
#line 138 "../src/DynamicNotebook.vala"
	g_object_get (_tmp0_, "gicon", &_tmp1_, NULL);
#line 138 "../src/DynamicNotebook.vala"
	_tmp2_ = _tmp1_;
#line 138 "../src/DynamicNotebook.vala"
	result = _tmp2_;
#line 138 "../src/DynamicNotebook.vala"
	return result;
#line 1519 "DynamicNotebook.c"
}


void
tab_set_icon (Tab* self,
              GIcon* value)
{
	GtkImage* _tmp0_;
#line 139 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 139 "../src/DynamicNotebook.vala"
	_tmp0_ = self->_icon;
#line 139 "../src/DynamicNotebook.vala"
	g_object_set (_tmp0_, "gicon", value, NULL);
#line 139 "../src/DynamicNotebook.vala"
	g_object_notify_by_pspec ((GObject *) self, tab_properties[TAB_ICON_PROPERTY]);
#line 1536 "DynamicNotebook.c"
}


gboolean
tab_get_working (Tab* self)
{
	gboolean result;
	gboolean _tmp0_;
#line 145 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 145 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->__working;
#line 145 "../src/DynamicNotebook.vala"
	result = _tmp0_;
#line 145 "../src/DynamicNotebook.vala"
	return result;
#line 1553 "DynamicNotebook.c"
}


void
tab_set_working (Tab* self,
                 gboolean value)
{
	GtkSpinner* _tmp0_;
	GtkImage* _tmp1_;
#line 147 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 148 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->_working;
#line 148 "../src/DynamicNotebook.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp0_, value);
#line 148 "../src/DynamicNotebook.vala"
	self->priv->__working = value;
#line 149 "../src/DynamicNotebook.vala"
	_tmp1_ = self->_icon;
#line 149 "../src/DynamicNotebook.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp1_, !value);
#line 147 "../src/DynamicNotebook.vala"
	g_object_notify_by_pspec ((GObject *) self, tab_properties[TAB_WORKING_PROPERTY]);
#line 1577 "DynamicNotebook.c"
}


PangoEllipsizeMode
tab_get_ellipsize_mode (Tab* self)
{
	PangoEllipsizeMode result;
	GtkLabel* _tmp0_;
	PangoEllipsizeMode _tmp1_;
	PangoEllipsizeMode _tmp2_;
#line 154 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 154 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->_label;
#line 154 "../src/DynamicNotebook.vala"
	_tmp1_ = gtk_label_get_ellipsize (_tmp0_);
#line 154 "../src/DynamicNotebook.vala"
	_tmp2_ = _tmp1_;
#line 154 "../src/DynamicNotebook.vala"
	result = _tmp2_;
#line 154 "../src/DynamicNotebook.vala"
	return result;
#line 1600 "DynamicNotebook.c"
}


void
tab_set_ellipsize_mode (Tab* self,
                        PangoEllipsizeMode value)
{
	GtkLabel* _tmp0_;
#line 155 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 155 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->_label;
#line 155 "../src/DynamicNotebook.vala"
	gtk_label_set_ellipsize (_tmp0_, value);
#line 155 "../src/DynamicNotebook.vala"
	g_object_notify_by_pspec ((GObject *) self, tab_properties[TAB_ELLIPSIZE_MODE_PROPERTY]);
#line 1617 "DynamicNotebook.c"
}


gboolean
tab_get_fixed (Tab* self)
{
	gboolean result;
	gboolean _tmp0_;
#line 161 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 161 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->_fixed;
#line 161 "../src/DynamicNotebook.vala"
	result = _tmp0_;
#line 161 "../src/DynamicNotebook.vala"
	return result;
#line 1634 "DynamicNotebook.c"
}


void
tab_set_fixed (Tab* self,
               gboolean value)
{
	gboolean _tmp0_;
#line 162 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 163 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->_fixed;
#line 163 "../src/DynamicNotebook.vala"
	if (value != _tmp0_) {
#line 1649 "DynamicNotebook.c"
		GtkLabel* _tmp1_;
#line 164 "../src/DynamicNotebook.vala"
		self->priv->_fixed = value;
#line 165 "../src/DynamicNotebook.vala"
		_tmp1_ = self->priv->_label;
#line 165 "../src/DynamicNotebook.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp1_, value);
#line 1657 "DynamicNotebook.c"
	}
#line 162 "../src/DynamicNotebook.vala"
	g_object_notify_by_pspec ((GObject *) self, tab_properties[TAB_FIXED_PROPERTY]);
#line 1661 "DynamicNotebook.c"
}


GtkMenu*
tab_get_menu (Tab* self)
{
	GtkMenu* result;
	GtkMenu* _tmp0_;
#line 170 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 170 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->_menu;
#line 170 "../src/DynamicNotebook.vala"
	result = _tmp0_;
#line 170 "../src/DynamicNotebook.vala"
	return result;
#line 1678 "DynamicNotebook.c"
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 170 "../src/DynamicNotebook.vala"
	return self ? g_object_ref (self) : NULL;
#line 1687 "DynamicNotebook.c"
}


void
tab_set_menu (Tab* self,
              GtkMenu* value)
{
#line 170 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 170 "../src/DynamicNotebook.vala"
	if (tab_get_menu (self) != value) {
#line 1699 "DynamicNotebook.c"
		GtkMenu* _tmp0_;
#line 170 "../src/DynamicNotebook.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 170 "../src/DynamicNotebook.vala"
		_g_object_unref0 (self->priv->_menu);
#line 170 "../src/DynamicNotebook.vala"
		self->priv->_menu = _tmp0_;
#line 170 "../src/DynamicNotebook.vala"
		g_object_notify_by_pspec ((GObject *) self, tab_properties[TAB_MENU_PROPERTY]);
#line 1709 "DynamicNotebook.c"
	}
}


void
tab_set_closable (Tab* self,
                  gboolean value)
{
	gboolean _tmp0_;
#line 174 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 175 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->_closable;
#line 175 "../src/DynamicNotebook.vala"
	if (value == _tmp0_) {
#line 176 "../src/DynamicNotebook.vala"
		return;
#line 1727 "DynamicNotebook.c"
	}
#line 178 "../src/DynamicNotebook.vala"
	self->priv->_closable = value;
#line 179 "../src/DynamicNotebook.vala"
	tab_update_close_button_visibility (self);
#line 174 "../src/DynamicNotebook.vala"
	g_object_notify_by_pspec ((GObject *) self, tab_properties[TAB_CLOSABLE_PROPERTY]);
#line 1735 "DynamicNotebook.c"
}


void
tab_set_is_current_tab (Tab* self,
                        gboolean value)
{
#line 190 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 191 "../src/DynamicNotebook.vala"
	self->priv->_is_current_tab = value;
#line 192 "../src/DynamicNotebook.vala"
	tab_update_close_button_visibility (self);
#line 190 "../src/DynamicNotebook.vala"
	g_object_notify_by_pspec ((GObject *) self, tab_properties[TAB_IS_CURRENT_TAB_PROPERTY]);
#line 1751 "DynamicNotebook.c"
}


static Block7Data*
block7_data_ref (Block7Data* _data7_)
{
#line 218 "../src/DynamicNotebook.vala"
	g_atomic_int_inc (&_data7_->_ref_count_);
#line 218 "../src/DynamicNotebook.vala"
	return _data7_;
#line 1762 "DynamicNotebook.c"
}


static void
block7_data_unref (void * _userdata_)
{
	Block7Data* _data7_;
	_data7_ = (Block7Data*) _userdata_;
#line 218 "../src/DynamicNotebook.vala"
	if (g_atomic_int_dec_and_test (&_data7_->_ref_count_)) {
#line 1773 "DynamicNotebook.c"
		Tab* self;
#line 218 "../src/DynamicNotebook.vala"
		self = _data7_->self;
#line 218 "../src/DynamicNotebook.vala"
		_g_object_unref0 (_data7_->close_other_m);
#line 218 "../src/DynamicNotebook.vala"
		_g_object_unref0 (self);
#line 218 "../src/DynamicNotebook.vala"
		g_slice_free (Block7Data, _data7_);
#line 1783 "DynamicNotebook.c"
	}
}


static void
_tab___lambda4_ (Tab* self)
{
#line 270 "../src/DynamicNotebook.vala"
	g_signal_emit (self, tab_signals[TAB_CLOSED_SIGNAL], 0);
#line 1793 "DynamicNotebook.c"
}


static void
__tab___lambda4__gtk_menu_item_activate (GtkMenuItem* _sender,
                                         gpointer self)
{
#line 270 "../src/DynamicNotebook.vala"
	_tab___lambda4_ ((Tab*) self);
#line 1803 "DynamicNotebook.c"
}


static void
_tab___lambda5_ (Tab* self)
{
#line 271 "../src/DynamicNotebook.vala"
	g_signal_emit (self, tab_signals[TAB_CLOSE_OTHERS_SIGNAL], 0);
#line 1812 "DynamicNotebook.c"
}


static void
__tab___lambda5__gtk_menu_item_activate (GtkMenuItem* _sender,
                                         gpointer self)
{
#line 271 "../src/DynamicNotebook.vala"
	_tab___lambda5_ ((Tab*) self);
#line 1822 "DynamicNotebook.c"
}


static void
_tab___lambda6_ (Tab* self)
{
#line 272 "../src/DynamicNotebook.vala"
	g_signal_emit (self, tab_signals[TAB_NEW_WINDOW_SIGNAL], 0);
#line 1831 "DynamicNotebook.c"
}


static void
__tab___lambda6__gtk_menu_item_activate (GtkMenuItem* _sender,
                                         gpointer self)
{
#line 272 "../src/DynamicNotebook.vala"
	_tab___lambda6_ ((Tab*) self);
#line 1841 "DynamicNotebook.c"
}


static void
_tab___lambda7_ (Tab* self)
{
#line 273 "../src/DynamicNotebook.vala"
	g_signal_emit (self, tab_signals[TAB_DUPLICATE_SIGNAL], 0);
#line 1850 "DynamicNotebook.c"
}


static void
__tab___lambda7__gtk_menu_item_activate (GtkMenuItem* _sender,
                                         gpointer self)
{
#line 273 "../src/DynamicNotebook.vala"
	_tab___lambda7_ ((Tab*) self);
#line 1860 "DynamicNotebook.c"
}


static void
_tab___lambda8_ (Tab* self)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 274 "../src/DynamicNotebook.vala"
	_tmp0_ = tab_get_pinned (self);
#line 274 "../src/DynamicNotebook.vala"
	_tmp1_ = _tmp0_;
#line 274 "../src/DynamicNotebook.vala"
	tab_set_pinned (self, !_tmp1_);
#line 1875 "DynamicNotebook.c"
}


static void
__tab___lambda8__gtk_menu_item_activate (GtkMenuItem* _sender,
                                         gpointer self)
{
#line 274 "../src/DynamicNotebook.vala"
	_tab___lambda8_ ((Tab*) self);
#line 1885 "DynamicNotebook.c"
}


static gboolean
_tab___lambda9_ (Tab* self,
                 GdkEventScroll* e)
{
	gboolean result = FALSE;
	GtkNotebook* notebook = NULL;
	GtkContainer* _tmp0_;
	GtkNotebook* _tmp1_;
	GdkScrollDirection _tmp2_;
#line 276 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 277 "../src/DynamicNotebook.vala"
	_tmp0_ = gtk_widget_get_parent ((GtkWidget*) self);
#line 277 "../src/DynamicNotebook.vala"
	_tmp1_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp0_, gtk_notebook_get_type ()) ? ((GtkNotebook*) _tmp0_) : NULL);
#line 277 "../src/DynamicNotebook.vala"
	notebook = _tmp1_;
#line 278 "../src/DynamicNotebook.vala"
	_tmp2_ = e->direction;
#line 278 "../src/DynamicNotebook.vala"
	switch (_tmp2_) {
#line 278 "../src/DynamicNotebook.vala"
		case GDK_SCROLL_UP:
#line 278 "../src/DynamicNotebook.vala"
		case GDK_SCROLL_LEFT:
#line 1914 "DynamicNotebook.c"
		{
			GtkNotebook* _tmp3_;
			gint _tmp4_;
			gint _tmp5_;
#line 281 "../src/DynamicNotebook.vala"
			_tmp3_ = notebook;
#line 281 "../src/DynamicNotebook.vala"
			g_object_get (_tmp3_, "page", &_tmp4_, NULL);
#line 281 "../src/DynamicNotebook.vala"
			_tmp5_ = _tmp4_;
#line 281 "../src/DynamicNotebook.vala"
			if (_tmp5_ > 0) {
#line 1927 "DynamicNotebook.c"
				GtkNotebook* _tmp6_;
				gint _tmp7_;
				gint _tmp8_;
#line 282 "../src/DynamicNotebook.vala"
				_tmp6_ = notebook;
#line 282 "../src/DynamicNotebook.vala"
				g_object_get (_tmp6_, "page", &_tmp7_, NULL);
#line 282 "../src/DynamicNotebook.vala"
				_tmp8_ = _tmp7_;
#line 282 "../src/DynamicNotebook.vala"
				g_object_set (_tmp6_, "page", _tmp8_ - 1, NULL);
#line 283 "../src/DynamicNotebook.vala"
				result = TRUE;
#line 283 "../src/DynamicNotebook.vala"
				_g_object_unref0 (notebook);
#line 283 "../src/DynamicNotebook.vala"
				return result;
#line 1945 "DynamicNotebook.c"
			}
#line 285 "../src/DynamicNotebook.vala"
			break;
#line 1949 "DynamicNotebook.c"
		}
#line 278 "../src/DynamicNotebook.vala"
		case GDK_SCROLL_DOWN:
#line 278 "../src/DynamicNotebook.vala"
		case GDK_SCROLL_RIGHT:
#line 1955 "DynamicNotebook.c"
		{
			GtkNotebook* _tmp9_;
			gint _tmp10_;
			gint _tmp11_;
			GtkNotebook* _tmp12_;
#line 289 "../src/DynamicNotebook.vala"
			_tmp9_ = notebook;
#line 289 "../src/DynamicNotebook.vala"
			g_object_get (_tmp9_, "page", &_tmp10_, NULL);
#line 289 "../src/DynamicNotebook.vala"
			_tmp11_ = _tmp10_;
#line 289 "../src/DynamicNotebook.vala"
			_tmp12_ = notebook;
#line 289 "../src/DynamicNotebook.vala"
			if (_tmp11_ < gtk_notebook_get_n_pages (_tmp12_)) {
#line 1971 "DynamicNotebook.c"
				GtkNotebook* _tmp13_;
				gint _tmp14_;
				gint _tmp15_;
#line 290 "../src/DynamicNotebook.vala"
				_tmp13_ = notebook;
#line 290 "../src/DynamicNotebook.vala"
				g_object_get (_tmp13_, "page", &_tmp14_, NULL);
#line 290 "../src/DynamicNotebook.vala"
				_tmp15_ = _tmp14_;
#line 290 "../src/DynamicNotebook.vala"
				g_object_set (_tmp13_, "page", _tmp15_ + 1, NULL);
#line 291 "../src/DynamicNotebook.vala"
				result = TRUE;
#line 291 "../src/DynamicNotebook.vala"
				_g_object_unref0 (notebook);
#line 291 "../src/DynamicNotebook.vala"
				return result;
#line 1989 "DynamicNotebook.c"
			}
#line 293 "../src/DynamicNotebook.vala"
			break;
#line 1993 "DynamicNotebook.c"
		}
		default:
#line 278 "../src/DynamicNotebook.vala"
		break;
#line 1998 "DynamicNotebook.c"
	}
#line 296 "../src/DynamicNotebook.vala"
	result = FALSE;
#line 296 "../src/DynamicNotebook.vala"
	_g_object_unref0 (notebook);
#line 296 "../src/DynamicNotebook.vala"
	return result;
#line 2006 "DynamicNotebook.c"
}


static gboolean
__tab___lambda9__gtk_widget_scroll_event (GtkWidget* _sender,
                                          GdkEventScroll* event,
                                          gpointer self)
{
	gboolean result;
	result = _tab___lambda9_ ((Tab*) self, event);
#line 276 "../src/DynamicNotebook.vala"
	return result;
#line 2019 "DynamicNotebook.c"
}


static gboolean
_tab___lambda10_ (Block7Data* _data7_,
                  GdkEventButton* e)
{
	Tab* self;
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	guint _tmp1_;
#line 299 "../src/DynamicNotebook.vala"
	self = _data7_->self;
#line 299 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 300 "../src/DynamicNotebook.vala"
	_tmp1_ = e->button;
#line 300 "../src/DynamicNotebook.vala"
	if (_tmp1_ == ((guint) 2)) {
#line 300 "../src/DynamicNotebook.vala"
		_tmp0_ = tab_close_button_is_visible (self);
#line 2041 "DynamicNotebook.c"
	} else {
#line 300 "../src/DynamicNotebook.vala"
		_tmp0_ = FALSE;
#line 2045 "DynamicNotebook.c"
	}
#line 300 "../src/DynamicNotebook.vala"
	if (_tmp0_) {
#line 2049 "DynamicNotebook.c"
		GdkModifierType _tmp2_;
		GdkModifierType _tmp3_;
#line 301 "../src/DynamicNotebook.vala"
		_tmp2_ = e->state;
#line 301 "../src/DynamicNotebook.vala"
		e->state = _tmp2_ & MODIFIER_MASK;
#line 303 "../src/DynamicNotebook.vala"
		_tmp3_ = e->state;
#line 303 "../src/DynamicNotebook.vala"
		if (_tmp3_ == 0) {
#line 304 "../src/DynamicNotebook.vala"
			g_signal_emit (self, tab_signals[TAB_CLOSED_SIGNAL], 0);
#line 2062 "DynamicNotebook.c"
		} else {
			GdkModifierType _tmp4_;
#line 305 "../src/DynamicNotebook.vala"
			_tmp4_ = e->state;
#line 305 "../src/DynamicNotebook.vala"
			if (_tmp4_ == GDK_SHIFT_MASK) {
#line 306 "../src/DynamicNotebook.vala"
				g_signal_emit (self, tab_signals[TAB_CLOSE_OTHERS_SIGNAL], 0);
#line 2071 "DynamicNotebook.c"
			}
		}
	} else {
		gboolean _tmp5_ = FALSE;
		gboolean _tmp6_ = FALSE;
		guint _tmp7_;
#line 308 "../src/DynamicNotebook.vala"
		_tmp7_ = e->button;
#line 308 "../src/DynamicNotebook.vala"
		if (_tmp7_ == ((guint) 1)) {
#line 2082 "DynamicNotebook.c"
			GdkEventType _tmp8_;
#line 308 "../src/DynamicNotebook.vala"
			_tmp8_ = e->type;
#line 308 "../src/DynamicNotebook.vala"
			_tmp6_ = _tmp8_ == GDK_2BUTTON_PRESS;
#line 2088 "DynamicNotebook.c"
		} else {
#line 308 "../src/DynamicNotebook.vala"
			_tmp6_ = FALSE;
#line 2092 "DynamicNotebook.c"
		}
#line 308 "../src/DynamicNotebook.vala"
		if (_tmp6_) {
#line 2096 "DynamicNotebook.c"
			GtkMenuItem* _tmp9_;
			gboolean _tmp10_;
			gboolean _tmp11_;
#line 308 "../src/DynamicNotebook.vala"
			_tmp9_ = self->duplicate_m;
#line 308 "../src/DynamicNotebook.vala"
			_tmp10_ = gtk_widget_get_visible ((GtkWidget*) _tmp9_);
#line 308 "../src/DynamicNotebook.vala"
			_tmp11_ = _tmp10_;
#line 308 "../src/DynamicNotebook.vala"
			_tmp5_ = _tmp11_;
#line 2108 "DynamicNotebook.c"
		} else {
#line 308 "../src/DynamicNotebook.vala"
			_tmp5_ = FALSE;
#line 2112 "DynamicNotebook.c"
		}
#line 308 "../src/DynamicNotebook.vala"
		if (_tmp5_) {
#line 309 "../src/DynamicNotebook.vala"
			g_signal_emit (self, tab_signals[TAB_DUPLICATE_SIGNAL], 0);
#line 2118 "DynamicNotebook.c"
		} else {
			guint _tmp12_;
#line 310 "../src/DynamicNotebook.vala"
			_tmp12_ = e->button;
#line 310 "../src/DynamicNotebook.vala"
			if (_tmp12_ == ((guint) 3)) {
#line 2125 "DynamicNotebook.c"
				GtkMenu* _tmp13_;
				GtkContainer* cont = NULL;
				GtkContainer* _tmp14_;
				GtkContainer* _tmp15_;
				guint _tmp16_ = 0U;
				GtkContainer* _tmp17_;
				guint num_tabs = 0U;
				GtkMenuItem* _tmp21_;
				guint _tmp22_;
				GtkMenuItem* _tmp23_;
				guint _tmp24_;
				GtkMenuItem* _tmp25_;
				guint _tmp26_;
				GtkMenuItem* _tmp27_;
				gboolean _tmp28_;
				gboolean _tmp29_;
#line 311 "../src/DynamicNotebook.vala"
				_tmp13_ = self->priv->_menu;
#line 311 "../src/DynamicNotebook.vala"
				gtk_menu_popup_at_pointer (_tmp13_, (GdkEvent*) e);
#line 312 "../src/DynamicNotebook.vala"
				_tmp14_ = gtk_widget_get_parent ((GtkWidget*) self);
#line 312 "../src/DynamicNotebook.vala"
				_tmp15_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp14_, gtk_container_get_type ()) ? ((GtkContainer*) _tmp14_) : NULL);
#line 312 "../src/DynamicNotebook.vala"
				cont = _tmp15_;
#line 313 "../src/DynamicNotebook.vala"
				_tmp17_ = cont;
#line 313 "../src/DynamicNotebook.vala"
				if (_tmp17_ == NULL) {
#line 313 "../src/DynamicNotebook.vala"
					_tmp16_ = (guint) 0;
#line 2158 "DynamicNotebook.c"
				} else {
					GtkContainer* _tmp18_;
					GList* _tmp19_;
					GList* _tmp20_;
#line 313 "../src/DynamicNotebook.vala"
					_tmp18_ = cont;
#line 313 "../src/DynamicNotebook.vala"
					_tmp19_ = gtk_container_get_children (_tmp18_);
#line 313 "../src/DynamicNotebook.vala"
					_tmp20_ = _tmp19_;
#line 313 "../src/DynamicNotebook.vala"
					_tmp16_ = g_list_length (_tmp20_);
#line 313 "../src/DynamicNotebook.vala"
					(_tmp20_ == NULL) ? NULL : (_tmp20_ = (g_list_free (_tmp20_), NULL));
#line 2173 "DynamicNotebook.c"
				}
#line 313 "../src/DynamicNotebook.vala"
				num_tabs = _tmp16_;
#line 314 "../src/DynamicNotebook.vala"
				_tmp21_ = _data7_->close_other_m;
#line 314 "../src/DynamicNotebook.vala"
				_tmp22_ = num_tabs;
#line 314 "../src/DynamicNotebook.vala"
				gtk_menu_item_set_label (_tmp21_, ngettext (_ ("Close Other Tab"), _ ("Close Other Tabs"), (gulong) (_tmp22_ - 1)));
#line 315 "../src/DynamicNotebook.vala"
				_tmp23_ = _data7_->close_other_m;
#line 315 "../src/DynamicNotebook.vala"
				_tmp24_ = num_tabs;
#line 315 "../src/DynamicNotebook.vala"
				gtk_widget_set_sensitive ((GtkWidget*) _tmp23_, _tmp24_ != ((guint) 1));
#line 316 "../src/DynamicNotebook.vala"
				_tmp25_ = self->new_window_m;
#line 316 "../src/DynamicNotebook.vala"
				_tmp26_ = num_tabs;
#line 316 "../src/DynamicNotebook.vala"
				gtk_widget_set_sensitive ((GtkWidget*) _tmp25_, _tmp26_ != ((guint) 1));
#line 317 "../src/DynamicNotebook.vala"
				_tmp27_ = self->pin_m;
#line 317 "../src/DynamicNotebook.vala"
				gtk_menu_item_set_label (_tmp27_, "Pin");
#line 318 "../src/DynamicNotebook.vala"
				_tmp28_ = tab_get_pinned (self);
#line 318 "../src/DynamicNotebook.vala"
				_tmp29_ = _tmp28_;
#line 318 "../src/DynamicNotebook.vala"
				if (_tmp29_) {
#line 2205 "DynamicNotebook.c"
					GtkMenuItem* _tmp30_;
#line 319 "../src/DynamicNotebook.vala"
					_tmp30_ = self->pin_m;
#line 319 "../src/DynamicNotebook.vala"
					gtk_menu_item_set_label (_tmp30_, "Unpin");
#line 2211 "DynamicNotebook.c"
				}
#line 310 "../src/DynamicNotebook.vala"
				_g_object_unref0 (cont);
#line 2215 "DynamicNotebook.c"
			} else {
#line 322 "../src/DynamicNotebook.vala"
				result = FALSE;
#line 322 "../src/DynamicNotebook.vala"
				return result;
#line 2221 "DynamicNotebook.c"
			}
		}
	}
#line 325 "../src/DynamicNotebook.vala"
	result = TRUE;
#line 325 "../src/DynamicNotebook.vala"
	return result;
#line 2229 "DynamicNotebook.c"
}


static gboolean
__tab___lambda10__gtk_widget_button_press_event (GtkWidget* _sender,
                                                 GdkEventButton* event,
                                                 gpointer self)
{
	gboolean result;
	result = _tab___lambda10_ (self, event);
#line 299 "../src/DynamicNotebook.vala"
	return result;
#line 2242 "DynamicNotebook.c"
}


static gboolean
_tab___lambda11_ (Tab* self,
                  GdkEventCrossing* e)
{
	gboolean result = FALSE;
#line 328 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 329 "../src/DynamicNotebook.vala"
	self->priv->cursor_over_tab = TRUE;
#line 330 "../src/DynamicNotebook.vala"
	tab_update_close_button_visibility (self);
#line 331 "../src/DynamicNotebook.vala"
	result = FALSE;
#line 331 "../src/DynamicNotebook.vala"
	return result;
#line 2261 "DynamicNotebook.c"
}


static gboolean
__tab___lambda11__gtk_widget_enter_notify_event (GtkWidget* _sender,
                                                 GdkEventCrossing* event,
                                                 gpointer self)
{
	gboolean result;
	result = _tab___lambda11_ ((Tab*) self, event);
#line 328 "../src/DynamicNotebook.vala"
	return result;
#line 2274 "DynamicNotebook.c"
}


static gboolean
_tab___lambda12_ (Tab* self,
                  GdkEventCrossing* e)
{
	gboolean result = FALSE;
	gboolean _tmp0_;
#line 334 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 337 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->cursor_over_tab;
#line 337 "../src/DynamicNotebook.vala"
	if (!_tmp0_) {
#line 338 "../src/DynamicNotebook.vala"
		result = FALSE;
#line 338 "../src/DynamicNotebook.vala"
		return result;
#line 2294 "DynamicNotebook.c"
	}
#line 340 "../src/DynamicNotebook.vala"
	self->priv->cursor_over_tab = FALSE;
#line 341 "../src/DynamicNotebook.vala"
	tab_update_close_button_visibility (self);
#line 342 "../src/DynamicNotebook.vala"
	result = FALSE;
#line 342 "../src/DynamicNotebook.vala"
	return result;
#line 2304 "DynamicNotebook.c"
}


static gboolean
__tab___lambda12__gtk_widget_leave_notify_event (GtkWidget* _sender,
                                                 GdkEventCrossing* event,
                                                 gpointer self)
{
	gboolean result;
	result = _tab___lambda12_ ((Tab*) self, event);
#line 334 "../src/DynamicNotebook.vala"
	return result;
#line 2317 "DynamicNotebook.c"
}


static gboolean
_tab___lambda13_ (Tab* self,
                  GdkEventCrossing* e)
{
	gboolean result = FALSE;
#line 350 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 351 "../src/DynamicNotebook.vala"
	self->priv->cursor_over_close_button = TRUE;
#line 352 "../src/DynamicNotebook.vala"
	tab_update_close_button_visibility (self);
#line 353 "../src/DynamicNotebook.vala"
	result = FALSE;
#line 353 "../src/DynamicNotebook.vala"
	return result;
#line 2336 "DynamicNotebook.c"
}


static gboolean
__tab___lambda13__gtk_widget_enter_notify_event (GtkWidget* _sender,
                                                 GdkEventCrossing* event,
                                                 gpointer self)
{
	gboolean result;
	result = _tab___lambda13_ ((Tab*) self, event);
#line 350 "../src/DynamicNotebook.vala"
	return result;
#line 2349 "DynamicNotebook.c"
}


static gboolean
_tab___lambda14_ (Tab* self,
                  GdkEventCrossing* e)
{
	gboolean result = FALSE;
	gboolean _tmp0_;
#line 356 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 359 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->cursor_over_close_button;
#line 359 "../src/DynamicNotebook.vala"
	if (!_tmp0_) {
#line 360 "../src/DynamicNotebook.vala"
		result = FALSE;
#line 360 "../src/DynamicNotebook.vala"
		return result;
#line 2369 "DynamicNotebook.c"
	}
#line 362 "../src/DynamicNotebook.vala"
	self->priv->cursor_over_close_button = FALSE;
#line 363 "../src/DynamicNotebook.vala"
	tab_update_close_button_visibility (self);
#line 364 "../src/DynamicNotebook.vala"
	result = FALSE;
#line 364 "../src/DynamicNotebook.vala"
	return result;
#line 2379 "DynamicNotebook.c"
}


static gboolean
__tab___lambda14__gtk_widget_leave_notify_event (GtkWidget* _sender,
                                                 GdkEventCrossing* event,
                                                 gpointer self)
{
	gboolean result;
	result = _tab___lambda14_ ((Tab*) self, event);
#line 356 "../src/DynamicNotebook.vala"
	return result;
#line 2392 "DynamicNotebook.c"
}


static gboolean
_tab___lambda15_ (Tab* self)
{
	gboolean result = FALSE;
#line 367 "../src/DynamicNotebook.vala"
	result = TRUE;
#line 367 "../src/DynamicNotebook.vala"
	return result;
#line 2404 "DynamicNotebook.c"
}


static gboolean
__tab___lambda15__gtk_widget_button_press_event (GtkWidget* _sender,
                                                 GdkEventButton* event,
                                                 gpointer self)
{
	gboolean result;
	result = _tab___lambda15_ ((Tab*) self);
#line 367 "../src/DynamicNotebook.vala"
	return result;
#line 2417 "DynamicNotebook.c"
}


static void
_tab___lambda16_ (Tab* self)
{
#line 368 "../src/DynamicNotebook.vala"
	g_signal_emit (self, tab_signals[TAB_CLOSED_SIGNAL], 0);
#line 2426 "DynamicNotebook.c"
}


static void
__tab___lambda16__gtk_button_clicked (GtkButton* _sender,
                                      gpointer self)
{
#line 368 "../src/DynamicNotebook.vala"
	_tab___lambda16_ ((Tab*) self);
#line 2436 "DynamicNotebook.c"
}


static GObject *
tab_constructor (GType type,
                 guint n_construct_properties,
                 GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	Tab * self;
	Block7Data* _data7_;
	GtkLabel* _tmp0_;
	GtkLabel* _tmp1_;
	GtkLabel* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	GtkLabel* _tmp5_;
	GtkImage* _tmp6_;
	GtkImage* _tmp7_;
	GtkImage* _tmp8_;
	GtkImage* _tmp9_;
	GtkSpinner* _tmp10_;
	GtkSpinner* _tmp11_;
	GtkSpinner* _tmp12_;
	GtkButton* close_button = NULL;
	GtkButton* _tmp13_;
	GtkButton* _tmp14_;
	GtkButton* _tmp15_;
	GtkButton* _tmp16_;
	GtkRevealer* _tmp17_;
	GtkRevealer* _tmp18_;
	GtkRevealer* _tmp19_;
	GtkButton* _tmp20_;
	GtkGrid* tab_layout = NULL;
	GtkGrid* _tmp21_;
	GtkGrid* _tmp22_;
	GtkGrid* _tmp23_;
	GtkGrid* _tmp24_;
	GtkRevealer* _tmp25_;
	GtkGrid* _tmp26_;
	GtkLabel* _tmp27_;
	GtkGrid* _tmp28_;
	GtkImage* _tmp29_;
	GtkGrid* _tmp30_;
	GtkSpinner* _tmp31_;
	GtkGrid* _tmp32_;
	TabPageContainer* _tmp33_;
	GtkMenu* _tmp34_;
	GtkMenu* _tmp35_;
	GtkMenuItem* close_m = NULL;
	GtkMenuItem* _tmp36_;
	GtkMenuItem* _tmp37_;
	GtkMenuItem* _tmp38_;
	GtkMenuItem* _tmp39_;
	GtkMenuItem* _tmp40_;
	GtkMenu* _tmp41_;
	GtkMenuItem* _tmp42_;
	GtkMenu* _tmp43_;
	GtkMenuItem* _tmp44_;
	GtkMenu* _tmp45_;
	GtkMenuItem* _tmp46_;
	GtkMenu* _tmp47_;
	GtkMenuItem* _tmp48_;
	GtkMenu* _tmp49_;
	GtkMenuItem* _tmp50_;
	GtkMenu* _tmp51_;
	GtkMenuItem* _tmp52_;
	GtkMenuItem* _tmp53_;
	GtkMenuItem* _tmp54_;
	GtkMenuItem* _tmp55_;
	GtkMenuItem* _tmp56_;
	GtkButton* _tmp57_;
	GtkButton* _tmp58_;
	TabPageContainer* _tmp59_;
	GtkButton* _tmp60_;
#line 218 "../src/DynamicNotebook.vala"
	parent_class = G_OBJECT_CLASS (tab_parent_class);
#line 218 "../src/DynamicNotebook.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 218 "../src/DynamicNotebook.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_TAB, Tab);
#line 218 "../src/DynamicNotebook.vala"
	_data7_ = g_slice_new0 (Block7Data);
#line 218 "../src/DynamicNotebook.vala"
	_data7_->_ref_count_ = 1;
#line 218 "../src/DynamicNotebook.vala"
	_data7_->self = g_object_ref (self);
#line 219 "../src/DynamicNotebook.vala"
	_tmp0_ = (GtkLabel*) gtk_label_new (NULL);
#line 219 "../src/DynamicNotebook.vala"
	g_object_ref_sink (_tmp0_);
#line 219 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->priv->_label);
#line 219 "../src/DynamicNotebook.vala"
	self->priv->_label = _tmp0_;
#line 220 "../src/DynamicNotebook.vala"
	_tmp1_ = self->priv->_label;
#line 220 "../src/DynamicNotebook.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp1_, TRUE);
#line 221 "../src/DynamicNotebook.vala"
	_tmp2_ = self->priv->_label;
#line 221 "../src/DynamicNotebook.vala"
	_tmp3_ = tab_get_label (self);
#line 221 "../src/DynamicNotebook.vala"
	_tmp4_ = _tmp3_;
#line 221 "../src/DynamicNotebook.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp2_, _tmp4_);
#line 222 "../src/DynamicNotebook.vala"
	_tmp5_ = self->priv->_label;
#line 222 "../src/DynamicNotebook.vala"
	gtk_label_set_ellipsize (_tmp5_, PANGO_ELLIPSIZE_END);
#line 224 "../src/DynamicNotebook.vala"
	_tmp6_ = (GtkImage*) gtk_image_new ();
#line 224 "../src/DynamicNotebook.vala"
	g_object_ref_sink (_tmp6_);
#line 224 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->_icon);
#line 224 "../src/DynamicNotebook.vala"
	self->_icon = _tmp6_;
#line 225 "../src/DynamicNotebook.vala"
	_tmp7_ = self->_icon;
#line 225 "../src/DynamicNotebook.vala"
	g_object_set (_tmp7_, "icon-size", (gint) GTK_ICON_SIZE_MENU, NULL);
#line 226 "../src/DynamicNotebook.vala"
	_tmp8_ = self->_icon;
#line 226 "../src/DynamicNotebook.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp8_, TRUE);
#line 227 "../src/DynamicNotebook.vala"
	_tmp9_ = self->_icon;
#line 227 "../src/DynamicNotebook.vala"
	gtk_widget_set_size_request ((GtkWidget*) _tmp9_, 16, 16);
#line 229 "../src/DynamicNotebook.vala"
	_tmp10_ = (GtkSpinner*) gtk_spinner_new ();
#line 229 "../src/DynamicNotebook.vala"
	g_object_ref_sink (_tmp10_);
#line 229 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->priv->_working);
#line 229 "../src/DynamicNotebook.vala"
	self->priv->_working = _tmp10_;
#line 230 "../src/DynamicNotebook.vala"
	_tmp11_ = self->priv->_working;
#line 230 "../src/DynamicNotebook.vala"
	gtk_widget_set_size_request ((GtkWidget*) _tmp11_, 16, 16);
#line 231 "../src/DynamicNotebook.vala"
	_tmp12_ = self->priv->_working;
#line 231 "../src/DynamicNotebook.vala"
	gtk_spinner_start (_tmp12_);
#line 233 "../src/DynamicNotebook.vala"
	_tmp13_ = (GtkButton*) gtk_button_new_from_icon_name ("window-close-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 233 "../src/DynamicNotebook.vala"
	g_object_ref_sink (_tmp13_);
#line 233 "../src/DynamicNotebook.vala"
	close_button = _tmp13_;
#line 234 "../src/DynamicNotebook.vala"
	_tmp14_ = close_button;
#line 234 "../src/DynamicNotebook.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp14_, _ ("Close Tab"));
#line 235 "../src/DynamicNotebook.vala"
	_tmp15_ = close_button;
#line 235 "../src/DynamicNotebook.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp15_, GTK_ALIGN_CENTER);
#line 236 "../src/DynamicNotebook.vala"
	_tmp16_ = close_button;
#line 236 "../src/DynamicNotebook.vala"
	gtk_button_set_relief (_tmp16_, GTK_RELIEF_NONE);
#line 238 "../src/DynamicNotebook.vala"
	_tmp17_ = (GtkRevealer*) gtk_revealer_new ();
#line 238 "../src/DynamicNotebook.vala"
	g_object_ref_sink (_tmp17_);
#line 238 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->priv->close_button_revealer);
#line 238 "../src/DynamicNotebook.vala"
	self->priv->close_button_revealer = _tmp17_;
#line 239 "../src/DynamicNotebook.vala"
	_tmp18_ = self->priv->close_button_revealer;
#line 239 "../src/DynamicNotebook.vala"
	gtk_revealer_set_transition_type (_tmp18_, GTK_REVEALER_TRANSITION_TYPE_CROSSFADE);
#line 240 "../src/DynamicNotebook.vala"
	_tmp19_ = self->priv->close_button_revealer;
#line 240 "../src/DynamicNotebook.vala"
	_tmp20_ = close_button;
#line 240 "../src/DynamicNotebook.vala"
	gtk_container_add ((GtkContainer*) _tmp19_, (GtkWidget*) _tmp20_);
#line 242 "../src/DynamicNotebook.vala"
	_tmp21_ = (GtkGrid*) gtk_grid_new ();
#line 242 "../src/DynamicNotebook.vala"
	g_object_ref_sink (_tmp21_);
#line 242 "../src/DynamicNotebook.vala"
	tab_layout = _tmp21_;
#line 243 "../src/DynamicNotebook.vala"
	_tmp22_ = tab_layout;
#line 243 "../src/DynamicNotebook.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp22_, FALSE);
#line 244 "../src/DynamicNotebook.vala"
	_tmp23_ = tab_layout;
#line 244 "../src/DynamicNotebook.vala"
	gtk_orientable_set_orientation ((GtkOrientable*) _tmp23_, GTK_ORIENTATION_HORIZONTAL);
#line 245 "../src/DynamicNotebook.vala"
	_tmp24_ = tab_layout;
#line 245 "../src/DynamicNotebook.vala"
	_tmp25_ = self->priv->close_button_revealer;
#line 245 "../src/DynamicNotebook.vala"
	gtk_container_add ((GtkContainer*) _tmp24_, (GtkWidget*) _tmp25_);
#line 246 "../src/DynamicNotebook.vala"
	_tmp26_ = tab_layout;
#line 246 "../src/DynamicNotebook.vala"
	_tmp27_ = self->priv->_label;
#line 246 "../src/DynamicNotebook.vala"
	gtk_container_add ((GtkContainer*) _tmp26_, (GtkWidget*) _tmp27_);
#line 247 "../src/DynamicNotebook.vala"
	_tmp28_ = tab_layout;
#line 247 "../src/DynamicNotebook.vala"
	_tmp29_ = self->_icon;
#line 247 "../src/DynamicNotebook.vala"
	gtk_container_add ((GtkContainer*) _tmp28_, (GtkWidget*) _tmp29_);
#line 248 "../src/DynamicNotebook.vala"
	_tmp30_ = tab_layout;
#line 248 "../src/DynamicNotebook.vala"
	_tmp31_ = self->priv->_working;
#line 248 "../src/DynamicNotebook.vala"
	gtk_container_add ((GtkContainer*) _tmp30_, (GtkWidget*) _tmp31_);
#line 250 "../src/DynamicNotebook.vala"
	gtk_event_box_set_visible_window ((GtkEventBox*) self, TRUE);
#line 252 "../src/DynamicNotebook.vala"
	_tmp32_ = tab_layout;
#line 252 "../src/DynamicNotebook.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp32_);
#line 253 "../src/DynamicNotebook.vala"
	gtk_widget_show_all ((GtkWidget*) self);
#line 255 "../src/DynamicNotebook.vala"
	_tmp33_ = tab_page_container_new (self);
#line 255 "../src/DynamicNotebook.vala"
	g_object_ref_sink (_tmp33_);
#line 255 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->page_container);
#line 255 "../src/DynamicNotebook.vala"
	self->page_container = _tmp33_;
#line 257 "../src/DynamicNotebook.vala"
	_tmp34_ = (GtkMenu*) gtk_menu_new ();
#line 257 "../src/DynamicNotebook.vala"
	g_object_ref_sink (_tmp34_);
#line 257 "../src/DynamicNotebook.vala"
	_tmp35_ = _tmp34_;
#line 257 "../src/DynamicNotebook.vala"
	tab_set_menu (self, _tmp35_);
#line 257 "../src/DynamicNotebook.vala"
	_g_object_unref0 (_tmp35_);
#line 258 "../src/DynamicNotebook.vala"
	_tmp36_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Close Tab"));
#line 258 "../src/DynamicNotebook.vala"
	g_object_ref_sink (_tmp36_);
#line 258 "../src/DynamicNotebook.vala"
	close_m = _tmp36_;
#line 259 "../src/DynamicNotebook.vala"
	_tmp37_ = (GtkMenuItem*) gtk_menu_item_new_with_label ("");
#line 259 "../src/DynamicNotebook.vala"
	g_object_ref_sink (_tmp37_);
#line 259 "../src/DynamicNotebook.vala"
	_data7_->close_other_m = _tmp37_;
#line 260 "../src/DynamicNotebook.vala"
	_tmp38_ = (GtkMenuItem*) gtk_menu_item_new_with_label ("");
#line 260 "../src/DynamicNotebook.vala"
	g_object_ref_sink (_tmp38_);
#line 260 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->pin_m);
#line 260 "../src/DynamicNotebook.vala"
	self->pin_m = _tmp38_;
#line 261 "../src/DynamicNotebook.vala"
	_tmp39_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Open in a New Window"));
#line 261 "../src/DynamicNotebook.vala"
	g_object_ref_sink (_tmp39_);
#line 261 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->new_window_m);
#line 261 "../src/DynamicNotebook.vala"
	self->new_window_m = _tmp39_;
#line 262 "../src/DynamicNotebook.vala"
	_tmp40_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Duplicate"));
#line 262 "../src/DynamicNotebook.vala"
	g_object_ref_sink (_tmp40_);
#line 262 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->duplicate_m);
#line 262 "../src/DynamicNotebook.vala"
	self->duplicate_m = _tmp40_;
#line 263 "../src/DynamicNotebook.vala"
	_tmp41_ = self->priv->_menu;
#line 263 "../src/DynamicNotebook.vala"
	_tmp42_ = _data7_->close_other_m;
#line 263 "../src/DynamicNotebook.vala"
	gtk_menu_shell_append ((GtkMenuShell*) _tmp41_, _tmp42_);
#line 264 "../src/DynamicNotebook.vala"
	_tmp43_ = self->priv->_menu;
#line 264 "../src/DynamicNotebook.vala"
	_tmp44_ = close_m;
#line 264 "../src/DynamicNotebook.vala"
	gtk_menu_shell_append ((GtkMenuShell*) _tmp43_, _tmp44_);
#line 265 "../src/DynamicNotebook.vala"
	_tmp45_ = self->priv->_menu;
#line 265 "../src/DynamicNotebook.vala"
	_tmp46_ = self->new_window_m;
#line 265 "../src/DynamicNotebook.vala"
	gtk_menu_shell_append ((GtkMenuShell*) _tmp45_, _tmp46_);
#line 266 "../src/DynamicNotebook.vala"
	_tmp47_ = self->priv->_menu;
#line 266 "../src/DynamicNotebook.vala"
	_tmp48_ = self->duplicate_m;
#line 266 "../src/DynamicNotebook.vala"
	gtk_menu_shell_append ((GtkMenuShell*) _tmp47_, _tmp48_);
#line 267 "../src/DynamicNotebook.vala"
	_tmp49_ = self->priv->_menu;
#line 267 "../src/DynamicNotebook.vala"
	_tmp50_ = self->pin_m;
#line 267 "../src/DynamicNotebook.vala"
	gtk_menu_shell_append ((GtkMenuShell*) _tmp49_, _tmp50_);
#line 268 "../src/DynamicNotebook.vala"
	_tmp51_ = self->priv->_menu;
#line 268 "../src/DynamicNotebook.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp51_);
#line 270 "../src/DynamicNotebook.vala"
	_tmp52_ = close_m;
#line 270 "../src/DynamicNotebook.vala"
	g_signal_connect_object (_tmp52_, "activate", (GCallback) __tab___lambda4__gtk_menu_item_activate, self, 0);
#line 271 "../src/DynamicNotebook.vala"
	_tmp53_ = _data7_->close_other_m;
#line 271 "../src/DynamicNotebook.vala"
	g_signal_connect_object (_tmp53_, "activate", (GCallback) __tab___lambda5__gtk_menu_item_activate, self, 0);
#line 272 "../src/DynamicNotebook.vala"
	_tmp54_ = self->new_window_m;
#line 272 "../src/DynamicNotebook.vala"
	g_signal_connect_object (_tmp54_, "activate", (GCallback) __tab___lambda6__gtk_menu_item_activate, self, 0);
#line 273 "../src/DynamicNotebook.vala"
	_tmp55_ = self->duplicate_m;
#line 273 "../src/DynamicNotebook.vala"
	g_signal_connect_object (_tmp55_, "activate", (GCallback) __tab___lambda7__gtk_menu_item_activate, self, 0);
#line 274 "../src/DynamicNotebook.vala"
	_tmp56_ = self->pin_m;
#line 274 "../src/DynamicNotebook.vala"
	g_signal_connect_object (_tmp56_, "activate", (GCallback) __tab___lambda8__gtk_menu_item_activate, self, 0);
#line 276 "../src/DynamicNotebook.vala"
	g_signal_connect_object ((GtkWidget*) self, "scroll-event", (GCallback) __tab___lambda9__gtk_widget_scroll_event, self, 0);
#line 299 "../src/DynamicNotebook.vala"
	g_signal_connect_data ((GtkWidget*) self, "button-press-event", (GCallback) __tab___lambda10__gtk_widget_button_press_event, block7_data_ref (_data7_), (GClosureNotify) block7_data_unref, 0);
#line 328 "../src/DynamicNotebook.vala"
	g_signal_connect_object ((GtkWidget*) self, "enter-notify-event", (GCallback) __tab___lambda11__gtk_widget_enter_notify_event, self, 0);
#line 334 "../src/DynamicNotebook.vala"
	g_signal_connect_object ((GtkWidget*) self, "leave-notify-event", (GCallback) __tab___lambda12__gtk_widget_leave_notify_event, self, 0);
#line 350 "../src/DynamicNotebook.vala"
	_tmp57_ = close_button;
#line 350 "../src/DynamicNotebook.vala"
	g_signal_connect_object ((GtkWidget*) _tmp57_, "enter-notify-event", (GCallback) __tab___lambda13__gtk_widget_enter_notify_event, self, 0);
#line 356 "../src/DynamicNotebook.vala"
	_tmp58_ = close_button;
#line 356 "../src/DynamicNotebook.vala"
	g_signal_connect_object ((GtkWidget*) _tmp58_, "leave-notify-event", (GCallback) __tab___lambda14__gtk_widget_leave_notify_event, self, 0);
#line 367 "../src/DynamicNotebook.vala"
	_tmp59_ = self->page_container;
#line 367 "../src/DynamicNotebook.vala"
	g_signal_connect_object ((GtkWidget*) _tmp59_, "button-press-event", (GCallback) __tab___lambda15__gtk_widget_button_press_event, self, 0);
#line 368 "../src/DynamicNotebook.vala"
	_tmp60_ = close_button;
#line 368 "../src/DynamicNotebook.vala"
	g_signal_connect_object (_tmp60_, "clicked", (GCallback) __tab___lambda16__gtk_button_clicked, self, 0);
#line 369 "../src/DynamicNotebook.vala"
	tab_set_working (self, FALSE);
#line 371 "../src/DynamicNotebook.vala"
	tab_update_close_button_visibility (self);
#line 218 "../src/DynamicNotebook.vala"
	_g_object_unref0 (close_m);
#line 218 "../src/DynamicNotebook.vala"
	_g_object_unref0 (tab_layout);
#line 218 "../src/DynamicNotebook.vala"
	_g_object_unref0 (close_button);
#line 218 "../src/DynamicNotebook.vala"
	block7_data_unref (_data7_);
#line 218 "../src/DynamicNotebook.vala"
	_data7_ = NULL;
#line 218 "../src/DynamicNotebook.vala"
	return obj;
#line 2815 "DynamicNotebook.c"
}


static void
tab_class_init (TabClass * klass)
{
#line 46 "../src/DynamicNotebook.vala"
	tab_parent_class = g_type_class_peek_parent (klass);
#line 46 "../src/DynamicNotebook.vala"
	g_type_class_adjust_private_offset (klass, &Tab_private_offset);
#line 46 "../src/DynamicNotebook.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_tab_get_property;
#line 46 "../src/DynamicNotebook.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_tab_set_property;
#line 46 "../src/DynamicNotebook.vala"
	G_OBJECT_CLASS (klass)->constructor = tab_constructor;
#line 46 "../src/DynamicNotebook.vala"
	G_OBJECT_CLASS (klass)->finalize = tab_finalize;
#line 46 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TAB_LABEL_PROPERTY, tab_properties[TAB_LABEL_PROPERTY] = g_param_spec_string ("label", "label", "label", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 46 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TAB_TOOLTIP_PROPERTY, tab_properties[TAB_TOOLTIP_PROPERTY] = g_param_spec_string ("tooltip", "tooltip", "tooltip", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 46 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TAB_PINNED_PROPERTY, tab_properties[TAB_PINNED_PROPERTY] = g_param_spec_boolean ("pinned", "pinned", "pinned", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 46 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TAB_PINNABLE_PROPERTY, tab_properties[TAB_PINNABLE_PROPERTY] = g_param_spec_boolean ("pinnable", "pinnable", "pinnable", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 2842 "DynamicNotebook.c"
	/**
	         * Data which will be kept once the tab is deleted, and which will be used by
	         * the application to restore the data into the restored tab. Let it empty if
	         * the tab should not be restored.
	         **/
#line 46 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TAB_RESTORE_DATA_PROPERTY, tab_properties[TAB_RESTORE_DATA_PROPERTY] = g_param_spec_string ("restore-data", "restore-data", "restore-data", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 46 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TAB_PAGE_PROPERTY, tab_properties[TAB_PAGE_PROPERTY] = g_param_spec_object ("page", "page", "page", gtk_widget_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 46 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TAB_ICON_PROPERTY, tab_properties[TAB_ICON_PROPERTY] = g_param_spec_object ("icon", "icon", "icon", g_icon_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 46 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TAB_WORKING_PROPERTY, tab_properties[TAB_WORKING_PROPERTY] = g_param_spec_boolean ("working", "working", "working", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 46 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TAB_ELLIPSIZE_MODE_PROPERTY, tab_properties[TAB_ELLIPSIZE_MODE_PROPERTY] = g_param_spec_enum ("ellipsize-mode", "ellipsize-mode", "ellipsize-mode", pango_ellipsize_mode_get_type (), 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 46 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TAB_FIXED_PROPERTY, tab_properties[TAB_FIXED_PROPERTY] = g_param_spec_boolean ("fixed", "fixed", "fixed", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_DEPRECATED));
#line 46 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TAB_MENU_PROPERTY, tab_properties[TAB_MENU_PROPERTY] = g_param_spec_object ("menu", "menu", "menu", gtk_menu_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 46 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TAB_CLOSABLE_PROPERTY, tab_properties[TAB_CLOSABLE_PROPERTY] = g_param_spec_boolean ("closable", "closable", "closable", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE));
#line 46 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), TAB_IS_CURRENT_TAB_PROPERTY, tab_properties[TAB_IS_CURRENT_TAB_PROPERTY] = g_param_spec_boolean ("is-current-tab", "is-current-tab", "is-current-tab", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_WRITABLE));
#line 46 "../src/DynamicNotebook.vala"
	tab_signals[TAB_CLOSED_SIGNAL] = g_signal_new ("closed", TYPE_TAB, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 46 "../src/DynamicNotebook.vala"
	tab_signals[TAB_CLOSE_OTHERS_SIGNAL] = g_signal_new ("close-others", TYPE_TAB, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 46 "../src/DynamicNotebook.vala"
	tab_signals[TAB_NEW_WINDOW_SIGNAL] = g_signal_new ("new-window", TYPE_TAB, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 46 "../src/DynamicNotebook.vala"
	tab_signals[TAB_DUPLICATE_SIGNAL] = g_signal_new ("duplicate", TYPE_TAB, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 46 "../src/DynamicNotebook.vala"
	tab_signals[TAB_PIN_SWITCH_SIGNAL] = g_signal_new ("pin-switch", TYPE_TAB, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 2876 "DynamicNotebook.c"
}


static void
tab_instance_init (Tab * self)
{
	gchar* _tmp0_;
#line 46 "../src/DynamicNotebook.vala"
	self->priv = tab_get_instance_private (self);
#line 60 "../src/DynamicNotebook.vala"
	self->priv->_pinned = FALSE;
#line 85 "../src/DynamicNotebook.vala"
	self->priv->_pinnable = TRUE;
#line 102 "../src/DynamicNotebook.vala"
	_tmp0_ = g_strdup ("");
#line 102 "../src/DynamicNotebook.vala"
	self->priv->_restore_data = _tmp0_;
#line 111 "../src/DynamicNotebook.vala"
	self->dropped_callback = NULL;
#line 111 "../src/DynamicNotebook.vala"
	self->dropped_callback_target = self;
#line 111 "../src/DynamicNotebook.vala"
	self->dropped_callback_target_destroy_notify = NULL;
#line 172 "../src/DynamicNotebook.vala"
	self->priv->_closable = TRUE;
#line 188 "../src/DynamicNotebook.vala"
	self->priv->_is_current_tab = FALSE;
#line 196 "../src/DynamicNotebook.vala"
	self->priv->cursor_over_tab = FALSE;
#line 197 "../src/DynamicNotebook.vala"
	self->priv->cursor_over_close_button = FALSE;
#line 2908 "DynamicNotebook.c"
}


static void
tab_finalize (GObject * obj)
{
	Tab * self;
#line 46 "../src/DynamicNotebook.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_TAB, Tab);
#line 47 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->priv->_label);
#line 102 "../src/DynamicNotebook.vala"
	_g_free0 (self->priv->_restore_data);
#line 111 "../src/DynamicNotebook.vala"
	(self->dropped_callback_target_destroy_notify == NULL) ? NULL : (self->dropped_callback_target_destroy_notify (self->dropped_callback_target), NULL);
#line 111 "../src/DynamicNotebook.vala"
	self->dropped_callback = NULL;
#line 111 "../src/DynamicNotebook.vala"
	self->dropped_callback_target = NULL;
#line 111 "../src/DynamicNotebook.vala"
	self->dropped_callback_target_destroy_notify = NULL;
#line 113 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->page_container);
#line 136 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->_icon);
#line 142 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->priv->_working);
#line 170 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->priv->_menu);
#line 184 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->new_window_m);
#line 185 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->duplicate_m);
#line 186 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->pin_m);
#line 198 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->priv->close_button_revealer);
#line 46 "../src/DynamicNotebook.vala"
	G_OBJECT_CLASS (tab_parent_class)->finalize (obj);
#line 2948 "DynamicNotebook.c"
}


/**
     * This is a standard tab which can be used in a notebook to form a tabbed UI.
     */
GType
tab_get_type (void)
{
	static volatile gsize tab_type_id__volatile = 0;
	if (g_once_init_enter (&tab_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (TabClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) tab_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (Tab), 0, (GInstanceInitFunc) tab_instance_init, NULL };
		GType tab_type_id;
		tab_type_id = g_type_register_static (gtk_event_box_get_type (), "Tab", &g_define_type_info, 0);
		Tab_private_offset = g_type_add_instance_private (tab_type_id, sizeof (TabPrivate));
		g_once_init_leave (&tab_type_id__volatile, tab_type_id);
	}
	return tab_type_id__volatile;
}


static void
_vala_tab_get_property (GObject * object,
                        guint property_id,
                        GValue * value,
                        GParamSpec * pspec)
{
	Tab * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_TAB, Tab);
#line 46 "../src/DynamicNotebook.vala"
	switch (property_id) {
#line 46 "../src/DynamicNotebook.vala"
		case TAB_LABEL_PROPERTY:
#line 46 "../src/DynamicNotebook.vala"
		g_value_set_string (value, tab_get_label (self));
#line 46 "../src/DynamicNotebook.vala"
		break;
#line 46 "../src/DynamicNotebook.vala"
		case TAB_TOOLTIP_PROPERTY:
#line 46 "../src/DynamicNotebook.vala"
		g_value_take_string (value, tab_get_tooltip (self));
#line 46 "../src/DynamicNotebook.vala"
		break;
#line 46 "../src/DynamicNotebook.vala"
		case TAB_PINNED_PROPERTY:
#line 46 "../src/DynamicNotebook.vala"
		g_value_set_boolean (value, tab_get_pinned (self));
#line 46 "../src/DynamicNotebook.vala"
		break;
#line 46 "../src/DynamicNotebook.vala"
		case TAB_PINNABLE_PROPERTY:
#line 46 "../src/DynamicNotebook.vala"
		g_value_set_boolean (value, tab_get_pinnable (self));
#line 46 "../src/DynamicNotebook.vala"
		break;
#line 46 "../src/DynamicNotebook.vala"
		case TAB_RESTORE_DATA_PROPERTY:
#line 46 "../src/DynamicNotebook.vala"
		g_value_set_string (value, tab_get_restore_data (self));
#line 46 "../src/DynamicNotebook.vala"
		break;
#line 46 "../src/DynamicNotebook.vala"
		case TAB_PAGE_PROPERTY:
#line 46 "../src/DynamicNotebook.vala"
		g_value_set_object (value, tab_get_page (self));
#line 46 "../src/DynamicNotebook.vala"
		break;
#line 46 "../src/DynamicNotebook.vala"
		case TAB_ICON_PROPERTY:
#line 46 "../src/DynamicNotebook.vala"
		g_value_take_object (value, tab_get_icon (self));
#line 46 "../src/DynamicNotebook.vala"
		break;
#line 46 "../src/DynamicNotebook.vala"
		case TAB_WORKING_PROPERTY:
#line 46 "../src/DynamicNotebook.vala"
		g_value_set_boolean (value, tab_get_working (self));
#line 46 "../src/DynamicNotebook.vala"
		break;
#line 46 "../src/DynamicNotebook.vala"
		case TAB_ELLIPSIZE_MODE_PROPERTY:
#line 46 "../src/DynamicNotebook.vala"
		g_value_set_enum (value, tab_get_ellipsize_mode (self));
#line 46 "../src/DynamicNotebook.vala"
		break;
#line 46 "../src/DynamicNotebook.vala"
		case TAB_FIXED_PROPERTY:
G_GNUC_BEGIN_IGNORE_DEPRECATIONS
#line 3037 "DynamicNotebook.c"
		g_value_set_boolean (value, tab_get_fixed (self));
G_GNUC_END_IGNORE_DEPRECATIONS
#line 46 "../src/DynamicNotebook.vala"
		break;
#line 46 "../src/DynamicNotebook.vala"
		case TAB_MENU_PROPERTY:
#line 46 "../src/DynamicNotebook.vala"
		g_value_set_object (value, tab_get_menu (self));
#line 46 "../src/DynamicNotebook.vala"
		break;
#line 3048 "DynamicNotebook.c"
		default:
#line 46 "../src/DynamicNotebook.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 46 "../src/DynamicNotebook.vala"
		break;
#line 3054 "DynamicNotebook.c"
	}
}


static void
_vala_tab_set_property (GObject * object,
                        guint property_id,
                        const GValue * value,
                        GParamSpec * pspec)
{
	Tab * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_TAB, Tab);
#line 46 "../src/DynamicNotebook.vala"
	switch (property_id) {
#line 46 "../src/DynamicNotebook.vala"
		case TAB_LABEL_PROPERTY:
#line 46 "../src/DynamicNotebook.vala"
		tab_set_label (self, g_value_get_string (value));
#line 46 "../src/DynamicNotebook.vala"
		break;
#line 46 "../src/DynamicNotebook.vala"
		case TAB_TOOLTIP_PROPERTY:
#line 46 "../src/DynamicNotebook.vala"
		tab_set_tooltip (self, g_value_get_string (value));
#line 46 "../src/DynamicNotebook.vala"
		break;
#line 46 "../src/DynamicNotebook.vala"
		case TAB_PINNED_PROPERTY:
#line 46 "../src/DynamicNotebook.vala"
		tab_set_pinned (self, g_value_get_boolean (value));
#line 46 "../src/DynamicNotebook.vala"
		break;
#line 46 "../src/DynamicNotebook.vala"
		case TAB_PINNABLE_PROPERTY:
#line 46 "../src/DynamicNotebook.vala"
		tab_set_pinnable (self, g_value_get_boolean (value));
#line 46 "../src/DynamicNotebook.vala"
		break;
#line 46 "../src/DynamicNotebook.vala"
		case TAB_RESTORE_DATA_PROPERTY:
#line 46 "../src/DynamicNotebook.vala"
		tab_set_restore_data (self, g_value_get_string (value));
#line 46 "../src/DynamicNotebook.vala"
		break;
#line 46 "../src/DynamicNotebook.vala"
		case TAB_PAGE_PROPERTY:
#line 46 "../src/DynamicNotebook.vala"
		tab_set_page (self, g_value_get_object (value));
#line 46 "../src/DynamicNotebook.vala"
		break;
#line 46 "../src/DynamicNotebook.vala"
		case TAB_ICON_PROPERTY:
#line 46 "../src/DynamicNotebook.vala"
		tab_set_icon (self, g_value_get_object (value));
#line 46 "../src/DynamicNotebook.vala"
		break;
#line 46 "../src/DynamicNotebook.vala"
		case TAB_WORKING_PROPERTY:
#line 46 "../src/DynamicNotebook.vala"
		tab_set_working (self, g_value_get_boolean (value));
#line 46 "../src/DynamicNotebook.vala"
		break;
#line 46 "../src/DynamicNotebook.vala"
		case TAB_ELLIPSIZE_MODE_PROPERTY:
#line 46 "../src/DynamicNotebook.vala"
		tab_set_ellipsize_mode (self, g_value_get_enum (value));
#line 46 "../src/DynamicNotebook.vala"
		break;
#line 46 "../src/DynamicNotebook.vala"
		case TAB_FIXED_PROPERTY:
G_GNUC_BEGIN_IGNORE_DEPRECATIONS
#line 3126 "DynamicNotebook.c"
		tab_set_fixed (self, g_value_get_boolean (value));
G_GNUC_END_IGNORE_DEPRECATIONS
#line 46 "../src/DynamicNotebook.vala"
		break;
#line 46 "../src/DynamicNotebook.vala"
		case TAB_MENU_PROPERTY:
#line 46 "../src/DynamicNotebook.vala"
		tab_set_menu (self, g_value_get_object (value));
#line 46 "../src/DynamicNotebook.vala"
		break;
#line 46 "../src/DynamicNotebook.vala"
		case TAB_CLOSABLE_PROPERTY:
#line 46 "../src/DynamicNotebook.vala"
		tab_set_closable (self, g_value_get_boolean (value));
#line 46 "../src/DynamicNotebook.vala"
		break;
#line 46 "../src/DynamicNotebook.vala"
		case TAB_IS_CURRENT_TAB_PROPERTY:
#line 46 "../src/DynamicNotebook.vala"
		tab_set_is_current_tab (self, g_value_get_boolean (value));
#line 46 "../src/DynamicNotebook.vala"
		break;
#line 3149 "DynamicNotebook.c"
		default:
#line 46 "../src/DynamicNotebook.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 46 "../src/DynamicNotebook.vala"
		break;
#line 3155 "DynamicNotebook.c"
	}
}


static inline gpointer
closed_tabs_get_instance_private (ClosedTabs* self)
{
	return G_STRUCT_MEMBER_P (self, ClosedTabs_private_offset);
}


ClosedTabs*
closed_tabs_construct (GType object_type)
{
	ClosedTabs * self = NULL;
#line 416 "../src/DynamicNotebook.vala"
	self = (ClosedTabs*) g_object_new (object_type, NULL);
#line 416 "../src/DynamicNotebook.vala"
	return self;
#line 3175 "DynamicNotebook.c"
}


ClosedTabs*
closed_tabs_new (void)
{
#line 416 "../src/DynamicNotebook.vala"
	return closed_tabs_construct (TYPE_CLOSED_TABS);
#line 3184 "DynamicNotebook.c"
}


void
closed_tabs_push (ClosedTabs* self,
                  Tab* tab)
{
	ClosedTabsEntry e = {0};
	const gchar* _tmp15_;
	const gchar* _tmp16_;
	gchar* _tmp17_;
	const gchar* _tmp18_;
	const gchar* _tmp19_;
	gchar* _tmp20_;
	GIcon* _tmp21_;
	GIcon* _tmp22_;
	GraniteWidgetsDroppedDelegate _tmp23_;
	void* _tmp23__target;
	ClosedTabsEntry _tmp24_ = {0};
	GeeLinkedList* _tmp25_;
	ClosedTabsEntry _tmp26_;
	GeeLinkedList* _tmp27_;
	gint _tmp28_;
	gint _tmp29_;
	gint _tmp30_;
	gint _tmp31_;
#line 430 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 430 "../src/DynamicNotebook.vala"
	g_return_if_fail (tab != NULL);
#line 3215 "DynamicNotebook.c"
	{
		GeeLinkedList* _entry_list = NULL;
		GeeLinkedList* _tmp0_;
		GeeLinkedList* _tmp1_;
		gint _entry_size = 0;
		GeeLinkedList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _entry_index = 0;
#line 431 "../src/DynamicNotebook.vala"
		_tmp0_ = self->priv->closed_tabs;
#line 431 "../src/DynamicNotebook.vala"
		_tmp1_ = _g_object_ref0 (_tmp0_);
#line 431 "../src/DynamicNotebook.vala"
		_entry_list = _tmp1_;
#line 431 "../src/DynamicNotebook.vala"
		_tmp2_ = _entry_list;
#line 431 "../src/DynamicNotebook.vala"
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
#line 431 "../src/DynamicNotebook.vala"
		_tmp4_ = _tmp3_;
#line 431 "../src/DynamicNotebook.vala"
		_entry_size = _tmp4_;
#line 431 "../src/DynamicNotebook.vala"
		_entry_index = -1;
#line 431 "../src/DynamicNotebook.vala"
		while (TRUE) {
#line 3243 "DynamicNotebook.c"
			gint _tmp5_;
			gint _tmp6_;
			gint _tmp7_;
			ClosedTabsEntry* entry = NULL;
			GeeLinkedList* _tmp8_;
			gint _tmp9_;
			gpointer _tmp10_;
			const gchar* _tmp11_;
			const gchar* _tmp12_;
			ClosedTabsEntry* _tmp13_;
			const gchar* _tmp14_;
#line 431 "../src/DynamicNotebook.vala"
			_tmp5_ = _entry_index;
#line 431 "../src/DynamicNotebook.vala"
			_entry_index = _tmp5_ + 1;
#line 431 "../src/DynamicNotebook.vala"
			_tmp6_ = _entry_index;
#line 431 "../src/DynamicNotebook.vala"
			_tmp7_ = _entry_size;
#line 431 "../src/DynamicNotebook.vala"
			if (!(_tmp6_ < _tmp7_)) {
#line 431 "../src/DynamicNotebook.vala"
				break;
#line 3267 "DynamicNotebook.c"
			}
#line 431 "../src/DynamicNotebook.vala"
			_tmp8_ = _entry_list;
#line 431 "../src/DynamicNotebook.vala"
			_tmp9_ = _entry_index;
#line 431 "../src/DynamicNotebook.vala"
			_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp8_, _tmp9_);
#line 431 "../src/DynamicNotebook.vala"
			entry = (ClosedTabsEntry*) _tmp10_;
#line 432 "../src/DynamicNotebook.vala"
			_tmp11_ = tab_get_restore_data (tab);
#line 432 "../src/DynamicNotebook.vala"
			_tmp12_ = _tmp11_;
#line 432 "../src/DynamicNotebook.vala"
			_tmp13_ = entry;
#line 432 "../src/DynamicNotebook.vala"
			_tmp14_ = (*_tmp13_).restore_data;
#line 432 "../src/DynamicNotebook.vala"
			if (g_strcmp0 (_tmp12_, _tmp14_) == 0) {
#line 433 "../src/DynamicNotebook.vala"
				_closed_tabs_entry_free0 (entry);
#line 433 "../src/DynamicNotebook.vala"
				_g_object_unref0 (_entry_list);
#line 433 "../src/DynamicNotebook.vala"
				return;
#line 3293 "DynamicNotebook.c"
			}
#line 431 "../src/DynamicNotebook.vala"
			_closed_tabs_entry_free0 (entry);
#line 3297 "DynamicNotebook.c"
		}
#line 431 "../src/DynamicNotebook.vala"
		_g_object_unref0 (_entry_list);
#line 3301 "DynamicNotebook.c"
	}
#line 436 "../src/DynamicNotebook.vala"
	_tmp15_ = tab_get_label (tab);
#line 436 "../src/DynamicNotebook.vala"
	_tmp16_ = _tmp15_;
#line 436 "../src/DynamicNotebook.vala"
	_tmp17_ = g_strdup (_tmp16_);
#line 436 "../src/DynamicNotebook.vala"
	_tmp18_ = tab_get_restore_data (tab);
#line 436 "../src/DynamicNotebook.vala"
	_tmp19_ = _tmp18_;
#line 436 "../src/DynamicNotebook.vala"
	_tmp20_ = g_strdup (_tmp19_);
#line 436 "../src/DynamicNotebook.vala"
	_tmp21_ = tab_get_icon (tab);
#line 436 "../src/DynamicNotebook.vala"
	_tmp22_ = _tmp21_;
#line 436 "../src/DynamicNotebook.vala"
	_tmp23_ = tab->dropped_callback;
#line 436 "../src/DynamicNotebook.vala"
	_tmp23__target = tab->dropped_callback_target;
#line 436 "../src/DynamicNotebook.vala"
	_g_free0 (_tmp24_.label);
#line 436 "../src/DynamicNotebook.vala"
	_tmp24_.label = _tmp17_;
#line 436 "../src/DynamicNotebook.vala"
	_g_free0 (_tmp24_.restore_data);
#line 436 "../src/DynamicNotebook.vala"
	_tmp24_.restore_data = _tmp20_;
#line 436 "../src/DynamicNotebook.vala"
	_g_object_unref0 (_tmp24_.icon);
#line 436 "../src/DynamicNotebook.vala"
	_tmp24_.icon = _tmp22_;
#line 436 "../src/DynamicNotebook.vala"
	_tmp24_.dropped_callback = _tmp23_;
#line 436 "../src/DynamicNotebook.vala"
	_tmp24_.dropped_callback_target = _tmp23__target;
#line 436 "../src/DynamicNotebook.vala"
	e = _tmp24_;
#line 437 "../src/DynamicNotebook.vala"
	_tmp25_ = self->priv->closed_tabs;
#line 437 "../src/DynamicNotebook.vala"
	_tmp26_ = e;
#line 437 "../src/DynamicNotebook.vala"
	gee_abstract_collection_add ((GeeAbstractCollection*) _tmp25_, &_tmp26_);
#line 440 "../src/DynamicNotebook.vala"
	_tmp27_ = self->priv->closed_tabs;
#line 440 "../src/DynamicNotebook.vala"
	_tmp28_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp27_);
#line 440 "../src/DynamicNotebook.vala"
	_tmp29_ = _tmp28_;
#line 440 "../src/DynamicNotebook.vala"
	_tmp30_ = closed_tabs_get_max_restorable_tabs (self);
#line 440 "../src/DynamicNotebook.vala"
	_tmp31_ = _tmp30_;
#line 440 "../src/DynamicNotebook.vala"
	if (_tmp29_ > _tmp31_) {
#line 3359 "DynamicNotebook.c"
		ClosedTabsEntry* elem = NULL;
		GeeLinkedList* _tmp32_;
		gpointer _tmp33_;
		GraniteWidgetsDroppedDelegate dropped_callback = NULL;
		ClosedTabsEntry* _tmp34_;
		GraniteWidgetsDroppedDelegate _tmp35_;
		void* _tmp35__target;
		void* dropped_callback_target;
		GraniteWidgetsDroppedDelegate _tmp36_;
		void* _tmp36__target;
#line 441 "../src/DynamicNotebook.vala"
		_tmp32_ = self->priv->closed_tabs;
#line 441 "../src/DynamicNotebook.vala"
		_tmp33_ = gee_deque_poll_head ((GeeDeque*) _tmp32_);
#line 441 "../src/DynamicNotebook.vala"
		elem = (ClosedTabsEntry*) _tmp33_;
#line 442 "../src/DynamicNotebook.vala"
		_tmp34_ = elem;
#line 442 "../src/DynamicNotebook.vala"
		_tmp35_ = (*_tmp34_).dropped_callback;
#line 442 "../src/DynamicNotebook.vala"
		_tmp35__target = (*_tmp34_).dropped_callback_target;
#line 442 "../src/DynamicNotebook.vala"
		dropped_callback = _tmp35_;
#line 442 "../src/DynamicNotebook.vala"
		dropped_callback_target = _tmp35__target;
#line 444 "../src/DynamicNotebook.vala"
		_tmp36_ = dropped_callback;
#line 444 "../src/DynamicNotebook.vala"
		_tmp36__target = dropped_callback_target;
#line 444 "../src/DynamicNotebook.vala"
		if (_tmp36_ != NULL) {
#line 3392 "DynamicNotebook.c"
			GraniteWidgetsDroppedDelegate _tmp37_;
			void* _tmp37__target;
#line 445 "../src/DynamicNotebook.vala"
			_tmp37_ = dropped_callback;
#line 445 "../src/DynamicNotebook.vala"
			_tmp37__target = dropped_callback_target;
#line 445 "../src/DynamicNotebook.vala"
			_tmp37_ (_tmp37__target);
#line 3401 "DynamicNotebook.c"
		}
#line 440 "../src/DynamicNotebook.vala"
		_closed_tabs_entry_free0 (elem);
#line 3405 "DynamicNotebook.c"
	}
#line 430 "../src/DynamicNotebook.vala"
	closed_tabs_entry_destroy (&e);
#line 3409 "DynamicNotebook.c"
}


void
closed_tabs_pop (ClosedTabs* self,
                 ClosedTabsEntry* result)
{
	GeeLinkedList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
	GeeLinkedList* _tmp3_;
	gpointer _tmp4_;
	ClosedTabsEntry* _tmp5_;
	ClosedTabsEntry _tmp6_ = {0};
	ClosedTabsEntry _tmp7_;
#line 449 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 450 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->closed_tabs;
#line 450 "../src/DynamicNotebook.vala"
	_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
#line 450 "../src/DynamicNotebook.vala"
	_tmp2_ = _tmp1_;
#line 450 "../src/DynamicNotebook.vala"
	_vala_assert (_tmp2_ > 0, "closed_tabs.size > 0");
#line 451 "../src/DynamicNotebook.vala"
	_tmp3_ = self->priv->closed_tabs;
#line 451 "../src/DynamicNotebook.vala"
	_tmp4_ = gee_deque_poll_tail ((GeeDeque*) _tmp3_);
#line 451 "../src/DynamicNotebook.vala"
	_tmp5_ = (ClosedTabsEntry*) _tmp4_;
#line 451 "../src/DynamicNotebook.vala"
	closed_tabs_entry_copy (_tmp5_, &_tmp6_);
#line 451 "../src/DynamicNotebook.vala"
	_tmp7_ = _tmp6_;
#line 451 "../src/DynamicNotebook.vala"
	_closed_tabs_entry_free0 (_tmp5_);
#line 451 "../src/DynamicNotebook.vala"
	*result = _tmp7_;
#line 451 "../src/DynamicNotebook.vala"
	return;
#line 3451 "DynamicNotebook.c"
}


void
closed_tabs_pick (ClosedTabs* self,
                  const gchar* search,
                  ClosedTabsEntry* result)
{
	ClosedTabsEntry picked = {0};
	ClosedTabsEntry _tmp0_ = {0};
#line 454 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 454 "../src/DynamicNotebook.vala"
	g_return_if_fail (search != NULL);
#line 455 "../src/DynamicNotebook.vala"
	_g_free0 (_tmp0_.label);
#line 455 "../src/DynamicNotebook.vala"
	_tmp0_.label = NULL;
#line 455 "../src/DynamicNotebook.vala"
	_g_free0 (_tmp0_.restore_data);
#line 455 "../src/DynamicNotebook.vala"
	_tmp0_.restore_data = NULL;
#line 455 "../src/DynamicNotebook.vala"
	_g_object_unref0 (_tmp0_.icon);
#line 455 "../src/DynamicNotebook.vala"
	_tmp0_.icon = NULL;
#line 455 "../src/DynamicNotebook.vala"
	picked = _tmp0_;
#line 3480 "DynamicNotebook.c"
	{
		gint i = 0;
#line 457 "../src/DynamicNotebook.vala"
		i = 0;
#line 3485 "DynamicNotebook.c"
		{
			gboolean _tmp1_ = FALSE;
#line 457 "../src/DynamicNotebook.vala"
			_tmp1_ = TRUE;
#line 457 "../src/DynamicNotebook.vala"
			while (TRUE) {
#line 3492 "DynamicNotebook.c"
				gint _tmp3_;
				GeeLinkedList* _tmp4_;
				gint _tmp5_;
				gint _tmp6_;
				ClosedTabsEntry* entry = NULL;
				GeeLinkedList* _tmp7_;
				gint _tmp8_;
				gpointer _tmp9_;
				ClosedTabsEntry* _tmp10_;
				const gchar* _tmp11_;
#line 457 "../src/DynamicNotebook.vala"
				if (!_tmp1_) {
#line 3505 "DynamicNotebook.c"
					gint _tmp2_;
#line 457 "../src/DynamicNotebook.vala"
					_tmp2_ = i;
#line 457 "../src/DynamicNotebook.vala"
					i = _tmp2_ + 1;
#line 3511 "DynamicNotebook.c"
				}
#line 457 "../src/DynamicNotebook.vala"
				_tmp1_ = FALSE;
#line 457 "../src/DynamicNotebook.vala"
				_tmp3_ = i;
#line 457 "../src/DynamicNotebook.vala"
				_tmp4_ = self->priv->closed_tabs;
#line 457 "../src/DynamicNotebook.vala"
				_tmp5_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp4_);
#line 457 "../src/DynamicNotebook.vala"
				_tmp6_ = _tmp5_;
#line 457 "../src/DynamicNotebook.vala"
				if (!(_tmp3_ < _tmp6_)) {
#line 457 "../src/DynamicNotebook.vala"
					break;
#line 3527 "DynamicNotebook.c"
				}
#line 458 "../src/DynamicNotebook.vala"
				_tmp7_ = self->priv->closed_tabs;
#line 458 "../src/DynamicNotebook.vala"
				_tmp8_ = i;
#line 458 "../src/DynamicNotebook.vala"
				_tmp9_ = gee_abstract_list_get ((GeeAbstractList*) _tmp7_, _tmp8_);
#line 458 "../src/DynamicNotebook.vala"
				entry = (ClosedTabsEntry*) _tmp9_;
#line 460 "../src/DynamicNotebook.vala"
				_tmp10_ = entry;
#line 460 "../src/DynamicNotebook.vala"
				_tmp11_ = (*_tmp10_).restore_data;
#line 460 "../src/DynamicNotebook.vala"
				if (g_strcmp0 (_tmp11_, search) == 0) {
#line 3543 "DynamicNotebook.c"
					GeeLinkedList* _tmp12_;
					gint _tmp13_;
					gpointer _tmp14_;
					ClosedTabsEntry* _tmp15_;
					ClosedTabsEntry _tmp16_ = {0};
#line 461 "../src/DynamicNotebook.vala"
					_tmp12_ = self->priv->closed_tabs;
#line 461 "../src/DynamicNotebook.vala"
					_tmp13_ = i;
#line 461 "../src/DynamicNotebook.vala"
					_tmp14_ = gee_abstract_list_remove_at ((GeeAbstractList*) _tmp12_, _tmp13_);
#line 461 "../src/DynamicNotebook.vala"
					_tmp15_ = (ClosedTabsEntry*) _tmp14_;
#line 461 "../src/DynamicNotebook.vala"
					closed_tabs_entry_copy (_tmp15_, &_tmp16_);
#line 461 "../src/DynamicNotebook.vala"
					closed_tabs_entry_destroy (&picked);
#line 461 "../src/DynamicNotebook.vala"
					picked = _tmp16_;
#line 461 "../src/DynamicNotebook.vala"
					_closed_tabs_entry_free0 (_tmp15_);
#line 462 "../src/DynamicNotebook.vala"
					_closed_tabs_entry_free0 (entry);
#line 462 "../src/DynamicNotebook.vala"
					break;
#line 3569 "DynamicNotebook.c"
				}
#line 457 "../src/DynamicNotebook.vala"
				_closed_tabs_entry_free0 (entry);
#line 3573 "DynamicNotebook.c"
			}
		}
	}
#line 466 "../src/DynamicNotebook.vala"
	*result = picked;
#line 466 "../src/DynamicNotebook.vala"
	return;
#line 3581 "DynamicNotebook.c"
}


gint
closed_tabs_get_max_restorable_tabs (ClosedTabs* self)
{
	gint result;
	gint _tmp0_;
#line 400 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 400 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->_max_restorable_tabs;
#line 400 "../src/DynamicNotebook.vala"
	result = _tmp0_;
#line 400 "../src/DynamicNotebook.vala"
	return result;
#line 3598 "DynamicNotebook.c"
}


void
closed_tabs_set_max_restorable_tabs (ClosedTabs* self,
                                     gint value)
{
#line 401 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 402 "../src/DynamicNotebook.vala"
	_vala_assert (value > 0, "value > 0");
#line 403 "../src/DynamicNotebook.vala"
	self->priv->_max_restorable_tabs = value;
#line 401 "../src/DynamicNotebook.vala"
	g_object_notify_by_pspec ((GObject *) self, closed_tabs_properties[CLOSED_TABS_MAX_RESTORABLE_TABS_PROPERTY]);
#line 3614 "DynamicNotebook.c"
}


gboolean
closed_tabs_get_empty (ClosedTabs* self)
{
	gboolean result;
	GeeLinkedList* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 425 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 426 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->closed_tabs;
#line 426 "../src/DynamicNotebook.vala"
	_tmp1_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp0_);
#line 426 "../src/DynamicNotebook.vala"
	_tmp2_ = _tmp1_;
#line 426 "../src/DynamicNotebook.vala"
	result = _tmp2_ == 0;
#line 426 "../src/DynamicNotebook.vala"
	return result;
#line 3637 "DynamicNotebook.c"
}


static Block8Data*
block8_data_ref (Block8Data* _data8_)
{
#line 473 "../src/DynamicNotebook.vala"
	g_atomic_int_inc (&_data8_->_ref_count_);
#line 473 "../src/DynamicNotebook.vala"
	return _data8_;
#line 3648 "DynamicNotebook.c"
}


static void
block8_data_unref (void * _userdata_)
{
	Block8Data* _data8_;
	_data8_ = (Block8Data*) _userdata_;
#line 473 "../src/DynamicNotebook.vala"
	if (g_atomic_int_dec_and_test (&_data8_->_ref_count_)) {
#line 3659 "DynamicNotebook.c"
		ClosedTabs* self;
#line 473 "../src/DynamicNotebook.vala"
		self = _data8_->self;
#line 473 "../src/DynamicNotebook.vala"
		_closed_tabs_entry_free0 (_data8_->entry);
#line 473 "../src/DynamicNotebook.vala"
		_g_object_unref0 (self);
#line 473 "../src/DynamicNotebook.vala"
		g_slice_free (Block8Data, _data8_);
#line 3669 "DynamicNotebook.c"
	}
}


static void
_closed_tabs_menu_____lambda17_ (Block8Data* _data8_)
{
	ClosedTabs* self;
	ClosedTabsEntry e = {0};
	ClosedTabsEntry* _tmp0_;
	const gchar* _tmp1_;
	ClosedTabsEntry _tmp2_ = {0};
	ClosedTabsEntry _tmp3_;
	const gchar* _tmp4_;
	ClosedTabsEntry _tmp5_;
	const gchar* _tmp6_;
	ClosedTabsEntry _tmp7_;
	GIcon* _tmp8_;
#line 477 "../src/DynamicNotebook.vala"
	self = _data8_->self;
#line 478 "../src/DynamicNotebook.vala"
	_tmp0_ = _data8_->entry;
#line 478 "../src/DynamicNotebook.vala"
	_tmp1_ = (*_tmp0_).restore_data;
#line 478 "../src/DynamicNotebook.vala"
	closed_tabs_pick (self, _tmp1_, &_tmp2_);
#line 478 "../src/DynamicNotebook.vala"
	e = _tmp2_;
#line 479 "../src/DynamicNotebook.vala"
	_tmp3_ = e;
#line 479 "../src/DynamicNotebook.vala"
	_tmp4_ = _tmp3_.label;
#line 479 "../src/DynamicNotebook.vala"
	_tmp5_ = e;
#line 479 "../src/DynamicNotebook.vala"
	_tmp6_ = _tmp5_.restore_data;
#line 479 "../src/DynamicNotebook.vala"
	_tmp7_ = e;
#line 479 "../src/DynamicNotebook.vala"
	_tmp8_ = _tmp7_.icon;
#line 479 "../src/DynamicNotebook.vala"
	g_signal_emit (self, closed_tabs_signals[CLOSED_TABS_RESTORED_SIGNAL], 0, _tmp4_, _tmp6_, _tmp8_);
#line 477 "../src/DynamicNotebook.vala"
	closed_tabs_entry_destroy (&e);
#line 3714 "DynamicNotebook.c"
}


static void
__closed_tabs_menu_____lambda17__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                         gpointer self)
{
#line 477 "../src/DynamicNotebook.vala"
	_closed_tabs_menu_____lambda17_ (self);
#line 3724 "DynamicNotebook.c"
}


static void
_closed_tabs_menu____lambda18_ (ClosedTabs* self)
{
	GeeLinkedList* _tmp15_;
	{
		GeeLinkedList* _entry_list = NULL;
		GeeLinkedList* _tmp0_;
		GeeLinkedList* _tmp1_;
		gint _entry_size = 0;
		GeeLinkedList* _tmp2_;
		gint _tmp3_;
		gint _tmp4_;
		gint _entry_index = 0;
#line 491 "../src/DynamicNotebook.vala"
		_tmp0_ = self->priv->closed_tabs;
#line 491 "../src/DynamicNotebook.vala"
		_tmp1_ = _g_object_ref0 (_tmp0_);
#line 491 "../src/DynamicNotebook.vala"
		_entry_list = _tmp1_;
#line 491 "../src/DynamicNotebook.vala"
		_tmp2_ = _entry_list;
#line 491 "../src/DynamicNotebook.vala"
		_tmp3_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp2_);
#line 491 "../src/DynamicNotebook.vala"
		_tmp4_ = _tmp3_;
#line 491 "../src/DynamicNotebook.vala"
		_entry_size = _tmp4_;
#line 491 "../src/DynamicNotebook.vala"
		_entry_index = -1;
#line 491 "../src/DynamicNotebook.vala"
		while (TRUE) {
#line 3759 "DynamicNotebook.c"
			gint _tmp5_;
			gint _tmp6_;
			gint _tmp7_;
			ClosedTabsEntry* entry = NULL;
			GeeLinkedList* _tmp8_;
			gint _tmp9_;
			gpointer _tmp10_;
			ClosedTabsEntry* _tmp11_;
			GraniteWidgetsDroppedDelegate _tmp12_;
			void* _tmp12__target;
#line 491 "../src/DynamicNotebook.vala"
			_tmp5_ = _entry_index;
#line 491 "../src/DynamicNotebook.vala"
			_entry_index = _tmp5_ + 1;
#line 491 "../src/DynamicNotebook.vala"
			_tmp6_ = _entry_index;
#line 491 "../src/DynamicNotebook.vala"
			_tmp7_ = _entry_size;
#line 491 "../src/DynamicNotebook.vala"
			if (!(_tmp6_ < _tmp7_)) {
#line 491 "../src/DynamicNotebook.vala"
				break;
#line 3782 "DynamicNotebook.c"
			}
#line 491 "../src/DynamicNotebook.vala"
			_tmp8_ = _entry_list;
#line 491 "../src/DynamicNotebook.vala"
			_tmp9_ = _entry_index;
#line 491 "../src/DynamicNotebook.vala"
			_tmp10_ = gee_abstract_list_get ((GeeAbstractList*) _tmp8_, _tmp9_);
#line 491 "../src/DynamicNotebook.vala"
			entry = (ClosedTabsEntry*) _tmp10_;
#line 492 "../src/DynamicNotebook.vala"
			_tmp11_ = entry;
#line 492 "../src/DynamicNotebook.vala"
			_tmp12_ = (*_tmp11_).dropped_callback;
#line 492 "../src/DynamicNotebook.vala"
			_tmp12__target = (*_tmp11_).dropped_callback_target;
#line 492 "../src/DynamicNotebook.vala"
			if (_tmp12_ != NULL) {
#line 3800 "DynamicNotebook.c"
				ClosedTabsEntry* _tmp13_;
				GraniteWidgetsDroppedDelegate _tmp14_;
				void* _tmp14__target;
#line 493 "../src/DynamicNotebook.vala"
				_tmp13_ = entry;
#line 493 "../src/DynamicNotebook.vala"
				_tmp14_ = (*_tmp13_).dropped_callback;
#line 493 "../src/DynamicNotebook.vala"
				_tmp14__target = (*_tmp13_).dropped_callback_target;
#line 493 "../src/DynamicNotebook.vala"
				_tmp14_ (_tmp14__target);
#line 3812 "DynamicNotebook.c"
			}
#line 491 "../src/DynamicNotebook.vala"
			_closed_tabs_entry_free0 (entry);
#line 3816 "DynamicNotebook.c"
		}
#line 491 "../src/DynamicNotebook.vala"
		_g_object_unref0 (_entry_list);
#line 3820 "DynamicNotebook.c"
	}
#line 497 "../src/DynamicNotebook.vala"
	_tmp15_ = self->priv->closed_tabs;
#line 497 "../src/DynamicNotebook.vala"
	gee_abstract_collection_clear ((GeeAbstractCollection*) _tmp15_);
#line 498 "../src/DynamicNotebook.vala"
	g_signal_emit (self, closed_tabs_signals[CLOSED_TABS_CLEARED_SIGNAL], 0);
#line 3828 "DynamicNotebook.c"
}


static void
__closed_tabs_menu____lambda18__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                        gpointer self)
{
#line 490 "../src/DynamicNotebook.vala"
	_closed_tabs_menu____lambda18_ ((ClosedTabs*) self);
#line 3838 "DynamicNotebook.c"
}


GtkMenu*
closed_tabs_get_menu (ClosedTabs* self)
{
	GtkMenu* result;
	GtkMenu* _menu = NULL;
	GtkMenu* _tmp0_;
	gboolean _tmp18_;
	gboolean _tmp19_;
#line 470 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 471 "../src/DynamicNotebook.vala"
	_tmp0_ = (GtkMenu*) gtk_menu_new ();
#line 471 "../src/DynamicNotebook.vala"
	g_object_ref_sink (_tmp0_);
#line 471 "../src/DynamicNotebook.vala"
	_menu = _tmp0_;
#line 3858 "DynamicNotebook.c"
	{
		GeeLinkedList* _entry_list = NULL;
		GeeLinkedList* _tmp1_;
		GeeLinkedList* _tmp2_;
		gint _entry_size = 0;
		GeeLinkedList* _tmp3_;
		gint _tmp4_;
		gint _tmp5_;
		gint _entry_index = 0;
#line 473 "../src/DynamicNotebook.vala"
		_tmp1_ = self->priv->closed_tabs;
#line 473 "../src/DynamicNotebook.vala"
		_tmp2_ = _g_object_ref0 (_tmp1_);
#line 473 "../src/DynamicNotebook.vala"
		_entry_list = _tmp2_;
#line 473 "../src/DynamicNotebook.vala"
		_tmp3_ = _entry_list;
#line 473 "../src/DynamicNotebook.vala"
		_tmp4_ = gee_abstract_collection_get_size ((GeeAbstractCollection*) _tmp3_);
#line 473 "../src/DynamicNotebook.vala"
		_tmp5_ = _tmp4_;
#line 473 "../src/DynamicNotebook.vala"
		_entry_size = _tmp5_;
#line 473 "../src/DynamicNotebook.vala"
		_entry_index = -1;
#line 473 "../src/DynamicNotebook.vala"
		while (TRUE) {
#line 3886 "DynamicNotebook.c"
			Block8Data* _data8_;
			gint _tmp6_;
			gint _tmp7_;
			gint _tmp8_;
			GeeLinkedList* _tmp9_;
			gint _tmp10_;
			gpointer _tmp11_;
			GtkMenuItem* item = NULL;
			ClosedTabsEntry* _tmp12_;
			const gchar* _tmp13_;
			GtkMenuItem* _tmp14_;
			GtkMenu* _tmp15_;
			GtkMenuItem* _tmp16_;
			GtkMenuItem* _tmp17_;
#line 473 "../src/DynamicNotebook.vala"
			_data8_ = g_slice_new0 (Block8Data);
#line 473 "../src/DynamicNotebook.vala"
			_data8_->_ref_count_ = 1;
#line 473 "../src/DynamicNotebook.vala"
			_data8_->self = g_object_ref (self);
#line 473 "../src/DynamicNotebook.vala"
			_tmp6_ = _entry_index;
#line 473 "../src/DynamicNotebook.vala"
			_entry_index = _tmp6_ + 1;
#line 473 "../src/DynamicNotebook.vala"
			_tmp7_ = _entry_index;
#line 473 "../src/DynamicNotebook.vala"
			_tmp8_ = _entry_size;
#line 473 "../src/DynamicNotebook.vala"
			if (!(_tmp7_ < _tmp8_)) {
#line 473 "../src/DynamicNotebook.vala"
				block8_data_unref (_data8_);
#line 473 "../src/DynamicNotebook.vala"
				_data8_ = NULL;
#line 473 "../src/DynamicNotebook.vala"
				break;
#line 3923 "DynamicNotebook.c"
			}
#line 473 "../src/DynamicNotebook.vala"
			_tmp9_ = _entry_list;
#line 473 "../src/DynamicNotebook.vala"
			_tmp10_ = _entry_index;
#line 473 "../src/DynamicNotebook.vala"
			_tmp11_ = gee_abstract_list_get ((GeeAbstractList*) _tmp9_, _tmp10_);
#line 473 "../src/DynamicNotebook.vala"
			_data8_->entry = (ClosedTabsEntry*) _tmp11_;
#line 474 "../src/DynamicNotebook.vala"
			_tmp12_ = _data8_->entry;
#line 474 "../src/DynamicNotebook.vala"
			_tmp13_ = (*_tmp12_).label;
#line 474 "../src/DynamicNotebook.vala"
			_tmp14_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_tmp13_);
#line 474 "../src/DynamicNotebook.vala"
			g_object_ref_sink (_tmp14_);
#line 474 "../src/DynamicNotebook.vala"
			item = _tmp14_;
#line 475 "../src/DynamicNotebook.vala"
			_tmp15_ = _menu;
#line 475 "../src/DynamicNotebook.vala"
			_tmp16_ = item;
#line 475 "../src/DynamicNotebook.vala"
			gtk_menu_shell_prepend ((GtkMenuShell*) _tmp15_, (GtkWidget*) _tmp16_);
#line 477 "../src/DynamicNotebook.vala"
			_tmp17_ = item;
#line 477 "../src/DynamicNotebook.vala"
			g_signal_connect_data (_tmp17_, "activate", (GCallback) __closed_tabs_menu_____lambda17__gtk_menu_item_activate, block8_data_ref (_data8_), (GClosureNotify) block8_data_unref, 0);
#line 473 "../src/DynamicNotebook.vala"
			_g_object_unref0 (item);
#line 473 "../src/DynamicNotebook.vala"
			block8_data_unref (_data8_);
#line 473 "../src/DynamicNotebook.vala"
			_data8_ = NULL;
#line 3959 "DynamicNotebook.c"
		}
#line 473 "../src/DynamicNotebook.vala"
		_g_object_unref0 (_entry_list);
#line 3963 "DynamicNotebook.c"
	}
#line 483 "../src/DynamicNotebook.vala"
	_tmp18_ = closed_tabs_get_empty (self);
#line 483 "../src/DynamicNotebook.vala"
	_tmp19_ = _tmp18_;
#line 483 "../src/DynamicNotebook.vala"
	if (!_tmp19_) {
#line 3971 "DynamicNotebook.c"
		GtkSeparatorMenuItem* separator = NULL;
		GtkSeparatorMenuItem* _tmp20_;
		GtkMenuItem* item = NULL;
		GtkMenuItem* _tmp21_;
		GtkMenu* _tmp22_;
		GtkSeparatorMenuItem* _tmp23_;
		GtkMenu* _tmp24_;
		GtkMenuItem* _tmp25_;
		GtkMenuItem* _tmp26_;
#line 484 "../src/DynamicNotebook.vala"
		_tmp20_ = (GtkSeparatorMenuItem*) gtk_separator_menu_item_new ();
#line 484 "../src/DynamicNotebook.vala"
		g_object_ref_sink (_tmp20_);
#line 484 "../src/DynamicNotebook.vala"
		separator = _tmp20_;
#line 485 "../src/DynamicNotebook.vala"
		_tmp21_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Clear All"));
#line 485 "../src/DynamicNotebook.vala"
		g_object_ref_sink (_tmp21_);
#line 485 "../src/DynamicNotebook.vala"
		item = _tmp21_;
#line 487 "../src/DynamicNotebook.vala"
		_tmp22_ = _menu;
#line 487 "../src/DynamicNotebook.vala"
		_tmp23_ = separator;
#line 487 "../src/DynamicNotebook.vala"
		gtk_menu_shell_append ((GtkMenuShell*) _tmp22_, (GtkMenuItem*) _tmp23_);
#line 488 "../src/DynamicNotebook.vala"
		_tmp24_ = _menu;
#line 488 "../src/DynamicNotebook.vala"
		_tmp25_ = item;
#line 488 "../src/DynamicNotebook.vala"
		gtk_menu_shell_append ((GtkMenuShell*) _tmp24_, _tmp25_);
#line 490 "../src/DynamicNotebook.vala"
		_tmp26_ = item;
#line 490 "../src/DynamicNotebook.vala"
		g_signal_connect_object (_tmp26_, "activate", (GCallback) __closed_tabs_menu____lambda18__gtk_menu_item_activate, self, 0);
#line 483 "../src/DynamicNotebook.vala"
		_g_object_unref0 (item);
#line 483 "../src/DynamicNotebook.vala"
		_g_object_unref0 (separator);
#line 4013 "DynamicNotebook.c"
	}
#line 502 "../src/DynamicNotebook.vala"
	result = _menu;
#line 502 "../src/DynamicNotebook.vala"
	return result;
#line 4019 "DynamicNotebook.c"
}


static void
g_cclosure_user_marshal_VOID__STRING_STRING_OBJECT (GClosure * closure,
                                                    GValue * return_value,
                                                    guint n_param_values,
                                                    const GValue * param_values,
                                                    gpointer invocation_hint,
                                                    gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__STRING_STRING_OBJECT) (gpointer data1, const char* arg_1, const char* arg_2, gpointer arg_3, gpointer data2);
	register GMarshalFunc_VOID__STRING_STRING_OBJECT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 393 "../src/DynamicNotebook.vala"
	g_return_if_fail (n_param_values == 4);
#line 393 "../src/DynamicNotebook.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 393 "../src/DynamicNotebook.vala"
		data1 = closure->data;
#line 393 "../src/DynamicNotebook.vala"
		data2 = param_values->data[0].v_pointer;
#line 4045 "DynamicNotebook.c"
	} else {
#line 393 "../src/DynamicNotebook.vala"
		data1 = param_values->data[0].v_pointer;
#line 393 "../src/DynamicNotebook.vala"
		data2 = closure->data;
#line 4051 "DynamicNotebook.c"
	}
#line 393 "../src/DynamicNotebook.vala"
	callback = (GMarshalFunc_VOID__STRING_STRING_OBJECT) (marshal_data ? marshal_data : cc->callback);
#line 393 "../src/DynamicNotebook.vala"
	callback (data1, g_value_get_string (param_values + 1), g_value_get_string (param_values + 2), g_value_get_object (param_values + 3), data2);
#line 4057 "DynamicNotebook.c"
}


static GObject *
closed_tabs_constructor (GType type,
                         guint n_construct_properties,
                         GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	ClosedTabs * self;
	GeeLinkedList* _tmp0_;
#line 420 "../src/DynamicNotebook.vala"
	parent_class = G_OBJECT_CLASS (closed_tabs_parent_class);
#line 420 "../src/DynamicNotebook.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 420 "../src/DynamicNotebook.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CLOSED_TABS, ClosedTabs);
#line 421 "../src/DynamicNotebook.vala"
	_tmp0_ = gee_linked_list_new (CLOSED_TABS_TYPE_ENTRY, (GBoxedCopyFunc) closed_tabs_entry_dup, (GDestroyNotify) closed_tabs_entry_free, NULL, NULL, NULL);
#line 421 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->priv->closed_tabs);
#line 421 "../src/DynamicNotebook.vala"
	self->priv->closed_tabs = _tmp0_;
#line 420 "../src/DynamicNotebook.vala"
	return obj;
#line 4084 "DynamicNotebook.c"
}


void
closed_tabs_entry_copy (const ClosedTabsEntry* self,
                        ClosedTabsEntry* dest)
{
	const gchar* _tmp0_;
	gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	GIcon* _tmp4_;
	GIcon* _tmp5_;
	GraniteWidgetsDroppedDelegate _tmp6_;
	void* _tmp6__target;
#line 407 "../src/DynamicNotebook.vala"
	_tmp0_ = (*self).label;
#line 407 "../src/DynamicNotebook.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 407 "../src/DynamicNotebook.vala"
	_g_free0 ((*dest).label);
#line 407 "../src/DynamicNotebook.vala"
	(*dest).label = _tmp1_;
#line 407 "../src/DynamicNotebook.vala"
	_tmp2_ = (*self).restore_data;
#line 407 "../src/DynamicNotebook.vala"
	_tmp3_ = g_strdup (_tmp2_);
#line 407 "../src/DynamicNotebook.vala"
	_g_free0 ((*dest).restore_data);
#line 407 "../src/DynamicNotebook.vala"
	(*dest).restore_data = _tmp3_;
#line 407 "../src/DynamicNotebook.vala"
	_tmp4_ = (*self).icon;
#line 407 "../src/DynamicNotebook.vala"
	_tmp5_ = _g_object_ref0 (_tmp4_);
#line 407 "../src/DynamicNotebook.vala"
	_g_object_unref0 ((*dest).icon);
#line 407 "../src/DynamicNotebook.vala"
	(*dest).icon = _tmp5_;
#line 407 "../src/DynamicNotebook.vala"
	_tmp6_ = (*self).dropped_callback;
#line 407 "../src/DynamicNotebook.vala"
	_tmp6__target = (*self).dropped_callback_target;
#line 407 "../src/DynamicNotebook.vala"
	(*dest).dropped_callback = _tmp6_;
#line 407 "../src/DynamicNotebook.vala"
	(*dest).dropped_callback_target = _tmp6__target;
#line 4132 "DynamicNotebook.c"
}


void
closed_tabs_entry_destroy (ClosedTabsEntry* self)
{
#line 408 "../src/DynamicNotebook.vala"
	_g_free0 ((*self).label);
#line 409 "../src/DynamicNotebook.vala"
	_g_free0 ((*self).restore_data);
#line 410 "../src/DynamicNotebook.vala"
	_g_object_unref0 ((*self).icon);
#line 4145 "DynamicNotebook.c"
}


ClosedTabsEntry*
closed_tabs_entry_dup (const ClosedTabsEntry* self)
{
	ClosedTabsEntry* dup;
#line 407 "../src/DynamicNotebook.vala"
	dup = g_new0 (ClosedTabsEntry, 1);
#line 407 "../src/DynamicNotebook.vala"
	closed_tabs_entry_copy (self, dup);
#line 407 "../src/DynamicNotebook.vala"
	return dup;
#line 4159 "DynamicNotebook.c"
}


void
closed_tabs_entry_free (ClosedTabsEntry* self)
{
#line 407 "../src/DynamicNotebook.vala"
	closed_tabs_entry_destroy (self);
#line 407 "../src/DynamicNotebook.vala"
	g_free (self);
#line 4170 "DynamicNotebook.c"
}


GType
closed_tabs_entry_get_type (void)
{
	static volatile gsize closed_tabs_entry_type_id__volatile = 0;
	if (g_once_init_enter (&closed_tabs_entry_type_id__volatile)) {
		GType closed_tabs_entry_type_id;
		closed_tabs_entry_type_id = g_boxed_type_register_static ("ClosedTabsEntry", (GBoxedCopyFunc) closed_tabs_entry_dup, (GBoxedFreeFunc) closed_tabs_entry_free);
		g_once_init_leave (&closed_tabs_entry_type_id__volatile, closed_tabs_entry_type_id);
	}
	return closed_tabs_entry_type_id__volatile;
}


static void
closed_tabs_class_init (ClosedTabsClass * klass)
{
#line 393 "../src/DynamicNotebook.vala"
	closed_tabs_parent_class = g_type_class_peek_parent (klass);
#line 393 "../src/DynamicNotebook.vala"
	g_type_class_adjust_private_offset (klass, &ClosedTabs_private_offset);
#line 393 "../src/DynamicNotebook.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_closed_tabs_get_property;
#line 393 "../src/DynamicNotebook.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_closed_tabs_set_property;
#line 393 "../src/DynamicNotebook.vala"
	G_OBJECT_CLASS (klass)->constructor = closed_tabs_constructor;
#line 393 "../src/DynamicNotebook.vala"
	G_OBJECT_CLASS (klass)->finalize = closed_tabs_finalize;
#line 393 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CLOSED_TABS_MAX_RESTORABLE_TABS_PROPERTY, closed_tabs_properties[CLOSED_TABS_MAX_RESTORABLE_TABS_PROPERTY] = g_param_spec_int ("max-restorable-tabs", "max-restorable-tabs", "max-restorable-tabs", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 393 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CLOSED_TABS_EMPTY_PROPERTY, closed_tabs_properties[CLOSED_TABS_EMPTY_PROPERTY] = g_param_spec_boolean ("empty", "empty", "empty", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 393 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), CLOSED_TABS_MENU_PROPERTY, closed_tabs_properties[CLOSED_TABS_MENU_PROPERTY] = g_param_spec_object ("menu", "menu", "menu", gtk_menu_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 393 "../src/DynamicNotebook.vala"
	closed_tabs_signals[CLOSED_TABS_RESTORED_SIGNAL] = g_signal_new ("restored", TYPE_CLOSED_TABS, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_STRING_OBJECT, G_TYPE_NONE, 3, G_TYPE_STRING, G_TYPE_STRING, g_icon_get_type ());
#line 393 "../src/DynamicNotebook.vala"
	closed_tabs_signals[CLOSED_TABS_CLEARED_SIGNAL] = g_signal_new ("cleared", TYPE_CLOSED_TABS, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 4212 "DynamicNotebook.c"
}


static void
closed_tabs_instance_init (ClosedTabs * self)
{
#line 393 "../src/DynamicNotebook.vala"
	self->priv = closed_tabs_get_instance_private (self);
#line 398 "../src/DynamicNotebook.vala"
	self->priv->_max_restorable_tabs = 10;
#line 4223 "DynamicNotebook.c"
}


static void
closed_tabs_finalize (GObject * obj)
{
	ClosedTabs * self;
#line 393 "../src/DynamicNotebook.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_CLOSED_TABS, ClosedTabs);
#line 414 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->priv->closed_tabs);
#line 393 "../src/DynamicNotebook.vala"
	G_OBJECT_CLASS (closed_tabs_parent_class)->finalize (obj);
#line 4237 "DynamicNotebook.c"
}


GType
closed_tabs_get_type (void)
{
	static volatile gsize closed_tabs_type_id__volatile = 0;
	if (g_once_init_enter (&closed_tabs_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (ClosedTabsClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) closed_tabs_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (ClosedTabs), 0, (GInstanceInitFunc) closed_tabs_instance_init, NULL };
		GType closed_tabs_type_id;
		closed_tabs_type_id = g_type_register_static (G_TYPE_OBJECT, "ClosedTabs", &g_define_type_info, 0);
		ClosedTabs_private_offset = g_type_add_instance_private (closed_tabs_type_id, sizeof (ClosedTabsPrivate));
		g_once_init_leave (&closed_tabs_type_id__volatile, closed_tabs_type_id);
	}
	return closed_tabs_type_id__volatile;
}


static void
_vala_closed_tabs_get_property (GObject * object,
                                guint property_id,
                                GValue * value,
                                GParamSpec * pspec)
{
	ClosedTabs * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CLOSED_TABS, ClosedTabs);
#line 393 "../src/DynamicNotebook.vala"
	switch (property_id) {
#line 393 "../src/DynamicNotebook.vala"
		case CLOSED_TABS_MAX_RESTORABLE_TABS_PROPERTY:
#line 393 "../src/DynamicNotebook.vala"
		g_value_set_int (value, closed_tabs_get_max_restorable_tabs (self));
#line 393 "../src/DynamicNotebook.vala"
		break;
#line 393 "../src/DynamicNotebook.vala"
		case CLOSED_TABS_EMPTY_PROPERTY:
#line 393 "../src/DynamicNotebook.vala"
		g_value_set_boolean (value, closed_tabs_get_empty (self));
#line 393 "../src/DynamicNotebook.vala"
		break;
#line 393 "../src/DynamicNotebook.vala"
		case CLOSED_TABS_MENU_PROPERTY:
#line 393 "../src/DynamicNotebook.vala"
		g_value_take_object (value, closed_tabs_get_menu (self));
#line 393 "../src/DynamicNotebook.vala"
		break;
#line 4284 "DynamicNotebook.c"
		default:
#line 393 "../src/DynamicNotebook.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 393 "../src/DynamicNotebook.vala"
		break;
#line 4290 "DynamicNotebook.c"
	}
}


static void
_vala_closed_tabs_set_property (GObject * object,
                                guint property_id,
                                const GValue * value,
                                GParamSpec * pspec)
{
	ClosedTabs * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_CLOSED_TABS, ClosedTabs);
#line 393 "../src/DynamicNotebook.vala"
	switch (property_id) {
#line 393 "../src/DynamicNotebook.vala"
		case CLOSED_TABS_MAX_RESTORABLE_TABS_PROPERTY:
#line 393 "../src/DynamicNotebook.vala"
		closed_tabs_set_max_restorable_tabs (self, g_value_get_int (value));
#line 393 "../src/DynamicNotebook.vala"
		break;
#line 4311 "DynamicNotebook.c"
		default:
#line 393 "../src/DynamicNotebook.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 393 "../src/DynamicNotebook.vala"
		break;
#line 4317 "DynamicNotebook.c"
	}
}


static inline gpointer
dynamic_notebook_get_instance_private (DynamicNotebook* self)
{
	return G_STRUCT_MEMBER_P (self, DynamicNotebook_private_offset);
}


GType
dynamic_notebook_tab_bar_behavior_get_type (void)
{
	static volatile gsize dynamic_notebook_tab_bar_behavior_type_id__volatile = 0;
	if (g_once_init_enter (&dynamic_notebook_tab_bar_behavior_type_id__volatile)) {
		static const GEnumValue values[] = {{DYNAMIC_NOTEBOOK_TAB_BAR_BEHAVIOR_ALWAYS, "DYNAMIC_NOTEBOOK_TAB_BAR_BEHAVIOR_ALWAYS", "always"}, {DYNAMIC_NOTEBOOK_TAB_BAR_BEHAVIOR_SINGLE, "DYNAMIC_NOTEBOOK_TAB_BAR_BEHAVIOR_SINGLE", "single"}, {DYNAMIC_NOTEBOOK_TAB_BAR_BEHAVIOR_NEVER, "DYNAMIC_NOTEBOOK_TAB_BAR_BEHAVIOR_NEVER", "never"}, {0, NULL, NULL}};
		GType dynamic_notebook_tab_bar_behavior_type_id;
		dynamic_notebook_tab_bar_behavior_type_id = g_enum_register_static ("DynamicNotebookTabBarBehavior", values);
		g_once_init_leave (&dynamic_notebook_tab_bar_behavior_type_id__volatile, dynamic_notebook_tab_bar_behavior_type_id);
	}
	return dynamic_notebook_tab_bar_behavior_type_id__volatile;
}


static void
_g_object_unref0_ (gpointer var)
{
#line 674 "../src/DynamicNotebook.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 4348 "DynamicNotebook.c"
}


static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 674 "../src/DynamicNotebook.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 4357 "DynamicNotebook.c"
}


/**
         * Create a new dynamic notebook
         */
DynamicNotebook*
dynamic_notebook_construct (GType object_type)
{
	DynamicNotebook * self = NULL;
#line 745 "../src/DynamicNotebook.vala"
	self = (DynamicNotebook*) g_object_new (object_type, NULL);
#line 745 "../src/DynamicNotebook.vala"
	return self;
#line 4372 "DynamicNotebook.c"
}


DynamicNotebook*
dynamic_notebook_new (void)
{
#line 745 "../src/DynamicNotebook.vala"
	return dynamic_notebook_construct (TYPE_DYNAMIC_NOTEBOOK);
#line 4381 "DynamicNotebook.c"
}


static void
dynamic_notebook_on_switch_page (DynamicNotebook* self,
                                 GtkWidget* page,
                                 guint pagenum)
{
	TabPageContainer* cont = NULL;
	TabPageContainer* _tmp0_;
	TabPageContainer* _tmp1_;
	Tab* new_tab = NULL;
	TabPageContainer* _tmp2_;
	Tab* _tmp3_;
	Tab* _tmp4_;
	Tab* _tmp5_;
	Tab* _tmp6_;
	Tab* _tmp8_;
	Tab* _tmp9_;
	Tab* _tmp10_;
	Tab* _tmp11_;
	Tab* _tmp12_;
#line 943 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 943 "../src/DynamicNotebook.vala"
	g_return_if_fail (page != NULL);
#line 944 "../src/DynamicNotebook.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (page, TYPE_TAB_PAGE_CONTAINER) ? ((TabPageContainer*) page) : NULL);
#line 944 "../src/DynamicNotebook.vala"
	cont = _tmp0_;
#line 945 "../src/DynamicNotebook.vala"
	_tmp1_ = cont;
#line 945 "../src/DynamicNotebook.vala"
	if (_tmp1_ == NULL) {
#line 945 "../src/DynamicNotebook.vala"
		_g_object_unref0 (cont);
#line 945 "../src/DynamicNotebook.vala"
		return;
#line 4420 "DynamicNotebook.c"
	}
#line 947 "../src/DynamicNotebook.vala"
	_tmp2_ = cont;
#line 947 "../src/DynamicNotebook.vala"
	_tmp3_ = tab_page_container_get_tab (_tmp2_);
#line 947 "../src/DynamicNotebook.vala"
	_tmp4_ = _tmp3_;
#line 947 "../src/DynamicNotebook.vala"
	_tmp5_ = _g_object_ref0 (_tmp4_);
#line 947 "../src/DynamicNotebook.vala"
	new_tab = _tmp5_;
#line 950 "../src/DynamicNotebook.vala"
	_tmp6_ = self->priv->old_tab;
#line 950 "../src/DynamicNotebook.vala"
	if (_tmp6_ != NULL) {
#line 4436 "DynamicNotebook.c"
		Tab* _tmp7_;
#line 951 "../src/DynamicNotebook.vala"
		_tmp7_ = self->priv->old_tab;
#line 951 "../src/DynamicNotebook.vala"
		tab_set_is_current_tab (_tmp7_, FALSE);
#line 4442 "DynamicNotebook.c"
	}
#line 954 "../src/DynamicNotebook.vala"
	_tmp8_ = new_tab;
#line 954 "../src/DynamicNotebook.vala"
	tab_set_is_current_tab (_tmp8_, TRUE);
#line 956 "../src/DynamicNotebook.vala"
	_tmp9_ = self->priv->old_tab;
#line 956 "../src/DynamicNotebook.vala"
	_tmp10_ = new_tab;
#line 956 "../src/DynamicNotebook.vala"
	g_signal_emit (self, dynamic_notebook_signals[DYNAMIC_NOTEBOOK_TAB_SWITCHED_SIGNAL], 0, _tmp9_, _tmp10_);
#line 958 "../src/DynamicNotebook.vala"
	_tmp11_ = new_tab;
#line 958 "../src/DynamicNotebook.vala"
	_tmp12_ = _g_object_ref0 (_tmp11_);
#line 958 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->priv->old_tab);
#line 958 "../src/DynamicNotebook.vala"
	self->priv->old_tab = _tmp12_;
#line 943 "../src/DynamicNotebook.vala"
	_g_object_unref0 (new_tab);
#line 943 "../src/DynamicNotebook.vala"
	_g_object_unref0 (cont);
#line 4466 "DynamicNotebook.c"
}


static void
dynamic_notebook_on_page_added (DynamicNotebook* self,
                                GtkWidget* page,
                                guint pagenum)
{
	TabPageContainer* cont = NULL;
	TabPageContainer* _tmp0_;
	TabPageContainer* _tmp1_;
	Tab* t = NULL;
	TabPageContainer* _tmp2_;
	Tab* _tmp3_;
	Tab* _tmp4_;
	Tab* _tmp5_;
	Tab* _tmp6_;
	Tab* _tmp7_;
#line 961 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 961 "../src/DynamicNotebook.vala"
	g_return_if_fail (page != NULL);
#line 962 "../src/DynamicNotebook.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (page, TYPE_TAB_PAGE_CONTAINER) ? ((TabPageContainer*) page) : NULL);
#line 962 "../src/DynamicNotebook.vala"
	cont = _tmp0_;
#line 963 "../src/DynamicNotebook.vala"
	_tmp1_ = cont;
#line 963 "../src/DynamicNotebook.vala"
	if (_tmp1_ == NULL) {
#line 963 "../src/DynamicNotebook.vala"
		_g_object_unref0 (cont);
#line 963 "../src/DynamicNotebook.vala"
		return;
#line 4501 "DynamicNotebook.c"
	}
#line 964 "../src/DynamicNotebook.vala"
	_tmp2_ = cont;
#line 964 "../src/DynamicNotebook.vala"
	_tmp3_ = tab_page_container_get_tab (_tmp2_);
#line 964 "../src/DynamicNotebook.vala"
	_tmp4_ = _tmp3_;
#line 964 "../src/DynamicNotebook.vala"
	_tmp5_ = _g_object_ref0 (_tmp4_);
#line 964 "../src/DynamicNotebook.vala"
	t = _tmp5_;
#line 966 "../src/DynamicNotebook.vala"
	_tmp6_ = t;
#line 966 "../src/DynamicNotebook.vala"
	dynamic_notebook_insert_callbacks (self, _tmp6_);
#line 967 "../src/DynamicNotebook.vala"
	_tmp7_ = t;
#line 967 "../src/DynamicNotebook.vala"
	g_signal_emit (self, dynamic_notebook_signals[DYNAMIC_NOTEBOOK_TAB_ADDED_SIGNAL], 0, _tmp7_);
#line 968 "../src/DynamicNotebook.vala"
	dynamic_notebook_update_tabs_visibility (self);
#line 961 "../src/DynamicNotebook.vala"
	_g_object_unref0 (t);
#line 961 "../src/DynamicNotebook.vala"
	_g_object_unref0 (cont);
#line 4527 "DynamicNotebook.c"
}


static void
dynamic_notebook_on_page_removed (DynamicNotebook* self,
                                  GtkWidget* page,
                                  guint pagenum)
{
	TabPageContainer* cont = NULL;
	TabPageContainer* _tmp0_;
	TabPageContainer* _tmp1_;
	Tab* t = NULL;
	TabPageContainer* _tmp2_;
	Tab* _tmp3_;
	Tab* _tmp4_;
	Tab* _tmp5_;
	Tab* _tmp6_;
	Tab* _tmp7_;
#line 971 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 971 "../src/DynamicNotebook.vala"
	g_return_if_fail (page != NULL);
#line 972 "../src/DynamicNotebook.vala"
	_tmp0_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (page, TYPE_TAB_PAGE_CONTAINER) ? ((TabPageContainer*) page) : NULL);
#line 972 "../src/DynamicNotebook.vala"
	cont = _tmp0_;
#line 973 "../src/DynamicNotebook.vala"
	_tmp1_ = cont;
#line 973 "../src/DynamicNotebook.vala"
	if (_tmp1_ == NULL) {
#line 973 "../src/DynamicNotebook.vala"
		_g_object_unref0 (cont);
#line 973 "../src/DynamicNotebook.vala"
		return;
#line 4562 "DynamicNotebook.c"
	}
#line 974 "../src/DynamicNotebook.vala"
	_tmp2_ = cont;
#line 974 "../src/DynamicNotebook.vala"
	_tmp3_ = tab_page_container_get_tab (_tmp2_);
#line 974 "../src/DynamicNotebook.vala"
	_tmp4_ = _tmp3_;
#line 974 "../src/DynamicNotebook.vala"
	_tmp5_ = _g_object_ref0 (_tmp4_);
#line 974 "../src/DynamicNotebook.vala"
	t = _tmp5_;
#line 976 "../src/DynamicNotebook.vala"
	_tmp6_ = t;
#line 976 "../src/DynamicNotebook.vala"
	dynamic_notebook_remove_callbacks (self, _tmp6_);
#line 977 "../src/DynamicNotebook.vala"
	_tmp7_ = t;
#line 977 "../src/DynamicNotebook.vala"
	g_signal_emit (self, dynamic_notebook_signals[DYNAMIC_NOTEBOOK_TAB_REMOVED_SIGNAL], 0, _tmp7_);
#line 978 "../src/DynamicNotebook.vala"
	dynamic_notebook_update_tabs_visibility (self);
#line 971 "../src/DynamicNotebook.vala"
	_g_object_unref0 (t);
#line 971 "../src/DynamicNotebook.vala"
	_g_object_unref0 (cont);
#line 4588 "DynamicNotebook.c"
}


static void
dynamic_notebook_on_page_reordered (DynamicNotebook* self,
                                    GtkWidget* page,
                                    guint pagenum)
{
	Tab* _tmp0_;
	Tab* _tmp1_;
#line 981 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 981 "../src/DynamicNotebook.vala"
	g_return_if_fail (page != NULL);
#line 982 "../src/DynamicNotebook.vala"
	_tmp0_ = tab_page_container_get_tab (G_TYPE_CHECK_INSTANCE_TYPE (page, TYPE_TAB_PAGE_CONTAINER) ? ((TabPageContainer*) page) : NULL);
#line 982 "../src/DynamicNotebook.vala"
	_tmp1_ = _tmp0_;
#line 982 "../src/DynamicNotebook.vala"
	g_signal_emit (self, dynamic_notebook_signals[DYNAMIC_NOTEBOOK_TAB_REORDERED_SIGNAL], 0, _tmp1_, (gint) pagenum);
#line 983 "../src/DynamicNotebook.vala"
	dynamic_notebook_recalc_order (self);
#line 4611 "DynamicNotebook.c"
}


static GtkNotebook*
dynamic_notebook_on_create_window (DynamicNotebook* self,
                                   GtkWidget* page,
                                   gint x,
                                   gint y)
{
	GtkNotebook* result = NULL;
	Tab* tab = NULL;
	GtkNotebook* _tmp0_;
	GtkWidget* _tmp1_;
	Tab* _tmp2_;
#line 986 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 986 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (page != NULL, NULL);
#line 987 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->notebook;
#line 987 "../src/DynamicNotebook.vala"
	_tmp1_ = gtk_notebook_get_tab_label (_tmp0_, page);
#line 987 "../src/DynamicNotebook.vala"
	_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp1_, TYPE_TAB) ? ((Tab*) _tmp1_) : NULL);
#line 987 "../src/DynamicNotebook.vala"
	tab = _tmp2_;
#line 988 "../src/DynamicNotebook.vala"
	g_signal_emit (self, dynamic_notebook_signals[DYNAMIC_NOTEBOOK_TAB_MOVED_SIGNAL], 0, tab, x, y);
#line 989 "../src/DynamicNotebook.vala"
	dynamic_notebook_recalc_order (self);
#line 990 "../src/DynamicNotebook.vala"
	result = G_TYPE_CHECK_INSTANCE_CAST (NULL, gtk_notebook_get_type (), GtkNotebook);
#line 990 "../src/DynamicNotebook.vala"
	_g_object_unref0 (tab);
#line 990 "../src/DynamicNotebook.vala"
	return result;
#line 4648 "DynamicNotebook.c"
}


static void
dynamic_notebook_recalc_order (DynamicNotebook* self)
{
	gboolean _tmp0_ = FALSE;
	gint _tmp1_;
	gint _tmp2_;
	gint pinned_tabs = 0;
#line 993 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 994 "../src/DynamicNotebook.vala"
	_tmp1_ = dynamic_notebook_get_n_tabs (self);
#line 994 "../src/DynamicNotebook.vala"
	_tmp2_ = _tmp1_;
#line 994 "../src/DynamicNotebook.vala"
	if (_tmp2_ == 0) {
#line 994 "../src/DynamicNotebook.vala"
		_tmp0_ = TRUE;
#line 4669 "DynamicNotebook.c"
	} else {
		gboolean _tmp3_;
		gboolean _tmp4_;
#line 994 "../src/DynamicNotebook.vala"
		_tmp3_ = dynamic_notebook_get_force_left (self);
#line 994 "../src/DynamicNotebook.vala"
		_tmp4_ = _tmp3_;
#line 994 "../src/DynamicNotebook.vala"
		_tmp0_ = !_tmp4_;
#line 4679 "DynamicNotebook.c"
	}
#line 994 "../src/DynamicNotebook.vala"
	if (_tmp0_) {
#line 995 "../src/DynamicNotebook.vala"
		return;
#line 4685 "DynamicNotebook.c"
	}
#line 997 "../src/DynamicNotebook.vala"
	pinned_tabs = 0;
#line 4689 "DynamicNotebook.c"
	{
		gint i = 0;
#line 998 "../src/DynamicNotebook.vala"
		i = 0;
#line 4694 "DynamicNotebook.c"
		{
			gboolean _tmp5_ = FALSE;
#line 998 "../src/DynamicNotebook.vala"
			_tmp5_ = TRUE;
#line 998 "../src/DynamicNotebook.vala"
			while (TRUE) {
#line 4701 "DynamicNotebook.c"
				gint _tmp7_;
				GtkNotebook* _tmp8_;
				Tab* tab = NULL;
				GtkNotebook* _tmp9_;
				GtkNotebook* _tmp10_;
				gint _tmp11_;
				GtkWidget* _tmp12_;
				GtkWidget* _tmp13_;
				Tab* _tmp14_;
				gboolean _tmp15_ = FALSE;
				Tab* _tmp16_;
#line 998 "../src/DynamicNotebook.vala"
				if (!_tmp5_) {
#line 4715 "DynamicNotebook.c"
					gint _tmp6_;
#line 998 "../src/DynamicNotebook.vala"
					_tmp6_ = i;
#line 998 "../src/DynamicNotebook.vala"
					i = _tmp6_ + 1;
#line 4721 "DynamicNotebook.c"
				}
#line 998 "../src/DynamicNotebook.vala"
				_tmp5_ = FALSE;
#line 998 "../src/DynamicNotebook.vala"
				_tmp7_ = i;
#line 998 "../src/DynamicNotebook.vala"
				_tmp8_ = self->priv->notebook;
#line 998 "../src/DynamicNotebook.vala"
				if (!(_tmp7_ < gtk_notebook_get_n_pages (_tmp8_))) {
#line 998 "../src/DynamicNotebook.vala"
					break;
#line 4733 "DynamicNotebook.c"
				}
#line 999 "../src/DynamicNotebook.vala"
				_tmp9_ = self->priv->notebook;
#line 999 "../src/DynamicNotebook.vala"
				_tmp10_ = self->priv->notebook;
#line 999 "../src/DynamicNotebook.vala"
				_tmp11_ = i;
#line 999 "../src/DynamicNotebook.vala"
				_tmp12_ = gtk_notebook_get_nth_page (_tmp10_, _tmp11_);
#line 999 "../src/DynamicNotebook.vala"
				_tmp13_ = gtk_notebook_get_tab_label (_tmp9_, _tmp12_);
#line 999 "../src/DynamicNotebook.vala"
				_tmp14_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp13_, TYPE_TAB) ? ((Tab*) _tmp13_) : NULL);
#line 999 "../src/DynamicNotebook.vala"
				tab = _tmp14_;
#line 1000 "../src/DynamicNotebook.vala"
				_tmp16_ = tab;
#line 1000 "../src/DynamicNotebook.vala"
				if (_tmp16_ != NULL) {
#line 4753 "DynamicNotebook.c"
					Tab* _tmp17_;
					gboolean _tmp18_;
					gboolean _tmp19_;
#line 1000 "../src/DynamicNotebook.vala"
					_tmp17_ = tab;
#line 1000 "../src/DynamicNotebook.vala"
					_tmp18_ = tab_get_pinned (_tmp17_);
#line 1000 "../src/DynamicNotebook.vala"
					_tmp19_ = _tmp18_;
#line 1000 "../src/DynamicNotebook.vala"
					_tmp15_ = _tmp19_;
#line 4765 "DynamicNotebook.c"
				} else {
#line 1000 "../src/DynamicNotebook.vala"
					_tmp15_ = FALSE;
#line 4769 "DynamicNotebook.c"
				}
#line 1000 "../src/DynamicNotebook.vala"
				if (_tmp15_) {
#line 4773 "DynamicNotebook.c"
					gint _tmp20_;
#line 1001 "../src/DynamicNotebook.vala"
					_tmp20_ = pinned_tabs;
#line 1001 "../src/DynamicNotebook.vala"
					pinned_tabs = _tmp20_ + 1;
#line 4779 "DynamicNotebook.c"
				}
#line 998 "../src/DynamicNotebook.vala"
				_g_object_unref0 (tab);
#line 4783 "DynamicNotebook.c"
			}
		}
	}
	{
		gint p = 0;
#line 1005 "../src/DynamicNotebook.vala"
		p = 0;
#line 4791 "DynamicNotebook.c"
		{
			gboolean _tmp21_ = FALSE;
#line 1005 "../src/DynamicNotebook.vala"
			_tmp21_ = TRUE;
#line 1005 "../src/DynamicNotebook.vala"
			while (TRUE) {
#line 4798 "DynamicNotebook.c"
				gint _tmp23_;
				gint _tmp24_;
				gint sel = 0;
				gint _tmp25_;
				gint _tmp43_;
				gint _tmp44_;
#line 1005 "../src/DynamicNotebook.vala"
				if (!_tmp21_) {
#line 4807 "DynamicNotebook.c"
					gint _tmp22_;
#line 1005 "../src/DynamicNotebook.vala"
					_tmp22_ = p;
#line 1005 "../src/DynamicNotebook.vala"
					p = _tmp22_ + 1;
#line 4813 "DynamicNotebook.c"
				}
#line 1005 "../src/DynamicNotebook.vala"
				_tmp21_ = FALSE;
#line 1005 "../src/DynamicNotebook.vala"
				_tmp23_ = p;
#line 1005 "../src/DynamicNotebook.vala"
				_tmp24_ = pinned_tabs;
#line 1005 "../src/DynamicNotebook.vala"
				if (!(_tmp23_ < _tmp24_)) {
#line 1005 "../src/DynamicNotebook.vala"
					break;
#line 4825 "DynamicNotebook.c"
				}
#line 1006 "../src/DynamicNotebook.vala"
				_tmp25_ = p;
#line 1006 "../src/DynamicNotebook.vala"
				sel = _tmp25_;
#line 4831 "DynamicNotebook.c"
				{
					gint i = 0;
					gint _tmp26_;
#line 1007 "../src/DynamicNotebook.vala"
					_tmp26_ = p;
#line 1007 "../src/DynamicNotebook.vala"
					i = _tmp26_;
#line 4839 "DynamicNotebook.c"
					{
						gboolean _tmp27_ = FALSE;
#line 1007 "../src/DynamicNotebook.vala"
						_tmp27_ = TRUE;
#line 1007 "../src/DynamicNotebook.vala"
						while (TRUE) {
#line 4846 "DynamicNotebook.c"
							gint _tmp29_;
							GtkNotebook* _tmp30_;
							Tab* tab = NULL;
							GtkNotebook* _tmp31_;
							GtkNotebook* _tmp32_;
							gint _tmp33_;
							GtkWidget* _tmp34_;
							GtkWidget* _tmp35_;
							Tab* _tmp36_;
							gboolean _tmp37_ = FALSE;
							Tab* _tmp38_;
#line 1007 "../src/DynamicNotebook.vala"
							if (!_tmp27_) {
#line 4860 "DynamicNotebook.c"
								gint _tmp28_;
#line 1007 "../src/DynamicNotebook.vala"
								_tmp28_ = i;
#line 1007 "../src/DynamicNotebook.vala"
								i = _tmp28_ + 1;
#line 4866 "DynamicNotebook.c"
							}
#line 1007 "../src/DynamicNotebook.vala"
							_tmp27_ = FALSE;
#line 1007 "../src/DynamicNotebook.vala"
							_tmp29_ = i;
#line 1007 "../src/DynamicNotebook.vala"
							_tmp30_ = self->priv->notebook;
#line 1007 "../src/DynamicNotebook.vala"
							if (!(_tmp29_ < gtk_notebook_get_n_pages (_tmp30_))) {
#line 1007 "../src/DynamicNotebook.vala"
								break;
#line 4878 "DynamicNotebook.c"
							}
#line 1008 "../src/DynamicNotebook.vala"
							_tmp31_ = self->priv->notebook;
#line 1008 "../src/DynamicNotebook.vala"
							_tmp32_ = self->priv->notebook;
#line 1008 "../src/DynamicNotebook.vala"
							_tmp33_ = i;
#line 1008 "../src/DynamicNotebook.vala"
							_tmp34_ = gtk_notebook_get_nth_page (_tmp32_, _tmp33_);
#line 1008 "../src/DynamicNotebook.vala"
							_tmp35_ = gtk_notebook_get_tab_label (_tmp31_, _tmp34_);
#line 1008 "../src/DynamicNotebook.vala"
							_tmp36_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp35_, TYPE_TAB) ? ((Tab*) _tmp35_) : NULL);
#line 1008 "../src/DynamicNotebook.vala"
							tab = _tmp36_;
#line 1009 "../src/DynamicNotebook.vala"
							_tmp38_ = tab;
#line 1009 "../src/DynamicNotebook.vala"
							if (_tmp38_ != NULL) {
#line 4898 "DynamicNotebook.c"
								Tab* _tmp39_;
								gboolean _tmp40_;
								gboolean _tmp41_;
#line 1009 "../src/DynamicNotebook.vala"
								_tmp39_ = tab;
#line 1009 "../src/DynamicNotebook.vala"
								_tmp40_ = tab_get_pinned (_tmp39_);
#line 1009 "../src/DynamicNotebook.vala"
								_tmp41_ = _tmp40_;
#line 1009 "../src/DynamicNotebook.vala"
								_tmp37_ = _tmp41_;
#line 4910 "DynamicNotebook.c"
							} else {
#line 1009 "../src/DynamicNotebook.vala"
								_tmp37_ = FALSE;
#line 4914 "DynamicNotebook.c"
							}
#line 1009 "../src/DynamicNotebook.vala"
							if (_tmp37_) {
#line 4918 "DynamicNotebook.c"
								gint _tmp42_;
#line 1010 "../src/DynamicNotebook.vala"
								_tmp42_ = i;
#line 1010 "../src/DynamicNotebook.vala"
								sel = _tmp42_;
#line 1011 "../src/DynamicNotebook.vala"
								_g_object_unref0 (tab);
#line 1011 "../src/DynamicNotebook.vala"
								break;
#line 4928 "DynamicNotebook.c"
							}
#line 1007 "../src/DynamicNotebook.vala"
							_g_object_unref0 (tab);
#line 4932 "DynamicNotebook.c"
						}
					}
				}
#line 1015 "../src/DynamicNotebook.vala"
				_tmp43_ = sel;
#line 1015 "../src/DynamicNotebook.vala"
				_tmp44_ = p;
#line 1015 "../src/DynamicNotebook.vala"
				if (_tmp43_ != _tmp44_) {
#line 4942 "DynamicNotebook.c"
					GtkNotebook* _tmp45_;
					GtkNotebook* _tmp46_;
					gint _tmp47_;
					GtkWidget* _tmp48_;
					gint _tmp49_;
#line 1016 "../src/DynamicNotebook.vala"
					_tmp45_ = self->priv->notebook;
#line 1016 "../src/DynamicNotebook.vala"
					_tmp46_ = self->priv->notebook;
#line 1016 "../src/DynamicNotebook.vala"
					_tmp47_ = sel;
#line 1016 "../src/DynamicNotebook.vala"
					_tmp48_ = gtk_notebook_get_nth_page (_tmp46_, _tmp47_);
#line 1016 "../src/DynamicNotebook.vala"
					_tmp49_ = p;
#line 1016 "../src/DynamicNotebook.vala"
					gtk_notebook_reorder_child (_tmp45_, _tmp48_, _tmp49_);
#line 4960 "DynamicNotebook.c"
				}
			}
		}
	}
}


static void
dynamic_notebook_recalc_size (DynamicNotebook* self)
{
	gint _tmp0_;
	gint _tmp1_;
	gint pinned_tabs = 0;
	gint unpinned_tabs = 0;
	gint _tmp15_;
	gint offset = 0;
	gint _tmp16_;
	gint _tmp17_;
	gint _tmp18_;
	gint _tmp19_;
	gint _tmp20_;
#line 1021 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 1022 "../src/DynamicNotebook.vala"
	_tmp0_ = dynamic_notebook_get_n_tabs (self);
#line 1022 "../src/DynamicNotebook.vala"
	_tmp1_ = _tmp0_;
#line 1022 "../src/DynamicNotebook.vala"
	if (_tmp1_ == 0) {
#line 1023 "../src/DynamicNotebook.vala"
		return;
#line 4992 "DynamicNotebook.c"
	}
#line 1025 "../src/DynamicNotebook.vala"
	pinned_tabs = 0;
#line 1026 "../src/DynamicNotebook.vala"
	unpinned_tabs = 0;
#line 4998 "DynamicNotebook.c"
	{
		gint i = 0;
#line 1027 "../src/DynamicNotebook.vala"
		i = 0;
#line 5003 "DynamicNotebook.c"
		{
			gboolean _tmp2_ = FALSE;
#line 1027 "../src/DynamicNotebook.vala"
			_tmp2_ = TRUE;
#line 1027 "../src/DynamicNotebook.vala"
			while (TRUE) {
#line 5010 "DynamicNotebook.c"
				gint _tmp4_;
				GtkNotebook* _tmp5_;
				GtkNotebook* _tmp6_;
				GtkNotebook* _tmp7_;
				gint _tmp8_;
				GtkWidget* _tmp9_;
				GtkWidget* _tmp10_;
				gboolean _tmp11_;
				gboolean _tmp12_;
#line 1027 "../src/DynamicNotebook.vala"
				if (!_tmp2_) {
#line 5022 "DynamicNotebook.c"
					gint _tmp3_;
#line 1027 "../src/DynamicNotebook.vala"
					_tmp3_ = i;
#line 1027 "../src/DynamicNotebook.vala"
					i = _tmp3_ + 1;
#line 5028 "DynamicNotebook.c"
				}
#line 1027 "../src/DynamicNotebook.vala"
				_tmp2_ = FALSE;
#line 1027 "../src/DynamicNotebook.vala"
				_tmp4_ = i;
#line 1027 "../src/DynamicNotebook.vala"
				_tmp5_ = self->priv->notebook;
#line 1027 "../src/DynamicNotebook.vala"
				if (!(_tmp4_ < gtk_notebook_get_n_pages (_tmp5_))) {
#line 1027 "../src/DynamicNotebook.vala"
					break;
#line 5040 "DynamicNotebook.c"
				}
#line 1028 "../src/DynamicNotebook.vala"
				_tmp6_ = self->priv->notebook;
#line 1028 "../src/DynamicNotebook.vala"
				_tmp7_ = self->priv->notebook;
#line 1028 "../src/DynamicNotebook.vala"
				_tmp8_ = i;
#line 1028 "../src/DynamicNotebook.vala"
				_tmp9_ = gtk_notebook_get_nth_page (_tmp7_, _tmp8_);
#line 1028 "../src/DynamicNotebook.vala"
				_tmp10_ = gtk_notebook_get_tab_label (_tmp6_, _tmp9_);
#line 1028 "../src/DynamicNotebook.vala"
				_tmp11_ = tab_get_pinned (G_TYPE_CHECK_INSTANCE_TYPE (_tmp10_, TYPE_TAB) ? ((Tab*) _tmp10_) : NULL);
#line 1028 "../src/DynamicNotebook.vala"
				_tmp12_ = _tmp11_;
#line 1028 "../src/DynamicNotebook.vala"
				if (_tmp12_) {
#line 5058 "DynamicNotebook.c"
					gint _tmp13_;
#line 1029 "../src/DynamicNotebook.vala"
					_tmp13_ = pinned_tabs;
#line 1029 "../src/DynamicNotebook.vala"
					pinned_tabs = _tmp13_ + 1;
#line 5064 "DynamicNotebook.c"
				} else {
					gint _tmp14_;
#line 1031 "../src/DynamicNotebook.vala"
					_tmp14_ = unpinned_tabs;
#line 1031 "../src/DynamicNotebook.vala"
					unpinned_tabs = _tmp14_ + 1;
#line 5071 "DynamicNotebook.c"
				}
			}
		}
	}
#line 1035 "../src/DynamicNotebook.vala"
	_tmp15_ = unpinned_tabs;
#line 1035 "../src/DynamicNotebook.vala"
	if (_tmp15_ == 0) {
#line 1036 "../src/DynamicNotebook.vala"
		unpinned_tabs = 1;
#line 5082 "DynamicNotebook.c"
	}
#line 1039 "../src/DynamicNotebook.vala"
	offset = 130;
#line 1040 "../src/DynamicNotebook.vala"
	_tmp16_ = offset;
#line 1040 "../src/DynamicNotebook.vala"
	_tmp17_ = pinned_tabs;
#line 1040 "../src/DynamicNotebook.vala"
	_tmp18_ = unpinned_tabs;
#line 1040 "../src/DynamicNotebook.vala"
	self->priv->tab_width = ((gtk_widget_get_allocated_width ((GtkWidget*) self) - _tmp16_) - (_tmp17_ * DYNAMIC_NOTEBOOK_TAB_WIDTH_PINNED)) / _tmp18_;
#line 1041 "../src/DynamicNotebook.vala"
	_tmp19_ = self->priv->tab_width;
#line 1041 "../src/DynamicNotebook.vala"
	if (_tmp19_ > DYNAMIC_NOTEBOOK_MAX_TAB_WIDTH) {
#line 1042 "../src/DynamicNotebook.vala"
		self->priv->tab_width = DYNAMIC_NOTEBOOK_MAX_TAB_WIDTH;
#line 5100 "DynamicNotebook.c"
	}
#line 1044 "../src/DynamicNotebook.vala"
	_tmp20_ = self->priv->tab_width;
#line 1044 "../src/DynamicNotebook.vala"
	if (_tmp20_ < 0) {
#line 1045 "../src/DynamicNotebook.vala"
		self->priv->tab_width = 0;
#line 5108 "DynamicNotebook.c"
	}
	{
		gint i = 0;
#line 1047 "../src/DynamicNotebook.vala"
		i = 0;
#line 5114 "DynamicNotebook.c"
		{
			gboolean _tmp21_ = FALSE;
#line 1047 "../src/DynamicNotebook.vala"
			_tmp21_ = TRUE;
#line 1047 "../src/DynamicNotebook.vala"
			while (TRUE) {
#line 5121 "DynamicNotebook.c"
				gint _tmp23_;
				GtkNotebook* _tmp24_;
				GtkNotebook* _tmp25_;
				GtkNotebook* _tmp26_;
				gint _tmp27_;
				GtkWidget* _tmp28_;
				GtkWidget* _tmp29_;
				gint _tmp30_;
				GtkNotebook* _tmp31_;
				GtkNotebook* _tmp32_;
				gint _tmp33_;
				GtkWidget* _tmp34_;
				GtkWidget* _tmp35_;
				gboolean _tmp36_;
				gboolean _tmp37_;
#line 1047 "../src/DynamicNotebook.vala"
				if (!_tmp21_) {
#line 5139 "DynamicNotebook.c"
					gint _tmp22_;
#line 1047 "../src/DynamicNotebook.vala"
					_tmp22_ = i;
#line 1047 "../src/DynamicNotebook.vala"
					i = _tmp22_ + 1;
#line 5145 "DynamicNotebook.c"
				}
#line 1047 "../src/DynamicNotebook.vala"
				_tmp21_ = FALSE;
#line 1047 "../src/DynamicNotebook.vala"
				_tmp23_ = i;
#line 1047 "../src/DynamicNotebook.vala"
				_tmp24_ = self->priv->notebook;
#line 1047 "../src/DynamicNotebook.vala"
				if (!(_tmp23_ < gtk_notebook_get_n_pages (_tmp24_))) {
#line 1047 "../src/DynamicNotebook.vala"
					break;
#line 5157 "DynamicNotebook.c"
				}
#line 1048 "../src/DynamicNotebook.vala"
				_tmp25_ = self->priv->notebook;
#line 1048 "../src/DynamicNotebook.vala"
				_tmp26_ = self->priv->notebook;
#line 1048 "../src/DynamicNotebook.vala"
				_tmp27_ = i;
#line 1048 "../src/DynamicNotebook.vala"
				_tmp28_ = gtk_notebook_get_nth_page (_tmp26_, _tmp27_);
#line 1048 "../src/DynamicNotebook.vala"
				_tmp29_ = gtk_notebook_get_tab_label (_tmp25_, _tmp28_);
#line 1048 "../src/DynamicNotebook.vala"
				_tmp30_ = self->priv->tab_width;
#line 1048 "../src/DynamicNotebook.vala"
				g_object_set (_tmp29_, "width-request", _tmp30_, NULL);
#line 1050 "../src/DynamicNotebook.vala"
				_tmp31_ = self->priv->notebook;
#line 1050 "../src/DynamicNotebook.vala"
				_tmp32_ = self->priv->notebook;
#line 1050 "../src/DynamicNotebook.vala"
				_tmp33_ = i;
#line 1050 "../src/DynamicNotebook.vala"
				_tmp34_ = gtk_notebook_get_nth_page (_tmp32_, _tmp33_);
#line 1050 "../src/DynamicNotebook.vala"
				_tmp35_ = gtk_notebook_get_tab_label (_tmp31_, _tmp34_);
#line 1050 "../src/DynamicNotebook.vala"
				_tmp36_ = tab_get_pinned (G_TYPE_CHECK_INSTANCE_TYPE (_tmp35_, TYPE_TAB) ? ((Tab*) _tmp35_) : NULL);
#line 1050 "../src/DynamicNotebook.vala"
				_tmp37_ = _tmp36_;
#line 1050 "../src/DynamicNotebook.vala"
				if (_tmp37_) {
#line 5189 "DynamicNotebook.c"
					GtkNotebook* _tmp38_;
					GtkNotebook* _tmp39_;
					gint _tmp40_;
					GtkWidget* _tmp41_;
					GtkWidget* _tmp42_;
#line 1051 "../src/DynamicNotebook.vala"
					_tmp38_ = self->priv->notebook;
#line 1051 "../src/DynamicNotebook.vala"
					_tmp39_ = self->priv->notebook;
#line 1051 "../src/DynamicNotebook.vala"
					_tmp40_ = i;
#line 1051 "../src/DynamicNotebook.vala"
					_tmp41_ = gtk_notebook_get_nth_page (_tmp39_, _tmp40_);
#line 1051 "../src/DynamicNotebook.vala"
					_tmp42_ = gtk_notebook_get_tab_label (_tmp38_, _tmp41_);
#line 1051 "../src/DynamicNotebook.vala"
					g_object_set (_tmp42_, "width-request", DYNAMIC_NOTEBOOK_TAB_WIDTH_PINNED, NULL);
#line 5207 "DynamicNotebook.c"
				}
			}
		}
	}
}


static void
dynamic_notebook_restore_last_tab (DynamicNotebook* self)
{
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_;
	gboolean _tmp2_;
	ClosedTabsEntry restored = {0};
	ClosedTabs* _tmp6_;
	ClosedTabsEntry _tmp7_ = {0};
	GtkButton* _tmp8_;
	ClosedTabs* _tmp9_;
	gboolean _tmp10_;
	gboolean _tmp11_;
	GtkMenuItem* _tmp12_;
	ClosedTabs* _tmp13_;
	gboolean _tmp14_;
	gboolean _tmp15_;
	ClosedTabsEntry _tmp16_;
	const gchar* _tmp17_;
	ClosedTabsEntry _tmp18_;
	const gchar* _tmp19_;
	ClosedTabsEntry _tmp20_;
	GIcon* _tmp21_;
#line 1058 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 1059 "../src/DynamicNotebook.vala"
	_tmp1_ = dynamic_notebook_get_allow_restoring (self);
#line 1059 "../src/DynamicNotebook.vala"
	_tmp2_ = _tmp1_;
#line 1059 "../src/DynamicNotebook.vala"
	if (!_tmp2_) {
#line 1059 "../src/DynamicNotebook.vala"
		_tmp0_ = TRUE;
#line 5248 "DynamicNotebook.c"
	} else {
		ClosedTabs* _tmp3_;
		gboolean _tmp4_;
		gboolean _tmp5_;
#line 1059 "../src/DynamicNotebook.vala"
		_tmp3_ = self->priv->closed_tabs;
#line 1059 "../src/DynamicNotebook.vala"
		_tmp4_ = closed_tabs_get_empty (_tmp3_);
#line 1059 "../src/DynamicNotebook.vala"
		_tmp5_ = _tmp4_;
#line 1059 "../src/DynamicNotebook.vala"
		_tmp0_ = _tmp5_;
#line 5261 "DynamicNotebook.c"
	}
#line 1059 "../src/DynamicNotebook.vala"
	if (_tmp0_) {
#line 1060 "../src/DynamicNotebook.vala"
		return;
#line 5267 "DynamicNotebook.c"
	}
#line 1062 "../src/DynamicNotebook.vala"
	_tmp6_ = self->priv->closed_tabs;
#line 1062 "../src/DynamicNotebook.vala"
	closed_tabs_pop (_tmp6_, &_tmp7_);
#line 1062 "../src/DynamicNotebook.vala"
	restored = _tmp7_;
#line 1063 "../src/DynamicNotebook.vala"
	_tmp8_ = self->priv->restore_button;
#line 1063 "../src/DynamicNotebook.vala"
	_tmp9_ = self->priv->closed_tabs;
#line 1063 "../src/DynamicNotebook.vala"
	_tmp10_ = closed_tabs_get_empty (_tmp9_);
#line 1063 "../src/DynamicNotebook.vala"
	_tmp11_ = _tmp10_;
#line 1063 "../src/DynamicNotebook.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp8_, !_tmp11_);
#line 1064 "../src/DynamicNotebook.vala"
	_tmp12_ = self->priv->restore_tab_m;
#line 1064 "../src/DynamicNotebook.vala"
	_tmp13_ = self->priv->closed_tabs;
#line 1064 "../src/DynamicNotebook.vala"
	_tmp14_ = closed_tabs_get_empty (_tmp13_);
#line 1064 "../src/DynamicNotebook.vala"
	_tmp15_ = _tmp14_;
#line 1064 "../src/DynamicNotebook.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp12_, !_tmp15_);
#line 1065 "../src/DynamicNotebook.vala"
	_tmp16_ = restored;
#line 1065 "../src/DynamicNotebook.vala"
	_tmp17_ = _tmp16_.label;
#line 1065 "../src/DynamicNotebook.vala"
	_tmp18_ = restored;
#line 1065 "../src/DynamicNotebook.vala"
	_tmp19_ = _tmp18_.restore_data;
#line 1065 "../src/DynamicNotebook.vala"
	_tmp20_ = restored;
#line 1065 "../src/DynamicNotebook.vala"
	_tmp21_ = _tmp20_.icon;
#line 1065 "../src/DynamicNotebook.vala"
	g_signal_emit (self, dynamic_notebook_signals[DYNAMIC_NOTEBOOK_TAB_RESTORED_SIGNAL], 0, _tmp17_, _tmp19_, _tmp21_);
#line 1058 "../src/DynamicNotebook.vala"
	closed_tabs_entry_destroy (&restored);
#line 5311 "DynamicNotebook.c"
}


static void
dynamic_notebook_switch_pin_tab (DynamicNotebook* self,
                                 Tab* tab)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 1068 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 1068 "../src/DynamicNotebook.vala"
	g_return_if_fail (tab != NULL);
#line 1069 "../src/DynamicNotebook.vala"
	_tmp0_ = dynamic_notebook_get_allow_pinning (self);
#line 1069 "../src/DynamicNotebook.vala"
	_tmp1_ = _tmp0_;
#line 1069 "../src/DynamicNotebook.vala"
	if (!_tmp1_) {
#line 1070 "../src/DynamicNotebook.vala"
		return;
#line 5333 "DynamicNotebook.c"
	}
#line 1073 "../src/DynamicNotebook.vala"
	dynamic_notebook_recalc_order (self);
#line 1074 "../src/DynamicNotebook.vala"
	dynamic_notebook_recalc_size (self);
#line 5339 "DynamicNotebook.c"
}


void
dynamic_notebook_remove_tab (DynamicNotebook* self,
                             Tab* tab)
{
	gint pos = 0;
	gint _tmp0_;
#line 1077 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 1077 "../src/DynamicNotebook.vala"
	g_return_if_fail (tab != NULL);
#line 1078 "../src/DynamicNotebook.vala"
	pos = dynamic_notebook_get_tab_position (self, tab);
#line 1080 "../src/DynamicNotebook.vala"
	_tmp0_ = pos;
#line 1080 "../src/DynamicNotebook.vala"
	if (_tmp0_ != -1) {
#line 5359 "DynamicNotebook.c"
		GtkNotebook* _tmp1_;
		gint _tmp2_;
#line 1081 "../src/DynamicNotebook.vala"
		_tmp1_ = self->priv->notebook;
#line 1081 "../src/DynamicNotebook.vala"
		_tmp2_ = pos;
#line 1081 "../src/DynamicNotebook.vala"
		gtk_notebook_remove_page (_tmp1_, _tmp2_);
#line 5368 "DynamicNotebook.c"
	}
}


void
dynamic_notebook_next_page (DynamicNotebook* self)
{
	gint _tmp0_ = 0;
	GtkNotebook* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	GtkNotebook* _tmp4_;
	GtkNotebook* _tmp9_;
#line 1084 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 1085 "../src/DynamicNotebook.vala"
	_tmp1_ = self->priv->notebook;
#line 1085 "../src/DynamicNotebook.vala"
	g_object_get (_tmp1_, "page", &_tmp2_, NULL);
#line 1085 "../src/DynamicNotebook.vala"
	_tmp3_ = _tmp2_;
#line 1085 "../src/DynamicNotebook.vala"
	_tmp4_ = self->priv->notebook;
#line 1085 "../src/DynamicNotebook.vala"
	if ((_tmp3_ + 1) >= gtk_notebook_get_n_pages (_tmp4_)) {
#line 5394 "DynamicNotebook.c"
		GtkNotebook* _tmp5_;
#line 1085 "../src/DynamicNotebook.vala"
		_tmp5_ = self->priv->notebook;
#line 1085 "../src/DynamicNotebook.vala"
		g_object_set (_tmp5_, "page", 0, NULL);
#line 1085 "../src/DynamicNotebook.vala"
		_tmp0_ = 0;
#line 5402 "DynamicNotebook.c"
	} else {
		GtkNotebook* _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
#line 1085 "../src/DynamicNotebook.vala"
		_tmp6_ = self->priv->notebook;
#line 1085 "../src/DynamicNotebook.vala"
		g_object_get (_tmp6_, "page", &_tmp7_, NULL);
#line 1085 "../src/DynamicNotebook.vala"
		_tmp8_ = _tmp7_;
#line 1085 "../src/DynamicNotebook.vala"
		_tmp0_ = _tmp8_ + 1;
#line 5415 "DynamicNotebook.c"
	}
#line 1085 "../src/DynamicNotebook.vala"
	_tmp9_ = self->priv->notebook;
#line 1085 "../src/DynamicNotebook.vala"
	g_object_set (_tmp9_, "page", _tmp0_, NULL);
#line 5421 "DynamicNotebook.c"
}


void
dynamic_notebook_previous_page (DynamicNotebook* self)
{
	gint _tmp0_ = 0;
	GtkNotebook* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	GtkNotebook* _tmp9_;
#line 1088 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 1089 "../src/DynamicNotebook.vala"
	_tmp1_ = self->priv->notebook;
#line 1089 "../src/DynamicNotebook.vala"
	g_object_get (_tmp1_, "page", &_tmp2_, NULL);
#line 1089 "../src/DynamicNotebook.vala"
	_tmp3_ = _tmp2_;
#line 1089 "../src/DynamicNotebook.vala"
	if ((_tmp3_ - 1) < 0) {
#line 5443 "DynamicNotebook.c"
		GtkNotebook* _tmp4_;
		GtkNotebook* _tmp5_;
#line 1090 "../src/DynamicNotebook.vala"
		_tmp4_ = self->priv->notebook;
#line 1090 "../src/DynamicNotebook.vala"
		_tmp5_ = self->priv->notebook;
#line 1090 "../src/DynamicNotebook.vala"
		g_object_set (_tmp4_, "page", gtk_notebook_get_n_pages (_tmp5_) - 1, NULL);
#line 1090 "../src/DynamicNotebook.vala"
		_tmp0_ = gtk_notebook_get_n_pages (_tmp5_) - 1;
#line 5454 "DynamicNotebook.c"
	} else {
		GtkNotebook* _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
#line 1090 "../src/DynamicNotebook.vala"
		_tmp6_ = self->priv->notebook;
#line 1090 "../src/DynamicNotebook.vala"
		g_object_get (_tmp6_, "page", &_tmp7_, NULL);
#line 1090 "../src/DynamicNotebook.vala"
		_tmp8_ = _tmp7_;
#line 1090 "../src/DynamicNotebook.vala"
		_tmp0_ = _tmp8_ - 1;
#line 5467 "DynamicNotebook.c"
	}
#line 1089 "../src/DynamicNotebook.vala"
	_tmp9_ = self->priv->notebook;
#line 1089 "../src/DynamicNotebook.vala"
	g_object_set (_tmp9_, "page", _tmp0_, NULL);
#line 5473 "DynamicNotebook.c"
}


static void
dynamic_notebook_real_show (GtkWidget* base)
{
	DynamicNotebook * self;
	GtkNotebook* _tmp0_;
#line 1093 "../src/DynamicNotebook.vala"
	self = (DynamicNotebook*) base;
#line 1094 "../src/DynamicNotebook.vala"
	GTK_WIDGET_CLASS (dynamic_notebook_parent_class)->show ((GtkWidget*) G_TYPE_CHECK_INSTANCE_CAST (self, gtk_event_box_get_type (), GtkEventBox));
#line 1095 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->notebook;
#line 1095 "../src/DynamicNotebook.vala"
	gtk_widget_show ((GtkWidget*) _tmp0_);
#line 5490 "DynamicNotebook.c"
}


GList*
dynamic_notebook_get_children (DynamicNotebook* self)
{
	GList* result = NULL;
	GList* list = NULL;
	GtkNotebook* _tmp0_;
	GList* _tmp1_;
#line 1098 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1099 "../src/DynamicNotebook.vala"
	list = NULL;
#line 1101 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->notebook;
#line 1101 "../src/DynamicNotebook.vala"
	_tmp1_ = gtk_container_get_children ((GtkContainer*) _tmp0_);
#line 5509 "DynamicNotebook.c"
	{
		GList* child_collection = NULL;
		GList* child_it = NULL;
#line 1101 "../src/DynamicNotebook.vala"
		child_collection = _tmp1_;
#line 1101 "../src/DynamicNotebook.vala"
		for (child_it = child_collection; child_it != NULL; child_it = child_it->next) {
#line 5517 "DynamicNotebook.c"
			GtkWidget* child = NULL;
#line 1101 "../src/DynamicNotebook.vala"
			child = (GtkWidget*) child_it->data;
#line 5521 "DynamicNotebook.c"
			{
				GtkContainer* cont = NULL;
				GtkWidget* _tmp2_;
				GtkContainer* _tmp3_;
				GtkContainer* _tmp4_;
#line 1102 "../src/DynamicNotebook.vala"
				_tmp2_ = child;
#line 1102 "../src/DynamicNotebook.vala"
				_tmp3_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp2_, gtk_container_get_type ()) ? ((GtkContainer*) _tmp2_) : NULL);
#line 1102 "../src/DynamicNotebook.vala"
				cont = _tmp3_;
#line 1103 "../src/DynamicNotebook.vala"
				_tmp4_ = cont;
#line 1103 "../src/DynamicNotebook.vala"
				if (_tmp4_ != NULL) {
#line 5537 "DynamicNotebook.c"
					GtkContainer* _tmp5_;
					GList* _tmp6_;
					GList* _tmp7_;
					gconstpointer _tmp8_;
					GtkWidget* _tmp9_;
#line 1104 "../src/DynamicNotebook.vala"
					_tmp5_ = cont;
#line 1104 "../src/DynamicNotebook.vala"
					_tmp6_ = gtk_container_get_children (_tmp5_);
#line 1104 "../src/DynamicNotebook.vala"
					_tmp7_ = _tmp6_;
#line 1104 "../src/DynamicNotebook.vala"
					_tmp8_ = g_list_nth_data (_tmp7_, (guint) 0);
#line 1104 "../src/DynamicNotebook.vala"
					_tmp9_ = _g_object_ref0 ((GtkWidget*) _tmp8_);
#line 1104 "../src/DynamicNotebook.vala"
					list = g_list_append (list, _tmp9_);
#line 1104 "../src/DynamicNotebook.vala"
					(_tmp7_ == NULL) ? NULL : (_tmp7_ = (g_list_free (_tmp7_), NULL));
#line 5557 "DynamicNotebook.c"
				}
#line 1101 "../src/DynamicNotebook.vala"
				_g_object_unref0 (cont);
#line 5561 "DynamicNotebook.c"
			}
		}
#line 1101 "../src/DynamicNotebook.vala"
		(child_collection == NULL) ? NULL : (child_collection = (g_list_free (child_collection), NULL));
#line 5566 "DynamicNotebook.c"
	}
#line 1108 "../src/DynamicNotebook.vala"
	result = list;
#line 1108 "../src/DynamicNotebook.vala"
	return result;
#line 5572 "DynamicNotebook.c"
}


gint
dynamic_notebook_get_tab_position (DynamicNotebook* self,
                                   Tab* tab)
{
	gint result = 0;
	GtkNotebook* _tmp0_;
	TabPageContainer* _tmp1_;
#line 1111 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 1111 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (tab != NULL, 0);
#line 1112 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->notebook;
#line 1112 "../src/DynamicNotebook.vala"
	_tmp1_ = tab->page_container;
#line 1112 "../src/DynamicNotebook.vala"
	result = gtk_notebook_page_num (_tmp0_, (GtkWidget*) _tmp1_);
#line 1112 "../src/DynamicNotebook.vala"
	return result;
#line 5595 "DynamicNotebook.c"
}


void
dynamic_notebook_set_tab_position (DynamicNotebook* self,
                                   Tab* tab,
                                   gint position)
{
	GtkNotebook* _tmp0_;
	TabPageContainer* _tmp1_;
#line 1115 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 1115 "../src/DynamicNotebook.vala"
	g_return_if_fail (tab != NULL);
#line 1116 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->notebook;
#line 1116 "../src/DynamicNotebook.vala"
	_tmp1_ = tab->page_container;
#line 1116 "../src/DynamicNotebook.vala"
	gtk_notebook_reorder_child (_tmp0_, (GtkWidget*) _tmp1_, position);
#line 1117 "../src/DynamicNotebook.vala"
	g_signal_emit (self, dynamic_notebook_signals[DYNAMIC_NOTEBOOK_TAB_REORDERED_SIGNAL], 0, tab, position);
#line 1118 "../src/DynamicNotebook.vala"
	dynamic_notebook_recalc_order (self);
#line 5620 "DynamicNotebook.c"
}


Tab*
dynamic_notebook_get_tab_by_index (DynamicNotebook* self,
                                   gint index)
{
	Tab* result = NULL;
	GtkNotebook* _tmp0_;
	GtkNotebook* _tmp1_;
	GtkWidget* _tmp2_;
	GtkWidget* _tmp3_;
	Tab* _tmp4_;
#line 1121 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1122 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->notebook;
#line 1122 "../src/DynamicNotebook.vala"
	_tmp1_ = self->priv->notebook;
#line 1122 "../src/DynamicNotebook.vala"
	_tmp2_ = gtk_notebook_get_nth_page (_tmp1_, index);
#line 1122 "../src/DynamicNotebook.vala"
	_tmp3_ = gtk_notebook_get_tab_label (_tmp0_, _tmp2_);
#line 1122 "../src/DynamicNotebook.vala"
	_tmp4_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp3_, TYPE_TAB) ? ((Tab*) _tmp3_) : NULL);
#line 1122 "../src/DynamicNotebook.vala"
	result = _tmp4_;
#line 1122 "../src/DynamicNotebook.vala"
	return result;
#line 5650 "DynamicNotebook.c"
}


Tab*
dynamic_notebook_get_tab_by_widget (DynamicNotebook* self,
                                    GtkWidget* widget)
{
	Tab* result = NULL;
	GtkNotebook* _tmp0_;
	GtkContainer* _tmp1_;
	GtkWidget* _tmp2_;
	Tab* _tmp3_;
#line 1125 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1125 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (widget != NULL, NULL);
#line 1126 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->notebook;
#line 1126 "../src/DynamicNotebook.vala"
	_tmp1_ = gtk_widget_get_parent (widget);
#line 1126 "../src/DynamicNotebook.vala"
	_tmp2_ = gtk_notebook_get_tab_label (_tmp0_, (GtkWidget*) _tmp1_);
#line 1126 "../src/DynamicNotebook.vala"
	_tmp3_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp2_, TYPE_TAB) ? ((Tab*) _tmp2_) : NULL);
#line 1126 "../src/DynamicNotebook.vala"
	result = _tmp3_;
#line 1126 "../src/DynamicNotebook.vala"
	return result;
#line 5679 "DynamicNotebook.c"
}


GtkWidget*
dynamic_notebook_get_nth_page (DynamicNotebook* self,
                               gint index)
{
	GtkWidget* result = NULL;
	GtkNotebook* _tmp0_;
	GtkWidget* _tmp1_;
	GtkWidget* _tmp2_;
#line 1129 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 1130 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->notebook;
#line 1130 "../src/DynamicNotebook.vala"
	_tmp1_ = gtk_notebook_get_nth_page (_tmp0_, index);
#line 1130 "../src/DynamicNotebook.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 1130 "../src/DynamicNotebook.vala"
	result = _tmp2_;
#line 1130 "../src/DynamicNotebook.vala"
	return result;
#line 5703 "DynamicNotebook.c"
}


guint
dynamic_notebook_insert_tab (DynamicNotebook* self,
                             Tab* tab,
                             gint index)
{
	guint result = 0U;
	GList* _tmp0_;
	GList* _tmp1_;
	gint i = 0;
	GtkNotebook* _tmp7_;
	TabPageContainer* _tmp8_;
	gboolean _tmp9_;
	gboolean _tmp10_;
	GtkNotebook* _tmp11_;
	TabPageContainer* _tmp12_;
	gboolean _tmp13_;
	gboolean _tmp14_;
	GtkMenuItem* _tmp15_;
	gboolean _tmp16_;
	gboolean _tmp17_;
	GtkMenuItem* _tmp18_;
	gboolean _tmp19_;
	gboolean _tmp20_;
	GtkMenuItem* _tmp21_;
	gboolean _tmp22_;
	gboolean _tmp23_;
	gboolean _tmp24_;
	gboolean _tmp25_;
	gint _tmp26_;
	gboolean _tmp27_;
	gboolean _tmp28_;
#line 1133 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, 0U);
#line 1133 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (tab != NULL, 0U);
#line 1134 "../src/DynamicNotebook.vala"
	_tmp0_ = dynamic_notebook_get_tabs (self);
#line 1134 "../src/DynamicNotebook.vala"
	_tmp1_ = _tmp0_;
#line 1134 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (g_list_index (_tmp1_, tab) < 0, 0);
#line 1136 "../src/DynamicNotebook.vala"
	i = 0;
#line 1137 "../src/DynamicNotebook.vala"
	if (index <= -1) {
#line 5752 "DynamicNotebook.c"
		GtkNotebook* _tmp2_;
		TabPageContainer* _tmp3_;
		GtkNotebook* _tmp4_;
#line 1138 "../src/DynamicNotebook.vala"
		_tmp2_ = self->priv->notebook;
#line 1138 "../src/DynamicNotebook.vala"
		_tmp3_ = tab->page_container;
#line 1138 "../src/DynamicNotebook.vala"
		_tmp4_ = self->priv->notebook;
#line 1138 "../src/DynamicNotebook.vala"
		i = gtk_notebook_insert_page (_tmp2_, (GtkWidget*) _tmp3_, (GtkWidget*) tab, gtk_notebook_get_n_pages (_tmp4_));
#line 5764 "DynamicNotebook.c"
	} else {
		GtkNotebook* _tmp5_;
		TabPageContainer* _tmp6_;
#line 1140 "../src/DynamicNotebook.vala"
		_tmp5_ = self->priv->notebook;
#line 1140 "../src/DynamicNotebook.vala"
		_tmp6_ = tab->page_container;
#line 1140 "../src/DynamicNotebook.vala"
		i = gtk_notebook_insert_page (_tmp5_, (GtkWidget*) _tmp6_, (GtkWidget*) tab, index);
#line 5774 "DynamicNotebook.c"
	}
#line 1142 "../src/DynamicNotebook.vala"
	_tmp7_ = self->priv->notebook;
#line 1142 "../src/DynamicNotebook.vala"
	_tmp8_ = tab->page_container;
#line 1142 "../src/DynamicNotebook.vala"
	_tmp9_ = dynamic_notebook_get_allow_drag (self);
#line 1142 "../src/DynamicNotebook.vala"
	_tmp10_ = _tmp9_;
#line 1142 "../src/DynamicNotebook.vala"
	gtk_notebook_set_tab_reorderable (_tmp7_, (GtkWidget*) _tmp8_, _tmp10_);
#line 1143 "../src/DynamicNotebook.vala"
	_tmp11_ = self->priv->notebook;
#line 1143 "../src/DynamicNotebook.vala"
	_tmp12_ = tab->page_container;
#line 1143 "../src/DynamicNotebook.vala"
	_tmp13_ = dynamic_notebook_get_allow_new_window (self);
#line 1143 "../src/DynamicNotebook.vala"
	_tmp14_ = _tmp13_;
#line 1143 "../src/DynamicNotebook.vala"
	gtk_notebook_set_tab_detachable (_tmp11_, (GtkWidget*) _tmp12_, _tmp14_);
#line 1145 "../src/DynamicNotebook.vala"
	_tmp15_ = tab->duplicate_m;
#line 1145 "../src/DynamicNotebook.vala"
	_tmp16_ = dynamic_notebook_get_allow_duplication (self);
#line 1145 "../src/DynamicNotebook.vala"
	_tmp17_ = _tmp16_;
#line 1145 "../src/DynamicNotebook.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp15_, _tmp17_);
#line 1146 "../src/DynamicNotebook.vala"
	_tmp18_ = tab->new_window_m;
#line 1146 "../src/DynamicNotebook.vala"
	_tmp19_ = dynamic_notebook_get_allow_new_window (self);
#line 1146 "../src/DynamicNotebook.vala"
	_tmp20_ = _tmp19_;
#line 1146 "../src/DynamicNotebook.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp18_, _tmp20_);
#line 1147 "../src/DynamicNotebook.vala"
	_tmp21_ = tab->pin_m;
#line 1147 "../src/DynamicNotebook.vala"
	_tmp22_ = dynamic_notebook_get_allow_pinning (self);
#line 1147 "../src/DynamicNotebook.vala"
	_tmp23_ = _tmp22_;
#line 1147 "../src/DynamicNotebook.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp21_, _tmp23_);
#line 1148 "../src/DynamicNotebook.vala"
	_tmp24_ = dynamic_notebook_get_allow_pinning (self);
#line 1148 "../src/DynamicNotebook.vala"
	_tmp25_ = _tmp24_;
#line 1148 "../src/DynamicNotebook.vala"
	tab_set_pinnable (tab, _tmp25_);
#line 1149 "../src/DynamicNotebook.vala"
	tab_set_pinned (tab, FALSE);
#line 1151 "../src/DynamicNotebook.vala"
	_tmp26_ = self->priv->tab_width;
#line 1151 "../src/DynamicNotebook.vala"
	g_object_set ((GtkWidget*) tab, "width-request", _tmp26_, NULL);
#line 1152 "../src/DynamicNotebook.vala"
	dynamic_notebook_recalc_size (self);
#line 1153 "../src/DynamicNotebook.vala"
	dynamic_notebook_recalc_order (self);
#line 1155 "../src/DynamicNotebook.vala"
	_tmp27_ = dynamic_notebook_get_tabs_closable (self);
#line 1155 "../src/DynamicNotebook.vala"
	_tmp28_ = _tmp27_;
#line 1155 "../src/DynamicNotebook.vala"
	if (!_tmp28_) {
#line 1156 "../src/DynamicNotebook.vala"
		tab_set_closable (tab, FALSE);
#line 5844 "DynamicNotebook.c"
	}
#line 1158 "../src/DynamicNotebook.vala"
	result = (guint) i;
#line 1158 "../src/DynamicNotebook.vala"
	return result;
#line 5850 "DynamicNotebook.c"
}


static void
_dynamic_notebook_on_tab_closed_tab_closed (Tab* _sender,
                                            gpointer self)
{
#line 1162 "../src/DynamicNotebook.vala"
	dynamic_notebook_on_tab_closed ((DynamicNotebook*) self, _sender);
#line 5860 "DynamicNotebook.c"
}


static void
_dynamic_notebook_on_close_others_tab_close_others (Tab* _sender,
                                                    gpointer self)
{
#line 1163 "../src/DynamicNotebook.vala"
	dynamic_notebook_on_close_others ((DynamicNotebook*) self, _sender);
#line 5870 "DynamicNotebook.c"
}


static void
_dynamic_notebook_on_new_window_tab_new_window (Tab* _sender,
                                                gpointer self)
{
#line 1164 "../src/DynamicNotebook.vala"
	dynamic_notebook_on_new_window ((DynamicNotebook*) self, _sender);
#line 5880 "DynamicNotebook.c"
}


static void
_dynamic_notebook_on_duplicate_tab_duplicate (Tab* _sender,
                                              gpointer self)
{
#line 1165 "../src/DynamicNotebook.vala"
	dynamic_notebook_on_duplicate ((DynamicNotebook*) self, _sender);
#line 5890 "DynamicNotebook.c"
}


static void
_dynamic_notebook_on_pin_switch_tab_pin_switch (Tab* _sender,
                                                gpointer self)
{
#line 1166 "../src/DynamicNotebook.vala"
	dynamic_notebook_on_pin_switch ((DynamicNotebook*) self, _sender);
#line 5900 "DynamicNotebook.c"
}


static void
dynamic_notebook_insert_callbacks (DynamicNotebook* self,
                                   Tab* tab)
{
#line 1161 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 1161 "../src/DynamicNotebook.vala"
	g_return_if_fail (tab != NULL);
#line 1162 "../src/DynamicNotebook.vala"
	g_signal_connect_object (tab, "closed", (GCallback) _dynamic_notebook_on_tab_closed_tab_closed, self, 0);
#line 1163 "../src/DynamicNotebook.vala"
	g_signal_connect_object (tab, "close-others", (GCallback) _dynamic_notebook_on_close_others_tab_close_others, self, 0);
#line 1164 "../src/DynamicNotebook.vala"
	g_signal_connect_object (tab, "new-window", (GCallback) _dynamic_notebook_on_new_window_tab_new_window, self, 0);
#line 1165 "../src/DynamicNotebook.vala"
	g_signal_connect_object (tab, "duplicate", (GCallback) _dynamic_notebook_on_duplicate_tab_duplicate, self, 0);
#line 1166 "../src/DynamicNotebook.vala"
	g_signal_connect_object (tab, "pin-switch", (GCallback) _dynamic_notebook_on_pin_switch_tab_pin_switch, self, 0);
#line 5922 "DynamicNotebook.c"
}


static void
dynamic_notebook_remove_callbacks (DynamicNotebook* self,
                                   Tab* tab)
{
	guint _tmp0_;
	guint _tmp1_;
	guint _tmp2_;
	guint _tmp3_;
	guint _tmp4_;
#line 1169 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 1169 "../src/DynamicNotebook.vala"
	g_return_if_fail (tab != NULL);
#line 1170 "../src/DynamicNotebook.vala"
	g_signal_parse_name ("closed", TYPE_TAB, &_tmp0_, NULL, FALSE);
#line 1170 "../src/DynamicNotebook.vala"
	g_signal_handlers_disconnect_matched (tab, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp0_, 0, NULL, (GCallback) _dynamic_notebook_on_tab_closed_tab_closed, self);
#line 1171 "../src/DynamicNotebook.vala"
	g_signal_parse_name ("close-others", TYPE_TAB, &_tmp1_, NULL, FALSE);
#line 1171 "../src/DynamicNotebook.vala"
	g_signal_handlers_disconnect_matched (tab, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _dynamic_notebook_on_close_others_tab_close_others, self);
#line 1172 "../src/DynamicNotebook.vala"
	g_signal_parse_name ("new-window", TYPE_TAB, &_tmp2_, NULL, FALSE);
#line 1172 "../src/DynamicNotebook.vala"
	g_signal_handlers_disconnect_matched (tab, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _dynamic_notebook_on_new_window_tab_new_window, self);
#line 1173 "../src/DynamicNotebook.vala"
	g_signal_parse_name ("duplicate", TYPE_TAB, &_tmp3_, NULL, FALSE);
#line 1173 "../src/DynamicNotebook.vala"
	g_signal_handlers_disconnect_matched (tab, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _dynamic_notebook_on_duplicate_tab_duplicate, self);
#line 1174 "../src/DynamicNotebook.vala"
	g_signal_parse_name ("pin-switch", TYPE_TAB, &_tmp4_, NULL, FALSE);
#line 1174 "../src/DynamicNotebook.vala"
	g_signal_handlers_disconnect_matched (tab, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp4_, 0, NULL, (GCallback) _dynamic_notebook_on_pin_switch_tab_pin_switch, self);
#line 5959 "DynamicNotebook.c"
}


static void
dynamic_notebook_on_tab_closed (DynamicNotebook* self,
                                Tab* tab)
{
	gint pos = 0;
	gboolean _tmp2_ = FALSE;
	gint _tmp3_;
	gboolean _tmp9_ = FALSE;
	const gchar* _tmp10_;
	const gchar* _tmp11_;
#line 1177 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 1177 "../src/DynamicNotebook.vala"
	g_return_if_fail (tab != NULL);
#line 1178 "../src/DynamicNotebook.vala"
	if (g_signal_has_handler_pending (self, g_signal_lookup ("close-tab-requested", TYPE_DYNAMIC_NOTEBOOK), (GQuark) 0, TRUE)) {
#line 5979 "DynamicNotebook.c"
		gboolean sure = FALSE;
		gboolean _tmp0_ = FALSE;
		gboolean _tmp1_;
#line 1179 "../src/DynamicNotebook.vala"
		g_signal_emit (self, dynamic_notebook_signals[DYNAMIC_NOTEBOOK_CLOSE_TAB_REQUESTED_SIGNAL], 0, tab, &_tmp0_);
#line 1179 "../src/DynamicNotebook.vala"
		sure = _tmp0_;
#line 1181 "../src/DynamicNotebook.vala"
		_tmp1_ = sure;
#line 1181 "../src/DynamicNotebook.vala"
		if (!_tmp1_) {
#line 1182 "../src/DynamicNotebook.vala"
			return;
#line 5993 "DynamicNotebook.c"
		}
	}
#line 1185 "../src/DynamicNotebook.vala"
	pos = dynamic_notebook_get_tab_position (self, tab);
#line 1187 "../src/DynamicNotebook.vala"
	dynamic_notebook_remove_tab (self, tab);
#line 1189 "../src/DynamicNotebook.vala"
	_tmp3_ = pos;
#line 1189 "../src/DynamicNotebook.vala"
	if (_tmp3_ != -1) {
#line 6004 "DynamicNotebook.c"
		GtkWidget* _tmp4_;
		GtkWidget* _tmp5_;
		GtkContainer* _tmp6_;
#line 1189 "../src/DynamicNotebook.vala"
		_tmp4_ = tab_get_page (tab);
#line 1189 "../src/DynamicNotebook.vala"
		_tmp5_ = _tmp4_;
#line 1189 "../src/DynamicNotebook.vala"
		_tmp6_ = gtk_widget_get_parent (_tmp5_);
#line 1189 "../src/DynamicNotebook.vala"
		_tmp2_ = _tmp6_ != NULL;
#line 6016 "DynamicNotebook.c"
	} else {
#line 1189 "../src/DynamicNotebook.vala"
		_tmp2_ = FALSE;
#line 6020 "DynamicNotebook.c"
	}
#line 1189 "../src/DynamicNotebook.vala"
	if (_tmp2_) {
#line 6024 "DynamicNotebook.c"
		GtkWidget* _tmp7_;
		GtkWidget* _tmp8_;
#line 1190 "../src/DynamicNotebook.vala"
		_tmp7_ = tab_get_page (tab);
#line 1190 "../src/DynamicNotebook.vala"
		_tmp8_ = _tmp7_;
#line 1190 "../src/DynamicNotebook.vala"
		gtk_widget_unparent (_tmp8_);
#line 6033 "DynamicNotebook.c"
	}
#line 1192 "../src/DynamicNotebook.vala"
	_tmp10_ = tab_get_label (tab);
#line 1192 "../src/DynamicNotebook.vala"
	_tmp11_ = _tmp10_;
#line 1192 "../src/DynamicNotebook.vala"
	if (g_strcmp0 (_tmp11_, "") != 0) {
#line 6041 "DynamicNotebook.c"
		const gchar* _tmp12_;
		const gchar* _tmp13_;
#line 1192 "../src/DynamicNotebook.vala"
		_tmp12_ = tab_get_restore_data (tab);
#line 1192 "../src/DynamicNotebook.vala"
		_tmp13_ = _tmp12_;
#line 1192 "../src/DynamicNotebook.vala"
		_tmp9_ = g_strcmp0 (_tmp13_, "") != 0;
#line 6050 "DynamicNotebook.c"
	} else {
#line 1192 "../src/DynamicNotebook.vala"
		_tmp9_ = FALSE;
#line 6054 "DynamicNotebook.c"
	}
#line 1192 "../src/DynamicNotebook.vala"
	if (_tmp9_) {
#line 6058 "DynamicNotebook.c"
		ClosedTabs* _tmp14_;
		GtkButton* _tmp15_;
		ClosedTabs* _tmp16_;
		gboolean _tmp17_;
		gboolean _tmp18_;
		GtkMenuItem* _tmp19_;
		ClosedTabs* _tmp20_;
		gboolean _tmp21_;
		gboolean _tmp22_;
#line 1193 "../src/DynamicNotebook.vala"
		_tmp14_ = self->priv->closed_tabs;
#line 1193 "../src/DynamicNotebook.vala"
		closed_tabs_push (_tmp14_, tab);
#line 1194 "../src/DynamicNotebook.vala"
		_tmp15_ = self->priv->restore_button;
#line 1194 "../src/DynamicNotebook.vala"
		_tmp16_ = self->priv->closed_tabs;
#line 1194 "../src/DynamicNotebook.vala"
		_tmp17_ = closed_tabs_get_empty (_tmp16_);
#line 1194 "../src/DynamicNotebook.vala"
		_tmp18_ = _tmp17_;
#line 1194 "../src/DynamicNotebook.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp15_, !_tmp18_);
#line 1195 "../src/DynamicNotebook.vala"
		_tmp19_ = self->priv->restore_tab_m;
#line 1195 "../src/DynamicNotebook.vala"
		_tmp20_ = self->priv->closed_tabs;
#line 1195 "../src/DynamicNotebook.vala"
		_tmp21_ = closed_tabs_get_empty (_tmp20_);
#line 1195 "../src/DynamicNotebook.vala"
		_tmp22_ = _tmp21_;
#line 1195 "../src/DynamicNotebook.vala"
		gtk_widget_set_sensitive ((GtkWidget*) _tmp19_, !_tmp22_);
#line 6092 "DynamicNotebook.c"
	}
}


static void
dynamic_notebook_on_close_others (DynamicNotebook* self,
                                  Tab* tab)
{
	gint num = 0;
#line 1199 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 1199 "../src/DynamicNotebook.vala"
	g_return_if_fail (tab != NULL);
#line 1200 "../src/DynamicNotebook.vala"
	num = 0;
#line 6108 "DynamicNotebook.c"
	{
		gint j = 0;
#line 1202 "../src/DynamicNotebook.vala"
		j = 0;
#line 6113 "DynamicNotebook.c"
		{
			gboolean _tmp0_ = FALSE;
#line 1202 "../src/DynamicNotebook.vala"
			_tmp0_ = TRUE;
#line 1202 "../src/DynamicNotebook.vala"
			while (TRUE) {
#line 6120 "DynamicNotebook.c"
				gint _tmp2_;
				GList* _tmp3_;
				GList* _tmp4_;
				GList* _tmp5_;
				GList* _tmp6_;
				gint _tmp7_;
				gconstpointer _tmp8_;
				gint _tmp17_;
				gint _tmp18_;
#line 1202 "../src/DynamicNotebook.vala"
				if (!_tmp0_) {
#line 6132 "DynamicNotebook.c"
					gint _tmp1_;
#line 1202 "../src/DynamicNotebook.vala"
					_tmp1_ = j;
#line 1202 "../src/DynamicNotebook.vala"
					j = _tmp1_ + 1;
#line 6138 "DynamicNotebook.c"
				}
#line 1202 "../src/DynamicNotebook.vala"
				_tmp0_ = FALSE;
#line 1202 "../src/DynamicNotebook.vala"
				_tmp2_ = j;
#line 1202 "../src/DynamicNotebook.vala"
				_tmp3_ = dynamic_notebook_get_tabs (self);
#line 1202 "../src/DynamicNotebook.vala"
				_tmp4_ = _tmp3_;
#line 1202 "../src/DynamicNotebook.vala"
				if (!(((guint) _tmp2_) < g_list_length (_tmp4_))) {
#line 1202 "../src/DynamicNotebook.vala"
					break;
#line 6152 "DynamicNotebook.c"
				}
#line 1203 "../src/DynamicNotebook.vala"
				_tmp5_ = dynamic_notebook_get_tabs (self);
#line 1203 "../src/DynamicNotebook.vala"
				_tmp6_ = _tmp5_;
#line 1203 "../src/DynamicNotebook.vala"
				_tmp7_ = j;
#line 1203 "../src/DynamicNotebook.vala"
				_tmp8_ = g_list_nth_data (_tmp6_, (guint) _tmp7_);
#line 1203 "../src/DynamicNotebook.vala"
				if (tab != ((Tab*) _tmp8_)) {
#line 6164 "DynamicNotebook.c"
					GList* _tmp9_;
					GList* _tmp10_;
					gint _tmp11_;
					gconstpointer _tmp12_;
					gint _tmp13_;
					gint _tmp14_;
					gint _tmp15_;
					gint _tmp16_;
#line 1204 "../src/DynamicNotebook.vala"
					_tmp9_ = dynamic_notebook_get_tabs (self);
#line 1204 "../src/DynamicNotebook.vala"
					_tmp10_ = _tmp9_;
#line 1204 "../src/DynamicNotebook.vala"
					_tmp11_ = j;
#line 1204 "../src/DynamicNotebook.vala"
					_tmp12_ = g_list_nth_data (_tmp10_, (guint) _tmp11_);
#line 1204 "../src/DynamicNotebook.vala"
					g_signal_emit ((Tab*) _tmp12_, tab_signals[TAB_CLOSED_SIGNAL], 0);
#line 1205 "../src/DynamicNotebook.vala"
					_tmp13_ = num;
#line 1205 "../src/DynamicNotebook.vala"
					_tmp14_ = dynamic_notebook_get_n_tabs (self);
#line 1205 "../src/DynamicNotebook.vala"
					_tmp15_ = _tmp14_;
#line 1205 "../src/DynamicNotebook.vala"
					if (_tmp13_ == _tmp15_) {
#line 1205 "../src/DynamicNotebook.vala"
						break;
#line 6193 "DynamicNotebook.c"
					}
#line 1206 "../src/DynamicNotebook.vala"
					_tmp16_ = j;
#line 1206 "../src/DynamicNotebook.vala"
					j = _tmp16_ - 1;
#line 6199 "DynamicNotebook.c"
				}
#line 1209 "../src/DynamicNotebook.vala"
				_tmp17_ = dynamic_notebook_get_n_tabs (self);
#line 1209 "../src/DynamicNotebook.vala"
				_tmp18_ = _tmp17_;
#line 1209 "../src/DynamicNotebook.vala"
				num = _tmp18_;
#line 6207 "DynamicNotebook.c"
			}
		}
	}
}


static void
dynamic_notebook_on_new_window (DynamicNotebook* self,
                                Tab* tab)
{
	GtkNotebook* _tmp0_;
	TabPageContainer* _tmp1_;
	GtkNotebook* _tmp2_ = NULL;
#line 1213 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 1213 "../src/DynamicNotebook.vala"
	g_return_if_fail (tab != NULL);
#line 1214 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->notebook;
#line 1214 "../src/DynamicNotebook.vala"
	_tmp1_ = tab->page_container;
#line 1214 "../src/DynamicNotebook.vala"
	g_signal_emit_by_name (_tmp0_, "create-window", (GtkWidget*) _tmp1_, 0, 0, &_tmp2_);
#line 6231 "DynamicNotebook.c"
}


static void
dynamic_notebook_on_duplicate (DynamicNotebook* self,
                               Tab* tab)
{
#line 1217 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 1217 "../src/DynamicNotebook.vala"
	g_return_if_fail (tab != NULL);
#line 1218 "../src/DynamicNotebook.vala"
	g_signal_emit (self, dynamic_notebook_signals[DYNAMIC_NOTEBOOK_TAB_DUPLICATED_SIGNAL], 0, tab);
#line 6245 "DynamicNotebook.c"
}


static void
dynamic_notebook_on_pin_switch (DynamicNotebook* self,
                                Tab* tab)
{
#line 1221 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 1221 "../src/DynamicNotebook.vala"
	g_return_if_fail (tab != NULL);
#line 1222 "../src/DynamicNotebook.vala"
	dynamic_notebook_switch_pin_tab (self, tab);
#line 6259 "DynamicNotebook.c"
}


static void
dynamic_notebook_update_tabs_visibility (DynamicNotebook* self)
{
	DynamicNotebookTabBarBehavior _tmp0_;
#line 1225 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 1226 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->_tab_bar_behavior;
#line 1226 "../src/DynamicNotebook.vala"
	if (_tmp0_ == DYNAMIC_NOTEBOOK_TAB_BAR_BEHAVIOR_SINGLE) {
#line 6273 "DynamicNotebook.c"
		GtkNotebook* _tmp1_;
		gint _tmp2_;
		gint _tmp3_;
#line 1227 "../src/DynamicNotebook.vala"
		_tmp1_ = self->priv->notebook;
#line 1227 "../src/DynamicNotebook.vala"
		_tmp2_ = dynamic_notebook_get_n_tabs (self);
#line 1227 "../src/DynamicNotebook.vala"
		_tmp3_ = _tmp2_;
#line 1227 "../src/DynamicNotebook.vala"
		gtk_notebook_set_show_tabs (_tmp1_, _tmp3_ > 1);
#line 6285 "DynamicNotebook.c"
	} else {
		DynamicNotebookTabBarBehavior _tmp4_;
#line 1228 "../src/DynamicNotebook.vala"
		_tmp4_ = self->priv->_tab_bar_behavior;
#line 1228 "../src/DynamicNotebook.vala"
		if (_tmp4_ == DYNAMIC_NOTEBOOK_TAB_BAR_BEHAVIOR_NEVER) {
#line 6292 "DynamicNotebook.c"
			GtkNotebook* _tmp5_;
#line 1229 "../src/DynamicNotebook.vala"
			_tmp5_ = self->priv->notebook;
#line 1229 "../src/DynamicNotebook.vala"
			gtk_notebook_set_show_tabs (_tmp5_, FALSE);
#line 6298 "DynamicNotebook.c"
		} else {
			DynamicNotebookTabBarBehavior _tmp6_;
#line 1230 "../src/DynamicNotebook.vala"
			_tmp6_ = self->priv->_tab_bar_behavior;
#line 1230 "../src/DynamicNotebook.vala"
			if (_tmp6_ == DYNAMIC_NOTEBOOK_TAB_BAR_BEHAVIOR_ALWAYS) {
#line 6305 "DynamicNotebook.c"
				GtkNotebook* _tmp7_;
#line 1231 "../src/DynamicNotebook.vala"
				_tmp7_ = self->priv->notebook;
#line 1231 "../src/DynamicNotebook.vala"
				gtk_notebook_set_show_tabs (_tmp7_, TRUE);
#line 6311 "DynamicNotebook.c"
			}
		}
	}
}


gint
dynamic_notebook_get_n_tabs (DynamicNotebook* self)
{
	gint result;
	GtkNotebook* _tmp0_;
#line 518 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 518 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->notebook;
#line 518 "../src/DynamicNotebook.vala"
	result = gtk_notebook_get_n_pages (_tmp0_);
#line 518 "../src/DynamicNotebook.vala"
	return result;
#line 6331 "DynamicNotebook.c"
}


gboolean
dynamic_notebook_get_show_tabs (DynamicNotebook* self)
{
	gboolean result;
	GtkNotebook* _tmp0_;
	gboolean _tmp1_;
	gboolean _tmp2_;
#line 525 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 525 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->notebook;
#line 525 "../src/DynamicNotebook.vala"
	_tmp1_ = gtk_notebook_get_show_tabs (_tmp0_);
#line 525 "../src/DynamicNotebook.vala"
	_tmp2_ = _tmp1_;
#line 525 "../src/DynamicNotebook.vala"
	result = _tmp2_;
#line 525 "../src/DynamicNotebook.vala"
	return result;
#line 6354 "DynamicNotebook.c"
}


void
dynamic_notebook_set_show_tabs (DynamicNotebook* self,
                                gboolean value)
{
	GtkNotebook* _tmp0_;
#line 526 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 526 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->notebook;
#line 526 "../src/DynamicNotebook.vala"
	gtk_notebook_set_show_tabs (_tmp0_, value);
#line 526 "../src/DynamicNotebook.vala"
	g_object_notify_by_pspec ((GObject *) self, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_SHOW_TABS_PROPERTY]);
#line 6371 "DynamicNotebook.c"
}


gboolean
dynamic_notebook_get_show_icons (DynamicNotebook* self)
{
	gboolean result;
	gboolean _tmp0_;
#line 535 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 535 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->_show_icons;
#line 535 "../src/DynamicNotebook.vala"
	result = _tmp0_;
#line 535 "../src/DynamicNotebook.vala"
	return result;
#line 6388 "DynamicNotebook.c"
}


void
dynamic_notebook_set_show_icons (DynamicNotebook* self,
                                 gboolean value)
{
#line 536 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 537 "../src/DynamicNotebook.vala"
	self->priv->_show_icons = value;
#line 536 "../src/DynamicNotebook.vala"
	g_object_notify_by_pspec ((GObject *) self, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_SHOW_ICONS_PROPERTY]);
#line 6402 "DynamicNotebook.c"
}


gboolean
dynamic_notebook_get_tabs_closable (DynamicNotebook* self)
{
	gboolean result;
	gboolean _tmp0_;
#line 546 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 546 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->_tabs_closable;
#line 546 "../src/DynamicNotebook.vala"
	result = _tmp0_;
#line 546 "../src/DynamicNotebook.vala"
	return result;
#line 6419 "DynamicNotebook.c"
}


static Block9Data*
block9_data_ref (Block9Data* _data9_)
{
#line 547 "../src/DynamicNotebook.vala"
	g_atomic_int_inc (&_data9_->_ref_count_);
#line 547 "../src/DynamicNotebook.vala"
	return _data9_;
#line 6430 "DynamicNotebook.c"
}


static void
block9_data_unref (void * _userdata_)
{
	Block9Data* _data9_;
	_data9_ = (Block9Data*) _userdata_;
#line 547 "../src/DynamicNotebook.vala"
	if (g_atomic_int_dec_and_test (&_data9_->_ref_count_)) {
#line 6441 "DynamicNotebook.c"
		DynamicNotebook* self;
#line 547 "../src/DynamicNotebook.vala"
		self = _data9_->self;
#line 547 "../src/DynamicNotebook.vala"
		_g_object_unref0 (self);
#line 547 "../src/DynamicNotebook.vala"
		g_slice_free (Block9Data, _data9_);
#line 6449 "DynamicNotebook.c"
	}
}


static void
_dynamic_notebook_tabs_closable____lambda21_ (Block9Data* _data9_,
                                              Tab* t)
{
	DynamicNotebook* self;
#line 549 "../src/DynamicNotebook.vala"
	self = _data9_->self;
#line 549 "../src/DynamicNotebook.vala"
	g_return_if_fail (t != NULL);
#line 550 "../src/DynamicNotebook.vala"
	tab_set_closable (t, _data9_->value);
#line 6465 "DynamicNotebook.c"
}


static void
__dynamic_notebook_tabs_closable____lambda21__gfunc (gconstpointer data,
                                                     gpointer self)
{
#line 549 "../src/DynamicNotebook.vala"
	_dynamic_notebook_tabs_closable____lambda21_ (self, (Tab*) data);
#line 6475 "DynamicNotebook.c"
}


void
dynamic_notebook_set_tabs_closable (DynamicNotebook* self,
                                    gboolean value)
{
	Block9Data* _data9_;
	gboolean _tmp0_;
#line 547 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 547 "../src/DynamicNotebook.vala"
	_data9_ = g_slice_new0 (Block9Data);
#line 547 "../src/DynamicNotebook.vala"
	_data9_->_ref_count_ = 1;
#line 547 "../src/DynamicNotebook.vala"
	_data9_->self = g_object_ref (self);
#line 547 "../src/DynamicNotebook.vala"
	_data9_->value = value;
#line 548 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->_tabs_closable;
#line 548 "../src/DynamicNotebook.vala"
	if (_data9_->value != _tmp0_) {
#line 6499 "DynamicNotebook.c"
		GList* _tmp1_;
		GList* _tmp2_;
#line 549 "../src/DynamicNotebook.vala"
		_tmp1_ = dynamic_notebook_get_tabs (self);
#line 549 "../src/DynamicNotebook.vala"
		_tmp2_ = _tmp1_;
#line 549 "../src/DynamicNotebook.vala"
		g_list_foreach (_tmp2_, __dynamic_notebook_tabs_closable____lambda21__gfunc, _data9_);
#line 6508 "DynamicNotebook.c"
	}
#line 552 "../src/DynamicNotebook.vala"
	self->priv->_tabs_closable = _data9_->value;
#line 547 "../src/DynamicNotebook.vala"
	block9_data_unref (_data9_);
#line 547 "../src/DynamicNotebook.vala"
	_data9_ = NULL;
#line 547 "../src/DynamicNotebook.vala"
	g_object_notify_by_pspec ((GObject *) self, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_TABS_CLOSABLE_PROPERTY]);
#line 6518 "DynamicNotebook.c"
}


gboolean
dynamic_notebook_get_allow_drag (DynamicNotebook* self)
{
	gboolean result;
	gboolean _tmp0_;
#line 561 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 561 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->_allow_drag;
#line 561 "../src/DynamicNotebook.vala"
	result = _tmp0_;
#line 561 "../src/DynamicNotebook.vala"
	return result;
#line 6535 "DynamicNotebook.c"
}


static Block10Data*
block10_data_ref (Block10Data* _data10_)
{
#line 562 "../src/DynamicNotebook.vala"
	g_atomic_int_inc (&_data10_->_ref_count_);
#line 562 "../src/DynamicNotebook.vala"
	return _data10_;
#line 6546 "DynamicNotebook.c"
}


static void
block10_data_unref (void * _userdata_)
{
	Block10Data* _data10_;
	_data10_ = (Block10Data*) _userdata_;
#line 562 "../src/DynamicNotebook.vala"
	if (g_atomic_int_dec_and_test (&_data10_->_ref_count_)) {
#line 6557 "DynamicNotebook.c"
		DynamicNotebook* self;
#line 562 "../src/DynamicNotebook.vala"
		self = _data10_->self;
#line 562 "../src/DynamicNotebook.vala"
		_g_object_unref0 (self);
#line 562 "../src/DynamicNotebook.vala"
		g_slice_free (Block10Data, _data10_);
#line 6565 "DynamicNotebook.c"
	}
}


static void
_dynamic_notebook_allow_drag___lambda19_ (Block10Data* _data10_,
                                          Tab* t)
{
	DynamicNotebook* self;
	GtkNotebook* _tmp0_;
	TabPageContainer* _tmp1_;
#line 564 "../src/DynamicNotebook.vala"
	self = _data10_->self;
#line 564 "../src/DynamicNotebook.vala"
	g_return_if_fail (t != NULL);
#line 565 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->notebook;
#line 565 "../src/DynamicNotebook.vala"
	_tmp1_ = t->page_container;
#line 565 "../src/DynamicNotebook.vala"
	gtk_notebook_set_tab_reorderable (_tmp0_, (GtkWidget*) _tmp1_, _data10_->value);
#line 6587 "DynamicNotebook.c"
}


static void
__dynamic_notebook_allow_drag___lambda19__gfunc (gconstpointer data,
                                                 gpointer self)
{
#line 564 "../src/DynamicNotebook.vala"
	_dynamic_notebook_allow_drag___lambda19_ (self, (Tab*) data);
#line 6597 "DynamicNotebook.c"
}


void
dynamic_notebook_set_allow_drag (DynamicNotebook* self,
                                 gboolean value)
{
	Block10Data* _data10_;
	GList* _tmp0_;
	GList* _tmp1_;
#line 562 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 562 "../src/DynamicNotebook.vala"
	_data10_ = g_slice_new0 (Block10Data);
#line 562 "../src/DynamicNotebook.vala"
	_data10_->_ref_count_ = 1;
#line 562 "../src/DynamicNotebook.vala"
	_data10_->self = g_object_ref (self);
#line 562 "../src/DynamicNotebook.vala"
	_data10_->value = value;
#line 563 "../src/DynamicNotebook.vala"
	self->priv->_allow_drag = _data10_->value;
#line 564 "../src/DynamicNotebook.vala"
	_tmp0_ = dynamic_notebook_get_tabs (self);
#line 564 "../src/DynamicNotebook.vala"
	_tmp1_ = _tmp0_;
#line 564 "../src/DynamicNotebook.vala"
	g_list_foreach (_tmp1_, __dynamic_notebook_allow_drag___lambda19__gfunc, _data10_);
#line 562 "../src/DynamicNotebook.vala"
	block10_data_unref (_data10_);
#line 562 "../src/DynamicNotebook.vala"
	_data10_ = NULL;
#line 562 "../src/DynamicNotebook.vala"
	g_object_notify_by_pspec ((GObject *) self, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_ALLOW_DRAG_PROPERTY]);
#line 6632 "DynamicNotebook.c"
}


gboolean
dynamic_notebook_get_allow_new_window (DynamicNotebook* self)
{
	gboolean result;
	gboolean _tmp0_;
#line 575 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 575 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->_allow_new_window;
#line 575 "../src/DynamicNotebook.vala"
	result = _tmp0_;
#line 575 "../src/DynamicNotebook.vala"
	return result;
#line 6649 "DynamicNotebook.c"
}


static Block11Data*
block11_data_ref (Block11Data* _data11_)
{
#line 576 "../src/DynamicNotebook.vala"
	g_atomic_int_inc (&_data11_->_ref_count_);
#line 576 "../src/DynamicNotebook.vala"
	return _data11_;
#line 6660 "DynamicNotebook.c"
}


static void
block11_data_unref (void * _userdata_)
{
	Block11Data* _data11_;
	_data11_ = (Block11Data*) _userdata_;
#line 576 "../src/DynamicNotebook.vala"
	if (g_atomic_int_dec_and_test (&_data11_->_ref_count_)) {
#line 6671 "DynamicNotebook.c"
		DynamicNotebook* self;
#line 576 "../src/DynamicNotebook.vala"
		self = _data11_->self;
#line 576 "../src/DynamicNotebook.vala"
		_g_object_unref0 (self);
#line 576 "../src/DynamicNotebook.vala"
		g_slice_free (Block11Data, _data11_);
#line 6679 "DynamicNotebook.c"
	}
}


static void
_dynamic_notebook_allow_new_window___lambda20_ (Block11Data* _data11_,
                                                Tab* t)
{
	DynamicNotebook* self;
	GtkNotebook* _tmp0_;
	TabPageContainer* _tmp1_;
#line 578 "../src/DynamicNotebook.vala"
	self = _data11_->self;
#line 578 "../src/DynamicNotebook.vala"
	g_return_if_fail (t != NULL);
#line 579 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->notebook;
#line 579 "../src/DynamicNotebook.vala"
	_tmp1_ = t->page_container;
#line 579 "../src/DynamicNotebook.vala"
	gtk_notebook_set_tab_detachable (_tmp0_, (GtkWidget*) _tmp1_, _data11_->value);
#line 6701 "DynamicNotebook.c"
}


static void
__dynamic_notebook_allow_new_window___lambda20__gfunc (gconstpointer data,
                                                       gpointer self)
{
#line 578 "../src/DynamicNotebook.vala"
	_dynamic_notebook_allow_new_window___lambda20_ (self, (Tab*) data);
#line 6711 "DynamicNotebook.c"
}


void
dynamic_notebook_set_allow_new_window (DynamicNotebook* self,
                                       gboolean value)
{
	Block11Data* _data11_;
	GList* _tmp0_;
	GList* _tmp1_;
#line 576 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 576 "../src/DynamicNotebook.vala"
	_data11_ = g_slice_new0 (Block11Data);
#line 576 "../src/DynamicNotebook.vala"
	_data11_->_ref_count_ = 1;
#line 576 "../src/DynamicNotebook.vala"
	_data11_->self = g_object_ref (self);
#line 576 "../src/DynamicNotebook.vala"
	_data11_->value = value;
#line 577 "../src/DynamicNotebook.vala"
	self->priv->_allow_new_window = _data11_->value;
#line 578 "../src/DynamicNotebook.vala"
	_tmp0_ = dynamic_notebook_get_tabs (self);
#line 578 "../src/DynamicNotebook.vala"
	_tmp1_ = _tmp0_;
#line 578 "../src/DynamicNotebook.vala"
	g_list_foreach (_tmp1_, __dynamic_notebook_allow_new_window___lambda20__gfunc, _data11_);
#line 576 "../src/DynamicNotebook.vala"
	block11_data_unref (_data11_);
#line 576 "../src/DynamicNotebook.vala"
	_data11_ = NULL;
#line 576 "../src/DynamicNotebook.vala"
	g_object_notify_by_pspec ((GObject *) self, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_ALLOW_NEW_WINDOW_PROPERTY]);
#line 6746 "DynamicNotebook.c"
}


gboolean
dynamic_notebook_get_allow_duplication (DynamicNotebook* self)
{
	gboolean result;
	gboolean _tmp0_;
#line 589 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 589 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->_allow_duplication;
#line 589 "../src/DynamicNotebook.vala"
	result = _tmp0_;
#line 589 "../src/DynamicNotebook.vala"
	return result;
#line 6763 "DynamicNotebook.c"
}


void
dynamic_notebook_set_allow_duplication (DynamicNotebook* self,
                                        gboolean value)
{
	GList* _tmp0_;
	GList* _tmp1_;
#line 590 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 591 "../src/DynamicNotebook.vala"
	self->priv->_allow_duplication = value;
#line 593 "../src/DynamicNotebook.vala"
	_tmp0_ = dynamic_notebook_get_tabs (self);
#line 593 "../src/DynamicNotebook.vala"
	_tmp1_ = _tmp0_;
#line 6781 "DynamicNotebook.c"
	{
		GList* tab_collection = NULL;
		GList* tab_it = NULL;
#line 593 "../src/DynamicNotebook.vala"
		tab_collection = _tmp1_;
#line 593 "../src/DynamicNotebook.vala"
		for (tab_it = tab_collection; tab_it != NULL; tab_it = tab_it->next) {
#line 6789 "DynamicNotebook.c"
			Tab* _tmp2_;
			Tab* tab = NULL;
#line 593 "../src/DynamicNotebook.vala"
			_tmp2_ = _g_object_ref0 ((Tab*) tab_it->data);
#line 593 "../src/DynamicNotebook.vala"
			tab = _tmp2_;
#line 6796 "DynamicNotebook.c"
			{
				Tab* _tmp3_;
				GtkMenuItem* _tmp4_;
#line 594 "../src/DynamicNotebook.vala"
				_tmp3_ = tab;
#line 594 "../src/DynamicNotebook.vala"
				_tmp4_ = _tmp3_->duplicate_m;
#line 594 "../src/DynamicNotebook.vala"
				gtk_widget_set_visible ((GtkWidget*) _tmp4_, value);
#line 593 "../src/DynamicNotebook.vala"
				_g_object_unref0 (tab);
#line 6808 "DynamicNotebook.c"
			}
		}
	}
#line 590 "../src/DynamicNotebook.vala"
	g_object_notify_by_pspec ((GObject *) self, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_ALLOW_DUPLICATION_PROPERTY]);
#line 6814 "DynamicNotebook.c"
}


gboolean
dynamic_notebook_get_allow_restoring (DynamicNotebook* self)
{
	gboolean result;
	gboolean _tmp0_;
#line 604 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 604 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->_allow_restoring;
#line 604 "../src/DynamicNotebook.vala"
	result = _tmp0_;
#line 604 "../src/DynamicNotebook.vala"
	return result;
#line 6831 "DynamicNotebook.c"
}


void
dynamic_notebook_set_allow_restoring (DynamicNotebook* self,
                                      gboolean value)
{
	GtkMenuItem* _tmp0_;
	GtkButton* _tmp1_;
#line 605 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 606 "../src/DynamicNotebook.vala"
	self->priv->_allow_restoring = value;
#line 607 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->restore_tab_m;
#line 607 "../src/DynamicNotebook.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp0_, value);
#line 608 "../src/DynamicNotebook.vala"
	_tmp1_ = self->priv->restore_button;
#line 608 "../src/DynamicNotebook.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp1_, value);
#line 605 "../src/DynamicNotebook.vala"
	g_object_notify_by_pspec ((GObject *) self, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_ALLOW_RESTORING_PROPERTY]);
#line 6855 "DynamicNotebook.c"
}


gint
dynamic_notebook_get_max_restorable_tabs (DynamicNotebook* self)
{
	gint result;
	ClosedTabs* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 617 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 617 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->closed_tabs;
#line 617 "../src/DynamicNotebook.vala"
	_tmp1_ = closed_tabs_get_max_restorable_tabs (_tmp0_);
#line 617 "../src/DynamicNotebook.vala"
	_tmp2_ = _tmp1_;
#line 617 "../src/DynamicNotebook.vala"
	result = _tmp2_;
#line 617 "../src/DynamicNotebook.vala"
	return result;
#line 6878 "DynamicNotebook.c"
}


void
dynamic_notebook_set_max_restorable_tabs (DynamicNotebook* self,
                                          gint value)
{
	ClosedTabs* _tmp0_;
#line 618 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 618 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->closed_tabs;
#line 618 "../src/DynamicNotebook.vala"
	closed_tabs_set_max_restorable_tabs (_tmp0_, value);
#line 618 "../src/DynamicNotebook.vala"
	g_object_notify_by_pspec ((GObject *) self, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_MAX_RESTORABLE_TABS_PROPERTY]);
#line 6895 "DynamicNotebook.c"
}


gboolean
dynamic_notebook_get_add_button_visible (DynamicNotebook* self)
{
	gboolean result;
	gboolean _tmp0_;
#line 626 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 626 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->_add_button_visible;
#line 626 "../src/DynamicNotebook.vala"
	result = _tmp0_;
#line 626 "../src/DynamicNotebook.vala"
	return result;
#line 6912 "DynamicNotebook.c"
}


void
dynamic_notebook_set_add_button_visible (DynamicNotebook* self,
                                         gboolean value)
{
	gboolean _tmp0_;
#line 627 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 628 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->_add_button_visible;
#line 628 "../src/DynamicNotebook.vala"
	if (value != _tmp0_) {
#line 6927 "DynamicNotebook.c"
		gboolean _tmp1_;
		GtkMenuItem* _tmp6_;
#line 629 "../src/DynamicNotebook.vala"
		_tmp1_ = self->priv->_add_button_visible;
#line 629 "../src/DynamicNotebook.vala"
		if (_tmp1_) {
#line 6934 "DynamicNotebook.c"
			GtkNotebook* _tmp2_;
			GtkButton* _tmp3_;
#line 630 "../src/DynamicNotebook.vala"
			_tmp2_ = self->priv->notebook;
#line 630 "../src/DynamicNotebook.vala"
			_tmp3_ = self->priv->add_button;
#line 630 "../src/DynamicNotebook.vala"
			gtk_container_remove ((GtkContainer*) _tmp2_, (GtkWidget*) _tmp3_);
#line 6943 "DynamicNotebook.c"
		} else {
			GtkNotebook* _tmp4_;
			GtkButton* _tmp5_;
#line 632 "../src/DynamicNotebook.vala"
			_tmp4_ = self->priv->notebook;
#line 632 "../src/DynamicNotebook.vala"
			_tmp5_ = self->priv->add_button;
#line 632 "../src/DynamicNotebook.vala"
			gtk_notebook_set_action_widget (_tmp4_, (GtkWidget*) _tmp5_, GTK_PACK_START);
#line 6953 "DynamicNotebook.c"
		}
#line 635 "../src/DynamicNotebook.vala"
		self->priv->_add_button_visible = value;
#line 636 "../src/DynamicNotebook.vala"
		_tmp6_ = self->priv->new_tab_m;
#line 636 "../src/DynamicNotebook.vala"
		gtk_widget_set_visible ((GtkWidget*) _tmp6_, value);
#line 6961 "DynamicNotebook.c"
	}
#line 627 "../src/DynamicNotebook.vala"
	g_object_notify_by_pspec ((GObject *) self, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_ADD_BUTTON_VISIBLE_PROPERTY]);
#line 6965 "DynamicNotebook.c"
}


gboolean
dynamic_notebook_get_allow_pinning (DynamicNotebook* self)
{
	gboolean result;
	gboolean _tmp0_;
#line 643 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 643 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->_allow_pinning;
#line 643 "../src/DynamicNotebook.vala"
	result = _tmp0_;
#line 643 "../src/DynamicNotebook.vala"
	return result;
#line 6982 "DynamicNotebook.c"
}


void
dynamic_notebook_set_allow_pinning (DynamicNotebook* self,
                                    gboolean value)
{
	GList* _tmp0_;
	GList* _tmp1_;
#line 644 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 645 "../src/DynamicNotebook.vala"
	self->priv->_allow_pinning = value;
#line 647 "../src/DynamicNotebook.vala"
	_tmp0_ = dynamic_notebook_get_tabs (self);
#line 647 "../src/DynamicNotebook.vala"
	_tmp1_ = _tmp0_;
#line 7000 "DynamicNotebook.c"
	{
		GList* tab_collection = NULL;
		GList* tab_it = NULL;
#line 647 "../src/DynamicNotebook.vala"
		tab_collection = _tmp1_;
#line 647 "../src/DynamicNotebook.vala"
		for (tab_it = tab_collection; tab_it != NULL; tab_it = tab_it->next) {
#line 7008 "DynamicNotebook.c"
			Tab* _tmp2_;
			Tab* tab = NULL;
#line 647 "../src/DynamicNotebook.vala"
			_tmp2_ = _g_object_ref0 ((Tab*) tab_it->data);
#line 647 "../src/DynamicNotebook.vala"
			tab = _tmp2_;
#line 7015 "DynamicNotebook.c"
			{
				Tab* _tmp3_;
#line 648 "../src/DynamicNotebook.vala"
				_tmp3_ = tab;
#line 648 "../src/DynamicNotebook.vala"
				tab_set_pinnable (_tmp3_, value);
#line 647 "../src/DynamicNotebook.vala"
				_g_object_unref0 (tab);
#line 7024 "DynamicNotebook.c"
			}
		}
	}
#line 644 "../src/DynamicNotebook.vala"
	g_object_notify_by_pspec ((GObject *) self, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_ALLOW_PINNING_PROPERTY]);
#line 7030 "DynamicNotebook.c"
}


gboolean
dynamic_notebook_get_force_left (DynamicNotebook* self)
{
	gboolean result;
	gboolean _tmp0_;
#line 655 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, FALSE);
#line 655 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->_force_left;
#line 655 "../src/DynamicNotebook.vala"
	result = _tmp0_;
#line 655 "../src/DynamicNotebook.vala"
	return result;
#line 7047 "DynamicNotebook.c"
}


void
dynamic_notebook_set_force_left (DynamicNotebook* self,
                                 gboolean value)
{
#line 656 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 656 "../src/DynamicNotebook.vala"
	self->priv->_force_left = value;
#line 656 "../src/DynamicNotebook.vala"
	g_object_notify_by_pspec ((GObject *) self, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_FORCE_LEFT_PROPERTY]);
#line 7061 "DynamicNotebook.c"
}


const gchar*
dynamic_notebook_get_add_button_tooltip (DynamicNotebook* self)
{
	const gchar* result;
	GtkButton* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	const gchar* _tmp3_;
#line 663 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 663 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->add_button;
#line 663 "../src/DynamicNotebook.vala"
	_tmp1_ = gtk_widget_get_tooltip_text ((GtkWidget*) _tmp0_);
#line 663 "../src/DynamicNotebook.vala"
	_tmp2_ = _tmp1_;
#line 663 "../src/DynamicNotebook.vala"
	_g_free0 (self->priv->_add_button_tooltip);
#line 663 "../src/DynamicNotebook.vala"
	self->priv->_add_button_tooltip = _tmp2_;
#line 663 "../src/DynamicNotebook.vala"
	_tmp3_ = self->priv->_add_button_tooltip;
#line 663 "../src/DynamicNotebook.vala"
	result = _tmp3_;
#line 663 "../src/DynamicNotebook.vala"
	return result;
#line 7091 "DynamicNotebook.c"
}


void
dynamic_notebook_set_add_button_tooltip (DynamicNotebook* self,
                                         const gchar* value)
{
	GtkButton* _tmp0_;
#line 664 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 664 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->add_button;
#line 664 "../src/DynamicNotebook.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp0_, value);
#line 664 "../src/DynamicNotebook.vala"
	g_object_notify_by_pspec ((GObject *) self, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_ADD_BUTTON_TOOLTIP_PROPERTY]);
#line 7108 "DynamicNotebook.c"
}


Tab*
dynamic_notebook_get_current (DynamicNotebook* self)
{
	Tab* result;
	GList* _tmp0_;
	GList* _tmp1_;
	GtkNotebook* _tmp2_;
	gconstpointer _tmp3_;
#line 670 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 670 "../src/DynamicNotebook.vala"
	_tmp0_ = dynamic_notebook_get_tabs (self);
#line 670 "../src/DynamicNotebook.vala"
	_tmp1_ = _tmp0_;
#line 670 "../src/DynamicNotebook.vala"
	_tmp2_ = self->priv->notebook;
#line 670 "../src/DynamicNotebook.vala"
	_tmp3_ = g_list_nth_data (_tmp1_, (guint) gtk_notebook_get_current_page (_tmp2_));
#line 670 "../src/DynamicNotebook.vala"
	result = (Tab*) _tmp3_;
#line 670 "../src/DynamicNotebook.vala"
	return result;
#line 7134 "DynamicNotebook.c"
}


void
dynamic_notebook_set_current (DynamicNotebook* self,
                              Tab* value)
{
	GtkNotebook* _tmp0_;
	GList* _tmp1_;
	GList* _tmp2_;
#line 671 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 671 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->notebook;
#line 671 "../src/DynamicNotebook.vala"
	_tmp1_ = dynamic_notebook_get_tabs (self);
#line 671 "../src/DynamicNotebook.vala"
	_tmp2_ = _tmp1_;
#line 671 "../src/DynamicNotebook.vala"
	gtk_notebook_set_current_page (_tmp0_, g_list_index (_tmp2_, value));
#line 671 "../src/DynamicNotebook.vala"
	g_object_notify_by_pspec ((GObject *) self, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_CURRENT_PROPERTY]);
#line 7157 "DynamicNotebook.c"
}


GList*
dynamic_notebook_get_tabs (DynamicNotebook* self)
{
	GList* result;
	GList* _tmp11_;
#line 676 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 677 "../src/DynamicNotebook.vala"
	(self->priv->_tabs == NULL) ? NULL : (self->priv->_tabs = (_g_list_free__g_object_unref0_ (self->priv->_tabs), NULL));
#line 677 "../src/DynamicNotebook.vala"
	self->priv->_tabs = NULL;
#line 7172 "DynamicNotebook.c"
	{
		gint i = 0;
#line 678 "../src/DynamicNotebook.vala"
		i = 0;
#line 7177 "DynamicNotebook.c"
		{
			gboolean _tmp0_ = FALSE;
#line 678 "../src/DynamicNotebook.vala"
			_tmp0_ = TRUE;
#line 678 "../src/DynamicNotebook.vala"
			while (TRUE) {
#line 7184 "DynamicNotebook.c"
				gint _tmp2_;
				gint _tmp3_;
				gint _tmp4_;
				GtkNotebook* _tmp5_;
				GtkNotebook* _tmp6_;
				gint _tmp7_;
				GtkWidget* _tmp8_;
				GtkWidget* _tmp9_;
				Tab* _tmp10_;
#line 678 "../src/DynamicNotebook.vala"
				if (!_tmp0_) {
#line 7196 "DynamicNotebook.c"
					gint _tmp1_;
#line 678 "../src/DynamicNotebook.vala"
					_tmp1_ = i;
#line 678 "../src/DynamicNotebook.vala"
					i = _tmp1_ + 1;
#line 7202 "DynamicNotebook.c"
				}
#line 678 "../src/DynamicNotebook.vala"
				_tmp0_ = FALSE;
#line 678 "../src/DynamicNotebook.vala"
				_tmp2_ = i;
#line 678 "../src/DynamicNotebook.vala"
				_tmp3_ = dynamic_notebook_get_n_tabs (self);
#line 678 "../src/DynamicNotebook.vala"
				_tmp4_ = _tmp3_;
#line 678 "../src/DynamicNotebook.vala"
				if (!(_tmp2_ < _tmp4_)) {
#line 678 "../src/DynamicNotebook.vala"
					break;
#line 7216 "DynamicNotebook.c"
				}
#line 679 "../src/DynamicNotebook.vala"
				_tmp5_ = self->priv->notebook;
#line 679 "../src/DynamicNotebook.vala"
				_tmp6_ = self->priv->notebook;
#line 679 "../src/DynamicNotebook.vala"
				_tmp7_ = i;
#line 679 "../src/DynamicNotebook.vala"
				_tmp8_ = gtk_notebook_get_nth_page (_tmp6_, _tmp7_);
#line 679 "../src/DynamicNotebook.vala"
				_tmp9_ = gtk_notebook_get_tab_label (_tmp5_, _tmp8_);
#line 679 "../src/DynamicNotebook.vala"
				_tmp10_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_tmp9_, TYPE_TAB) ? ((Tab*) _tmp9_) : NULL);
#line 679 "../src/DynamicNotebook.vala"
				self->priv->_tabs = g_list_append (self->priv->_tabs, _tmp10_);
#line 7232 "DynamicNotebook.c"
			}
		}
	}
#line 681 "../src/DynamicNotebook.vala"
	_tmp11_ = self->priv->_tabs;
#line 681 "../src/DynamicNotebook.vala"
	result = _tmp11_;
#line 681 "../src/DynamicNotebook.vala"
	return result;
#line 7242 "DynamicNotebook.c"
}


const gchar*
dynamic_notebook_get_group_name (DynamicNotebook* self)
{
	const gchar* result;
	GtkNotebook* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
#line 686 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 686 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->notebook;
#line 686 "../src/DynamicNotebook.vala"
	_tmp1_ = gtk_notebook_get_group_name (_tmp0_);
#line 686 "../src/DynamicNotebook.vala"
	_tmp2_ = _tmp1_;
#line 686 "../src/DynamicNotebook.vala"
	result = _tmp2_;
#line 686 "../src/DynamicNotebook.vala"
	return result;
#line 7265 "DynamicNotebook.c"
}


void
dynamic_notebook_set_group_name (DynamicNotebook* self,
                                 const gchar* value)
{
	GtkNotebook* _tmp0_;
#line 687 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 687 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->notebook;
#line 687 "../src/DynamicNotebook.vala"
	gtk_notebook_set_group_name (_tmp0_, value);
#line 687 "../src/DynamicNotebook.vala"
	g_object_notify_by_pspec ((GObject *) self, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_GROUP_NAME_PROPERTY]);
#line 7282 "DynamicNotebook.c"
}


DynamicNotebookTabBarBehavior
dynamic_notebook_get_tab_bar_behavior (DynamicNotebook* self)
{
	DynamicNotebookTabBarBehavior result;
	DynamicNotebookTabBarBehavior _tmp0_;
#line 705 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 705 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->_tab_bar_behavior;
#line 705 "../src/DynamicNotebook.vala"
	result = _tmp0_;
#line 705 "../src/DynamicNotebook.vala"
	return result;
#line 7299 "DynamicNotebook.c"
}


void
dynamic_notebook_set_tab_bar_behavior (DynamicNotebook* self,
                                       DynamicNotebookTabBarBehavior value)
{
#line 700 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 701 "../src/DynamicNotebook.vala"
	self->priv->_tab_bar_behavior = value;
#line 702 "../src/DynamicNotebook.vala"
	dynamic_notebook_update_tabs_visibility (self);
#line 700 "../src/DynamicNotebook.vala"
	g_object_notify_by_pspec ((GObject *) self, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_TAB_BAR_BEHAVIOR_PROPERTY]);
#line 7315 "DynamicNotebook.c"
}


GtkMenu*
dynamic_notebook_get_menu (DynamicNotebook* self)
{
	GtkMenu* result;
	GtkMenu* _tmp0_;
#line 713 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 713 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->_menu;
#line 713 "../src/DynamicNotebook.vala"
	result = _tmp0_;
#line 713 "../src/DynamicNotebook.vala"
	return result;
#line 7332 "DynamicNotebook.c"
}


static void
dynamic_notebook_set_menu (DynamicNotebook* self,
                           GtkMenu* value)
{
#line 713 "../src/DynamicNotebook.vala"
	g_return_if_fail (self != NULL);
#line 713 "../src/DynamicNotebook.vala"
	if (dynamic_notebook_get_menu (self) != value) {
#line 7344 "DynamicNotebook.c"
		GtkMenu* _tmp0_;
#line 713 "../src/DynamicNotebook.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 713 "../src/DynamicNotebook.vala"
		_g_object_unref0 (self->priv->_menu);
#line 713 "../src/DynamicNotebook.vala"
		self->priv->_menu = _tmp0_;
#line 713 "../src/DynamicNotebook.vala"
		g_object_notify_by_pspec ((GObject *) self, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_MENU_PROPERTY]);
#line 7354 "DynamicNotebook.c"
	}
}


static void
g_cclosure_user_marshal_VOID__OBJECT_OBJECT (GClosure * closure,
                                             GValue * return_value,
                                             guint n_param_values,
                                             const GValue * param_values,
                                             gpointer invocation_hint,
                                             gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_OBJECT) (gpointer data1, gpointer arg_1, gpointer arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_OBJECT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 513 "../src/DynamicNotebook.vala"
	g_return_if_fail (n_param_values == 3);
#line 513 "../src/DynamicNotebook.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 513 "../src/DynamicNotebook.vala"
		data1 = closure->data;
#line 513 "../src/DynamicNotebook.vala"
		data2 = param_values->data[0].v_pointer;
#line 7381 "DynamicNotebook.c"
	} else {
#line 513 "../src/DynamicNotebook.vala"
		data1 = param_values->data[0].v_pointer;
#line 513 "../src/DynamicNotebook.vala"
		data2 = closure->data;
#line 7387 "DynamicNotebook.c"
	}
#line 513 "../src/DynamicNotebook.vala"
	callback = (GMarshalFunc_VOID__OBJECT_OBJECT) (marshal_data ? marshal_data : cc->callback);
#line 513 "../src/DynamicNotebook.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_object (param_values + 2), data2);
#line 7393 "DynamicNotebook.c"
}


static void
g_cclosure_user_marshal_VOID__OBJECT_INT (GClosure * closure,
                                          GValue * return_value,
                                          guint n_param_values,
                                          const GValue * param_values,
                                          gpointer invocation_hint,
                                          gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_INT) (gpointer data1, gpointer arg_1, gint arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_INT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 513 "../src/DynamicNotebook.vala"
	g_return_if_fail (n_param_values == 3);
#line 513 "../src/DynamicNotebook.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 513 "../src/DynamicNotebook.vala"
		data1 = closure->data;
#line 513 "../src/DynamicNotebook.vala"
		data2 = param_values->data[0].v_pointer;
#line 7419 "DynamicNotebook.c"
	} else {
#line 513 "../src/DynamicNotebook.vala"
		data1 = param_values->data[0].v_pointer;
#line 513 "../src/DynamicNotebook.vala"
		data2 = closure->data;
#line 7425 "DynamicNotebook.c"
	}
#line 513 "../src/DynamicNotebook.vala"
	callback = (GMarshalFunc_VOID__OBJECT_INT) (marshal_data ? marshal_data : cc->callback);
#line 513 "../src/DynamicNotebook.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_int (param_values + 2), data2);
#line 7431 "DynamicNotebook.c"
}


static void
g_cclosure_user_marshal_VOID__OBJECT_INT_INT (GClosure * closure,
                                              GValue * return_value,
                                              guint n_param_values,
                                              const GValue * param_values,
                                              gpointer invocation_hint,
                                              gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_INT_INT) (gpointer data1, gpointer arg_1, gint arg_2, gint arg_3, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_INT_INT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 513 "../src/DynamicNotebook.vala"
	g_return_if_fail (n_param_values == 4);
#line 513 "../src/DynamicNotebook.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 513 "../src/DynamicNotebook.vala"
		data1 = closure->data;
#line 513 "../src/DynamicNotebook.vala"
		data2 = param_values->data[0].v_pointer;
#line 7457 "DynamicNotebook.c"
	} else {
#line 513 "../src/DynamicNotebook.vala"
		data1 = param_values->data[0].v_pointer;
#line 513 "../src/DynamicNotebook.vala"
		data2 = closure->data;
#line 7463 "DynamicNotebook.c"
	}
#line 513 "../src/DynamicNotebook.vala"
	callback = (GMarshalFunc_VOID__OBJECT_INT_INT) (marshal_data ? marshal_data : cc->callback);
#line 513 "../src/DynamicNotebook.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_int (param_values + 2), g_value_get_int (param_values + 3), data2);
#line 7469 "DynamicNotebook.c"
}


static void
g_cclosure_user_marshal_BOOLEAN__OBJECT (GClosure * closure,
                                         GValue * return_value,
                                         guint n_param_values,
                                         const GValue * param_values,
                                         gpointer invocation_hint,
                                         gpointer marshal_data)
{
	typedef gboolean (*GMarshalFunc_BOOLEAN__OBJECT) (gpointer data1, gpointer arg_1, gpointer data2);
	register GMarshalFunc_BOOLEAN__OBJECT callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	gboolean v_return;
	cc = (GCClosure *) closure;
#line 513 "../src/DynamicNotebook.vala"
	g_return_if_fail (return_value != NULL);
#line 513 "../src/DynamicNotebook.vala"
	g_return_if_fail (n_param_values == 2);
#line 513 "../src/DynamicNotebook.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 513 "../src/DynamicNotebook.vala"
		data1 = closure->data;
#line 513 "../src/DynamicNotebook.vala"
		data2 = param_values->data[0].v_pointer;
#line 7498 "DynamicNotebook.c"
	} else {
#line 513 "../src/DynamicNotebook.vala"
		data1 = param_values->data[0].v_pointer;
#line 513 "../src/DynamicNotebook.vala"
		data2 = closure->data;
#line 7504 "DynamicNotebook.c"
	}
#line 513 "../src/DynamicNotebook.vala"
	callback = (GMarshalFunc_BOOLEAN__OBJECT) (marshal_data ? marshal_data : cc->callback);
#line 513 "../src/DynamicNotebook.vala"
	v_return = callback (data1, g_value_get_object (param_values + 1), data2);
#line 513 "../src/DynamicNotebook.vala"
	g_value_set_boolean (return_value, v_return);
#line 7512 "DynamicNotebook.c"
}


static gboolean
_dynamic_notebook___lambda22_ (DynamicNotebook* self,
                               cairo_t* ctx)
{
	gboolean result = FALSE;
	GtkStyleContext* _tmp0_;
#line 759 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (ctx != NULL, FALSE);
#line 760 "../src/DynamicNotebook.vala"
	_tmp0_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 760 "../src/DynamicNotebook.vala"
	gtk_render_activity (_tmp0_, ctx, (gdouble) 0, (gdouble) 0, (gdouble) gtk_widget_get_allocated_width ((GtkWidget*) self), (gdouble) 27);
#line 761 "../src/DynamicNotebook.vala"
	result = FALSE;
#line 761 "../src/DynamicNotebook.vala"
	return result;
#line 7532 "DynamicNotebook.c"
}


static gboolean
__dynamic_notebook___lambda22__gtk_widget_draw (GtkWidget* _sender,
                                                cairo_t* cr,
                                                gpointer self)
{
	gboolean result;
	result = _dynamic_notebook___lambda22_ ((DynamicNotebook*) self, cr);
#line 759 "../src/DynamicNotebook.vala"
	return result;
#line 7545 "DynamicNotebook.c"
}


static void
_dynamic_notebook___lambda23_ (DynamicNotebook* self)
{
#line 775 "../src/DynamicNotebook.vala"
	g_signal_emit (self, dynamic_notebook_signals[DYNAMIC_NOTEBOOK_NEW_TAB_REQUESTED_SIGNAL], 0);
#line 7554 "DynamicNotebook.c"
}


static void
__dynamic_notebook___lambda23__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                       gpointer self)
{
#line 774 "../src/DynamicNotebook.vala"
	_dynamic_notebook___lambda23_ ((DynamicNotebook*) self);
#line 7564 "DynamicNotebook.c"
}


static void
_dynamic_notebook___lambda24_ (DynamicNotebook* self)
{
#line 779 "../src/DynamicNotebook.vala"
	dynamic_notebook_restore_last_tab (self);
#line 7573 "DynamicNotebook.c"
}


static void
__dynamic_notebook___lambda24__gtk_menu_item_activate (GtkMenuItem* _sender,
                                                       gpointer self)
{
#line 778 "../src/DynamicNotebook.vala"
	_dynamic_notebook___lambda24_ ((DynamicNotebook*) self);
#line 7583 "DynamicNotebook.c"
}


static void
_dynamic_notebook___lambda25_ (DynamicNotebook* self,
                               const gchar* label,
                               const gchar* restore_data,
                               GIcon* icon)
{
	gboolean _tmp0_;
	gboolean _tmp1_;
	GtkButton* _tmp2_;
	ClosedTabs* _tmp3_;
	gboolean _tmp4_;
	gboolean _tmp5_;
	GtkMenuItem* _tmp6_;
	ClosedTabs* _tmp7_;
	gboolean _tmp8_;
	gboolean _tmp9_;
#line 783 "../src/DynamicNotebook.vala"
	g_return_if_fail (label != NULL);
#line 783 "../src/DynamicNotebook.vala"
	g_return_if_fail (restore_data != NULL);
#line 784 "../src/DynamicNotebook.vala"
	_tmp0_ = dynamic_notebook_get_allow_restoring (self);
#line 784 "../src/DynamicNotebook.vala"
	_tmp1_ = _tmp0_;
#line 784 "../src/DynamicNotebook.vala"
	if (!_tmp1_) {
#line 785 "../src/DynamicNotebook.vala"
		return;
#line 7615 "DynamicNotebook.c"
	}
#line 786 "../src/DynamicNotebook.vala"
	_tmp2_ = self->priv->restore_button;
#line 786 "../src/DynamicNotebook.vala"
	_tmp3_ = self->priv->closed_tabs;
#line 786 "../src/DynamicNotebook.vala"
	_tmp4_ = closed_tabs_get_empty (_tmp3_);
#line 786 "../src/DynamicNotebook.vala"
	_tmp5_ = _tmp4_;
#line 786 "../src/DynamicNotebook.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp2_, !_tmp5_);
#line 787 "../src/DynamicNotebook.vala"
	_tmp6_ = self->priv->restore_tab_m;
#line 787 "../src/DynamicNotebook.vala"
	_tmp7_ = self->priv->closed_tabs;
#line 787 "../src/DynamicNotebook.vala"
	_tmp8_ = closed_tabs_get_empty (_tmp7_);
#line 787 "../src/DynamicNotebook.vala"
	_tmp9_ = _tmp8_;
#line 787 "../src/DynamicNotebook.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp6_, !_tmp9_);
#line 788 "../src/DynamicNotebook.vala"
	g_signal_emit (self, dynamic_notebook_signals[DYNAMIC_NOTEBOOK_TAB_RESTORED_SIGNAL], 0, label, restore_data, icon);
#line 7639 "DynamicNotebook.c"
}


static void
__dynamic_notebook___lambda25__closed_tabs_restored (ClosedTabs* _sender,
                                                     const gchar* label,
                                                     const gchar* restore_data,
                                                     GIcon* icon,
                                                     gpointer self)
{
#line 783 "../src/DynamicNotebook.vala"
	_dynamic_notebook___lambda25_ ((DynamicNotebook*) self, label, restore_data, icon);
#line 7652 "DynamicNotebook.c"
}


static void
_dynamic_notebook___lambda26_ (DynamicNotebook* self)
{
	GtkButton* _tmp0_;
	GtkMenuItem* _tmp1_;
#line 792 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->restore_button;
#line 792 "../src/DynamicNotebook.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp0_, FALSE);
#line 793 "../src/DynamicNotebook.vala"
	_tmp1_ = self->priv->restore_tab_m;
#line 793 "../src/DynamicNotebook.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp1_, FALSE);
#line 7669 "DynamicNotebook.c"
}


static void
__dynamic_notebook___lambda26__closed_tabs_cleared (ClosedTabs* _sender,
                                                    gpointer self)
{
#line 791 "../src/DynamicNotebook.vala"
	_dynamic_notebook___lambda26_ ((DynamicNotebook*) self);
#line 7679 "DynamicNotebook.c"
}


static void
_dynamic_notebook___lambda27_ (DynamicNotebook* self)
{
#line 819 "../src/DynamicNotebook.vala"
	g_signal_emit (self, dynamic_notebook_signals[DYNAMIC_NOTEBOOK_NEW_TAB_REQUESTED_SIGNAL], 0);
#line 7688 "DynamicNotebook.c"
}


static void
__dynamic_notebook___lambda27__gtk_button_clicked (GtkButton* _sender,
                                                   gpointer self)
{
#line 818 "../src/DynamicNotebook.vala"
	_dynamic_notebook___lambda27_ ((DynamicNotebook*) self);
#line 7698 "DynamicNotebook.c"
}


static gboolean
_dynamic_notebook___lambda28_ (DynamicNotebook* self,
                               GdkEventButton* e)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	GdkEventType _tmp1_;
#line 822 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 824 "../src/DynamicNotebook.vala"
	_tmp1_ = e->type;
#line 824 "../src/DynamicNotebook.vala"
	if (_tmp1_ == GDK_2BUTTON_PRESS) {
#line 7715 "DynamicNotebook.c"
		guint _tmp2_;
#line 824 "../src/DynamicNotebook.vala"
		_tmp2_ = e->button;
#line 824 "../src/DynamicNotebook.vala"
		_tmp0_ = _tmp2_ == ((guint) 1);
#line 7721 "DynamicNotebook.c"
	} else {
#line 824 "../src/DynamicNotebook.vala"
		_tmp0_ = FALSE;
#line 7725 "DynamicNotebook.c"
	}
#line 824 "../src/DynamicNotebook.vala"
	result = _tmp0_;
#line 824 "../src/DynamicNotebook.vala"
	return result;
#line 7731 "DynamicNotebook.c"
}


static gboolean
__dynamic_notebook___lambda28__gtk_widget_button_press_event (GtkWidget* _sender,
                                                              GdkEventButton* event,
                                                              gpointer self)
{
	gboolean result;
	result = _dynamic_notebook___lambda28_ ((DynamicNotebook*) self, event);
#line 822 "../src/DynamicNotebook.vala"
	return result;
#line 7744 "DynamicNotebook.c"
}


static void
_dynamic_notebook___lambda29_ (DynamicNotebook* self)
{
	GtkMenu* menu = NULL;
	ClosedTabs* _tmp0_;
	GtkMenu* _tmp1_;
	GtkMenu* _tmp2_;
	GtkMenu* _tmp3_;
	GtkButton* _tmp4_;
	GtkMenu* _tmp5_;
	GtkMenu* _tmp6_;
	GtkButton* _tmp7_;
#line 828 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->closed_tabs;
#line 828 "../src/DynamicNotebook.vala"
	_tmp1_ = closed_tabs_get_menu (_tmp0_);
#line 828 "../src/DynamicNotebook.vala"
	_tmp2_ = _tmp1_;
#line 828 "../src/DynamicNotebook.vala"
	menu = _tmp2_;
#line 829 "../src/DynamicNotebook.vala"
	_tmp3_ = menu;
#line 829 "../src/DynamicNotebook.vala"
	_tmp4_ = self->priv->restore_button;
#line 829 "../src/DynamicNotebook.vala"
	g_object_set (_tmp3_, "attach-widget", (GtkWidget*) _tmp4_, NULL);
#line 830 "../src/DynamicNotebook.vala"
	_tmp5_ = menu;
#line 830 "../src/DynamicNotebook.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp5_);
#line 831 "../src/DynamicNotebook.vala"
	_tmp6_ = menu;
#line 831 "../src/DynamicNotebook.vala"
	_tmp7_ = self->priv->restore_button;
#line 831 "../src/DynamicNotebook.vala"
	gtk_menu_popup_at_widget (_tmp6_, (GtkWidget*) _tmp7_, GDK_GRAVITY_SOUTH_EAST, GDK_GRAVITY_NORTH_EAST, NULL);
#line 827 "../src/DynamicNotebook.vala"
	_g_object_unref0 (menu);
#line 7786 "DynamicNotebook.c"
}


static void
__dynamic_notebook___lambda29__gtk_button_clicked (GtkButton* _sender,
                                                   gpointer self)
{
#line 827 "../src/DynamicNotebook.vala"
	_dynamic_notebook___lambda29_ ((DynamicNotebook*) self);
#line 7796 "DynamicNotebook.c"
}


static void
_dynamic_notebook___lambda30_ (DynamicNotebook* self)
{
#line 838 "../src/DynamicNotebook.vala"
	dynamic_notebook_recalc_size (self);
#line 7805 "DynamicNotebook.c"
}


static void
__dynamic_notebook___lambda30__gtk_widget_size_allocate (GtkWidget* _sender,
                                                         GtkAllocation* allocation,
                                                         gpointer self)
{
#line 837 "../src/DynamicNotebook.vala"
	_dynamic_notebook___lambda30_ ((DynamicNotebook*) self);
#line 7816 "DynamicNotebook.c"
}


static gboolean
_dynamic_notebook___lambda31_ (DynamicNotebook* self,
                               GdkEventButton* e)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	GdkEventType _tmp1_;
#line 841 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 842 "../src/DynamicNotebook.vala"
	_tmp1_ = e->type;
#line 842 "../src/DynamicNotebook.vala"
	if (_tmp1_ == GDK_2BUTTON_PRESS) {
#line 7833 "DynamicNotebook.c"
		guint _tmp2_;
#line 842 "../src/DynamicNotebook.vala"
		_tmp2_ = e->button;
#line 842 "../src/DynamicNotebook.vala"
		_tmp0_ = _tmp2_ == ((guint) 1);
#line 7839 "DynamicNotebook.c"
	} else {
#line 842 "../src/DynamicNotebook.vala"
		_tmp0_ = FALSE;
#line 7843 "DynamicNotebook.c"
	}
#line 842 "../src/DynamicNotebook.vala"
	if (_tmp0_) {
#line 843 "../src/DynamicNotebook.vala"
		g_signal_emit (self, dynamic_notebook_signals[DYNAMIC_NOTEBOOK_NEW_TAB_REQUESTED_SIGNAL], 0);
#line 7849 "DynamicNotebook.c"
	} else {
		gboolean _tmp3_ = FALSE;
		guint _tmp4_;
#line 844 "../src/DynamicNotebook.vala"
		_tmp4_ = e->button;
#line 844 "../src/DynamicNotebook.vala"
		if (_tmp4_ == ((guint) 2)) {
#line 7857 "DynamicNotebook.c"
			gboolean _tmp5_;
			gboolean _tmp6_;
#line 844 "../src/DynamicNotebook.vala"
			_tmp5_ = dynamic_notebook_get_allow_restoring (self);
#line 844 "../src/DynamicNotebook.vala"
			_tmp6_ = _tmp5_;
#line 844 "../src/DynamicNotebook.vala"
			_tmp3_ = _tmp6_;
#line 7866 "DynamicNotebook.c"
		} else {
#line 844 "../src/DynamicNotebook.vala"
			_tmp3_ = FALSE;
#line 7870 "DynamicNotebook.c"
		}
#line 844 "../src/DynamicNotebook.vala"
		if (_tmp3_) {
#line 845 "../src/DynamicNotebook.vala"
			dynamic_notebook_restore_last_tab (self);
#line 846 "../src/DynamicNotebook.vala"
			result = TRUE;
#line 846 "../src/DynamicNotebook.vala"
			return result;
#line 7880 "DynamicNotebook.c"
		} else {
			gboolean _tmp7_ = FALSE;
			guint _tmp8_;
#line 847 "../src/DynamicNotebook.vala"
			_tmp8_ = e->button;
#line 847 "../src/DynamicNotebook.vala"
			if (_tmp8_ == ((guint) 3)) {
#line 7888 "DynamicNotebook.c"
				gboolean _tmp9_ = FALSE;
				gboolean _tmp10_;
				gboolean _tmp11_;
#line 847 "../src/DynamicNotebook.vala"
				_tmp10_ = dynamic_notebook_get_allow_restoring (self);
#line 847 "../src/DynamicNotebook.vala"
				_tmp11_ = _tmp10_;
#line 847 "../src/DynamicNotebook.vala"
				if (_tmp11_) {
#line 847 "../src/DynamicNotebook.vala"
					_tmp9_ = TRUE;
#line 7900 "DynamicNotebook.c"
				} else {
					gboolean _tmp12_;
					gboolean _tmp13_;
#line 847 "../src/DynamicNotebook.vala"
					_tmp12_ = dynamic_notebook_get_add_button_visible (self);
#line 847 "../src/DynamicNotebook.vala"
					_tmp13_ = _tmp12_;
#line 847 "../src/DynamicNotebook.vala"
					_tmp9_ = _tmp13_;
#line 7910 "DynamicNotebook.c"
				}
#line 847 "../src/DynamicNotebook.vala"
				_tmp7_ = _tmp9_;
#line 7914 "DynamicNotebook.c"
			} else {
#line 847 "../src/DynamicNotebook.vala"
				_tmp7_ = FALSE;
#line 7918 "DynamicNotebook.c"
			}
#line 847 "../src/DynamicNotebook.vala"
			if (_tmp7_) {
#line 7922 "DynamicNotebook.c"
				GtkMenu* _tmp14_;
#line 848 "../src/DynamicNotebook.vala"
				_tmp14_ = self->priv->_menu;
#line 848 "../src/DynamicNotebook.vala"
				gtk_menu_popup_at_pointer (_tmp14_, (GdkEvent*) e);
#line 7928 "DynamicNotebook.c"
			}
		}
	}
#line 851 "../src/DynamicNotebook.vala"
	result = FALSE;
#line 851 "../src/DynamicNotebook.vala"
	return result;
#line 7936 "DynamicNotebook.c"
}


static gboolean
__dynamic_notebook___lambda31__gtk_widget_button_press_event (GtkWidget* _sender,
                                                              GdkEventButton* event,
                                                              gpointer self)
{
	gboolean result;
	result = _dynamic_notebook___lambda31_ ((DynamicNotebook*) self, event);
#line 841 "../src/DynamicNotebook.vala"
	return result;
#line 7949 "DynamicNotebook.c"
}


static gboolean
_dynamic_notebook___lambda32_ (DynamicNotebook* self,
                               GdkEventKey* e)
{
	gboolean result = FALSE;
	GdkModifierType _tmp0_;
	guint _tmp1_;
#line 854 "../src/DynamicNotebook.vala"
	g_return_val_if_fail (e != NULL, FALSE);
#line 855 "../src/DynamicNotebook.vala"
	_tmp0_ = e->state;
#line 855 "../src/DynamicNotebook.vala"
	e->state = _tmp0_ & MODIFIER_MASK;
#line 857 "../src/DynamicNotebook.vala"
	_tmp1_ = e->keyval;
#line 857 "../src/DynamicNotebook.vala"
	switch (_tmp1_) {
#line 857 "../src/DynamicNotebook.vala"
		case GDK_KEY_w:
#line 857 "../src/DynamicNotebook.vala"
		case GDK_KEY_W:
#line 7974 "DynamicNotebook.c"
		{
			GdkModifierType _tmp2_;
#line 860 "../src/DynamicNotebook.vala"
			_tmp2_ = e->state;
#line 860 "../src/DynamicNotebook.vala"
			if (_tmp2_ == GDK_CONTROL_MASK) {
#line 7981 "DynamicNotebook.c"
				gboolean _tmp3_;
				gboolean _tmp4_;
				Tab* _tmp5_;
				Tab* _tmp6_;
#line 861 "../src/DynamicNotebook.vala"
				_tmp3_ = dynamic_notebook_get_tabs_closable (self);
#line 861 "../src/DynamicNotebook.vala"
				_tmp4_ = _tmp3_;
#line 861 "../src/DynamicNotebook.vala"
				if (!_tmp4_) {
#line 862 "../src/DynamicNotebook.vala"
					break;
#line 7994 "DynamicNotebook.c"
				}
#line 865 "../src/DynamicNotebook.vala"
				_tmp5_ = dynamic_notebook_get_current (self);
#line 865 "../src/DynamicNotebook.vala"
				_tmp6_ = _tmp5_;
#line 865 "../src/DynamicNotebook.vala"
				tab_close (_tmp6_);
#line 866 "../src/DynamicNotebook.vala"
				result = TRUE;
#line 866 "../src/DynamicNotebook.vala"
				return result;
#line 8006 "DynamicNotebook.c"
			}
#line 869 "../src/DynamicNotebook.vala"
			break;
#line 8010 "DynamicNotebook.c"
		}
#line 857 "../src/DynamicNotebook.vala"
		case GDK_KEY_t:
#line 857 "../src/DynamicNotebook.vala"
		case GDK_KEY_T:
#line 8016 "DynamicNotebook.c"
		{
			GdkModifierType _tmp7_;
#line 873 "../src/DynamicNotebook.vala"
			_tmp7_ = e->state;
#line 873 "../src/DynamicNotebook.vala"
			if (_tmp7_ == GDK_CONTROL_MASK) {
#line 874 "../src/DynamicNotebook.vala"
				g_signal_emit (self, dynamic_notebook_signals[DYNAMIC_NOTEBOOK_NEW_TAB_REQUESTED_SIGNAL], 0);
#line 875 "../src/DynamicNotebook.vala"
				result = TRUE;
#line 875 "../src/DynamicNotebook.vala"
				return result;
#line 8029 "DynamicNotebook.c"
			} else {
				gboolean _tmp8_ = FALSE;
				GdkModifierType _tmp9_;
#line 876 "../src/DynamicNotebook.vala"
				_tmp9_ = e->state;
#line 876 "../src/DynamicNotebook.vala"
				if (_tmp9_ == (GDK_CONTROL_MASK | GDK_SHIFT_MASK)) {
#line 8037 "DynamicNotebook.c"
					gboolean _tmp10_;
					gboolean _tmp11_;
#line 876 "../src/DynamicNotebook.vala"
					_tmp10_ = dynamic_notebook_get_allow_restoring (self);
#line 876 "../src/DynamicNotebook.vala"
					_tmp11_ = _tmp10_;
#line 876 "../src/DynamicNotebook.vala"
					_tmp8_ = _tmp11_;
#line 8046 "DynamicNotebook.c"
				} else {
#line 876 "../src/DynamicNotebook.vala"
					_tmp8_ = FALSE;
#line 8050 "DynamicNotebook.c"
				}
#line 876 "../src/DynamicNotebook.vala"
				if (_tmp8_) {
#line 877 "../src/DynamicNotebook.vala"
					dynamic_notebook_restore_last_tab (self);
#line 878 "../src/DynamicNotebook.vala"
					result = TRUE;
#line 878 "../src/DynamicNotebook.vala"
					return result;
#line 8060 "DynamicNotebook.c"
				}
			}
#line 881 "../src/DynamicNotebook.vala"
			break;
#line 8065 "DynamicNotebook.c"
		}
#line 857 "../src/DynamicNotebook.vala"
		case GDK_KEY_Page_Up:
#line 8069 "DynamicNotebook.c"
		{
			GdkModifierType _tmp12_;
#line 884 "../src/DynamicNotebook.vala"
			_tmp12_ = e->state;
#line 884 "../src/DynamicNotebook.vala"
			if (_tmp12_ == GDK_CONTROL_MASK) {
#line 885 "../src/DynamicNotebook.vala"
				dynamic_notebook_next_page (self);
#line 886 "../src/DynamicNotebook.vala"
				result = TRUE;
#line 886 "../src/DynamicNotebook.vala"
				return result;
#line 8082 "DynamicNotebook.c"
			}
#line 889 "../src/DynamicNotebook.vala"
			break;
#line 8086 "DynamicNotebook.c"
		}
#line 857 "../src/DynamicNotebook.vala"
		case GDK_KEY_Page_Down:
#line 8090 "DynamicNotebook.c"
		{
			GdkModifierType _tmp13_;
#line 892 "../src/DynamicNotebook.vala"
			_tmp13_ = e->state;
#line 892 "../src/DynamicNotebook.vala"
			if (_tmp13_ == GDK_CONTROL_MASK) {
#line 893 "../src/DynamicNotebook.vala"
				dynamic_notebook_previous_page (self);
#line 894 "../src/DynamicNotebook.vala"
				result = TRUE;
#line 894 "../src/DynamicNotebook.vala"
				return result;
#line 8103 "DynamicNotebook.c"
			}
#line 897 "../src/DynamicNotebook.vala"
			break;
#line 8107 "DynamicNotebook.c"
		}
#line 857 "../src/DynamicNotebook.vala"
		case GDK_KEY_1:
#line 857 "../src/DynamicNotebook.vala"
		case GDK_KEY_2:
#line 857 "../src/DynamicNotebook.vala"
		case GDK_KEY_3:
#line 857 "../src/DynamicNotebook.vala"
		case GDK_KEY_4:
#line 857 "../src/DynamicNotebook.vala"
		case GDK_KEY_5:
#line 857 "../src/DynamicNotebook.vala"
		case GDK_KEY_6:
#line 857 "../src/DynamicNotebook.vala"
		case GDK_KEY_7:
#line 857 "../src/DynamicNotebook.vala"
		case GDK_KEY_8:
#line 8125 "DynamicNotebook.c"
		{
			GdkModifierType _tmp14_;
#line 907 "../src/DynamicNotebook.vala"
			_tmp14_ = e->state;
#line 907 "../src/DynamicNotebook.vala"
			if ((_tmp14_ & GDK_MOD1_MASK) == GDK_MOD1_MASK) {
#line 8132 "DynamicNotebook.c"
				guint i = 0U;
				guint _tmp15_;
				gint n_pages = 0;
				GtkNotebook* _tmp16_;
				guint _tmp17_ = 0U;
				guint _tmp18_;
				gint _tmp19_;
				GtkNotebook* _tmp22_;
#line 908 "../src/DynamicNotebook.vala"
				_tmp15_ = e->keyval;
#line 908 "../src/DynamicNotebook.vala"
				i = _tmp15_ - 49;
#line 909 "../src/DynamicNotebook.vala"
				_tmp16_ = self->priv->notebook;
#line 909 "../src/DynamicNotebook.vala"
				n_pages = gtk_notebook_get_n_pages (_tmp16_);
#line 910 "../src/DynamicNotebook.vala"
				_tmp18_ = i;
#line 910 "../src/DynamicNotebook.vala"
				_tmp19_ = n_pages;
#line 910 "../src/DynamicNotebook.vala"
				if (_tmp18_ >= ((guint) _tmp19_)) {
#line 8155 "DynamicNotebook.c"
					gint _tmp20_;
#line 910 "../src/DynamicNotebook.vala"
					_tmp20_ = n_pages;
#line 910 "../src/DynamicNotebook.vala"
					_tmp17_ = (guint) (_tmp20_ - 1);
#line 8161 "DynamicNotebook.c"
				} else {
					guint _tmp21_;
#line 910 "../src/DynamicNotebook.vala"
					_tmp21_ = i;
#line 910 "../src/DynamicNotebook.vala"
					_tmp17_ = _tmp21_;
#line 8168 "DynamicNotebook.c"
				}
#line 910 "../src/DynamicNotebook.vala"
				_tmp22_ = self->priv->notebook;
#line 910 "../src/DynamicNotebook.vala"
				g_object_set (_tmp22_, "page", (gint) _tmp17_, NULL);
#line 911 "../src/DynamicNotebook.vala"
				result = TRUE;
#line 911 "../src/DynamicNotebook.vala"
				return result;
#line 8178 "DynamicNotebook.c"
			}
#line 914 "../src/DynamicNotebook.vala"
			break;
#line 8182 "DynamicNotebook.c"
		}
#line 857 "../src/DynamicNotebook.vala"
		case GDK_KEY_9:
#line 8186 "DynamicNotebook.c"
		{
			GdkModifierType _tmp23_;
#line 917 "../src/DynamicNotebook.vala"
			_tmp23_ = e->state;
#line 917 "../src/DynamicNotebook.vala"
			if ((_tmp23_ & GDK_MOD1_MASK) == GDK_MOD1_MASK) {
#line 8193 "DynamicNotebook.c"
				GtkNotebook* _tmp24_;
				GtkNotebook* _tmp25_;
#line 918 "../src/DynamicNotebook.vala"
				_tmp24_ = self->priv->notebook;
#line 918 "../src/DynamicNotebook.vala"
				_tmp25_ = self->priv->notebook;
#line 918 "../src/DynamicNotebook.vala"
				g_object_set (_tmp24_, "page", gtk_notebook_get_n_pages (_tmp25_) - 1, NULL);
#line 919 "../src/DynamicNotebook.vala"
				result = TRUE;
#line 919 "../src/DynamicNotebook.vala"
				return result;
#line 8206 "DynamicNotebook.c"
			}
#line 922 "../src/DynamicNotebook.vala"
			break;
#line 8210 "DynamicNotebook.c"
		}
		default:
#line 857 "../src/DynamicNotebook.vala"
		break;
#line 8215 "DynamicNotebook.c"
	}
#line 925 "../src/DynamicNotebook.vala"
	result = FALSE;
#line 925 "../src/DynamicNotebook.vala"
	return result;
#line 8221 "DynamicNotebook.c"
}


static gboolean
__dynamic_notebook___lambda32__gtk_widget_key_press_event (GtkWidget* _sender,
                                                           GdkEventKey* event,
                                                           gpointer self)
{
	gboolean result;
	result = _dynamic_notebook___lambda32_ ((DynamicNotebook*) self, event);
#line 854 "../src/DynamicNotebook.vala"
	return result;
#line 8234 "DynamicNotebook.c"
}


static void
_dynamic_notebook_on_switch_page_gtk_notebook_switch_page (GtkNotebook* _sender,
                                                           GtkWidget* page,
                                                           guint page_num,
                                                           gpointer self)
{
#line 929 "../src/DynamicNotebook.vala"
	dynamic_notebook_on_switch_page ((DynamicNotebook*) self, page, page_num);
#line 8246 "DynamicNotebook.c"
}


static void
_dynamic_notebook_on_page_added_gtk_notebook_page_added (GtkNotebook* _sender,
                                                         GtkWidget* child,
                                                         guint page_num,
                                                         gpointer self)
{
#line 930 "../src/DynamicNotebook.vala"
	dynamic_notebook_on_page_added ((DynamicNotebook*) self, child, page_num);
#line 8258 "DynamicNotebook.c"
}


static void
_dynamic_notebook_on_page_removed_gtk_notebook_page_removed (GtkNotebook* _sender,
                                                             GtkWidget* child,
                                                             guint page_num,
                                                             gpointer self)
{
#line 931 "../src/DynamicNotebook.vala"
	dynamic_notebook_on_page_removed ((DynamicNotebook*) self, child, page_num);
#line 8270 "DynamicNotebook.c"
}


static void
_dynamic_notebook_on_page_reordered_gtk_notebook_page_reordered (GtkNotebook* _sender,
                                                                 GtkWidget* child,
                                                                 guint page_num,
                                                                 gpointer self)
{
#line 932 "../src/DynamicNotebook.vala"
	dynamic_notebook_on_page_reordered ((DynamicNotebook*) self, child, page_num);
#line 8282 "DynamicNotebook.c"
}


static GtkNotebook*
_dynamic_notebook_on_create_window_gtk_notebook_create_window (GtkNotebook* _sender,
                                                               GtkWidget* page,
                                                               gint x,
                                                               gint y,
                                                               gpointer self)
{
	GtkNotebook* result;
	result = dynamic_notebook_on_create_window ((DynamicNotebook*) self, page, x, y);
#line 933 "../src/DynamicNotebook.vala"
	return result;
#line 8297 "DynamicNotebook.c"
}


static void
_dynamic_notebook___lambda33_ (DynamicNotebook* self)
{
	GtkNotebook* _tmp0_;
	guint _tmp1_;
	GtkNotebook* _tmp2_;
	guint _tmp3_;
	GtkNotebook* _tmp4_;
	guint _tmp5_;
	GtkNotebook* _tmp6_;
	guint _tmp7_;
	GtkNotebook* _tmp8_;
	guint _tmp9_;
#line 929 "../src/DynamicNotebook.vala"
	_tmp0_ = self->priv->notebook;
#line 929 "../src/DynamicNotebook.vala"
	g_signal_parse_name ("switch-page", gtk_notebook_get_type (), &_tmp1_, NULL, FALSE);
#line 929 "../src/DynamicNotebook.vala"
	g_signal_handlers_disconnect_matched (_tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _dynamic_notebook_on_switch_page_gtk_notebook_switch_page, self);
#line 930 "../src/DynamicNotebook.vala"
	_tmp2_ = self->priv->notebook;
#line 930 "../src/DynamicNotebook.vala"
	g_signal_parse_name ("page-added", gtk_notebook_get_type (), &_tmp3_, NULL, FALSE);
#line 930 "../src/DynamicNotebook.vala"
	g_signal_handlers_disconnect_matched (_tmp2_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp3_, 0, NULL, (GCallback) _dynamic_notebook_on_page_added_gtk_notebook_page_added, self);
#line 931 "../src/DynamicNotebook.vala"
	_tmp4_ = self->priv->notebook;
#line 931 "../src/DynamicNotebook.vala"
	g_signal_parse_name ("page-removed", gtk_notebook_get_type (), &_tmp5_, NULL, FALSE);
#line 931 "../src/DynamicNotebook.vala"
	g_signal_handlers_disconnect_matched (_tmp4_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp5_, 0, NULL, (GCallback) _dynamic_notebook_on_page_removed_gtk_notebook_page_removed, self);
#line 932 "../src/DynamicNotebook.vala"
	_tmp6_ = self->priv->notebook;
#line 932 "../src/DynamicNotebook.vala"
	g_signal_parse_name ("page-reordered", gtk_notebook_get_type (), &_tmp7_, NULL, FALSE);
#line 932 "../src/DynamicNotebook.vala"
	g_signal_handlers_disconnect_matched (_tmp6_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp7_, 0, NULL, (GCallback) _dynamic_notebook_on_page_reordered_gtk_notebook_page_reordered, self);
#line 933 "../src/DynamicNotebook.vala"
	_tmp8_ = self->priv->notebook;
#line 933 "../src/DynamicNotebook.vala"
	g_signal_parse_name ("create-window", gtk_notebook_get_type (), &_tmp9_, NULL, FALSE);
#line 933 "../src/DynamicNotebook.vala"
	g_signal_handlers_disconnect_matched (_tmp8_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp9_, 0, NULL, (GCallback) _dynamic_notebook_on_create_window_gtk_notebook_create_window, self);
#line 8344 "DynamicNotebook.c"
}


static void
__dynamic_notebook___lambda33__gtk_widget_destroy (GtkWidget* _sender,
                                                   gpointer self)
{
#line 928 "../src/DynamicNotebook.vala"
	_dynamic_notebook___lambda33_ ((DynamicNotebook*) self);
#line 8354 "DynamicNotebook.c"
}


static GObject *
dynamic_notebook_constructor (GType type,
                              guint n_construct_properties,
                              GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	DynamicNotebook * self;
	GtkNotebook* _tmp0_;
	GtkNotebook* _tmp1_;
	GtkStyleContext* _tmp2_;
	GtkNotebook* _tmp3_;
	GtkNotebook* _tmp4_;
	GtkNotebook* _tmp5_;
	GtkMenu* _tmp6_;
	GtkMenu* _tmp7_;
	GtkMenuItem* _tmp8_;
	GtkMenuItem* _tmp9_;
	GtkMenuItem* _tmp10_;
	GtkMenu* _tmp11_;
	GtkMenuItem* _tmp12_;
	GtkMenu* _tmp13_;
	GtkMenuItem* _tmp14_;
	GtkMenu* _tmp15_;
	GtkMenuItem* _tmp16_;
	GtkMenuItem* _tmp17_;
	ClosedTabs* _tmp18_;
	ClosedTabs* _tmp19_;
	ClosedTabs* _tmp20_;
	GtkButton* _tmp21_;
	GtkButton* _tmp22_;
	GtkButton* _tmp23_;
	GtkButton* _tmp24_;
	GtkButton* _tmp25_;
	GtkButton* _tmp26_;
	GtkButton* _tmp27_;
	GtkButton* _tmp28_;
	GtkButton* _tmp29_;
	GtkNotebook* _tmp30_;
	GtkButton* _tmp31_;
	GtkNotebook* _tmp32_;
	GtkButton* _tmp33_;
	GtkButton* _tmp34_;
	GtkButton* _tmp35_;
	GtkButton* _tmp36_;
	GtkMenuItem* _tmp37_;
	gboolean _tmp38_;
	gboolean _tmp39_;
	GtkButton* _tmp40_;
	gboolean _tmp41_;
	gboolean _tmp42_;
	GtkNotebook* _tmp43_;
	GtkNotebook* _tmp44_;
	GtkNotebook* _tmp45_;
	GtkNotebook* _tmp46_;
	GtkNotebook* _tmp47_;
#line 749 "../src/DynamicNotebook.vala"
	parent_class = G_OBJECT_CLASS (dynamic_notebook_parent_class);
#line 749 "../src/DynamicNotebook.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 749 "../src/DynamicNotebook.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_DYNAMIC_NOTEBOOK, DynamicNotebook);
#line 750 "../src/DynamicNotebook.vala"
	_tmp0_ = (GtkNotebook*) gtk_notebook_new ();
#line 750 "../src/DynamicNotebook.vala"
	g_object_ref_sink (_tmp0_);
#line 750 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->priv->notebook);
#line 750 "../src/DynamicNotebook.vala"
	self->priv->notebook = _tmp0_;
#line 751 "../src/DynamicNotebook.vala"
	_tmp1_ = self->priv->notebook;
#line 751 "../src/DynamicNotebook.vala"
	gtk_widget_set_can_focus ((GtkWidget*) _tmp1_, FALSE);
#line 752 "../src/DynamicNotebook.vala"
	gtk_event_box_set_visible_window ((GtkEventBox*) self, FALSE);
#line 753 "../src/DynamicNotebook.vala"
	_tmp2_ = gtk_widget_get_style_context ((GtkWidget*) self);
#line 753 "../src/DynamicNotebook.vala"
	gtk_style_context_add_class (_tmp2_, "dynamic-notebook");
#line 755 "../src/DynamicNotebook.vala"
	_tmp3_ = self->priv->notebook;
#line 755 "../src/DynamicNotebook.vala"
	gtk_notebook_set_scrollable (_tmp3_, TRUE);
#line 756 "../src/DynamicNotebook.vala"
	_tmp4_ = self->priv->notebook;
#line 756 "../src/DynamicNotebook.vala"
	gtk_notebook_set_show_border (_tmp4_, FALSE);
#line 757 "../src/DynamicNotebook.vala"
	self->priv->_tab_bar_behavior = DYNAMIC_NOTEBOOK_TAB_BAR_BEHAVIOR_ALWAYS;
#line 759 "../src/DynamicNotebook.vala"
	g_signal_connect_object ((GtkWidget*) self, "draw", (GCallback) __dynamic_notebook___lambda22__gtk_widget_draw, self, 0);
#line 764 "../src/DynamicNotebook.vala"
	_tmp5_ = self->priv->notebook;
#line 764 "../src/DynamicNotebook.vala"
	gtk_container_add ((GtkContainer*) self, (GtkWidget*) _tmp5_);
#line 766 "../src/DynamicNotebook.vala"
	_tmp6_ = (GtkMenu*) gtk_menu_new ();
#line 766 "../src/DynamicNotebook.vala"
	g_object_ref_sink (_tmp6_);
#line 766 "../src/DynamicNotebook.vala"
	_tmp7_ = _tmp6_;
#line 766 "../src/DynamicNotebook.vala"
	dynamic_notebook_set_menu (self, _tmp7_);
#line 766 "../src/DynamicNotebook.vala"
	_g_object_unref0 (_tmp7_);
#line 767 "../src/DynamicNotebook.vala"
	_tmp8_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("New Tab"));
#line 767 "../src/DynamicNotebook.vala"
	g_object_ref_sink (_tmp8_);
#line 767 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->priv->new_tab_m);
#line 767 "../src/DynamicNotebook.vala"
	self->priv->new_tab_m = _tmp8_;
#line 768 "../src/DynamicNotebook.vala"
	_tmp9_ = (GtkMenuItem*) gtk_menu_item_new_with_label (_ ("Undo Close Tab"));
#line 768 "../src/DynamicNotebook.vala"
	g_object_ref_sink (_tmp9_);
#line 768 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->priv->restore_tab_m);
#line 768 "../src/DynamicNotebook.vala"
	self->priv->restore_tab_m = _tmp9_;
#line 769 "../src/DynamicNotebook.vala"
	_tmp10_ = self->priv->restore_tab_m;
#line 769 "../src/DynamicNotebook.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp10_, FALSE);
#line 770 "../src/DynamicNotebook.vala"
	_tmp11_ = self->priv->_menu;
#line 770 "../src/DynamicNotebook.vala"
	_tmp12_ = self->priv->new_tab_m;
#line 770 "../src/DynamicNotebook.vala"
	gtk_menu_shell_append ((GtkMenuShell*) _tmp11_, _tmp12_);
#line 771 "../src/DynamicNotebook.vala"
	_tmp13_ = self->priv->_menu;
#line 771 "../src/DynamicNotebook.vala"
	_tmp14_ = self->priv->restore_tab_m;
#line 771 "../src/DynamicNotebook.vala"
	gtk_menu_shell_append ((GtkMenuShell*) _tmp13_, _tmp14_);
#line 772 "../src/DynamicNotebook.vala"
	_tmp15_ = self->priv->_menu;
#line 772 "../src/DynamicNotebook.vala"
	gtk_widget_show_all ((GtkWidget*) _tmp15_);
#line 774 "../src/DynamicNotebook.vala"
	_tmp16_ = self->priv->new_tab_m;
#line 774 "../src/DynamicNotebook.vala"
	g_signal_connect_object (_tmp16_, "activate", (GCallback) __dynamic_notebook___lambda23__gtk_menu_item_activate, self, 0);
#line 778 "../src/DynamicNotebook.vala"
	_tmp17_ = self->priv->restore_tab_m;
#line 778 "../src/DynamicNotebook.vala"
	g_signal_connect_object (_tmp17_, "activate", (GCallback) __dynamic_notebook___lambda24__gtk_menu_item_activate, self, 0);
#line 782 "../src/DynamicNotebook.vala"
	_tmp18_ = closed_tabs_new ();
#line 782 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->priv->closed_tabs);
#line 782 "../src/DynamicNotebook.vala"
	self->priv->closed_tabs = _tmp18_;
#line 783 "../src/DynamicNotebook.vala"
	_tmp19_ = self->priv->closed_tabs;
#line 783 "../src/DynamicNotebook.vala"
	g_signal_connect_object (_tmp19_, "restored", (GCallback) __dynamic_notebook___lambda25__closed_tabs_restored, self, 0);
#line 791 "../src/DynamicNotebook.vala"
	_tmp20_ = self->priv->closed_tabs;
#line 791 "../src/DynamicNotebook.vala"
	g_signal_connect_object (_tmp20_, "cleared", (GCallback) __dynamic_notebook___lambda26__closed_tabs_cleared, self, 0);
#line 796 "../src/DynamicNotebook.vala"
	_tmp21_ = (GtkButton*) gtk_button_new_from_icon_name ("list-add-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 796 "../src/DynamicNotebook.vala"
	g_object_ref_sink (_tmp21_);
#line 796 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->priv->add_button);
#line 796 "../src/DynamicNotebook.vala"
	self->priv->add_button = _tmp21_;
#line 797 "../src/DynamicNotebook.vala"
	_tmp22_ = self->priv->add_button;
#line 797 "../src/DynamicNotebook.vala"
	gtk_button_set_relief (_tmp22_, GTK_RELIEF_NONE);
#line 798 "../src/DynamicNotebook.vala"
	_tmp23_ = self->priv->add_button;
#line 798 "../src/DynamicNotebook.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp23_, _ ("New Tab"));
#line 807 "../src/DynamicNotebook.vala"
	_tmp24_ = (GtkButton*) gtk_button_new_from_icon_name ("document-open-recent-symbolic", (GtkIconSize) GTK_ICON_SIZE_MENU);
#line 807 "../src/DynamicNotebook.vala"
	g_object_ref_sink (_tmp24_);
#line 807 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->priv->restore_button);
#line 807 "../src/DynamicNotebook.vala"
	self->priv->restore_button = _tmp24_;
#line 808 "../src/DynamicNotebook.vala"
	_tmp25_ = self->priv->restore_button;
#line 808 "../src/DynamicNotebook.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp25_, 3);
#line 809 "../src/DynamicNotebook.vala"
	_tmp26_ = self->priv->restore_button;
#line 809 "../src/DynamicNotebook.vala"
	gtk_button_set_relief (_tmp26_, GTK_RELIEF_NONE);
#line 810 "../src/DynamicNotebook.vala"
	_tmp27_ = self->priv->restore_button;
#line 810 "../src/DynamicNotebook.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp27_, _ ("Closed Tabs"));
#line 811 "../src/DynamicNotebook.vala"
	_tmp28_ = self->priv->restore_button;
#line 811 "../src/DynamicNotebook.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp28_, FALSE);
#line 812 "../src/DynamicNotebook.vala"
	_tmp29_ = self->priv->restore_button;
#line 812 "../src/DynamicNotebook.vala"
	gtk_widget_show ((GtkWidget*) _tmp29_);
#line 814 "../src/DynamicNotebook.vala"
	_tmp30_ = self->priv->notebook;
#line 814 "../src/DynamicNotebook.vala"
	_tmp31_ = self->priv->add_button;
#line 814 "../src/DynamicNotebook.vala"
	gtk_notebook_set_action_widget (_tmp30_, (GtkWidget*) _tmp31_, GTK_PACK_START);
#line 815 "../src/DynamicNotebook.vala"
	_tmp32_ = self->priv->notebook;
#line 815 "../src/DynamicNotebook.vala"
	_tmp33_ = self->priv->restore_button;
#line 815 "../src/DynamicNotebook.vala"
	gtk_notebook_set_action_widget (_tmp32_, (GtkWidget*) _tmp33_, GTK_PACK_END);
#line 818 "../src/DynamicNotebook.vala"
	_tmp34_ = self->priv->add_button;
#line 818 "../src/DynamicNotebook.vala"
	g_signal_connect_object (_tmp34_, "clicked", (GCallback) __dynamic_notebook___lambda27__gtk_button_clicked, self, 0);
#line 822 "../src/DynamicNotebook.vala"
	_tmp35_ = self->priv->add_button;
#line 822 "../src/DynamicNotebook.vala"
	g_signal_connect_object ((GtkWidget*) _tmp35_, "button-press-event", (GCallback) __dynamic_notebook___lambda28__gtk_widget_button_press_event, self, 0);
#line 827 "../src/DynamicNotebook.vala"
	_tmp36_ = self->priv->restore_button;
#line 827 "../src/DynamicNotebook.vala"
	g_signal_connect_object (_tmp36_, "clicked", (GCallback) __dynamic_notebook___lambda29__gtk_button_clicked, self, 0);
#line 834 "../src/DynamicNotebook.vala"
	_tmp37_ = self->priv->restore_tab_m;
#line 834 "../src/DynamicNotebook.vala"
	_tmp38_ = dynamic_notebook_get_allow_restoring (self);
#line 834 "../src/DynamicNotebook.vala"
	_tmp39_ = _tmp38_;
#line 834 "../src/DynamicNotebook.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp37_, _tmp39_);
#line 835 "../src/DynamicNotebook.vala"
	_tmp40_ = self->priv->restore_button;
#line 835 "../src/DynamicNotebook.vala"
	_tmp41_ = dynamic_notebook_get_allow_restoring (self);
#line 835 "../src/DynamicNotebook.vala"
	_tmp42_ = _tmp41_;
#line 835 "../src/DynamicNotebook.vala"
	gtk_widget_set_visible ((GtkWidget*) _tmp40_, _tmp42_);
#line 837 "../src/DynamicNotebook.vala"
	g_signal_connect_object ((GtkWidget*) self, "size-allocate", (GCallback) __dynamic_notebook___lambda30__gtk_widget_size_allocate, self, 0);
#line 841 "../src/DynamicNotebook.vala"
	g_signal_connect_object ((GtkWidget*) self, "button-press-event", (GCallback) __dynamic_notebook___lambda31__gtk_widget_button_press_event, self, 0);
#line 854 "../src/DynamicNotebook.vala"
	g_signal_connect_object ((GtkWidget*) self, "key-press-event", (GCallback) __dynamic_notebook___lambda32__gtk_widget_key_press_event, self, 0);
#line 928 "../src/DynamicNotebook.vala"
	g_signal_connect_object ((GtkWidget*) self, "destroy", (GCallback) __dynamic_notebook___lambda33__gtk_widget_destroy, self, 0);
#line 936 "../src/DynamicNotebook.vala"
	_tmp43_ = self->priv->notebook;
#line 936 "../src/DynamicNotebook.vala"
	g_signal_connect_object (_tmp43_, "switch-page", (GCallback) _dynamic_notebook_on_switch_page_gtk_notebook_switch_page, self, 0);
#line 937 "../src/DynamicNotebook.vala"
	_tmp44_ = self->priv->notebook;
#line 937 "../src/DynamicNotebook.vala"
	g_signal_connect_object (_tmp44_, "page-added", (GCallback) _dynamic_notebook_on_page_added_gtk_notebook_page_added, self, 0);
#line 938 "../src/DynamicNotebook.vala"
	_tmp45_ = self->priv->notebook;
#line 938 "../src/DynamicNotebook.vala"
	g_signal_connect_object (_tmp45_, "page-removed", (GCallback) _dynamic_notebook_on_page_removed_gtk_notebook_page_removed, self, 0);
#line 939 "../src/DynamicNotebook.vala"
	_tmp46_ = self->priv->notebook;
#line 939 "../src/DynamicNotebook.vala"
	g_signal_connect_object (_tmp46_, "page-reordered", (GCallback) _dynamic_notebook_on_page_reordered_gtk_notebook_page_reordered, self, 0);
#line 940 "../src/DynamicNotebook.vala"
	_tmp47_ = self->priv->notebook;
#line 940 "../src/DynamicNotebook.vala"
	g_signal_connect_object (_tmp47_, "create-window", (GCallback) _dynamic_notebook_on_create_window_gtk_notebook_create_window, self, 0);
#line 749 "../src/DynamicNotebook.vala"
	return obj;
#line 8636 "DynamicNotebook.c"
}


static void
dynamic_notebook_class_init (DynamicNotebookClass * klass)
{
#line 513 "../src/DynamicNotebook.vala"
	dynamic_notebook_parent_class = g_type_class_peek_parent (klass);
#line 513 "../src/DynamicNotebook.vala"
	g_type_class_adjust_private_offset (klass, &DynamicNotebook_private_offset);
#line 513 "../src/DynamicNotebook.vala"
	((GtkWidgetClass *) klass)->show = (void (*) (GtkWidget*)) dynamic_notebook_real_show;
#line 513 "../src/DynamicNotebook.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_dynamic_notebook_get_property;
#line 513 "../src/DynamicNotebook.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_dynamic_notebook_set_property;
#line 513 "../src/DynamicNotebook.vala"
	G_OBJECT_CLASS (klass)->constructor = dynamic_notebook_constructor;
#line 513 "../src/DynamicNotebook.vala"
	G_OBJECT_CLASS (klass)->finalize = dynamic_notebook_finalize;
#line 8657 "DynamicNotebook.c"
	/**
	         * number of pages
	         */
#line 513 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DYNAMIC_NOTEBOOK_N_TABS_PROPERTY, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_N_TABS_PROPERTY] = g_param_spec_int ("n-tabs", "n-tabs", "n-tabs", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 8663 "DynamicNotebook.c"
	/**
	         * Hide the tab bar and only show the pages
	         */
#line 513 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DYNAMIC_NOTEBOOK_SHOW_TABS_PROPERTY, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_SHOW_TABS_PROPERTY] = g_param_spec_boolean ("show-tabs", "show-tabs", "show-tabs", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 513 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DYNAMIC_NOTEBOOK_SHOW_ICONS_PROPERTY, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_SHOW_ICONS_PROPERTY] = g_param_spec_boolean ("show-icons", "show-icons", "show-icons", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_DEPRECATED));
#line 513 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DYNAMIC_NOTEBOOK_TABS_CLOSABLE_PROPERTY, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_TABS_CLOSABLE_PROPERTY] = g_param_spec_boolean ("tabs-closable", "tabs-closable", "tabs-closable", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 513 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DYNAMIC_NOTEBOOK_ALLOW_DRAG_PROPERTY, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_ALLOW_DRAG_PROPERTY] = g_param_spec_boolean ("allow-drag", "allow-drag", "allow-drag", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 513 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DYNAMIC_NOTEBOOK_ALLOW_NEW_WINDOW_PROPERTY, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_ALLOW_NEW_WINDOW_PROPERTY] = g_param_spec_boolean ("allow-new-window", "allow-new-window", "allow-new-window", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 513 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DYNAMIC_NOTEBOOK_ALLOW_DUPLICATION_PROPERTY, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_ALLOW_DUPLICATION_PROPERTY] = g_param_spec_boolean ("allow-duplication", "allow-duplication", "allow-duplication", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 513 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DYNAMIC_NOTEBOOK_ALLOW_RESTORING_PROPERTY, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_ALLOW_RESTORING_PROPERTY] = g_param_spec_boolean ("allow-restoring", "allow-restoring", "allow-restoring", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 8681 "DynamicNotebook.c"
	/**
	         * Set or get the upper limit of the size of the set
	         * of restorable tabs.
	         */
#line 513 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DYNAMIC_NOTEBOOK_MAX_RESTORABLE_TABS_PROPERTY, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_MAX_RESTORABLE_TABS_PROPERTY] = g_param_spec_int ("max-restorable-tabs", "max-restorable-tabs", "max-restorable-tabs", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 513 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DYNAMIC_NOTEBOOK_ADD_BUTTON_VISIBLE_PROPERTY, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_ADD_BUTTON_VISIBLE_PROPERTY] = g_param_spec_boolean ("add-button-visible", "add-button-visible", "add-button-visible", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 513 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DYNAMIC_NOTEBOOK_ALLOW_PINNING_PROPERTY, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_ALLOW_PINNING_PROPERTY] = g_param_spec_boolean ("allow-pinning", "allow-pinning", "allow-pinning", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 513 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DYNAMIC_NOTEBOOK_FORCE_LEFT_PROPERTY, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_FORCE_LEFT_PROPERTY] = g_param_spec_boolean ("force-left", "force-left", "force-left", FALSE, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 8694 "DynamicNotebook.c"
	/**
	        * The text shown in the add button tooltip
	        */
#line 513 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DYNAMIC_NOTEBOOK_ADD_BUTTON_TOOLTIP_PROPERTY, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_ADD_BUTTON_TOOLTIP_PROPERTY] = g_param_spec_string ("add-button-tooltip", "add-button-tooltip", "add-button-tooltip", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 513 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DYNAMIC_NOTEBOOK_CURRENT_PROPERTY, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_CURRENT_PROPERTY] = g_param_spec_object ("current", "current", "current", TYPE_TAB, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 513 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DYNAMIC_NOTEBOOK_TABS_PROPERTY, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_TABS_PROPERTY] = g_param_spec_pointer ("tabs", "tabs", "tabs", G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 513 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DYNAMIC_NOTEBOOK_GROUP_NAME_PROPERTY, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_GROUP_NAME_PROPERTY] = g_param_spec_string ("group-name", "group-name", "group-name", NULL, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 8706 "DynamicNotebook.c"
	/**
	         * The behavior of the tab bar and its visibility
	        */
#line 513 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DYNAMIC_NOTEBOOK_TAB_BAR_BEHAVIOR_PROPERTY, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_TAB_BAR_BEHAVIOR_PROPERTY] = g_param_spec_enum ("tab-bar-behavior", "tab-bar-behavior", "tab-bar-behavior", DYNAMIC_NOTEBOOK_TYPE_TAB_BAR_BEHAVIOR, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE));
#line 8712 "DynamicNotebook.c"
	/**
	         * The menu appearing when the notebook is clicked on a blank space
	         */
#line 513 "../src/DynamicNotebook.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), DYNAMIC_NOTEBOOK_MENU_PROPERTY, dynamic_notebook_properties[DYNAMIC_NOTEBOOK_MENU_PROPERTY] = g_param_spec_object ("menu", "menu", "menu", gtk_menu_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 513 "../src/DynamicNotebook.vala"
	dynamic_notebook_signals[DYNAMIC_NOTEBOOK_TAB_ADDED_SIGNAL] = g_signal_new ("tab-added", TYPE_DYNAMIC_NOTEBOOK, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_TAB);
#line 513 "../src/DynamicNotebook.vala"
	dynamic_notebook_signals[DYNAMIC_NOTEBOOK_TAB_REMOVED_SIGNAL] = g_signal_new ("tab-removed", TYPE_DYNAMIC_NOTEBOOK, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_TAB);
#line 513 "../src/DynamicNotebook.vala"
	dynamic_notebook_signals[DYNAMIC_NOTEBOOK_TAB_SWITCHED_SIGNAL] = g_signal_new ("tab-switched", TYPE_DYNAMIC_NOTEBOOK, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_OBJECT, G_TYPE_NONE, 2, TYPE_TAB, TYPE_TAB);
#line 513 "../src/DynamicNotebook.vala"
	dynamic_notebook_signals[DYNAMIC_NOTEBOOK_TAB_REORDERED_SIGNAL] = g_signal_new ("tab-reordered", TYPE_DYNAMIC_NOTEBOOK, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_INT, G_TYPE_NONE, 2, TYPE_TAB, G_TYPE_INT);
#line 513 "../src/DynamicNotebook.vala"
	dynamic_notebook_signals[DYNAMIC_NOTEBOOK_TAB_MOVED_SIGNAL] = g_signal_new ("tab-moved", TYPE_DYNAMIC_NOTEBOOK, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_INT_INT, G_TYPE_NONE, 3, TYPE_TAB, G_TYPE_INT, G_TYPE_INT);
#line 513 "../src/DynamicNotebook.vala"
	dynamic_notebook_signals[DYNAMIC_NOTEBOOK_TAB_DUPLICATED_SIGNAL] = g_signal_new ("tab-duplicated", TYPE_DYNAMIC_NOTEBOOK, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, TYPE_TAB);
#line 513 "../src/DynamicNotebook.vala"
	dynamic_notebook_signals[DYNAMIC_NOTEBOOK_TAB_RESTORED_SIGNAL] = g_signal_new ("tab-restored", TYPE_DYNAMIC_NOTEBOOK, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__STRING_STRING_OBJECT, G_TYPE_NONE, 3, G_TYPE_STRING, G_TYPE_STRING, g_icon_get_type ());
#line 513 "../src/DynamicNotebook.vala"
	dynamic_notebook_signals[DYNAMIC_NOTEBOOK_NEW_TAB_REQUESTED_SIGNAL] = g_signal_new ("new-tab-requested", TYPE_DYNAMIC_NOTEBOOK, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__VOID, G_TYPE_NONE, 0);
#line 513 "../src/DynamicNotebook.vala"
	dynamic_notebook_signals[DYNAMIC_NOTEBOOK_CLOSE_TAB_REQUESTED_SIGNAL] = g_signal_new ("close-tab-requested", TYPE_DYNAMIC_NOTEBOOK, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_BOOLEAN__OBJECT, G_TYPE_BOOLEAN, 1, TYPE_TAB);
#line 8736 "DynamicNotebook.c"
}


static void
dynamic_notebook_instance_init (DynamicNotebook * self)
{
#line 513 "../src/DynamicNotebook.vala"
	self->priv = dynamic_notebook_get_instance_private (self);
#line 544 "../src/DynamicNotebook.vala"
	self->priv->_tabs_closable = TRUE;
#line 559 "../src/DynamicNotebook.vala"
	self->priv->_allow_drag = TRUE;
#line 573 "../src/DynamicNotebook.vala"
	self->priv->_allow_new_window = FALSE;
#line 587 "../src/DynamicNotebook.vala"
	self->priv->_allow_duplication = FALSE;
#line 602 "../src/DynamicNotebook.vala"
	self->priv->_allow_restoring = FALSE;
#line 624 "../src/DynamicNotebook.vala"
	self->priv->_add_button_visible = TRUE;
#line 641 "../src/DynamicNotebook.vala"
	self->priv->_allow_pinning = FALSE;
#line 653 "../src/DynamicNotebook.vala"
	self->priv->_force_left = TRUE;
#line 719 "../src/DynamicNotebook.vala"
	self->priv->tab_width = 150;
#line 8763 "DynamicNotebook.c"
}


static void
dynamic_notebook_finalize (GObject * obj)
{
	DynamicNotebook * self;
#line 513 "../src/DynamicNotebook.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, TYPE_DYNAMIC_NOTEBOOK, DynamicNotebook);
#line 667 "../src/DynamicNotebook.vala"
	_g_free0 (self->priv->_add_button_tooltip);
#line 674 "../src/DynamicNotebook.vala"
	(self->priv->_tabs == NULL) ? NULL : (self->priv->_tabs = (_g_list_free__g_object_unref0_ (self->priv->_tabs), NULL));
#line 713 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->priv->_menu);
#line 715 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->priv->closed_tabs);
#line 717 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->priv->notebook);
#line 725 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->priv->old_tab);
#line 734 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->priv->new_tab_m);
#line 735 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->priv->restore_tab_m);
#line 737 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->priv->add_button);
#line 738 "../src/DynamicNotebook.vala"
	_g_object_unref0 (self->priv->restore_button);
#line 513 "../src/DynamicNotebook.vala"
	G_OBJECT_CLASS (dynamic_notebook_parent_class)->finalize (obj);
#line 8795 "DynamicNotebook.c"
}


/**
    * Tab bar widget designed for a variable number of tabs.
    * Supports showing a "New tab" button, restoring closed tabs, "pinning" tabs, and more.
    *
    * {{../doc/images/DynamicNotebook.png}}
    */
GType
dynamic_notebook_get_type (void)
{
	static volatile gsize dynamic_notebook_type_id__volatile = 0;
	if (g_once_init_enter (&dynamic_notebook_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (DynamicNotebookClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) dynamic_notebook_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (DynamicNotebook), 0, (GInstanceInitFunc) dynamic_notebook_instance_init, NULL };
		GType dynamic_notebook_type_id;
		dynamic_notebook_type_id = g_type_register_static (gtk_event_box_get_type (), "DynamicNotebook", &g_define_type_info, 0);
		DynamicNotebook_private_offset = g_type_add_instance_private (dynamic_notebook_type_id, sizeof (DynamicNotebookPrivate));
		g_once_init_leave (&dynamic_notebook_type_id__volatile, dynamic_notebook_type_id);
	}
	return dynamic_notebook_type_id__volatile;
}


static void
_vala_dynamic_notebook_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec)
{
	DynamicNotebook * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_DYNAMIC_NOTEBOOK, DynamicNotebook);
#line 513 "../src/DynamicNotebook.vala"
	switch (property_id) {
#line 513 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_N_TABS_PROPERTY:
#line 513 "../src/DynamicNotebook.vala"
		g_value_set_int (value, dynamic_notebook_get_n_tabs (self));
#line 513 "../src/DynamicNotebook.vala"
		break;
#line 513 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_SHOW_TABS_PROPERTY:
#line 513 "../src/DynamicNotebook.vala"
		g_value_set_boolean (value, dynamic_notebook_get_show_tabs (self));
#line 513 "../src/DynamicNotebook.vala"
		break;
#line 513 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_SHOW_ICONS_PROPERTY:
G_GNUC_BEGIN_IGNORE_DEPRECATIONS
#line 8845 "DynamicNotebook.c"
		g_value_set_boolean (value, dynamic_notebook_get_show_icons (self));
G_GNUC_END_IGNORE_DEPRECATIONS
#line 513 "../src/DynamicNotebook.vala"
		break;
#line 513 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_TABS_CLOSABLE_PROPERTY:
#line 513 "../src/DynamicNotebook.vala"
		g_value_set_boolean (value, dynamic_notebook_get_tabs_closable (self));
#line 513 "../src/DynamicNotebook.vala"
		break;
#line 513 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_ALLOW_DRAG_PROPERTY:
#line 513 "../src/DynamicNotebook.vala"
		g_value_set_boolean (value, dynamic_notebook_get_allow_drag (self));
#line 513 "../src/DynamicNotebook.vala"
		break;
#line 513 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_ALLOW_NEW_WINDOW_PROPERTY:
#line 513 "../src/DynamicNotebook.vala"
		g_value_set_boolean (value, dynamic_notebook_get_allow_new_window (self));
#line 513 "../src/DynamicNotebook.vala"
		break;
#line 513 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_ALLOW_DUPLICATION_PROPERTY:
#line 513 "../src/DynamicNotebook.vala"
		g_value_set_boolean (value, dynamic_notebook_get_allow_duplication (self));
#line 513 "../src/DynamicNotebook.vala"
		break;
#line 513 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_ALLOW_RESTORING_PROPERTY:
#line 513 "../src/DynamicNotebook.vala"
		g_value_set_boolean (value, dynamic_notebook_get_allow_restoring (self));
#line 513 "../src/DynamicNotebook.vala"
		break;
#line 513 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_MAX_RESTORABLE_TABS_PROPERTY:
#line 513 "../src/DynamicNotebook.vala"
		g_value_set_int (value, dynamic_notebook_get_max_restorable_tabs (self));
#line 513 "../src/DynamicNotebook.vala"
		break;
#line 513 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_ADD_BUTTON_VISIBLE_PROPERTY:
#line 513 "../src/DynamicNotebook.vala"
		g_value_set_boolean (value, dynamic_notebook_get_add_button_visible (self));
#line 513 "../src/DynamicNotebook.vala"
		break;
#line 513 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_ALLOW_PINNING_PROPERTY:
#line 513 "../src/DynamicNotebook.vala"
		g_value_set_boolean (value, dynamic_notebook_get_allow_pinning (self));
#line 513 "../src/DynamicNotebook.vala"
		break;
#line 513 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_FORCE_LEFT_PROPERTY:
#line 513 "../src/DynamicNotebook.vala"
		g_value_set_boolean (value, dynamic_notebook_get_force_left (self));
#line 513 "../src/DynamicNotebook.vala"
		break;
#line 513 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_ADD_BUTTON_TOOLTIP_PROPERTY:
#line 513 "../src/DynamicNotebook.vala"
		g_value_set_string (value, dynamic_notebook_get_add_button_tooltip (self));
#line 513 "../src/DynamicNotebook.vala"
		break;
#line 513 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_CURRENT_PROPERTY:
#line 513 "../src/DynamicNotebook.vala"
		g_value_set_object (value, dynamic_notebook_get_current (self));
#line 513 "../src/DynamicNotebook.vala"
		break;
#line 513 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_TABS_PROPERTY:
#line 513 "../src/DynamicNotebook.vala"
		g_value_set_pointer (value, dynamic_notebook_get_tabs (self));
#line 513 "../src/DynamicNotebook.vala"
		break;
#line 513 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_GROUP_NAME_PROPERTY:
#line 513 "../src/DynamicNotebook.vala"
		g_value_set_string (value, dynamic_notebook_get_group_name (self));
#line 513 "../src/DynamicNotebook.vala"
		break;
#line 513 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_TAB_BAR_BEHAVIOR_PROPERTY:
#line 513 "../src/DynamicNotebook.vala"
		g_value_set_enum (value, dynamic_notebook_get_tab_bar_behavior (self));
#line 513 "../src/DynamicNotebook.vala"
		break;
#line 513 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_MENU_PROPERTY:
#line 513 "../src/DynamicNotebook.vala"
		g_value_set_object (value, dynamic_notebook_get_menu (self));
#line 513 "../src/DynamicNotebook.vala"
		break;
#line 8940 "DynamicNotebook.c"
		default:
#line 513 "../src/DynamicNotebook.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 513 "../src/DynamicNotebook.vala"
		break;
#line 8946 "DynamicNotebook.c"
	}
}


static void
_vala_dynamic_notebook_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec)
{
	DynamicNotebook * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, TYPE_DYNAMIC_NOTEBOOK, DynamicNotebook);
#line 513 "../src/DynamicNotebook.vala"
	switch (property_id) {
#line 513 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_SHOW_TABS_PROPERTY:
#line 513 "../src/DynamicNotebook.vala"
		dynamic_notebook_set_show_tabs (self, g_value_get_boolean (value));
#line 513 "../src/DynamicNotebook.vala"
		break;
#line 513 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_SHOW_ICONS_PROPERTY:
G_GNUC_BEGIN_IGNORE_DEPRECATIONS
#line 8970 "DynamicNotebook.c"
		dynamic_notebook_set_show_icons (self, g_value_get_boolean (value));
G_GNUC_END_IGNORE_DEPRECATIONS
#line 513 "../src/DynamicNotebook.vala"
		break;
#line 513 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_TABS_CLOSABLE_PROPERTY:
#line 513 "../src/DynamicNotebook.vala"
		dynamic_notebook_set_tabs_closable (self, g_value_get_boolean (value));
#line 513 "../src/DynamicNotebook.vala"
		break;
#line 513 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_ALLOW_DRAG_PROPERTY:
#line 513 "../src/DynamicNotebook.vala"
		dynamic_notebook_set_allow_drag (self, g_value_get_boolean (value));
#line 513 "../src/DynamicNotebook.vala"
		break;
#line 513 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_ALLOW_NEW_WINDOW_PROPERTY:
#line 513 "../src/DynamicNotebook.vala"
		dynamic_notebook_set_allow_new_window (self, g_value_get_boolean (value));
#line 513 "../src/DynamicNotebook.vala"
		break;
#line 513 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_ALLOW_DUPLICATION_PROPERTY:
#line 513 "../src/DynamicNotebook.vala"
		dynamic_notebook_set_allow_duplication (self, g_value_get_boolean (value));
#line 513 "../src/DynamicNotebook.vala"
		break;
#line 513 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_ALLOW_RESTORING_PROPERTY:
#line 513 "../src/DynamicNotebook.vala"
		dynamic_notebook_set_allow_restoring (self, g_value_get_boolean (value));
#line 513 "../src/DynamicNotebook.vala"
		break;
#line 513 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_MAX_RESTORABLE_TABS_PROPERTY:
#line 513 "../src/DynamicNotebook.vala"
		dynamic_notebook_set_max_restorable_tabs (self, g_value_get_int (value));
#line 513 "../src/DynamicNotebook.vala"
		break;
#line 513 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_ADD_BUTTON_VISIBLE_PROPERTY:
#line 513 "../src/DynamicNotebook.vala"
		dynamic_notebook_set_add_button_visible (self, g_value_get_boolean (value));
#line 513 "../src/DynamicNotebook.vala"
		break;
#line 513 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_ALLOW_PINNING_PROPERTY:
#line 513 "../src/DynamicNotebook.vala"
		dynamic_notebook_set_allow_pinning (self, g_value_get_boolean (value));
#line 513 "../src/DynamicNotebook.vala"
		break;
#line 513 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_FORCE_LEFT_PROPERTY:
#line 513 "../src/DynamicNotebook.vala"
		dynamic_notebook_set_force_left (self, g_value_get_boolean (value));
#line 513 "../src/DynamicNotebook.vala"
		break;
#line 513 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_ADD_BUTTON_TOOLTIP_PROPERTY:
#line 513 "../src/DynamicNotebook.vala"
		dynamic_notebook_set_add_button_tooltip (self, g_value_get_string (value));
#line 513 "../src/DynamicNotebook.vala"
		break;
#line 513 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_CURRENT_PROPERTY:
#line 513 "../src/DynamicNotebook.vala"
		dynamic_notebook_set_current (self, g_value_get_object (value));
#line 513 "../src/DynamicNotebook.vala"
		break;
#line 513 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_GROUP_NAME_PROPERTY:
#line 513 "../src/DynamicNotebook.vala"
		dynamic_notebook_set_group_name (self, g_value_get_string (value));
#line 513 "../src/DynamicNotebook.vala"
		break;
#line 513 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_TAB_BAR_BEHAVIOR_PROPERTY:
#line 513 "../src/DynamicNotebook.vala"
		dynamic_notebook_set_tab_bar_behavior (self, g_value_get_enum (value));
#line 513 "../src/DynamicNotebook.vala"
		break;
#line 513 "../src/DynamicNotebook.vala"
		case DYNAMIC_NOTEBOOK_MENU_PROPERTY:
#line 513 "../src/DynamicNotebook.vala"
		dynamic_notebook_set_menu (self, g_value_get_object (value));
#line 513 "../src/DynamicNotebook.vala"
		break;
#line 9059 "DynamicNotebook.c"
		default:
#line 513 "../src/DynamicNotebook.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 513 "../src/DynamicNotebook.vala"
		break;
#line 9065 "DynamicNotebook.c"
	}
}



